/*
  This file is part of CDO. CDO is a collection of Operators to
  manipulate and analyse Climate Data files.

  Copyright (C) 2003-2005 Uwe Schulzweida, schulzweida@dkrz.de
  See COPYING file for copying and redistribution conditions.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 of the License.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/

#include <unistd.h>
#include <sys/times.h>

#define clock_ticks ( (double) sysconf(_SC_CLK_TCK) )

void cdoTimer(double *utime, double *stime)
{
  struct tms tbuf;

  if ( times(&tbuf) == -1 )
    {
      *utime  = 0;
      *stime  = 0;
    }
  else
    {
      *utime  = ((double) tbuf.tms_utime) / clock_ticks; 
      *stime  = ((double) tbuf.tms_stime) / clock_ticks;
    }
}
