
/* Generated automatically from m214003 on Fr Apr  1 19:52:30 CEST 2005 */

#if  defined  (HAVE_CONFIG_H)
#  include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <float.h>
#include <math.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#if ! defined (HAVE_CONFIG_H)
#  define  HAVE_LIBGRIB      1
#  define  HAVE_LIBSERVICE   1
#  define  HAVE_LIBEXTRA     1
#endif

#ifndef _CDI_LIMITS_H
#define _CDI_LIMITS_H

#define  MAX_GRIDS  128  /* maximum of different grids for each file */
#define  MAX_ZAXIS  128  /* maximum of different zaxis for each file */

#endif  /* _CDI_LIMITS_H */
#ifndef _TAXIS_H
#define _TAXIS_H


typedef struct {
  int     used;
  int     type;           /* time type             */
  int     vdate;          /* verification date     */
  int     vtime;          /* verification time     */
  int     rdate;          /* reference date        */
  int     rtime;          /* reference time        */
  int     calendar;
  int     unit;           /* time unit             */
  int     numavg;
}
TAXIS;

void    ptaxisInit(TAXIS *taxis);
void    ptaxisCopy(TAXIS *dest, TAXIS *source);
TAXIS  *taxisPtr(int timeID);
void    timeval2vtime(double timevalue, TAXIS *taxis, int *vdate, int *vtime);
double  vtime2timeval(int vdate, int vtime, TAXIS *taxis);


#endif  /* _TAXIS_H */
#ifndef _ERROR_H
#define _ERROR_H

#define  _FATAL     1     /* Error flag: exit on error  */
#define  _VERBOSE   2     /* Error flag: report errors  */
#define  _DEBUG     4     /* Error flag: debug          */

extern int _ExitOnError;  /* If set to 1, exit on error (default 1)       */
extern int _Verbose;      /* If set to 1, errors are reported (default 1) */
extern int _Debug;        /* If set to 1, debuggig (default 0)            */

void SysError(const char *caller, const char *fmt, ...);
void    Error(const char *caller, const char *fmt, ...);
void  Warning(const char *caller, const char *fmt, ...);
void  Message(const char *caller, const char *fmt, ...);

#endif  /* _ERROR_H */
#ifndef _DTYPES_H
#define _DTYPES_H

#include <stdio.h>
#include <limits.h>

/* INT32 */

#if ! defined (INT_MAX)
#  error INT_MAX undefined
#endif

#undef  INT32
#if  INT_MAX == 2147483647L
#  define  INT32  int
#elif LONG_MAX == 2147483647L
#  define  INT32  long
#endif

/* INT64 */

#if ! defined (LONG_MAX)
#  error LONG_MAX undefined
#endif

#undef  INT64
#if  LONG_MAX > 2147483647L
#  define  INT64  long
#else
#  define  INT64  long long
#endif

/* REAL4 */

#undef   REAL4
#define  REAL4  float

/* Real8 */

#undef   REAL8
#define  REAL8  double

#endif  /* _DTYPES_H */
#ifndef _FILE_H
#define _FILE_H

#include <stdio.h>
#include <sys/types.h>


#define  FILE_UNDEFID   -1

#define  FILE_TYPE_STD   1
#define  FILE_TYPE_MMAP  2

const
char  *fileLibraryVersion(void);

void   fileDebug(int debug);

int    fileSetBufferType(int fileID, int type);
void   fileSetBufferSize(int fileID, long buffersize);

int    fileOpen(const char *filename, const char *mode);
void   fileClose(int fileID);

char  *fileInqName(int fileID);
int    fileInqMode(int fileID);

int    fileFlush(int fileID);
void   fileClearerr(int fileID);
int    fileEOF(int fileID);
void   fileRewind(int fileID);

off_t  fileGetPos(int fileID);
int    fileSetPos(int fileID, off_t offset, int whence);

int    fileGetc(int fileID);

size_t fileRead(int fileID, void *ptr, size_t size);
size_t fileWrite(int fileID, const void *ptr, size_t size);

#endif  /* _FILE_H */
#ifndef _GRIB_H
#define _GRIB_H

#include <stdio.h>
#include <sys/types.h>

#define  GRIB_MISSVAL  -9.E33

/* Level Types */
#define  LTYPE_SURFACE               1
#define  LTYPE_99                   99
#define  LTYPE_ISOBARIC            100
#define  LTYPE_MEANSEA             102
#define  LTYPE_ALTITUDE            103
#define  LTYPE_HEIGHT              105
#define  LTYPE_SIGMA               107
#define  LTYPE_HYBRID              109
#define  LTYPE_HYBRID_LAYER        110
#define  LTYPE_LANDDEPTH           111
#define  LTYPE_LANDDEPTH_LAYER     112
#define  LTYPE_SEADEPTH            160
#define  LTYPE_99_MARGIN          1000

/*
 *  Data representation type (Grid Type) [Table 6]
 */
#define  GTYPE_LATLON                0  /*  latitude/longitude                       */
#define  GTYPE_LATLON_ROT           10  /*  rotated latitude/longitude               */
#define  GTYPE_LATLON_STR           20  /*  stretched latitude/longitude             */
#define  GTYPE_LATLON_ROTSTR        30  /*  rotated and stretched latitude/longitude */
#define  GTYPE_GAUSSIAN              4  /*  gaussian grid                            */
#define  GTYPE_GAUSSIAN_ROT         14  /*  rotated gaussian grid                    */
#define  GTYPE_GAUSSIAN_STR         24  /*  stretched gaussian grid                  */
#define  GTYPE_GAUSSIAN_ROTSTR      34  /*  rotated and stretched gaussian grid      */
#define  GTYPE_SPECTRAL             50  /*  spherical harmonics                      */
#define  GTYPE_TRIANGULAR          192  /*  triangular grid                          */

/*
 *  Macros for the indicator section ( Section 0 )
 */
#define  ISEC0_GRIB_Len             (isec0[ 0])  /*  Number of octets in the GRIB message         */
#define  ISEC0_GRIB_Version         (isec0[ 1])  /*  GRIB edition number                          */


/*
 *  Macros for the product definition section ( Section 1 )
 */
#define  ISEC1_TABLE4_MINUTE  0
#define  ISEC1_TABLE4_HOUR    1
#define  ISEC1_TABLE4_DAY     2


#define  ISEC1_CodeTable            (isec1[ 0])  /*  Version number of code table                 */
#define  ISEC1_CenterID             (isec1[ 1])  /*  Identification of centre                     */
#define  ISEC1_ModelID              (isec1[ 2])  /*  Identification of model                      */
#define  ISEC1_GridDefinition       (isec1[ 3])  /*  Grid definition                              */
#define  ISEC1_Sec2Or3Flag          (isec1[ 4])  /*  Section 2 or 3 included                      */
#define  ISEC1_Parameter            (isec1[ 5])  /*  Parameter indicator                          */
#define  ISEC1_LevelType            (isec1[ 6])  /*  Type of level indicator                      */
#define  ISEC1_Level1               (isec1[ 7])  /*  Level 1                                      */
#define  ISEC1_Level2               (isec1[ 8])  /*  Level 2                                      */
#define  ISEC1_Year                 (isec1[ 9])  /*  Year of century (YY)                         */
#define  ISEC1_Month                (isec1[10])  /*  Month (MM)                                   */
#define  ISEC1_Day                  (isec1[11])  /*  Day (DD)                                     */
#define  ISEC1_Hour                 (isec1[12])  /*  Hour (HH)                                    */
#define  ISEC1_Minute               (isec1[13])  /*  Minute (MM)                                  */
#define  ISEC1_TimeUnit             (isec1[14])  /*  Time unit indicator                          */
#define  ISEC1_TimePeriod1          (isec1[15])  /*  P1 Time period                               */
#define  ISEC1_TimePeriod2          (isec1[16])  /*  P2 Time period                               */
#define  ISEC1_TimeRange            (isec1[17])  /*  Time range indicator                         */
#define  ISEC1_AvgNum               (isec1[18])  /*  Number of products included in an average    */
#define  ISEC1_AvgMiss              (isec1[19])  /*  Number of products missing form an average   */
#define  ISEC1_Century              (isec1[20])  /*  Century                                      */
#define  ISEC1_SubCenterID          (isec1[21])  /*  Subcenter identifier                         */
#define  ISEC1_DecScaleFactor       (isec1[22])  /*  Decimal scale factor                         */
#define  ISEC1_LocalFLag            (isec1[23])  /*  Flag field to indicate local use in isec1    */

#define  ISEC1_ECMWF_LocalExtention (isec1[36])
#define  ISEC1_ECMWF_Class          (isec1[37])


/*
 *  Macros for the grid definition section ( Section 2 )
 */
#define  ISEC2_GridType             (isec2[ 0])  /* Data representation type */

/* Triangular grids */

#define  ISEC2_TRI_NI2              (isec2[ 1])  /*  Number of factor 2 in factorisation of Ni    */
#define  ISEC2_TRI_NI3              (isec2[ 2])  /*  Number of factor 3 in factorisation of Ni    */
#define  ISEC2_TRI_ND               (isec2[ 3])  /*  Nubmer of diamonds                           */
#define  ISEC2_TRI_NI               (isec2[ 4])  /*  Number of tri. subdiv. of the icosahedron    */
#define  ISEC2_TRI_AFlag            (isec2[ 5])  /*  Flag for orientation of diamonds (Table A)   */
#define  ISEC2_TRI_LatPP            (isec2[ 6])  /*  Latitude of pole point                       */
#define  ISEC2_TRI_LonPP            (isec2[ 7])  /*  Longitude of pole point                      */
#define  ISEC2_TRI_LonMPL           (isec2[ 8])  /*  Longitude of the first diamond               */
#define  ISEC2_TRI_BFlag            (isec2[ 9])  /*  Flag for storage sequence (Table B)          */

/* Spherical harmonic coeficients */

#define  ISEC2_PentaJ               (isec2[ 1])  /*  J pentagonal resolution parameter            */
#define  ISEC2_PentaK               (isec2[ 2])  /*  K pentagonal resolution parameter            */
#define  ISEC2_PentaM               (isec2[ 3])  /*  M pentagonal resolution parameter            */
#define  ISEC2_RepType              (isec2[ 4])  /*  Representation type                          */
#define  ISEC2_RepMode              (isec2[ 5])  /*  Representation mode                          */

/* Gaussian grids */

#define  ISEC2_NumLon               (isec2[ 1])  /*  Number of points along a parallel (Ni)       */
#define  ISEC2_NumLat               (isec2[ 2])  /*  Number of points along a meridian (Nj)       */
#define  ISEC2_FirstLat             (isec2[ 3])  /*  Latitude of the first grid point             */
#define  ISEC2_FirstLon             (isec2[ 4])  /*  Longitude of the first grid point            */
#define  ISEC2_ResFlag              (isec2[ 5])  /*  Resolution flag: 128 regular grid            */
#define  ISEC2_LastLat              (isec2[ 6])  /*  Latitude of the last grid point              */
#define  ISEC2_LastLon              (isec2[ 7])  /*  Longitude of the last grid point             */
#define  ISEC2_LonIncr              (isec2[ 8])  /*  i direction increment                        */
#define  ISEC2_LatIncr              (isec2[ 9])  /*  j direction increment                        */
#define  ISEC2_NumPar               (isec2[ 9])  /*  Number of parallels between a pole and the E.*/
#define  ISEC2_ScanFlag             (isec2[10])  /*  Scanning mode flags                          */
#define  ISEC2_NumVCP               (isec2[11])  /*  Number of vertical coordinate parameters     */

#define  ISEC2_Reduced              (isec2[16])  /* 0: regular, 1: reduced grid                   */

#define  ISEC2_RowLonPtr            (&isec2[22])
#define  ISEC2_RowLon(i)            (isec2[22+i]) /* Number of points along each parallel         */

/* */

#define  ISEC2_LatSP                (isec2[12])  /* Latitude of the southern pole of rotation     */
#define  ISEC2_LonSP                (isec2[13])  /* Longitude of the southern pole of rotation    */

#define  FSEC2_RotAngle             (fsec2[ 0])  /* Angle of rotation                             */
#define  FSEC2_StrFact              (fsec2[ 1])  /* Stretching factor                             */

/*
 *  Macros for the bit map section ( Section 3 )
 */
#define  ISEC3_PredefBitmap         (isec3[ 0])  /* Predefined bitmap                             */
#define  ISEC3_MissVal              (isec3[ 1])  /* Missing data value for integers               */
#define  FSEC3_MissVal              (fsec3[ 1])  /* Missing data value for floats                 */

/*
 *  Macros for the binary data section ( Section 4 )
 */
#define  ISEC4_NumValues            (isec4[ 0])  /* Number of data values for encode/decode       */
#define  ISEC4_NumBits              (isec4[ 1])  /* Number of bits used for each encoded value    */
#define  ISEC4_NumNonMissValues     (isec4[20])  /* Number of non-missing values                  */




void  gribSetDebug(int debug);
void  gribSetRound(int round);
void  gribSetRefDP(double refval);
void  gribSetRefSP(float  refval);
void  gribSetValueCheck(int vcheck);


void  gribExSP(int *isec0, int *isec1, int *isec2, float *fsec2, int *isec3,
               float *fsec3, int *isec4, float *fsec4, int klenp, int *kgrib,
               int kleng, int *kword, char *hoper, int *kret);

void  gribExDP(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
               double *fsec3, int *isec4, double *fsec4, int klenp, int *kgrib,
               int kleng, int *kword, char *hoper, int *kret);


const char *gribLibraryVersion(void);

void  gribDebug(int debug);


void  gribDateTime(int *isec1, int *date, int *time);
int   gribRefDate(int *isec1);
int   gribRefTime(int *isec1);
int   gribTimeIsFC(int *isec1);

void  gribPrintSec0(int *isec0);
void  gribPrintSec1(int *isec0, int *isec1);
void  gribPrintSec2DP(int *isec0, int *isec2, double *fsec2);
void  gribPrintSec2SP(int *isec0, int *isec2, float  *fsec2);
void  gribPrintSec3DP(int *isec0, int *isec3, double *fsec3);
void  gribPrintSec3SP(int *isec0, int *isec3, float  *fsec3);
void  gribPrintSec4DP(int *isec0, int *isec4, double *fsec4);
void  gribPrintSec4SP(int *isec0, int *isec4, float  *fsec4);
void  gribPrintSec4Wave(int *isec4);

void  gribPrintALL(int nrec, long offset, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintPDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintGDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintBMS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintBDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);


int   gribOpen(const char *filename, const char *mode);
void  gribClose(int fileID);

int   gribRead(int fileID, unsigned char *buffer, size_t *buffersize);
int   gribWrite(int fileID, unsigned char *buffer, size_t buffersize);
off_t gribGetPos(int fileID);
int   gribGetSize(int fileID);
int   gribFileSeek(int fileID, long *offset);
int   gribReadSize(int fileID);
int   gribVersion(unsigned char *buffer, size_t buffersize);

int gribGinfo(long recpos, long recsize, unsigned char *gribbuffer, int *intnum, float *fltnum);

#endif  /* _GRIB_H */
#ifndef  _CDI_H
#define  _CDI_H

#if defined(__cplusplus)
extern "C" {
#endif

#define  CDI_UNDEFID             -1

/* Error identifier */

#define  CDI_ESYSTEM            -10   /* Operating system error           */
#define  CDI_EINVAL             -20   /* Invalid argument                 */
#define  CDI_EUFTYPE            -21   /* Unsupported file type            */
#define  CDI_ELIBNAVAIL         -22   /* xxx library not available        */
#define  CDI_EUFSTRUCT          -23   /* Unsupported file structure       */

/* File types */

#define  FILETYPE_GRB             1   /* File type GRIB                   */
#define  FILETYPE_G2              2   /* File type GRIB version 2         */
#define  FILETYPE_NC              3   /* File type netCDF                 */
#define  FILETYPE_NC2             4   /* File type netCDF version 2       */
#define  FILETYPE_SRV             5   /* File type SERVICE                */
#define  FILETYPE_EXT             6   /* File type EXTRA                  */
#define  FILETYPE_H5              7   /* File type HDF5                   */

/* Data types */

#define  DATATYPE_PACK            0
#define  DATATYPE_PACK1           1
#define  DATATYPE_PACK2           2
#define  DATATYPE_PACK3           3
#define  DATATYPE_REAL4           4
#define  DATATYPE_REAL8           5
#define  DATATYPE_INT1            6
#define  DATATYPE_INT2            7
#define  DATATYPE_INT4            8

/* GRID types */

#define  GRID_GENERIC             1
#define  GRID_GAUSSIAN            2
#define  GRID_GAUSSIAN_REDUCED    3
#define  GRID_LONLAT              4
#define  GRID_SPECTRAL            5
#define  GRID_FOURIER             6
#define  GRID_TRIANGULAR          7
#define  GRID_TRAJECTORY          8
#define  GRID_CELL                9
#define  GRID_CURVILINEAR        10

/* ZAXIS types */

#define  ZAXIS_SURFACE            0
#define  ZAXIS_GENERIC            1
#define  ZAXIS_HYBRID             2
#define  ZAXIS_HYBRID_HALF        3
#define  ZAXIS_PRESSURE           4
#define  ZAXIS_HEIGHT             5
#define  ZAXIS_DEPTH_BELOW_SEA    6
#define  ZAXIS_DEPTH_BELOW_LAND   7
#define  ZAXIS_ISENTROPIC         8
#define  ZAXIS_TRAJECTORY         9

/* TAXIS types */

#define  TAXIS_ABSOLUTE           1
#define  TAXIS_RELATIVE           2

/* TIME types */

#define  TIME_CONSTANT            1
#define  TIME_VARIABLE            2

/* TUNIT types */

#define  TUNIT_SECOND             1
#define  TUNIT_MINUTE             2
#define  TUNIT_HOUR               3
#define  TUNIT_DAY                4
#define  TUNIT_MONTH              5
#define  TUNIT_YEAR               6

/* CALENDAR types */

#define  CALENDAR_STANDARD        0
#define  CALENDAR_NONE            1
#define  CALENDAR_360DAYS         2
#define  CALENDAR_365DAYS         3
#define  CALENDAR_366DAYS         4


/* CDI control routines */

const char *cdiStringError(int cdiErrno);

void    cdiDebug(int debug);

const char *cdiLibraryVersion(void);
void    cdiPrintVersion(void);

void    cdiDefMissval(double missval);
double  cdiInqMissval(void);
int     cdiDefGlobal(const char *string, int val);
void    cdiDefCompress(int level);

/* STREAM control routines */

/*      streamOpenRead: Open a file for reading */
int     streamOpenRead(const char *filename);

/*      streamOpenWrite: Open a file for writing */
int     streamOpenWrite(const char *filename, int filetype);

int     streamOpenAppend(const char *filename);

/*      streamClose: Close an Open file */
void    streamClose(int streamID);

/*      streamDefVlist: Define the Vlist for a stream */
void    streamDefVlist(int streamID, int vlistID);

/*      streamInqVlist: Get the Vlist of a stream */
int     streamInqVlist(int streamID);

int     streamInqFiletype(int streamID);
void    streamDefByteorder(int streamID, int byteorder);
int     streamInqByteorder(int streamID);

int     streamDefTimestep(int streamID, int tsID);
int     streamInqTimestep(int streamID, int tsID);

char   *streamFilename(int streamID);
char   *streamFilesuffix(int filetype);
int     streamNtsteps(int streamID);


/* STREAM var I/O routines */

/*      streamReadVar: Read a variable */
void    streamReadVar(int streamID, int varID, double *data, int *nmiss);

/*      streamWriteVar: Write a variable */
void    streamWriteVar(int streamID, int varID, double *data, int nmiss);

/*      streamReadVarSlice: Read a horizontal slice of a variable */
void    streamReadVarSlice(int streamID, int varID, int levelID, double *data, int *nmiss);

/*      streamWriteVarSlice: Write a horizontal slice of a variable */
void    streamWriteVarSlice(int streamID, int varID, int levelID, double *data, int nmiss);


/* STREAM record I/O routines */

void    streamInqRecord(int streamID, int *varID, int *levelID);
void    streamDefRecord(int streamID, int  varID, int  levelID);
void    streamReadRecord(int streamID, double *data, int *nmiss);
void    streamWriteRecord(int streamID, double *data, int nmiss);
void    streamCopyRecord(int streamIDdest, int streamIDsrc);

void    streamInqGinfo(int streamID, int *intnum, float *fltnum);

/* VLIST routines */

/*      vlistNew: Create a variable list */
int     vlistNew(void);

/*      vlistFree: Delete a variable list */
void    vlistFree(int vlistID);

/*      vlistDuplicate: Duplicate a variable list */
int     vlistDuplicate(int vlistID);

/*      vlistCopy: Copy a variable list */
void    vlistCopy(int vlistID2, int vlistID1);

/*      vlistCopyFlag: Copy some entries of a variable list */
void    vlistCopyFlag(int vlistID2, int vlistID1);

void    vlistClearFlag(int vlistID);

/*      vlistCat: Concatenate two variable lists */
void    vlistCat(int vlistID2, int vlistID1);

/*      vlistMerge: Merge two variable lists */
void    vlistMerge(int vlistID2, int vlistID1);

void    vlistPrint(int vlistID);

/*      vlistNvars: Number of variables in a variable list */
int     vlistNvars(int vlistID);

/*      vlistNgrids: Number of grids in a variable list */
int     vlistNgrids(int vlistID);

/*      vlistNzaxis: Number of zaxis in a variable list */
int     vlistNzaxis(int vlistID);

void    vlistDefNtsteps(int vlistID, int nts);
int     vlistNtsteps(int vlistID);
int     vlistGridsizeMax(int vlistID);
int     vlistGrid(int vlistID, int index);
int     vlistGridIndex(int vlistID, int gridID);
void    vlistChangeGridIndex(int vlistID, int index, int gridID);
void    vlistChangeGrid(int vlistID, int gridID1, int gridID2);
int     vlistZaxis(int vlistID, int index);
int     vlistZaxisIndex(int vlistID, int zaxisID);
void    vlistChangeZaxisIndex(int vlistID, int index, int zaxisID);
void    vlistChangeZaxis(int vlistID, int zaxisID1, int zaxisID2);
int     vlistNrecs(int vlistID);
void    vlistDefTaxis(int vlistID, int taxisID);
int     vlistInqTaxis(int vlistID);
void    vlistDefTable(int vlistID, int tableID);
int     vlistInqTable(int vlistID);
void    vlistDefInstitut(int vlistID, int instID);
int     vlistInqInstitut(int vlistID);
void    vlistDefModel(int vlistID, int modelID);
int     vlistInqModel(int vlistID);
void    vlistDefAttribute(int vlistID, const char *attname, const char *attstring);


/* VLIST VAR routines */

/*      vlistDefVar: Create a new Variable */
int     vlistDefVar(int vlistID, int gridID, int zaxisID, int timeID);

void    vlistInqVar(int vlistID, int varID, int *gridID, int *zaxisID, int *timeID);
int     vlistInqVarGrid(int vlistID, int varID);
int     vlistInqVarZaxis(int vlistID, int varID);
int     vlistInqVarTime(int vlistID, int varID);

/*      vlistDefVarCode: Define the Code number of a variable */
void    vlistDefVarCode(int vlistID, int varID, int code);

int     vlistInqVarCode(int vlistID, int varID);

/*      vlistDefVarDatatype: Define the data type of a variable */
void    vlistDefVarDatatype(int vlistID, int varID, int datatype);

int     vlistInqVarDatatype(int vlistID, int varID);

void    vlistDefVarInstitut(int vlistID, int varID, int instID);
int     vlistInqVarInstitut(int vlistID, int varID);
void    vlistDefVarModel(int vlistID, int varID, int modelID);
int     vlistInqVarModel(int vlistID, int varID);
void    vlistDefVarTable(int vlistID, int varID, int tableID);
int     vlistInqVarTable(int vlistID, int varID);

/*      vlistDefVarName: Define the name of a variable */
void    vlistDefVarName(int vlistID, int varID, const char *name);

void    vlistInqVarName(int vlistID, int varID, char *name);

/*      vlistDefVarLongname: Define the long name of a variable */
void    vlistDefVarLongname(int vlistID, int varID, const char *longname);

void    vlistInqVarLongname(int vlistID, int varID, char *longname);

/*      vlistDefVarUnits: Define the units of a variable */
void    vlistDefVarUnits(int vlistID, int varID, const char *units);

void    vlistInqVarUnits(int vlistID, int varID, char *units);

/*      vlistDefVarMissval: Define the missing value of a variable */
void    vlistDefVarMissval(int vlistID, int varID, double missval);

double  vlistInqVarMissval(int vlistID, int varID);

void    vlistDefVarScalefactor(int vlistID, int varID, double scalefactor);
double  vlistInqVarScalefactor(int vlistID, int varID);
void    vlistDefVarAddoffset(int vlistID, int varID, double addoffset);
double  vlistInqVarAddoffset(int vlistID, int varID);
void    vlistDefVarAverage(int vlistID, int varID, int average);
int     vlistInqVarAverage(int vlistID, int varID);
int     vlistInqVarSize(int vlistID, int varID);
int     vlistInqVarID(int vlistID, int code);

void    vlistDefIndex(int vlistID, int varID, int levID, int index);
int     vlistInqIndex(int vlistID, int varID, int levID);
void    vlistDefFlag(int vlistID, int varID, int levID, int flag);
int     vlistInqFlag(int vlistID, int varID, int levID);
int     vlistFlagVar(int vlistID, int varID);
int     vlistFlagLevel(int vlistID, int varID, int levelID);
int     vlistFindVar(int vlistID, int fvarID);
int     vlistFindLevel(int vlistID, int fvarID, int flevelID);


/* GRID routines */

/*      gridNew: Create a new Grid */
int     gridNew(int gridtype, int size);

/*      gridInqType: Get the type of a Grid */
int     gridInqType(int gridID);

/*      gridInqSize: Get the size of a Grid */
int     gridInqSize(int gridID);

/*      gridDuplicate: Duplicate a Grid */
int     gridDuplicate(int gridID);

void    gridPrint(int gridID);
int     gridSize(void);

/*      gridDefXsize: Define the size of a X-axis */
void    gridDefXsize(int gridID, int xsize);

/*      gridInqXsize: Get the size of a X-axis */
int     gridInqXsize(int gridID);

/*      gridDefYsize: Define the size of a Y-axis */
void    gridDefYsize(int gridID, int ysize);

/*      gridInqYsize: Get the size of a Y-axis */
int     gridInqYsize(int gridID);

/*      gridDefXvals: Define the values of a X-axis */
void    gridDefXvals(int gridID, double *xvals);

/*      gridInqXvals: Get all values of a X-axis */
int     gridInqXvals(int gridID, double *xvals);

/*      gridDefYvals: Define the values of a Y-axis */
void    gridDefYvals(int gridID, double *yvals);

/*      gridInqYvals: Get all values of a Y-axis */
int     gridInqYvals(int gridID, double *yvals);

char   *gridNamePtr(int gridtype);

/*      gridDefXname: Define the name of a X-axis */
void    gridDefXname(int gridID, char *xname);

/*      gridDefXlongname: Define the longname of a X-axis  */
void    gridDefXlongname(int gridID, char *xlongname);

/*      gridDefXunits: Define the units of a X-axis */
void    gridDefXunits(int gridID, char *xunits);

/*      gridDefYname: Define the name of a Y-axis */
void    gridDefYname(int gridID, char *yname);

/*      gridDefYlongname: Define the longname of a Y-axis */
void    gridDefYlongname(int gridID, char *ylongname);

/*      gridDefYunits: Define the units of a Y-axis */
void    gridDefYunits(int gridID, char *yunits);

/*      gridInqXname: Get the name of a X-axis */
void    gridInqXname(int gridID, char *xname);

/*      gridInqXlongname: Get the longname of a X-axis */
void    gridInqXlongname(int gridID, char *xlongname);

/*      gridInqXstdname: Get the standard name of a X-axis */
void    gridInqXstdname(int gridID, char *xstdname);

/*      gridInqXunits: Get the units of a X-axis */
void    gridInqXunits(int gridID, char *xunits);

/*      gridInqYname: Get the name of a Y-axis */
void    gridInqYname(int gridID, char *yname);

/*      gridInqYlongname: Get the longname of a Y-axis */
void    gridInqYlongname(int gridID, char *ylongname);

/*      gridInqYstdname: Get the standard name of a Y-axis */
void    gridInqYstdname(int gridID, char *ystdname);

/*      gridInqYunits: Get the units of a Y-axis */
void    gridInqYunits(int gridID, char *yunits);

/*      gridDefPrec: Define the precision of a Grid */
void    gridDefPrec(int gridID, int prec);

/*      gridInqPrec: Get the precision of a Grid */
int     gridInqPrec(int gridID);

/*      gridInqXval: Get one value of a X-axis */
double  gridInqXval(int gridID, int index);

/*      gridInqYval: Get one value of a Y-axis */
double  gridInqYval(int gridID, int index);

double  gridInqXinc(int gridID);
double  gridInqYinc(int gridID);
int     gridIsRotated(int gridID);
double  gridInqXpole(int gridID);
void    gridDefXpole(int gridID, double xpole);
double  gridInqYpole(int gridID);
void    gridDefYpole(int gridID, double ypole);
double  gridInqAngle(int gridID);
void    gridDefAngle(int gridID, double angle);
void    gridDefTrunc(int gridID, int trunc);
int     gridInqTrunc(int gridID);
 /* Triangular grid */
int     gridInqTriNd(int gridID);
void    gridDefTriNd(int gridID, int nd);
int     gridInqTriNi(int gridID);
void    gridDefTriNi(int gridID, int ni);
int     gridInqTriNi2(int gridID);
void    gridDefTriNi2(int gridID, int ni2);
int     gridInqTriNi3(int gridID);
void    gridDefTriNi3(int gridID, int ni3);

void    gridDefArea(int gridID, double *area);
void    gridInqArea(int gridID, double *area);
double *gridInqAreaPtr(int gridID);

/*      gridDefNvertex: Define the number of vertex of a Gridbox */
void    gridDefNvertex(int gridID, int nvertex);

/*      gridInqNvertex: Get the number of vertex of a Gridbox */
int     gridInqNvertex(int gridID);

/*      gridDefXbounds: Define the bounds of a X-axis */
void    gridDefXbounds(int gridID, double *xbounds);

/*      gridInqXbounds: Get the bounds of a X-axis */
int     gridInqXbounds(int gridID, double *xbounds);

/*      gridDefYbounds: Define the bounds of a Y-axis */
void    gridDefYbounds(int gridID, double *ybounds);

/*      gridInqYbounds: Get the bounds of a Y-axis */
int     gridInqYbounds(int gridID, double *ybounds);

void    gridDefRowlon(int gridID, int nrowlon, int *rowlon);
void    gridInqRowlon(int gridID, int *rowlon);
void    gridChangeType(int gridID, int gridtype);
int     gridToZonal(int gridID);
int     gridToMeridional(int gridID);
int     gridToCell(int gridID);
int     gridToCurvilinear(int gridID);

/* ZAXIS routines */

/*      zaxisNew: Create a new Z-axis */
int     zaxisNew(int leveltype, int size);

/*      zaxisInqType: Get the type of a Z-axis */
int     zaxisInqType(int zaxisID);

/*      zaxisInqSize: Get the size of a Z-axis */
int     zaxisInqSize(int zaxisID);

/*      zaxisDuplicate: Duplicate a Z-axis */
int     zaxisDuplicate(int zaxisID);

void    zaxisResize(int zaxisID, int size);

void    zaxisPrint(int zaxisID);
int     zaxisSize(void);

/*      zaxisDefLevels: Define the levels of a Z-axis */
void    zaxisDefLevels(int zaxisID, double *levels);

/*      zaxisInqLevels: Get all levels of a Z-axis */
void    zaxisInqLevels(int zaxisID, double *levels);

/*      zaxisDefLevel: Define one level of a Z-axis */
void    zaxisDefLevel(int zaxisID, int levelID, double levels);

/*      zaxisInqLevel: Get one level of a Z-axis */
double  zaxisInqLevel(int zaxisID, int levelID);

/*      zaxisDefName: Define the name of a Z-axis */
void    zaxisDefName(int zaxisID, const char *name);

/*      zaxisDefLongname: Define the longname of a Z-axis */
void    zaxisDefLongname(int zaxisID, const char *longname);

/*      zaxisDefUnits: Define the units of a Z-axis */
void    zaxisDefUnits(int zaxisID, const char *units);

/*      zaxisInqName: Get the name of a Z-axis */
void    zaxisInqName(int zaxisID, char *name);

/*      zaxisInqLongname: Get the longname of a Z-axis */
void    zaxisInqLongname(int zaxisID, char *longname);

/*      zaxisInqUnits: Get the units of a Z-axis */
void    zaxisInqUnits(int zaxisID, char *units);

void    zaxisDefPrec(int zaxisID, int prec);

int     zaxisInqPrec(int zaxisID);
const double *zaxisInqLevelsPtr(int zaxisID);
void    zaxisDefVct(int zaxisID, int size, const double *vct);
int     zaxisInqVctSize(int zaxisID);
const double *zaxisInqVctPtr(int zaxisID);
double  zaxisInqLbound(int zaxisID, int index);
double  zaxisInqUbound(int zaxisID, int index);
int     zaxisInqHasBounds(int zaxisID);
void    zaxisDefBounds(int zaxisID, int size, double *lower, double *upper);
void    zaxisChangeType(int zaxisID, int leveltype);

/* TAXIS routines */

/*      taxisNew: Create a new T-axis */
int     taxisNew(int timetype);

int     taxisDuplicate(int taxisID);

void    taxisDefType(int taxisID, int type);

/*      taxisDefVdate: Define the verification date */
void    taxisDefVdate(int taxisID, int date);

/*      taxisDefVtime: Define the verification time */
void    taxisDefVtime(int taxisID, int time);

/*      taxisDefRdate: Define the reference date */
void    taxisDefRdate(int taxisID, int date);

/*      taxisDefRtime: Define the reference date */
void    taxisDefRtime(int taxisID, int time);

/*      taxisDefCalendar: Define the calendar */
void    taxisDefCalendar(int taxisID, int calendar);

void    taxisDefTunit(int taxisID, int tunit);

void    taxisDefNumavg(int taxisID, int numavg);

int     taxisInqType(int taxisID);

/*      taxisInqVdate: Get the verification date */
int     taxisInqVdate(int taxisID);

/*      taxisInqVtime: Get the verification time */
int     taxisInqVtime(int taxisID);

/*      taxisInqRdate: Get the reference date */
int     taxisInqRdate(int taxisID);

/*      taxisInqRtime: Get the reference time */
int     taxisInqRtime(int taxisID);

/*      taxisInqCalendar: Get the calendar */
int     taxisInqCalendar(int taxisID);

int     taxisInqTunit(int taxisID);

int     taxisInqNumavg(int taxisID);

char   *tunitNamePtr(int tunitID);


/* Institut routines */

int     institutDef(int center, int subcenter, const char *name, const char *longname);
int     institutInq(int center, int subcenter, const char *name, const char *longname);
int     institutInqNumber(void);
int     institutInqCenter(int instID);
int     institutInqSubcenter(int instID);
char   *institutInqNamePtr(int instID);
char   *institutInqLongnamePtr(int instID);

/* Model routines */

int     modelDef(int instID, int modelgribID, const char *name);
int     modelInq(int instID, int modelgribID, char *name);
int     modelInqInstitut(int modelID);
int     modelInqGribID(int modelID);
char   *modelInqNamePtr(int modelID);

/* Table routines */

void    tableWriteC(const char *filename, int tableID);
void    tableWrite(const char *filename, int tableID);
int     tableRead(const char *tablefile);
int     tableDef(int modelID, int tablegribID, const char *tablename);

char   *tableInqNamePtr(int tableID);
void    tableDefEntry(int tableID, int code, const char *name, const char *longname, const char *units);

int     tableInq(int modelID, int tablegribID, const char *tablename);
int     tableInqNumber(void);

int     tableInqGribID(int tableID);
int     tableInqModel(int tableID);

void    tableInqPar(int tableID, int code, char *name, char *longname, char *units);

int     tableInqParName(int tableID, int code, char *name);
int     tableInqParLongname(int tableID, int code, char *longname);
int     tableInqParUnits(int tableID, int code, char *units);

char   *tableInqParNamePtr(int tableID, int parID);
char   *tableInqParLongnamePtr(int tableID, int parID);
char   *tableInqParUnitsPtr(int tableID, int parID);

/* History routines */

void    streamDefHistory(int streamID, int size, const char *history);
int     streamInqHistorySize(int streamID);
void    streamInqHistoryString(int streamID, char *history);

#if defined (__cplusplus)
}
#endif

#endif  /* _CDI_H */
#ifndef _CALENDAR_H
#define _CALENDAR_H

typedef struct {
  double  origin;  /* origin datatype */
  double  factor;  /* scaling factor  */
}
sUnit;

void Calendar(double value, sUnit unit, int *year, int *month,
	      int *day, int *hour, int *minute, double *second);
void InvCalendar(int year, int month, int day, int hour,
		 int minute, double second, sUnit unit, double *value);

void cdiCalendar(int dpy, double value, sUnit unit, int *year, int *month,
		 int *day, int *hour, int *minute, double *second);
void cdiInvCalendar(int dpy, int year, int month, int day, int hour,
		    int minute, double second, sUnit unit, double *value);

#endif  /* _CALENDAR_H */
#ifndef _BASETIME_H
#define _BASETIME_H

#ifndef _CALENDAR_H
#include "calendar.h"
#endif


typedef struct {
  int   ncvarid;
  int   ncdimid;
}
BaseTime;

void basetimeInit(BaseTime *basetime);

#endif  /* _BASETIME_H */
#ifndef _STREAM_INT_H
#define _STREAM_INT_H

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif

#include <stdio.h>
#include <sys/types.h>

#ifndef _ERROR_H
#  include "error.h"
#endif
#ifndef _BASETIME_H
#  include "basetime.h"
#endif
#ifndef _TAXIS_H
#  include "taxis.h"
#endif
#ifndef _CDI_LIMITS_H
#  include "cdi_limits.h"
#endif

#ifndef NINT
#  define  NINT(x)  ((x) < 0 ? (int)((x)-.5) : (int)((x)+.5))
#endif

#define  FALSE  0
#define  TRUE   1

#define  TYPE_REC  0
#define  TYPE_VAR  1

typedef struct
{
  void     *buffer;
  size_t    buffersize;
  off_t     position;
  int       recsize;
  int       size;
  int       dataread;
  int       code;
  int       level;
  int       date;
  int       time;
  int       gridID;
  int       zaxisID;
  int       used;
  int       nrec;
  int       varID;
  int       levelID;
  int       recid;
  int       prec;
  int       sec0[2];
  int       sec1[1024];
  int       sec2[4096];
  int       sec3[2];
  int       sec4[512];
}
Record;

typedef struct
{
  off_t     position;
  size_t    size;
  int       ilevel;
  int       ilevel2;
  int       ltype;
  short     table;
  short     used;
  short     code;
  short     varID;
  short     levelID;
}
RECORD;

typedef struct {
  RECORD   *records;
  int       recordSize;  /* number of allocated records           */
  int      *recIDs;      /* IDs of non constant records           */
  int       nrecs;       /* number of used records                */
                         /* tsID=0 nallrecs                       */
                         /* tsID>0 number of non constant records */
  int       nallrecs;    /* number of all records                 */
  int       curRecID;    /* current record ID                     */
  long      next;
  off_t     position;    /* timestep file position                */
  TAXIS     taxis;
}
TSTEPS;

typedef struct {
  int       ncvarid;
  int       nlevs;
  int      *level;       /* record IDs */
  int      *lindex;      /* level index */
  int       defmiss;     /* TRUE if missval is defined in file */

  int       isUsed;
  int       gridID;
  int       zaxisID;
  int       timeID;      /* ( TIME_VARIABLE or TIME_CONSTANT ) */
  int       nlevel;
}
SVARINFO;

typedef struct {
  int       ilev;
  int       mlev;
  int       ilevID;
  int       mlevID;
}
VCT;

typedef struct {
  int       accesstype;   /* TYPE_REC or TYPE_VAR */
  int       accessmode;
  int       filetype;
  int       byteorder;
  int       fileID;
  int       dimgroupID;
  int       filemode;
  char     *filename;
  char     *ctlname;
  FILE     *ctlfp;
  Record   *record;
  int       nrecs;        /* number of records                  */
  int       nvars;        /* number of variables                */
  int       varlocked;    /* variables locked                   */
  SVARINFO *vars;
  int       varsAllocated;
  int       varinit;
  int       curTsID;      /* current timestep ID */
  int       rtsteps;      /* number of tsteps accessed       */
  long      ntsteps;      /* number of tsteps : only set if all records accessed */
  int       numTimestep;  /* number of tsteps : only set if all records accessed */
  TSTEPS   *tsteps;
  int       tstepsTableSize;
  int       tstepsNextID;
  BaseTime  basetime;
  int       ncmode;
  int       vlistID;
  int       xdimID[MAX_GRIDS];
  int       ydimID[MAX_GRIDS];
  int       zaxisID[MAX_ZAXIS];
  int       ncxvarID[MAX_GRIDS];
  int       ncyvarID[MAX_GRIDS];
  int       ncavarID[MAX_GRIDS];
  int       historyID;
  int       globalatts;
  int       localatts;
  VCT       vct;
  int       unreduced;
  int       compress;
}
CDITABLE;

extern CDITABLE *streams;
extern int CDI_Debug;      /* If set to 1, debuggig (default 0)            */
extern double cdiDefaultMissval;
extern int cdiDefaultInstID;
extern int cdiDefaultModelID;
extern int cdiDefaultTableID;
extern int cdiDefaultLeveltype;

int     streamInqFileID(int streamID);

int     zaxisInqLevelID(int zaxisID, double level);
char   *zaxisTypeNamePtr(int leveltype);

void    streamCheckID(const char *func, int streamID);

void    streamDefineTaxis(int streamID);

int     streamsNewEntry(int filetype);
void    streamsInitEntry(int streamID);
int     streamNewVar(int streamID, int gridID, int zaxisID);

int     tstepsNewEntry(int streamID);

char   *strfiletype(int filetype);

void    cdiGenVars(int streamID);

void    cdiCheckContents(int streamID);

void    cdiCreateRecords(int streamID, int tsID);

int     recordNewEntry(int streamID, int tsID);

void    cdiCreateTimesteps(int streamID);

void    recordInitEntry(RECORD *record);

void    cdiCheckZaxis(int zaxisID);

void    cdiPrintDatatypes(void);

void    cdiDefAccesstype(int streamID, int type);
int     cdiInqAccesstype(int streamID);

void    streamDefDimgroupID(int streamID, int dimgroupID);
int     streamInqDimgroupID(int streamID);

#endif  /* _STREAM_INT_H */
#ifndef _STREAM_GRB_H
#define _STREAM_GRB_H

#ifndef _GRIB_H
#  include "grib.h"
#endif

int   grbScanTimestep(int streamID);
int   grbInqTimeSize(int streamID);
int   grbInqContents(int streamID);
int   grbInqTimestep(int streamID, int tsID);

int   grbInqRecord(int streamID, int *varID, int *levelID);
int   grbDefRecord(int streamID);
int   grbWriteRecord(int streamID, const double *data, int nmiss);
int   grbReadRecord(int streamID, double *data, int *nmiss);
int   grbCopyRecord(int streamIDdest, int streamIDsrc);

void  grbReadVarDP(int streamID, int varID, double *data, int *nmiss);
void  grbWriteVarDP(int streamID, int varID, const double *data, int nmiss);

void  grbReadVarSliceDP(int streamID, int varID, int levelID, double *data, int *nmiss);
void  grbWriteVarSliceDP(int streamID, int varID, int levelID, const double *data, int nmiss);

#endif  /* _STREAM_GRB_H */
typedef struct
{
  long date;
  long time;
}
DateTime;
#ifndef _STREAM_CDF_H
#define _STREAM_CDF_H

void   cdfDefVars(int streamID);
void   cdfDefTimestep(int streamID, int tsID);
int    cdfInqTimestep(int streamID, int tsID);
void   cdfInqContents(int streamID);
void   cdfDefHistory(int streamID, int size, char *history);
int    cdfInqHistorySize(int streamID);
void   cdfInqHistoryString(int streamID, char *history);

void   cdfEndDef(int streamID);
int    cdfDefRecord(int streamID);
int    cdfCopyRecord(int streamIDdest, int streamIDsrc);
int    cdfReadRecord(int streamID, double *data, int *nmiss);
void   cdfWriteRecord(int streamID, double *data, int nmiss);

void   cdfReadVarDP(int streamID, int varID, double *data, int *nmiss);
void   cdfWriteVarDP(int streamID, int varID, double *data, int nmiss);

int    cdfReadVarSliceDP(int streamID, int varID, int levelID, double *data, int *nmiss);
int    cdfWriteVarSliceDP(int streamID, int varID, int levelID, double *data, int nmiss);

#endif
#ifndef _STREAM_HDF_H
#define _STREAM_HDF_H

void   hdfDefDimgroup(int streamID);

void   hdfDefTimestep(int streamID, int tsID);
int    hdfInqTimestep(int streamID, int tsID);
void   hdfInqContents(int streamID);
void   hdfDefHistory(int streamID, int size, char *history);
int    hdfInqHistorySize(int streamID);
void   hdfInqHistoryString(int streamID, char *history);

void   hdfEndDef(int streamID);
int    hdfDefRecord(int streamID);
int    hdfCopyRecord(int streamIDdest, int streamIDsrc);
int    hdfReadRecord(int streamID, double *data, int *nmiss);
void   hdfWriteRecord(int streamID, double *data, int nmiss);

void   hdfReadVarDP(int streamID, int varID, double *data, int *nmiss);
void   hdfWriteVarDP(int streamID, int varID, double *data, int nmiss);

int    hdfReadVarSliceDP(int streamID, int varID, int levelID, double *data, int *nmiss);
int    hdfWriteVarSliceDP(int streamID, int varID, int levelID, double *data, int nmiss);

#endif
#ifndef _GRIB_H
#define _GRIB_H

#include <stdio.h>
#include <sys/types.h>

#define  GRIB_MISSVAL  -9.E33

/* Level Types */
#define  LTYPE_SURFACE               1
#define  LTYPE_99                   99
#define  LTYPE_ISOBARIC            100
#define  LTYPE_MEANSEA             102
#define  LTYPE_ALTITUDE            103
#define  LTYPE_HEIGHT              105
#define  LTYPE_SIGMA               107
#define  LTYPE_HYBRID              109
#define  LTYPE_HYBRID_LAYER        110
#define  LTYPE_LANDDEPTH           111
#define  LTYPE_LANDDEPTH_LAYER     112
#define  LTYPE_SEADEPTH            160
#define  LTYPE_99_MARGIN          1000

/*
 *  Data representation type (Grid Type) [Table 6]
 */
#define  GTYPE_LATLON                0  /*  latitude/longitude                       */
#define  GTYPE_LATLON_ROT           10  /*  rotated latitude/longitude               */
#define  GTYPE_LATLON_STR           20  /*  stretched latitude/longitude             */
#define  GTYPE_LATLON_ROTSTR        30  /*  rotated and stretched latitude/longitude */
#define  GTYPE_GAUSSIAN              4  /*  gaussian grid                            */
#define  GTYPE_GAUSSIAN_ROT         14  /*  rotated gaussian grid                    */
#define  GTYPE_GAUSSIAN_STR         24  /*  stretched gaussian grid                  */
#define  GTYPE_GAUSSIAN_ROTSTR      34  /*  rotated and stretched gaussian grid      */
#define  GTYPE_SPECTRAL             50  /*  spherical harmonics                      */
#define  GTYPE_TRIANGULAR          192  /*  triangular grid                          */

/*
 *  Macros for the indicator section ( Section 0 )
 */
#define  ISEC0_GRIB_Len             (isec0[ 0])  /*  Number of octets in the GRIB message         */
#define  ISEC0_GRIB_Version         (isec0[ 1])  /*  GRIB edition number                          */


/*
 *  Macros for the product definition section ( Section 1 )
 */
#define  ISEC1_TABLE4_MINUTE  0
#define  ISEC1_TABLE4_HOUR    1
#define  ISEC1_TABLE4_DAY     2


#define  ISEC1_CodeTable            (isec1[ 0])  /*  Version number of code table                 */
#define  ISEC1_CenterID             (isec1[ 1])  /*  Identification of centre                     */
#define  ISEC1_ModelID              (isec1[ 2])  /*  Identification of model                      */
#define  ISEC1_GridDefinition       (isec1[ 3])  /*  Grid definition                              */
#define  ISEC1_Sec2Or3Flag          (isec1[ 4])  /*  Section 2 or 3 included                      */
#define  ISEC1_Parameter            (isec1[ 5])  /*  Parameter indicator                          */
#define  ISEC1_LevelType            (isec1[ 6])  /*  Type of level indicator                      */
#define  ISEC1_Level1               (isec1[ 7])  /*  Level 1                                      */
#define  ISEC1_Level2               (isec1[ 8])  /*  Level 2                                      */
#define  ISEC1_Year                 (isec1[ 9])  /*  Year of century (YY)                         */
#define  ISEC1_Month                (isec1[10])  /*  Month (MM)                                   */
#define  ISEC1_Day                  (isec1[11])  /*  Day (DD)                                     */
#define  ISEC1_Hour                 (isec1[12])  /*  Hour (HH)                                    */
#define  ISEC1_Minute               (isec1[13])  /*  Minute (MM)                                  */
#define  ISEC1_TimeUnit             (isec1[14])  /*  Time unit indicator                          */
#define  ISEC1_TimePeriod1          (isec1[15])  /*  P1 Time period                               */
#define  ISEC1_TimePeriod2          (isec1[16])  /*  P2 Time period                               */
#define  ISEC1_TimeRange            (isec1[17])  /*  Time range indicator                         */
#define  ISEC1_AvgNum               (isec1[18])  /*  Number of products included in an average    */
#define  ISEC1_AvgMiss              (isec1[19])  /*  Number of products missing form an average   */
#define  ISEC1_Century              (isec1[20])  /*  Century                                      */
#define  ISEC1_SubCenterID          (isec1[21])  /*  Subcenter identifier                         */
#define  ISEC1_DecScaleFactor       (isec1[22])  /*  Decimal scale factor                         */
#define  ISEC1_LocalFLag            (isec1[23])  /*  Flag field to indicate local use in isec1    */

#define  ISEC1_ECMWF_LocalExtention (isec1[36])
#define  ISEC1_ECMWF_Class          (isec1[37])


/*
 *  Macros for the grid definition section ( Section 2 )
 */
#define  ISEC2_GridType             (isec2[ 0])  /* Data representation type */

/* Triangular grids */

#define  ISEC2_TRI_NI2              (isec2[ 1])  /*  Number of factor 2 in factorisation of Ni    */
#define  ISEC2_TRI_NI3              (isec2[ 2])  /*  Number of factor 3 in factorisation of Ni    */
#define  ISEC2_TRI_ND               (isec2[ 3])  /*  Nubmer of diamonds                           */
#define  ISEC2_TRI_NI               (isec2[ 4])  /*  Number of tri. subdiv. of the icosahedron    */
#define  ISEC2_TRI_AFlag            (isec2[ 5])  /*  Flag for orientation of diamonds (Table A)   */
#define  ISEC2_TRI_LatPP            (isec2[ 6])  /*  Latitude of pole point                       */
#define  ISEC2_TRI_LonPP            (isec2[ 7])  /*  Longitude of pole point                      */
#define  ISEC2_TRI_LonMPL           (isec2[ 8])  /*  Longitude of the first diamond               */
#define  ISEC2_TRI_BFlag            (isec2[ 9])  /*  Flag for storage sequence (Table B)          */

/* Spherical harmonic coeficients */

#define  ISEC2_PentaJ               (isec2[ 1])  /*  J pentagonal resolution parameter            */
#define  ISEC2_PentaK               (isec2[ 2])  /*  K pentagonal resolution parameter            */
#define  ISEC2_PentaM               (isec2[ 3])  /*  M pentagonal resolution parameter            */
#define  ISEC2_RepType              (isec2[ 4])  /*  Representation type                          */
#define  ISEC2_RepMode              (isec2[ 5])  /*  Representation mode                          */

/* Gaussian grids */

#define  ISEC2_NumLon               (isec2[ 1])  /*  Number of points along a parallel (Ni)       */
#define  ISEC2_NumLat               (isec2[ 2])  /*  Number of points along a meridian (Nj)       */
#define  ISEC2_FirstLat             (isec2[ 3])  /*  Latitude of the first grid point             */
#define  ISEC2_FirstLon             (isec2[ 4])  /*  Longitude of the first grid point            */
#define  ISEC2_ResFlag              (isec2[ 5])  /*  Resolution flag: 128 regular grid            */
#define  ISEC2_LastLat              (isec2[ 6])  /*  Latitude of the last grid point              */
#define  ISEC2_LastLon              (isec2[ 7])  /*  Longitude of the last grid point             */
#define  ISEC2_LonIncr              (isec2[ 8])  /*  i direction increment                        */
#define  ISEC2_LatIncr              (isec2[ 9])  /*  j direction increment                        */
#define  ISEC2_NumPar               (isec2[ 9])  /*  Number of parallels between a pole and the E.*/
#define  ISEC2_ScanFlag             (isec2[10])  /*  Scanning mode flags                          */
#define  ISEC2_NumVCP               (isec2[11])  /*  Number of vertical coordinate parameters     */

#define  ISEC2_Reduced              (isec2[16])  /* 0: regular, 1: reduced grid                   */

#define  ISEC2_RowLonPtr            (&isec2[22])
#define  ISEC2_RowLon(i)            (isec2[22+i]) /* Number of points along each parallel         */

/* */

#define  ISEC2_LatSP                (isec2[12])  /* Latitude of the southern pole of rotation     */
#define  ISEC2_LonSP                (isec2[13])  /* Longitude of the southern pole of rotation    */

#define  FSEC2_RotAngle             (fsec2[ 0])  /* Angle of rotation                             */
#define  FSEC2_StrFact              (fsec2[ 1])  /* Stretching factor                             */

/*
 *  Macros for the bit map section ( Section 3 )
 */
#define  ISEC3_PredefBitmap         (isec3[ 0])  /* Predefined bitmap                             */
#define  ISEC3_MissVal              (isec3[ 1])  /* Missing data value for integers               */
#define  FSEC3_MissVal              (fsec3[ 1])  /* Missing data value for floats                 */

/*
 *  Macros for the binary data section ( Section 4 )
 */
#define  ISEC4_NumValues            (isec4[ 0])  /* Number of data values for encode/decode       */
#define  ISEC4_NumBits              (isec4[ 1])  /* Number of bits used for each encoded value    */
#define  ISEC4_NumNonMissValues     (isec4[20])  /* Number of non-missing values                  */




void  gribSetDebug(int debug);
void  gribSetRound(int round);
void  gribSetRefDP(double refval);
void  gribSetRefSP(float  refval);
void  gribSetValueCheck(int vcheck);


void  gribExSP(int *isec0, int *isec1, int *isec2, float *fsec2, int *isec3,
               float *fsec3, int *isec4, float *fsec4, int klenp, int *kgrib,
               int kleng, int *kword, char *hoper, int *kret);

void  gribExDP(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
               double *fsec3, int *isec4, double *fsec4, int klenp, int *kgrib,
               int kleng, int *kword, char *hoper, int *kret);


const char *gribLibraryVersion(void);

void  gribDebug(int debug);


void  gribDateTime(int *isec1, int *date, int *time);
int   gribRefDate(int *isec1);
int   gribRefTime(int *isec1);
int   gribTimeIsFC(int *isec1);

void  gribPrintSec0(int *isec0);
void  gribPrintSec1(int *isec0, int *isec1);
void  gribPrintSec2DP(int *isec0, int *isec2, double *fsec2);
void  gribPrintSec2SP(int *isec0, int *isec2, float  *fsec2);
void  gribPrintSec3DP(int *isec0, int *isec3, double *fsec3);
void  gribPrintSec3SP(int *isec0, int *isec3, float  *fsec3);
void  gribPrintSec4DP(int *isec0, int *isec4, double *fsec4);
void  gribPrintSec4SP(int *isec0, int *isec4, float  *fsec4);
void  gribPrintSec4Wave(int *isec4);

void  gribPrintALL(int nrec, long offset, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintPDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintGDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintBMS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);
void  gribPrintBDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer);


int   gribOpen(const char *filename, const char *mode);
void  gribClose(int fileID);

int   gribRead(int fileID, unsigned char *buffer, size_t *buffersize);
int   gribWrite(int fileID, unsigned char *buffer, size_t buffersize);
off_t gribGetPos(int fileID);
int   gribGetSize(int fileID);
int   gribFileSeek(int fileID, long *offset);
int   gribReadSize(int fileID);
int   gribVersion(unsigned char *buffer, size_t buffersize);

int gribGinfo(long recpos, long recsize, unsigned char *gribbuffer, int *intnum, float *fltnum);

#endif  /* _GRIB_H */
#ifndef _TABLEPAR_H
#define _TABLEPAR_H

typedef struct
{
  int   id;	     /* Parameter number (GRIB) */
  char *name;	     /* Parameter name */
  char *longname;    /* Parameter long name */
  char *units;	     /* Parameter units */
}
PAR;


void tableLink(int tableID, PAR *pars, int npars);
int tableDef(int modelID, int tablegribID, const char *tablename);

#endif
#ifndef _TABLE_H
#define _TABLE_H

static PAR echam4[] = {
  {   4, "precip",      "total precipitation",                      "m/s"      },
  {  34, "low_cld",     "low cloud",                                 NULL      },
  {  35, "mid_cld",     "mid cloud",                                 NULL      },
  {  36, "hih_cld",     "high cloud",                                NULL      },
  { 129, "geosp",       "surface geopotential (orography)",         "m^2/s^2"  },
  { 130, "t",           "temperature",                              "K"        },
  { 131, "u",           "u-velocity",                               "m/s"      },
  { 132, "v",           "v-velocity",                               "m/s"      },
  { 133, "sq",          "specific humidity",                        "kg/kg"    },
  { 134, "aps",         "Surface pressure",                         "Pa"       },
  { 135, "omega",       "vertical velocity",                        "Pa/s"     },
  { 138, "svo",         "vorticity",                                "1/s"      },
  { 139, "ts",          "surface temperature",                      "K"        },
  { 140, "ws",          "soil wetness",                             "m"        },
  { 141, "sn",          "snow depth",                               "m"        },
  { 142, "aprl",        "large scale precipitation",                "m/s"      },
  { 143, "aprc",        "convective  precipitation",                "m/s"      },
  { 144, "aprs",        "snow fall",                                "m/s"      },
  { 145, "vdis",        "boundary layer dissipation",               "W/m^2"    },
  { 146, "ahfs",        "surface sensible heat flux",               "W/m^2"    },
  { 147, "ahfl",        "surface latent heat flux",                 "W/m^2"    },
  { 148, "stream",      "streamfunction",                           "m^2/s"    },
  { 149, "velopot",     "velocity potential",                       "m^2/s"    },
  { 151, "slp",         "mean sea level pressure",                  "Pa"       },
  { 152, "lsp",         "log surface pressure",                      NULL      },
  { 153, "sx",          "liquid water content",                     "kg/kg"    },
  { 155, "sd",          "divergence",                               "1/s"      },
  { 156, "geopoth",     "geopotential height",                      "m"        },
  { 157, "rhumidity",   "relative humidity",                        "fraction" },
  { 158, "var158",      "tendency of surface pressure",             "Pa/s"     },
  { 159, "ustar3",      "ustar3",                                   "m^3/s^3"  },
  { 160, "runoff",      "surface runoff",                           "m/s"      },
  { 161, "alwc",        "liquid water content",                     "kg/kg"    },
  { 162, "aclc",        "cloud cover",                              "fraction" },
  { 163, "aclcv",       "total cloud cover",                        "fraction" },
  { 164, "aclcov",      "total cloud cover",                        "fraction" },
  { 165, "u10",         "10m u-velocity",                           "m/s"      },
  { 166, "v10",         "10m v-velocity",                           "m/s"      },
  { 167, "temp2",       "2m temperature",                           "K"        },
  { 168, "dew2",        "2m dew point temperature",                 "K"        },
  { 169, "tsurf",       "surface temperature",                      "K"        },
  { 170, "td",          "deep soil temperature",                    "K"        },
  { 171, "wind10",      "10m windspeed",                            "m/s"      },
  { 172, "slm",         "land sea mask",                            "fraction" },
  { 173, "az0",         "surface roughness length",                 "m"        },
  { 174, "alb",         "surface background albedo",                "fraction" },
  { 175, "albedo",      "surface albedo",                           "fraction" },
  { 176, "srads",       "net surface solar radiation",              "W/m^2"    },
  { 177, "trads",       "net surface thermal radiation",            "W/m^2"    },
  { 178, "srad0",       "net top solar radiation",                  "W/m^2"    },
  { 179, "trad0",       "top thermal radiation (OLR)",              "W/m^2"    },
  { 180, "ustr",        "surface u-stress",                         "Pa"       },
  { 181, "vstr",        "surface v-stress",                         "Pa"       },
  { 182, "evap",        "surface evaporation",                      "m/s"      },
  { 183, "tdcl",        "soil temperature",                         "K"        },
  { 185, "srafs",       "net surf. solar radiation   (clear sky)",  "W/m^2"    },
  { 186, "trafs",       "net surf. thermal radiation (clear sky)",  "W/m^2"    },
  { 187, "sraf0",       "net top solar radiation     (clear sky)",  "W/m^2"    },
  { 188, "traf0",       "net top thermal radiation   (clear sky)",  "W/m^2"    },
  { 189, "sclfs",       "surface solar cloud forcing",              "W/m^2"    },
  { 190, "tclfs",       "surface thermal cloud forcing",            "W/m^2"    },
  { 191, "sclf0",       "top solar cloud forcing",                  "W/m^2"    },
  { 192, "tclf0",       "top thermal cloud forcing",                "W/m^2"    },
  { 193, "wl",          "skin reservoir content",                   "m"        },
  { 194, "wlm1",        "skin reservoir content of plants",         "m"        },
  { 195, "ustrgw",      "u-gravity wave stress",                    "Pa"       },
  { 196, "vstrgw",      "v-gravity wave stress",                    "Pa"       },
  { 197, "vdisgw",      "gravity wave dissipation",                 "W/m^2"    },
  { 198, "vgrat",       "vegetation ratio",                         "fraction" },
  { 199, "varor",       "orographic variance",                      "m^2"      },
  { 200, "vlt",         "leaf area index",                           NULL      },
  { 201, "t2max",       "maximum 2m-temperature",                   "K"        },
  { 202, "t2min",       "minimum 2m-temperature",                   "K"        },
  { 203, "srad0u",      "top solar radiation upward",               "W/m^2"    },
  { 204, "sradsu",      "surface solar radiation upward",           "W/m^2"    },
  { 205, "tradsu",      "surface thermal radiation upward",         "W/m^2"    },
  { 206, "tsn",         "snow temperature",                         "K"        },
  { 207, "td3",         "soil temperature 3",                       "K"        },
  { 208, "td4",         "soil temperature 4",                       "K"        },
  { 209, "td5",         "soil temperature 5",                       "K"        },
  { 210, "seaice",      "sea ice cover",                            "fraction" },
  { 211, "siced",       "sea ice depth",                            "m"        },
  { 212, "forest",      "vegetation type",                          "fraction" },
  { 213, "teff",        "(effective) sea-ice skin temperature",     "K"        },
  { 214, "tsmax",       "maximum surface temperature",              "K"        },
  { 215, "tsmin",       "minimum surface temperature",              "K"        },
  { 216, "wimax",       "maximum 10m-wind speed",                   "m/s"      },
  { 217, "topmax",      "maximum height of convective cloud tops",  "Pa"       },
  { 218, "snmel",       "snow melt",                                "m/s"      },
  { 219, "runtoc",      "surface runoff into ocean",                 NULL      },
  { 220, "tslin",       "land: residual surface heat budget",       "W/m^2"    },
  { 221, "dsnac",       "snow depth change",                        "m/s"      },
  { 222, "alwcac",      "liquid water content",                     "kg/kg"    },
  { 223, "aclcac",      "cloud cover",                              "fraction" },
  { 224, "tke",         "turbulent kinetic energy",                  NULL      },
  { 225, "tkem1",       "turbulent kinetic energy (t-1)",            NULL      },
  { 226, "fao",         "FAO data set (soil data flags)",            NULL      },
  { 227, "rgcgn",       "heat capacity of soil",                     NULL      },
  { 228, "sodif",       "soil diffusivity",                          NULL      },
  { 229, "wsmx",        "field capacity of soil",                   "m"        },
  { 230, "qvi",         "vertically integrated specific humidity",  "kg/m^2"   },
  { 231, "alwcvi",      "vertically integrated liquid water cont.", "kg/m^2"   },
  { 232, "glac",        "glacier mask",                             "fraction" },
  { 233, "runlnd",      "surface runoff not running into ocean",     NULL      },
  { 259, "windspeed",   "windspeed (sqrt(u^2+v^2))",                 NULL      },
  { 260, "precip",      "total precipitation",                      "m/s"      },
  { 261, "net_top",     "total top radiation",                       NULL      },
  { 262, "net_bot",     "total surface radiation",                   NULL      },
  { 263, "net_heat",    "net surface heat flux",                     NULL      },
  { 264, "net_water",   "total surface water",                       NULL      },
  { 268, "sw_atm",       NULL,                                       NULL      },
  { 269, "lw_atm",       NULL,                                       NULL      },
  { 270, "net_atm",      NULL,                                       NULL      },
  { 271, "surf_runoff", "surface runoff",                            NULL      },
  { 275, "fresh_water",  NULL,                                       NULL      },
};

static PAR echam5[] = {
  {   4, "precip",      "total precipitation",                       "kg/m^2s"  },
  {  34, "low_cld",     "low cloud",                                  NULL      },
  {  35, "mid_cld",     "mid cloud",                                  NULL      },
  {  36, "hih_cld",     "high cloud",                                 NULL      },
  {  91, "trfliac",     "LW flux over ice",                          "W/m^2"    },
  {  92, "trflwac",     "LW flux over water",                        "W/m^2"    },
  {  93, "trfllac",     "LW flux over land",                         "W/m^2"    },
  {  94, "sofliac",     "SW flux over ice",                          "W/m^2"    },
  {  95, "soflwac",     "SW flux over water",                        "W/m^2"    },
  {  96, "sofllac",     "SW flux over land",                         "W/m^2"    },
  {  97, "friac",       "ice cover (fraction of grid box)",           NULL      },
  { 102, "tsi",         "surface temperature of ice",                "K"        },
  { 103, "tsw",         "surface temperature of water",              "K"        },
  { 104, "ustri",       "zonal      wind stress over ice",           "Pa"       },
  { 105, "vstri",       "meridional wind stress over ice",           "Pa"       },
  { 106, "ustrw",       "zonal      wind stress over water",         "Pa"       },
  { 107, "vstrw",       "meridional wind stress over water",         "Pa"       },
  { 108, "ustrl",       "zonal      wind stress over land",          "Pa"       },
  { 109, "vstrl",       "meridional wind stress over land",          "Pa"       },
  { 110, "ahfliac",     "latent heat flux over ice",                 "W/m^2"    },
  { 111, "ahflwac",     "latent heat flux over water",               "W/m^2"    },
  { 112, "ahfllac",     "latent heat flux over land",                "W/m^2"    },
  { 113, "evapiac",     "evaporation over ice",                      "kg/m^2s"  },
  { 114, "evapwac",     "evaporation over water",                    "kg/m^2s"  },
  { 115, "evaplac",     "evaporation over land",                     "kg/m^2s"  },
  { 116, "az0i",        "roughness length over ice",                 "m"        },
  { 117, "az0w",        "roughness length over water",               "m"        },
  { 118, "az0l",        "roughness length over land",                "m"        },
  { 119, "ahfsiac",     "sensible heat flux over ice",               "W/m^2"    },
  { 120, "ahfswac",     "sensible heat flux over water",             "W/m^2"    },
  { 121, "ahfslac",     "sensible heat flux over land",              "W/m^2"    },
  { 122, "alsoi",       "albedo of ice",                              NULL      },
  { 123, "alsow",       "albedo of water",                            NULL      },
  { 124, "alsol",       "albedo of land",                             NULL      },
  { 125, "ahfice",      "conductive heat flux",                      "W/m^2"    },
  { 126, "qres",        "residual heat flux for melting sea ice",    "W/m^2"    },
  { 127, "alake",       "lake fraction of grid box",                 "fraction" },
  { 128, "var128",       NULL,                                        NULL      },
  { 129, "geosp",       "surface geopotential (orography)",          "m^2/s^2"  },
  { 130, "t",           "temperature",                               "K"        },
  { 131, "u",           "u-velocity",                                "m/s"      },
  { 132, "v",           "v-velocity",                                "m/s"      },
  { 133, "q",           "specific humidity",                         "kg/kg"    },
  { 134, "aps",         "surface pressure",                          "Pa"       },
  { 135, "omega",       "vertical velocity",                         "Pa/s"     },
  { 136, "acdnc",       "cloud droplet number concentration",         NULL      },
  { 137, "var137",       NULL,                                        NULL      },
  { 138, "svo",         "vorticity",                                 "1/s"      },
  { 139, "tslm1",       "surface temperature of land",               "K"        },
  { 140, "ws",          "soil wetness",                              "m"        },
  { 141, "sn",          "snow depth",                                "m"        },
  { 142, "aprl",        "large scale precipitation",                 "kg/m^2s"  },
  { 143, "aprc",        "convective  precipitation",                 "kg/m^2s"  },
  { 144, "aprs",        "snow fall",                                 "kg/m^2s"  },
  { 145, "vdis",        "boundary layer dissipation",                "W/m^2"    },
  { 146, "ahfs",        "sensible heat flux",                        "W/m^2"    },
  { 147, "ahfl",        "latent heat flux",                          "W/m^2"    },
  { 148, "stream",      "streamfunction",                            "m^2/s"    },
  { 149, "velopot",     "velocity potential",                        "m^2/s"    },
  { 150, "xivi",        "vertically integrated cloud ice",           "kg/m^2"   },
  { 151, "slp",         "mean sea level pressure",                   "Pa"       },
  { 152, "lsp",         "log surface pressure",                       NULL      },
  { 153, "xl",          "cloud water",                               "kg/kg"    },
  { 154, "xi",          "cloud ice",                                 "kg/kg"    },
  { 155, "sd",          "divergence",                                "1/s"      },
  { 156, "geopoth",     "geopotential height",                       "m"        },
  { 157, "rhumidity",   "relative humidity",                         "fraction" },
  { 158, "var158",      "tendency of surface pressure",              "Pa/s"     },
  { 159, "ustar3",      "ustar^3",                                   "m^3/s^3"  },
  { 160, "runoff",      "surface runoff and drainage",               "kg/m^2s"  },
  { 161, "drain",       "drainage",                                  "kg/m^2s"  },
  { 162, "aclc",        "cloud cover",                                NULL      },
  { 163, "aclcv",       "total cloud cover",                          NULL      },
  { 164, "aclcov",      "total cloud cover",                          NULL      },
  { 165, "u10",         "10m u-velocity",                            "m/s"      },
  { 166, "v10",         "10m v-velocity",                            "m/s"      },
  { 167, "temp2",       "2m temperature",                            "K"        },
  { 168, "dew2",        "2m dew point temperature",                  "K"        },
  { 169, "tsurf",       "surface temperature",                       "K"        },
  { 170, "xvar",        "variance of total water amount qv+qi+ql",    NULL      },
  { 171, "wind10",      "10m windspeed",                             "m/s"      },
  { 172, "slm",         "land sea mask (1. = land, 0. = sea/lakes)",  NULL      },
  { 173, "az0",         "roughness length",                          "m"        },
  { 174, "alb",         "surface background albedo",                  NULL      },
  { 175, "albedo",      "surface albedo",                             NULL      },
  { 176, "srads",       "net surface solar radiation",               "W/m^2"    },
  { 177, "trads",       "net surface thermal radiation",             "W/m^2"    },
  { 178, "srad0",       "net top solar radiation",                   "W/m^2"    },
  { 179, "trad0",       "top thermal radiation (OLR)",               "W/m^2"    },
  { 180, "ustr",        "u-stress",                                  "Pa"       },
  { 181, "vstr",        "v-stress",                                  "Pa"       },
  { 182, "evap",        "evaporation",                               "kg/m^2s"  },
  { 183, "xskew",       "skewness of total water amount qv+qi+ql",    NULL      },
  { 184, "srad0d",      "top incoming solar radiation",              "W/m^2"    },
  { 185, "srafs",       "net surf. solar radiation   (clear sky)",   "W/m^2"    },
  { 186, "trafs",       "net surf. thermal radiation (clear sky)",   "W/m^2"    },
  { 187, "sraf0",       "net top solar radiation     (clear sky)",   "W/m^2"    },
  { 188, "traf0",       "net top thermal radiation   (clear sky)",   "W/m^2"    },
  { 189, "var189",      "surface solar cloud forcing",               "W/m^2"    },
  { 190, "var190",      "surface thermal cloud forcing",             "W/m^2"    },
  { 191, "var191",      "SW top cloud forcing (178-187)",            "W/m^2"    },
  { 192, "var192",      "LW top cloud forcing (179-188)",            "W/m^2"    },
  { 193, "wl",          "skin reservoir content",                    "m"        },
  { 194, "slf",         "sea land fraction",                         "fraction" },
  { 195, "ustrgw",      "u-gravity wave stress",                     "Pa"       },
  { 196, "vstrgw",      "v-gravity wave stress",                     "Pa"       },
  { 197, "vdisgw",      "gravity wave dissipation",                  "W/m^2"    },
  { 198, "vgrat",       "vegetation ratio",                           NULL      },
  { 199, "orostd",      "orographic standard deviation",             "m"        },
  { 200, "vlt",         "leaf area index",                            NULL      },
  { 201, "t2max",       "maximum 2m-temperature",                    "K"        },
  { 202, "t2min",       "minimum 2m-temperature",                    "K"        },
  { 203, "srad0u",      "top solar radiation upward",                "W/m^2"    },
  { 204, "sradsu",      "surface solar radiation upward",            "W/m^2"    },
  { 205, "tradsu",      "surface thermal radiation upward",          "W/m^2"    },
  { 206, "grndflux",    "surface ground heat flux",                   NULL      },
  { 207, "tsoil",       "deep soil temperatures (5 layers)",         "K"        },
  { 208, "ahfcon",      "conductive heat flux through ice",          "W/m^2"    },
  { 209, "ahfres",      "residual heat flux over ice",               "W/m^2"    },
  { 210, "seaice",      "ice cover (fraction of 1-SLM)",              NULL      },
  { 211, "siced",       "ice depth",                                 "m"        },
  { 212, "forest",      "forest fraction",                            NULL      },
  { 213, "gld",         "glacier depth",                             "m"        },
  { 214, "sni",         "water equivalent of snow on ice",           "m"        },
  { 215, "rogl",        "glacier runoff",                            "kg/m^2s"  },
  { 216, "wimax",       "maximum 10m-wind speed",                    "m/s"      },
  { 217, "topmax",      "maximum height of convective cloud tops",   "Pa"       },
  { 218, "snmel",       "snow melt",                                 "kg/m^2s"  },
  { 219, "runtoc",      "surface runoff into ocean",                 "kg/m^2s"  },
  { 220, "runlnd",      "surface runoff not running into ocean",     "kg/m^2s"  },
  { 221, "apmegl",      "P-E over land ice",                         "kg/m^2s"  },
  { 222, "snacl",       "snow accumulation over land",               "kg/m^2s"  },
  { 223, "aclcac",      "cloud cover",                                NULL      },
  { 224, "tke",         "turbulent kinetic energy",                   NULL      },
  { 225, "tkem1",       "turbulent kinetic energy (t-1)",             NULL      },
  { 226, "fao",         "FAO data set (soil data flags)",             NULL      },
  { 227, "rgcgn",       "heat capacity of soil",                      NULL      },
  { 228, "sodif",       "soil diffusivity",                           NULL      },
  { 229, "wsmx",        "field capacity of soil",                    "m"        },
  { 230, "qvi",         "vertically integrated water vapor",         "kg/m^2"   },
  { 231, "xlvi",        "vertically integrated cloud water",         "kg/m^2"   },
  { 232, "glac",        "fraction of land covered by glaciers",       NULL      },
  { 233, "snc",         "snow depth at the canopy",                  "m"        },
  { 259, "windspeed",   "windspeed (sqrt(u^2+v^2))",                  NULL      },
  { 260, "precip",      "total precipitation",                       "kg/m^2s"  },
  { 261, "net_top",     "total top radiation",                        NULL      },
  { 262, "net_bot",     "total surface radiation",                    NULL      },
  { 263, "net_heat",    "net surface heat flux",                      NULL      },
  { 264, "net_water",   "total surface water",                        NULL      },
  { 268, "sw_atm",       NULL,                                        NULL      },
  { 269, "lw_atm",       NULL,                                        NULL      },
  { 270, "net_atm",      NULL,                                        NULL      },
  { 271, "surf_runoff", "surface runoff",                             NULL      },
  { 275, "fresh_water",  NULL,                                        NULL      },
};

static PAR mpiom1[] = {
  {   2, "THO",      "temperature",                     "C"        },
  {   5, "SAO",      "salinity",                        "psu"      },
  {   3, "UKO",      "zon. velocity",                   "m/s"      },
  {   4, "VKE",      "mer. velocity",                   "m/s"      },
  { 303, "UKOMFL",   "zon. velocity (divergence free)", "m/s"      },
  { 304, "VKEMFL",   "mer. velocity (divergence free)", "m/s"      },
  {   7, "WO",       "ver. velocity",                   "m/s"      },
  {   8, "RHO",      "insitu density",                  "kg/m**3"  },
  {   6, "PO",       "pressure",                        "Pa"       },
  {  67, "EMINPO",   "freshwaterflux by restoring",     "m/s"      },
  {  70, "FLUM",     "total heatflux",                  "W/m**2"   },
  {  79, "PEM",      "total freshwaterflux",            "m/s"      },
  {  13, "SICTHO",   "ice thickness",                   "m"        },
  {  15, "SICOMO",   "ice compactness",                 "frac."    },
  {  35, "SICUO",    "zon. ice velocity",               "m/s"      },
  {  36, "SICVE",    "mer. ice velocity",               "m/s"      },
  {  92, "TAFO",     "surface air temperature",         "C"        },
  { 164, "FCLOU",    "cloud cover",                      NULL      },
  {  52, "TXO",      "surface u-stress",                "Pa/1025." },
  {  53, "TYE",      "surface v-stress",                "Pa/1025." },
  { 260, "FPREC",    "prescr. precipitation",           "m/s"      },
  {  80, "FSWR",     "downward shortwave rad.",         "W/m**2"   },
  {  81, "FTDEW",    "dewpoint temperature",            "K"        },
  { 171, "FU10",     "10m windspeed",                   "m/s"      },
  { 141, "SICSNO",   "snow thickness",                  "m"        },
  { 176, "QSWO",     "heat flux shortwave",             "W/m**2"   },
  { 177, "QLWO",     "heat flux longwave",              "W/m**2"   },
  { 147, "QLAO",     "heat flux latent",                "W/m**2"   },
  { 146, "QSEO",     "heat flux sensible",              "W/m**2"   },
  {  65, "PRECO",    "net freshwater flux + runoff",    "m/s"      },
  {   1, "ZO",       "sealevel",                        "m"        },
  {  82, "Z1O",      "sealevel change",                 "m"        },
  {  69, "KCONDEP",  "depth of convection",             "level"    },
  {  27, "PSIUWE",   "hor. bar. streamfunction",        "Sv"       },
  {  83, "AMLD",     "mixed layer depth",               "m"        },
  { 172, "WETO",     "landseamask (pressure points)",    NULL      },
  { 507, "AMSUE",    "landseamask (vector points v)",    NULL      },
  { 508, "AMSUO",    "landseamask (vector points u)",    NULL      },
  {  84, "DEPTO",    "depth at pressure points",        "m"        },
  { 484, "DEUTO",    "depth at vector points (u)",      "m"        },
  { 584, "DEUTE",    "depth at vector points (v)",      "m"        },
  { 184, "DDUO",     "level thickness (vector u )",     "m"        },
  { 284, "DDUE",     "level thickness (vector v )",     "m"        },
  { 384, "DDPO",     "level thickness (pressure )",     "m"        },
  {  85, "DLXP",     "grid distance x",                 "m"        },
  {  86, "DLYP",     "grid distance y",                 "m"        },
  { 185, "DLXU",     "grid distance x  (vector u)",     "m"        },
  { 186, "DLYU",     "grid distance y  (vector u)",     "m"        },
  { 285, "DLXV",     "grid distance x  (vector v)",     "m"        },
  { 286, "DLYV",     "grid distance y  (vector v)",     "m"        },
  {  54, "GILA",     "latitude in radiants",            "rad"      },
  {  55, "GIPH",     "longitude in radiants",           "rad"      },
  { 354, "ALAT",     "latitude in degrees (pressure)",  "deg"      },
  { 355, "ALON",     "longitude in degrees (pressure)", "deg"      },
  { 154, "ALATU",    "latitude in degrees (vector u)",  "deg"      },
  { 155, "ALONU",    "longitude in degrees (vector u)", "deg"      },
  { 254, "ALATV",    "latitude in degrees (vector v)",  "deg"      },
  { 255, "ALONV",    "longitude in degrees (vector v)", "deg"      },
  { 110, "AVO",      "vertical impuls diffusion",       "m**2/s"   },
  { 111, "DVO",      "vertical T,S diffusion",          "m**2/s"   },
  { 142, "SICTRU",   "seaice transport x",              "m**2/s"   },
  { 143, "SICTRV",   "seaice transport y",              "m**2/s"   },
  { 612, "WTMIX",    "wind mixing",                     "m**2/s"   },
  { 183, "zmld",     "mixed layer depth (SJ)",          "m"        },
  { 207, "WGO",      "GM vertical velocity",            "m/s"      },
  { 305, "rivrun",   "RiverRunoff",                     "m/s"      },
  { 158, "TMCDO",    "mon. mean depth of convection",   "level"    },
  { 247, "DQSWO",    "heatflux sw over water",          "W/m**2"   },
  { 248, "DQLWO",    "heatflux lw over water",          "W/m**2"   },
  { 249, "DQSEO",    "heatflux se over water",          "W/m**2"   },
  { 250, "DQLAO",    "heatflux la over water",          "W/m**2"   },
  { 251, "DQTHO",    "heatflux net over water",         "W/m**2"   },
  { 252, "DQSWI",    "heatflux sw over seaice",         "W/m**2"   },
  { 253, "DQLWI",    "heatflux lw over seaice",         "W/m**2"   },
  { 254, "DQSEI",    "heatflux se over seaice",         "W/m**2"   },
  { 255, "DQLAI",    "heatflux la over seaice",         "W/m**2"   },
  { 256, "DQTHI",    "heatflux net over seaice",        "W/m**2"   },
  { 257, "DTICEO",   "Equi. temp over seaice",          "K"        },
  { 270, "AOFLNHWO", "oasis net heat flux water",       "W/m**2"   },
  { 271, "AOFLSHWO", "oasis downward short wave",       "W/m**2"   },
  { 272, "AOFLRHIO", "oasis residual heat flux ice",    "W/m**2"   },
  { 273, "AOFLCHIO", "oasis conduct. heat flux ice",    "W/m**2"   },
  { 274, "AOFLFRWO", "oasis fluid fresh water flux",    "m/s"      },
  { 275, "AOFLFRIO", "oasis solid fresh water flux",    "m/s"      },
  { 276, "AOFLTXWO", "oasis wind stress water x",       "Pa/102"   },
  { 277, "AOFLTYWO", "oasis wind stress water y",       "Pa/102"   },
  { 278, "AOFLTXIO", "oasis wind stress ice x",         "Pa/102"   },
  { 279, "AOFLTYIO", "oasis wind stress ice x",         "Pa/102"   },
  { 280, "AOFLWSVO", "oasis wind speed",                "m/s"      },
};


void
tableDefault(void)
{
  int tableID, instID, modelID;


  /*
   *  define table : echam4
   */

  instID  = institutInq(98, 255, "MPIMET", NULL);
  if ( instID == -1 )
    instID  = institutDef(98, 255, "MPIMET", NULL);

  modelID = modelInq(instID, 0, "ECHAM4");
  if ( modelID == -1 )
    modelID = modelDef(instID, 0, "ECHAM4");

  tableID = tableDef(modelID, 128, "echam4");

  tableLink(tableID, echam4, sizeof(echam4) / sizeof(PAR));

  /*
   *  define table : echam5
   */

  instID  = institutInq(0, 0, "MPIMET", NULL);
  if ( instID == -1 )
    instID  = institutDef(0, 0, "MPIMET", NULL);

  modelID = modelInq(instID, 0, "ECHAM5");
  if ( modelID == -1 )
    modelID = modelDef(instID, 0, "ECHAM5");

  tableID = tableDef(modelID, 128, "echam5");

  tableLink(tableID, echam5, sizeof(echam5) / sizeof(PAR));

  /*
   *  define table : mpiom1
   */

  instID  = institutInq(0, 0, "MPIMET", NULL);
  if ( instID == -1 )
    instID  = institutDef(0, 0, "MPIMET", NULL);

  modelID = modelInq(instID, 0, "MPIOM1");
  if ( modelID == -1 )
    modelID = modelDef(instID, 0, "MPIOM1");

  tableID = tableDef(modelID, 128, "mpiom1");

  tableLink(tableID, mpiom1, sizeof(mpiom1) / sizeof(PAR));
}

#endif  /* _TABLE_H */
#ifndef _UTIL_H
#define _UTIL_H

#ifndef _DTYPES_H
#include "dtypes.h"
#endif

#define UINT32   unsigned INT32
#define UINT64   unsigned INT64

UINT32 get_UINT32(unsigned char *x);
UINT32 get_SUINT32(unsigned char *x);
UINT64 get_UINT64(unsigned char *x);
UINT64 get_SUINT64(unsigned char *x);

void   gaussaw(double pa[], double pw[], int nlat);

#endif  /* _UTIL_H */
#ifndef _GRID_H
#define _GRID_H


typedef struct {
  int     type;                   /* grid type                      */
  int     prec;                   /* grid precision                 */
  double *xvals;
  double *yvals;
  double *area;
  double *xbounds;
  double *ybounds;
  double  xfirst, yfirst;
  double  xlast, ylast;
  double  xinc, yinc;
  double  xpole, ypole, angle;    /* rotated north pole             */
  int     isRotated;              /* TRUE for rotated grids         */
  int     xdef;                   /* 0: undefined 1:xvals 2:x0+xinc */
  int     ydef;                   /* 0: undefined 1:yvals 2:y0+yinc */
  int     nd, ni, ni2, ni3;       /* parameter for GRID_TRIANGULAR  */
  int     trunc;                  /* parameter for GRID_SPECTEAL    */
  int     nvertex;
  int    *rowlon;
  int     nrowlon;
  int     size;
  int     xsize;
  int     ysize;
  int     locked;
  char    xname[256];
  char    yname[256];
  char    xlongname[256];
  char    ylongname[256];
  char    xstdname[256];
  char    ystdname[256];
  char    xunits[256];
  char    yunits[256];
}
GRID;


const double *gridInqXvalsPtr(int gridID);
const double *gridInqYvalsPtr(int gridID);

double *gridInqXboundsPtr(int gridID);
double *gridInqYboundsPtr(int gridID);

int gridCompare(int gridID, GRID grid);
int gridGenerate(GRID grid);

void glo_coor(double *pxn, double *prlon, double *prlat, 
	      int kig1s, int kig1e, int kig2s, int kig2e, int knd, 
	      int kni2, int kni3);

double rls_to_rl(double phis, double rlas, double polphi, double pollam);
double phs_to_ph(double phis, double rlas, double polphi, double pollam);
double rl_to_rls(double phi, double rla, double polphi, double pollam);
double ph_to_phs(double phi, double rla, double polphi, double pollam);

#endif
#ifndef _VARSCAN_H
#define _VARSCAN_H

#ifndef _GRID_H
#  include "grid.h"
#endif


void varAddRecord(int recID, int code, int gridID, int leveltype, int lbounds,
		  int level1, int level2, int prec, int *pvarID, int *plevelID,
		  int numavg, int codetable);

void varDefVCT(size_t vctsize, double *vctptr);

int  varDefGrid(int vlistID, GRID grid, int mode);
int  varDefZaxis(int vlistID, int leveltype, int nlevels, double *levels, int lbounds, double *levels1, double *levels2,
		 int vctsize, double *vct, char *name, char *longname, char *units, int prec, int mode);

void varDefInst(int varID, int instID);
int  varInqInst(int varID);
void varDefModel(int varID, int modelID);
int  varInqModel(int varID);
void varDefTable(int varID, int tableID);
int  varInqTable(int varID);

int  zaxisCompare(int zaxisID, int leveltype, int nlevels, double *levels, char *longname, char *units);

#endif
#ifndef _BINARY_H
#define _BINARY_H

#include <stdio.h>

#ifndef _DTYPES_H
#include "dtypes.h"
#endif


size_t binReadF77Block(int fileID, int byteswap);
void   binWriteF77Block(int fileID, int byteswap, size_t blocksize);

int binReadInt32(int fileID, int byteswap, size_t size, INT32 *ptr);
int binReadInt64(int fileID, int byteswap, size_t size, INT64 *ptr);

int binWriteInt32(int fileID, int byteswap, size_t size, INT32 *ptr);
int binWriteInt64(int fileID, int byteswap, size_t size, INT64 *ptr);

int binReadReal4(int fileID, int byteswap, size_t size, REAL4 *ptr);
int binReadReal8(int fileID, int byteswap, size_t size, REAL8 *ptr);

int binWriteReal4(int fileID, int byteswap, size_t size, REAL4 *ptr);
int binWriteReal8(int fileID, int byteswap, size_t size, REAL8 *ptr);

#endif  /* _BINARY_H */

void swap4byte(void *ptr, size_t size);
void swap8byte(void *ptr, size_t size);
#ifndef _SERVICE_H
#define _SERVICE_H

const char *srvLibraryVersion(void);

void srvDebug(int debug);

int  srvCheckFiletype(int fileID, int *swap);

int  srvInqPrec(int fileID);
void srvDefPrec(int fileID, int prec);

int  srvReadHeader(int fileID, int *header);
int  srvReadDataSP(int fileID, float *data);
int  srvReadDataDP(int fileID, double *data);

int  srvWriteHeader(int fileID, const int *header);
int  srvWriteDataSP(int fileID, const float *data);
int  srvWriteDataDP(int fileID, const double *data);

int  srvOpen(const char *filename, const char *mode);
void srvClose(int fileID);

int  srvInqByteswap(int fileID);
void srvDefByteswap(int fileID);

int  srvMove(int ifileID, int ofileID);

#endif  /* _SERVICE_H */
#ifndef _STREAM_SRV_H
#define _STREAM_SRV_H

#ifndef _SERVICE_H
#  include "service.h"
#endif

int    srvScanTimestep(int streamID);
int    srvInqContents(int streamID);
int    srvInqTimestep(int streamID, int tsID);

int    srvInqRecord(int streamID, int *varID, int *levelID);
int    srvDefRecord(int streamID);
int    srvCopyRecord(int streamIDdest, int streamIDsrc);
int    srvReadRecord(int streamID, double *data, int *nmiss);
int    srvWriteRecord(int streamID, const double *data);

void   srvReadVarDP (int streamID, int varID,       double *data, int *nmiss);
void   srvWriteVarDP(int streamID, int varID, const double *data);

void   srvReadVarSliceDP (int streamID, int varID, int levelID,       double *data, int *nmiss);
void   srvWriteVarSliceDP(int streamID, int varID, int levelID, const double *data);

#endif  /* _STREAM_SRV_H */
#ifndef _EXTRA_H
#define _EXTRA_H

const char *extLibraryVersion(void);

void extDebug(int debug);

int  extCheckFiletype(int fileID, int *swap);

int  extInqPrec(int fileID);
void extDefPrec(int fileID, int prec);

int  extReadHeader(int fileID, int *header);
int  extReadDataSP(int fileID, float *data);
int  extReadDataDP(int fileID, double *data);

int  extWriteHeader(int fileID, const int *header);
int  extWriteDataSP(int fileID, const float *data);
int  extWriteDataDP(int fileID, const double *data);

int  extOpen(const char *filename, const char *mode);
void extClose(int fileID);

int  extInqByteswap(int fileID);
void extDefByteswap(int fileID);

#endif  /* _EXTRA_H */
#ifndef _STREAM_EXT_H
#define _STREAM_EXT_H

#ifndef _EXTRA_H
#  include "extra.h"
#endif

int    extScanTimestep(int streamID);
int    extInqContents(int streamID);
int    extInqTimestep(int streamID, int tsID);

int    extInqRecord(int streamID, int *varID, int *levelID);
int    extDefRecord(int streamID);
int    extCopyRecord(int streamIDdest, int streamIDsrc);
int    extReadRecord(int streamID, double *data, int *nmiss);
int    extWriteRecord(int streamID, const double *data);

void   extReadVarDP (int streamID, int varID,       double *data, int *nmiss);
void   extWriteVarDP(int streamID, int varID, const double *data);

void   extReadVarSliceDP (int streamID, int varID, int levelID,       double *data, int *nmiss);
void   extWriteVarSliceDP(int streamID, int varID, int levelID, const double *data);

#endif  /* _STREAM_EXT_H */
#ifndef _CDF_INT_H
#define _CDF_INT_H

#if  defined  (HAVE_LIBNETCDF)

#include "netcdf.h"

void cdf_create (const char *path, int cmode, int *idp);
void cdf_open   (const char *path, int omode, int *idp);
void cdf_close  (int ncid);

void cdf_redef (int ncid);
void cdf_enddef (int ncid);

void cdf_inq (int ncid, int *ndimsp, int *nvarsp, int *ngattsp, int *unlimdimidp);

void cdf_def_dim (int ncid, const char *name, size_t len, int *idp);
void cdf_inq_dimid (int ncid, const char *name, int *dimidp);
void cdf_inq_dim (int ncid, int dimid, char *name, size_t * lengthp);
void cdf_inq_dimname (int ncid, int dimid, char *name);
void cdf_inq_dimlen (int ncid, int dimid, size_t * lengthp);
void cdf_def_var (int ncid, const char *name, nc_type xtype, int ndims,
		 const int dimids[], int *varidp);
void cdf_inq_varid (int ncid, const char *name, int *varidp);
void cdf_inq_nvars (int ncid, int *nvarsp);
void cdf_inq_var (int ncid, int varid, char *name, nc_type *xtypep,
		 int *ndimsp, int dimids[], int *nattsp);
void cdf_inq_varname (int ncid, int varid, char *name);
void cdf_inq_vartype (int ncid, int varid, nc_type *xtypep);
void cdf_inq_varndims (int ncid, int varid, int *ndimsp);
void cdf_inq_vardimid (int ncid, int varid, int dimids[]);
void cdf_inq_varnatts (int ncid, int varid, int *nattsp);

void cdf_copy_att (int ncid_in, int varid_in, const char *name, int ncid_out, int varid_out);
void cdf_put_var_text   (int ncid, int varid, const char *tp);
void cdf_put_var_uchar  (int ncid, int varid, const unsigned char *up);
void cdf_put_var_schar  (int ncid, int varid, const signed char *cp);
void cdf_put_var_short  (int ncid, int varid, const short *sp);
void cdf_put_var_int    (int ncid, int varid, const int *ip);
void cdf_put_var_long   (int ncid, int varid, const long *lp);
void cdf_put_var_float  (int ncid, int varid, const float *fp);
void cdf_put_var_double (int ncid, int varid, const double *dp);

void cdf_get_var_text   (int ncid, int varid, char *tp);
void cdf_get_var_uchar  (int ncid, int varid, unsigned char *up);
void cdf_get_var_schar  (int ncid, int varid, signed char *cp);
void cdf_get_var_short  (int ncid, int varid, short *sp);
void cdf_get_var_int    (int ncid, int varid, int *ip);
void cdf_get_var_long   (int ncid, int varid, long *lp);
void cdf_get_var_float  (int ncid, int varid, float *fp);
void cdf_get_var_double (int ncid, int varid, double *dp);

void cdf_get_var1_double(int ncid, int varid, const size_t index[], double *dp);
void cdf_put_var1_double(int ncid, int varid, const size_t index[], const double *dp);

void cdf_get_vara_double(int ncid, int varid, const size_t start[],
                         const size_t count[], double *dp);
void cdf_put_vara_double(int ncid, int varid, const size_t start[],
                         const size_t count[], const double *dp);

void cdf_put_att_text (int ncid, int varid, const char *name, size_t len,
		      const char *tp);
void cdf_put_att_int (int ncid, int varid, const char *name, nc_type xtype,
		     size_t len, const int *ip);
void cdf_put_att_double (int ncid, int varid, const char *name, nc_type xtype,
			size_t len, const double *dp);

void cdf_get_att_text (int ncid, int varid, char *name, char *tp);
void cdf_get_att_int (int ncid, int varid, char *name, int *ip);
void cdf_get_att_double (int ncid, int varid, char *name, double *dp);

void cdf_inq_att (int ncid, int varid, const char *name, nc_type * xtypep,
		 size_t * lenp);
void cdf_inq_atttype (int ncid, int varid, const char *name, nc_type *xtypep);
void cdf_inq_attlen (int ncid, int varid, const char *name, size_t *lenp);
void cdf_inq_attname (int ncid, int varid, int attnum, char *name);
void cdf_inq_attid (int ncid, int varid, const char *name, int *attnump);

#endif

#endif  /* _CDF_INT_H */
#ifndef _HDF_INT_H
#define _HDF_INT_H

#if  defined  (HAVE_LIBHDF5)

#include "hdf5.h"

#define  HDF_GLOBAL  -1
int    hdf_create(const char *path, int cmode);
int    hdf_open(const char *path, int omode);
void   hdf_close(int hfid);

/*

void hdf_redef (int hfid);
void hdf_enddef (int hfid);

int  hdf_inq_rec (int fileID, int *code, int *gridid, int *levelID, int *date, int *time);

void hdf_inq (int hfid, int *ndimsp, int *nvarsp, int *ngattsp, int *unlimdimidp);

void hdf_def_dim (int hfid, const char *name, size_t len, int *idp);
void hdf_inq_dimid (int hfid, const char *name, int *dimidp);
void hdf_inq_dim (int hfid, int dimid, char *name, size_t * lengthp);
void hdf_inq_dimname (int hfid, int dimid, char *name);
void hdf_inq_dimlen (int hfid, int dimid, size_t * lengthp);
*/
void hdf_def_var(int hfid, const char *name, int xtype, int ndims,
		 const int dimids[], int *varidp, int plistid);

void hdf_inq_varid (int hfid, const char *name, int *varidp);

int  hdf_inq_nvars(int hfid);
int  hdf_inq_ngatts(int hfid);

void hdf_inq_vartype (int hfid, int varid, int *xtypep);
int  hdf_inq_varndims(int varid);
int  hdf_inq_varxtype(int varid);
void hdf_inq_vardimid (int hfid, int varid, int dimids[]);
void hdf_inq_varnatts (int hfid, int varid, int *nattsp);
/*
void hdf_copy_att (int hfid_in, int varid_in, const char *name, int hfid_out, int varid_out);
void hdf_put_var_text   (int hfid, int varid, const char *tp);
void hdf_put_var_uchar  (int hfid, int varid, const unsigned char *up);
void hdf_put_var_schar  (int hfid, int varid, const signed char *cp);
void hdf_put_var_short  (int hfid, int varid, const short *sp);
*/
void hdf_put_var_int    (int hfid, int varid, const int *ip);
/*
void hdf_put_var_long   (int hfid, int varid, const long *lp);
void hdf_put_var_float  (int hfid, int varid, const float *fp);
*/
void hdf_put_var_double (int hfid, int varid, const double *dp);
/*
void hdf_get_var_text   (int hfid, int varid, char *tp);
void hdf_get_var_uchar  (int hfid, int varid, unsigned char *up);
void hdf_get_var_schar  (int hfid, int varid, signed char *cp);
void hdf_get_var_short  (int hfid, int varid, short *sp);
void hdf_get_var_int    (int hfid, int varid, int *ip);
void hdf_get_var_long   (int hfid, int varid, long *lp);
void hdf_get_var_float  (int hfid, int varid, float *fp);
void hdf_get_var_double (int hfid, int varid, double *dp);

void hdf_get_var1_double(int hfid, int varid, const size_t index[], double *dp);
*/
void hdf_put_var1_double(int hfid, int varid, const size_t index[], const double *dp);
/*
void hdf_get_vara_double(int hfid, int varid, const size_t start[],
                         const size_t count[], double *dp);
*/
void hdf_put_vara_double(int hfid, int varid, const size_t start[],
                         const size_t count[], const double *dp);
void hdf_put_att_text (int hfid, int varid, const char *name, size_t len,
		      const char *tp);
/*
void hdf_put_att_int (int hfid, int varid, const char *name, int xtype,
		     size_t len, const int *ip);
void hdf_put_att_double (int hfid, int varid, const char *name, int xtype,
			size_t len, const double *dp);

*/
void hdf_get_att_text (int hfid, int varid, char *name, char *tp);
void hdf_get_att_int (int hfid, int varid, char *name, int *ip);
void hdf_get_att_double (int hfid, int varid, char *name, double *dp);

void hdf_inq_att (int hfid, int varid, const char *name, int *xtypep,
		 size_t * lenp);
void hdf_inq_atttype (int hfid, int varid, const char *name, int *xtypep);
void hdf_inq_attlen (int hfid, int varid, const char *name, size_t *lenp);
void hdf_inq_attname (int hfid, int varid, int attnum, char *name);
void hdf_inq_attid (int hfid, int varid, const char *name, int *attnump);

#endif

#endif  /* _HDF_INT_H */
#ifndef _CDF_H
#define _CDF_H

void cdfDebug(int debug);

const char *cdfLibraryVersion(void);

int  cdfOpen(const char *filename, const char *mode);
int  cdfOpen64(const char *filename, const char *mode);
void cdfClose(int fileID);

#endif  /* _CDF_H */
#ifndef _HDF_H
#define _HDF_H

void hdfDebug(int debug);

const char *hdfLibraryVersion(void);

int  hdfOpen(const char *filename, const char *mode);
void hdfClose(int fileID);

#endif  /* _HDF_H */
#ifndef _VLIST_H
#define _VLIST_H

#ifndef _CDI_LIMITS_H
#  include "cdi_limits.h"
#endif

#define  MAX_ATTRIBUTES  99

typedef struct
{
  int      flag;
  int      index;
  int      flevelID;
}
LEVINFO;

typedef struct
{
  int      flag;
  int      nlevs;
  int      isUsed;
  int      fvarID;
  int      code;
  int      gridID;
  int      zaxisID;
  int      timeID;    /* ( TIME_VARIABLE or TIME_CONSTANT ) */
  int      datatype;  /* DATATYPE_PACKX for GRIB data, else DATATYPE_REAL4 or DATATYPE_REAL8 */
  int      instID;
  int      modelID;
  int      tableID;
  int      average;
  int      func;
  int      missvalused;  /* TRUE if missval is defined */
  char    *name;
  char    *longname;
  char    *units;
  double   missval;
  double   scalefactor;
  double   addoffset;
  LEVINFO *levinfo;
}
VARINFO;

typedef struct
{
  int      used;
  int      nlock;
  int      nvars;        /* number of variables                */
  int      ngrids;
  int      nzaxis;
  int      ntsteps;
  int      taxisID;
  int      tableID;
  int      instID;
  int      modelID;
  int      varsAllocated;
  int      gridIDs[MAX_GRIDS];
  int      zaxisIDs[MAX_ZAXIS];
  VARINFO *vars;
  int      natts;
  char    *attnames[MAX_ATTRIBUTES];
  char    *attstrings[MAX_ATTRIBUTES];
}
VLIST;

extern VLIST  *vlist;

int     vlistNlock(int vlistID);
void    vlistLock(int vlistID);
void    vlistUnlock(int vlistID);
char   *vlistInqVarNamePtr(int vlistID, int varID);
char   *vlistInqVarLongnamePtr(int vlistID, int varID);
char   *vlistInqVarUnitsPtr(int vlistID, int varID);
void    vlistFreeVarName(int vlistID, int varID);
void    vlistFreeVarLongname(int vlistID, int varID);
void    vlistFreeVarUnits(int vlistID, int varID);
void    vlistDefVarTime(int vlistID, int varID, int timeID);
int     vlistInqVarMissvalUsed(int vlistID, int varID);
int     vlistHasTime(int vlistID);

#endif  /* _VLIST_H */
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




int DefaultTimeType = TAXIS_ABSOLUTE;
int DefaultTimeUnit = TUNIT_HOUR;
int DefaultCalendar = CALENDAR_STANDARD;

static int  TimeTableInit = 0;

TAXIS *taxisTable;
int    taxisTableSize = 0;

char *Timeunits[] = {
  "undefined",
  "seconds",
  "minutes",
  "hours",
  "days",
  "months",
  "years",
};

char *tunitNamePtr(int unitID)
{
  char *name;
  int size = sizeof(Timeunits)/sizeof(char *);

  if ( unitID > 0 && unitID < size )
    name = Timeunits[unitID];
  else
    name = Timeunits[0];

  return (name);
}

void taxisTableInit(void)
{
  static char func[] = "taxisTableInit";
  char *timeunit;

  timeunit = getenv("TIMEUNIT");
  if ( timeunit )
    {
      if ( strcmp(timeunit, "minute") == 0 )
	DefaultTimeUnit = TUNIT_MINUTE;
      else if ( strcmp(timeunit, "hour") == 0 )
	DefaultTimeUnit = TUNIT_HOUR;
      else if ( strcmp(timeunit, "day") == 0 )
	DefaultTimeUnit = TUNIT_DAY;
      else if ( strcmp(timeunit, "month") == 0 )
	DefaultTimeUnit = TUNIT_MONTH;
      else if ( strcmp(timeunit, "year") == 0 )
	DefaultTimeUnit = TUNIT_YEAR;
      else
	Warning(func, "Unsupported TIMEUNIT %s!", timeunit);
    }

  TimeTableInit = 1;
}

void ptaxisInit(TAXIS *taxis)
{
  if ( ! TimeTableInit ) taxisTableInit();

  taxis->used      = FALSE;
  taxis->type      = DefaultTimeType;
  taxis->vdate     = 0;
  taxis->vtime     = 0;
  taxis->rdate     = CDI_UNDEFID;
  taxis->rtime     = 0;
  taxis->calendar  = DefaultCalendar;
  taxis->unit      = DefaultTimeUnit;
  taxis->numavg    = 0;
}

void ptaxisCopy(TAXIS *dest, TAXIS *source)
{
  memcpy(dest, source, sizeof(TAXIS));
}

int taxisTableNewEntry(int timetype)
{
  static char func[] = "taxisTableNewEntry";
  int taxisID = 0;

  if ( ! TimeTableInit ) taxisTableInit();

  /*
    Look for a free slot in taxisTable.
    (Create the table the first time through).
  */
  if ( ! taxisTableSize )
    {
      int i;

      taxisTableSize = 2;
      taxisTable = (TAXIS *) malloc(taxisTableSize*sizeof(TAXIS));
      if ( taxisTable == NULL )
	{
          Message(func, "taxisTableSize = %d", taxisTableSize);
	  SysError(func, "Allocation of TAXISTABLE failed");
	}

      for ( i = 0; i < taxisTableSize; i++ )
	{
	  taxisTable[i].used = FALSE;
	  ptaxisInit(&taxisTable[i]);
	}
    }
  else
    {
      while ( taxisID < taxisTableSize )
	{
	  if ( ! taxisTable[taxisID].used ) break;
	  taxisID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( taxisID == taxisTableSize )
    {
      int i;

      taxisTableSize = 2*taxisTableSize;
      taxisTable = (TAXIS *) realloc(taxisTable, taxisTableSize*sizeof(TAXIS));
      if ( taxisTable == NULL )
	{
          Message(func, "taxisTableSize = %d", taxisTableSize);
	  SysError(func, "Reallocation of TAXISTABLE failed");
	}

      taxisID = taxisTableSize/2;

      for ( i = taxisID; i < taxisTableSize; i++ )
	{
	  taxisTable[i].used = FALSE;
	  ptaxisInit(&taxisTable[i]);
	}
    }

  taxisTable[taxisID].type = timetype;
  taxisTable[taxisID].used = TRUE;

  return (taxisID);
}

static void taxisCheckID(const char *func, int taxisID)
{
  if ( taxisID == CDI_UNDEFID )
    Error(func, "taxisID undefined!");

  if ( taxisID < 0 || taxisID >= taxisTableSize )
    Error(func, "taxisID %d undefined!", taxisID);

  if ( taxisTable[taxisID].type == CDI_UNDEFID )
    Error(func, "taxisID %d type undefined!", taxisID);
}


/*
@Function  taxisNew
@Title     Create a new T-axis

@Prototype int taxisNew(int taxistype)
@Parameter
    @Item  taxistype  The type of the time axis, one of the set of predefined CDI time types.
                      The valid CDI time types are {\tt TAXIS_ABSOLUTE} and {\tt TAXIS_RELATIVE}.

@Description
The function {\tt taxisNew} creates a new Time axis.

@Result
{\tt taxisNew} return an identifier to the new T-axis.

@EndFunction
*/
int taxisNew(int taxistype)
{
  static char func[] = "taxisNew";
  int taxisID;

  if ( CDI_Debug )
    Message(func, "taxistype: %d", taxistype);

  /* get next free time entry */
  taxisID = taxisTableNewEntry(taxistype);

  if ( CDI_Debug )
    Message(func, "taxisID: %d", taxisID);

  return (taxisID);
}


int taxisDuplicate(int taxisID1)
{
  static char func[] = "taxisDuplicate";
  int taxisID2;
  /* get next free time entry */
  taxisID2 = taxisTableNewEntry(taxisInqType(taxisID1));

  if ( CDI_Debug )
    Message(func, "taxisID: %d", taxisID2);

  ptaxisCopy(taxisPtr(taxisID2), taxisPtr(taxisID1));

  return (taxisID2);
}

void taxisDefType(int taxisID, int type)
{
  static char func[] = "taxisDefType";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].type = type;
}


/*
@Function  taxisDefVdate
@Title     Define the verification date

@Prototype void taxisDefVdate(int taxisID, int vdate)
@Parameter
    @Item  taxisID  T-axis identifier
    @Item  vdate    Verification date (YYYYMMDD)

@Description
The function {\tt taxisDefVdate} defines the verification date of a Time axis.

@EndFunction
*/
void taxisDefVdate(int taxisID, int vdate)
{
  static char func[] = "taxisDefVdate";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].vdate = vdate;
}


/*
@Function  taxisDefVtime
@Title     Define the verification time

@Prototype void taxisDefVtime(int taxisID, int vtime)
@Parameter
    @Item  taxisID  T-axis identifier
    @Item  vtime    Verification time (HHMM)

@Description
The function {\tt taxisDefVtime} defines the verification time of a Time axis.

@EndFunction
*/
void taxisDefVtime(int taxisID, int vtime)
{
  static char func[] = "taxisDefVtime";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].vtime = vtime;
}


/*
@Function  taxisDefRdate
@Title     Define the reference date

@Prototype void taxisDefRdate(int taxisID, int rdate)
@Parameter
    @Item  taxisID  T-axis identifier
    @Item  rdate    Reference date (YYYYMMDD)

@Description
The function {\tt taxisDefVdate} defines the reference date of a Time axis.

@EndFunction
*/
void taxisDefRdate(int taxisID, int rdate)
{
  static char func[] = "taxisDefRdate";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].rdate = rdate;
}


/*
@Function  taxisDefRtime
@Title     Define the reference time

@Prototype void taxisDefRtime(int taxisID, int rtime)
@Parameter
    @Item  taxisID  T-axis identifier
    @Item  rtime    Reference time (HHMM)

@Description
The function {\tt taxisDefVdate} defines the reference time of a Time axis.

@EndFunction
*/
void taxisDefRtime(int taxisID, int rtime)
{
  static char func[] = "taxisDefRtime";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].rtime = rtime;
}


/*
@Function  taxisDefCalendar
@Title     Define the calendar

@Prototype void taxisDefCalendar(int taxisID, int calendar)
@Parameter
    @Item  taxisID   T-axis identifier
    @Item  calendar  The type of the calendar, one of the set of predefined CDI calendar types.
                     The valid CDI calendar types are {\tt CALENDAR_STANDARD}, {\tt CALENDAR_360DAYS},
                     {\tt CALENDAR_365DAYS} and {\tt CALENDAR_366DAYS}.

@Description
The function {\tt taxisDefCalendar} defines the calendar of a Time axis.

@EndFunction
*/
void taxisDefCalendar(int taxisID, int calendar)
{
  static char func[] = "taxisDefCalendar";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].calendar = calendar;
}


void taxisDefTunit(int taxisID, int unit)
{
  static char func[] = "taxisDefTunit";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].unit = unit;
}

void taxisDefNumavg(int taxisID, int numavg)
{
  static char func[] = "taxisDefNumavg";

  taxisCheckID(func, taxisID);

  taxisTable[taxisID].numavg = numavg;
}


/*
The type of the time axis, one of the set of predefined CDI time types.
The valid CDI time types are TAXIS_ABSOLUTE and TAXIS_RELATIVE.
*/
int taxisInqType(int taxisID)
{
  static char func[] = "taxisInqType";

  taxisCheckID(func, taxisID);

  return (taxisTable[taxisID].type);
}


/*
@Function  taxisInqVdate
@Title     Get the verification date

@Prototype int taxisInqVdate(int taxisID)
@Parameter
    @Item  taxisID  T-axis identifier

@Description
The function {\tt taxisInqVdate} gets the verification date of a Time axis.

@Result
{\tt taxisInqVdate} return the verification date.

@EndFunction
*/
int taxisInqVdate(int taxisID)
{
  static char func[] = "taxisInqVdate";

  taxisCheckID(func, taxisID);

  return (taxisTable[taxisID].vdate);
}


/*
@Function  taxisInqVtime
@Title     Get the verification time

@Prototype int taxisInqVtime(int taxisID)
@Parameter
    @Item  taxisID  T-axis identifier

@Description
The function {\tt taxisInqVtime} gets the verification time of a Time axis.

@Result
{\tt taxisInqVtime} return the verification time.

@EndFunction
*/
int taxisInqVtime(int taxisID)
{
  static char func[] = "taxisInqVtime";

  taxisCheckID(func, taxisID);

  return (taxisTable[taxisID].vtime);
}


/*
@Function  taxisInqRdate
@Title     Get the reference date

@Prototype int taxisInqRdate(int taxisID)
@Parameter
    @Item  taxisID  T-axis identifier

@Description
The function {\tt taxisInqRdate} gets the reference date of a Time axis.

@Result
{\tt taxisInqVdate} return the reference date.

@EndFunction
*/
int taxisInqRdate(int taxisID)
{
  static char func[] = "taxisInqRdate";

  taxisCheckID(func, taxisID);

  if ( taxisTable[taxisID].rdate == -1 )
    {
      taxisTable[taxisID].rdate = taxisTable[taxisID].vdate;
      taxisTable[taxisID].rtime = taxisTable[taxisID].vtime;
    }

  return (taxisTable[taxisID].rdate);
}


/*
@Function  taxisInqRtime
@Title     Get the reference time

@Prototype int taxisInqRtime(int taxisID)
@Parameter
    @Item  taxisID  T-axis identifier

@Description
The function {\tt taxisInqRtime} gets the reference time of a Time axis.

@Result
{\tt taxisInqVtime} return the reference time.

@EndFunction
*/
int taxisInqRtime(int taxisID)
{
  static char func[] = "taxisInqRtime";

  taxisCheckID(func, taxisID);

  if ( taxisTable[taxisID].rdate == -1 )
    {
      taxisTable[taxisID].rdate = taxisTable[taxisID].vdate;
      taxisTable[taxisID].rtime = taxisTable[taxisID].vtime;
    }

  return (taxisTable[taxisID].rtime);
}


/*
@Function  taxisInqCalendar
@Title     Get the calendar

@Prototype int taxisInqCalendar(int taxisID)
@Parameter
    @Item  taxisID  T-axis identifier

@Description
The function {\tt taxisInqCalendar} gets the calendar of a Time axis.

@Result
{\tt taxisInqCalendar} return the type of the calendar,
one of the set of predefined CDI calendar types.
The valid CDI calendar types are {\tt CALENDAR_STANDARD}, {\tt CALENDAR_360DAYS},
{\tt CALENDAR_365DAYS} and {\tt CALENDAR_366DAYS}.

@EndFunction
*/
int taxisInqCalendar(int taxisID)
{
  static char func[] = "taxisInqCalendar";

  taxisCheckID(func, taxisID);

  return (taxisTable[taxisID].calendar);
}


int taxisInqTunit(int taxisID)
{
  static char func[] = "taxisInqTunit";

  taxisCheckID(func, taxisID);

  return (taxisTable[taxisID].unit);
}

int taxisInqNumavg(int taxisID)
{
  static char func[] = "taxisInqNumavg";

  taxisCheckID(func, taxisID);

  return (taxisTable[taxisID].numavg);
}

TAXIS *taxisPtr(int taxisID)
{
  static char func[] = "taxisPtr";

  taxisCheckID(func, taxisID);

  return (&taxisTable[taxisID]);
}

void timeval2vtime(double timevalue, TAXIS *taxis, int *vdate, int *vtime)
{
  static char func[] = "timeval2vtime";
  int year, month, day, hour, minute;
  int rdate, rtime;
  sUnit tunit = {0, 1};
  double value, factor = 1;
  int timeunit;
  int calendar, dpy = 0;
  double second;
  static int lwarn = TRUE;

  timeunit = (*taxis).unit;
  calendar = (*taxis).calendar;

  if      ( calendar == CALENDAR_360DAYS ) dpy = 360;
  else if ( calendar == CALENDAR_365DAYS ) dpy = 365;
  else if ( calendar == CALENDAR_366DAYS ) dpy = 366;

  rdate  = (*taxis).rdate;
  rtime  = (*taxis).rtime;
  year   =  rdate / 10000;
  month  = (rdate - year*10000) / 100;
  day    =  rdate - year*10000 - month*100;
  hour   =  rtime / 100;
  minute =  rtime - hour*100;

  switch ( timeunit )
    {
    case TUNIT_SECOND: factor =     1.0;         break;
    case TUNIT_MINUTE: factor =    60.0;         break;
    case TUNIT_HOUR:   factor =  3600.0;         break;
    case TUNIT_DAY:    factor = 86400.0;         break;
    case TUNIT_MONTH:  month += NINT(timevalue); break;
    case TUNIT_YEAR:   year  += NINT(timevalue); break;
    default:
      if ( lwarn )
	{
	  Warning(func, "timeunit %s unsupported!", tunitNamePtr(timeunit));
	  lwarn = FALSE;
	}
    }

  /* attention: used offset of 1 second to prevent rounding errors */
  cdiInvCalendar(dpy, year, month, day, hour, minute, 1.0, tunit, &value);

  if ( timeunit == TUNIT_MONTH || timeunit == TUNIT_YEAR )
    timevalue = value;
  else
    tunit.origin = value;

  tunit.factor = factor;

  cdiCalendar(dpy, timevalue, tunit, &year, &month, &day, &hour, &minute, &second);

  *vdate = year*10000 + month*100 + day;
  *vtime = hour*100 + minute;
}

double vtime2timeval(int vdate, int vtime, TAXIS *taxis)
{
  static char func[] = "vtime2timeval";
  int ryear, rmonth;
  int year, month, day, hour, minute;
  int rdate, rtime;
  sUnit tunit = {0, 1};
  double value;
  int timeunit;
  int calendar, dpy = 0;
  static int lwarn = TRUE;

  timeunit = (*taxis).unit;
  calendar = (*taxis).calendar;

  if      ( calendar == CALENDAR_360DAYS ) dpy = 360;
  else if ( calendar == CALENDAR_365DAYS ) dpy = 365;
  else if ( calendar == CALENDAR_366DAYS ) dpy = 366;

  rdate  = (*taxis).rdate;
  rtime  = (*taxis).rtime;
  if ( rdate == -1 )
    {
      rdate  = (*taxis).vdate;
      rtime  = (*taxis).vtime;
    }

  ryear  =  rdate / 10000;
  rmonth = (rdate - ryear*10000) / 100;
  day    =  rdate - ryear*10000 - rmonth*100;
  hour   =  rtime / 100;
  minute =  rtime - hour*100;

  cdiInvCalendar(dpy, ryear, rmonth, day, hour, minute, 0.0, tunit, &value);
  tunit.origin = value;
  tunit.factor = 60.0;
      
  year   =  vdate / 10000;
  month  = (vdate - year*10000) / 100;
  day    =  vdate - year*10000 - month*100;
  hour   =  vtime / 100;
  minute =  vtime - hour*100;

  if ( timeunit == TUNIT_MONTH || timeunit == TUNIT_YEAR )
    {
      value = (year-ryear)*12 - rmonth + month;
      if ( timeunit == TUNIT_YEAR ) value = NINT(value/12);
    }
  else
    {
      switch ( timeunit )
	{
	case TUNIT_SECOND: tunit.factor =      1.0; break;
	case TUNIT_MINUTE: tunit.factor =     60.0; break;
	case TUNIT_HOUR:   tunit.factor =   3600.0; break;
	case TUNIT_DAY:    tunit.factor =  86400.0; break;
	default:
	  if ( lwarn )
	    {
	      Warning(func, "timeunit %s unsupported!", tunitNamePtr(timeunit));
	      lwarn = FALSE;
	    }
	}

      cdiInvCalendar(dpy, year, month, day, hour, minute, 0.0, tunit, &value);
    }

  return (value);
}
#if  defined  (HAVE_CONFIG_H)
#  include "config.h"
#endif



#if ! defined (HAVE_MALLOC_H)
#  if defined (__sun) || defined (__i386) || defined (__ia64) || defined (SX)
#    define  HAVE_MALLOC_H
#  endif
#endif

#if  defined  (HAVE_MALLOC_H)
#  define  HAVE_MALLINFO
#endif

#if  defined  (HAVE_MALLOC_H)
#  include <malloc.h>
#endif


#define  MALLOC_FUNC   0
#define  CALLOC_FUNC   1
#define  REALLOC_FUNC  2
#define  FREE_FUNC     3

#undef   UNDEFID
#define  UNDEFID  -1

#define  MAXNAME  32   /* Min = 8, for  "unknown" ! */

int dmemory_ExitOnError = 0;

typedef struct
{
  void     *ptr;
  int       item;
  size_t    size;
  size_t    nobj;
  int       mtype;
  int       line;
  char      file[MAXNAME];
  char      caller[MAXNAME];
}
MemTable;

static MemTable *memTable;
static int     memTableSize  = 0;
static long    memAccess     = 0;

static size_t  MemObjs    = 0;
static size_t  MaxMemObjs = 0;
static size_t  MemUsed    = 0;
static size_t  MaxMemUsed = 0;

static int     MEM_Debug  = 0;   /* If set to 1, debugging */

void memDebug(int debug)
{
  MEM_Debug = debug;
}

static void memInternalProblem(const char *caller, const char *fmt, ...)
{
  va_list args;
	
  va_start(args, fmt);

  printf("\n");
   fprintf(stderr, "Internal problem (%s) : ", caller);
  vfprintf(stderr, fmt, args);
   fprintf(stderr, "\n");

  va_end(args);

  exit(EXIT_FAILURE);
}

static void memError(const char *caller, const char *file, int line, size_t size)
{
  printf("\n");
  fprintf(stderr, "Error (%s) : Allocation of %ld bytes failed. [ line %d file %s ]\n",
	  caller, (long) size, line, file);

  if ( errno )
    perror("System error message ");
	
  exit(EXIT_FAILURE);
}

static void memListPrintEntry(int mtype, int item, size_t size, void *ptr,
			      const char *caller, const char *file, int line)
{
  switch (mtype)
    {
    case MALLOC_FUNC:
      fprintf(stderr, "[%-7s ", "Malloc");
      break;
    case CALLOC_FUNC:
      fprintf(stderr, "[%-7s ", "Calloc");
      break;
    case REALLOC_FUNC:
      fprintf(stderr, "[%-7s ", "Realloc");
      break;
    case FREE_FUNC:
      fprintf(stderr, "[%-7s ", "Free");
      break;
    }

   fprintf(stderr, "memory item %3d ", item);
   fprintf(stderr, "(%6u byte) ", (unsigned) size);
   fprintf(stderr, "at %p", ptr);
   if ( file != NULL )
     {
       fprintf(stderr, " line %4d", line);
       fprintf(stderr, " file %s", file);
     }    
   if ( caller != NULL )
     fprintf(stderr, " (%s)", caller);     
   fprintf(stderr, "]\n");
}

static void memListPrintTable(void)
{
  int memID, item, item1, item2 = 0;

  if ( MemObjs ) fprintf(stderr, "\nMemory table:\n");

  /* find maximum item */
  for ( memID = 0; memID < memTableSize; memID++ )
    if ( memTable[memID].item != UNDEFID )
      if ( memTable[memID].item > item2 ) item2 = memTable[memID].item;

  /* find minimum item */
  item1 = item2;
  for ( memID = 0; memID < memTableSize; memID++ )
    if ( memTable[memID].item != UNDEFID )
      if ( memTable[memID].item < item1 ) item1 = memTable[memID].item;

  for ( item = item1; item <= item2; item++ )
    for ( memID = 0; memID < memTableSize; memID++ )
      {
	if ( memTable[memID].item == item )
	  memListPrintEntry(memTable[memID].mtype, memTable[memID].item,
			    memTable[memID].size*memTable[memID].nobj,
			    memTable[memID].ptr, memTable[memID].caller,
			    memTable[memID].file, memTable[memID].line);
      }

  if ( MemObjs )
    {
      fprintf(stderr, "  Memory access             : %6u\n", (unsigned) memAccess);
      fprintf(stderr, "  Maximum objects           : %6u\n", (unsigned) memTableSize);
      fprintf(stderr, "  Objects used              : %6u\n", (unsigned) MaxMemObjs);
      fprintf(stderr, "  Objects in use            : %6u\n", (unsigned) MemObjs);
      fprintf(stderr, "  Memory allocated          : ");
      if (MemUsed > 1024*1024*1024)
	fprintf(stderr, " %5d GB\n",   (int) (MemUsed/(1024*1024*1024)));
      else if (MemUsed > 1024*1024)
	fprintf(stderr, " %5d MB\n",   (int) (MemUsed/(1024*1024)));
      else if (MemUsed > 1024)
	fprintf(stderr, " %5d KB\n",   (int) (MemUsed/(1024)));
      else
	fprintf(stderr, " %5d Byte\n", (int)  MemUsed);
    }

  if ( MaxMemUsed )
    {
      fprintf(stderr, "  Maximum memory allocated  : ");
      if (MaxMemUsed > 1024*1024*1024)
	fprintf(stderr, " %5d GB\n",   (int) (MaxMemUsed/(1024*1024*1024)));
      else if (MaxMemUsed > 1024*1024)
	fprintf(stderr, " %5d MB\n",   (int) (MaxMemUsed/(1024*1024)));
      else if (MaxMemUsed > 1024)
	fprintf(stderr, " %5d KB\n",   (int) (MaxMemUsed/(1024)));
      else
	fprintf(stderr, " %5d Byte\n", (int)  MaxMemUsed);
    }
}

static void memGetDebugLevel(void)
{
  char *debugLevel;

  debugLevel = getenv("MEMORY_DEBUG");

  if ( debugLevel )
    {
      if ( isdigit((int) debugLevel[0]) )
	MEM_Debug = atoi(debugLevel);

      if ( MEM_Debug )
	atexit(memListPrintTable);
    }
}

static void memInit(void)
{
  static int initDebugLevel = 0;

  if ( ! initDebugLevel )
    {
      memGetDebugLevel();
      initDebugLevel = 1;
    }  
}

static int memListDeleteEntry(void *ptr, size_t *size)
{
  int memID = 0;
  int item = UNDEFID;

  for ( memID = 0; memID < memTableSize; memID++ )
    {
      if ( memTable[memID].item == UNDEFID ) continue;
      if ( memTable[memID].ptr == ptr ) break;
    }

  if ( memID != memTableSize )
    {
      MemObjs--;
      MemUsed -= memTable[memID].size * memTable[memID].nobj;
      *size = memTable[memID].size * memTable[memID].nobj;
       item = memTable[memID].item;
       memTable[memID].item   = UNDEFID;
    }

  return (item);
}

static void memTableInitEntry(int memID)
{
  static char func[] = "memTableInitEntry";

  if ( memID < 0 || memID >= memTableSize )
    memInternalProblem(func, "memID %d undefined!", memID);

  memTable[memID].ptr    = NULL;
  memTable[memID].item   = UNDEFID;
  memTable[memID].size   = 0;
  memTable[memID].nobj   = 0;
  memTable[memID].mtype  = UNDEFID;
  memTable[memID].line   = UNDEFID;
}

static int memListNewEntry(int mtype, void *ptr, size_t size, size_t nobj,
			   const char *caller, const char *file, int line)
{
  static char func[] = "memListNewEntry";
  static int item = 0;
  size_t memSize = 0;
  int memID = 0;
  size_t len;
  int i;

  /*
    Look for a free slot in memTable.
    (Create the table the first time through).
  */
  if ( memTableSize == 0 )
    {
      memTableSize = 8;
      memSize  = memTableSize*sizeof(MemTable);
      memTable = (MemTable *) malloc(memSize);
      if( memTable == NULL ) memError(func, __FILE__, __LINE__, memSize);

      for( i = 0; i < memTableSize; i++ )
	memTableInitEntry(i);
    }
  else
    {
      while( memID < memTableSize )
	{
	  if ( memTable[memID].item == UNDEFID ) break;
	  memID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( memID == memTableSize )
    {
      memTableSize = 2*memTableSize;
      memSize  = memTableSize*sizeof(MemTable);
      memTable = (MemTable *) realloc(memTable, memSize);
      if( memTable == NULL ) memError(func, __FILE__, __LINE__, memSize);

      for( i = memID; i < memTableSize; i++ )
	memTableInitEntry(i);
    }

  memTable[memID].item  = item;
  memTable[memID].ptr   = ptr;
  memTable[memID].size  = size;
  memTable[memID].nobj  = nobj;
  memTable[memID].mtype = mtype;
  memTable[memID].line  = line;

  if ( file )
    {
      len = strlen(file);
      if ( len > MAXNAME-1 ) len = MAXNAME-1;
    
      (void) strncpy(memTable[memID].file, file, len);
      memTable[memID].file[len] = '\0';
    }
  else
    {
      (void) strcpy(memTable[memID].file, "unknown");
    }

  if ( caller )
    {
      len = strlen(caller);
      if ( len > MAXNAME-1 ) len = MAXNAME-1;

      (void) strncpy(memTable[memID].caller, caller, len);
      memTable[memID].caller[len] = '\0';
    }
  else
    {
      (void) strcpy(memTable[memID].caller, "unknown");
    }

  MaxMemObjs++;
  MemObjs++;
  MemUsed += size*nobj;
  if ( MemUsed > MaxMemUsed ) MaxMemUsed = MemUsed;

  return (item++);
}

static int memListChangeEntry(void *ptrold, void *ptr, size_t size,
			      const char *caller, const char *file, int line)
{
  static char func[] = "memListChangeEntry";
  int item = UNDEFID;
  int memID = 0;
  size_t len;
  size_t sizeold;

  while( memID < memTableSize )
    {
      if ( memTable[memID].item != UNDEFID )
	if ( memTable[memID].ptr == ptrold ) break;
      memID++;
    }

  if ( memID == memTableSize )
    {
      if ( ptrold != NULL )
	memInternalProblem(func, "Item at %p not found.", ptrold);
    }
  else
    {
      item = memTable[memID].item;

      sizeold = memTable[memID].size*memTable[memID].nobj;
      
      memTable[memID].ptr   = ptr;
      memTable[memID].size  = size;
      memTable[memID].nobj  = 1;
      memTable[memID].mtype = REALLOC_FUNC;
      memTable[memID].line  = line;

      if ( file )
	{
	  len = strlen(file);
	  if ( len > MAXNAME-1 ) len = MAXNAME-1;

	  (void) strncpy(memTable[memID].file, file, len);
	  memTable[memID].file[len] = '\0';
	}
      else
	{
	  (void) strcpy(memTable[memID].file, "unknown");
	}

      if ( caller )
	{
	  len = strlen(caller);
	  if ( len > MAXNAME-1 ) len = MAXNAME-1;

	  (void) strncpy(memTable[memID].caller, caller, len);
	  memTable[memID].caller[len] = '\0';
	}
      else
	{
	  (void) strcpy(memTable[memID].caller, "unknown");
	}

      MemUsed -= sizeold;
      MemUsed += size;
      if ( MemUsed > MaxMemUsed ) MaxMemUsed = MemUsed;
    }

  return (item);
}

void *Calloc(const char *caller, const char *file, int line, size_t nobjs, size_t size)
{
  void *ptr = 0;
  int item = UNDEFID;

  memInit();

  ptr = calloc(nobjs, size);

  if ( MEM_Debug )
    {
      memAccess++;

      if ( ptr )
	item = memListNewEntry(CALLOC_FUNC, ptr, size, nobjs, caller, file, line);

      memListPrintEntry(CALLOC_FUNC, item, size*nobjs, ptr, caller, file, line);
    }

  if ( ptr == NULL && dmemory_ExitOnError )
    memError(caller, file, line, size*nobjs);

  return(ptr);
}

void *Malloc(const char *caller, const char *file, int line, size_t size)
{
  void *ptr = NULL;
  int item = UNDEFID;

  memInit();

  ptr = malloc(size);

  if ( MEM_Debug )
    {
      memAccess++;

      if ( ptr )
	item = memListNewEntry(MALLOC_FUNC, ptr, size, 1, caller, file, line);

      memListPrintEntry(MALLOC_FUNC, item, size, ptr, caller, file, line);
    }

  if ( ptr == NULL && dmemory_ExitOnError )
    memError(caller, file, line, size);

  return (ptr);
}

void *Realloc(const char *caller, const char *file, int line, void *ptrold, size_t size)
{
  void *ptr = NULL;
  int item = UNDEFID;

  memInit();

  ptr = realloc(ptrold, size);

  if ( MEM_Debug )
    {
      memAccess++;

      if ( ptr )
	{
	  item = memListChangeEntry(ptrold, ptr, size, caller, file, line);

	  if ( item == UNDEFID )
	    item = memListNewEntry(REALLOC_FUNC, ptr, size, 1, caller, file, line);
	}

      memListPrintEntry(REALLOC_FUNC, item, size, ptr, caller, file, line);
    }

  if ( ptr == NULL && dmemory_ExitOnError )
    memError(caller, file, line, size);

  return (ptr);
}

void Free(const char *caller, const char *file, int line, void *ptr)
{
  static char func[] = "Free";
  int item;
  size_t size;

  memInit();

  if ( MEM_Debug )
    {
      if ( (item = memListDeleteEntry(ptr, &size)) >= 0 )
	{
	  memListPrintEntry(FREE_FUNC, item, size, ptr, caller, file, line);
	}
      else
	{
	  if ( ptr )
	    fprintf(stderr, "%s info: memory entry at %p not found. [line %4d file %s (%s)]\n",
		    func, ptr, line, file, caller);
	}
    }

  free(ptr);
}

size_t memTotal(void)
{
  size_t memtotal = 0;
#if  defined  (HAVE_MALLINFO)
  struct mallinfo meminfo = mallinfo();
  /*
  printf("arena      %d\n", meminfo.arena);
  printf("ordblks    %d\n", meminfo.ordblks);
  printf("smblks     %d\n", meminfo.smblks);
  printf("usmblks    %d\n", meminfo.usmblks);
  printf("fsmblks    %d\n", meminfo.fsmblks);
  printf("uordblks   %d\n", meminfo.uordblks);
  printf("fordblks   %d\n", meminfo.fordblks);
  printf("Memory in use: %d bytes\n", meminfo.usmblks + meminfo.uordblks);
  printf("Total heap size: %d bytes\n", meminfo.arena);
  */
  memtotal = meminfo.arena;
#endif

  return (memtotal);
}

void memExitOnError(void)
{
  dmemory_ExitOnError = 1;
}
#ifndef _DMEMORY_H
#define _DMEMORY_H


/*
 * if DEBUG_MEMORY is defined setenv MEMORY_DEBUG to debug memory
 */

#define  DEBUG_MEMORY

#define  WITH_CALLER_NAME

extern size_t  memTotal(void);
extern void    memDebug(int debug);
extern void    memExitOnError(void);

#if  defined  DEBUG_MEMORY

extern void   *Realloc(const char *caller, const char *file, int line, void *ptr, size_t size);
extern void   *Calloc (const char *caller, const char *file, int line, size_t nmemb, size_t size);
extern void   *Malloc (const char *caller, const char *file, int line, size_t size);
extern void    Free   (const char *caller, const char *file, int line, void *ptr);

#if  defined  calloc
#  undef  calloc
#endif

#if  defined  WITH_CALLER_NAME
#  define  realloc(x, y)  Realloc(func, __FILE__, __LINE__, x, y)
#  define   calloc(x, y)   Calloc(func, __FILE__, __LINE__, x, y)
#  define   malloc(x)      Malloc(func, __FILE__, __LINE__, x)
#  define     free(x)        Free(func, __FILE__, __LINE__, x)
#else
#  define  realloc(x, y)  Realloc((void *) NULL, __FILE__, __LINE__, x, y)
#  define   calloc(x, y)   Calloc((void *) NULL, __FILE__, __LINE__, x, y)
#  define   malloc(x)      Malloc((void *) NULL, __FILE__, __LINE__, x)
#  define     free(x)        Free((void *) NULL, __FILE__, __LINE__, x)
#endif

#endif /* DEBUG_MEMORY */

#endif /* _DMEMORY_H */
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



int _ExitOnError   = 1;	/* If set to 1, exit on error       */
int _Verbose = 1;	/* If set to 1, errors are reported */
int _Debug   = 0;       /* If set to 1, debugging           */


void SysError(const char *caller, const char *fmt, ...)
{
  va_list args;
	
  va_start(args, fmt);

  printf("\n");
   fprintf(stderr, "Error (%s) : ", caller);
  vfprintf(stderr, fmt, args);
   fprintf(stderr, "\n");

  va_end(args);

  if ( errno )
    perror("System error message ");
	
  exit(EXIT_FAILURE);
}

void Error(const char *caller, const char *fmt, ...)
{
  va_list args;
	
  va_start(args, fmt);

  printf("\n");
   fprintf(stderr, "Error (%s) : ", caller);
  vfprintf(stderr, fmt, args);
   fprintf(stderr, "\n");

  va_end(args);

  if ( _ExitOnError ) exit(EXIT_FAILURE);
}

void Warning(const char *caller, const char *fmt, ...)
{
  va_list args;
	
  va_start(args, fmt);

  if ( _Verbose )
    {
       fprintf(stderr, "Warning (%s) : ", caller);
      vfprintf(stderr, fmt, args);
       fprintf(stderr, "\n");
    }

  va_end(args);
}

void Message(const char *caller, const char *fmt, ...)
{
  va_list args;
	
  va_start(args, fmt);

   fprintf(stdout, "%-18s : ", caller);
  vfprintf(stdout, fmt, args);
   fprintf(stdout, "\n");

  va_end(args);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



#undef 	 ABS
#define	 ABS(a)		((a) < 0 ? -(a) : (a))

static int month_360[12] = {30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30};
static int month_365[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
static int month_366[12] = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

/*
 * The following two functions convert between Julian day number and
 * Gregorian/Julian dates (Julian dates are used prior to October 15,
 * 1582; Gregorian dates are used after that).  Julian day number 0 is
 * midday, January 1, 4713 BCE.  The Gregorian calendar was adopted
 * midday, October 15, 1582.
 *
 * Author: Robert Iles, March 1994
 *
 * C Porter: Steve Emmerson, October 1995
 *
 * Original: http://www.nag.co.uk:70/nagware/Examples/calendar.f90
 *
 * There is no warranty on this code.
 */


/*
 * Convert a Julian day number to a Gregorian/Julian date.
 */
static void julday_to_gregdate(
    unsigned long	julday,		/* Julian day number to convert */
    int			*year,		/* Gregorian year (out) */
    int			*month,		/* Gregorian month (1-12) (out) */
    int			*day		/* Gregorian day (1-31) (out) */
    )
{
    long	ja, jb;
    int		jc;
    long	jd;
    int		je, iday, imonth, iyear;
    double	xc;

    if (julday < 2299161)
	ja = julday;
    else
    {
	int	ia = (int) (((julday - 1867216) - 0.25) / 36524.25);

	ja = julday + 1 + ia - (int)(0.25 * ia);
    }

    jb = ja + 1524;
    xc = ((jb - 2439870) - 122.1) / 365.25;
    jc = (long) (6680.0 + xc);
    jd = 365 * jc + (int)(0.25 * jc);
    je = (int) ((jb - jd) / 30.6001);

    iday = (int) (jb - jd - (int)(30.6001 * je));

    imonth = je - 1;
    if (imonth > 12)
	imonth -= 12;

    iyear = jc - 4715;
    if (imonth > 2)
	iyear -= 1;
    if (iyear <= 0)
	iyear -= 1;

    *year = iyear;
    *month = imonth;
    *day = iday;
}


/*
 * Convert a Gregorian/Julian date to a Julian day number.
 *
 * The Gregorian calendar was adopted midday, October 15, 1582.
 */
static unsigned long gregdate_to_julday(
    int		year,	/* Gregorian year */
    int		month,	/* Gregorian month (1-12) */
    int		day	/* Gregorian day (1-31) */
    )
{
    long		igreg = 15 + 31 * (10 + (12 * 1582));
    int			iy;	/* signed, origin 0 year */
    int			ja;	/* Julian century */
    int			jm;	/* Julian month */
    int			jy;	/* Julian year */
    unsigned long	julday;	/* returned Julian day number */

    /*
     * Because there is no 0 BC or 0 AD, assume the user wants the start of 
     * the common era if they specify year 0.
     */
    if (year == 0)
	year = 1;

    iy = year;
    if (year < 0)
	iy++;
    if (month > 2)
    {
	jy = iy;
	jm = month + 1;
    }
    else
    {
	jy = iy - 1;
	jm = month + 13;
    }

    /*
     *  Note: SLIGHTLY STRANGE CONSTRUCTIONS REQUIRED TO AVOID PROBLEMS WITH
     *        OPTIMISATION OR GENERAL ERRORS UNDER VMS!
     */
    julday = day + (int)(30.6001 * jm);
    if (jy >= 0)
    {
	julday += 365 * jy;
	julday += jy / 4;
    }
    else
    {
	double		xi = 365.25 * jy;

	if ((int)xi != xi)
	    xi -= 1;
	julday += (int)xi;
    }
    julday += 1720995;

    if (day + (31* (month + (12 * iy))) >= igreg)
    {
	ja = jy/100;
	julday -= ja;
	julday += 2;
	julday += ja/4;
    }

    return julday;
}

/*
 * Encode a date as a double-precision value.
 */
static double utencdate(int year, int month, int day)
{
    return ((long)gregdate_to_julday(year, month, day) - 
	    (long)gregdate_to_julday(2001, 1, 1)) * 86400.0;
}


/*
 * Encode a time as a double-precision value.
 */
static double utencclock(int hours, int minutes, double seconds)
{
    return (hours*60 + minutes)*60 + seconds;
}



/*
 * Decompose a value into a set of values accounting for uncertainty.
 */
static void decomp(
       double	value,
       double	uncer,		/* >= 0 */
       int	nbasis,
       double	*basis,		/* all values > 0 */
       double	*count
    )
{
    int		i;

    for (i = 0; i < nbasis; i++)
    {
	double	r = fmod(value, basis[i]);	/* remainder */

	/* Adjust remainder to minimum magnitude. */
	if (ABS(2*r) > basis[i])
	    r += r > 0
		    ? -basis[i]
		    :  basis[i];

	if (ABS(r) <= uncer)
	{
	    /* The value equals a basis multiple within the uncertainty. */
	    double	half = value < 0 ? -basis[i]/2 : basis[i]/2;
	    modf((value+half)/basis[i], count+i);
	    break;
	}

	value = basis[i] * modf(value/basis[i], count+i);
    }

    for (i++; i < nbasis; i++)
	count[i] = 0;
}


/*
 * Decode a time from a double-precision value.
 */
static void dectime(
	double	value,
	int	*year,
	int	*month,
	int	*day,
	int	*hour,
	int	*minute,
	float	*second)
{
    long	days;
    int  	hours;
    int 	minutes;
    double	seconds;
    double	uncer;		/* uncertainty of input value */
    typedef union
    {
	double	    vec[7];
	struct
	{
	    double	days;
	    double	hours12;
	    double	hours;
	    double	minutes10;
	    double	minutes;
	    double	seconds10;
	    double	seconds;
	}	    ind;
    } Basis;
    Basis	counts;
    static Basis	basis;

    basis.ind.days      = 86400;
    basis.ind.hours12   = 43200;
    basis.ind.hours     = 3600;
    basis.ind.minutes10 = 600;
    basis.ind.minutes   = 60;
    basis.ind.seconds10 = 10;
    basis.ind.seconds   = 1;

    uncer = ldexp(value < 0 ? -value : value, -DBL_MANT_DIG);

    days = (long) floor(value/86400.0);
    value -= days * 86400.0;		/* make positive excess */

    decomp(value, uncer, sizeof(basis.vec)/sizeof(basis.vec[0]),
	   basis.vec, counts.vec);

    days   += (long) counts.ind.days;
    hours   = (int)counts.ind.hours12 * 12 + (int)counts.ind.hours;
    minutes = (int)counts.ind.minutes10 * 10 + (int)counts.ind.minutes;
    seconds = (int)counts.ind.seconds10 * 10 + counts.ind.seconds;

    *second = seconds;
    *minute = minutes;
    *hour = hours;
    julday_to_gregdate(gregdate_to_julday(2001, 1, 1) + days, year, month, day);
}

/*
 * Convert a Gregorian/Julian date and time into a temporal value.
 *
 */
void InvCalendar(int year, int month, int day, int hour,
		 int minute, double second, sUnit unit, double *value)
{
  *value = (utencdate(year, month, day) + 
	    utencclock(hour, minute, second) - unit.origin) /
            unit.factor;
}

/*
 * Convert a temporal value into UTC Gregorian/Julian date and time.
 *
 */
void Calendar(double value, sUnit unit, int *year, int *month,
	      int *day, int *hour, int *minute, double *second)
{
  float	sec;

  dectime(unit.origin + value*unit.factor, year, month, day, hour, minute, &sec);
  *second = sec;
}


/*
 * Encode a date as a double-precision value.
 */
static double encdateXXX(int dpy, int year, int month, int day)
{
  int i;
  int *dpm = NULL;
  double rval;

  rval = dpy * year + day;

  if      ( dpy == 360 ) dpm = month_360;
  else if ( dpy == 365 ) dpm = month_365;
  else if ( dpy == 366 ) dpm = month_366;
  
  if ( dpm ) for ( i = 0; i < month-1; i++ ) rval += dpm[i];

  return (rval * 86400.0);
}


/*
 * Convert a XXX day/year date and time into a temporal value.
 *
 */
void InvCalendarXXX(int dpy, int year, int month, int day, int hour,
		    int minute, double second, sUnit unit, double *value)
{
  *value = (encdateXXX(dpy, year, month, day) + 
	    utencclock(hour, minute, second) - unit.origin) /
            unit.factor;
}


/*
 * Convert a temporal value into XXX day/year date and time.
 *
 */
void CalendarXXX(int dpy, double value, sUnit unit, int *year, int *month,
		 int *day, int *hour, int *minute, double *second)
{
    int i = 0;
    int *dpm = NULL;
    long	days;
    int  	hours;
    int 	minutes;
    double	seconds;
    double	uncer;		/* uncertainty of input value */
    typedef union
    {
	double	    vec[7];
	struct
	{
	    double	days;
	    double	hours12;
	    double	hours;
	    double	minutes10;
	    double	minutes;
	    double	seconds10;
	    double	seconds;
	}	    ind;
    } Basis;
    Basis	counts;
    static Basis	basis;

    value = unit.origin + value*unit.factor;

    basis.ind.days      = 86400;
    basis.ind.hours12   = 43200;
    basis.ind.hours     = 3600;
    basis.ind.minutes10 = 600;
    basis.ind.minutes   = 60;
    basis.ind.seconds10 = 10;
    basis.ind.seconds   = 1;

    uncer = ldexp(value < 0 ? -value : value, -DBL_MANT_DIG);

    days = (long) floor(value/86400.0);
    value -= days * 86400.0;		/* make positive excess */

    decomp(value, uncer, sizeof(basis.vec)/sizeof(basis.vec[0]),
	   basis.vec, counts.vec);

    days   += (long) counts.ind.days;
    hours   = (int)counts.ind.hours12   * 12 + (int)counts.ind.hours;
    minutes = (int)counts.ind.minutes10 * 10 + (int)counts.ind.minutes;
    seconds = (int)counts.ind.seconds10 * 10 + counts.ind.seconds;

    *second = seconds;
    *minute = minutes;
    *hour   = hours;

    *year = (days-1) / dpy;

    days -= (*year*dpy);

    if      ( dpy == 360 ) dpm = month_360;
    else if ( dpy == 365 ) dpm = month_365;
    else if ( dpy == 366 ) dpm = month_366;

    if ( dpm )
      for ( i = 0; i < 12; i++ )
	{
	    if ( days > dpm[i] ) days -= dpm[i];
	    else break;
	}

    *month = i + 1;

    *day = days;
}


/*
 * Convert a cdi date and time into a temporal value.
 *
 */
void cdiInvCalendar(int dpy, int year, int month, int day, int hour,
		    int minute, double second, sUnit unit, double *value)
{
  if ( dpy == 360 || dpy == 365 || dpy == 366 )
    InvCalendarXXX(dpy, year, month, day, hour, minute, second, unit, value);
  else
    InvCalendar(year, month, day, hour, minute, second, unit, value);
}


/*
 * Convert a temporal value into cdi date and time.
 *
 */
void cdiCalendar(int dpy, double value, sUnit unit, int *year, int *month,
		 int *day, int *hour, int *minute, double *second)
{
  if ( dpy == 360 || dpy == 365 || dpy == 366 )
    CalendarXXX(dpy, value, unit, year, month, day, hour, minute, second);
  else
    Calendar(value, unit, year, month, day, hour, minute, second);
}

/*
int main(void)
{
  int i, dpy = 0;
  int year, month, day, hour, minute;
  sUnit tunit = {0, 1};
  double second;
  double value;

  year=1978; month=1; day=15; hour=12; minute=30;

  printf("dpy = %d\n", dpy);
  printf("%d/%02d/%02d %02d:%02d\n", year, month, day, hour, minute);

  cdiInvCalendar(dpy, year, month, day, hour, minute, 0.0, tunit, &value);

  cdiCalendar(dpy, value, tunit, &year, &month, &day, &hour, &minute, &second);
  printf("%d/%02d/%02d %02d:%02d   %g\n", year, month, day, hour, minute, value);

  tunit.origin = value;
  tunit.factor = 86400.0;

  for ( i = 0; i < 400; i++ )
    {
      value = i;
      cdiCalendar(dpy, value, tunit, &year, &month, &day, &hour, &minute, &second);
      printf("%2d %d/%02d/%02d %02d:%02d\n", i, year, month, day, hour, minute);
    }

  return (0);
}
*/
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



#undef  UNDEFID
#define UNDEFID -1

int ECHAM4 = UNDEFID;
int ECHAM5 = UNDEFID;

typedef struct
{
  int      used;  
  int      instID;  
  int      modelgribID;
  char    *name;
}
Model;

Model *models;

static int modelsSize = 0;

static int ModelsInit = 0;

void modelsInit(void);

int modelDef(int instID, int modelgribID, const char *name);

void modelsInitEntry(int modelID)
{
  static char func[] = "modelsInitEntry";

  if ( modelID < 0 || modelID >= modelsSize )
    Error(func, "modelID %d undefined!", modelID);

  models[modelID].used        = 0;
  models[modelID].instID      = UNDEFID;
  models[modelID].modelgribID = UNDEFID;
  models[modelID].name        = NULL;
}

int modelsNewEntry(void)
{
  static char func[] = "modelsNewEntry";
  int modelID = 0;

  /*
    Look for a free slot in models.
    (Create the table the first time through).
  */
  if ( !modelsSize )
    {
      int i;

      modelsSize = 2;
      models = (Model *) malloc(modelsSize*sizeof(Model));
      if( models == NULL )
	{
          Message(func, "modelsSize = %d", modelsSize);
	  SysError(func, "Allocation of Model failed");
	}

      for( i = 0; i < modelsSize; i++ )
	modelsInitEntry(i);
    }
  else
    {
      while( modelID < modelsSize )
	{
	  if ( models[modelID].used == 0 ) break;
	  modelID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( modelID == modelsSize )
    {
      int i;

      modelsSize = 2*modelsSize;
      models = (Model *) realloc(models, modelsSize*sizeof(Model));
      if( models == NULL )
	{
          Message(func, "modelsSize = %d", modelsSize);
	  SysError(func, "Reallocation of Model failed");
	}

      for( i = modelID; i < modelsSize; i++ )
	modelsInitEntry(i);
    }

  models[modelID].used = 1;

  return (modelID);
}

void modelsDefault(void)
{
  int instID;

  instID  = institutInq(  0,   0, "ECMWF", NULL);
  (void)    modelDef(instID, 131, "ERA15");
  (void)    modelDef(instID, 199, "ERA40");

  instID  = institutInq(  0,   0, "MPIMET", NULL);
  ECHAM5  = modelDef(instID,  63, "ECHAM5.3");
  (void)    modelDef(instID,  62, "ECHAM5.2");
  (void)    modelDef(instID,  61, "ECHAM5.1");

  instID  = institutInq( 98, 255, "MPIMET", NULL);
  (void)    modelDef(instID,  60, "ECHAM5.0");
  ECHAM4  = modelDef(instID,  50, "ECHAM4");
  (void)    modelDef(instID, 110, "MPIOM1");

  instID  = institutInq(  0,   0, "DWD", NULL);
  (void)    modelDef(instID, 149, "GME");

  instID  = institutInq(  0,   1, "NCEP", NULL);
  (void)    modelDef(instID,  80, "T62L28MRF");
}

void modelsInit(void)
{
  ModelsInit = 1;

  modelsDefault();
}

int modelInq(int instID, int modelgribID, char *name)
{
  int modelID = UNDEFID;
  size_t len;
  int found;

  if ( ! ModelsInit ) modelsInit();

  for( modelID = 0; modelID < modelsSize; modelID++ )
    {
      if ( models[modelID].used )
	{
	  if ( name )
	    {
	      found = 1;
	      if ( instID      != -1 && models[modelID].instID      != instID )      found = 0;
	      if ( modelgribID !=  0 && models[modelID].modelgribID != modelgribID ) found = 0;

	      if ( found )
		{
		  if ( models[modelID].name )
		    {
		      len = strlen(models[modelID].name);
		      if ( strncmp(models[modelID].name, name, len) == 0 ) break;
		      len = strlen(name);
		      if ( strncmp(models[modelID].name, name, len) == 0 ) break;
		    }
		}
	    }
	  else
	    {
	      if ( models[modelID].instID      == instID &&
		   models[modelID].modelgribID == modelgribID ) break;
	    }
	}
    }

  if ( modelID == modelsSize ) modelID = UNDEFID;

  return (modelID);
}

int modelDef(int instID, int modelgribID, const char *name)
{
  static char func[] = "modelDef";
  int modelID = UNDEFID;

  if ( ! ModelsInit ) modelsInit();
  /*
  modelID = modelInq(instID, modelgribID, name);
  */
  if ( modelID == UNDEFID )
    {
      modelID = modelsNewEntry();

      models[modelID].instID      = instID;
      models[modelID].modelgribID = modelgribID;

      if ( name ) models[modelID].name = strdup(name);
    }

  return (modelID);
}

void modelCheckID(char *func, int modelID)
{
  if ( modelID < 0 || modelID >= modelsSize )
    Error(func, "modelID %d undefined!", modelID);

  if ( ! models[modelID].used )
    Error(func, "modelID %d undefined!", modelID);
}

int modelInqInstitut(int modelID)
{
  static char func[] = "modelInqInstitut";
  int instID = UNDEFID;

  if ( ! ModelsInit ) modelsInit();

  if ( modelID != UNDEFID )
    {
      modelCheckID(func, modelID);
  
      instID = models[modelID].instID;
    }

  return (instID);
}

int modelInqGribID(int modelID)
{
  static char func[] = "modelInqGribID";
  int modelgribID = UNDEFID;

  if ( ! ModelsInit ) modelsInit();

  if ( modelID != UNDEFID )
    {
      modelCheckID(func, modelID);

      modelgribID = models[modelID].modelgribID;
    }

  return (modelgribID);
}

char *modelInqNamePtr(int modelID)
{
  static char func[] = "modelInqNamePtr";
  char *name = NULL;

  if ( ! ModelsInit ) modelsInit();

  if ( modelID != UNDEFID )
    {
      modelCheckID(func, modelID);

      if ( models[modelID].name )
	name = models[modelID].name;
    }

  return (name);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



#undef  UNDEFID
#define UNDEFID  -1

int ECMWF  = UNDEFID;
int MPIMET = UNDEFID;

typedef struct
{
  int    used;  
  int    center;  
  int    subcenter;
  char  *name;
  char  *longname;
}
Institut;

Institut *instituts;

static int institutsSize = 0;
static int institutsNum  = 0;
static int InstitutsInit = 0;


void institutsDefault(void);
void institutsInit(void);


void institutsInitEntry(int instID)
{
  static char func[] = "institutsInitEntry";

  if ( instID < 0 || instID >= institutsSize )
    Error(func, "instID %d undefined!", instID);

  instituts[instID].used       = 0;
  instituts[instID].center     = UNDEFID;
  instituts[instID].subcenter  = UNDEFID;
  instituts[instID].name       = NULL;
  instituts[instID].longname   = NULL;
}


int institutsNewEntry(void)
{
  static char func[] = "institutsNewEntry";
  int instID = 0;

  /*
    Look for a free slot in instituts.
    (Create the table the first time through).
  */
  if ( !institutsSize )
    {
      int i;

      institutsSize = 2;
      instituts = (Institut *) malloc(institutsSize*sizeof(Institut));
      if( instituts == NULL )
	{
          Message(func, "institutsSize = %d", institutsSize);
	  SysError(func, "Allocation of Institut failed");
	}

      for( i = 0; i < institutsSize; i++ )
	institutsInitEntry(i);
    }
  else
    {
      while( instID < institutsSize )
	{
	  if ( instituts[instID].used == 0 ) break;
	  instID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( instID == institutsSize )
    {
      int i;

      institutsSize = 2*institutsSize;
      instituts = (Institut *) realloc(instituts, institutsSize*sizeof(Institut));
      if( instituts == NULL )
	{
          Message(func, "institutsSize = %d", institutsSize);
	  SysError(func, "Reallocation of Institut failed");
	}

      for( i = instID; i < institutsSize; i++ )
	institutsInitEntry(i);
    }

  instituts[instID].used = 1;
  institutsNum++;

  return (instID);
}


void institutsInit(void)
{
  InstitutsInit = 1;

  institutsDefault();
}


int institutInq(int center, int subcenter, const char *name, const char *longname)
{
  int instID;
  size_t len;
  int found;

  if ( ! InstitutsInit ) institutsInit();

  for( instID = 0; instID < institutsSize; instID++ )
    {
      if ( instituts[instID].used )
	{
	  if ( name )
	    {
	      found = 1;
	      if ( center    > 0 && instituts[instID].center    != center )    found = 0;
	      if ( subcenter > 0 && instituts[instID].subcenter != subcenter ) found = 0;

	      if ( found )
		{
		  if ( instituts[instID].name )
		    {
		      len = strlen(instituts[instID].name);
		      if ( strncmp(instituts[instID].name, name, len) == 0 ) break;
		    }
		}
	    }
	  else if ( longname )
	    {
	      if ( instituts[instID].longname )
		{
		  len = strlen(instituts[instID].longname);
		  if ( strncmp(instituts[instID].longname, longname, len) == 0 ) break;
		}
	    }
	  else
	    {
	      if ( instituts[instID].center    == center &&
		   instituts[instID].subcenter == subcenter ) break;
	    }
	}
    }

  if ( instID == institutsSize ) instID = UNDEFID;

  return (instID);
}


int institutDef(int center, int subcenter, const char *name, const char *longname)
{
  static char func[] = "institutDef";
  int instID;

  if ( ! InstitutsInit ) institutsInit();
  /*
  instID = institutInq(center, subcenter, name, longname);

  if ( instID == UNDEFID )
  */
    {
      instID = institutsNewEntry();

      instituts[instID].center    = center;
      instituts[instID].subcenter = subcenter;

      if ( name )     instituts[instID].name     = strdup(name);
      if ( longname ) instituts[instID].longname = strdup(longname);
    }

  return (instID);
}


void institutionCheckID(char *func, int instID)
{
  if ( instID < 0 || instID >= institutsSize )
    Error(func, "instID %d undefined!", instID);

  if ( ! instituts[instID].used )
    Error(func, "instID %d undefined!", instID);
}


int institutInqCenter(int instID)
{
  static char func[] = "institutInqCenter";
  int center = UNDEFID;

  if ( ! InstitutsInit ) institutsInit();

  if ( instID != UNDEFID )
    {
      institutionCheckID(func, instID);

      center = instituts[instID].center;
    }

  return (center);
}


int institutInqSubcenter(int instID)
{
  static char func[] = "institutInqSubcenter";
  int subcenter = UNDEFID;

  if ( ! InstitutsInit ) institutsInit();

  if ( instID != UNDEFID )
    {
      institutionCheckID(func, instID);

      subcenter = instituts[instID].subcenter;
    }

  return (subcenter);
}


char *institutInqNamePtr(int instID)
{
  static char func[] = "institutInqNamePtr";
  char *name = NULL;

  if ( ! InstitutsInit ) institutsInit();

  if ( instID != UNDEFID )
    {
      institutionCheckID(func, instID);

      if ( instituts[instID].name )
	name = instituts[instID].name;
    }

  return (name);
}


char *institutInqLongnamePtr(int instID)
{
  static char func[] = "institutInqLongnamePtr";
  char *name = NULL;

  if ( ! InstitutsInit ) institutsInit();

  if ( instID != UNDEFID )
    {
      institutionCheckID(func, instID);

      if ( instituts[instID].longname )
	name = instituts[instID].longname;
    }

  return (name);
}


int institutInqNumber(void)
{
  if ( ! InstitutsInit ) institutsInit();

  return (institutsNum);
}


void institutsDefault(void)
{
  ECMWF   = institutDef( 98,   0, "ECMWF",     "European Centre for Medium-Range Weather Forecasts");
  MPIMET  = institutDef( 98, 232, "MPIMET",    "Max-Planck-Institute for Meteorology");
     (void) institutDef( 98, 255, "MPIMET",    "Max-Planck-Institute for Meteorology");
     (void) institutDef( 98, 232, "MPIMET",    "Max-Planck Institute for Meteorology");
     (void) institutDef( 78, 255, "DWD",       "Deutscher Wetterdienst");
     (void) institutDef(  7,   0, "NCEP",      "National Centers for Environmental Prediction");
     (void) institutDef(  7,   1, "NCEP",      "National Centers for Environmental Prediction");
     (void) institutDef( 60,   0, "NCAR",      "National Center for Atmospheric Research");
     (void) institutDef( 74,   0, "METOFFICE", "U.K. Met Office");
     (void) institutDef( 97,   0, "ESA",       "European Space Agency ");
     (void) institutDef( 99,   0, "KNMI",      "Royal Netherlands Meteorological Institute");
     (void) institutDef(  0,   0, "IPSL",      "IPSL (Institut Pierre Simon Laplace, Paris, France)");
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




#undef  UNDEFID
#define UNDEFID -1

/*int TableDefine = 0; */ /* Define new table also if the entry already exist */
                          /* This is needed for createtable */


#define MAX_TABLE  99
#define MAX_PARS   1024

typedef struct
{
  int    used;  
  PAR   *pars;
  int    npars;
  int    modelID;
  int    number;
  char  *name;
} 
PARTAB;

static PARTAB parTable[MAX_TABLE];
static int  parTableSize = MAX_TABLE;
static int  parTableNum  = 0;
static int  ParTableInit = 0;

static char *tablePath = NULL;

void tableDefModelID(int tableID, int modelID);
void tableDefGribID(int tableID, int tablegribID);

void tableDefEntry(int tableID, int id, const char *name,
		   const char *longname, const char *units)
{
  static char func[] = "tableDefEntry";
  int item;

  item = parTable[tableID].npars++;
  parTable[tableID].pars[item].id       = id;
  parTable[tableID].pars[item].name     = NULL;
  parTable[tableID].pars[item].longname = NULL;
  parTable[tableID].pars[item].units    = NULL;

  if ( name )
    if ( strlen(name) > 0 )
      parTable[tableID].pars[item].name     = strdup(name);
  if ( longname )
    if ( strlen(longname) > 0 )
      parTable[tableID].pars[item].longname = strdup(longname);
  if ( units )
    if ( strlen(units) > 0 )
      parTable[tableID].pars[item].units    = strdup(units);
}

void tableLink(int tableID, PAR *pars, int npars)
{
  int item;

  for ( item = 0; item < npars; item++ )
    {
      parTable[tableID].pars[item].id       = pars[item].id;
      parTable[tableID].pars[item].name     = pars[item].name;
      parTable[tableID].pars[item].longname = pars[item].longname;
      parTable[tableID].pars[item].units    = pars[item].units;
    }

  parTable[tableID].npars = npars;
}

void parTableInitEntry(int tableID)
{
  parTable[tableID].used    = 0;
  parTable[tableID].pars    = NULL;
  parTable[tableID].npars   = 0;
  parTable[tableID].modelID = UNDEFID;
  parTable[tableID].number  = UNDEFID;
  parTable[tableID].name    = NULL;
}

void tableGetPath(void)
{
  static char func[] = "tableGetPath";
  char *path;

  path = getenv("TABLEPATH");

  if ( path ) tablePath = strdup(path);
  /*
  printf("tablePath = %s\n", tablePath);
  */
}

void parTableInit(void)
{
  ParTableInit = 1;

  tableDefault();

  tableGetPath();
}

int tableNewEntry()
{
  static char func[] = "tableNewEntry";
  int tableID = 0;
  static int init = 0;

  if ( ! init )
    {
      for ( tableID = 0; tableID < parTableSize; tableID++ )
	parTableInitEntry(tableID);
      init = 1;
    }

  /*
    Look for a free slot in parTable.
  */
  for ( tableID = 0; tableID < parTableSize; tableID++ )
    {
      if ( ! parTable[tableID].used ) break;
    }

  if ( tableID == parTableSize )
    Error(func, "no more entries!");

  parTable[tableID].used = 1;
  parTableNum++;

  return (tableID);
}

int decodeForm1(int lnr, char *pline, char *name, char *longname, char *units)
{
  /* Format 1 : code name add mult longname [units] */
  double add, mult;
  int level;
  char *pstart, *pend;
  long len;

  level = strtol(pline, &pline, 10);
  while ( isspace((int) *pline) ) pline++;

  pstart = pline;
  while ( ! (isspace((int) *pline) || *pline == 0) ) pline++;
  len = pline - pstart;
  if ( len > 0 )
    {
      strncpy(name, pstart, len);
      name[len] = 0;
    }
  else
    return (0);

  len = strlen(pline);
  if ( len == 0 ) return (0);

  add  = strtod(pline, &pline);
  mult = strtod(pline, &pline);

  while ( isspace((int) *pline) ) pline++;

  len = strlen(pline);
  if ( len > 0)
    {
      pstart = pline;
      pend = strrchr(pline, '[');
      if ( pend )
	pend--;
      else
	pend = pstart + len;
      while ( isspace((int) *pend) ) pend--;
      len = pend - pstart + 1;
      if ( len > 0 )
	{
	  strncpy(longname, pstart, len);
	  longname[len] = 0;
	}
      pstart = strrchr(pline, '[');
      if ( pstart )
	{
	  pstart++;
	  while ( isspace((int) *pstart) ) pstart++;
	  pend = strchr(pstart, ']');
	  if ( ! pend ) return (0);
	  pend--;
	  while ( isspace((int) *pend) ) pend--;
	  len = pend - pstart + 1;
	  if ( len > 0 )
	    {
	      strncpy(units, pstart, len);
	      units[len] = 0;
	    }	  
	}
    }
 
  return (0);
}

int decodeForm2(int lnr, char *pline, char *name, char *longname, char *units)
{
  /* Format 2 : code | name | longname | units */
  char *pend;
  long len;

  pline = strchr(pline, '|');
  pline++;

  while ( isspace((int) *pline) ) pline++;
  pend = strchr(pline, '|');
  if ( ! pend )
    {
      pend = pline;
      while ( ! isspace((int) *pend) ) pend++;
      len = pend - pline;
      if ( len > 0 )
	{
	  strncpy(name, pline, len);
	  name[len] = 0;
	}
      return (0);
    }
  else
    {
      pend--;
      while ( isspace((int) *pend) ) pend--;
      len = pend - pline + 1;
      if ( len > 0 )
	{
	  strncpy(name, pline, len);
	  name[len] = 0;
	}
    }

  pline = strchr(pline, '|');
  pline++;
  while ( isspace((int) *pline) ) pline++;
  pend = strchr(pline, '|');
  if ( !pend ) pend = strchr(pline, 0);
  pend--;
  while ( isspace((int) *pend) ) pend--;
  len = pend - pline + 1;
  if ( len > 0 )
    {
      strncpy(longname, pline, len);
      longname[len] = 0;
    }

  pline = strchr(pline, '|');
  if ( pline )
    {
      pline++;
      while ( isspace((int) *pline) ) pline++;
      pend = strchr(pline, '|');
      if ( !pend ) pend = strchr(pline, 0);
      pend--;
      while ( isspace((int) *pend) ) pend--;
      len = pend - pline + 1;
      if ( len < 0 ) len = 0;
      strncpy(units, pline, len);
      units[len] = 0;
    }

  return (0);
}

int tableRead(const char *tablefile)
{
  char line[1024], *pline;
  int lnr = 0;
  long len;
  int id;
  char name[256], longname[256], units[256];
  int tableID = UNDEFID;
  int err;
  char *tablename;
  FILE *tablefp;

  tablefp = fopen(tablefile, "r");
  if ( tablefp == NULL ) return (tableID);

  tablename = strrchr(tablefile, '/');
  if ( tablename == 0 ) tablename = (char *) tablefile;
  else                  tablename++;

  tableID = tableDef(-1, 0, tablename);

  while ( fgets(line, 1023, tablefp) )
    {
      len = strlen(line);
      if ( line[len-1] == '\n' ) line[len-1] = '\0';
      lnr++;
      id       = CDI_UNDEFID;
      name[0]     = 0;
      longname[0] = 0;
      units[0]    = 0;
      if ( line[0] == '#' ) continue;
      pline = line;

      len = strlen(pline);
      if ( len < 4 ) continue;
      while ( isspace((int) *pline) ) pline++;
      id = atoi(pline);
      /*
      if ( id > 255 ) id -= 256;
      */
      if ( id == 0 ) continue;

      while ( isdigit((int) *pline) ) pline++; 

      if ( strchr(pline, '|') )
	err = decodeForm2(lnr, pline, name, longname, units);
      else
	err = decodeForm1(lnr, pline, name, longname, units);

      if ( err ) continue;

      if ( strlen(name) == 0 ) sprintf(name, "var%d", id);

      tableDefEntry(tableID, id, name, longname, units);
    }

  return (tableID);
}

int tableFromEnv(int modelID, int tablegribID)
{
  static char func[] = "tableFromEnv";
  int tableID = UNDEFID;
  char tablename[256] = {'\0'};
  int tablenamefound = 0;

  if ( modelInqNamePtr(modelID) )
    {
      strcpy(tablename, modelInqNamePtr(modelID));
      if ( tablegribID )
	{
	  int len = strlen(tablename);
	  sprintf(tablename+len, "_%03d", tablegribID);
	}
      tablenamefound = 1;
      /* printf("tableInq: tablename = >%s<\n", tablename); */
    }
  else
    {
      int instID = modelInqInstitut(modelID);
      if ( instID != UNDEFID )
	{
	  if ( institutInqNamePtr(instID) )
	    {
	      strcpy(tablename, institutInqNamePtr(instID));
	      if ( tablegribID )
		{
		  int len = strlen(tablename);
		  sprintf(tablename+len, "_%03d", tablegribID);
		}
	      tablenamefound = 1;
	      /* printf("tableInq: tablename = >%s<\n", tablename); */
	    }
	}
    }

  if ( tablenamefound )
    {
      int lenp = 0, lenf;
      char *tablefile = NULL;
      if ( tablePath )
	lenp = strlen(tablePath);
      lenf = strlen(tablename);
      /* if (tablePath) printf("tablePath = %s\n", tablePath); */
      /* if (tablename) printf("tableName = %s\n", tablename); */
      tablefile = (char *) malloc(lenp+lenf+3);
      if ( tablePath )
	{
	  strcpy(tablefile, tablePath);
	  strcat(tablefile, "/");
	}
      else
	tablefile[0] = '\0';
      strcat(tablefile, tablename);
      /* if (tablefile) printf("tableFile = %s\n", tablefile); */

      tableID = tableRead(tablefile);
      if ( tableID != UNDEFID )
	{
	  tableDefModelID(tableID, modelID);
	  tableDefGribID(tableID, tablegribID);
	}
      /* printf("tableID = %d %s\n", tableID, tablefile); */

      free(tablefile);
    }

  return (tableID);
}

int tableInq(int modelID, int tablegribID, const char *tablename)
{
  static char func[] = "tableInq";
  int tableID = UNDEFID;
  int modelID2 = UNDEFID, i, len;
  char tablefile[256] = {'\0'};

  if ( ! ParTableInit ) parTableInit();

  if ( tablename )
    {
      size_t len;
      strcpy(tablefile, tablename);
      /*
      printf("tableInq: tablefile = >%s<\n", tablefile);
      */
      /* search for internal table */
      for ( tableID = 0; tableID < MAX_TABLE; tableID++ )
	{
	  if ( parTable[tableID].used && parTable[tableID].name )
	    {
	      /* len = strlen(parTable[tableID].name); */
	      len = strlen(tablename);
	      if ( strncmp(parTable[tableID].name, tablename, len) == 0 ) break;
	    }
	}
      if ( tableID == MAX_TABLE ) tableID = UNDEFID;
      if ( CDI_Debug )
	Message(func, "tableID = %d tablename = %s", tableID, tablename);
    }
  else
    {
      for ( tableID = 0; tableID < MAX_TABLE; tableID++ )
	{
	  if ( parTable[tableID].used )
	    {	  
	      if ( parTable[tableID].modelID == modelID &&
		   parTable[tableID].number  == tablegribID ) break;
	    }
	}
  
      if ( tableID == MAX_TABLE ) tableID = UNDEFID;

      if ( tableID == UNDEFID )
	{
	  if ( modelID != UNDEFID )
	    {
	      if ( modelInqNamePtr(modelID) )
		{
		  strcpy(tablefile, modelInqNamePtr(modelID));
		  len = strlen(tablefile);
		  for ( i = 0; i < len; i++)
		    if ( tablefile[i] == '.' ) tablefile[i] = '\0';
		  modelID2 = modelInq(-1, 0, tablefile);
		}
	    }
	  if ( modelID2 != UNDEFID )
	    for ( tableID = 0; tableID < MAX_TABLE; tableID++ )
	      {
		if ( parTable[tableID].used )
		  {
		    if ( parTable[tableID].modelID == modelID2 &&
			 parTable[tableID].number  == tablegribID ) break;
		  }
	      }
	}

      if ( tableID == MAX_TABLE ) tableID = UNDEFID;

      if ( tableID == UNDEFID && modelID != UNDEFID )
	tableID = tableFromEnv(modelID, tablegribID);

      if ( CDI_Debug )
	if ( tablename )
	  Message(func, "tableID = %d tablename = %s", tableID, tablename);
    }

  return (tableID);
}

int tableDef(int modelID, int tablegribID, const char *tablename)
{
  static char func[] = "tableDef";
  int tableID = UNDEFID;

  if ( ! ParTableInit ) parTableInit();
  /*
  if ( ! (modelID == UNDEFID && tablegribID == 0) )
    tableID = tableInq(modelID, tablegribID, tablename);
    */
  if ( tableID == UNDEFID )
    {
      tableID = tableNewEntry();

      parTable[tableID].modelID = modelID;
      parTable[tableID].number  = tablegribID;
      if ( tablename ) 
	parTable[tableID].name = strdup(tablename);

      parTable[tableID].pars = (PAR *) malloc(MAX_PARS * sizeof(PAR));
    }

  return (tableID);
}

void tableDefModelID(int tableID, int modelID)
{
  parTable[tableID].modelID = modelID;
}

void tableDefGribID(int tableID, int tablegribID)
{
  parTable[tableID].number  = tablegribID;
}

int tableInqGribID(int tableID)
{
  int codetable = 0;

  if ( tableID >= 0 && tableID < MAX_TABLE )
    codetable = parTable[tableID].number;

  return (codetable);
}

int tableInqModel(int tableID)
{
  int modelID = -1;

  if ( tableID >= 0 && tableID < MAX_TABLE )
    modelID = parTable[tableID].modelID;

  return (modelID);
}

void partabCheckID(int item)
{
  static char func[] = "partabCheckID";

  if ( item < 0 || item >= parTableSize )
    Error(func, "item %d undefined!", item);

  if ( ! parTable[item].name )
    Error(func, "item %d name undefined!", item);
}

char *tableInqNamePtr(int tableID)
{
  static char func[] = "tableInqNamePtr";
  char *tablename = NULL;

  if ( CDI_Debug )
    Message(func, "tableID = %d", tableID);

  if ( ! ParTableInit ) parTableInit();

  if ( tableID >= 0 && tableID < parTableSize )
    if ( parTable[tableID].name )
      tablename = parTable[tableID].name;

  return (tablename);
}

void tableWrite(const char *ptfile, int tableID)
{
  static char func[] = "tableWrite";
  int item, npars;
  int lenname, lenlname, lenunits;
  int maxname = 4, maxlname = 10, maxunits = 2;
  FILE *ptfp;
  int tablegribID, modelID, instID = CDI_UNDEFID;
  int center = 0, subcenter = 0;
  char *instnameptr = NULL, *modelnameptr = NULL;

  if ( CDI_Debug )
    Message(func, "write parameter table %d to %s", tableID, ptfile);

  if ( tableID == UNDEFID )
    {
      Warning(func, "parameter table ID undefined");
      return;
    }

  partabCheckID(tableID);

  ptfp = fopen(ptfile, "w");

  npars = parTable[tableID].npars;

  for ( item = 0; item < npars; item++)
    {
      lenname  = strlen(parTable[tableID].pars[item].name);
      lenlname = strlen(parTable[tableID].pars[item].longname);
      lenunits = strlen(parTable[tableID].pars[item].units);
      if ( lenname  > maxname )  maxname  = lenname;
      if ( lenlname > maxlname ) maxlname = lenlname;
      if ( lenunits > maxunits ) maxunits = lenunits;
    }

  tablegribID = tableInqGribID(tableID);
  modelID = parTable[tableID].modelID;
  if ( modelID != CDI_UNDEFID )
    {
      modelnameptr = modelInqNamePtr(modelID);
      instID = modelInqInstitut(modelID);
    }
  if ( instID != CDI_UNDEFID )
    {
      center = institutInqCenter(instID);
      subcenter = institutInqSubcenter(instID);
      instnameptr = institutInqNamePtr(instID);
    }

  fprintf(ptfp, "# Parameter table\n");
  fprintf(ptfp, "#\n");
  if ( tablegribID )
    fprintf(ptfp, "# TABLE_ID=%d\n", tablegribID);
  fprintf(ptfp, "# TABLE_NAME=%s\n", parTable[tableID].name);
  if ( modelnameptr )
    fprintf(ptfp, "# TABLE_MODEL=%s\n", modelnameptr);
  if ( instnameptr )
    fprintf(ptfp, "# TABLE_INSTITUT=%s\n", instnameptr);
  if ( center )
    fprintf(ptfp, "# TABLE_CENTER=%d\n", center);
  if ( subcenter )
    fprintf(ptfp, "# TABLE_SUBCENTER=%d\n", subcenter);
  fprintf(ptfp, "#\n");
  fprintf(ptfp, "#\n");
  fprintf(ptfp, "# id       = parameter ID\n");
  fprintf(ptfp, "# name     = variable name\n");
  fprintf(ptfp, "# title    = long name (description)\n");
  fprintf(ptfp, "# units    = variable units\n");
  fprintf(ptfp, "#\n");
  fprintf(ptfp, "# The format of each record is:\n");
  fprintf(ptfp, "#\n");
  fprintf(ptfp, "# id | %-*s | %-*s | %-*s\n",
	  maxname,  "name",
	  maxlname, "title",
	  maxunits, "units");
	  
  for ( item = 0; item < npars; item++)
    {
      fprintf(ptfp, "%4d | %-*s | %-*s | %-*s\n",
	      parTable[tableID].pars[item].id,
	      maxname,
	      parTable[tableID].pars[item].name,
	      maxlname,
	      parTable[tableID].pars[item].longname,
	      maxunits,
	      parTable[tableID].pars[item].units);
    }

  fclose(ptfp);
}

void tableWriteC(const char *filename, int tableID)
{
  static char func[] = "tableWriteC";
  char chelp[] = "";
  int item, npars;
  int lenname, lenlname, lenunits;
  int maxname = 0, maxlname = 0, maxunits = 0;
  char tablename[256];
  int len, i;
  FILE *ptfp;

  if ( CDI_Debug )
    Message(func, "write parameter table %d to %s", tableID, filename);

  if ( tableID == UNDEFID )
    {
      Warning(func, "parameter table ID undefined");
      return;
    }

  partabCheckID(tableID);

  ptfp = fopen(filename, "w");

  npars = parTable[tableID].npars;

  for ( item = 0; item < npars; item++)
    {
      lenname  = strlen(parTable[tableID].pars[item].name);
      if ( parTable[tableID].pars[item].longname )
	lenlname = strlen(parTable[tableID].pars[item].longname);
      else
	lenlname = 0;
      if ( parTable[tableID].pars[item].units )
	lenunits = strlen(parTable[tableID].pars[item].units);
      else
	lenunits = 0;
      if ( lenname  > maxname )  maxname  = lenname;
      if ( lenlname > maxlname ) maxlname = lenlname;
      if ( lenunits > maxunits ) maxunits = lenunits;
    }

  strcpy(tablename, parTable[tableID].name);
  len = strlen(tablename);

  for ( i = 0; i < len; i++ )
    if ( tablename[i] == '.' ) tablename[i] = '_';

  fprintf(ptfp, "static PAR %s[] = {\n", tablename);
	  
  for ( item = 0; item < npars; item++ )
    {
      len = strlen(parTable[tableID].pars[item].name);
      fprintf(ptfp, "  {%4d, \"%s\", %-*s",
	      parTable[tableID].pars[item].id,
	      parTable[tableID].pars[item].name, maxname-len, chelp);

      if ( parTable[tableID].pars[item].longname )
	len = strlen(parTable[tableID].pars[item].longname);
      else
	len = 0;

      if ( len == 0 )
	fprintf(ptfp, " NULL, %-*s", maxlname-3, chelp);
      else
	fprintf(ptfp, "\"%s\", %-*s",
		parTable[tableID].pars[item].longname, maxlname-len, chelp);

      if ( parTable[tableID].pars[item].units )
	len = strlen(parTable[tableID].pars[item].units);
      else
	len = 0;

      if ( len == 0 )
	fprintf(ptfp, " NULL %-*s},\n", maxunits-3, chelp);
      else
	fprintf(ptfp, "\"%s\" %-*s},\n",
		parTable[tableID].pars[item].units,
		maxunits-len, chelp);
    }

  fprintf(ptfp, "};\n\n");

  fclose(ptfp);
}

int tableInqParName(int tableID, int code, char *varname)
{
  int item, npars;
  int err = 0;

  npars = parTable[tableID].npars;

  if ( tableID == UNDEFID )
    {
      err = 1;
    }
  else
    {
      for ( item = 0; item < npars; item++ )
	{
	  if ( parTable[tableID].pars[item].id == code )
	    {
	      if ( parTable[tableID].pars[item].name )
		strcpy(varname, parTable[tableID].pars[item].name);
	      break;
	    }
	}
      if ( item == npars ) err = 1;
    }

  return (err);
}

char *tableInqParNamePtr(int tableID, int code)
{
  char *name = NULL;
  int item, npars;

  if ( tableID != UNDEFID )
    {
      npars = parTable[tableID].npars;
      for ( item = 0; item < npars; item++ )
	{
	  if ( parTable[tableID].pars[item].id == code )
	    {
	      name = parTable[tableID].pars[item].name;
	      break;
	    }
	}
    }

  return (name);
}

char *tableInqParLongnamePtr(int tableID, int code)
{
  char *longname = NULL;
  int item, npars;

  if ( tableID != UNDEFID )
    {
      npars = parTable[tableID].npars;
      for ( item = 0; item < npars; item++ )
	{
	  if ( parTable[tableID].pars[item].id == code )
	    {
	      longname = parTable[tableID].pars[item].longname;
	      break;
	    }
	}
    }

  return (longname);
}

char *tableInqParUnitsPtr(int tableID, int code)
{
  char *units = NULL;
  int item, npars;

  if ( tableID != UNDEFID )
    {
      npars = parTable[tableID].npars;
      for ( item = 0; item < npars; item++ )
	{
	  if ( parTable[tableID].pars[item].id == code )
	    {
	      units = parTable[tableID].pars[item].units;
	      break;
	    }
	}
    }

  return (units);
}

int tableInqParLongname(int tableID, int code, char *longname)
{
  int item, npars;
  int err = 0;

  npars = parTable[tableID].npars;

  if ( tableID == UNDEFID )
    {
      err = 1;
    }
  else
    {
      for ( item = 0; item < npars; item++ )
	{
	  if ( parTable[tableID].pars[item].id == code )
	    {
	      if ( parTable[tableID].pars[item].longname )
		strcpy(longname, parTable[tableID].pars[item].longname);
	      break;
	    }
	}
      if ( item == npars ) err = 1;
    }

  return (err);
}

int tableInqParUnits(int tableID, int code, char *units)
{
  int item, npars;
  int err = 0;

  npars = parTable[tableID].npars;

  if ( tableID == UNDEFID )
    {
      err = 1;
    }
  else
    {
      for ( item = 0; item < npars; item++ )
	{
	  if ( parTable[tableID].pars[item].id == code )
	    {
	      if ( parTable[tableID].pars[item].units )
		strcpy(units, parTable[tableID].pars[item].units);
	      break;
	    }
	}
      if ( item == npars ) err = 1;
    }

  return (err);
}

void tableInqPar(int tableID, int code, char *name, char *longname, char *units)
{
  int item, npars;

  npars = parTable[tableID].npars;

  for ( item = 0; item < npars; item++ )
    {
      if ( parTable[tableID].pars[item].id == code )
	{
	  if ( parTable[tableID].pars[item].name )
	    strcpy(name, parTable[tableID].pars[item].name);
	  if ( parTable[tableID].pars[item].longname )
	    strcpy(longname, parTable[tableID].pars[item].longname);
	  if ( parTable[tableID].pars[item].units )
	    strcpy(units, parTable[tableID].pars[item].units);
	  break;
	}
    }
}

void tableInqParPtr(int tableID, int code, char *name, char *longname, char *units)
{
  int item, npars;

  npars = parTable[tableID].npars;

  for ( item = 0; item < npars; item++ )
    {
      if ( parTable[tableID].pars[item].id == code )
	{
	  name     = parTable[tableID].pars[item].name;
	  longname = parTable[tableID].pars[item].longname;
	  units    = parTable[tableID].pars[item].units;
	  break;
	}
    }
}

int parInqID(int tableID, int code)
{
  int item, npars;

  npars = parTable[tableID].npars;

  for ( item = 0; item < npars; item++ )
    {
      if ( parTable[tableID].pars[item].id == code ) break;
    }

  if ( item == npars ) item = -1;

  return (item);
}

int tableInqNumber(void)
{
  if ( ! ParTableInit ) parTableInit();

  return (parTableNum);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





/* IsBigendian returns 1 for big endian byte order */
static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};

#undef  IsBigendian
#define IsBigendian()  ( u_byteorder.c[sizeof(long) - 1] )

void cdiPrintDatatypes(void)
{
  fprintf (stderr, "+-------------+-------+\n"); 
  fprintf (stderr, "| types       | bytes |\n"); 
  fprintf (stderr, "+-------------+-------+\n"); 
  fprintf (stderr, "| void *      |   %3d |\n", (int) sizeof(void *));
  fprintf (stderr, "+-------------+-------+\n"); 
  fprintf (stderr, "| char        |   %3d |\n", (int) sizeof(char));
  fprintf (stderr, "+-------------+-------+\n"); 
  fprintf (stderr, "| short       |   %3d |\n", (int) sizeof(short));
  fprintf (stderr, "| int         |   %3d |\n", (int) sizeof(int));
  fprintf (stderr, "| long        |   %3d |\n", (int) sizeof(long));
  fprintf (stderr, "| long long   |   %3d |\n", (int) sizeof(long long));
  fprintf (stderr, "| size_t      |   %3d |\n", (int) sizeof(size_t));
  fprintf (stderr, "| off_t       |   %3d |\n", (int) sizeof(off_t));
  fprintf (stderr, "+-------------+-------+\n"); 
  fprintf (stderr, "| float       |   %3d |\n", (int) sizeof(float));
  fprintf (stderr, "| double      |   %3d |\n", (int) sizeof(double));
  fprintf (stderr, "| long double |   %3d |\n", (int) sizeof(long double));
  fprintf (stderr, "+-------------+-------+\n\n"); 
#define XSTRING(x)	#x
#define STRING(x)	XSTRING(x)
  fprintf (stderr, "+-------------+-----------+\n"); 
  fprintf (stderr, "| INT32       | %-9s |\n", STRING(INT32));
  fprintf (stderr, "| INT64       | %-9s |\n", STRING(INT64));
  fprintf (stderr, "| REAL4       | %-9s |\n", STRING(REAL4));
  fprintf (stderr, "| REAL8       | %-9s |\n", STRING(REAL8));
  fprintf (stderr, "+-------------+-----------+\n");

  if ( IsBigendian() )
    fprintf (stderr, "\n  byte ordering is BIGENDIAN\n\n");
  else
    fprintf (stderr, "\n  byte ordering is LITTLEENDIAN\n\n");
}

UINT32 get_UINT32(unsigned char *x)
{
  if ( IsBigendian() )
    return((UINT32)(((UINT32)x[0]<<24)+((UINT32)x[1]<<16)+((UINT32)x[2]<< 8)+ (UINT32)x[3]));
  else
    return((UINT32)(((UINT32)x[3]<<24)+((UINT32)x[2]<<16)+((UINT32)x[1]<< 8)+ (UINT32)x[0]));
}

UINT32 get_SUINT32(unsigned char *x)
{
  if ( IsBigendian() )
    return((UINT32)(((UINT32)x[3]<<24)+((UINT32)x[2]<<16)+((UINT32)x[1]<< 8)+ (UINT32)x[0]));
  else
    return((UINT32)(((UINT32)x[0]<<24)+((UINT32)x[1]<<16)+((UINT32)x[2]<< 8)+ (UINT32)x[3]));
}

UINT64 get_UINT64(unsigned char *x)
{
  if ( IsBigendian() )
    return((UINT64)(((UINT64)x[0]<<56)+((UINT64)x[1]<<48)+((UINT64)x[2]<<40)+((UINT64)x[3]<<32)+
		    ((UINT64)x[4]<<24)+((UINT64)x[5]<<16)+((UINT64)x[6]<< 8)+ (UINT64)x[7]));
  else
    return((UINT64)(((UINT64)x[7]<<56)+((UINT64)x[6]<<48)+((UINT64)x[5]<<40)+((UINT64)x[4]<<32)+
		    ((UINT64)x[3]<<24)+((UINT64)x[2]<<16)+((UINT64)x[1]<< 8)+ (UINT64)x[0]));
}

UINT64 get_SUINT64(unsigned char *x)
{
  if ( IsBigendian() )
    return((UINT64)(((UINT64)x[7]<<56)+((UINT64)x[6]<<48)+((UINT64)x[5]<<40)+((UINT64)x[4]<<32)+
		    ((UINT64)x[3]<<24)+((UINT64)x[2]<<16)+((UINT64)x[1]<< 8)+ (UINT64)x[0]));
  else
    return((UINT64)(((UINT64)x[0]<<56)+((UINT64)x[1]<<48)+((UINT64)x[2]<<40)+((UINT64)x[3]<<32)+
		    ((UINT64)x[4]<<24)+((UINT64)x[5]<<16)+((UINT64)x[6]<< 8)+ (UINT64)x[7]));
}

void gaussaw(double pa[], double pw[], int nlat)
{
  /*
   * Compute Gaussian latitudes.  On return pa contains the
   * sine of the latitudes starting closest to the north pole and going
   * toward the south
   *
   */

  const int itemax = 20;

  int isym, iter, ins2, jn, j;
  double za, zw, zan;
  double z, zk, zkm1, zkm2, zx, zxn, zldn, zmod;

  /*
   * Perform the Newton loop
   * Find 0 of Legendre polynomial with Newton loop
   */

  ins2 = nlat/2 + nlat%2;

  for ( j = 0; j < ins2; j++ )
    {
      z = (double) (4*(j+1)-1)*M_PI / (double) (4*nlat+2);
      pa[j] = cos(z + 1.0/(tan(z)*(double)(8*nlat*nlat)));
    }

  for ( j = 0; j < ins2; j++ )
    {

      za = pa[j];

      iter = 0;
      do
	{
	  iter++;
	  zk = 0.0;

	  /* Newton iteration step */

	  zkm2 = 1.0;
	  zkm1 = za;
	  zx = za;
	  for ( jn = 2; jn <= nlat; jn++ )
	    {
	      zk = ((double) (2*jn-1)*zx*zkm1-(double)(jn-1)*zkm2) / (double)(jn);
	      zkm2 = zkm1;
	      zkm1 = zk;
	    }
	  zkm1 = zkm2;
	  zldn = ((double) (nlat)*(zkm1-zx*zk)) / (1.-zx*zx);
	  zmod = -zk/zldn;
	  zxn = zx+zmod;
	  zan = zxn;

	  /* computes weight */

	  zkm2 = 1.0;
	  zkm1 = zxn;
	  zx = zxn;
	  for ( jn = 2; jn <= nlat; jn++ )
	    {
	      zk = ((double) (2*jn-1)*zx*zkm1-(double)(jn-1)*zkm2) / (double) (jn);
	      zkm2 = zkm1;
	      zkm1 = zk;
	    }
	  zkm1 = zkm2;
	  zw = (1.0-zx*zx) / ((double) (nlat*nlat)*zkm1*zkm1);
	  za = zan;
	}
      while ( iter <= itemax && fabs(zmod) >= DBL_EPSILON );

      pa[j] = zan;
      pw[j] = 2.0*zw;
    }

#if defined (SX)
#pragma vdir nodep
#endif
  for (j = 0; j < nlat/2; j++)
    {
      isym = nlat-(j+1);
      pa[isym] = -pa[j];
      pw[isym] =  pw[j];
    }

  return;
}

void globlons(int nlon, double lons[])
{
  int i;
  double dlon;

  dlon = 360. / nlon;
  lons [0] = 0.0;
  for (i = 1; i < nlon; i++)
    {
      lons[i] = lons[i-1] + dlon;
    }
}

void gausslats(int nlat, double lats[])
{
  static char func[] = "gausslats";
  int i;
  double *tmp;

  tmp = (double *) malloc(sizeof (double) * nlat);
  gaussaw (lats, tmp, nlat);
  free (tmp);

  for (i = 0; i < nlat; i++)
    {
      lats[i] = 180.*asin(lats[i])/M_PI;
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



#undef  UNDEFID
#define UNDEFID -1

static size_t Vctsize = 0;
static double *Vct = NULL;

typedef struct
{
  int      level1;
  int      level2;
  int      recID;
  int      lindex;
}
LEVELTABLE;

typedef struct
{
  int         code;
  int         prec;
  int         average;
  int         gridID;
  int         leveltype;
  int         lbounds;
  int         zaxisID;
  int         nlevels;
  int         levelTableSize;
  LEVELTABLE *levelTable;
  int         instID;
  int         modelID;
  int         tableID;
  int         codetable;
}
VARTABLE;

int vartableInit = 0;
VARTABLE *vartable;
static int varTablesize = 0;
int nvars = 0;

void codeInitEntry(int varID, int code)
{
  vartable[varID].code           = code;
  vartable[varID].prec           = 0;
  vartable[varID].average        = 0;
  vartable[varID].levelTable     = NULL;
  vartable[varID].levelTableSize = 0;
  vartable[varID].nlevels        = 0;
  vartable[varID].instID         = UNDEFID;
  vartable[varID].modelID        = UNDEFID;
  vartable[varID].tableID        = UNDEFID;
}

int varGetEntry(int code, int leveltype, int codetable)
{
  int varID;

  for ( varID = 0; varID < varTablesize; varID++ )
    {
      if ( vartable[varID].code      == code      &&
	   vartable[varID].leveltype == leveltype &&
	   vartable[varID].codetable == codetable )
	return (varID);
    }

  return (UNDEFID);
}

void varFree(void)
{
  static char func[] = "varFree";
  int varID;

  for ( varID = 0; varID < nvars; varID++ )
    {
      if ( vartable[varID].levelTable )
	free(vartable[varID].levelTable);
    }

  if ( vartable )
    free(vartable);

  vartable = NULL;
  varTablesize = 0;
  nvars = 0;

  if ( Vct )
    free(Vct);

  Vct = NULL;
  Vctsize = 0;
}

int levelNewEntry(int varID, int level1, int level2)
{
  static char func[] = "levelNewEntry";
  int levelID = 0;
  int levelTableSize, nlevels;
  LEVELTABLE *levelTable;

  nlevels        = vartable[varID].nlevels;
  levelTableSize = vartable[varID].levelTableSize;
  levelTable     = vartable[varID].levelTable;

  /*
    Look for a free slot in levelTable.
    (Create the table the first time through).
  */
  if ( ! levelTableSize )
    {
      int i;

      levelTableSize = 2;
      levelTable = (LEVELTABLE *) malloc(levelTableSize*sizeof(LEVELTABLE));
      if( levelTable == NULL )
	{
          Message(func, "levelTableSize = %d", levelTableSize);
	  SysError(func, "Allocation of LEVELTABLE failed");
	}

      for( i = 0; i < levelTableSize; i++ )
	levelTable[i].recID = UNDEFID;
    }
  else
    {
      while( levelID < levelTableSize )
	{
	  if ( levelTable[levelID].recID == UNDEFID ) break;
	  levelID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if( levelID == levelTableSize )
    {
      int i;

      levelTableSize = 2*levelTableSize;
      levelTable = (LEVELTABLE *) realloc(levelTable, levelTableSize*sizeof(LEVELTABLE));
      if( levelTable == NULL )
	{
          Message(func, "levelTableSize = %d", levelTableSize);
	  SysError(func, "Reallocation of LEVELTABLE failed");
	}
      levelID = levelTableSize/2;

      for( i = levelID; i < levelTableSize; i++ )
	levelTable[i].recID = UNDEFID;
    }

  levelTable[levelID].level1 = level1;
  levelTable[levelID].level2 = level2;
  levelTable[levelID].lindex = levelID;

  vartable[varID].nlevels = levelID+1;
  vartable[varID].levelTableSize = levelTableSize;
  vartable[varID].levelTable = levelTable;

  return (levelID);
}

int codeNewEntry (int code)
{
  static char func[] = "codeNewEntry";
  int varID = 0;

  /*
    Look for a free slot in vartable.
    (Create the table the first time through).
  */
  if ( ! varTablesize )
    {
      int i;

      varTablesize = 2;
      vartable = (VARTABLE *) malloc(varTablesize*sizeof(VARTABLE));
      if( vartable == NULL )
	{
          Message(func, "varTablesize = %d", varTablesize);
	  SysError(func, "Allocation of VARTABLE failed");
	}

      for( i = 0; i < varTablesize; i++ )
	vartable[i].code = 0;
    }
  else
    {
      while( varID < varTablesize )
	{
	  if ( vartable[varID].code == 0 ) break;
	  varID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if( varID == varTablesize )
    {
      int i;

      varTablesize = 2*varTablesize;
      vartable = (VARTABLE *) realloc(vartable, varTablesize*sizeof(VARTABLE));
      if( vartable == NULL )
	{
          Message(func, "varTablesize = %d", varTablesize);
	  SysError(func, "Reallocation of VARTABLE failed");
	}
      varID = varTablesize/2;

      for( i = varID; i < varTablesize; i++ )
	vartable[i].code = 0;
    }

  codeInitEntry(varID, code);

  return (varID);
}

void varAddRecord(int recID, int code, int gridID, int leveltype, int lbounds,
		  int level1, int level2, int prec, int *pvarID, int *plevelID,
		  int numavg, int codetable)
{
  static char func[] = "varAddRecord";
  int varID;
  int levelID = -1;

  varID = varGetEntry(code, leveltype, codetable);

  if ( varID == UNDEFID )
    {
      nvars++;
      varID = codeNewEntry(code);
      if ( prec > vartable[varID].prec ) vartable[varID].prec = prec;
      vartable[varID].gridID    = gridID;
      vartable[varID].leveltype = leveltype;
      vartable[varID].lbounds   = lbounds;
      if ( numavg ) vartable[varID].average = 1;
      vartable[varID].codetable = codetable;
    }
  else
    {
      if ( vartable[varID].gridID != gridID )
	{
	  Message(func, "code = %d gridID = %d", code, gridID);
	  Error(func, "horizontal grid must not change for same code");
	}
      if ( vartable[varID].leveltype != leveltype )
	{
	  Message(func, "code = %d leveltype = %d", code, leveltype);
	  Error(func, "leveltype must not change for same code");
	}
    }

  levelID = levelNewEntry(varID, level1, level2);
  vartable[varID].levelTable[levelID].recID = recID;

  if ( CDI_Debug )
    Message(func, "varID = %d  levelID = %d", varID, levelID);

  *pvarID   = varID;
  *plevelID = levelID;
}

int dblcmp(const void *s1, const void *s2)
{
  int cmp = 0;

  if      ( *((double *) s1) < *((double *) s2) ) cmp = -1;
  else if ( *((double *) s1) > *((double *) s2) ) cmp =  1;

  return (cmp);
}


int cmpLevelTable(const void *s1, const void *s2)
{
  int cmp = 0;
  LEVELTABLE *x = (LEVELTABLE *) s1;
  LEVELTABLE *y = (LEVELTABLE *) s2;
  /*
  printf("%g %g  %d %d\n", x->leve11, y->level1, x, y);
  */
  if      ( x->level1 < y->level1 ) cmp = -1;
  else if ( x->level1 > y->level1 ) cmp =  1;

  return (cmp);
}

void cdiGenVars(int streamID)
{
  static char func[] = "cdiGenVars";
  int varID, gridID, zaxisID, levelID;
  int instID, modelID, tableID;
  int code, nlevels, leveltype, lindex;
  int prec;
  int average;
  int lbounds;
  char name[256], longname[256], units[256];
  double *dlevels = NULL;
  double *dlevels1 = NULL;
  double *dlevels2 = NULL;
  int vlistID;

  vlistID =  streamInqVlist(streamID);

  for ( varID = 0; varID < nvars; varID++ )
    {
      gridID    = vartable[varID].gridID;
      code      = vartable[varID].code;
      nlevels   = vartable[varID].nlevels;
      leveltype = vartable[varID].leveltype;
      if ( leveltype == ZAXIS_GENERIC && cdiDefaultLeveltype != -1 )
	leveltype = cdiDefaultLeveltype;
      lbounds   = vartable[varID].lbounds;
      prec      = vartable[varID].prec;
      instID    = vartable[varID].instID;
      modelID   = vartable[varID].modelID;
      tableID   = vartable[varID].tableID;
      average   = vartable[varID].average;

      zaxisID = UNDEFID;

      if ( nlevels == 1 && ! fabs(vartable[varID].levelTable[0].level1) )
	leveltype = ZAXIS_SURFACE;

      dlevels = (double *) malloc(nlevels*sizeof(double));

      if ( lbounds && leveltype != ZAXIS_HYBRID && leveltype != ZAXIS_HYBRID_HALF )
	for ( levelID = 0; levelID < nlevels; levelID++ )
	  dlevels[levelID] = (vartable[varID].levelTable[levelID].level1 +
	                      vartable[varID].levelTable[levelID].level2)/2;
      else
	for ( levelID = 0; levelID < nlevels; levelID++ )
	  dlevels[levelID] = vartable[varID].levelTable[levelID].level1;

      if ( nlevels > 1 )
	{
	  int linc = FALSE, ldec = FALSE;
	  /* check increasing of levels */
	  for ( levelID = 1; levelID < nlevels; levelID++ )
	    if ( dlevels[levelID] < dlevels[levelID-1] ) break;

	  if ( levelID == nlevels ) linc = TRUE;

	  if ( linc == FALSE )
	    {
	      /* check decreasing of levels */
	      for ( levelID = 1; levelID < nlevels; levelID++ )
		if ( dlevels[levelID] > dlevels[levelID-1] ) break;

	      if ( levelID == nlevels ) ldec = TRUE;

	      if ( ldec == FALSE ||
		   leveltype == ZAXIS_HYBRID ||
		   leveltype == ZAXIS_DEPTH_BELOW_LAND )
		{
		  /*
		  qsort(dlevels, nlevels, sizeof(double), dblcmp);
		  */
		  qsort(vartable[varID].levelTable, nlevels, 
			sizeof(LEVELTABLE), cmpLevelTable);

		  if ( lbounds && leveltype != ZAXIS_HYBRID && leveltype != ZAXIS_HYBRID_HALF )
		    for ( levelID = 0; levelID < nlevels; levelID++ )
		      dlevels[levelID] = (vartable[varID].levelTable[levelID].level1 +
					  vartable[varID].levelTable[levelID].level2)/2.;
		  else
		    for ( levelID = 0; levelID < nlevels; levelID++ )
		      dlevels[levelID] = vartable[varID].levelTable[levelID].level1;
		}
	    }
	}

      if ( lbounds )
	{
	  dlevels1 = (double *) malloc(nlevels*sizeof(double));
	  for ( levelID = 0; levelID < nlevels; levelID++ )
	    dlevels1[levelID] = vartable[varID].levelTable[levelID].level1;
	  dlevels2 = (double *) malloc(nlevels*sizeof(double));
	  for ( levelID = 0; levelID < nlevels; levelID++ )
	    dlevels2[levelID] = vartable[varID].levelTable[levelID].level2;
	}

      zaxisID = varDefZaxis(vlistID, leveltype, nlevels, dlevels, lbounds, dlevels1, dlevels2,
			    Vctsize, Vct, NULL, NULL, NULL, 0, 0);

      if ( lbounds ) free(dlevels1);
      if ( lbounds ) free(dlevels2);
      free(dlevels);

      varID = streamNewVar(streamID, gridID, zaxisID);
      varID = vlistDefVar(vlistID, gridID, zaxisID, TIME_VARIABLE);

      vlistDefVarCode(vlistID, varID, code);
      vlistDefVarDatatype(vlistID, varID, prec);
      vlistDefVarAverage(vlistID, varID, average);

      if ( cdiDefaultTableID != UNDEFID )
	{
	  if ( tableInqParNamePtr(cdiDefaultTableID, code) )
	    {
	      if ( tableID != UNDEFID )
		{
		  size_t len;
		  len = strlen(tableInqParNamePtr(cdiDefaultTableID, code));
		  strcpy(name, tableInqParNamePtr(cdiDefaultTableID, code));
		  vlistDefVarName(vlistID, varID, name);
		  if ( tableInqParLongnamePtr(cdiDefaultTableID, code) )
		    {
		      len = strlen(tableInqParLongnamePtr(cdiDefaultTableID, code));
		      strcpy(longname, tableInqParLongnamePtr(cdiDefaultTableID, code));
		      vlistDefVarLongname(vlistID, varID, longname);
		    }
		  if ( tableInqParUnitsPtr(cdiDefaultTableID, code) )
		    {
		      len = strlen(tableInqParUnitsPtr(cdiDefaultTableID, code));
		      strcpy(units, tableInqParUnitsPtr(cdiDefaultTableID, code));
		      vlistDefVarUnits(vlistID, varID, units);
		    }
		}
	      else
		tableID = cdiDefaultTableID;
	    }
	  if ( cdiDefaultModelID != UNDEFID ) modelID = cdiDefaultModelID;
	  if ( cdiDefaultInstID  != UNDEFID )  instID = cdiDefaultInstID;
	}

      if ( instID  != UNDEFID ) vlistDefVarInstitut(vlistID, varID, instID);
      if ( modelID != UNDEFID ) vlistDefVarModel(vlistID, varID, modelID);
      if ( tableID != UNDEFID ) vlistDefVarTable(vlistID, varID, tableID);
    }

  for ( varID = 0; varID < nvars; varID++ )
    {
      nlevels   = vartable[varID].nlevels;
      /*
      for ( levelID = 0; levelID < nlevels; levelID++ )
	{
	  lindex = vartable[varID].levelTable[levelID].lindex;
	  printf("%d %d %d %d %d\n", varID, levelID, 
		 vartable[varID].levelTable[levelID].lindex,
		 vartable[varID].levelTable[levelID].recID,
		 vartable[varID].levelTable[levelID].level1);
	}
      */
      for ( levelID = 0; levelID < nlevels; levelID++ )
	{
	  streams[streamID].vars[varID].level[levelID] =
	    vartable[varID].levelTable[levelID].recID;
	  for ( lindex = 0; lindex < nlevels; lindex++ )
	    if ( levelID == vartable[varID].levelTable[lindex].lindex ) break;

	  if ( lindex == nlevels )
	    Error(func, "Internal problem! lindex not found.");

	  streams[streamID].vars[varID].lindex[levelID] = lindex;
	}
    }

  varFree();
}

void varDefVCT(size_t vctsize, double *vctptr)
{
  static char func[] = "varDefVCT";

  if ( Vct == NULL && vctptr != NULL && vctsize > 0 )
    {
      Vctsize = vctsize;
      Vct = (double *) malloc(vctsize*sizeof(double));
      memcpy(Vct, vctptr, vctsize*sizeof(double)); 
    }
}

int varDefGrid(int vlistID, GRID grid, int mode)
{
  /*
    mode: 0 search in vlist and grid table
          1 search in grid table
   */
  static char func[] = "varDefGrid";
  int gridglobdefined = 0;
  int griddefined;
  int ngrids;
  int gridID = UNDEFID;
  int index;

  griddefined = 0;
  ngrids = vlist[vlistID].ngrids;

  if ( mode == 0 )
    for ( index = 0; index < ngrids; index++ )
      {
	gridID = vlist[vlistID].gridIDs[index];
	if ( gridID == UNDEFID )
	  Error(func, "undefined gridID %d", gridID);

	if ( gridCompare(gridID, grid) == 0 )
	  {
	    griddefined = 1;
	    break;
	  }
      }

  if ( ! griddefined )
    {
      ngrids = gridSize();
      for ( gridID = 0; gridID < ngrids; gridID++ )
	{
	  if ( gridCompare(gridID, grid) == 0 )
	    {
	      gridglobdefined = 1;
	      break;
	    }
	}

      ngrids = vlist[vlistID].ngrids;
      if ( mode == 1 )
	for ( index = 0; index < ngrids; index++ )
	  if ( vlist[vlistID].gridIDs[index] == gridID )
	    {
	      gridglobdefined = FALSE;
	      break;
	    }
    }

  if ( ! griddefined )
    {
      if ( ! gridglobdefined ) gridID = gridGenerate(grid);
      ngrids = vlist[vlistID].ngrids;
      vlist[vlistID].gridIDs[ngrids] = gridID;
      vlist[vlistID].ngrids++;
    }

  return (gridID);
}


int zaxisCompare(int zaxisID, int leveltype, int nlevels, double *levels, char *longname, char *units)
{
  int differ = 1;
  int levelID;

  if ( leveltype == zaxisInqType(zaxisID) || leveltype == ZAXIS_GENERIC )
    {
      if ( nlevels == zaxisInqSize(zaxisID) )
	{
	  const double *dlevels;
	  char zlongname[256];
	  char zunits[256];
	  
	  dlevels = zaxisInqLevelsPtr(zaxisID);
	  for ( levelID = 0; levelID < nlevels; levelID++ )
	    {
	      if ( fabs(dlevels[levelID] - levels[levelID]) )
		break;
	    }

	  if ( levelID == nlevels ) differ = 0;

	  if ( ! differ )
	    {
	      zaxisInqLongname(zaxisID, zlongname);
	      zaxisInqUnits(zaxisID, zunits);
	      if ( longname && zlongname[0] )
		{
		  if ( strcmp(longname, zlongname) != 0 ) differ = 1;
		}
	      if ( units && zunits[0] )
		{
		  if ( strcmp(units, zunits) != 0 ) differ = 1;
		}
	    }
	}
    }

  return (differ);
}


int varDefZaxis(int vlistID, int leveltype, int nlevels, double *levels, int lbounds, double *levels1, double *levels2,
		int vctsize, double *vct, char *name, char *longname, char *units, int prec, int mode)
{
  /*
    mode: 0 search in vlist and zaxis table
          1 search in zaxis table
   */
  static char func[] = "varDefZaxis";
  int zaxisdefined;
  int nzaxis;
  int zaxisID = UNDEFID;
  int index;
  int zaxisglobdefined = 0;

  zaxisdefined = 0;
  nzaxis = vlist[vlistID].nzaxis;

  if ( mode == 0 )
    for ( index = 0; index < nzaxis; index++ )
      {
	zaxisID = vlist[vlistID].zaxisIDs[index];

	if ( zaxisCompare(zaxisID, leveltype, nlevels, levels, longname, units) == 0 )
	  {
	    zaxisdefined = 1;
	    break;
	  }
      }

  if ( ! zaxisdefined )
    {
      nzaxis = zaxisSize();
      for ( zaxisID = 0; zaxisID < nzaxis; zaxisID++ )
	if ( zaxisCompare(zaxisID, leveltype, nlevels, levels, longname, units) == 0 )
	  {
	    zaxisglobdefined = 1;
	    break;
	  }

      nzaxis = vlist[vlistID].nzaxis;
      if ( mode == 1 )
	for ( index = 0; index < nzaxis; index++ )
	  if ( vlist[vlistID].zaxisIDs[index] == zaxisID )
	    {
	      zaxisglobdefined = FALSE;
	      break;
	    }
    }

  if ( ! zaxisdefined )
    {
      if ( ! zaxisglobdefined )
	{
	  zaxisID = zaxisNew(leveltype, nlevels);
	  zaxisDefLevels(zaxisID, levels);
	  if ( lbounds ) zaxisDefBounds(zaxisID, nlevels, levels1, levels2);

	  if ( leveltype == ZAXIS_HYBRID )
	    {
	      if ( vctsize > 0 )
		zaxisDefVct(zaxisID, vctsize, vct);
	      else
		Warning(func, "VCT missing");
	    }

	  zaxisDefName(zaxisID, name);
	  zaxisDefLongname(zaxisID, longname);
	  zaxisDefUnits(zaxisID, units);
	  zaxisDefPrec(zaxisID, prec);
	}

      nzaxis = vlist[vlistID].nzaxis;
      vlist[vlistID].zaxisIDs[nzaxis] = zaxisID;
      vlist[vlistID].nzaxis++;
    }

  return (zaxisID);
}

int varInqInst(int varID)
{
  return (vartable[varID].instID);
}

void varDefInst(int varID, int instID)
{
  vartable[varID].instID = instID;
}

int varInqModel(int varID)
{
  return (vartable[varID].modelID);
}

void varDefModel(int varID, int modelID)
{
  vartable[varID].modelID = modelID;
}

int varInqTable(int varID)
{
  return (vartable[varID].tableID);
}

void varDefTable(int varID, int tableID)
{
  vartable[varID].tableID = tableID;
}



VLIST *vlist = NULL;
static int vlistSize = 0;


void vlistCheckID(const char *func, int vlistID)
{
  if ( vlistID < 0 || vlistID >= vlistSize )
    Error(func, "vlistID %d undefined!", vlistID);
}


void vlistInitEntry(int vlistID)
{
  static char func[] = "vlistInitEntry";

  if ( vlistID < 0 || vlistID >= vlistSize )
    Error(func, "vlistID %d undefined!", vlistID);

  vlist[vlistID].used           = 0;
  vlist[vlistID].nlock          = 0;
  vlist[vlistID].nvars          = 0;
  vlist[vlistID].vars           = NULL;
  vlist[vlistID].ngrids         = 0;
  vlist[vlistID].nzaxis         = 0;
  vlist[vlistID].taxisID        = CDI_UNDEFID; 
  vlist[vlistID].instID         = cdiDefaultInstID;
  vlist[vlistID].modelID        = cdiDefaultModelID;
  vlist[vlistID].tableID        = cdiDefaultTableID;
  vlist[vlistID].varsAllocated  = 0;
  vlist[vlistID].natts          = 0;
  vlist[vlistID].ntsteps        = CDI_UNDEFID;
}


/*
@Function  vlistNew
@Title     Create a variable list

@Prototype int vlistNew(void)

@EndFunction
*/
int vlistNew(void)
{
  static char func[] = "vlistNew";
  int vlistMax = 1024;
  int vlistID = 0;

  /*
    Look for a free slot in vlist.
    (Create the table the first time through).
  */
  if ( ! vlistSize )
    {
      int i;

      vlistSize = 2;
      vlist = (VLIST *) malloc(vlistSize*sizeof(VLIST));
      if( vlist == NULL )
	{
          Message(func, "vlistSize = %d", vlistSize);
	  SysError(func, "Allocation of VLIST failed");
	}

      for( i = 0; i < vlistSize; i++ )
	vlistInitEntry(i);
    }
  else
    {
      while( vlistID < vlistSize )
	{
	  if ( ! vlist[vlistID].used ) break;
	  vlistID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if( vlistID == vlistSize )
    {
      int i;

      if ( vlistSize == vlistMax )
	Error(func, "SINFO maximum table size of %d reached", vlistMax);

      vlistSize = 2*vlistSize;
      vlist = (VLIST *) realloc(vlist, vlistSize*sizeof(VLIST));
      if( vlist == NULL )
	{
          Message(func, "vlistSize = %d", vlistSize);
	  SysError(func, "Reallocation of VLIST failed");
	}
      vlistID = vlistSize/2;

      for( i = vlistID; i < vlistSize; i++ )
	vlistInitEntry(i);
    }

  vlistInitEntry(vlistID);

  vlist[vlistID].used = 1;
  vlistLock(vlistID);

  return (vlistID);
}


/*
@Function  vlistFree
@Title     Delete a variable list

@Prototype void vlistFree(int vlistID)
@Parameter
    @Item  vlistID Identifier, from a previous call to {\tt vlistNew}

@EndFunction
*/
void vlistFree(int vlistID)
{
  static char func[] = "vlistFree";

  vlistCheckID(func, vlistID);

  vlistUnlock(vlistID);

  if ( vlist[vlistID].nlock > 0 )
    {
      Warning(func, "vlist %d is locked!", vlistID);
    }
  else
    {
      int nvars = vlist[vlistID].nvars;
      int varID, attID;

      for ( attID = 0; attID < vlist[vlistID].natts; attID++ )
	{
	  free(vlist[vlistID].attnames[attID]);

	  if ( vlist[vlistID].attstrings[attID] )
	    free(vlist[vlistID].attstrings[attID]);
	}

      for ( varID = 0; varID < nvars; varID++ )
	if ( vlist[vlistID].vars[varID].levinfo ) free(vlist[vlistID].vars[varID].levinfo);

      if ( vlist[vlistID].vars ) free(vlist[vlistID].vars);

      vlist[vlistID].used = FALSE;
    }
}

int vlistNlock(int vlistID)
{
  static char func[] = "vlistNlock";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].nlock);
}

void vlistLock(int vlistID)
{
  static char func[] = "vlistLock";

  vlistCheckID(func, vlistID);

  vlist[vlistID].nlock++;
  /*  Message(func, "vlistID %d nlock %d", vlistID, vlist[vlistID].nlock); */
}

void vlistUnlock(int vlistID)
{
  static char func[] = "vlistUnlock";

  vlistCheckID(func, vlistID);

  vlist[vlistID].nlock--;
  /*  Message(func, "vlistID %d nlock %d", vlistID, vlist[vlistID].nlock); */
}


/*
@Function  vlistCopy
@Title     Copy a variable list

@Prototype void vlistCopy(int vlistID2, int vlistID1)
@Parameter
    @Item  vlistID2 Target variable list
    @Item  vlistID1 Source variable list

@Description
The {\tt vlistCopy} function copies all entries from vlistID1 to vlistID2.

@EndFunction
*/
void vlistCopy(int vlistID2, int vlistID1)
{
  static char func[] = "vlistCopy";
  int attID;

  vlistCheckID(func, vlistID1);
  vlistCheckID(func, vlistID2);

  memcpy(&vlist[vlistID2], &vlist[vlistID1], sizeof(VLIST));
  
  for ( attID = 0; attID < vlist[vlistID1].natts; attID++ )
    {
      vlist[vlistID2].attnames[attID] = strdup(vlist[vlistID1].attnames[attID]);

      if ( vlist[vlistID1].attstrings[attID] )
	vlist[vlistID2].attstrings[attID] = strdup(vlist[vlistID1].attstrings[attID]);
      else
	vlist[vlistID2].attstrings[attID] = NULL;
    }

  if ( vlist[vlistID1].vars )
    {
      int nvars = vlist[vlistID1].nvars;
      int nlevs, varID;

      vlist[vlistID2].vars = (VARINFO *) malloc(nvars*sizeof(VARINFO));
      memcpy(vlist[vlistID2].vars, vlist[vlistID1].vars, nvars*sizeof(VARINFO));

      for ( varID = 0; varID < nvars; varID++ )
	{
	  if ( vlist[vlistID1].vars[varID].name )
	    vlist[vlistID2].vars[varID].name = strdup(vlist[vlistID1].vars[varID].name);

	  if ( vlist[vlistID1].vars[varID].longname )
	    vlist[vlistID2].vars[varID].longname = strdup(vlist[vlistID1].vars[varID].longname);

	  if ( vlist[vlistID1].vars[varID].units )
	    vlist[vlistID2].vars[varID].units = strdup(vlist[vlistID1].vars[varID].units);

	  nlevs = vlist[vlistID1].vars[varID].nlevs;
	  vlist[vlistID2].vars[varID].levinfo = (LEVINFO *) malloc(nlevs*sizeof(LEVINFO));
	  memcpy(vlist[vlistID2].vars[varID].levinfo,
		 vlist[vlistID1].vars[varID].levinfo, nlevs*sizeof(LEVINFO));
	}
    }

  vlist[vlistID2].nlock = 0;
}


/*
@Function  vlistDuplicate
@Title     Duplicate a variable list

@Prototype int vlistDuplicate(int vlistID)
@Parameter
    @Item  vlistID Variable list identifier

@Description
The {\tt vlistDuplicate} function duplicate the variable list from vlistID1.

@Result
{\tt vlistDuplicate} return an identifier to the duplicated variable list.

@EndFunction
*/
int vlistDuplicate(int vlistID)
{
  static char func[] = "vlistDuplicate";
  int vlistIDnew;

  vlistCheckID(func, vlistID);

  vlistIDnew = vlistNew();

  vlistCopy(vlistIDnew, vlistID);

  return (vlistIDnew);
}


void vlistClearFlag(int vlistID)
{
  int varID, levID;

  for ( varID = 0; varID < vlist[vlistID].nvars; varID++ )
    {
      vlist[vlistID].vars[varID].flag = FALSE;
      for ( levID = 0; levID < vlist[vlistID].vars[varID].nlevs; levID++ )
	{
	  vlist[vlistID].vars[varID].levinfo[levID].flag = FALSE;
	}
    }
}


int vlistInqZaxis(int vlistID, int leveltype, int nlevels, double *levels, int lbounds, double *levels2,
		  int vctsize, const double *vct)
{
  static char func[] = "vlistInqZaxis";
  int zaxisdefined;
  int nzaxis;
  int zaxisID = CDI_UNDEFID;
  int index;
  int zaxisglobdefined = 0;

  vlistCheckID(func, vlistID);

  zaxisdefined = 0;
  nzaxis = vlist[vlistID].nzaxis;

  for ( index = 0; index < nzaxis; index++ )
    {
      zaxisID = vlist[vlistID].zaxisIDs[index];

      if ( zaxisCompare(zaxisID, leveltype, nlevels, levels, NULL, NULL) == 0 )
	{
	  zaxisdefined = 1;
	  break;
	}
    }

  if ( ! zaxisdefined )
    {
      nzaxis = zaxisSize();
      for ( zaxisID = 0; zaxisID < nzaxis; zaxisID++ )
	if ( zaxisCompare(zaxisID, leveltype, nlevels, levels, NULL, NULL) == 0 )
	  {
	    zaxisglobdefined = 1;
	    break;
	  }
    }

  if ( ! zaxisdefined )
    {
      if ( ! zaxisglobdefined )
	{
	  zaxisID = zaxisNew(leveltype, nlevels);
	  zaxisDefLevels(zaxisID, levels);
	  if ( lbounds ) zaxisDefBounds(zaxisID, nlevels, levels, levels2);

	  if ( leveltype == ZAXIS_HYBRID )
	    {
	      if ( vctsize > 0 )
		zaxisDefVct(zaxisID, vctsize, vct);
	      else
		Warning(func, "VCT missing");
	    }
	}

      nzaxis = vlist[vlistID].nzaxis;
      vlist[vlistID].zaxisIDs[nzaxis] = zaxisID;
      vlist[vlistID].nzaxis++;
    }

  return (zaxisID);
}


/*
@Function  vlistCopyFlag
@Title     Copy some entries of a variable list

@Prototype void vlistCopyFlag(int vlistID2, int vlistID1)
@Parameter
    @Item  vlistID2 Target variable list
    @Item  vlistID1 Source variable list

@Description
The {\tt vlistCopyFlag} function copies all entries with a flag from vlistID1 to vlistID2.

@EndFunction
*/
void vlistCopyFlag(int vlistID2, int vlistID1)
{
  static char func[] = "vlistCopyFlag";
  int attID;

  vlistCheckID(func, vlistID1);
  vlistCheckID(func, vlistID2);

  memcpy(&vlist[vlistID2], &vlist[vlistID1], sizeof(VLIST));
  
  for ( attID = 0; attID < vlist[vlistID1].natts; attID++ )
    {
      vlist[vlistID2].attnames[attID] = strdup(vlist[vlistID1].attnames[attID]);

      if ( vlist[vlistID1].attstrings[attID] )
	vlist[vlistID2].attstrings[attID] = strdup(vlist[vlistID1].attstrings[attID]);
      else
	vlist[vlistID2].attstrings[attID] = NULL;
    }

  if ( vlist[vlistID1].vars )
    {
      int nvars = vlist[vlistID1].nvars;
      int nvars2 = 0, levID2;
      int nlevs, nlevs2, levID, varID, varID2;
      int gridID, zaxisID;
      int index;

      vlist[vlistID2].ngrids = 0;
      vlist[vlistID2].nzaxis = 0;

      for ( varID = 0; varID < nvars; varID++ )
	if ( vlist[vlistID1].vars[varID].flag ) nvars2++;

      vlist[vlistID2].nvars = nvars2;
      vlist[vlistID2].vars  = (VARINFO *) malloc(nvars2*sizeof(VARINFO));

      varID2 = 0;
      for ( varID = 0; varID < nvars; varID++ )
	if ( vlist[vlistID1].vars[varID].flag )
	  {
	    vlist[vlistID2].vars[varID2].flag = FALSE;
	    zaxisID = vlist[vlistID1].vars[varID].zaxisID;
	    gridID  = vlist[vlistID1].vars[varID].gridID;

	    memcpy(&vlist[vlistID2].vars[varID2], &vlist[vlistID1].vars[varID], sizeof(VARINFO));

	    vlist[vlistID1].vars[varID].fvarID = varID2;
	    vlist[vlistID2].vars[varID2].fvarID = varID;

	    if ( vlist[vlistID1].vars[varID].name )
	      vlist[vlistID2].vars[varID2].name = strdup(vlist[vlistID1].vars[varID].name);

	    if ( vlist[vlistID1].vars[varID].longname )
	      vlist[vlistID2].vars[varID2].longname = strdup(vlist[vlistID1].vars[varID].longname);

	    if ( vlist[vlistID1].vars[varID].units )
	      vlist[vlistID2].vars[varID2].units = strdup(vlist[vlistID1].vars[varID].units);

	    nlevs  = vlist[vlistID1].vars[varID].nlevs;
	    nlevs2 = 0;
	    for ( levID = 0; levID < nlevs; levID++ )
	      if ( vlist[vlistID1].vars[varID].levinfo[levID].flag ) nlevs2++;

	    vlist[vlistID2].vars[varID2].levinfo = (LEVINFO *) malloc(nlevs2*sizeof(LEVINFO));

	    if ( nlevs != nlevs2 )
	      {
		int zaxisType;
		int zaxisID2;
		int nvct = 0;
		int lbounds;
		double *levels;
		double *levels2;
		const double *vct = NULL;

		zaxisID = vlist[vlistID1].vars[varID].zaxisID;
		levels = (double *) malloc(nlevs2*sizeof(double));
		levID2 = 0;
		for ( levID = 0; levID < nlevs; levID++ )
		  if ( vlist[vlistID1].vars[varID].levinfo[levID].flag )
		    {
		      vlist[vlistID1].vars[varID].levinfo[levID].flevelID = levID2;
		      levels[levID2++] = zaxisInqLevel(zaxisID, levID);
		    }

		zaxisType = zaxisInqType(zaxisID);

		if ( zaxisType == ZAXIS_HYBRID )
		  {
		    nvct = zaxisInqVctSize(zaxisID);
		    vct  = zaxisInqVctPtr(zaxisID);
		  }
		lbounds = 0;     /* <------------ have to define */
		levels2 = NULL;  /* <------------ have to define */
		zaxisID2 = vlistInqZaxis(vlistID2, zaxisType, nlevs2, levels, lbounds, levels2, nvct, vct);

		free(levels);
		zaxisID = zaxisID2;
		vlist[vlistID2].vars[varID2].zaxisID = zaxisID2;
		vlist[vlistID2].vars[varID2].nlevs   = nlevs2;
	      }

	    for ( levID = 0; levID < nlevs2; levID++ )
	      {
		vlist[vlistID2].vars[varID2].levinfo[levID].flag  = FALSE;
		vlist[vlistID2].vars[varID2].levinfo[levID].index = -1;
	      }

	    levID2 = 0;
	    for ( levID = 0; levID < nlevs; levID++ )
	      if ( vlist[vlistID1].vars[varID].levinfo[levID].flag )
		vlist[vlistID2].vars[varID2].levinfo[levID2++].flevelID = levID;

	    for ( index = 0; index < vlist[vlistID2].ngrids; index++ )
	      if ( vlist[vlistID2].gridIDs[index] == gridID ) break;

	    if ( index == vlist[vlistID2].ngrids )
	      {
		vlist[vlistID2].gridIDs[vlist[vlistID2].ngrids++] = gridID;
		if ( vlist[vlistID2].ngrids >= MAX_GRIDS )
		  Error(func, "Internal Problem! More than %d grids.", MAX_GRIDS);
	      }

	    for ( index = 0; index < vlist[vlistID2].nzaxis; index++ )
	      if ( vlist[vlistID2].zaxisIDs[index] == zaxisID ) break;

	    if ( index == vlist[vlistID2].nzaxis )
	      {
		vlist[vlistID2].zaxisIDs[vlist[vlistID2].nzaxis++] = zaxisID;
		if ( vlist[vlistID2].nzaxis >= MAX_ZAXIS )
		  Error(func, "Internal Problem! More than %d zaxis.", MAX_ZAXIS);
	      }

	    varID2++;
	  }
    }
}


/*
@Function  vlistCat
@Title     Concatenate two variable lists

@Prototype void vlistCat(int vlistID2, int vlistID1)
@Parameter
    @Item  vlistID2 Target variable list
    @Item  vlistID1 Source variable list

@Description
Concatenate the variable list vlistID1 at the end of vlistID2.

@EndFunction
*/
void vlistCat(int vlistID2, int vlistID1)
{
  static char func[] = "vlistCat";
  int nvars, nvars1, nvars2;
  int varID, varID2, nlevs;
  int index, gridID, zaxisID;

  vlistCheckID(func, vlistID1);
  vlistCheckID(func, vlistID2);

  nvars1 = vlist[vlistID1].nvars;
  nvars2 = vlist[vlistID2].nvars;
  nvars = nvars1 + nvars2;
  vlist[vlistID2].nvars = nvars;

  vlist[vlistID2].vars = (VARINFO *) realloc(vlist[vlistID2].vars, nvars*sizeof(VARINFO));
  memcpy(vlist[vlistID2].vars+nvars2, vlist[vlistID1].vars, nvars1*sizeof(VARINFO));

  for ( varID = 0; varID < nvars1; varID++ )
    {
      varID2 = varID + nvars2;
      vlist[vlistID1].vars[varID].fvarID = varID2;
      vlist[vlistID2].vars[varID2].fvarID = varID;

      if ( vlist[vlistID1].vars[varID].name )
	vlist[vlistID2].vars[varID2].name = strdup(vlist[vlistID1].vars[varID].name);

      if ( vlist[vlistID1].vars[varID].longname )
	vlist[vlistID2].vars[varID2].longname = strdup(vlist[vlistID1].vars[varID].longname);

      if ( vlist[vlistID1].vars[varID].units )
	vlist[vlistID2].vars[varID2].units = strdup(vlist[vlistID1].vars[varID].units);

      nlevs = vlist[vlistID1].vars[varID].nlevs;
      vlist[vlistID2].vars[varID2].levinfo = (LEVINFO *) malloc(nlevs*sizeof(LEVINFO));
      memcpy(vlist[vlistID2].vars[varID2].levinfo, vlist[vlistID1].vars[varID].levinfo, nlevs*sizeof(LEVINFO));

      gridID = vlist[vlistID1].vars[varID].gridID;
      for ( index = 0; index < vlist[vlistID2].ngrids; index++ )
	if ( gridID == vlist[vlistID2].gridIDs[index] ) break;

      if ( index == vlist[vlistID2].ngrids )
	{
	  vlist[vlistID2].gridIDs[vlist[vlistID2].ngrids++] = gridID;
	  if ( vlist[vlistID2].ngrids >= MAX_GRIDS )
	    Error(func, "Internal Problem! More than %d grids.", MAX_GRIDS);
	}

      zaxisID = vlist[vlistID1].vars[varID].zaxisID;
      for ( index = 0; index < vlist[vlistID2].nzaxis; index++ )
	if ( zaxisID == vlist[vlistID2].zaxisIDs[index] ) break;

      if ( index == vlist[vlistID2].nzaxis )
	{
	  vlist[vlistID2].zaxisIDs[vlist[vlistID2].nzaxis++] = zaxisID;
	  if ( vlist[vlistID2].nzaxis >= MAX_ZAXIS )
	    Error(func, "Internal Problem! More than %d zaxis.", MAX_ZAXIS);
	}
    }
}


/*
@Function  vlistMerge
@Title     Merge two variable lists

@Prototype void vlistMerge(int vlistID2, int vlistID1)
@Parameter
    @Item  vlistID2 Target variable list
    @Item  vlistID1 Source variable list

@Description
Merge the variable list vlistID1 and the variable list vlistID2.

@EndFunction
*/
void vlistMerge(int vlistID2, int vlistID1)
{
  static char func[] = "vlistMerge";
  int nvars, nvars1, nvars2;
  int varID = 0, varID2, levID, nlevs, nlevs1, nlevs2;
  int index, zaxisID;
  int zaxisID1, zaxisID2;
  int *lvar;
  double *levels;

  vlistCheckID(func, vlistID1);
  vlistCheckID(func, vlistID2);

  nvars1 = vlist[vlistID1].nvars;
  nvars2 = vlist[vlistID2].nvars;

  if ( nvars1 == nvars2 )
    {
      for ( varID = 0; varID < nvars2; varID++ )
	{
	  if ( vlist[vlistID1].vars[varID].name && vlist[vlistID2].vars[varID].name )
	    {
	      if ( strcmp(vlist[vlistID1].vars[varID].name,
			  vlist[vlistID2].vars[varID].name) != 0 ) break;
	    }
	  else
	    {
	      if ( vlist[vlistID1].vars[varID].code == vlist[vlistID2].vars[varID].code )
		break;
	    }
	}
    }

  if ( varID == nvars2 ) /* same variables in vlistID1 and vlistID2 */
    {
      for ( varID = 0; varID < nvars2; varID++ )
	{
	  vlist[vlistID1].vars[varID].fvarID = varID;
	  vlist[vlistID2].vars[varID].fvarID = varID;

	  nlevs1 = vlist[vlistID1].vars[varID].nlevs;
	  nlevs2 = vlist[vlistID2].vars[varID].nlevs;

	  nlevs = nlevs1 + nlevs2;

	  vlist[vlistID2].vars[varID].nlevs = nlevs;

	  printf("var %d %d %d %d\n", varID, nlevs1, nlevs2, nlevs);

	  vlist[vlistID2].vars[varID].levinfo =
	    (LEVINFO *) realloc(vlist[vlistID2].vars[varID].levinfo, nlevs*sizeof(LEVINFO));

	  memcpy(vlist[vlistID2].vars[varID].levinfo+nlevs1,
		 vlist[vlistID1].vars[varID].levinfo, nlevs2*sizeof(LEVINFO));
	}

      lvar = (int *) malloc(nvars2*sizeof(int));
      for ( varID = 0; varID < nvars2; varID++ ) lvar[varID] = FALSE;

      for ( varID = 0; varID < nvars2; varID++ )
	{
	  if ( lvar[varID] == TRUE ) continue;

	  zaxisID1 = vlist[vlistID1].vars[varID].zaxisID;
	  zaxisID2 = vlist[vlistID2].vars[varID].zaxisID;
	  /*
	  nlevs1 = vlist[vlistID1].vars[varID].nlevs;
	  nlevs2 = vlist[vlistID2].vars[varID].nlevs;
	  */
	  nlevs1 = zaxisInqSize(zaxisID1);
	  nlevs2 = zaxisInqSize(zaxisID2);

	  printf("zaxis %d %d %d %d\n", zaxisID1, zaxisID2, nlevs1, nlevs2);

	  nlevs = nlevs1 + nlevs2;

	  zaxisID = zaxisDuplicate(zaxisID2);

	  zaxisResize(zaxisID, nlevs);

	  levels = (double *) malloc(nlevs1*sizeof(double));

	  zaxisInqLevels(zaxisID1, levels);

	  for ( levID = 0; levID < nlevs1; levID++ )
	    zaxisDefLevel(zaxisID, nlevs2+levID, levels[levID]);

	  free(levels);

	  for ( index = 0; index < vlist[vlistID2].nzaxis; index++ )
	    if ( vlist[vlistID2].zaxisIDs[index] == zaxisID2 )
	      vlist[vlistID2].zaxisIDs[index] = zaxisID;

	  for ( varID2 = varID+1; varID2 < nvars1; varID2++ )
	    if ( vlist[vlistID2].vars[varID2].zaxisID == zaxisID2 )
	      {
		vlist[vlistID2].vars[varID2].zaxisID = zaxisID;
		lvar[varID2] = TRUE;
	      }
	}

      free(lvar);
    }
  else
    {
      vlistCat(vlistID2, vlistID1);
    }
}


/*
@Function  vlistNvars
@Title     Number of variables in a variable list

@Prototype int vlistNvars(int vlistID)
@Parameter
    @Item  vlistID Variable list identifier

@Description
The {\tt vlistNvars} function get the number of variables in the variable list vlistID.

@Result
{\tt vlistNvars} return the number of variables in a variable list.

@EndFunction
*/
int vlistNvars(int vlistID)
{
  static char func[] = "vlistNvars";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].nvars);
}

int vlistNrecs(int vlistID)
{
  static char func[] = "vlistNrecs";
  int varID, nrecs = 0;

  vlistCheckID(func, vlistID);

  for ( varID = 0; varID < vlist[vlistID].nvars; varID++ )
    nrecs +=  vlist[vlistID].vars[varID].nlevs;

  return (nrecs);
}


/*
@Function  vlistNgrids
@Title     Number of grids in a variable list

@Prototype int vlistNgrids(int vlistID)
@Parameter
    @Item  vlistID Variable list identifier

@Description
The {\tt vlistNvars} function get the number of grids in the variable list vlistID.

@Result
{\tt vlistNvars} return the number of grids in a variable list.

@EndFunction
*/
int vlistNgrids(int vlistID)
{
  static char func[] = "vlistNgrids";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].ngrids);
}


/*
@Function  vlistNzaxis
@Title     Number of zaxis in a variable list

@Prototype int vlistNzaxis(int vlistID)
@Parameter
    @Item  vlistID Variable list identifier

@Description
The {\tt vlistNvars} function get the number of zaxis in the variable list vlistID.

@Result
{\tt vlistNvars} return the number of zaxis in a variable list.

@EndFunction
*/
int vlistNzaxis(int vlistID)
{
  static char func[] = "vlistNzaxis";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].nzaxis);
}


void vlistDefNtsteps(int vlistID, int nts)
{
  static char func[] = "vlistDefNtsteps";

  vlistCheckID(func, vlistID);

  vlist[vlistID].ntsteps = nts;
}


int vlistNtsteps(int vlistID)
{
  static char func[] = "vlistNtsteps";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].ntsteps);
}


void vlistPrint(int vlistID)
{
  static char func[] = "vlistPrint";
  int nvars, flag, index;
  int varID, fvarID, flevID, levID;
  int code, gridID, zaxisID, timeID, nlevs;
  int dtype;
  char *name, *longname, *units;
  double level;

  vlistCheckID(func, vlistID);

  printf("#\n# vlistID %d\n#\n", vlistID);

  if ( vlistID == CDI_UNDEFID ) return;

  nvars = vlist[vlistID].nvars;

  printf("nvars   %d\n", nvars);
  printf("ngrids  %d\n", vlist[vlistID].ngrids);
  printf("nzaxis  %d\n", vlist[vlistID].nzaxis);
  printf("taxisID %d\n", vlist[vlistID].taxisID);
  printf("instID  %d\n", vlist[vlistID].instID);
  printf("modelID %d\n", vlist[vlistID].modelID);
  printf("tableID %d\n", vlist[vlistID].tableID);

  if ( nvars > 0 )
    {
      printf(" varID   code gridID zaxisID timeID nlevel flag  name     longname\n");
      for ( varID = 0; varID < nvars; varID++ )
	{
	  code     = vlist[vlistID].vars[varID].code;
	  gridID   = vlist[vlistID].vars[varID].gridID;
	  zaxisID  = vlist[vlistID].vars[varID].zaxisID;
	  timeID   = vlist[vlistID].vars[varID].timeID;
	  nlevs    = vlist[vlistID].vars[varID].nlevs;
	  name     = vlist[vlistID].vars[varID].name;
	  longname = vlist[vlistID].vars[varID].longname;
	  units    = vlist[vlistID].vars[varID].units;
	  flag     = vlist[vlistID].vars[varID].flag;
	  printf("%6d %6d %6d %6d %6d %6d %5d  %-8s %s",
		 varID, code, gridID, zaxisID, timeID, nlevs, flag,
		 name ? name : "", longname ? longname : "");
	  if ( units ) printf("   [%s]", units);
	  printf("\n");
	}

      printf("\n");
      printf(" varID  levID fvarID flevID  index  dtype  flag  level\n");
      for ( varID = 0; varID < nvars; varID++ )
	{
	  nlevs    = vlist[vlistID].vars[varID].nlevs;
	  zaxisID  = vlist[vlistID].vars[varID].zaxisID;
	  fvarID   = vlist[vlistID].vars[varID].fvarID;
	  dtype    = vlist[vlistID].vars[varID].datatype;
	  for ( levID = 0; levID < nlevs; levID++ )
	    {
	      flevID = vlist[vlistID].vars[varID].levinfo[levID].flevelID;
	      index  = vlist[vlistID].vars[varID].levinfo[levID].index;
	      flag   = vlist[vlistID].vars[varID].levinfo[levID].flag;
	      level  = zaxisInqLevel(zaxisID, levID);
	      printf("%6d %6d %6d %6d %6d %6d %5d  %.9g\n",
		     varID, levID, fvarID, flevID, index, dtype, flag, level);
	    }
	}
    }
}

void vlistDefTaxis(int vlistID, int taxisID)
{
  static char func[] = "vlistDefTaxis";

  vlistCheckID(func, vlistID);

  vlist[vlistID].taxisID = taxisID;
}

int vlistInqTaxis(int vlistID)
{
  static char func[] = "vlistInqTaxis";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].taxisID);
}

void  vlistDefTable(int vlistID, int tableID)
{
  static char func[] = "vlistDefTable";

  vlistCheckID(func, vlistID);

  vlist[vlistID].tableID = tableID;
}

int vlistInqTable(int vlistID)
{
  static char func[] = "vlistInqTable";

  vlistCheckID(func, vlistID);

  return (vlist[vlistID].tableID);
}

void vlistDefInstitut(int vlistID, int instID)
{
  static char func[] = "vlistDefInstitut";

  vlistCheckID(func, vlistID);

  vlist[vlistID].instID = instID;
}

int vlistInqInstitut(int vlistID)
{
  static char func[] = "vlistInqInstitut";
  int varID, instID;

  vlistCheckID(func, vlistID);

  instID = vlist[vlistID].instID;

  if ( instID == CDI_UNDEFID )
    {
      instID  = vlistInqVarInstitut(vlistID, 0);

      for ( varID = 1; varID < vlist[vlistID].nvars; varID++ )
	if ( instID != vlistInqVarInstitut(vlistID, varID) )
	  {
	    instID = CDI_UNDEFID;
	    break;
      }
      
      vlistDefInstitut(vlistID, instID);
    }

  return (instID);
}

void vlistDefModel(int vlistID, int modelID)
{
  static char func[] = "vlistDefModel";

  vlistCheckID(func, vlistID);

  vlist[vlistID].modelID = modelID;
}

int vlistInqModel(int vlistID)
{
  static char func[] = "vlistInqModel";
  int varID, modelID;

  vlistCheckID(func, vlistID);

  modelID = vlist[vlistID].modelID;

  if ( modelID == CDI_UNDEFID )
    {
      modelID = vlistInqVarModel(vlistID, 0);

      for ( varID = 1; varID < vlist[vlistID].nvars; varID++ )
	if ( modelID != vlistInqVarModel(vlistID, varID) )
	  {
	    modelID = CDI_UNDEFID;
	    break;
	  }

      vlistDefModel(vlistID, modelID);
    }

  return (modelID);
}

int vlistGridsizeMax(int vlistID)
{
  static char func[] = "vlistGridsizeMax";
  int gridsize, gridsizemax = 0;
  int gridID, index;

  vlistCheckID(func, vlistID);

  for ( index = 0 ; index < vlist[vlistID].ngrids ; index++ )
    {
      gridID = vlist[vlistID].gridIDs[index];
      gridsize = gridInqSize(gridID);
      if ( gridsize > gridsizemax ) gridsizemax = gridsize;
    }
  
  return (gridsizemax);
}

int vlistGrid(int vlistID, int index)
{
  static char func[] = "vlistGrid";
  int gridID = CDI_UNDEFID;

  vlistCheckID(func, vlistID);

  if ( index < vlist[vlistID].ngrids && index >= 0 )
    gridID = vlist[vlistID].gridIDs[index];
  
  return (gridID);
}

int vlistGridIndex(int vlistID, int gridID)
{
  static char func[] = "vlistGridIndex";
  int index;

  vlistCheckID(func, vlistID);

  for ( index = 0 ; index < vlist[vlistID].ngrids ; index++ )
    if ( gridID == vlist[vlistID].gridIDs[index] ) break;

  if ( index == vlist[vlistID].ngrids ) index = -1;
  
  return (index);
}

void vlistChangeGridIndex(int vlistID, int index, int gridID)
{
  static char func[] = "vlistChangeGridIndex";
  int gridIDold;
  int varID, nvars;

  vlistCheckID(func, vlistID);

  gridIDold = vlist[vlistID].gridIDs[index];
  vlist[vlistID].gridIDs[index] = gridID;

  nvars = vlist[vlistID].nvars;
  for ( varID = 0; varID < nvars; varID++ )
    if ( vlist[vlistID].vars[varID].gridID == gridIDold )
      vlist[vlistID].vars[varID].gridID = gridID;
}

void vlistChangeGrid(int vlistID, int gridID1, int gridID2)
{
  static char func[] = "vlistChangeGrid";
  int varID, nvars;
  int index, ngrids;

  vlistCheckID(func, vlistID);

  ngrids = vlist[vlistID].ngrids;
  for ( index = 0; index < ngrids; index++ )
    {
      if ( vlist[vlistID].gridIDs[index] == gridID1 )
	{
	  vlist[vlistID].gridIDs[index] = gridID2;
	  break;
	}
    }

  nvars = vlist[vlistID].nvars;
  for ( varID = 0; varID < nvars; varID++ )
    if ( vlist[vlistID].vars[varID].gridID == gridID1 )
      vlist[vlistID].vars[varID].gridID = gridID2;
}

int vlistZaxis(int vlistID, int index)
{
  static char func[] = "vlistZaxis";
  int zaxisID = CDI_UNDEFID;

  vlistCheckID(func, vlistID);

  if ( index < vlist[vlistID].nzaxis && index >= 0 )
    zaxisID = vlist[vlistID].zaxisIDs[index];
  
  return (zaxisID);
}

int vlistZaxisIndex(int vlistID, int zaxisID)
{
  static char func[] = "vlistZaxisIndex";
  int index;

  vlistCheckID(func, vlistID);

  for ( index = 0 ; index < vlist[vlistID].nzaxis ; index++ )
    if ( zaxisID == vlist[vlistID].zaxisIDs[index] ) break;

  if ( index == vlist[vlistID].nzaxis ) index = -1;
  
  return (index);
}

void vlistChangeZaxisIndex(int vlistID, int index, int zaxisID)
{
  static char func[] = "vlistChangeZaxisIndex";
  int zaxisIDold;
  int varID, nvars;
  int nlevs, levID;

  vlistCheckID(func, vlistID);

  zaxisIDold = vlist[vlistID].zaxisIDs[index];
  vlist[vlistID].zaxisIDs[index] = zaxisID;

  nvars = vlist[vlistID].nvars;
  for ( varID = 0; varID < nvars; varID++ )
    if ( vlist[vlistID].vars[varID].zaxisID == zaxisIDold )
      {
	vlist[vlistID].vars[varID].zaxisID = zaxisID;

	nlevs = zaxisInqSize(zaxisID);
	if ( nlevs != vlist[vlistID].vars[varID].nlevs )
	  {
	    vlist[vlistID].vars[varID].nlevs   = nlevs;
	    vlist[vlistID].vars[varID].levinfo = (LEVINFO *) realloc(vlist[vlistID].vars[varID].levinfo,
								     nlevs*sizeof(LEVINFO));

	    for ( levID = 0; levID < nlevs; levID++ )
	      {
		vlist[vlistID].vars[varID].levinfo[levID].flevelID = levID;
		vlist[vlistID].vars[varID].levinfo[levID].index    = -1;
		vlist[vlistID].vars[varID].levinfo[levID].flag     = FALSE;
	      }
	  }
      }
}

void vlistChangeZaxis(int vlistID, int zaxisID1, int zaxisID2)
{
  static char func[] = "vlistChangeZaxis";
  int varID, nvars;
  int index, nzaxis;
  int nlevs, levID;

  vlistCheckID(func, vlistID);

  nzaxis = vlist[vlistID].nzaxis;
  for ( index = 0; index < nzaxis; index++ )
    {
      if ( vlist[vlistID].zaxisIDs[index] == zaxisID1 )
	{
	  vlist[vlistID].zaxisIDs[index] = zaxisID2;
	  break;
	}
    }

  nvars = vlist[vlistID].nvars;
  for ( varID = 0; varID < nvars; varID++ )
    if ( vlist[vlistID].vars[varID].zaxisID == zaxisID1 )
      {
	vlist[vlistID].vars[varID].zaxisID = zaxisID2;

	nlevs = zaxisInqSize(zaxisID2);
	if ( nlevs != vlist[vlistID].vars[varID].nlevs )
	  {
	    vlist[vlistID].vars[varID].nlevs   = nlevs;
	    vlist[vlistID].vars[varID].levinfo = (LEVINFO *) realloc(vlist[vlistID].vars[varID].levinfo,
								     nlevs*sizeof(LEVINFO));

	    for ( levID = 0; levID < nlevs; levID++ )
	      {
		vlist[vlistID].vars[varID].levinfo[levID].flevelID = levID;
		vlist[vlistID].vars[varID].levinfo[levID].index    = -1;
		vlist[vlistID].vars[varID].levinfo[levID].flag     = FALSE;
	      }
	  }
      }
}

int vlistHasTime(int vlistID)
{
  static char func[] = "vlistHasTime";
  int varID;
  int hastime = FALSE;

  vlistCheckID(func, vlistID);

  for ( varID = 0; varID <  vlist[vlistID].nvars; varID++ )
    if ( vlist[vlistID].vars[varID].timeID == TIME_VARIABLE )
      {
	hastime = TRUE;
	break;
      }

  return (hastime);
}

void vlistDefAttribute(int vlistID, const char *attname, const char *attstring)
{
  static char func[] = "vlistDefAttribute";
  int attID;

  vlistCheckID(func, vlistID);

  if ( attname == NULL ) return;

  if ( (vlist[vlistID].natts + 1) == MAX_ATTRIBUTES )
    {
      Warning(func, "vlistID %d, maximum of %d attributes reached!",
	      vlistID, MAX_ATTRIBUTES);
    }
  else
    {
      for ( attID = 0; attID < vlist[vlistID].natts; attID++ )
	if ( strcmp(vlist[vlistID].attnames[attID], attname ) == 0 )
	  {
	    if ( vlist[vlistID].attstrings[attID] )
	      free(vlist[vlistID].attstrings[attID]);
	    
	    break;
	  }

      if ( attID == vlist[vlistID].natts )
	{
	  attID = vlist[vlistID].natts++;
	  vlist[vlistID].attnames[attID]   = strdup(attname);
	}

      if ( attstring )
	vlist[vlistID].attstrings[attID] = strdup(attstring);
      else
	vlist[vlistID].attstrings[attID] = NULL;
    }
}

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





static void vlistvarInitEntry(int vlistID, int varID)
{
  vlist[vlistID].vars[varID].fvarID       = varID;
  vlist[vlistID].vars[varID].flag         = 0;
  vlist[vlistID].vars[varID].code         = 0;
  vlist[vlistID].vars[varID].timeID       = CDI_UNDEFID;
  vlist[vlistID].vars[varID].datatype     = CDI_UNDEFID;
  vlist[vlistID].vars[varID].average      = 0;
  vlist[vlistID].vars[varID].gridID       = CDI_UNDEFID;
  vlist[vlistID].vars[varID].zaxisID      = CDI_UNDEFID;
  vlist[vlistID].vars[varID].instID       = CDI_UNDEFID;
  vlist[vlistID].vars[varID].modelID      = CDI_UNDEFID;
  vlist[vlistID].vars[varID].tableID      = CDI_UNDEFID;
  vlist[vlistID].vars[varID].missvalused  = FALSE;
  vlist[vlistID].vars[varID].missval      = cdiDefaultMissval;
  vlist[vlistID].vars[varID].addoffset    = 0.0;
  vlist[vlistID].vars[varID].scalefactor  = 1.0;
  vlist[vlistID].vars[varID].name         = NULL;
  vlist[vlistID].vars[varID].longname     = NULL;
  vlist[vlistID].vars[varID].units        = NULL;
  vlist[vlistID].vars[varID].nlevs        = 0;
  vlist[vlistID].vars[varID].levinfo      = NULL;
}

static int vlistvarNewEntry(int vlistID)
{
  static char func[] = "vlistvarNewEntry";
  int varID = 0;
  int vlistvarSize;
  VARINFO *vlistvar;

  vlistvarSize = vlist[vlistID].varsAllocated;
  vlistvar     = vlist[vlistID].vars;
  /*
    Look for a free slot in vlistvar.
    (Create the table the first time through).
  */
  if ( ! vlistvarSize )
    {
      int i;

      vlistvarSize = 2;
      vlistvar = (VARINFO *) malloc(vlistvarSize*sizeof(VARINFO));
      if ( vlistvar == NULL )
	{
          Message(func, "vlistvarSize = %d", vlistvarSize);
	  SysError(func, "Allocation of VARINFO failed");
	}

      for ( i = 0; i < vlistvarSize; i++ )
	vlistvar[i].isUsed = FALSE;
    }
  else
    {
      while ( varID < vlistvarSize )
	{
	  if ( ! vlistvar[varID].isUsed ) break;
	  varID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( varID == vlistvarSize )
    {
      int i;

      vlistvarSize = 2*vlistvarSize;
      vlistvar = (VARINFO *) realloc(vlistvar, vlistvarSize*sizeof(VARINFO));
      if ( vlistvar == NULL )
	{
          Message(func, "vlistvarSize = %d", vlistvarSize);
	  SysError(func, "Reallocation of VARINFO failed");
	}
      varID = vlistvarSize/2;

      for ( i = varID; i < vlistvarSize; i++ )
	vlistvar[i].isUsed = FALSE;
    }

  vlist[vlistID].varsAllocated = vlistvarSize;
  vlist[vlistID].vars          = vlistvar;

  vlistvarInitEntry(vlistID, varID);

  vlist[vlistID].vars[varID].isUsed = TRUE;

  return (varID);
}

static void vlistCheckVarID(char func[], int vlistID, int varID)
{
  if ( vlistID == CDI_UNDEFID )
    Error(func, "varID undefined!");

  if ( varID < 0 || varID >= vlist[vlistID].nvars )
    Error(func, "varID %d undefined!", varID);

  if ( ! vlist[vlistID].vars[varID].isUsed )
    Error(func, "varID %d undefined!", varID);
}


/*
@Function  vlistDefVar
@Title     Create a Variable

@Prototype int vlistDefVar(int vlistID, int gridID, int zaxisID, int timeID)
@Parameter
    @Item  vlistID   Variable list ID, from a previous call to vlistNew or vlistCopy
    @Item  gridID    Grid ID, from a previous call to gridNew
    @Item  zaxisID   Z-axis ID, from a previous call to zaxisNew
    @Item  timeID    One of the set of predefined CDI time identifiers.
                     The valid CDI time identifiers are TIME_CONSTANT and TIME_VARIABLE.

@Description
The function {\tt vlistDefVar} adds a new variable to vlistID.

@Result
{\tt vlistDefVar} return an identifier to the new variable.

@EndFunction
*/
int vlistDefVar(int vlistID, int gridID, int zaxisID, int timeID)
{
  static char func[] = "vlistDefVar";
  int varID;
  int nlevs;
  int levID;
  int index;

  if ( CDI_Debug )
    Message(func, "gridID = %d  zaxisID = %d  timeID = %d", gridID, zaxisID, timeID);

  varID = vlistvarNewEntry(vlistID);

  vlist[vlistID].nvars++;

  vlist[vlistID].vars[varID].gridID  = gridID;
  vlist[vlistID].vars[varID].zaxisID = zaxisID;
  vlist[vlistID].vars[varID].timeID  = timeID;

  if ( timeID != TIME_VARIABLE && timeID != TIME_CONSTANT )
    {
      Message(func, "unexpected timeID %d. Set to TIME_VARIABLE", timeID);
      vlist[vlistID].vars[varID].timeID = TIME_VARIABLE;	  
    }

  nlevs = zaxisInqSize(zaxisID);

  vlist[vlistID].vars[varID].levinfo = (LEVINFO *) malloc(nlevs*sizeof(LEVINFO));

  for ( levID = 0; levID < nlevs; levID++ )
    {
      vlist[vlistID].vars[varID].levinfo[levID].flag     = 0;
      vlist[vlistID].vars[varID].levinfo[levID].index    = -1;
      vlist[vlistID].vars[varID].levinfo[levID].flevelID = levID;
    }

  vlist[vlistID].vars[varID].nlevs = nlevs;

  for ( index = 0; index < vlist[vlistID].ngrids; index++ )
    if ( gridID == vlist[vlistID].gridIDs[index] ) break;

  if ( index == vlist[vlistID].ngrids )
    {
      vlist[vlistID].gridIDs[vlist[vlistID].ngrids] = gridID;
      vlist[vlistID].ngrids++;
    }

  for ( index = 0; index < vlist[vlistID].nzaxis; index++ )
    if ( zaxisID == vlist[vlistID].zaxisIDs[index] ) break;

  if ( index == vlist[vlistID].nzaxis )
    {
      vlist[vlistID].zaxisIDs[vlist[vlistID].nzaxis] = zaxisID;
      vlist[vlistID].nzaxis++;
    }

  vlist[vlistID].vars[varID].code = -(varID + 1);

  return (varID);
}


/*
@Function  vlistDefVarCode
@Title     Define the Code number of a variable

@Prototype void vlistDefVarCode(int vlistID, int varID, int code)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  code      Code number

@Description
The function {\tt vlistDefVarCode} defines the code number of a variable.

@EndFunction
*/
void vlistDefVarCode(int vlistID, int varID, int code)
{
  static char func[] = "vlistDefVarCode";

  vlistCheckVarID(func, vlistID, varID);

  vlist[vlistID].vars[varID].code = code;
}


void vlistInqVar(int vlistID, int varID, int *gridID, int *zaxisID, int *timeID)
{
  static char func[] = "vlistInqVar";

  vlistCheckVarID(func, vlistID, varID);

  *gridID  = vlist[vlistID].vars[varID].gridID;
  *zaxisID = vlist[vlistID].vars[varID].zaxisID;
  *timeID  = vlist[vlistID].vars[varID].timeID;

  return;
}


int vlistInqVarGrid(int vlistID, int varID)
{
  static char func[] = "vlistInqVarGrid";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].gridID);
}


int vlistInqVarZaxis(int vlistID, int varID)
{
  static char func[] = "vlistInqVarZaxis";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].zaxisID);
}

int vlistInqVarTime(int vlistID, int varID)
{
  static char func[] = "vlistInqVarTime";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].timeID);
}


/*
@Function  vlistInqVarCode
@Title     Get the Code number of a variable

@Prototype int vlistInqVarCode(int vlistID, int varID)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier

@Description
The function {\tt vlistInqVarCode} gets the code number of a variable.

@Result
{\tt vlistInqVarCode} return the code number of the variable.

@EndFunction
*/
int vlistInqVarCode(int vlistID, int varID)
{
  static char func[] = "vlistInqVarCode";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].code);
}


char *vlistInqVarNamePtr(int vlistID, int varID)
{
  static char func[] = "vlistInqVarNamePtr";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].name);
}

char *vlistInqVarLongnamePtr(int vlistID, int varID)
{
  static char func[] = "vlistInqVarLongnamePtr";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].longname);
}

char *vlistInqVarUnitsPtr(int vlistID, int varID)
{
  static char func[] = "vlistInqVarUnitsPtr";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].units);
}


/*
@Function  vlistInqVarName
@Title     Get the name of a variable

@Prototype void vlistInqVarName(int vlistID, int varID, char *name)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  name      Variable name

@Description
The function {\tt vlistInqVarName} gets the name of a variable.

@Result
{\tt vlistInqVarName} return the name of the variable to the parameter name.

@EndFunction
*/
void vlistInqVarName(int vlistID, int varID, char *name)
{
  static char func[] = "vlistInqVarName";
  int code, tableID;

  vlistCheckVarID(func, vlistID, varID);

  if ( vlist[vlistID].vars[varID].name == NULL )
    {
      code    = vlist[vlistID].vars[varID].code;
      tableID = vlist[vlistID].vars[varID].tableID;
      if ( tableInqParName(tableID, code, name) != 0 )
	sprintf(name, "var%d", code);
    }  
  else
    strcpy(name, vlist[vlistID].vars[varID].name);

  return;
}


/*
@Function  vlistInqVarLongname
@Title     Get the longname of a variable

@Prototype void vlistInqVarLongname(int vlistID, int varID, char *longname)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  longname  Variable description

@Description
The function {\tt vlistInqVarLongname} gets the longname of a variable.

@Result
{\tt vlistInqVaeLongname} return the longname of the variable to the parameter longname.

@EndFunction
*/
void vlistInqVarLongname(int vlistID, int varID, char *longname)
{
  static char func[] = "vlistInqVarLongname";
  int code, tableID;

  vlistCheckVarID(func, vlistID, varID);

  if ( vlist[vlistID].vars[varID].longname == NULL )
    {
      code    = vlist[vlistID].vars[varID].code;
      tableID = vlist[vlistID].vars[varID].tableID;
      if ( tableInqParLongname(tableID, code, longname) != 0 )
	longname[0] = '\0';
    }  
  else
    strcpy(longname, vlist[vlistID].vars[varID].longname);

  return;
}


/*
@Function  vlistInqVarUnits
@Title     Get the units of a variable

@Prototype void vlistInqVarUnits(int vlistID, int varID, char *units)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  units     Variable units

@Description
The function {\tt vlistInqVarUnits} gets the units of a variable.

@Result
{\tt vlistInqVarUnits} return the units of the variable to the parameter units.

@EndFunction
*/
void vlistInqVarUnits(int vlistID, int varID, char *units)
{
  static char func[] = "vlistInqVarUnits";
  int code, tableID;

  vlistCheckVarID(func, vlistID, varID);

  if ( vlist[vlistID].vars[varID].units == NULL )
    {
      code    = vlist[vlistID].vars[varID].code;
      tableID = vlist[vlistID].vars[varID].tableID;
      if ( tableInqParUnits(tableID, code, units) != 0 )
	units[0] = '\0';
    }  
  else
    strcpy(units, vlist[vlistID].vars[varID].units);

  return;
}

int vlistInqVarID(int vlistID, int code)
{
  int varID;

  for ( varID = 0; varID < vlist[vlistID].nvars; varID++ )
    if ( vlist[vlistID].vars[varID].code == code ) break;

  if ( varID == vlist[vlistID].nvars )
    {
      /*
      Warning(func, "varID not found for code %d\n", code);
      */
      varID = CDI_UNDEFID;
    }

  return (varID);
}

int vlistInqVarSize(int vlistID, int varID)
{
  static char func[] = "vlistInqVarSize";
  int size;
  int zaxisID, gridID;
  int nlevs, gridsize;
  int timeID;

  vlistCheckVarID(func, vlistID, varID);

  vlistInqVar(vlistID, varID, &gridID, &zaxisID, &timeID);

  nlevs = zaxisInqSize(zaxisID);

  gridsize = gridInqSize(gridID);

  size = gridsize*nlevs;

  return (size);
}


/*
@Function  vlistInqVarDatatype
@Title     Get the datatype of a variable

@Prototype int vlistInqVarDatatype(int vlistID, int varID)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier

@Description
The function {\tt vlistInqVarDatatype} gets the datatype of a variable.

@Result
{\tt vlistInqVarDatatype} return an identifier to the datatype of the variable.

@EndFunction
*/
int vlistInqVarDatatype(int vlistID, int varID)
{
  static char func[] = "vlistInqVarDatatype";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].datatype);
}


/*
@Function  vlistDefVarDatatype
@Title     Define the data type of a variable

@Prototype void vlistDefVarDatatype(int vlistID, int varID, int datatype)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  datatype  Data type identifier

@Description
The function {\tt vlistDefVarDatatype} defines the data type of a variable.

@EndFunction
*/
void vlistDefVarDatatype(int vlistID, int varID, int datatype)
{
  static char func[] = "vlistDefVarDatatype";

  vlistCheckVarID(func, vlistID, varID);

  vlist[vlistID].vars[varID].datatype = datatype;  
}

void vlistDefVarInstitut(int vlistID, int varID, int instID)
{
  vlist[vlistID].vars[varID].instID = instID;
}

int vlistInqVarInstitut(int vlistID, int varID)
{
  return (vlist[vlistID].vars[varID].instID);
}

void vlistDefVarModel(int vlistID, int varID, int modelID)
{
  vlist[vlistID].vars[varID].modelID = modelID;
}

int vlistInqVarModel(int vlistID, int varID)
{
  return (vlist[vlistID].vars[varID].modelID);
}

void vlistDefVarTable(int vlistID, int varID, int tableID)
{
  vlist[vlistID].vars[varID].tableID = tableID;
}

int vlistInqVarTable(int vlistID, int varID)
{
  int tableID;

  tableID = vlist[vlistID].vars[varID].tableID;

  return (tableID);
}


/*
@Function  vlistDefVarName
@Title     Define the name of a variable

@Prototype void vlistDefVarName(int vlistID, int varID, const char *name)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  name      Name of the variable

@Description
The function {\tt vlistDefVarName} defines the name of a variable.

@EndFunction
*/
void vlistDefVarName(int vlistID, int varID, const char *name)
{
  static char func[] = "vlistDefVarName";

  vlistCheckVarID(func, vlistID, varID);

  if ( vlist[vlistID].vars[varID].name ) free(vlist[vlistID].vars[varID].name);

  if ( name ) vlist[vlistID].vars[varID].name = strdup(name);
}


/*
@Function  vlistDefVarLongname
@Title     Define the long name of a variable

@Prototype void vlistDefVarLongname(int vlistID, int varID, const char *longname)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  longname  Long name of the variable

@Description
The function {\tt vlistDefVarLongname} defines the long name of a variable.

@EndFunction
*/
void vlistDefVarLongname(int vlistID, int varID, const char *longname)
{
  static char func[] = "vlistDefVarLongname";

  vlistCheckVarID(func, vlistID, varID);

  if ( vlist[vlistID].vars[varID].longname ) free(vlist[vlistID].vars[varID].longname);

  if ( longname ) vlist[vlistID].vars[varID].longname = strdup(longname);
}


/*
@Function  vlistDefVarUnits
@Title     Define the units of a variable

@Prototype void vlistDefVarUnits(int vlistID, int varID, const char *units)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  units     Units of the variable

@Description
The function {\tt vlistDefVarUnits} defines the units of a variable.

@EndFunction
*/
void vlistDefVarUnits(int vlistID, int varID, const char *units)
{
  static char func[] = "vlistDefVarUnits";

  vlistCheckVarID(func, vlistID, varID);

  if ( vlist[vlistID].vars[varID].units ) free(vlist[vlistID].vars[varID].units);

  if ( units ) vlist[vlistID].vars[varID].units = strdup(units);
}


/*
@Function  vlistInqVarMissval
@Title     Get the missing value of a variable

@Prototype double vlistInqVarMissval(int vlistID, int varID)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier

@Description
The function {\tt vlistInqVarMissval} gets the missing value of a variable.

@Result
{\tt vlistInqVarMissval} return the missing value of the variable.

@EndFunction
*/
double vlistInqVarMissval(int vlistID, int varID)
{
  static char func[] = "vlistInqVarMissval";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].missval);
}


double vlistInqVarScalefactor(int vlistID, int varID)
{
  static char func[] = "vlistInqVarScalefactor";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].scalefactor);
}

double vlistInqVarAddoffset(int vlistID, int varID)
{
  static char func[] = "vlistInqVarAddoffset";

  vlistCheckVarID(func, vlistID, varID);

  return (vlist[vlistID].vars[varID].addoffset);
}


/*
@Function  vlistDefVarMissval
@Title     Define the missing value of a variable

@Prototype void vlistDefVarMissval(int vlistID, int varID, double missval)
@Parameter
    @Item  vlistID   Variable list identifier
    @Item  varID     Variable identifier
    @Item  missval   Missing value

@Description
The function {\tt vlistDefVarMissval} defines the missing value of a variable.

@EndFunction
*/
void vlistDefVarMissval(int vlistID, int varID, double missval)
{
  static char func[] = "vlistDefVarMissval";

  vlistCheckVarID(func, vlistID, varID);

  vlist[vlistID].vars[varID].missval = missval;
  vlist[vlistID].vars[varID].missvalused = TRUE;
}

void vlistDefVarScalefactor(int vlistID, int varID, double scalefactor)
{
  static char func[] = "vlistDefVarScalefactor";

  vlistCheckVarID(func, vlistID, varID);

  vlist[vlistID].vars[varID].scalefactor = scalefactor;
}

void vlistDefVarAddoffset(int vlistID, int varID, double addoffset)
{
  static char func[] = "vlistDefVarAddoffset";

  vlistCheckVarID(func, vlistID, varID);

  vlist[vlistID].vars[varID].addoffset = addoffset;
}

void vlistDefVarAverage(int vlistID, int varID, int average)
{
  vlist[vlistID].vars[varID].average = average;
}

int vlistInqVarAverage(int vlistID, int varID)
{
  return (vlist[vlistID].vars[varID].average);
}

void vlistFreeVarName(int vlistID, int varID)
{
  static char func[] = "vlistFreeVarName";

  if ( vlist[vlistID].vars[varID].name )
    {
      free(vlist[vlistID].vars[varID].name);
      vlist[vlistID].vars[varID].name = NULL;
    }
}

void vlistFreeVarLongname(int vlistID, int varID)
{
  static char func[] = "vlistFreeVarLongname";

  if ( vlist[vlistID].vars[varID].longname )
    {
      free(vlist[vlistID].vars[varID].longname);
      vlist[vlistID].vars[varID].longname = NULL;
    }
}

void vlistFreeVarUnits(int vlistID, int varID)
{
  static char func[] = "vlistFreeVarUnits";

  if ( vlist[vlistID].vars[varID].units )
    {
      free(vlist[vlistID].vars[varID].units);
      vlist[vlistID].vars[varID].units = NULL;
    }
}

void vlistDefVarTime(int vlistID, int varID, int timeID)
{
  vlist[vlistID].vars[varID].timeID = timeID;
}

int vlistInqVarMissvalUsed(int vlistID, int varID)
{
  return (vlist[vlistID].vars[varID].missvalused);
}

void vlistDefFlag(int vlistID, int varID, int levID, int flag)
{
  vlist[vlistID].vars[varID].flag = flag;
  vlist[vlistID].vars[varID].levinfo[levID].flag = flag;
}

int vlistInqFlag(int vlistID, int varID, int levID)
{
  return (vlist[vlistID].vars[varID].levinfo[levID].flag);
}

int vlistFindVar(int vlistID, int fvarID)
{
  static char func[] = "vlistFindVar";
  int varID;

  for ( varID = 0; varID < vlist[vlistID].nvars; varID++ )
    {
      if ( vlist[vlistID].vars[varID].fvarID == fvarID ) break;
    }

  if ( varID == vlist[vlistID].nvars )
    {
      varID = -1;
      Message(func, "varID not found for fvarID %d in vlistID %d!", fvarID, vlistID);
    }

  return (varID);  
}

int vlistFindLevel(int vlistID, int fvarID, int flevelID)
{
  static char func[] = "vlistFindLevel";
  int varID;
  int levelID = -1;

  varID = vlistFindVar(vlistID, fvarID);

  if ( varID != -1 )
    {
      for ( levelID = 0; levelID < vlist[vlistID].vars[varID].nlevs; levelID++ )
	{
	  if ( vlist[vlistID].vars[varID].levinfo[levelID].flevelID == flevelID ) break;
	}

      if ( levelID == vlist[vlistID].vars[varID].nlevs )
	{
	  levelID = -1;
	  Message(func, "levelID not found for fvarID %d and levelID %d in vlistID %d!",
		  fvarID, flevelID, vlistID);
	}
    }

  return (levelID);  
}


int vlistFlagVar(int vlistID, int varID)
{
  return (vlist[vlistID].vars[varID].fvarID);  
}


int vlistFlagLevel(int vlistID, int varID, int levelID)
{
  return (vlist[vlistID].vars[varID].levinfo[levelID].flevelID);  
}


void vlistDefIndex(int vlistID, int varID, int levelID, int index)
{
  vlist[vlistID].vars[varID].levinfo[levelID].index = index;  
}

int vlistInqIndex(int vlistID, int varID, int levelID)
{
  return (vlist[vlistID].vars[varID].levinfo[levelID].index);  
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID

void basetimeInit(BaseTime *basetime)
{
  static char func[] = "cdiInitTime";

  if ( basetime == NULL )
    Error(func, "Internal problem! Basetime not allocated.");

  (*basetime).ncvarid = UNDEFID;
  (*basetime).ncdimid = UNDEFID;
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#define SINGLE_PRECISION  4
#define DOUBLE_PRECISION  8

typedef struct {
  int    fileID;
  int    byteswap;
  int    header[8];
  int    hprec;      /* header precision */
  int    dprec;      /* data   precision */
  int    recnum;
  size_t datasize;
  size_t buffersize;
  void  *buffer;
}
SRVTABLE;

static SRVTABLE *srvTable = NULL;
static int srvTableSize = 0;

static int initSrv = 0;
static int srvDefaultHprec = 0;
static int srvDefaultDprec = 0;

int srvTableGetIndex(int fileID);

/*
 * A version string.
 */

#undef  LIBVERSION
#define LIBVERSION      0.9.1
#define XSTRING(x)	#x
#define STRING(x)	XSTRING(x)
static const char srv_libvers[] = STRING(LIBVERSION) " of "__DATE__" "__TIME__;

const char *srvLibraryVersion(void)
{
  return (srv_libvers);
}


int SRV_Debug = 0;    /* If set to 1, debugging */

void srvDebug(int debug)
{
  static char func[] = "srvDebug";

  SRV_Debug = debug;

  if ( SRV_Debug )
    Message(func, "debug level %d", debug);
}

void srvInit()
{
  static char func[] = "srvInit";
  char *envString;
  char *envName = "SRV_PRECISION";

  initSrv = 1;

  envString = getenv(envName);
  if ( envString )
    {
      int pos;
      int nrun;
      if ( strlen(envString) == 2 ) nrun = 1;
      else                          nrun = 2;

      pos = 0;
      while ( nrun-- )
	{
	  switch ( tolower((int) envString[pos]) )
	    {
	    case 'i':
	      {
		switch ( (int) envString[pos+1] )
		  {
		  case '4': srvDefaultHprec = SINGLE_PRECISION; break;
		  case '8': srvDefaultHprec = DOUBLE_PRECISION; break;
		  default:
		    Message(func, "Invalid digit in %s: %s", envName, envString);
		  }
		break;
	      }
	    case 'r':
	      {
		switch ( (int) envString[pos+1] )
		  {
		  case '4': srvDefaultDprec = SINGLE_PRECISION; break;
		  case '8': srvDefaultDprec = DOUBLE_PRECISION; break;
		  default:
		    Message(func, "Invalid digit in %s: %s", envName, envString);
		  }
		break;		
	      }
	    default:
	      Message(func, "Invalid character in %s: %s", envName, envString);
	    }
	  pos += 2;
	}
    }
}

int srvOpen(const char *filename, const char *mode)
{
  if ( ! initSrv ) srvInit();

  return (fileOpen(filename, mode));  
}

void srvClose(int fileID)
{
  fileClose(fileID);
}

int srvInqByteswap(int fileID)
{
  int srvID = srvTableGetIndex(fileID);
  return (srvTable[srvID].byteswap);
}

void srvDefByteswap(int fileID)
{
  int srvID = srvTableGetIndex(fileID);
  srvTable[srvID].byteswap = 1;
}

void srvTableInitEntry(int srvID)
{
  static char func[] = "srvTableInitEntry";

  if ( srvID < 0 || srvID >= srvTableSize )
    Error(func, "srvID %d undefined!", srvID);

  srvTable[srvID].fileID     = FILE_UNDEFID;
  srvTable[srvID].byteswap   = 0;
  srvTable[srvID].hprec      = 0;
  srvTable[srvID].dprec      = 0;
  srvTable[srvID].recnum     = 0;
  srvTable[srvID].datasize   = 0;
  srvTable[srvID].buffersize = 0;
  srvTable[srvID].buffer     = NULL;
}

int srvTableNewEntry(int fileID)
{
  static char func[] = "srvTableNewEntry";
  int srvID = 0;

  /*
    Look for a free slot in srvTable.
    (Create the table the first time through).
  */
  if ( !srvTableSize )
    {
      int i;

      srvTableSize = 2;
      srvTable = (SRVTABLE *) malloc(srvTableSize*sizeof(SRVTABLE));
      if ( srvTable == NULL )
	{
          Message(func, "srvTableSize = %d", srvTableSize);
	  SysError(func, "Allocation of SRVTABLE failed");
	}

      for ( i = 0; i < srvTableSize; i++ )
	srvTableInitEntry(i);
    }
  else
    {
      while ( srvID < srvTableSize )
	{
	  if ( srvTable[srvID].fileID == FILE_UNDEFID ) break;
	  srvID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( srvID == srvTableSize )
    {
      int i;

      srvTableSize = 2*srvTableSize;
      srvTable = (SRVTABLE *) realloc(srvTable, srvTableSize*sizeof(SRVTABLE));
      if ( srvTable == NULL )
	{
          Message(func, "srvTableSize = %d", srvTableSize);
	  SysError(func, "Reallocation of SRVTABLE failed");
	}
      srvID = srvTableSize/2;

      for ( i = srvID; i < srvTableSize; i++ )
	srvTableInitEntry(i);
    }

  srvTableInitEntry(srvID);

  srvTable[srvID].fileID = fileID;

  if ( SRV_Debug )
    Message(func, "srvID = %d  fileID = %d", srvID, fileID);

  return (srvID);
}

void srvTableDelEntry(int srvID)
{
  if ( srvID >= 0 && srvID < srvTableSize )
    srvTableInitEntry(srvID);
}

int srvCheckFiletype(int fileID, int *swap)
{
  static char func[] = "srvCheckFiletype";
  unsigned long blocklen = 0;
  unsigned long swapblocklen = 0;
  unsigned long data = 0;
  unsigned long dimx = 0, dimy = 0;
  int fact = 0, found = 0;
  unsigned char buffer[72], *pbuf;

  if ( fileRead(fileID, buffer, 4) != 4 ) return (found);

      blocklen =  get_UINT32(buffer);
  swapblocklen = get_SUINT32(buffer);

  if ( blocklen == 32 )
    {
     *swap = 0;
      fact = 4;
      if ( fileRead(fileID, buffer, 40) != 40 ) return (found);
      pbuf = buffer+16;  dimx = get_UINT32(pbuf);
      pbuf = buffer+20;  dimy = get_UINT32(pbuf);
      pbuf = buffer+36;  data = get_UINT32(pbuf);
    }
  else if ( blocklen == 64 )
    {
     *swap = 0;
      fact = 8;
      if ( fileRead(fileID, buffer, 72) != 72 ) return (found);
      pbuf = buffer+32;  dimx = get_UINT64(pbuf);
      pbuf = buffer+40;  dimy = get_UINT64(pbuf);
      pbuf = buffer+68;  data = get_UINT32(pbuf);
    }
  else if ( swapblocklen == 32 )
    {
     *swap = 1;
      fact = 4;
      if ( fileRead(fileID, buffer, 40) != 40 ) return (found);
      pbuf = buffer+16;  dimx = get_SUINT32(pbuf);
      pbuf = buffer+20;  dimy = get_SUINT32(pbuf);
      pbuf = buffer+36;  data = get_SUINT32(pbuf);
    }
  else if ( swapblocklen == 64 )
    {
     *swap = 1;
      fact = 8;
      if ( fileRead(fileID, buffer, 72) != 72 ) return (found);
      pbuf = buffer+32;  dimx = get_SUINT64(pbuf);
      pbuf = buffer+40;  dimy = get_SUINT64(pbuf);
      pbuf = buffer+68;  data = get_SUINT32(pbuf);
    }

  fileRewind(fileID);

  if      ( data && dimx*dimy*fact == data ) found = 1;
  else if ( data && dimx*dimy*8    == data ) found = 1;

  if ( SRV_Debug )
    {
      Message(func, "swap = %d fact = %d", *swap, fact);
      Message(func, "dimx = %lu dimy = %lu data = %lu", dimx, dimy, data);
    }

  return (found);
}

int srvTableGetIndex(int fileID)
{
  static char func[] = "srvTableGetIndex";
  int srvID = 0;

  while ( srvID < srvTableSize )
    {
      if ( srvTable[srvID].fileID == fileID ) break;
      srvID++;
    }

  if ( srvID == srvTableSize )
    {
      srvID = srvTableNewEntry(fileID);

      if ( SRV_Debug )
	Message(func, "srvTable slot = %d  fileID = %d", srvID, fileID);

      if ( fileInqMode(fileID) == 'r' )
	{
	  int swap = 0;
	  if ( ! srvCheckFiletype(fileID, &swap) )
	    Error("srvCheckFiletype",
		  "check SERVICE failed for %s", fileInqName(fileID));

	  if ( swap ) srvDefByteswap(fileID);
	}
    }

  return (srvID);
}

int srvInqPrec(int fileID)
{
  return (srvTable[srvTableGetIndex(fileID)].dprec);
}

void srvDefPrec(int fileID, int prec)
{
  srvTable[srvTableGetIndex(fileID)].dprec = prec;
}

int srvReadHeader(int fileID, int *header)
{
  static char func[] = "srvReadHeader";
  size_t headerlen = 8;
  size_t datasize;
  size_t blocklen;
  size_t i;
  char tempheader[64];
  int hprec, dprec;
  void *buffer;
  int buffersize;
  int srvID;
  int byteswap = srvInqByteswap(fileID);

  srvID = srvTableGetIndex(fileID);

  /* read header record */
  blocklen = binReadF77Block(fileID, byteswap);

  if ( fileEOF(fileID) ) return (0);

  if ( SRV_Debug )
    Message(func, "blocklen = %lu", blocklen);

  hprec = blocklen / headerlen;

  srvTable[srvID].hprec = hprec;

  switch ( hprec )
    {
    case SINGLE_PRECISION:
      {
	binReadInt32(fileID, byteswap, headerlen, (INT32 *) tempheader);

	for (i = 0; i < headerlen; i++)
          header[i] = (int) ((INT32 *) tempheader)[i];

	break;
      }
    case DOUBLE_PRECISION:
      {
	binReadInt64(fileID, byteswap, headerlen, (INT64 *) tempheader);

	for (i = 0; i < headerlen; i++)
          header[i] = (int) ((INT64 *) tempheader)[i];

	break;
      }
    default:
      {
	Error(func, "unexpected header precision %d", hprec);
      }
    }
  
  for ( i = 0; i < headerlen; i++ )
    srvTable[srvID].header[i] = header[i];

  blocklen = binReadF77Block(fileID, byteswap);

  srvTable[srvID].datasize = header[4]*header[5];

  if ( SRV_Debug )
    Message(func, "datasize = %lu", srvTable[srvID].datasize);

  blocklen = binReadF77Block(fileID, byteswap);

  buffersize = srvTable[srvID].buffersize;

  if ( buffersize < blocklen )
    {
      buffersize = blocklen;
      buffer = srvTable[srvID].buffer;
      buffer = realloc(buffer, buffersize);
      srvTable[srvID].buffer = buffer;
      srvTable[srvID].buffersize = buffersize;
    }
  else
    buffer = srvTable[srvID].buffer;

  datasize = srvTable[srvID].datasize;

  dprec = blocklen / datasize;

  srvTable[srvID].dprec = dprec;

  if ( dprec != SINGLE_PRECISION && dprec != DOUBLE_PRECISION )
    Error(func, "unexpected data precision %d", dprec);

  fileRead(fileID, buffer, blocklen);

  blocklen = binReadF77Block(fileID, byteswap);

  return (++srvTable[srvID].recnum);
}

int srvWriteHeader(int fileID, const int *header)
{
  static char func[] = "srvWriteHeader";
  size_t headerlen = 8;
  size_t i;
  int srvID;

  srvID = srvTableGetIndex(fileID);

  for (i = 0; i < headerlen; i++)
    srvTable[srvID].header[i] = header[i];
  
  srvTable[srvID].datasize = header[4]*header[5];

  if ( SRV_Debug )
    Message(func, "datasize = %lu", srvTable[srvID].datasize);

  return (++srvTable[srvID].recnum);
}

int srvReadData(int fileID, int prec, void *data)
{
  static char func[] = "srvReadData";
  size_t datasize;
  size_t i;
  int ierr = 0;
  int dprec;
  void *buffer;
  int srvID;
  int byteswap = srvInqByteswap(fileID);

  srvID = srvTableGetIndex(fileID);

  datasize = srvTable[srvID].datasize;

  buffer = srvTable[srvID].buffer;

  dprec = srvTable[srvID].dprec;

  switch ( dprec )
    {
    case SINGLE_PRECISION:
      {
	if ( sizeof(REAL4) == 4 )
	  {
	    if ( byteswap ) swap4byte(buffer, datasize);

	    if ( dprec == prec )
	      memcpy(data, buffer, datasize*sizeof(REAL4));
	    else
	      for (i = 0; i < datasize; i++)
		((double *) data)[i] = (double) ((float *) buffer)[i];
	  }
	else
	  {
	    Error(func, "not implemented for %d byte float", sizeof(REAL4));
	  }	
	break;
      }
    case DOUBLE_PRECISION:
	if ( sizeof(REAL8) == 8 )
	  {
	    if ( byteswap ) swap8byte(buffer, datasize);

	    if ( dprec == prec )
	      memcpy(data, buffer, datasize*sizeof(REAL8));
	    else
	      for (i = 0; i < datasize; i++)
		((float *) data)[i] = (float) ((double *) buffer)[i];
	  }
	else
	  {
	    Error(func, "not implemented for %d byte float", sizeof(REAL8));
	  }	
	break;
    default:
      {
	Error(func, "unexpected data precision %d", dprec);
      }
    }

  return (ierr);
}

int srvReadDataSP(int fileID, float *data)
{
  return (srvReadData(fileID, SINGLE_PRECISION, (void *) data));
}

int srvReadDataDP(int fileID, double *data)
{
  return (srvReadData(fileID, DOUBLE_PRECISION, (void *) data));
}

int srvWriteData(int fileID, int prec, const void *data)
{
  static char func[] = "srvWriteData";
  size_t headerlen = 8;
  size_t datasize;
  size_t blocklen;
  size_t buffersize;
  size_t i;
  int dprec, hprec;
  char tempheader[64];
  int *header;
  void *buffer;
  int srvID;
  int byteswap = srvInqByteswap(fileID);

  srvID = srvTableGetIndex(fileID);

  header = srvTable[srvID].header;

  if ( srvDefaultDprec ) dprec = srvDefaultDprec;
  else                   dprec = srvTable[srvID].dprec;

  if ( ! dprec ) dprec = prec;

  if ( srvDefaultHprec ) hprec = srvDefaultHprec;
  else                   hprec = dprec;

  /* write header record */
  blocklen = headerlen * hprec;

  binWriteF77Block(fileID, byteswap, blocklen);

  switch ( hprec )
    {
    case SINGLE_PRECISION:
      {
	for (i = 0; i < headerlen; i++)
          ((INT32 *) tempheader)[i] = (INT32) header[i];

	binWriteInt32(fileID, byteswap, headerlen, (INT32 *) tempheader);

	break;
      }
    case DOUBLE_PRECISION:
      {
	for (i = 0; i < headerlen; i++)
          ((INT64 *) tempheader)[i] = (INT64) header[i];

	binWriteInt64(fileID, byteswap, headerlen, (INT64 *) tempheader);

	break;
      }
    default:
      {
	Error(func, "unexpected header precision %d", hprec);
      }
    }
  
  binWriteF77Block(fileID, byteswap, blocklen);

  datasize = header[4]*header[5];
  blocklen = datasize * dprec;

  binWriteF77Block(fileID, byteswap, blocklen);

  srvTable[srvID].datasize = datasize;

  buffersize = srvTable[srvID].buffersize;

  if ( buffersize != blocklen )
    {
      buffersize = blocklen;
      buffer = srvTable[srvID].buffer;
      buffer = realloc(buffer, buffersize);
      srvTable[srvID].buffer = buffer;
      srvTable[srvID].buffersize = buffersize;
    }
  else
    buffer = srvTable[srvID].buffer;

  switch ( dprec )
    {
    case SINGLE_PRECISION:
      {
	if ( dprec == prec )
	  memcpy(buffer, data, datasize*sizeof(REAL4));
	else
	  for (i = 0; i < datasize; i++)
	    ((float *) buffer)[i] = (float) ((double *) data)[i];

	binWriteReal4(fileID, byteswap, datasize, (REAL4 *) buffer);

	break;
      }
    case DOUBLE_PRECISION:
      {
	if ( dprec == prec )
	  memcpy(buffer, data, datasize*sizeof(REAL8));
	else
	  for (i = 0; i < datasize; i++)
	    ((double *) buffer)[i] = (double) ((float *) data)[i];

	binWriteReal8(fileID, byteswap, datasize, (REAL8 *) buffer);

	break;
      }
    default:
      {
	Error(func, "unexpected data precision %d", dprec);
      }
    }

  binWriteF77Block(fileID, byteswap, blocklen);

  return (++srvTable[srvID].recnum);
}

int srvWriteDataSP(int fileID, const float *data)
{
  return (srvWriteData(fileID, SINGLE_PRECISION, (void *) data));
}

int srvWriteDataDP(int fileID, const double *data)
{
  return (srvWriteData(fileID, DOUBLE_PRECISION, (void *) data));
}

int srvMove(int ifileID, int ofileID)
{
  static char func[] = "srvMove";
  int isrvID, osrvID;
  size_t headerlen = 8;
  size_t datasize;
  size_t blocklen;
  size_t buffersize;
  size_t i;
  int hprec, dprec;
  char tempheader[64];
  int *header;
  void *buffer;
  int byteswap = srvInqByteswap(ofileID);

  isrvID = srvTableGetIndex(ifileID);
  osrvID = srvTableGetIndex(ofileID);

  hprec  = srvTable[isrvID].hprec;
  dprec  = srvTable[isrvID].dprec;
  header = srvTable[isrvID].header;
  
  /* write header record */
  blocklen = headerlen * hprec;

  binWriteF77Block(ofileID, byteswap, blocklen);

  switch ( hprec )
    {
    case SINGLE_PRECISION:
      {
	for (i = 0; i < headerlen; i++)
          ((INT32 *) tempheader)[i] = (INT32) header[i];

	binWriteInt32(ofileID, byteswap, headerlen, (INT32 *) tempheader);

	break;
      }
    case DOUBLE_PRECISION:
      {
	for (i = 0; i < headerlen; i++)
          ((INT64 *) tempheader)[i] = (INT64) header[i];

	binWriteInt64(ofileID, byteswap, headerlen, (INT64 *) tempheader);

	break;
      }
    default:
      {
	Error(func, "unexpected header precision %d", hprec);
      }
    }
  
  binWriteF77Block(ofileID, byteswap, blocklen);

  datasize = header[4]*header[5];
  printf("datasize = %d\n", datasize);
  blocklen = datasize * dprec;

  binWriteF77Block(ofileID, byteswap, blocklen);

  srvTable[osrvID].datasize = datasize;

  buffersize = srvTable[isrvID].buffersize;

  buffer = srvTable[isrvID].buffer;

  switch ( dprec )
    {
    case SINGLE_PRECISION:
      {
	binWriteReal4(ofileID, byteswap, datasize, (REAL4 *) buffer);
	break;
      }
    case DOUBLE_PRECISION:
      {
	binWriteReal8(ofileID, byteswap, datasize, (REAL8 *) buffer);
	break;
      }
    default:
      {
	Error(func, "unexpected data precision %d", dprec);
      }
    }

  binWriteF77Block(ofileID, byteswap, blocklen);

  return (++srvTable[osrvID].recnum);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#define SINGLE_PRECISION  4
#define DOUBLE_PRECISION  8

typedef struct {
  int    fileID;
  int    byteswap;
  int    header[4];
  int    hprec;      /* header precision */
  int    dprec;      /* data   precision */
  int    recnum;
  size_t datasize;
  size_t buffersize;
  void  *buffer;
}
EXTTABLE;

static EXTTABLE *extTable = NULL;
static int extTableSize = 0;

static int initExt = 0;
static int extDefaultHprec = 0;
static int extDefaultDprec = 0;

int extTableGetIndex(int fileID);

/*
 * A version string.
 */

#undef  LIBVERSION
#define LIBVERSION      0.9.1
#define XSTRING(x)	#x
#define STRING(x)	XSTRING(x)
static const char ext_libvers[] = STRING(LIBVERSION) " of "__DATE__" "__TIME__;

const char *extLibraryVersion(void)
{
  return (ext_libvers);
}


int EXT_Debug = 0;    /* If set to 1, debugging */

void extDebug(int debug)
{
  static char func[] = "extDebug";

  EXT_Debug = debug;

  if ( EXT_Debug )
    Message(func, "debug level %d", debug);
}

void extInit()
{
  static char func[] = "extInit";
  char *envString;
  char *envName = "EXT_PRECISION";

  initExt = 1;

  envString = getenv(envName);
  if ( envString )
    {
      int pos;
      int nrun;
      if ( strlen(envString) == 2 ) nrun = 1;
      else                          nrun = 2;

      pos = 0;
      while ( nrun-- )
	{
	  switch ( tolower((int) envString[pos]) )
	    {
	    case 'i':
	      {
		switch ( (int) envString[pos+1] )
		  {
		  case '4': extDefaultHprec = SINGLE_PRECISION; break;
		  case '8': extDefaultHprec = DOUBLE_PRECISION; break;
		  default:
		    Message(func, "Invalid digit in %s: %s", envName, envString);
		  }
		break;
	      }
	    case 'r':
	      {
		switch ( (int) envString[pos+1] )
		  {
		  case '4': extDefaultDprec = SINGLE_PRECISION; break;
		  case '8': extDefaultDprec = DOUBLE_PRECISION; break;
		  default:
		    Message(func, "Invalid digit in %s: %s", envName, envString);
		  }
		break;		
	      }
	    default:
	      Message(func, "Invalid character in %s: %s", envName, envString);
	    }
	  pos += 2;
	}
    }
}

int extOpen(const char *filename, const char *mode)
{
  if ( ! initExt ) extInit();

  return (fileOpen(filename, mode));  
}

void extClose(int fileID)
{
  fileClose(fileID);
}

int extInqByteswap(int fileID)
{
  int extID = extTableGetIndex(fileID);
  return (extTable[extID].byteswap);
}

void extDefByteswap(int fileID)
{
  int extID = extTableGetIndex(fileID);
  extTable[extID].byteswap = 1;
}

void extTableInitEntry(int extID)
{
  static char func[] = "extTableInitEntry";

  if ( extID < 0 || extID >= extTableSize )
    Error(func, "extID %d undefined!", extID);

  extTable[extID].fileID     = FILE_UNDEFID;
  extTable[extID].byteswap   = 0;
  extTable[extID].hprec      = 0;
  extTable[extID].dprec      = 0;
  extTable[extID].recnum     = 0;
  extTable[extID].datasize   = 0;
  extTable[extID].buffersize = 0;
  extTable[extID].buffer     = NULL;
}

int extTableNewEntry(int fileID)
{
  static char func[] = "extTableNewEntry";
  int extID = 0;

  /*
    Look for a free slot in extTable.
    (Create the table the first time through).
  */
  if ( !extTableSize )
    {
      int i;

      extTableSize = 2;
      extTable = (EXTTABLE *) malloc(extTableSize*sizeof(EXTTABLE));
      if ( extTable == NULL )
	{
          Message(func, "extTableSize = %d", extTableSize);
	  SysError(func, "Allocation of EXTTABLE failed");
	}

      for ( i = 0; i < extTableSize; i++ )
	extTableInitEntry(i);
    }
  else
    {
      while ( extID < extTableSize )
	{
	  if ( extTable[extID].fileID == FILE_UNDEFID ) break;
	  extID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( extID == extTableSize )
    {
      int i;

      extTableSize = 2*extTableSize;
      extTable = (EXTTABLE *) realloc(extTable, extTableSize*sizeof(EXTTABLE));
      if ( extTable == NULL )
	{
          Message(func, "extTableSize = %d", extTableSize);
	  SysError(func, "Reallocation of EXTTABLE failed");
	}
      extID = extTableSize/2;

      for ( i = extID; i < extTableSize; i++ )
	extTableInitEntry(i);
    }

  extTableInitEntry(extID);

  extTable[extID].fileID = fileID;

  if ( EXT_Debug )
    Message(func, "extID = %d  fileID = %d", extID, fileID);

  return (extID);
}

void extTableDelEntry(int extID)
{
  if ( extID >= 0 && extID < extTableSize )
    extTableInitEntry(extID);
}

int extCheckFiletype(int fileID, int *swap)
{
  static char func[] = "extCheckFiletype";
  unsigned long blocklen = 0;
  unsigned long swapblocklen = 0;
  unsigned long data =  0;
  unsigned long dimxy = 0;
  int fact = 0, found = 0;
  unsigned char buffer[40], *pbuf;

  if ( fileRead(fileID, buffer, 4) != 4 ) return (found);

      blocklen =  get_UINT32(buffer);
  swapblocklen = get_SUINT32(buffer);

  if ( blocklen == 16 )
    {
     *swap = 0;
      fact = 4;
      if ( fileRead(fileID, buffer, 24) != 24 ) return (found);
      pbuf = buffer+12;  dimxy = get_UINT32(pbuf);
      pbuf = buffer+20;  data  = get_UINT32(pbuf);
    }
  else if ( blocklen == 32 )
    {
     *swap = 0;
      fact = 8;
      if ( fileRead(fileID, buffer, 40) != 40 ) return (found);
      pbuf = buffer+24;  dimxy = get_UINT64(pbuf);
      pbuf = buffer+36;  data  = get_UINT32(pbuf);
    }
  else if ( swapblocklen == 16 )
    {
     *swap = 1;
      fact = 4;
      if ( fileRead(fileID, buffer, 24) != 24 ) return (found);
      pbuf = buffer+12;  dimxy = get_SUINT32(pbuf);
      pbuf = buffer+20;  data  = get_SUINT32(pbuf);
    }
  else if ( swapblocklen == 32 )
    {
     *swap = 1;
      fact = 8;
      if ( fileRead(fileID, buffer, 40) != 40 ) return (found);
      pbuf = buffer+24;  dimxy = get_SUINT64(pbuf);
      pbuf = buffer+36;  data  = get_SUINT32(pbuf);
    }

  fileRewind(fileID);

  if      ( data && dimxy*fact == data ) found = 1;
  else if ( data && dimxy*8    == data ) found = 1;

  if ( EXT_Debug )
    {
      Message(func, "swap = %d fact = %d", *swap, fact);
      Message(func, "dimxy = %lu data = %lu", dimxy, data);
    }

  return (found);
}

int extTableGetIndex(int fileID)
{
  static char func[] = "extTableGetIndex";
  int extID = 0;

  while ( extID < extTableSize )
    {
      if ( extTable[extID].fileID == fileID ) break;
      extID++;
    }

  if ( extID == extTableSize )
    {
      extID = extTableNewEntry(fileID);

      if ( EXT_Debug )
	Message(func, "extTable slot = %d  fileID = %d", extID, fileID);

      if ( fileInqMode(fileID) == 'r' )
	{
	  int swap = 0;
	  if ( ! extCheckFiletype(fileID, &swap) )
	    Error("extCheckFiletype",
		  "check EXTRA failed for %s", fileInqName(fileID));

	  if ( swap ) extDefByteswap(fileID);
	}
    }

  return (extID);
}

int extInqPrec(int fileID)
{
  return (extTable[extTableGetIndex(fileID)].dprec);
}

void extDefPrec(int fileID, int prec)
{
  extTable[extTableGetIndex(fileID)].dprec = prec;
}

int extReadHeader(int fileID, int *header)
{
  static char func[] = "extReadHeader";
  size_t headerlen = 4;
  size_t datasize;
  size_t blocklen;
  size_t i;
  char tempheader[32];
  int hprec, dprec;
  void *buffer;
  int buffersize;
  int extID;
  int byteswap = extInqByteswap(fileID);

  extID = extTableGetIndex(fileID);

  /* read header record */
  blocklen = binReadF77Block(fileID, byteswap);

  if ( fileEOF(fileID) ) return (0);

  if ( EXT_Debug )
    Message(func, "blocklen = %lu", blocklen);

  hprec = blocklen / headerlen;

  extTable[extID].hprec = hprec;

  switch ( hprec )
    {
    case SINGLE_PRECISION:
      {
	binReadInt32(fileID, byteswap, headerlen, (INT32 *) tempheader);

	for (i = 0; i < headerlen; i++)
          header[i] = (int) ((INT32 *) tempheader)[i];

	break;
      }
    case DOUBLE_PRECISION:
      {
	binReadInt64(fileID, byteswap, headerlen, (INT64 *) tempheader);

	for (i = 0; i < headerlen; i++)
          header[i] = (int) ((INT64 *) tempheader)[i];

	break;
      }
    default:
      {
	Error(func, "unexpected header precision %d", hprec);
      }
    }
  
  for ( i = 0; i < headerlen; i++ )
    extTable[extID].header[i] = header[i];

  blocklen = binReadF77Block(fileID, byteswap);

  extTable[extID].datasize = header[3];

  if ( EXT_Debug )
    Message(func, "datasize = %lu", extTable[extID].datasize);

  blocklen = binReadF77Block(fileID, byteswap);

  buffersize = extTable[extID].buffersize;

  if ( buffersize < blocklen )
    {
      buffersize = blocklen;
      buffer = extTable[extID].buffer;
      buffer = realloc(buffer, buffersize);
      extTable[extID].buffer = buffer;
      extTable[extID].buffersize = buffersize;
    }
  else
    buffer = extTable[extID].buffer;

  datasize = extTable[extID].datasize;

  dprec = blocklen / datasize;

  extTable[extID].dprec = dprec;

  if ( dprec != SINGLE_PRECISION && dprec != DOUBLE_PRECISION )
    Error(func, "unexpected data precision %d", dprec);

  fileRead(fileID, buffer, blocklen);

  blocklen = binReadF77Block(fileID, byteswap);

  return (++extTable[extID].recnum);
}

int extWriteHeader(int fileID, const int *header)
{
  static char func[] = "extWriteHeader";
  size_t headerlen = 4;
  size_t i;
  int extID;

  extID = extTableGetIndex(fileID);

  for (i = 0; i < headerlen; i++)
    extTable[extID].header[i] = header[i];
  
  extTable[extID].datasize = header[3];

  if ( EXT_Debug )
    Message(func, "datasize = %lu", extTable[extID].datasize);

  return (++extTable[extID].recnum);
}

int extReadData(int fileID, int prec, void *data)
{
  static char func[] = "extReadData";
  size_t datasize;
  size_t i;
  int ierr = 0;
  int dprec;
  void *buffer;
  int extID;
  int byteswap = extInqByteswap(fileID);

  extID = extTableGetIndex(fileID);

  datasize = extTable[extID].datasize;

  buffer = extTable[extID].buffer;

  dprec = extTable[extID].dprec;

  switch ( dprec )
    {
    case SINGLE_PRECISION:
      {
	if ( sizeof(REAL4) == 4 )
	  {
	    if ( byteswap ) swap4byte(buffer, datasize);

	    if ( dprec == prec )
	      memcpy(data, buffer, datasize*sizeof(REAL4));
	    else
	      for (i = 0; i < datasize; i++)
		((double *) data)[i] = (double) ((float *) buffer)[i];
	  }
	else
	  {
	    Error(func, "not implemented for %d byte float", sizeof(REAL4));
	  }	
	break;
      }
    case DOUBLE_PRECISION:
	if ( sizeof(REAL8) == 8 )
	  {
	    if ( byteswap ) swap8byte(buffer, datasize);

	    if ( dprec == prec )
	      memcpy(data, buffer, datasize*sizeof(REAL8));
	    else
	      for (i = 0; i < datasize; i++)
		((float *) data)[i] = (float) ((double *) buffer)[i];
	  }
	else
	  {
	    Error(func, "not implemented for %d byte float", sizeof(REAL8));
	  }	
	break;
    default:
      {
	Error(func, "unexpected data precision %d", dprec);
      }
    }

  return (ierr);
}

int extReadDataSP(int fileID, float *data)
{
  return (extReadData(fileID, SINGLE_PRECISION, (void *) data));
}

int extReadDataDP(int fileID, double *data)
{
  return (extReadData(fileID, DOUBLE_PRECISION, (void *) data));
}

int extWriteData(int fileID, int prec, const void *data)
{
  static char func[] = "extWriteData";
  size_t headerlen = 4;
  size_t datasize;
  size_t blocklen;
  size_t buffersize;
  size_t i;
  int dprec, hprec;
  char tempheader[32];
  int *header;
  void *buffer;
  int extID;
  int byteswap = extInqByteswap(fileID);

  extID = extTableGetIndex(fileID);

  header = extTable[extID].header;

  if ( extDefaultDprec ) dprec = extDefaultDprec;
  else                   dprec = extTable[extID].dprec;

  if ( ! dprec ) dprec = prec;

  if ( extDefaultHprec ) hprec = extDefaultHprec;
  else                   hprec = dprec;

  /* write header record */
  blocklen = headerlen * hprec;

  binWriteF77Block(fileID, byteswap, blocklen);

  switch ( hprec )
    {
    case SINGLE_PRECISION:
      {
	for (i = 0; i < headerlen; i++)
          ((INT32 *) tempheader)[i] = (INT32) header[i];

	binWriteInt32(fileID, byteswap, headerlen, (INT32 *) tempheader);

	break;
      }
    case DOUBLE_PRECISION:
      {
	for (i = 0; i < headerlen; i++)
          ((INT64 *) tempheader)[i] = (INT64) header[i];

	binWriteInt64(fileID, byteswap, headerlen, (INT64 *) tempheader);

	break;
      }
    default:
      {
	Error(func, "unexpected header precision %d", hprec);
      }
    }
  
  binWriteF77Block(fileID, byteswap, blocklen);
  
  datasize = header[3];
  blocklen = datasize * dprec;

  binWriteF77Block(fileID, byteswap, blocklen);

  extTable[extID].datasize = datasize;

  buffersize = extTable[extID].buffersize;

  if ( buffersize != blocklen )
    {
      buffersize = blocklen;
      buffer = extTable[extID].buffer;
      buffer = realloc(buffer, buffersize);
      extTable[extID].buffer = buffer;
      extTable[extID].buffersize = buffersize;
    }
  else
    buffer = extTable[extID].buffer;

  switch ( dprec )
    {
    case SINGLE_PRECISION:
      {
	if ( dprec == prec )
	  memcpy(buffer, data, datasize*sizeof(REAL4));
	else
	  for (i = 0; i < datasize; i++)
	    ((float *) buffer)[i] = (float) ((double *) data)[i];

	binWriteReal4(fileID, byteswap, datasize, (REAL4 *) buffer);

	break;
      }
    case DOUBLE_PRECISION:
      {
	if ( dprec == prec )
	  memcpy(buffer, data, datasize*sizeof(REAL8));
	else
	  for (i = 0; i < datasize; i++)
	    ((double *) buffer)[i] = (double) ((float *) data)[i];

	binWriteReal8(fileID, byteswap, datasize, (REAL8 *) buffer);

	break;
      }
    default:
      {
	Error(func, "unexpected data precision %d", dprec);
      }
    }

  binWriteF77Block(fileID, byteswap, blocklen);

  return (++extTable[extID].recnum);
}

int extWriteDataSP(int fileID, const float *data)
{
  return (extWriteData(fileID, SINGLE_PRECISION, (void *) data));
}

int extWriteDataDP(int fileID, const double *data)
{
  return (extWriteData(fileID, DOUBLE_PRECISION, (void *) data));
}


#ifndef  rad2deg
#define  rad2deg  (180./M_PI)   /* conversion for rad to deg */
#endif

#ifndef  deg2rad
#define  deg2rad  (M_PI/180.)   /* conversion for deg to rad */
#endif


double rls_to_rl(double phis, double rlas, double polphi, double pollam)
{
  /*
    Umrechnung von rlas (rot. System) auf rla (geo. System)

    phis   : Breite im rotierten System (N>0)
    rlas   : Laenge im rotierten System (E>0)
    polphi : Geographische Breite des Nordpols des rot. Systems
    pollam : Geographische Laenge des Nordpols des rot. Systems

    result : Geographische Laenge
  */
  double zsinpol, zcospol, zlampol;
  double zphis, zrlas, zarg1, zarg2;

  zsinpol = sin(deg2rad*polphi);
  zcospol = cos(deg2rad*polphi);

  zlampol = deg2rad*pollam;
  zphis   = deg2rad*phis;
  if ( rlas > 180.0 ) rlas = rlas - 360.0;
  zrlas   = deg2rad*rlas;

  zarg1   = sin(zlampol)*(- zsinpol*cos(zrlas)*cos(zphis)  +
                            zcospol*           sin(zphis)) -
            cos(zlampol)*           sin(zrlas)*cos(zphis);
  zarg2   = cos(zlampol)*(- zsinpol*cos(zrlas)*cos(zphis)  +
                            zcospol*           sin(zphis)) +
            sin(zlampol)*           sin(zrlas)*cos(zphis);

  if ( zarg2 == 0.0 ) zarg2 = 1.0e-20;

  return (rad2deg*atan2(zarg1, zarg2));
}


double phs_to_ph(double phis, double rlas, double polphi, double pollam)
{
  /*
    Umrechnung von phis (rot. System) auf phi (geo. System)

    phis   : Breite im rotierten System (N>0)
    rlas   : Laenge im rotierten System (E>0)
    polphi : Geographische Breite des Nordpols des rot. Systems
    pollam : Geographische Laenge des Nordpols des rot. Systems

    result : Geographische Breite
  */
  double zsinpol, zcospol;
  double zphis, zrlas, zarg;

  zsinpol = sin(deg2rad*polphi);
  zcospol = cos(deg2rad*polphi);

  zphis   = deg2rad*phis;
  if (rlas > 180.0 ) rlas = rlas - 360.0;
  zrlas   = deg2rad*rlas;

  zarg    = zcospol*cos(zphis)*cos(zrlas) + zsinpol*sin(zphis);

  return (rad2deg*asin(zarg));
}


double rl_to_rls(double phi, double rla, double polphi, double pollam)
{
  /*
    Umrechnung von rla (geo. System) auf rlas (rot. System)

    phi    : Breite im geographischen System (N>0)
    rla    : Laenge im geographischen System (E>0)
    polphi : Geographische Breite des Nordpols des rot. Systems
    pollam : Geographische Laenge des Nordpols des rot. Systems

    result : Rotierte Laenge
  */
  double zsinpol, zcospol, zlampol;
  double zphi, zrla, zarg1, zarg2;

  zsinpol = sin(deg2rad*polphi);
  zcospol = cos(deg2rad*polphi);
  zlampol =     deg2rad*pollam;

  if ( rla > 180.0 ) rla = rla - 360.0;

  zrla = deg2rad*rla;
  zphi = deg2rad*phi;

  zarg1  = - sin(zrla-zlampol)*cos(zphi);
  zarg2  = - zsinpol*cos(zphi)*cos(zrla-zlampol)+zcospol*sin(zphi);
  if ( zarg2 == 0.0 ) zarg2 = 1.0e-20;

  return (rad2deg*atan2(zarg1,zarg2));
}


double ph_to_phs(double phi, double rla, double polphi, double pollam)
{
  /*
    Umrechnung von phi (geo. System) auf phis (rot. System)

    phi    : Breite im geographischen System (N>0)
    rla    : Laenge im geographischen System (E>0)
    polphi : Geographische Breite des Nordpols des rot. Systems
    pollam : Geographische Laenge des Nordpols des rot. Systems

    result : Rotierte Breite
  */
  double zsinpol, zcospol, zlampol;
  double zphi, zrla, zarg;

  zsinpol = sin(deg2rad*polphi);
  zcospol = cos(deg2rad*polphi);
  zlampol =     deg2rad*pollam;

  zphi = deg2rad*phi;
  if ( rla > 180.0 ) rla = rla-360.0;
  zrla = deg2rad*rla;

  zarg = zcospol*cos(zphi)*cos(zrla-zlampol) + zsinpol*sin(zphi);

  return (rad2deg*asin(zarg));
}

/*
int main(void)
{
  double polphi, pollam;
  double x0, y0, x1, y1, x2, y2;
  int i;

  polphi = 90.0;
  pollam = 0.0;

  polphi = 32.5;
  pollam = -170.0;

  x0 = -20.0;
  y0 = 0.0;

  for ( i = 0; i < 10; i++ )
    {
      x0 = i *20.0;
      printf("%g %g\n", x0, y0);

      x1 = rls_to_rl(y0, x0, polphi, pollam);
      y1 = phs_to_ph(y0, x0, polphi, pollam);

      printf("%g %g\n", x1, y1);

      x2 = rl_to_rls(y1, x1, polphi, pollam);
      y2 = ph_to_phs(y1, x1, polphi, pollam);

      printf("%g %g\n", x2, y2);
    }

  return (0);
}
*/


int pow_ii(int x, int n)
{
  int pow;
  
  if (n <= 0) {
    if (n == 0 || x == 1)
      return 1;
    if (x != -1)
      return x == 0 ? 1/x : 0;
    n = -n;
  }
  for(pow = 1; ; )
    {
      if(n & 01)
	pow *= x;
      if(n >>= 1)
	x *= x;
      else
	break;
    }
  return(pow);
}


void factorni(int kni, int *kni2, int *kni3)
{
  /**********************************************************************/
  /* factorni computes the factors of the integer input kni, assuming   */ 
  /* that kni decomposes into kni3 factors (kni3 either 0 or 1) of "3"  */
  /* and kni2 (kni2 > 0) factors of "2". The subroutine returns the     */
  /* number of factors of "3", kni3, number of factors of "2", kni2.    */
  /* Bails out in case of error.                                        */
  /**********************************************************************/
  /*  Author: D. Majewski, DWD, January 2000                            */
  /**********************************************************************/ 
  /*  Input                                                             */
  /*  kni     INT   number of intervals on a main triangle side         */
  /**********************************************************************/
  /*  Output                                                            */
  /*  kni2    INT      exponent of "2", kni2 > 0                        */ 
  /*  kni3    INT      exponent of "3", either 0 or 1                   */
  /**********************************************************************/

  int mx;

  mx    = kni;

  *kni2  = 0;
  *kni3  = 0;

  while (mx > 1)
    { 
      if (mx%2 == 0) 
	{
          *kni2 = *kni2 + 1;
          mx   = mx/2;
	}
      else if (mx%3 == 0) 
	{
          *kni3 = *kni3 + 1;
          mx   = mx/3;
	}
      else
	{
	  /* error return */
        }
    }

  /* kni3 must not be greater than */

  if (*kni3 > 1) 
    {
      /* error return */
    }
}

void tricntr(double *pxn, 
	     int kig1s, int kig1e, int kig2s, int kig2e, int knd, 
	     int kjd, int kni)
{
  int id1, id2, id3, ioffset;
  double r1, r2, r3;

  int j, mi1, mi2;
  double zxnorm;

  /**********************************************************************/
  /*  tricntr finds the coordinates of the node at the center           */
  /*  of the two icosahedral triangles comprising diamond kjd. These    */
  /*  nodes are present when ni contains the factor 3, i.e. if ni3 = 1. */
  /**********************************************************************/
  /*  Author: D. Majewski, DWD, May 1996 based on                       */
  /*          J. Baumgardner (Los Alamos Nat. Lab.)                     */
  /**********************************************************************/
  /*  Input                                                             */
  /*  pxn     DOUBLE    pxn(kig1s:kig1e, kig2s:kig2e, 3, knd): Carte-   */
  /*                    sian (x,y,z) coordinates of the location vector */
  /*                    of the gridpoints (nodes) on the unit-sphere;   */
  /*                    phys. dim. ( - )                                */
  /*  kig1s   INT   first  dimension of array, start index              */
  /*  kig1e   INT   first  dimension of array, end   index              */
  /*  kig2s   INT   second dimension of array, start index              */
  /*  kig2e   INT   second dimension of array, end   index              */
  /*  knd     INT   number of diamonds (knd = 10)                       */
  /*  kjd     INT   index of actual diamond (kjd = 1 to 10)             */
  /*  kni     INT   number of intervals on a main triangle side         */
  /**********************************************************************/
  /*  Output                                                            */
  /*  pxn     DOUBLE      see above                                     */
  /**********************************************************************/
    
  id1 = kig1e-kig1s+1;
  id2 = id1*(kig2e-kig2s+1);
  id3 = id2*3;
  ioffset = -(id1+id2+id3);
    
  for (j = 1; j <= 2; ++j) {
    mi1 = j*kni/3;
    mi2 = (j-1)*kni+1;
    pxn[mi1+id1*(mi1+1)+id2*1+id3*kjd+ioffset] 
      = pxn[mi2-1+id1*(mi2)+id2*1+id3*kjd+ioffset] 
       +pxn[kni+id1*1+id2*1+id3*kjd+ioffset] 
       +pxn[0+id1*(kni+1)+id2*1+id3*kjd+ioffset];
    pxn[mi1+id1*(mi1+1)+id2*2+id3*kjd+ioffset] 
      = pxn[mi2-1+id1*(mi2)+id2*2+id3*kjd+ioffset] 
       +pxn[kni+id1*1+id2*2+id3*kjd+ioffset] 
       +pxn[0+id1*(kni+1)+id2*2+id3*kjd+ioffset];
    pxn[mi1+id1*(mi1+1)+id2*3+id3*kjd+ioffset] 
      = pxn[mi2-1+id1*(mi2)+id2*3+id3*kjd+ioffset] 
       +pxn[kni+id1*1+id2*3+id3*kjd+ioffset] 
       +pxn[0+id1*(kni+1)+id2*3+id3*kjd+ioffset];
    /* Normalize to unit-sphere */
      
    r1 = pxn[mi1+id1*(mi1+1)+id2*1+id3*kjd+ioffset];
    r2 = pxn[mi1+id1*(mi1+1)+id2*2+id3*kjd+ioffset];
    r3 = pxn[mi1+id1*(mi1+1)+id2*3+id3*kjd+ioffset];
    zxnorm = 1.0/sqrt(r1*r1+r2*r2+r3*r3);
      
    pxn[mi1+id1*(mi1+1)+id2*1+id3*kjd+ioffset] 
      = zxnorm*pxn[mi1+id1*(mi1+1)+id2*1+id3*kjd+ioffset];
    pxn[mi1+id1*(mi1+1)+id2*2+id3*kjd+ioffset] 
      = zxnorm*pxn[mi1+id1*(mi1+1)+id2*2+id3*kjd+ioffset];
    pxn[mi1+id1*(mi1+1)+id2*3+id3*kjd+ioffset] 
      = zxnorm*pxn[mi1+id1*(mi1+1)+id2*3+id3*kjd+ioffset];
  }

  return;
} /* tricntr */

/****************************************************************************/

void gcpt(double *pxn, 
	  int kig1s, int kig1e, int kig2s, int kig2e, int knd, 
	  int kjd, double pgamma, 
	  int ki1, int kj1, int ki2, int kj2, int ki, int kj)
{
  int id1, id2, id3, ioffset;
  double r1, r2, r3;
    
  double zbeta, zalpha, zchord, ztheta;
    
  /**********************************************************************/
  /*  gcpt finds the point x along the shorter great circle             */
  /*  arc between points x1 and x2 on the unit sphere, such that        */
  /*  x and x1 subtend the angle pgamma*ztheta0, where ztheta0 is the   */
  /*  angle subtended by x1 and x2. Note gamma resides on the           */
  /*  interval [0-1]. The Cartesian coordinates of the point x are      */
  /*  stored in the array pxn at the indices ki, kj.                    */
  /**********************************************************************/
  /*  Author: D. Majewski, DWD, May 1996 based on                       */
  /*          J. Baumgardner (Los Alamos Nat. Lab.)                     */
  /**********************************************************************/
  /*  Input                                                             */
  /*  pxn     DOUBLE    pxn(kig1s:kig1e, kig2s:kig2e, 3, knd): Carte-   */
  /*                    sian (x,y,z) coordinates of the location vector */
  /*                    of the gridpoints (nodes) on the unit-sphere;   */
  /*                    phys. dim. ( - )                                */
  /*  kig1s   INT   first  dimension of array, start index              */
  /*  kig1e   INT   first  dimension of array, end   index              */
  /*  kig2s   INT   second dimension of array, start index              */
  /*  kig2e   INT   second dimension of array, end   index              */
  /*  knd     INT   number of diamond (knd = 10)                        */
  /*  kjd     INT   index of actual diamond (kjd = 1 to 10)             */
  /*  pgamma  DOUBLE      the normalized great circle angular parameter */
  /*                    interpolating between x1 and x2.                */
  /*  ki1     INT   index of point x1 in i1-direction                   */
  /*  kj1     INT   index of point x1 in i2-direction                   */
  /*  ki2     INT   index of point x2 in i1-direction                   */
  /*  kj2     INT   index of point x2 in i2-direction                   */
  /*  ki      INT   index of point x  in i1-direction                   */
  /*  kj      INT   index of point x  in i2-direction                   */
  /**********************************************************************/
  /*  Output                                                            */
  /*  pxn     DOUBLE      see above                                     */
  /**********************************************************************/

  /* Calculate "zchord", the Cartesian distance between x1 and x2 */

  id1 = kig1e-kig1s+1;
  id2 = id1*(kig2e-kig2s+1);
  id3 = id2*3;
  ioffset = -(id1+id2+id3);

  r1 = (pxn[ki2+id1*kj2+id2*1+id3*kjd+ioffset] 
       -pxn[ki1+id1*kj1+id2*1+id3*kjd+ioffset]);
  r2 = (pxn[ki2+id1*kj2+id2*2+id3*kjd+ioffset] 
       -pxn[ki1+id1*kj1+id2*2+id3*kjd+ioffset]);
  r3 = (pxn[ki2+id1*kj2+id2*3+id3*kjd+ioffset] 
       -pxn[ki1+id1*kj1+id2*3+id3*kjd+ioffset]);
  
  zchord = sqrt((r1*r1)+(r2*r2)+(r3*r3));
    
  /* Calculate "ztheta", the great circle angle between x1 and x2 */
  ztheta = 2.0*asin(zchord*0.5);
    
  /* Calculate the weighting factors which follow from the condition */
  /* that x is a point on the unit-sphere, too. */
  zbeta = sin(pgamma*ztheta)/sin(ztheta);
  zalpha = sin((1.0-pgamma)*ztheta)/sin(ztheta);
    
  /* Store the (x,y,z) coordinates of the point x into the array pxn */
  pxn[ki+id1*kj+id2*1+id3*kjd+ioffset] 
    = zalpha*pxn[ki1+id1*kj1+id2*1+id3*kjd+ioffset] 
     +zbeta *pxn[ki2+id1*kj2+id2*1+id3*kjd+ioffset];
  pxn[ki+id1*kj+id2*2+id3*kjd+ioffset] 
    = zalpha*pxn[ki1+id1*kj1+id2*2+id3*kjd+ioffset] 
     +zbeta *pxn[ki2+id1*kj2+id2*2+id3*kjd+ioffset];
  pxn[ki+id1*kj+id2*3+id3*kjd+ioffset] 
    = zalpha*pxn[ki1+id1*kj1+id2*3+id3*kjd+ioffset] 
     +zbeta *pxn[ki2+id1*kj2+id2*3+id3*kjd+ioffset];

  return;
} /* gcpt */

/****************************************************************************/

void glo_coor(double *pxn, double *prlon, double *prlat, 
	      int kig1s, int kig1e, int kig2s, int kig2e, int knd, 
	      int kni2, int kni3)
{
  static char func[] = "glo_coor";
  int id1, id2, id3, ioffset, joffset;

  double zsgn;
  int j1, j2;
  double zrlon, zcosw, zsinw;
  int jb, jd, ml, mm;
  double zgamma, zw;
  int mi1, mi2, ml2, ml3, mni;

  int *mcosv;

  const double pid5 = 0.2*M_PI;

  /**************************************************************************/
  /*     glo_coor calculates the global arrays which define the             */
  /*     triangular grid                                                    */
  /**************************************************************************/
  /*     Author: D. Majewski, DWD, May 1996 based on                        */
  /*             J. Baumgardner (Los Alamos Nat. Lab.)                      */
  /**************************************************************************/
  /*     Input/Output                                                       */
  /*     pxn    (kig1sm2:kig1ep2, kig2sm2:kig2ep2, 3, knd) DOUBLE:  Carte-  */
  /*            sian (x,y,z) coordinates of the location vector of the grid */
  /*            points (nodes) on the unit-sphere; phys. dim. ( - )         */
  /*            Attention: pxn is defined for the extended domain, i.e.     */
  /*            with 2 rows and columns around the original diamond array   */
  /*            size.                                                       */
  /*     prlon  (kig1s  :kig1e  , kig2s  :kig2e  ,    knd):  geographical   */
  /*            longitude of the gridpoints; phys. dim. (radians)           */
  /*     prlat  (kig1s  :kig1e  , kig2s  :kig2e  ,    knd):  geographical   */
  /*            latitude of the gridpoints; phys. dim. (radians)            */
  /*     kig1s   INT  first dimension of arrays, start index (kig1s = 0)    */
  /*     kig1e   INT  first dimension of arrays, end index (kig1e = ni)     */
  /*     kig2s   INT  sec. dimension of arrays, start index (kig2s = 1)     */
  /*     kig2e   INT  sec. dimension of arrays, end index (kig2e = ni+1)    */
  /*     knd     INT  number of diamonds (knd = 10)                         */
  /*     kni2    INT  exponent of factor "2" in the factorization of ni,    */
  /*                      i.e. the number of bisections to perform          */
  /*     kni3    INT  exponent of factor "3" in the factorization of ni,    */
  /*                      i.e. the number of trisections to perform (0 or1) */
  /**************************************************************************/

  /**************************************************************************/
  /*     1. Calculate the Cartesian coordinates of the gridpoints of the    */
  /*        icosahedral grid on the unit sphere.  The grid resolution       */
  /*        corresponds to a subdivision of the edges of the original       */
  /*        icosahedral triangles into mni equal parts.                     */
  
  if ((mcosv = (int *) malloc (knd*sizeof(int))) == NULL ) {
    perror("malloc mcosv");
    exit (EXIT_FAILURE);
  }

  id1 = kig1e-kig1s+1;
  id2 = id1*(kig2e-kig2s+1);
  id3 = id2*3;
  ioffset = -(id1+id2+id3);
  joffset = -(id1+id2);

  /*     Compute angles associated with the icosahedron. */

  zw = acos(1.0/(sin(pid5)*2.0))*2.0;
  zcosw = cos(zw);
  zsinw = sin(zw);
  mni = pow_ii(2, kni2)*pow_ii(3, kni3);
  
  /*     Compute the local array mcosv, i.e. the meridian angle locations */

  for (jd = 1; jd <= knd; ++jd) {
    if (jd % 2 == 1) {
      mcosv[(jd+1)/2-1] = jd-2-knd*((jd-1)/7);
    } else {
      mcosv[jd/2+4]     = jd-2-knd*((jd-1)/7);
    }
  }

  /**************************************************************************/
  /*     Loop over the ten diamonds computing diamond vertices (x,y,z)      */
  /*     coordinates and then iteratively bisecting them kni2 times.        */
  /*     First a trisection is performed, if required (kni3=1).             */

  for (jd = 1; jd <= knd; ++jd) {
    
    /*     Toggle the hemisphere */
    if (jd >= 6) {
      zsgn = -1.0;
    } else {
      zsgn =  1.0;
    }

    /*     Compute the meridian angle for each diamond "home" vertex. */
    zrlon = mcosv[jd-1]*pid5;

    /*     Every diamond has one vertex at a pole (N or S). */
    /*     Label this point (0,1,,) in each diamond, and */
    /*     initialize it to have the (x,y,z) coordinates of */
    /*     the pole point on the unit sphere. */
    pxn[0+id1*1+id2*1+id3*jd+ioffset] = 0.0;
    pxn[0+id1*1+id2*2+id3*jd+ioffset] = 0.0;
    pxn[0+id1*1+id2*3+id3*jd+ioffset] = zsgn;

    /*     Now initialize the (x,y,z) coordinates of the "home" vertex, */
    /*     which defines which diamond we are talking about, and label  */
    /*     this point (mni,1,,). */
    pxn[mni+id1*1+id2*1+id3*jd+ioffset] = zsinw*cos(zrlon);
    pxn[mni+id1*1+id2*2+id3*jd+ioffset] = zsinw*sin(zrlon);
    pxn[mni+id1*1+id2*3+id3*jd+ioffset] = zcosw*zsgn;

    /*     Next initialize the (x,y,z) coordinates for the corner of the */
    /*     diamond on the same latitude as the (mni,1,,) vertex, which   */
    /*     is (0,mni+1,,) */
    pxn[0+id1*(mni+1)+id2*1+id3*jd+ioffset] = zsinw*cos(zrlon+2*pid5);
    pxn[0+id1*(mni+1)+id2*2+id3*jd+ioffset] = zsinw*sin(zrlon+2*pid5);
    pxn[0+id1*(mni+1)+id2*3+id3*jd+ioffset] = zcosw*zsgn;

    /*     Initialize the last diamond vertex, which is located */
    /*     in the opposite hemisphere as (mni,mni+1,,)          */
    pxn[mni+id1*(mni+1)+id2*1+id3*jd+ioffset] = zsinw*cos(zrlon+pid5);
    pxn[mni+id1*(mni+1)+id2*2+id3*jd+ioffset] = zsinw*sin(zrlon+pid5);
    pxn[mni+id1*(mni+1)+id2*3+id3*jd+ioffset] = -(zcosw*zsgn);

    /***********************************************************************/
    /*     First a trisection is performed, if required (kni3=1).          */

    if (kni3 == 1) {
      ml3 = mni/3;
      
      /*     Trisect the rows of the diamond. */
      for (j1 = 1; j1 <= 2; ++j1) {
	for (j2 = 1; j2 <= 2; ++j2) {
	  mi1 = (j1-1)*mni;
	  mi2 = j2*ml3+1;
	  zgamma = (double) j2/3.0;
	  gcpt(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd, 
		zgamma, mi1, 1, mi1, mni+1, mi1, mi2);
	}
      }
      
      /*     Trisect the columns of the diamond. */
      for (j1 = 1; j1 <= 2; ++j1) {
	for (j2 = 1; j2 <= 2; ++j2) {
	  mi1 = j2*ml3;
	  mi2 = (j1-1)*mni+1;
	  zgamma = (double) j2/3.0;
	  gcpt(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd,
		zgamma, 0, mi2, mni, mi2, mi1, mi2);
	}
      }
      
      /*     Trisect the diagonal of the diamond. */
      for (j2 = 1; j2 <= 2; ++j2) {
	mi1 = mni-j2*ml3;
	mi2 = j2*ml3+1;
	zgamma = (double) j2/(float)3.;
	gcpt(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd, 
	      zgamma, mni, 1, 0, mni+1, mi1, mi2);
      }
      
      /*     Compute coordinates of icosahedral triangle centers. */
      tricntr(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd, mni);
      
    }
    
    /***********************************************************************/
    /*     Find the coordinates of the triangle nodes by iteratively       */
    /*     bisecting the diamond intervals.                                */

    for (jb = 0; jb <= kni2-1; ++jb) {
      mm = pow_ii(3, kni3)*pow_ii(2, jb);
      ml = mni/mm;
      ml2 = ml/2;
      
      /*     Compute the rows of the diamond. */

      for (j1 = 1; j1 <= mm+1; ++j1) {
	for (j2 = 1; j2 <= mm; ++j2) {
	  mi1 = (j1-1)*ml;
	  mi2 = (j2-1)*ml+ml2+1;
	  gcpt(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd, 
		0.5, mi1, mi2-ml2, mi1, mi2+ml2, mi1, mi2);
	}
      }
      
      /*     Compute the columns of diamond. */

      for (j1 = 1; j1 <= mm+1; ++j1) {
	for (j2 = 1; j2 <= mm; ++j2) {
	  mi1 = (j2-1)*ml+ml2;
	  mi2 = (j1-1)*ml+1;
	  gcpt(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd,
		0.5, mi1-ml2, mi2, mi1+ml2, mi2, mi1, mi2);
	}
      }
      
      /*     Compute the diagonals of the diamond. */

      for (j1 = 1; j1 <= mm; ++j1) {
	for (j2 = 1; j2 <= mm; ++j2) {
	  mi1 = (j1-1)*ml+ml2;
	  mi2 = (j2-1)*ml+ml2+1;
	  gcpt(pxn, kig1s, kig1e, kig2s, kig2e, knd, jd,
		0.5, mi1-ml2, mi2+ml2, mi1+ml2, mi2-ml2, mi1, mi2);
	}
      }

    }

    /***********************************************************************/
    /* Set pxn to 0 if it is less than 2.5 e-14 to avoid round-off errors  */
    
    for (j2 = kig2s; j2 <= kig2e; ++j2) {
      for (j1 = kig1s; j1 <= kig1e; ++j1) {
	if (fabs(pxn[j1+id1*j2+id2*1+id3*jd+ioffset]) < 2.5e-14) {
	  pxn[j1+id1*j2+id2*1+id3*jd+ioffset] = 0.0;
	}
	if (fabs(pxn[j1+id1*j2+id2*2+id3*jd+ioffset]) < 2.5e-14) {
	  pxn[j1+id1*j2+id2*2+id3*jd+ioffset] = 0.0;
	}
	if (fabs(pxn[j1+id1*j2+id2*3+id3*jd+ioffset]) < 2.5e-14) {
	  pxn[j1+id1*j2+id2*3+id3*jd+ioffset] = 0.0;
	}
      }
    }
  }

  /*************************************************************************/
  /*     Calculate the longitude "prlon" and the latitude "prlat";         */
  /*     only for the core of the diamonds, not the extended ones.         */

  for (jd = 1; jd <= knd; ++jd) {
    for (j2 = kig2s; j2 <= kig2e; ++j2) {
      for (j1 = kig1s; j1 <= kig1e; ++j1) {
	prlon[j1+id1*j2+id2*jd+joffset] 
	  = 180.0/M_PI*atan2(pxn[j1+id1*j2+id2*2+id3*jd+ioffset],
		             pxn[j1+id1*j2+id2*1+id3*jd+ioffset]+1.0e-20);
	prlat[j1+id1*j2+id2*jd+joffset] 
	  = 180.0/M_PI*asin(pxn[j1+id1*j2+id2*3+id3*jd+ioffset]);
      }
    }
  }
  
  /*************************************************************************/

  free(mcosv);

  return;
} /* glo_coor */
/*
int main (int argc, char *argv[])
{
  int ni = 6, nd = 10;
  int ni2, ni3;
  int i;

  double *xn, *rlon, *rlat;

  factorni(ni, &ni2, &ni3);

  if (( xn  = (double *) malloc ((ni+1)*(ni+1)*3*nd*sizeof(double))) == NULL) {
    perror("malloc xn");
    exit (EXIT_FAILURE);
  } 

  if ((rlon = (double *) malloc ((ni+1)*(ni+1)  *nd*sizeof(double))) == NULL) {
    perror("malloc rlon");
    exit (EXIT_FAILURE);
  } 

  if ((rlat = (double *) malloc ((ni+1)*(ni+1)  *nd*sizeof(double))) == NULL) {
    perror("malloc rlat");
    exit (EXIT_FAILURE);
  } 

  glo_coor(xn, rlon, rlat, 0, ni, 1, ni+1, nd, ni2, ni3);

  for ( i = 0; i < (ni+1)*(ni+1)*nd; i++ )
    printf ("%d %25.15g %25.15g\n", i, rlon[i], rlat[i]);

  free (xn);
  free (rlon);
  free (rlat);

  return 0;
}
*/
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





char *Grids[] = {
  "undefined",
  "generic",
  "gaussian",
  "gaussian reduced",
  "lonlat",
  "spectral",
  "fourier",
  "triangular",
  "trajectory",
  "cell",
  "curvilinear",
};


static GRID *gridTable;
static int   gridTableSize = 0;

static void gridTableInitEntry(int gridID)
{
  gridTable[gridID].type         = CDI_UNDEFID;
  gridTable[gridID].xvals        = NULL;
  gridTable[gridID].yvals        = NULL;
  gridTable[gridID].area         = NULL;
  gridTable[gridID].xbounds      = NULL;
  gridTable[gridID].ybounds      = NULL;
  gridTable[gridID].rowlon       = NULL;
  gridTable[gridID].nrowlon      = 0;
  gridTable[gridID].xinc         = 0.0;
  gridTable[gridID].yinc         = 0.0;
  gridTable[gridID].trunc        = 0;
  gridTable[gridID].nvertex      = 0;
  gridTable[gridID].nd           = 0;
  gridTable[gridID].ni           = 0;
  gridTable[gridID].ni2          = 0;
  gridTable[gridID].ni3          = 0;
  gridTable[gridID].prec         = 0;
  gridTable[gridID].size         = 0;
  gridTable[gridID].xsize        = 0;
  gridTable[gridID].ysize        = 0;
  gridTable[gridID].isRotated    = FALSE;
  gridTable[gridID].xpole        = 0.0;
  gridTable[gridID].ypole        = 0.0;
  gridTable[gridID].angle        = 0.0;
  gridTable[gridID].locked       = FALSE;
  gridTable[gridID].xname[0]     = 0;
  gridTable[gridID].yname[0]     = 0;
  gridTable[gridID].xlongname[0] = 0;
  gridTable[gridID].ylongname[0] = 0;
  gridTable[gridID].xunits[0]    = 0;
  gridTable[gridID].yunits[0]    = 0;
  gridTable[gridID].xstdname[0]  = 0;
  gridTable[gridID].ystdname[0]  = 0;
}

static int gridTableNewEntry(int gridtype)
{
  static char func[] = "gridTableNewEntry";
  int gridID = 0;

  /*
    Look for a free slot in gridTable.
    (Create the table the first time through).
  */
  if ( ! gridTableSize )
    {
      int i;

      gridTableSize = 2;
      gridTable = (GRID *) malloc(gridTableSize*sizeof(GRID));
      if ( gridTable == NULL )
	{
          Message(func, "gridTableSize = %d", gridTableSize);
	  SysError(func, "Allocation of GRIDTABLE failed");
	}

      for ( i = 0; i < gridTableSize; i++ )
	gridTableInitEntry(i);
    }
  else
    {
      while ( gridID < gridTableSize )
	{
	  if ( gridTable[gridID].type == CDI_UNDEFID ) break;
	  gridID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( gridID == gridTableSize )
    {
      int i;

      gridTableSize = 2*gridTableSize;
      gridTable = (GRID *) realloc(gridTable, gridTableSize*sizeof(GRID));
      if ( gridTable == NULL )
	{
          Message(func, "gridTableSize = %d", gridTableSize);
	  SysError(func, "Reallocation of GRIDTABLE failed");
	}

      gridID = gridTableSize/2;

      for ( i = gridID; i < gridTableSize; i++ )
	gridTableInitEntry(i);
    }

  gridTable[gridID].type = gridtype;

  return (gridID);
}

void gridCheckID(const char *func, int gridID)
{
  if ( gridID < 0 || gridID >= gridTableSize )
    Error(func, "gridID %d undefined!", gridID);

  if ( gridTable[gridID].type == CDI_UNDEFID )
    Error(func, "gridID %d type undefined!", gridID);
}

void gridGenXvals(int xsize, double xfirst, double xlast, double xinc, double *xvals)
{
  int i;

  if ( ! fabs(xinc) && xsize > 1 )
    {
      if ( xfirst >= xlast )
	{
	  while ( xfirst >= xlast ) xlast += 360;
	  xinc = (xlast-xfirst)/(xsize);
	}
      else
	{
	  xinc = (xlast-xfirst)/(xsize-1);
	}
    }

  for ( i = 0; i < xsize; i++ )
    xvals[i] = xfirst + i*xinc;
}

void gridGenYvals(int gridtype, int ysize, double yfirst, double ylast, double yinc, double *yvals)
{
  static char func[] = "gridGenYvals";
  int i;

  if ( gridtype == GRID_GAUSSIAN || gridtype == GRID_GAUSSIAN_REDUCED )
    {
      double *yw;
      int yhsize;

      yw    = (double *) malloc(ysize*sizeof(double));
      gaussaw(yvals, yw, ysize);
      free(yw);
      for ( i = 0; i < ysize; i++ )
	yvals[i] = asin(yvals[i])/M_PI*180.0;

      if ( yfirst < ylast && yfirst > -90.0 && ylast < 90.0 )
	{
	  double ytmp;
	  yhsize = ysize/2;
	  for ( i = 0; i < yhsize; i++ )
	    {
	      ytmp = yvals[i];
	      yvals[i] = yvals[ysize-i-1];
	      yvals[ysize-i-1] = ytmp;
	    }
	}
    }
  /*     else if ( gridtype == GRID_LONLAT || gridtype == GRID_GENERIC ) */
  else
    {
      if ( ! fabs(yinc) && ysize > 1 )
	{
	  if ( yfirst == ylast && yfirst != 0 ) ylast *= -1;

	  if ( yfirst > ylast )
	    yinc = (yfirst-ylast)/(ysize-1);
	  else if ( yfirst < ylast )
	    yinc = (ylast-yfirst)/(ysize-1);
	  else
	    {
	      if ( ysize%2 != 0 )
		{
		  yinc = 180.0/(ysize-1);
		  yfirst = -90;
		}
	      else
		{
		  yinc = 180.0/ysize;
		  yfirst = -90 + yinc/2;
		}
	    }
	}

      if ( yfirst > ylast && yinc > 0 ) yinc = -yinc;

      for ( i = 0; i < ysize; i++ )
	yvals[i] = yfirst + i*yinc;
    }
  /*
    else
    Error(func, "unable to calculate values for %s grid!", gridNamePtr(gridtype));
  */
}
/*
static void defineXvals(int gridID)
{
  static char func[] = "defineXvals";

  if ( gridTable[gridID].type == GRID_CELL ) return;

  if ( gridTable[gridID].xvals == NULL )
    {
      double *xvals, xfirst, xlast, xinc;
      int i, xsize;

      xsize = gridTable[gridID].xsize;
      if ( xsize == 0 )
	Error(func, "xsize undefined for gridID = %d", gridID);

      xvals = (double *) malloc(xsize*sizeof(double));
      xfirst = gridTable[gridID].xfirst;
      xlast  = gridTable[gridID].xlast;
      xinc = gridTable[gridID].xinc;
      if ( ! fabs(xinc) )
	{
	  if ( xfirst > xlast )
	    xinc = (xfirst-xlast)/xsize;
	  else
	    xinc = (xlast-xfirst)/xsize;

	  gridTable[gridID].xinc = xinc;
	}
      if ( xfirst > xlast && xinc > 0 ) xinc = -xinc;
      for ( i = 0; i < xsize; i++ )
	xvals[i] = xfirst + i*xinc;

      gridTable[gridID].xvals = xvals;
    }
}
*/

static void defineYvals(int gridID)
{
  static char func[] = "defineYvals";
  int gridtype;

  gridtype = gridTable[gridID].type;

  if ( gridtype == GRID_CELL ) return;

  if ( gridTable[gridID].yvals == NULL )
    {
      double *yvals, yfirst, ylast, yinc;
      int i, ysize;

      ysize = gridTable[gridID].ysize;

      if ( gridtype == GRID_GAUSSIAN || gridtype == GRID_GAUSSIAN_REDUCED )
	{
	  double *yw;
	  int yhsize;

	  yvals = (double *) malloc(ysize*sizeof(double));
	  yw    = (double *) malloc(ysize*sizeof(double));
	  gaussaw(yvals, yw, ysize);
	  free(yw);
	  for ( i = 0; i < ysize; i++ )
	    yvals[i] = asin(yvals[i])/M_PI*180.0;

	  yfirst = gridTable[gridID].yfirst;
	  ylast  = gridTable[gridID].ylast;
	  if ( yfirst < ylast && yfirst > -90.0 && ylast < 90.0 )
	    {
	      double ytmp;
	      yhsize = ysize/2;
	      for ( i = 0; i < yhsize; i++ )
		{
		  ytmp = yvals[i];
		  yvals[i] = yvals[ysize-i-1];
		  yvals[ysize-i-1] = ytmp;
		}
	    }
	  gridTable[gridID].yvals = yvals;
	}
      /*     else if ( gridtype == GRID_LONLAT || gridtype == GRID_GENERIC ) */
      else
	{
	  if ( ysize == 0 )
	    Error(func, "ysize undefined for gridID = %d", gridID);

	  yvals = (double *) malloc(ysize*sizeof(double));
	  yfirst = gridTable[gridID].yfirst;
	  ylast  = gridTable[gridID].ylast;
	  yinc = gridTable[gridID].yinc;
	  if ( ! fabs(yinc) )
	    {
	      if ( ysize > 1 )
		{
		  if ( yfirst > ylast )
		    yinc = (yfirst-ylast)/(ysize-1);
		  else
		    yinc = (ylast-yfirst)/(ysize-1);
		}

	      gridTable[gridID].yinc = yinc;
	    }
	  if ( yfirst > ylast && yinc > 0 ) yinc = -yinc;
	  for ( i = 0; i < ysize; i++ )
	    yvals[i] = yfirst + i*yinc;

	  gridTable[gridID].yvals = yvals;
	}
      /*
      else
	Error(func, "unable to calculate values for %s grid!", gridNamePtr(gridtype));
      */
    }
}


/*
@Function  gridNew
@Title     Create a new Grid

@Prototype int gridNew(int gridtype, int size)
@Parameter
    @Item  gridtype  The type of the grid, one of the set of predefined CDI grid types.
                     The valid CDI grid types are {\tt GRID_GENERIC}, {\tt GRID_GAUSSIAN},
                     {\tt GRID_LONLAT}, {\tt GRID_SPECTRAL}, {\tt GRID_CURVILINEAR} and {\tt GRID_CELL}.
    @Item  size      Number of gridpoints.

@Description
The function {\tt gridNew} creates a new Grid.

@Result
{\tt gridNew} return an identifier to the new Grid.

@EndFunction
*/
int gridNew(int gridtype, int size)
{
  static char func[] = "gridNew";
  int gridID;

  if ( CDI_Debug )
    Message(func, "gridtype: %d size: %d", gridtype, size);

  /* get next free grid entry */
  gridID = gridTableNewEntry(gridtype);

  if ( CDI_Debug ) Message(func, "gridID: %d", gridID);

  gridTable[gridID].size = size;

  /*  if ( gridtype == GRID_GENERIC )     gridTable[gridID].xsize = size; */
  if ( gridtype == GRID_CELL )        gridTable[gridID].xsize = size;
  if ( gridtype == GRID_CURVILINEAR ) gridTable[gridID].nvertex = 4;

  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
    case GRID_GAUSSIAN_REDUCED:
    case GRID_CURVILINEAR:
    case GRID_TRAJECTORY:
      {
	if ( gridtype == GRID_TRAJECTORY )
	  {
	    gridDefXname(gridID, "tlon");
	    gridDefYname(gridID, "tlat");
	  }
	else
	  {
	    gridDefXname(gridID, "lon");
	    gridDefYname(gridID, "lat");
	  }
	gridDefXlongname(gridID, "longitude");
	gridDefYlongname(gridID, "latitude");
	strcpy(gridTable[gridID].xstdname, "longitude");
	strcpy(gridTable[gridID].ystdname, "latitude");
	gridDefXunits(gridID, "degrees_east");
	gridDefYunits(gridID, "degrees_north");

	break;
      }
    case GRID_TRIANGULAR:
    case GRID_CELL:
    case GRID_GENERIC:
      {
	gridDefXname(gridID, "x");
	gridDefYname(gridID, "y");
	break;
      }
    }

  return (gridID);
}

char *gridNamePtr(int gridtype)
{
  char *name;
  int size = sizeof(Grids)/sizeof(char *);

  if ( gridtype > 0 && gridtype < size )
    name = Grids[gridtype];
  else
    name = Grids[0];

  return (name);
}


/*
@Function  gridDefXname
@Title     Define the name of a X-axis

@Prototype void gridDefXname(int gridID, const char *name)
@Parameter
    @Item  gridID    Grid identifier
    @Item  name      Name of the X-axis

@Description
The function {\tt gridDefXname} defines the name of a X-axis.

@EndFunction
*/
void gridDefXname(int gridID, char *xname)
{
  if ( xname )
    strcpy(gridTable[gridID].xname, xname);
}


/*
@Function  gridDefXlongname
@Title     Define the longname of a X-axis

@Prototype void gridDefXlongname(int gridID, const char *longname)
@Parameter
    @Item  gridID    Grid identifier
    @Item  longname  Longname of the X-axis

@Description
The function {\tt gridDefXlongname} defines the longname of a X-axis.

@EndFunction
*/
void gridDefXlongname(int gridID, char *xlongname)
{
  if ( xlongname )
    strcpy(gridTable[gridID].xlongname, xlongname);
}


/*
@Function  gridDefXunits
@Title     Define the units of a X-axis

@Prototype void gridDefXunits(int gridID, const char *units)
@Parameter
    @Item  gridID    Grid identifier
    @Item  units     Units of the X-axis

@Description
The function {\tt gridDefXunits} defines the units of a X-axis.

@EndFunction
*/
void gridDefXunits(int gridID, char *xunits)
{
  if ( xunits )
    strcpy(gridTable[gridID].xunits, xunits);
}


/*
@Function  gridDefYname
@Title     Define the name of a Y-axis

@Prototype void gridDefYname(int gridID, const char *name)
@Parameter
    @Item  gridID    Grid identifier
    @Item  name      Name of the Y-axis

@Description
The function {\tt gridDefYname} defines the name of a Y-axis.

@EndFunction
*/
void gridDefYname(int gridID, char *yname)
{
  if ( yname )
    strcpy(gridTable[gridID].yname, yname);
}


/*
@Function  gridDefYlongname
@Title     Define the longname of a Y-axis

@Prototype void gridDefYlongname(int gridID, const char *longname)
@Parameter
    @Item  gridID    Grid identifier
    @Item  longname  Longname of the Y-axis

@Description
The function {\tt gridDefYlongname} defines the longname of a Y-axis.

@EndFunction
*/
void gridDefYlongname(int gridID, char *ylongname)
{
  if ( ylongname )
    strcpy(gridTable[gridID].ylongname, ylongname);
}


/*
@Function  gridDefYunits
@Title     Define the units of a Y-axis

@Prototype void gridDefYunits(int gridID, const char *units)
@Parameter
    @Item  gridID    Grid identifier
    @Item  units     Units of the Y-axis

@Description
The function {\tt gridDefYunits} defines the units of a Y-axis.

@EndFunction
*/
void gridDefYunits(int gridID, char *yunits)
{
  if ( yunits )
    strcpy(gridTable[gridID].yunits, yunits);
}


/*
@Function  gridInqXname
@Title     Get the name of a X-axis

@Prototype void gridInqXname(int gridID, const char *name)
@Parameter
    @Item  gridID    Grid identifier
    @Item  name      Name of the X-axis

@Description
The function {\tt gridInqXname} gets the name of a X-axis.

@Result
{\tt gridInqXname} return the name of the X-axis to the parameter name.

@EndFunction
*/
void gridInqXname(int gridID, char *xname)
{
  strcpy(xname, gridTable[gridID].xname);
}


/*
@Function  gridInqXlongname
@Title     Get the longname of a X-axis

@Prototype void gridInqXlongname(int gridID, const char *longname)
@Parameter
    @Item  gridID    Grid identifier
    @Item  longname  Longname of the X-axis

@Description
The function {\tt gridInqXlongname} gets the longname of a X-axis.

@Result
{\tt gridInqXlongname} return the longname of the X-axis to the parameter longname.

@EndFunction
*/
void gridInqXlongname(int gridID, char *xlongname)
{
  strcpy(xlongname, gridTable[gridID].xlongname);
}


/*
@Function  gridInqXunits
@Title     Get the units of a X-axis

@Prototype void gridInqXunits(int gridID, const char *units)
@Parameter
    @Item  gridID    Grid identifier
    @Item  units     Units of the X-axis

@Description
The function {\tt gridInqXunits} gets the units of a X-axis.

@Result
{\tt gridInqXunits} return the units of the X-axis to the parameter units.

@EndFunction
*/
void gridInqXunits(int gridID, char *xunits)
{
  strcpy(xunits, gridTable[gridID].xunits);
}


void gridInqXstdname(int gridID, char *xstdname)
{
  strcpy(xstdname, gridTable[gridID].xstdname);
}


/*
@Function  gridInqYname
@Title     Get the name of a Y-axis

@Prototype void gridInqYname(int gridID, const char *name)
@Parameter
    @Item  gridID    Grid identifier
    @Item  name      Name of the Y-axis

@Description
The function {\tt gridInqYname} gets the name of a Y-axis.

@Result
{\tt gridInqYname} return the name of the Y-axis to the parameter name.

@EndFunction
*/
void gridInqYname(int gridID, char *yname)
{
  strcpy(yname, gridTable[gridID].yname);
}


/*
@Function  gridInqYlongname
@Title     Get the longname of a Y-axis

@Prototype void gridInqXlongname(int gridID, const char *longname)
@Parameter
    @Item  gridID    Grid identifier
    @Item  longname  Longname of the Y-axis

@Description
The function {\tt gridInqYlongname} gets the longname of a Y-axis.

@Result
{\tt gridInqYlongname} return the longname of the Y-axis to the parameter longname.

@EndFunction
*/
void gridInqYlongname(int gridID, char *ylongname)
{
  strcpy(ylongname, gridTable[gridID].ylongname);
}


/*
@Function  gridInqYunits
@Title     Get the units of a Y-axis

@Prototype void gridInqYunits(int gridID, const char *units)
@Parameter
    @Item  gridID    Grid identifier
    @Item  units     Units of the Y-axis

@Description
The function {\tt gridInqYunits} gets the units of a Y-axis.

@Result
{\tt gridInqYunits} return the units of the Y-axis to the parameter units.

@EndFunction
*/
void gridInqYunits(int gridID, char *yunits)
{
  strcpy(yunits, gridTable[gridID].yunits);
}

void gridInqYstdname(int gridID, char *ystdname)
{
  strcpy(ystdname, gridTable[gridID].ystdname);
}


/*
@Function  gridInqType
@Title     Get the type of a Grid

@Prototype int gridInqType(int gridID)
@Parameter
    @Item  gridID  Grid identifier

@Description
The function {\tt gridInqType} get the type of a Grid.

@Result
{\tt gridInqType} return the type of the grid,
one of the set of predefined CDI grid types.
The valid CDI grid types are {\tt GRID_GENERIC}, {\tt GRID_GAUSSIAN},
{\tt GRID_LONLAT}, {\tt GRID_SPECTRAL}, {\tt GRID_CURVILINEAR} and {\tt GRID_CELL}.

@EndFunction
*/
int gridInqType(int gridID)
{
  static char func[] = "gridInqType";

  gridCheckID(func, gridID);

  return (gridTable[gridID].type);
}


/*
@Function  gridInqSize
@Title     Get the size of a Grid

@Prototype int gridInqSize(int gridID)
@Parameter
    @Item  gridID  Grid identifier

@Description
The function {\tt gridInqSize} get the size of a Grid.

@Result
{\tt gridInqSize} return the number of grid points of a Grid.

@EndFunction
*/
int gridInqSize(int gridID)
{
  static char func[] = "gridInqSize";
  int size = 0;

  gridCheckID(func, gridID);

  size = gridTable[gridID].size;

  if ( ! size )
    {
      int xsize, ysize;

      xsize = gridTable[gridID].xsize;
      ysize = gridTable[gridID].ysize;

      if ( ysize )
	size = xsize *ysize;
      else
	size = xsize;

      gridTable[gridID].size = size;  
    }

  return (size);
}

static int nlat2trunc(int nlat)
{
  int trunc;

  trunc = (nlat*2 - 1) / 3;

  return (trunc);
}

static int nsp2trunc(int nsp)
{
  /*  nsp = (trunc+1)*(trunc+1)              */
  /*      => trunc^2 + 3*trunc - (x-2) = 0   */
  /*                                         */
  /*  with:  y^2 + p*y + q = 0               */
  /*         y = -p/2 +- sqrt((p/2)^2 - q)   */
  /*         p = 3 and q = - (x-2)           */
  int trunc;

  trunc = (int) (sqrt(nsp*4.0 + 1) - 3) / 2;

  return (trunc);
}

static int trunc2nlat(int trunc)
{
  int nlat;

  nlat = (trunc*3 + 1) / 2;

  if ( (nlat % 2) > 0 ) nlat++;

  return (nlat);
}

int gridInqTrunc(int gridID)
{
  static char func[] = "gridInqTrunc";

  gridCheckID(func, gridID);

  if ( gridTable[gridID].trunc == 0 )
    {
      if      ( gridTable[gridID].type == GRID_GAUSSIAN )
	gridTable[gridID].trunc = nlat2trunc(gridTable[gridID].ysize);
      else if ( gridTable[gridID].type == GRID_SPECTRAL )
	gridTable[gridID].trunc = nsp2trunc(gridTable[gridID].size);
    }

  return (gridTable[gridID].trunc);
}

void gridDefTrunc(int gridID, int trunc)
{
  static char func[] = "gridDefTrunc";

  gridCheckID(func, gridID);

  gridTable[gridID].trunc = trunc;
}

void gridDefXsize(int gridID, int xsize)
{
  static char func[] = "gridDefXsize";

  gridCheckID(func, gridID);

  if ( xsize > gridInqSize(gridID) )
    Error(func, "xsize %d is greater then gridsize %d", xsize, gridInqSize(gridID));

  if ( gridInqType(gridID) == GRID_CELL && xsize != gridInqSize(gridID) )
    Error(func, "xsize %d musst be equal gridsize %d for gridtype CELL", xsize, gridInqSize(gridID));

  gridTable[gridID].xsize = xsize;

  if ( gridInqType(gridID) != GRID_CELL && 
       gridTable[gridID].xsize*gridTable[gridID].ysize > gridInqSize(gridID) )
    Error(func, "inconsistent grid declaration! (xsize %d ysize %d gridsize %d)",
	  gridTable[gridID].xsize, gridTable[gridID].ysize, gridInqSize(gridID));
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefPrec(int gridID, int prec)
{
  static char func[] = "gridDefPrec";

  gridCheckID(func, gridID);

  gridTable[gridID].prec = prec;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqPrec(int gridID)
{
  static char func[] = "gridInqPrec";

  gridCheckID(func, gridID);

  return (gridTable[gridID].prec);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqXsize(int gridID)
{
  static char func[] = "gridInqXsize";

  gridCheckID(func, gridID);

  return (gridTable[gridID].xsize);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefYsize(int gridID, int ysize)
{
  static char func[] = "gridDefYsize";

  gridCheckID(func, gridID);

  if ( ysize > gridInqSize(gridID) )
    Error(func, "ysize %d is greater then gridsize %d", ysize, gridInqSize(gridID));

  if ( gridInqType(gridID) == GRID_CELL && ysize != gridInqSize(gridID) )
    Error(func, "ysize %d musst be equal gridsize %d for gridtype CELL", ysize, gridInqSize(gridID));

  gridTable[gridID].ysize = ysize;

  if ( gridInqType(gridID) != GRID_CELL && 
       gridTable[gridID].xsize*gridTable[gridID].ysize > gridInqSize(gridID) )
    Error(func, "inconsistent grid declaration! (xsize %d ysize %d gridsize %d)",
	  gridTable[gridID].xsize, gridTable[gridID].ysize, gridInqSize(gridID));
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqYsize(int gridID)
{
  static char func[] = "gridInqYsize";

  gridCheckID(func, gridID);

  return (gridTable[gridID].ysize);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefRowlon(int gridID, int nrowlon, int *rowlon)
{
  static char func[] = "gridDefRowlon";
  
  gridCheckID(func, gridID);

  gridTable[gridID].rowlon = (int *) malloc(nrowlon*sizeof(int));
  gridTable[gridID].nrowlon = nrowlon;

  memcpy(gridTable[gridID].rowlon, rowlon, nrowlon*sizeof(int));
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridInqRowlon(int gridID, int *rowlon)
{
  static char func[] = "gridInqRowlon";

  gridCheckID(func, gridID);

  if ( gridTable[gridID].rowlon == 0 )  Error(func, "undefined pointer");

  memcpy(rowlon, gridTable[gridID].rowlon, gridTable[gridID].nrowlon*sizeof(int));
}


/*
@Function  gridInqXvals
@Title     Get all values of a X-axis

@Prototype int gridInqXvals(int gridID, double *xvals)
@Parameter
    @Item  gridID    Grid identifier
    @Item  xvals     X-values of the grid

@Description
The function {\tt gridInqXvals} gets all values of the X-axis.

@Result
Upon successful completion {\tt gridInqXvals} return the number of values and
the values are stored in {\tt xvals}.
Otherwise, 0 is returned and {\tt xvals} is empty.

@EndFunction
*/
int gridInqXvals(int gridID, double *xvals)
{
  static char func[] = "gridInqXvals";
  int size;
  int i;

  gridCheckID(func, gridID);

  if ( gridTable[gridID].type == GRID_CURVILINEAR )
    size = gridTable[gridID].size;
  else
    size = gridTable[gridID].xsize;

  if ( CDI_Debug && size == 0 )
    Warning(func, "size undefined for gridID = %d", gridID);
    
  if ( xvals && gridTable[gridID].xvals )
    for ( i = 0; i < size; i++ )
      xvals[i] = gridTable[gridID].xvals[i];

  if ( gridTable[gridID].xvals == NULL ) size = 0;

  return (size);
}


/*
@Function  gridDefXvals
@Title     Define the values of a X-axis

@Prototype void gridDefXvals(int gridID, double *xvals)
@Parameter
    @Item  gridID    Grid identifier
    @Item  xvals     X-values of the grid

@Description
The function {\tt gridDefXvals} defines all values of the X-axis.

@EndFunction
*/
void gridDefXvals(int gridID, double *xvals)
{
  static char func[] = "gridDefXvals";
  int size;
  int gridtype;
  int i;

  gridCheckID(func, gridID);

  gridtype = gridTable[gridID].type;

  if ( gridtype == GRID_CELL || gridtype == GRID_CURVILINEAR )
    size = gridTable[gridID].size;
  else
    size = gridTable[gridID].xsize;

  if ( size == 0 )
    Error(func, "size undefined for gridID = %d", gridID);
    
  if ( gridTable[gridID].xvals == NULL )
    gridTable[gridID].xvals = (double *) malloc(size*sizeof(double));
  else if ( CDI_Debug )
    Warning(func, "values allready defined!");

  for ( i = 0; i < size; i++ )
    gridTable[gridID].xvals[i] = xvals[i];
}


/*
@Function  gridInqYvals
@Title     Get all values of a Y-axis

@Prototype int gridInqYvals(int gridID, double *yvals)
@Parameter
    @Item  gridID    Grid identifier
    @Item  yvals     Y-values of the grid

@Description
The function {\tt gridInqYvals} gets all values of the Y-axis.

@Result
Upon successful completion {\tt gridInqYvals} return the number of values and
the values are stored in {\tt yvals}.
Otherwise, 0 is returned and {\tt yvals} is empty.

@EndFunction
*/
int gridInqYvals(int gridID, double *yvals)
{
  static char func[] = "gridInqYvals";
  int size;
  int i;

  gridCheckID(func, gridID);

  if ( gridTable[gridID].type == GRID_CURVILINEAR )
    size = gridTable[gridID].size;
  else
    size = gridTable[gridID].ysize;

  if ( CDI_Debug && size == 0 )
    Warning(func, "size undefined for gridID = %d", gridID);
    
  if ( yvals && gridTable[gridID].yvals )
    for ( i = 0; i < size; i++ )
      yvals[i] =  gridTable[gridID].yvals[i];

  if ( gridTable[gridID].yvals == NULL ) size = 0;

  return (size);
}


/*
@Function  gridDefYvals
@Title     Define the values of a Y-axis

@Prototype void gridDefYvals(int gridID, double *yvals)
@Parameter
    @Item  gridID    Grid identifier
    @Item  yvals     Y-values of the grid

@Description
The function {\tt gridDefYvals} defines all values of the Y-axis.

@EndFunction
*/
void gridDefYvals(int gridID, double *yvals)
{
  static char func[] = "gridDefYvals";
  int size;
  int gridtype;
  int i;

  gridCheckID(func, gridID);

  gridtype = gridTable[gridID].type;

  if ( gridtype == GRID_CELL || gridtype == GRID_CURVILINEAR )
    size = gridTable[gridID].size;
  else
    size = gridTable[gridID].ysize;

  if ( size == 0 )
    Error(func, "size undefined for gridID = %d", gridID);
    
  if ( gridTable[gridID].yvals == NULL )
    gridTable[gridID].yvals = (double *) malloc(size*sizeof(double));
  else if ( CDI_Debug )
    Warning(func, "values allready defined!");
    
  for ( i = 0; i < size; i++ )
    gridTable[gridID].yvals[i] = yvals[i];
}


double gridInqXval(int gridID, int index)
{
  double xval = 0;

  if ( gridTable[gridID].xvals )
    xval = gridTable[gridID].xvals[index];

  return (xval);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
double gridInqYval(int gridID, int index)
{
  double yval = 0;

  if ( gridTable[gridID].yvals )
    yval = gridTable[gridID].yvals[index];

  return (yval);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
double gridInqXinc(int gridID)
{
  double xinc;

  xinc = gridTable[gridID].xinc;

  if ( ! fabs(xinc) && gridTable[gridID].xvals )
    {
      int xsize;
      double *xvals;

      xsize = gridTable[gridID].xsize;
      xvals = gridTable[gridID].xvals;

      if ( xsize > 1 )
	{
	  int i;
	  xinc = fabs(xvals[0] - xvals[1]);
	  for ( i = 2; i < xsize; i++ )
	    if ( fabs(fabs(xvals[i-1] - xvals[i]) - xinc) > (xinc/1000) ) break;
		  
	  if ( i < xsize ) xinc = 0;
	}
    }

  return (xinc);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
double gridInqYinc(int gridID)
{
  double yinc;

  yinc = gridTable[gridID].yinc;

  if ( ! fabs(yinc) && gridTable[gridID].yvals )
    {
      int ysize;
      double *yvals;

      ysize = gridTable[gridID].ysize;
      yvals = gridTable[gridID].yvals;

      if ( ysize > 1 )
	{
	  int i;
	  yinc = fabs(yvals[1] - yvals[0]);
	  for ( i = 2; i < ysize; i++ )
	    if ( fabs(fabs(yvals[i] - yvals[i-1]) - yinc) > (yinc/1000) ) break;
		  
	  if ( i < ysize ) yinc = 0;
	  else             yinc = yvals[1] - yvals[0];
	}
    }

  return (yinc);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
double gridInqXpole(int gridID)
{
  return (gridTable[gridID].xpole);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefXpole(int gridID, double xpole)
{
  gridTable[gridID].isRotated = TRUE;
  gridTable[gridID].xpole = xpole;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
double gridInqYpole(int gridID)
{
  return (gridTable[gridID].ypole);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefYpole(int gridID, double ypole)
{
  gridTable[gridID].isRotated = TRUE;
  gridTable[gridID].ypole = ypole;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
double gridInqAngle(int gridID)
{
  return (gridTable[gridID].angle);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefAngle(int gridID, double angle)
{
  gridTable[gridID].isRotated = TRUE;
  gridTable[gridID].angle = angle;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqTriNd(int gridID)
{
  return (gridTable[gridID].nd);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefTriNd(int gridID, int nd)
{
  gridTable[gridID].nd = nd;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqTriNi(int gridID)
{
  return (gridTable[gridID].ni);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefTriNi(int gridID, int ni)
{
  gridTable[gridID].ni = ni;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqTriNi2(int gridID)
{
  return (gridTable[gridID].ni2);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridDefTriNi2(int gridID, int ni2)
{
  gridTable[gridID].ni2 = ni2;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridInqTriNi3(int gridID)
{
  return (gridTable[gridID].ni3);
}

void gridDefTriNi3(int gridID, int ni3)
{
  gridTable[gridID].ni3 = ni3;
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
int gridSize(void)
{
  int gridID = 0;

  while ( gridID < gridTableSize )
    {
      if ( gridTable[gridID].type == CDI_UNDEFID ) break;
      gridID++;
    }

  return (gridID);
}


/*
@Function  
@Title     

@Prototype 
@Parameter
    @Item  Grid identifier

@EndFunction
*/
void gridChangeType(int gridID, int gridtype)
{
  static char func[] = "gridChangeType";

  Message(func, "Change grid type from %s to %s\n",
	  gridNamePtr(gridTable[gridID].type),
	  gridNamePtr(gridtype));
  
  gridTable[gridID].type = gridtype;
}


int gridIsRotated(int gridID)
{
  return ( gridTable[gridID].isRotated );
}


int gridCompare(int gridID, GRID grid)
{
  int differ = 1;
  int xsize, ysize;

  xsize = grid.xsize;
  ysize = grid.ysize;

  if ( grid.type == gridInqType(gridID) || grid.type == GRID_GENERIC )
    {
      if ( grid.size == gridInqSize(gridID) )
	{
	  differ = 0;
	  if ( grid.type == GRID_LONLAT )
	    {
	      /*
	      printf("gridID      %d\n", gridID);
	      printf("grid.xsize  %d\n", grid.xsize);
	      printf("grid.ysize  %d\n", grid.ysize);
	      printf("grid.xfirst %f\n", grid.xfirst);
	      printf("grid.yfirst %f\n", grid.yfirst);
	      printf("grid.xfirst %f\n", gridInqXval(gridID, 0));
	      printf("grid.yfirst %f\n", gridInqYval(gridID, 0));
	      printf("grid.xinc   %f\n", grid.xinc);
	      printf("grid.yinc   %f\n", grid.yinc);
	      printf("grid.xinc   %f\n", gridInqXinc(gridID));
	      printf("grid.yinc   %f\n", gridInqYinc(gridID));
	      */
	      if ( grid.xsize == gridInqXsize(gridID) &&
		   grid.ysize == gridInqYsize(gridID) )
		if ( grid.xdef == 2 && grid.ydef == 2 )
		  if ( ! (grid.xfirst == 0 && grid.xlast == 0 && grid.xinc == 0) &&
		       ! (grid.yfirst == 0 && grid.ylast == 0 && grid.yinc == 0) )
		    if ( grid.xfirst != gridInqXval(gridID, 0) ||
			 grid.yfirst != gridInqYval(gridID, 0) ||
			 fabs(fabs(grid.xinc) - fabs(gridInqXinc(gridID))) > fabs(grid.xinc/1000) ||
			 fabs(fabs(grid.yinc) - fabs(gridInqYinc(gridID))) > fabs(grid.yinc/1000) )
		      {
			differ = 1;
		      }
	    }
	  else if ( grid.type == GRID_CURVILINEAR )
	    {
	      /*
	      printf("gridID      %d\n", gridID);
	      printf("grid.xsize  %d\n", grid.xsize);
	      printf("grid.ysize  %d\n", grid.ysize);
	      printf("grid.xfirst %f\n", grid.xvals[0]);
	      printf("grid.yfirst %f\n", grid.yvals[0]);
	      printf("grid.xfirst %f\n", gridInqXval(gridID, 0));
	      printf("grid.yfirst %f\n", gridInqYval(gridID, 0));
	      printf("grid.xlast  %f\n", grid.xvals[xsize-1]);
	      printf("grid.ylast  %f\n", grid.yvals[ysize-1]);
	      printf("grid.xlast  %f\n", gridInqXval(gridID, xsize-1));
	      printf("grid.ylast  %f\n", gridInqYval(gridID, ysize-1));
	      */
	      if ( grid.xsize == gridInqXsize(gridID) &&
		   grid.ysize == gridInqYsize(gridID) )
		if ( grid.xvals && gridInqXvalsPtr(gridID) )
		  {
		    if ( fabs(grid.xvals[0] - gridInqXval(gridID, 0)) > 1.e-9 ||
			 fabs(grid.xvals[xsize-1] - gridInqXval(gridID, xsize-1)) > 1.e-9 )
		      differ = 1;
		  }
		if ( grid.yvals && gridInqYvalsPtr(gridID) )
		  {
		    if ( fabs(grid.yvals[0] - gridInqYval(gridID, 0)) > 1.e-9 ||
			 fabs(grid.yvals[ysize-1] - gridInqYval(gridID, ysize-1)) > 1.e-9 )
		      differ = 1;
		  }
	    }
	}
    }

  return (differ);
}

int gridGenerate(GRID grid)
{
  static char func[] = "gridGenerate";
  int gridID;

  gridID = gridNew(grid.type, grid.size);

  gridDefPrec(gridID, grid.prec);
	  
  switch (grid.type)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
    case GRID_CELL:
    case GRID_CURVILINEAR:
    case GRID_GENERIC:
      {
	if ( grid.xsize > 0 ) gridDefXsize(gridID, grid.xsize);
	if ( grid.ysize > 0 ) gridDefYsize(gridID, grid.ysize);

	if ( grid.nvertex > 0 )
	  gridDefNvertex(gridID, grid.nvertex);

	if ( grid.xdef == 1 )
	  {
	    gridDefXvals(gridID, grid.xvals);
	    if ( grid.xbounds )
	      gridDefXbounds(gridID, grid.xbounds);
	  }
	else if ( grid.xdef == 2 )
	  {
	    double *xvals = (double *) malloc(grid.xsize*sizeof(double));
	    gridGenXvals(grid.xsize, grid.xfirst, grid.xlast, grid.xinc, xvals);
	    gridDefXvals(gridID, xvals);
	    free(xvals);
	    /*
	    gridDefXinc(gridID, grid.xinc);
	    */
	  }

	if ( grid.ydef == 1 )
	  {
	    gridDefYvals(gridID, grid.yvals);
	    if ( grid.ybounds && grid.nvertex )
	      gridDefYbounds(gridID, grid.ybounds);
	  }
	else if ( grid.ydef == 2 )
	  {
	    double *yvals = (double *) malloc(grid.ysize*sizeof(double));
	    gridGenYvals(grid.type, grid.ysize, grid.yfirst, grid.ylast, grid.yinc, yvals);
	    gridDefYvals(gridID, yvals);
	    free(yvals);
	    /*
	    gridDefYinc(gridID, grid.yinc);
	    */
	  }

	if ( grid.isRotated )
	  {
	    gridDefXname(gridID, "rlon");
	    gridDefYname(gridID, "rlat");
	    gridDefXlongname(gridID, "longitude in rotated pole grid");
	    gridDefYlongname(gridID, "latitude in rotated pole grid");
	    strcpy(gridTable[gridID].xstdname, "grid_longitude");
	    strcpy(gridTable[gridID].ystdname, "grid_latitude");
	    gridDefXunits(gridID, "degrees");
	    gridDefYunits(gridID, "degrees");

	    gridDefXpole(gridID, grid.xpole);
	    gridDefYpole(gridID, grid.ypole);
	    gridDefAngle(gridID, grid.angle);
	  }

	if ( grid.area )
	  {
	    gridDefArea(gridID, grid.area);
	  }

	break;
      }
    case GRID_GAUSSIAN_REDUCED:
      {
	gridDefYsize(gridID, grid.ysize);
	gridDefRowlon(gridID, grid.ysize, grid.rowlon);
	break;
      }
    case GRID_SPECTRAL:
      {
	gridDefTrunc(gridID, grid.trunc);
	break;
      }
    case GRID_TRIANGULAR:
      {
	gridDefTriNd(gridID, grid.nd);
	gridDefTriNi(gridID, grid.ni);
	gridDefTriNi2(gridID, grid.ni2);
	gridDefTriNi3(gridID, grid.ni3);
	break;
      }
      /*
    case GRID_GENERIC:
      {
	if ( grid.xsize > 0 && grid.ysize > 0 )
	  {
	    gridDefXsize(gridID, grid.xsize);
	    gridDefYsize(gridID, grid.ysize);
	    if ( grid.xvals ) gridDefXvals(gridID, grid.xvals);
	    if ( grid.yvals ) gridDefYvals(gridID, grid.yvals);
	  }
	break;
      }
      */
    case GRID_TRAJECTORY:
      {
	gridDefXsize(gridID, 1);
	gridDefYsize(gridID, 1);
	break;
      }
    default:
      {
	Error(func, "Gridtype %s unsupported!", gridNamePtr(grid.type));
	break;
      }
    }

  if ( grid.xname[0]     ) gridDefXname(gridID, grid.xname);
  if ( grid.xlongname[0] ) gridDefXlongname(gridID, grid.xlongname);
  if ( grid.xunits[0]    ) gridDefXunits(gridID, grid.xunits);
  if ( grid.yname[0]     ) gridDefYname(gridID, grid.yname);
  if ( grid.ylongname[0] ) gridDefYlongname(gridID, grid.ylongname);
  if ( grid.yunits[0]    ) gridDefYunits(gridID, grid.yunits);

  return (gridID);
}


int gridDuplicate(int gridID)
{
  static char func[] = "gridDuplicate";
  int gridIDnew;
  int gridtype, gridsize;
  int nrowlon;
  int size;

  gridtype = gridInqType(gridID);
  gridsize = gridInqSize(gridID);

  gridIDnew = gridNew(gridtype, gridsize);

  memcpy(&gridTable[gridIDnew], &gridTable[gridID], sizeof(GRID));

  strcpy(gridTable[gridIDnew].xname, gridTable[gridID].xname);
  strcpy(gridTable[gridIDnew].yname, gridTable[gridID].yname);
  strcpy(gridTable[gridIDnew].xlongname, gridTable[gridID].xlongname);
  strcpy(gridTable[gridIDnew].ylongname, gridTable[gridID].ylongname);
  strcpy(gridTable[gridIDnew].xunits, gridTable[gridID].xunits);
  strcpy(gridTable[gridIDnew].yunits, gridTable[gridID].yunits);
  strcpy(gridTable[gridIDnew].xstdname, gridTable[gridID].xstdname);
  strcpy(gridTable[gridIDnew].ystdname, gridTable[gridID].ystdname);

  nrowlon = gridTable[gridID].nrowlon;
  if ( nrowlon )
    {
      gridTable[gridIDnew].rowlon = (int *) malloc(nrowlon*sizeof(int));
      memcpy(gridTable[gridIDnew].rowlon, gridTable[gridID].rowlon, nrowlon*sizeof(int));
    }

  if ( gridTable[gridID].xvals != NULL )
    {
      if ( gridtype == GRID_CURVILINEAR || gridtype == GRID_CELL )
	size = gridsize;
      else
	size = gridTable[gridID].xsize;

      gridTable[gridIDnew].xvals = (double *) malloc(size*sizeof(double));
      memcpy(gridTable[gridIDnew].xvals, gridTable[gridID].xvals, size*sizeof(double));
    }

  if ( gridTable[gridID].yvals != NULL )
    {
      if ( gridtype == GRID_CURVILINEAR || gridtype == GRID_CELL )
	size = gridsize;
      else
	size = gridTable[gridID].ysize;

      gridTable[gridIDnew].yvals = (double *) malloc(size*sizeof(double));
      memcpy(gridTable[gridIDnew].yvals, gridTable[gridID].yvals, size*sizeof(double));
    }

  if ( gridTable[gridID].xbounds != NULL )
    {
      if ( gridtype == GRID_CURVILINEAR || gridtype == GRID_CELL )
	size = gridsize;
      else
	size = gridTable[gridID].xsize;

      size *= gridTable[gridID].nvertex;

      gridTable[gridIDnew].xbounds = (double *) malloc(size*sizeof(double));
      memcpy(gridTable[gridIDnew].xbounds, gridTable[gridID].xbounds, size*sizeof(double));
    }

  if ( gridTable[gridID].ybounds != NULL )
    {
      if ( gridtype == GRID_CURVILINEAR || gridtype == GRID_CELL )
	size = gridsize;
      else
	size = gridTable[gridID].ysize;

      size *= gridTable[gridID].nvertex;

      gridTable[gridIDnew].ybounds = (double *) malloc(size*sizeof(double));
      memcpy(gridTable[gridIDnew].ybounds, gridTable[gridID].ybounds, size*sizeof(double));
    }

  if ( gridTable[gridID].area != NULL )
    {
      size = gridsize;

      gridTable[gridIDnew].area = (double *) malloc(size*sizeof(double));
      memcpy(gridTable[gridIDnew].area, gridTable[gridID].area, size*sizeof(double));
    }

  return (gridIDnew);
}

void gridDefArea(int gridID, double *area)
{
  static char func[] = "gridDefArea";
  int size;
  int i;

  gridCheckID(func, gridID);

  size = gridTable[gridID].size;

  if ( size == 0 )
    Error(func, "size undefined for gridID = %d", gridID);
    
  if ( gridTable[gridID].area == NULL )
    gridTable[gridID].area = (double *) malloc(size*sizeof(double));
  else if ( CDI_Debug )
    Warning(func, "values allready defined!");

  for ( i = 0; i < size; i++ ) gridTable[gridID].area[i] = area[i];
}


void gridInqArea(int gridID, double *area)
{
  int size;
  int i;

  size = gridTable[gridID].size;

  if ( gridTable[gridID].area )
    for ( i = 0; i < size; i++ ) area[i] = gridTable[gridID].area[i];
}


double *gridInqAreaPtr(int gridID)
{
  return (gridTable[gridID].area);
}


void gridDefNvertex(int gridID, int nvertex)
{
  gridTable[gridID].nvertex = nvertex;
}


int gridInqNvertex(int gridID)
{
  return (gridTable[gridID].nvertex);
}


/*
@Function  gridDefXbounds
@Title     Define the bounds of a X-axis

@Prototype void gridDefXbounds(int gridID, double *xbounds)
@Parameter
    @Item  gridID    Grid identifier
    @Item  xbounds   X-bounds of the grid

@Description
The function {\tt gridDefXbounds} defines all bounds of the X-axis.

@EndFunction
*/
void gridDefXbounds(int gridID, double *xbounds)
{
  static char func[] = "gridDefXbounds";
  int size;
  int i, nvertex;

  nvertex = gridTable[gridID].nvertex;
  if ( nvertex == 0 )
    {
      Warning(func, "nvertex undefined for gridID = %d. Can't define bounds!", gridID);
      return;
    }

  if ( gridTable[gridID].type == GRID_CURVILINEAR || gridTable[gridID].type == GRID_CELL )
    size = nvertex*gridTable[gridID].size;
  else
    size = nvertex*gridTable[gridID].xsize;

  if ( size == 0 )
    Error(func, "size undefined for gridID = %d", gridID);
    
  if ( gridTable[gridID].xbounds == NULL )
    gridTable[gridID].xbounds = (double *) malloc(size*sizeof(double));
  else if ( CDI_Debug )
    Warning(func, "values allready defined!");

  for ( i = 0; i < size; i++ )
    gridTable[gridID].xbounds[i] = xbounds[i];
}


/*
@Function  gridInqXbounds
@Title     Get the bounds of a X-axis

@Prototype int gridInqXbounds(int gridID, double *xbounds)
@Parameter
    @Item  gridID    Grid identifier
    @Item  xbounds   X-bounds of the grid

@Description
The function {\tt gridInqXbounds} gets the bounds of the X-axis.

@Result
Upon successful completion {\tt gridInqXbounds} return the number of bounds and
the bounds are stored in {\tt xbounds}.
Otherwise, 0 is returned and {\tt xbounds} is empty.

@EndFunction
*/
int gridInqXbounds(int gridID, double *xbounds)
{
  static char func[] = "gridInqXbounds";
  int size;
  int i, nvertex;

  nvertex = gridTable[gridID].nvertex;
  if ( CDI_Debug && nvertex == 0 )
    Warning(func, "nvertex undefined for gridID = %d", gridID);

  if ( gridTable[gridID].type == GRID_CURVILINEAR || gridTable[gridID].type == GRID_CELL )
    size = nvertex*gridTable[gridID].size;
  else
    size = nvertex*gridTable[gridID].xsize;

  if ( CDI_Debug && size == 0 )
    Warning(func, "size undefined for gridID = %d", gridID);

  if ( xbounds && gridTable[gridID].xbounds )
    for ( i = 0; i < size; i++ )
      xbounds[i] = gridTable[gridID].xbounds[i];

  if ( gridTable[gridID].xbounds == NULL ) size = 0;

  return (size);
}


double *gridInqXboundsPtr(int gridID)
{
  return (gridTable[gridID].xbounds);
}


/*
@Function  gridDefYbounds
@Title     Define the bounds of a Y-axis

@Prototype void gridDefYbounds(int gridID, double *ybounds)
@Parameter
    @Item  gridID    Grid identifier
    @Item  ybounds   Y-bounds of the grid

@Description
The function {\tt gridDefYbounds} defines all bounds of the Y-axis.

@EndFunction
*/
void gridDefYbounds(int gridID, double *ybounds)
{
  static char func[] = "gridDefYbounds";
  int size;
  int i, nvertex;

  nvertex = gridTable[gridID].nvertex;
  if ( nvertex == 0 )
    {
      Warning(func, "nvertex undefined for gridID = %d. Can't define bounds!", gridID);
      return;
    }

  if ( gridTable[gridID].type == GRID_CURVILINEAR || gridTable[gridID].type == GRID_CELL )
    size = nvertex*gridTable[gridID].size;
  else
    size = nvertex*gridTable[gridID].ysize;

  if ( size == 0 )
    Error(func, "size undefined for gridID = %d", gridID);
    
  if ( gridTable[gridID].ybounds == NULL )
    gridTable[gridID].ybounds = (double *) malloc(size*sizeof(double));
  else if ( CDI_Debug )
    Warning(func, "values allready defined!");

  for ( i = 0; i < size; i++ )
    gridTable[gridID].ybounds[i] = ybounds[i];
}


/*
@Function  gridInqYbounds
@Title     Get the bounds of a Y-axis

@Prototype int gridInqYbounds(int gridID, double *ybounds)
@Parameter
    @Item  gridID    Grid identifier
    @Item  ybounds   Y-bounds of the grid

@Description
The function {\tt gridInqYbounds} gets the bounds of the Y-axis.

@Result
Upon successful completion {\tt gridInqYbounds} return the number of bounds and
the bounds are stored in {\tt ybounds}.
Otherwise, 0 is returned and {\tt ybounds} is empty.

@EndFunction
*/
int gridInqYbounds(int gridID, double *ybounds)
{
  static char func[] = "gridInqYbounds";
  int size;
  int i, nvertex;

  nvertex = gridTable[gridID].nvertex;
  if ( CDI_Debug && nvertex == 0 )
    Warning(func, "nvertex undefined for gridID = %d", gridID);

  if ( gridTable[gridID].type == GRID_CURVILINEAR || gridTable[gridID].type == GRID_CELL )
    size = nvertex*gridTable[gridID].size;
  else
    size = nvertex*gridTable[gridID].ysize;

  if ( CDI_Debug && size == 0 )
    Warning(func, "size undefined for gridID = %d", gridID);

  if ( ybounds && gridTable[gridID].ybounds )
    for ( i = 0; i < size; i++ )
      ybounds[i] = gridTable[gridID].ybounds[i];

  if ( gridTable[gridID].ybounds == NULL ) size = 0;

  return (size);
}


double *gridInqYboundsPtr(int gridID)
{
  return (gridTable[gridID].ybounds);
}


void gridPrint(int gridID)
{
  static char func[] = "gridPrint";
  FILE *fp = stdout;
  int type;
  int gridsize, xsize, ysize, xdim, ydim;
  int trunc;
  int nbyte0, nbyte;
  int index;
  int nvertex, iv;
  const double *area    = gridInqAreaPtr(gridID);
  const double *xvals   = gridInqXvalsPtr(gridID);
  const double *yvals   = gridInqYvalsPtr(gridID);
  const double *xbounds = gridInqXboundsPtr(gridID);
  const double *ybounds = gridInqYboundsPtr(gridID);


  type     = gridInqType(gridID);
  trunc    = gridInqTrunc(gridID);
  gridsize = gridInqSize(gridID);
  xsize    = gridInqXsize(gridID);
  ysize    = gridInqYsize(gridID);
  nvertex  = gridInqNvertex(gridID);

  nbyte0 = 0;
  fprintf(fp, "#\n");
  fprintf(fp, "# gridID %d\n", gridID);
  fprintf(fp, "#\n");
  fprintf(fp, "gridtype  : %s\n", gridNamePtr(type));
  fprintf(fp, "gridsize  : %d\n", gridsize);

  if ( gridTable[gridID].xname[0]     ) fprintf(fp, "xname     : %s\n", gridTable[gridID].xname);
  if ( gridTable[gridID].xlongname[0] ) fprintf(fp, "xlongname : %s\n", gridTable[gridID].xlongname);
  if ( gridTable[gridID].xunits[0]    ) fprintf(fp, "xunits    : %s\n", gridTable[gridID].xunits);
  if ( gridTable[gridID].yname[0]     ) fprintf(fp, "yname     : %s\n", gridTable[gridID].yname);
  if ( gridTable[gridID].ylongname[0] ) fprintf(fp, "ylongname : %s\n", gridTable[gridID].ylongname);
  if ( gridTable[gridID].yunits[0]    ) fprintf(fp, "yunits    : %s\n", gridTable[gridID].yunits);
  if ( type == GRID_CELL ) fprintf(fp, "nvertex   : %d\n", nvertex);

  switch (type)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
    case GRID_GENERIC:
    case GRID_CURVILINEAR:
    case GRID_CELL:
      {
	if ( type == GRID_CURVILINEAR || type == GRID_CELL )
	  {
	    xdim = gridsize;
	    ydim = gridsize;
	  }
	else
	  {
	    xdim = xsize;
	    ydim = ysize;
	  }

	if ( xsize > 0 ) fprintf(fp, "xsize     : %d\n", xsize);
	if ( ysize > 0 ) fprintf(fp, "ysize     : %d\n", ysize);

	if ( gridTable[gridID].isRotated )
	  {
	    if ( xsize > 0 ) fprintf(fp, "xnpole    : %g\n", gridTable[gridID].xpole);
	    if ( ysize > 0 ) fprintf(fp, "ynpole    : %g\n", gridTable[gridID].ypole);
	  }

	if ( xvals )
	  {
	    nbyte0 = fprintf(fp, "xvals     : ");
	    nbyte = nbyte0;
	    for ( index = 0; index < xdim; index++ )
	      {
		if ( nbyte > 80 )
		  {
		    fprintf(fp, "\n");
		    fprintf(fp, "%*s", nbyte0, "");
		    nbyte = nbyte0;
		  }
		nbyte += fprintf(fp, "%.9g ", xvals[index]);
	      }
	    fprintf(fp, "\n");
	  }

	if ( xbounds )
	  {
	    nbyte0 = fprintf(fp, "xbounds   : ");
	    for ( index = 0; index < xdim; index++ )
	      {
		if ( index ) fprintf(fp, "%*s", nbyte0, "");

		for ( iv = 0; iv < nvertex; iv++ )
		  fprintf(fp, "%.9g ", xbounds[index*nvertex+iv]);
		fprintf(fp, "\n");
	      }
	  }

	if ( yvals )
	  {
	    nbyte0 = fprintf(fp, "yvals     : ");
	    nbyte = nbyte0;
	    for ( index = 0; index < ydim; index++ )
	      {
		if ( nbyte > 80 )
		  {
		    fprintf(fp, "\n");
		    fprintf(fp, "%*s", nbyte0, "");
		    nbyte = nbyte0;
		  }
		nbyte += fprintf(fp, "%.9g ", yvals[index]);
	      }
	    fprintf(fp, "\n");
	  }

	if ( ybounds )
	  {
	    nbyte0 = fprintf(fp, "ybounds   : ");
	    for ( index = 0; index < ydim; index++ )
	      {
		if ( index ) fprintf(fp, "%*s", nbyte0, "");

		for ( iv = 0; iv < nvertex; iv++ )
		  fprintf(fp, "%.9g ", ybounds[index*nvertex+iv]);
		fprintf(fp, "\n");
	      }
	  }

	if ( area )
	  {
	    nbyte0 = fprintf(fp, "area      : ");
	    nbyte  = nbyte0;
	    for ( index = 0; index < gridsize; index++ )
	      {
		if ( nbyte > 80 )
		  {
		    fprintf(fp, "\n");
		    fprintf(fp, "%*s", nbyte0, "");
		    nbyte = nbyte0;
		  }
		nbyte += fprintf(fp, "%.9g ", area[index]);
	      }
	    fprintf(fp, "\n");
	  }
	break;
      }
   case GRID_GAUSSIAN_REDUCED:
      {
	int *rowlon;
	fprintf(fp, "ysize : %d\n", ysize);	        
	nbyte0 = fprintf(fp, "rowlon : %d  ", ysize);
	nbyte  = nbyte0;
	rowlon = (int *) malloc(ysize*sizeof(int));
	gridInqRowlon(gridID, rowlon);
	for ( index = 0; index < ysize; index++ )
	  {
	    if ( nbyte > 80 )
	      {
		fprintf(fp, "\n");
		fprintf(fp, "%*s", nbyte0, "");
		nbyte = nbyte0;
	      }
	    nbyte += fprintf(fp, "%d ", rowlon[index]);
	  }
	fprintf(fp, "\n");
	free(rowlon);
	break;
      }
    case GRID_SPECTRAL:
      {
	fprintf(fp, "truncation : %d\n", trunc);
	break;
      }
   default:
      {
	fprintf(stderr, "%s grid unsupported\n", gridNamePtr(type));
      }
    }
}


int gridToZonal(int gridID1)
{
  static char func[] = "gridToZonal";
  int gridID2;
  int gridtype, gridsize;
  double  xval = 0;
  double *yvals;

  gridtype = gridInqType(gridID1);
  gridsize = gridInqYsize(gridID1);
  gridID2  = gridNew(gridtype, gridsize);
	  
  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
      {
	gridDefXsize(gridID2, 1);
	gridDefYsize(gridID2, gridsize);

	yvals = (double *) malloc(gridsize*sizeof(double));

	gridInqYvals(gridID1, yvals);
	gridDefXvals(gridID2, &xval);
	gridDefYvals(gridID2, yvals);

	free(yvals);

	break;
      }
    default:
      {
	Error(func, "Gridtype %s unsupported!", gridNamePtr(gridtype));
	break;
      }
    }

  return (gridID2);
}

int gridToMeridional(int gridID1)
{
  static char func[] = "gridToMeridional";
  int gridID2;
  int gridtype, gridsize;
  double *xvals;
  double  yval = 0;

  gridtype = gridInqType(gridID1);
  gridsize = gridInqXsize(gridID1);
  gridID2  = gridNew(gridtype, gridsize);
	  
  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
      {
	gridDefXsize(gridID2, gridsize);
	gridDefYsize(gridID2, 1);

	xvals = (double *) malloc(gridsize*sizeof(double));

	gridInqXvals(gridID1, xvals);
	gridDefXvals(gridID2, xvals);
	gridDefYvals(gridID2, &yval);

	free(xvals);

	break;
      }
    default:
      {
	Error(func, "Gridtype %s unsupported!", gridNamePtr(gridtype));
	break;
      }
    }

  return (gridID2);
}


void gridGenXbounds(int nx, double *xvals, double *xbounds)
{
  int i;

  for ( i = 0; i < nx-1; i++ )
    {
      xbounds[2*i+1]   = 0.5*(xvals[i] + xvals[i+1]);
      xbounds[2*(i+1)] = 0.5*(xvals[i] + xvals[i+1]);
    }

  xbounds[0]      = 2*xvals[0] - xbounds[1];
  xbounds[2*nx-1] = 2*xvals[nx-1] - xbounds[2*(nx-1)];
}


void gridGenYbounds(int ny, double *yvals, double *ybounds)
{
  int i;

  for ( i = 0; i < ny-1; i++ )
    {
      ybounds[2*i+1]   = 0.5*(yvals[i] + yvals[i+1]);
      ybounds[2*(i+1)] = 0.5*(yvals[i] + yvals[i+1]);
    }

  ybounds[0]      = 2*yvals[0] - ybounds[1];
  ybounds[2*ny-1] = 2*yvals[ny-1] - ybounds[2*(ny-1)];

  if ( yvals[0] > yvals[ny-1] )
    {
      if ( ybounds[0]      >  88 ) ybounds[0]      =  90;
      if ( ybounds[2*ny-1] < -88 ) ybounds[2*ny-1] = -90;
    }
  else
    {
      if ( ybounds[0]      < -88 ) ybounds[0]      = -90;
      if ( ybounds[2*ny-1] >  88 ) ybounds[2*ny-1] =  90;
    }
}


void gridGenRotBounds(int gridID, int nx, int ny,
		      double *xbounds, double *ybounds, double *xbounds2D, double *ybounds2D)
{
  int i, j, index;
  double minlon, maxlon;
  double minlat, maxlat;
  double xpole, ypole;

  xpole = gridInqXpole(gridID);
  ypole = gridInqYpole(gridID);

  for ( j = 0; j < ny; j++ )
    {
      if ( ybounds[0] > ybounds[1] )
	{
	  maxlat = ybounds[2*j];
	  minlat = ybounds[2*j+1];
	}
      else
	{
	  maxlat = ybounds[2*j+1];
	  minlat = ybounds[2*j];
	}

      for ( i = 0; i < nx; i++ )
	{
	  minlon = xbounds[2*i];
	  maxlon = xbounds[2*i+1];

	  index = j*4*nx + 4*i;
	  xbounds2D[index+0] = rls_to_rl(minlat, minlon, ypole, xpole);
	  xbounds2D[index+1] = rls_to_rl(minlat, maxlon, ypole, xpole);
	  xbounds2D[index+2] = rls_to_rl(maxlat, maxlon, ypole, xpole);
	  xbounds2D[index+3] = rls_to_rl(maxlat, minlon, ypole, xpole);

	  ybounds2D[index+0] = phs_to_ph(minlat, minlon, ypole, xpole);
	  ybounds2D[index+1] = phs_to_ph(minlat, maxlon, ypole, xpole);
	  ybounds2D[index+2] = phs_to_ph(maxlat, maxlon, ypole, xpole);
	  ybounds2D[index+3] = phs_to_ph(maxlat, minlon, ypole, xpole);
	}
    }
}


void gridGenXbounds2D(int nx, int ny, double *xbounds, double *xbounds2D)
{
  int i, j, index;
  double minlon, maxlon;

  for ( i = 0; i < nx; i++ )
    {
      minlon = xbounds[2*i];
      maxlon = xbounds[2*i+1];

      for ( j = 0; j < ny; j++ )
	{
	  index = j*4*nx + 4*i;
	  xbounds2D[index+0] = minlon;
	  xbounds2D[index+1] = maxlon;
	  xbounds2D[index+2] = maxlon;
	  xbounds2D[index+3] = minlon;
	}
    }
}


void gridGenYbounds2D(int nx, int ny, double *ybounds, double *ybounds2D)
{
  int i, j, index;
  double minlat, maxlat;

  for ( j = 0; j < ny; j++ )
    {
      if ( ybounds[0] > ybounds[1] )
	{
	  maxlat = ybounds[2*j];
	  minlat = ybounds[2*j+1];
	}
      else
	{
	  maxlat = ybounds[2*j+1];
	  minlat = ybounds[2*j];
	}

      for ( i = 0; i < nx; i++ )
	{
	  index = j*4*nx + 4*i;
	  ybounds2D[index+0] = minlat;
	  ybounds2D[index+1] = minlat;
	  ybounds2D[index+2] = maxlat;
	  ybounds2D[index+3] = maxlat;
	}
    }
}


int gridToCurvilinear(int gridID1)
{
  static char func[] = "gridToCurvilinear";
  int gridID2;
  int gridtype, gridsize;

  gridtype = gridInqType(gridID1);
  gridsize = gridInqSize(gridID1);
  gridID2  = gridNew(GRID_CURVILINEAR, gridsize);
	  
  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
      {
	int i, j, nx, ny;
	double *xvals, *yvals;
	double *xvals2D, *yvals2D;
	double *xbounds = NULL, *ybounds = NULL;
	double *xbounds2D, *ybounds2D;

	nx = gridInqXsize(gridID1);
	ny = gridInqYsize(gridID1);

	gridDefXsize(gridID2, nx);
	gridDefYsize(gridID2, ny);

	xvals = (double *) malloc(nx*sizeof(double));
	yvals = (double *) malloc(ny*sizeof(double));

	xvals2D = (double *) malloc(gridsize*sizeof(double));
	yvals2D = (double *) malloc(gridsize*sizeof(double));

	gridInqXvals(gridID1, xvals);
	gridInqYvals(gridID1, yvals);

	if ( gridIsRotated(gridID1) )
	  {
	    double xpole, ypole;

	    xpole = gridInqXpole(gridID1);
	    ypole = gridInqYpole(gridID1);

	    for ( j = 0; j < ny; j++ )
	      for ( i = 0; i < nx; i++ )
		{
		  xvals2D[j*nx+i] = rls_to_rl(yvals[j], xvals[i], ypole, xpole);
		  yvals2D[j*nx+i] = phs_to_ph(yvals[j], xvals[i], ypole, xpole);
		}	    
	  }
	else
	  {
	    for ( j = 0; j < ny; j++ )
	      for ( i = 0; i < nx; i++ )
		{
		  xvals2D[j*nx+i] = xvals[i];
		  yvals2D[j*nx+i] = yvals[j];
		}
	  }

	gridDefXvals(gridID2, xvals2D);
	gridDefYvals(gridID2, yvals2D);

	free(xvals2D);
	free(yvals2D);

	if ( gridInqXboundsPtr(gridID1) )
	  {
	    xbounds = (double *) malloc(2*nx*sizeof(double));
	    gridInqXbounds(gridID1, xbounds);
	  }
	else if ( nx > 1 )
	  {
	    xbounds = (double *) malloc(2*nx*sizeof(double));
	    gridGenXbounds(nx, xvals, xbounds);
	  }

	if ( gridInqYboundsPtr(gridID1) )
	  {
	    ybounds = (double *) malloc(2*ny*sizeof(double));
	    gridInqYbounds(gridID1, ybounds);
	  }
	else if ( ny > 1 )
	  {
	    ybounds = (double *) malloc(2*ny*sizeof(double));
	    gridGenYbounds(ny, yvals, ybounds);
	  }

	free(xvals);
	free(yvals);

	if ( xbounds && ybounds )
	  {
	    xbounds2D = (double *) malloc(4*gridsize*sizeof(double));
	    ybounds2D = (double *) malloc(4*gridsize*sizeof(double));

	    if ( gridIsRotated(gridID1) )
	      {
		gridGenRotBounds(gridID1, nx, ny, xbounds, ybounds, xbounds2D, ybounds2D);
	      }
	    else
	      {
		gridGenXbounds2D(nx, ny, xbounds, xbounds2D);
		gridGenYbounds2D(nx, ny, ybounds, ybounds2D);
	      }

	    gridDefXbounds(gridID2, xbounds2D);
	    gridDefYbounds(gridID2, ybounds2D);

	    free(xbounds);
	    free(ybounds);
	    free(xbounds2D);
	    free(ybounds2D);
	  }

	break;
      }
    default:
      {
	Error(func, "Gridtype %s unsupported!", gridNamePtr(gridtype));
	break;
      }
    }

  return (gridID2);
}

int gridToCell(int gridID1)
{
  static char func[] = "gridToCell";
  int gridID2;
  int gridtype, gridsize;

  gridtype = gridInqType(gridID1);
  gridsize = gridInqSize(gridID1);
  gridID2  = gridNew(GRID_CELL, gridsize);
	  
  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
      {
	int i, j, nx, ny;
	double *xvals, *yvals;
	double *xvals2D, *yvals2D;
	double *xbounds = NULL, *ybounds = NULL;
	double *xbounds2D, *ybounds2D;

	gridDefXname(gridID2, "lon");
	gridDefYname(gridID2, "lat");
	gridDefXlongname(gridID2, "longitude");
	gridDefYlongname(gridID2, "latitude");
	gridDefXunits(gridID2, "degrees_east");
	gridDefYunits(gridID2, "degrees_north");

	gridDefNvertex(gridID2, 4);

	nx = gridInqXsize(gridID1);
	ny = gridInqYsize(gridID1);
	 
	gridDefXsize(gridID2, gridsize);
	gridDefYsize(gridID2, gridsize);

	xvals = (double *) malloc(nx*sizeof(double));
	yvals = (double *) malloc(ny*sizeof(double));

	xvals2D = (double *) malloc(gridsize*sizeof(double));
	yvals2D = (double *) malloc(gridsize*sizeof(double));

	gridInqXvals(gridID1, xvals);
	gridInqYvals(gridID1, yvals);

	for ( j = 0; j < ny; j++ )
	  for ( i = 0; i < nx; i++ )
	    {
	      xvals2D[j*nx+i] = xvals[i];
	      yvals2D[j*nx+i] = yvals[j];
	    }

	gridDefXvals(gridID2, xvals2D);
	gridDefYvals(gridID2, yvals2D);

	for ( j = 0; j < ny; j++ )
	  for ( i = 0; i < nx; i++ )
	    {
	      xvals2D[j*nx+i] = xvals[i];
	      yvals2D[j*nx+i] = yvals[j];
	    }

	gridDefXvals(gridID2, xvals2D);
	gridDefYvals(gridID2, yvals2D);

	free(xvals2D);
	free(yvals2D);

	if ( gridInqXboundsPtr(gridID1) )
	  {
	    xbounds = (double *) malloc(2*nx*sizeof(double));
	    gridInqXbounds(gridID1, xbounds);
	  }
	else if ( nx > 1 )
	  {
	    xbounds = (double *) malloc(2*nx*sizeof(double));
	    gridGenXbounds(nx, xvals, xbounds);
	  }

	if ( gridInqYboundsPtr(gridID1) )
	  {
	    ybounds = (double *) malloc(2*ny*sizeof(double));
	    gridInqYbounds(gridID1, ybounds);
	  }
	else if ( ny > 1 )
	  {
	    ybounds = (double *) malloc(2*ny*sizeof(double));
	    gridGenYbounds(ny, yvals, ybounds);
	  }

	free(xvals);
	free(yvals);

	if ( xbounds )
	  {
	    xbounds2D = (double *) malloc(4*gridsize*sizeof(double));
	    gridGenXbounds2D(nx, ny, xbounds, xbounds2D);
	    gridDefXbounds(gridID2, xbounds2D);

	    free(xbounds);
	    free(xbounds2D);
	  }

	if ( ybounds )
	  {
	    ybounds2D = (double *) malloc(4*gridsize*sizeof(double));
	    gridGenYbounds2D(nx, ny, ybounds, ybounds2D);
	    gridDefYbounds(gridID2, ybounds2D);

	    free(ybounds);
	    free(ybounds2D);
	  }

	break;
      }
    case GRID_TRIANGULAR:
      {
	int nd, ni, ni2, ni3;
	double *xn, *rlon, *rlat;

	nd  = gridInqTriNd(gridID1);
	ni  = gridInqTriNi(gridID1);
	ni2 = gridInqTriNi2(gridID1);
	ni3 = gridInqTriNi3(gridID1);

	xn   = (double *) malloc(gridsize*3*sizeof(double));
	rlon = (double *) malloc(gridsize*sizeof(double));
	rlat = (double *) malloc(gridsize*sizeof(double));

	glo_coor(xn, rlon, rlat, 0, ni, 1, ni+1, nd, ni2, ni3);
	/*
	for ( i = 0; i < gridsize; i++ )
	  printf("%d %g %g\n", i, rlon[i], rlat[i]);
	*/
	gridDefXsize(gridID2, gridsize);
	gridDefYsize(gridID2, gridsize);

	gridDefXvals(gridID2, rlon);
	gridDefYvals(gridID2, rlat);

	gridDefXunits(gridID2, "degrees");
	gridDefYunits(gridID2, "degrees");

	free (xn);
	free (rlon);
	free (rlat);
	
	break;
      }
    default:
      {
	Error(func, "Gridtype %s unsupported!", gridNamePtr(gridtype));
	break;
      }
    }

  return (gridID2);
}

const double *gridInqXvalsPtr(int gridID)
{
  return ( gridTable[gridID].xvals );
}

const double *gridInqYvalsPtr(int gridID)
{
  return ( gridTable[gridID].yvals );
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





static struct {
  char *name;
  char *longname;
  char *units;
}
LevelTypeEntry[] = {
  {"sfc",     "surface",                  ""},
  {"lev",     "generic",                  "level"},
  {"lev",     "hybrid",                   "level"},
  {"lev",     "hybrid_half",              "level"},
  {"lev",     "pressure",                 "Pa"},
  {"height",  "height",                   "m"},
  {"depth",   "depth below sea",          "m"},
  {"depth",   "depth below land",         "cm"},
  {"lev",     "isentropic",               "K"},
};

static int CDI_MaxLeveltype = sizeof(LevelTypeEntry) / sizeof(LevelTypeEntry[0]);


#define  LevelDown  0
#define  LevelUp    1

typedef struct {
  char     name[256];
  char     longname[256];
  char     units[256];
  double  *vals;
  double  *lower;
  double  *upper;
  int      prec;
  int      lbounds;
  int      type;
  int      size;
  int      direction;
  int      used;
  int      vctsize;
  double  *vct;
}
ZAXIS;

static ZAXIS *zaxisTable;
static int    zaxisTableSize = 0;


static void zaxisTableInitEntry (int zaxisID)
{
  zaxisTable[zaxisID].name[0]     = 0;
  zaxisTable[zaxisID].longname[0] = 0;
  zaxisTable[zaxisID].units[0]    = 0;
  zaxisTable[zaxisID].vals        = NULL;
  zaxisTable[zaxisID].upper       = NULL;
  zaxisTable[zaxisID].lower       = NULL;
  zaxisTable[zaxisID].type        = CDI_UNDEFID;
  zaxisTable[zaxisID].direction   = CDI_UNDEFID;
  zaxisTable[zaxisID].prec        = 0;
  zaxisTable[zaxisID].lbounds     = 0;
  zaxisTable[zaxisID].size        = 0;
  zaxisTable[zaxisID].vctsize     = 0;
  zaxisTable[zaxisID].vct         = NULL;
}


static int zaxisTableNewEntry (int zaxistype)
{
  static char func[] = "zaxisTableNewEntry";
  int zaxisID = 0;

  /*
    Look for a free slot in zaxisTable.
    (Create the table the first time through).
  */
  if ( ! zaxisTableSize )
    {
      int i;

      zaxisTableSize = 2;
      zaxisTable = (ZAXIS *) malloc(zaxisTableSize*sizeof(ZAXIS));
      if ( zaxisTable == NULL )
	{
          Message(func, "zaxisTableSize = %d", zaxisTableSize);
	  SysError(func, "Allocation of ZAXISTABLE failed");
	}

      for ( i = 0; i < zaxisTableSize; i++ )
	zaxisTableInitEntry(i);
    }
  else
    {
      while ( zaxisID < zaxisTableSize )
	{
	  if ( zaxisTable[zaxisID].type == CDI_UNDEFID ) break;
	  zaxisID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( zaxisID == zaxisTableSize )
    {
      int i;

      zaxisTableSize = 2*zaxisTableSize;
      zaxisTable = (ZAXIS *) realloc(zaxisTable, zaxisTableSize*sizeof(ZAXIS));
      if ( zaxisTable == NULL )
	{
          Message(func, "zaxisTableSize = %d", zaxisTableSize);
	  SysError(func, "Reallocation of ZAXISTABLE failed");
	}

      zaxisID = zaxisTableSize/2;

      for ( i = zaxisID; i < zaxisTableSize; i++ )
	zaxisTableInitEntry(i);
    }

  zaxisTable[zaxisID].type = zaxistype;

  return (zaxisID);
}


void zaxisCheckID(const char *func, int zaxisID)
{
  if ( zaxisID < 0 || zaxisID >= zaxisTableSize )
      Error(func, "zaxisID %d undefined!", zaxisID);

  if ( zaxisTable[zaxisID].type == CDI_UNDEFID )
    Error(func, "zaxisID %d type undefined!", zaxisID);
}


/*
@Function  zaxisNew
@Title     Create a new Z-axis

@Prototype int zaxisNew(int zaxistype, int size)
@Parameter
    @Item  zaxistype  The type of the Z-axis, one of the set of predefined CDI Z-axis types.
                      The valid CDI Z-axis types are {\tt ZAXIS_SURFACE}, {\tt ZAXIS_HYBRID},
                      {\tt ZAXIS_HYBRID_HALF}, {\tt ZAXIS_PRESSURE}, {\tt ZAXIS_HEIGHT},
                      {\tt ZAXIS_DEPTH_BELOW_SEA} and {\tt ZAXIS_DEPTH_BELOW_LAND}.
    @Item  size       Number of levels

@Description
The function {\tt zaxisNew} creates a new Z-axis.

@Result
{\tt zaxisNew} return an identifier to the new Z-axis.

@EndFunction
*/
int zaxisNew(int zaxistype, int size)
{
  static char func[] = "zaxisNew";
  int ilev;
  int zaxisID;
  double *vals;

  if ( CDI_Debug )
    Message(func, "zaxistype: %d size: %d ", zaxistype, size);

  /* get next free level entry */
  zaxisID = zaxisTableNewEntry(zaxistype);

  zaxisTable[zaxisID].size = size;

  if ( zaxistype > CDI_MaxLeveltype )
    Error(func, "Internal problem! zaxistype > CDI_MaxLeveltype");

  zaxisDefName(zaxisID, LevelTypeEntry[zaxistype].name);
  zaxisDefLongname(zaxisID, LevelTypeEntry[zaxistype].longname);
  zaxisDefUnits(zaxisID, LevelTypeEntry[zaxistype].units);

  vals = (double *) malloc(size*sizeof(double));

  for ( ilev = 0; ilev < size; ilev++ )
    vals[ilev] = 0.0;

  zaxisTable[zaxisID].vals = vals;

  return (zaxisID);
}


char *zaxisTypeNamePtr(int leveltype)
{
  static char func[] = "zaxisTypeNamePtr";
  char *longname = NULL;

  if ( leveltype >= 0 && leveltype < CDI_MaxLeveltype )
    longname = LevelTypeEntry[leveltype].longname;
  else
    Error(func, "leveltype %d undefined", leveltype);

  return (longname);
}


/*
@Function  zaxisDefName
@Title     Define the name of a Z-axis

@Prototype void zaxisDefName(int zaxisID, const char *name)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  name      Name of the Z-axis

@Description
The function {\tt zaxisDefName} defines the name of a Z-axis.

@EndFunction
*/
void zaxisDefName(int zaxisID, const char *name)
{
  if ( name )
    strcpy(zaxisTable[zaxisID].name, name);
}


/*
@Function  zaxisDefLongname
@Title     Define the longname of a Z-axis

@Prototype void zaxisDefLongname(int zaxisID, const char *longname)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  longname  Longname of the Z-axis

@Description
The function {\tt zaxisDefLongname} defines the longname of a Z-axis.

@EndFunction
*/
void zaxisDefLongname(int zaxisID, const char *longname)
{
  if ( longname )
    strcpy(zaxisTable[zaxisID].longname, longname);
}


/*
@Function  zaxisDefUnits
@Title     Define the units of a Z-axis

@Prototype void zaxisDefUnits(int zaxisID, const char *units)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  units     Units of the Z-axis

@Description
The function {\tt zaxisDefUnits} defines the units of a Z-axis.

@EndFunction
*/
void zaxisDefUnits(int zaxisID, const char *units)
{
  if ( units )
    strcpy(zaxisTable[zaxisID].units, units);
}


/*
@Function  zaxisInqName
@Title     Get the name of a Z-axis

@Prototype void zaxisInqName(int zaxisID, char *name)
@Parameter
    @Item  zaxisID     Z-axis identifier
    @Item  name        Name of the Z-axis

@Description
The function {\tt zaxisInqName} gets the name of a Z-axis.

@Result
{\tt zaxisInqName} return the name of the Z-axis to the parameter name.

@EndFunction
*/
void zaxisInqName(int zaxisID, char *name)
{
  strcpy(name, zaxisTable[zaxisID].name);
}


/*
@Function  zaxisInqLongname
@Title     Get the longname of a Z-axis

@Prototype void zaxisInqLongname(int zaxisID, char *longname)
@Parameter
    @Item  zaxisID     Z-axis identifier
    @Item  longname    Longname of the Z-axis

@Description
The function {\tt zaxisInqLongname} gets the longname of a Z-axis.

@Result
{\tt zaxisInqLongname} return the longname of the Z-axis to the parameter longname.

@EndFunction
*/
void zaxisInqLongname(int zaxisID, char *longname)
{
  strcpy(longname, zaxisTable[zaxisID].longname);
}


/*
@Function  zaxisInqUnits
@Title     Get the units of a Z-axis

@Prototype void zaxisInqUnits(int zaxisID, char *units)
@Parameter
    @Item  zaxisID     Z-axis identifier
    @Item  units       Units of the Z-axis

@Description
The function {\tt zaxisInqUnits} gets the units of a Z-axis.

@Result
{\tt zaxisInqUnits} return the units of the Z-axis to the parameter units.

@EndFunction
*/
void zaxisInqUnits(int zaxisID, char *units)
{
  strcpy(units, zaxisTable[zaxisID].units);
}


void zaxisDefPrec(int zaxisID, int prec)
{
  static char func[] = "zaxisDefPrec";

  zaxisCheckID(func, zaxisID);

  zaxisTable[zaxisID].prec = prec;
}


int zaxisInqPrec(int zaxisID)
{
  static char func[] = "zaxisInqPrec";

  zaxisCheckID(func, zaxisID);

  return (zaxisTable[zaxisID].prec);
}


/*
@Function  zaxisDefLevels
@Title     Define the levels of a Z-axis

@Prototype void zaxisDefLevels(int zaxisID, double *levels)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  levels    All levels of the Z-axis

@Description
The function {\tt zaxisDefLevels} defines the levels of a Z-axis.

@EndFunction
*/
void zaxisDefLevels(int zaxisID, double *levels)
{
  static char func[] = "zaxisDefLevels";
  int ilev;
  int size;
  double *vals;

  zaxisCheckID(func, zaxisID);

  size = zaxisTable[zaxisID].size;

  vals = zaxisTable[zaxisID].vals;

  for ( ilev = 0; ilev < size; ilev++ )
    vals[ilev] = levels[ilev];
}


/*
@Function  zaxisDefLevel
@Title     Define one level of a Z-axis

@Prototype void zaxisDefLevel(int zaxisID, int levelID, double level)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  levelID   Level identifier
    @Item  level     Level

@Description
The function {\tt zaxisDefLevel} defines one level of a Z-axis.

@EndFunction
*/
void zaxisDefLevel(int zaxisID, int levelID, double level)
{
  static char func[] = "zaxisDefLevel";

  zaxisCheckID(func, zaxisID);

  if ( levelID >= 0 && levelID < zaxisTable[zaxisID].size )
    zaxisTable[zaxisID].vals[levelID] = level;
}


/*
@Function  zaxisInqLevel
@Title     Get one level of a Z-axis

@Prototype double zaxisInqLevel(int zaxisID, int levelID)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  levelID   Level index (range: 0 to nlevel-1)

@Description
The function {\tt zaxisInqLevel} gets one level of a Z-axis.

@Result
{\tt zaxisInqLevel} return the level of a Z-axis.
@EndFunction
*/
double zaxisInqLevel(int zaxisID, int levelID)
{
  static char func[] = "zaxisInqLevel";
  double level = 0;

  zaxisCheckID(func, zaxisID);

  if ( levelID >= 0 && levelID < zaxisTable[zaxisID].size )
    level = zaxisTable[zaxisID].vals[levelID];

  return (level);
}


double zaxisInqLbound(int zaxisID, int index)
{
  static char func[] = "zaxisInqLbound";
  double level = 0;

  zaxisCheckID(func, zaxisID);

  if ( index >= 0 && index < zaxisTable[zaxisID].size )
    level = zaxisTable[zaxisID].lower[index];

  return (level);
}


double zaxisInqUbound(int zaxisID, int index)
{
  static char func[] = "zaxisInqUbound";
  double level = 0;

  zaxisCheckID(func, zaxisID);

  if ( index >= 0 && index < zaxisTable[zaxisID].size )
    level = zaxisTable[zaxisID].upper[index];

  return (level);
}


const double *zaxisInqLevelsPtr(int zaxisID)
{
  return ( zaxisTable[zaxisID].vals );
}


/*
@Function  zaxisInqLevels
@Title     Get all levels of a Z-axis

@Prototype void zaxisInqLevels(int zaxisID, double *levels)
@Parameter
    @Item  zaxisID   Z-axis identifier
    @Item  levels    Levels of the Z-axis
    
@Description
The function {\tt zaxisInqLevels} gets all levels of a Z-axis.

@Result
{\tt zaxisInqLevels} saves all levels to the parameter {\tt levels}.
@EndFunction
*/
void zaxisInqLevels(int zaxisID, double *levels)
{
  static char func[] = "zaxisInqLevels";
  int size;
  int i;

  zaxisCheckID(func, zaxisID);

  size = zaxisTable[zaxisID].size;
  for ( i = 0; i < size; i++ )
    levels[i] =  zaxisTable[zaxisID].vals[i];
}


int zaxisInqLevelID(int zaxisID, double level)
{
  static char func[] = "zaxisInqLevelID";
  int size;
  int levelID = CDI_UNDEFID;
  int i;

  zaxisCheckID(func, zaxisID);

  size = zaxisTable[zaxisID].size;
  for ( i = 0; i < size; i++ )
    if ( fabs(level-zaxisTable[zaxisID].vals[i]) < DBL_EPSILON ) break;

  if ( i < size ) levelID = i;

  return (levelID);
}


/*
@Function  zaxisInqType
@Title     Get the type of a Z-axis

@Prototype int zaxisInqType(int zaxisID)
@Parameter
    @Item  zaxisID   Z-axis identifier

@Description
The function {\tt zaxisInqType} get the type of a Z-axis.

@Result
{\tt zaxisInqType} return the type of the Z-axis,
one of the set of predefined CDI Z-axis types.
The valid CDI Z-axis types are {\tt ZAXIS_SURFACE}, {\tt ZAXIS_HYBRID},
{\tt ZAXIS_HYBRID_HALF, {\tt ZAXIS_PRESSURE}, {\tt ZAXIS_HEIGHT},
{\tt ZAXIS_DEPTH_BELOW_SEA} and {\tt ZAXIS_DEPTH_BELOW_LAND}.

@EndFunction
*/
int zaxisInqType(int zaxisID)
{
  static char func[] = "zaxisInqType";

  zaxisCheckID(func, zaxisID);

  return (zaxisTable[zaxisID].type);
}


/*
@Function  zaxisInqSize
@Title     Get the size of a Z-axis

@Prototype int zaxisInqSize(int zaxisID)
@Parameter
    @Item  zaxisID  Z-axis identifier

@Description
The function {\tt zaxisInqSize} get the size of a Z-axis.

@Result
{\tt zaxisInqSize} return the number of levels of a Z-axis.

@EndFunction
*/
int zaxisInqSize(int zaxisID)
{
  static char func[] = "zaxisInqSize";
  int size = 1;

  zaxisCheckID(func, zaxisID);

  size = zaxisTable[zaxisID].size;

  return (size);
}


void cdiCheckZaxis(int zaxisID)
{
  static char func[] = "cdiCheckZaxis";
  int size, i, found;
  
  zaxisCheckID(func, zaxisID);

  if ( zaxisInqType(zaxisID) == ZAXIS_GENERIC )
    {
      size = zaxisTable[zaxisID].size;
      if ( size > 1 )
	{
	  /* check direction */
	  if ( zaxisTable[zaxisID].direction == CDI_UNDEFID )
	    {
	      found = 0;
	      for ( i = 1; i < size; i++ )
		if ( zaxisTable[zaxisID].vals[i] > zaxisTable[zaxisID].vals[i-1] )
		  found++;
	      if ( found == size-1 )
		{
		  zaxisTable[zaxisID].direction = LevelUp;
		}
	      else
		{
		  found = 0;
		  for ( i = 1; i < size; i++ )
		    if ( zaxisTable[zaxisID].vals[i] < zaxisTable[zaxisID].vals[i-1] )
		      found++;
		  if ( found == size-1 )
		    {
		      zaxisTable[zaxisID].direction = LevelDown;
		    }
		}
	    }
	  /* check consistent */
	  if ( zaxisTable[zaxisID].direction == CDI_UNDEFID )
	    {
	      Warning(func, "direction undefined for zaxisID %d", zaxisID);
	    }
	}
    }
}


int zaxisSize(void)
{
  int zaxisID = 0;

  while ( zaxisID < zaxisTableSize )
    {
      if ( zaxisTable[zaxisID].type == CDI_UNDEFID ) break;
      zaxisID++;
    }

  return (zaxisID);
}


void zaxisDefVct(int zaxisID, int size, const double *vct)
{
  static char func[] = "zaxisDefVct";

  zaxisCheckID(func, zaxisID);

  if ( zaxisTable[zaxisID].vct == 0 )
    {
      zaxisTable[zaxisID].vctsize = size;
      zaxisTable[zaxisID].vct = (double *) malloc(size*sizeof(double));
      memcpy(zaxisTable[zaxisID].vct, vct, size*sizeof(double));
    }
  else
    if ( zaxisTable[zaxisID].vctsize != size )
      Warning(func, "VCT was allready defined");
}


int zaxisInqVctSize(int zaxisID)
{
  static char func[] = "zaxisInqVctSize";

  zaxisCheckID(func, zaxisID);

  return (zaxisTable[zaxisID].vctsize);
}


const double *zaxisInqVctPtr(int zaxisID)
{
  static char func[] = "zaxisInqVctPtr";

  zaxisCheckID(func, zaxisID);

  return (zaxisTable[zaxisID].vct);
}


void zaxisDefBounds(int zaxisID, int size, double *lower, double *upper)
{
  static char func[] = "zaxisDefBounds";

  zaxisCheckID(func, zaxisID);

  if ( zaxisTable[zaxisID].size != size )
    Error(func, "Unexpected size = %d\n", size);

  if ( zaxisTable[zaxisID].upper != NULL || zaxisTable[zaxisID].lower != NULL )
    Warning(func, "Level bounds allready defined for zaxisID = %d", zaxisID);

  zaxisTable[zaxisID].lower = (double *) malloc(size*sizeof(double));
  zaxisTable[zaxisID].upper = (double *) malloc(size*sizeof(double));

  memcpy(zaxisTable[zaxisID].lower, lower, size*sizeof(double));
  memcpy(zaxisTable[zaxisID].upper, upper, size*sizeof(double));

  zaxisTable[zaxisID].lbounds = 1;
}


int zaxisInqHasBounds(int zaxisID)
{
  static char func[] = "zaxisInqHasBounds";

  zaxisCheckID(func, zaxisID);

  return (zaxisTable[zaxisID].lbounds);
}


void zaxisChangeType(int zaxisID, int leveltype)
{
  static char func[] = "zaxisChangeType";

  zaxisCheckID(func, zaxisID);

  Message(func, "Change zaxis type from %s to %s\n",
	  zaxisTypeNamePtr(zaxisTable[zaxisID].type),
	  zaxisTypeNamePtr(leveltype));
  
  zaxisTable[zaxisID].type = leveltype;
}


void zaxisResize(int zaxisID, int size)
{
  static char func[] = "zaxisResize";

  zaxisCheckID(func, zaxisID);

  zaxisTable[zaxisID].size = size;

  if ( zaxisTable[zaxisID].vals )
    zaxisTable[zaxisID].vals =
      (double *) realloc(zaxisTable[zaxisID].vals, size*sizeof(double));
}


int zaxisDuplicate(int zaxisID)
{
  static char func[] = "zaxisDuplicate";
  int zaxisIDnew;
  int zaxistype, zaxissize;
  int size;

  zaxistype = zaxisInqType(zaxisID);
  zaxissize = zaxisInqSize(zaxisID);

  zaxisIDnew = zaxisNew(zaxistype, zaxissize);

  memcpy(&zaxisTable[zaxisIDnew], &zaxisTable[zaxisID], sizeof(ZAXIS));

  strcpy(zaxisTable[zaxisIDnew].name, zaxisTable[zaxisID].name);
  strcpy(zaxisTable[zaxisIDnew].longname, zaxisTable[zaxisID].longname);
  strcpy(zaxisTable[zaxisIDnew].units, zaxisTable[zaxisID].units);

  if ( zaxisTable[zaxisID].vals != NULL )
    {
      size = zaxissize;

      zaxisTable[zaxisIDnew].vals = (double *) malloc(size*sizeof(double));
      memcpy(zaxisTable[zaxisIDnew].vals, zaxisTable[zaxisID].vals, size*sizeof(double));
    }

  if ( zaxisTable[zaxisIDnew].lbounds )
    {
      size = zaxissize;

      zaxisTable[zaxisIDnew].lower = (double *) malloc(size*sizeof(double));
      memcpy(zaxisTable[zaxisIDnew].lower, zaxisTable[zaxisID].lower, size*sizeof(double));

      zaxisTable[zaxisIDnew].upper = (double *) malloc(size*sizeof(double));
      memcpy(zaxisTable[zaxisIDnew].upper, zaxisTable[zaxisID].upper, size*sizeof(double));

      zaxisTable[zaxisIDnew].lbounds = 1;
    }

  if ( zaxisTable[zaxisID].vct != NULL )
    {
      size = zaxisTable[zaxisID].vctsize;

      if ( size )
	{
	  zaxisTable[zaxisID].vctsize = size;
	  zaxisTable[zaxisIDnew].vct = (double *) malloc(size*sizeof(double));
	  memcpy(zaxisTable[zaxisIDnew].vct, zaxisTable[zaxisID].vct, size*sizeof(double));
	}
    }

  return (zaxisIDnew);
}


void zaxisPrint(int zaxisID)
{
  FILE *fp = stdout;
  int type;
  int nlevels, levelID;
  int nbyte0, nbyte;
  double level;

  type    = zaxisInqType(zaxisID);
  nlevels = zaxisInqSize(zaxisID);

  nbyte0 = 0;
  fprintf(fp, "#\n");
  fprintf(fp, "# zaxisID %d\n", zaxisID);
  fprintf(fp, "#\n");
  fprintf(fp, "zaxistype : %s\n", zaxisTypeNamePtr(type));
  fprintf(fp, "nlevel    : %d\n", nlevels);
  if ( zaxisTable[zaxisID].name[0]     ) fprintf(fp, "name      : %s\n", zaxisTable[zaxisID].name);
  if ( zaxisTable[zaxisID].longname[0] ) fprintf(fp, "longname  : %s\n", zaxisTable[zaxisID].longname);
  if ( zaxisTable[zaxisID].units[0]    ) fprintf(fp, "units     : %s\n", zaxisTable[zaxisID].units);

  nbyte0 = fprintf(fp, "levels    : ");
  nbyte = nbyte0;
  for ( levelID = 0; levelID < nlevels; levelID++ )
    {
      if ( nbyte > 80 )
	{
	  fprintf(stdout, "\n");
	  fprintf(stdout, "%*s", nbyte0, "");
	  nbyte = nbyte0;
	}
      level = zaxisInqLevel(zaxisID, levelID);
      nbyte += fprintf(stdout, "%.9g ", level);
    }
  fprintf(stdout, "\n");

  if ( zaxisInqHasBounds(zaxisID) )
    {
      double level1, level2;
      nbyte = nbyte0;
      nbyte0 = fprintf(stdout, "%32s : ", "bounds");
      for ( levelID = 0; levelID < nlevels; levelID++ )
	{
	  if ( nbyte > 80 )
	    {
	      fprintf(stdout, "\n");
	      fprintf(stdout, "%*s", nbyte0, "");
	      nbyte = nbyte0;
	    }
	  level1 = zaxisInqLbound(zaxisID, levelID);
	  level2 = zaxisInqUbound(zaxisID, levelID);
	  nbyte += fprintf(stdout, "%.9g-%.9g ", level1, level2);
	}
      fprintf(stdout, "\n");
    }

  if ( type == ZAXIS_HYBRID )
    {
      int i;
      int vctsize;
      const double *vct;

      vctsize = zaxisInqVctSize(zaxisID);
      vct     = zaxisInqVctPtr(zaxisID);
      fprintf(stdout, "vctsize   : %d\n", vctsize);
      nbyte0 = fprintf(stdout, "vct_a     : ");
      nbyte = nbyte0;
      for ( i = 0; i < vctsize/2; i++ )
	{
	  if ( nbyte > 70 )
	    {
	      fprintf(stdout, "\n%*s", nbyte0, "");
	      nbyte = nbyte0;
	    }
	  nbyte += fprintf(stdout, "%.9g ", vct[i]);
	}
      fprintf(stdout, "\n");

      nbyte0 = fprintf(stdout, "vct_b     : ");
      nbyte  = nbyte0;
      for ( i = 0; i < vctsize/2; i++ )
	{
	  if ( nbyte > 70 )
	    {
	      fprintf(stdout, "\n%*s", nbyte0, "");
		      nbyte = nbyte0;
	    }
	  nbyte += fprintf(stdout, "%.9g ", vct[vctsize/2+i]);
	}
      fprintf(stdout, "\n");
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




extern int CDF_Fatal;
extern int CDF_Verbose;
extern int CDF_Debug;

#if  defined  (HAVE_LIBNETCDF)

#if ! defined (MIN_BUF_SIZE)
#  define  MIN_BUF_SIZE  131072L
#endif

static size_t ChunkSizeMin = MIN_BUF_SIZE;

void cdf_create(const char *path, int cmode, int *ncidp)
{
  static char func[] = "cdf_create";
  int status;
  int oldfill;
  struct stat filestat;
  size_t initialsz, chunksizehint;
  char basename[1024];
  char *pend;

  pend = strrchr(path, '/');
  if ( pend == 0 )
    strcpy(basename, "./");
  else
    {
      strncpy(basename, path, pend-path);
      basename[pend-path] = 0;
    }

  if ( stat(basename, &filestat) != 0 )
    SysError(func, basename);

  chunksizehint = (size_t) filestat.st_blksize * 4;
  if ( chunksizehint < ChunkSizeMin ) chunksizehint = ChunkSizeMin;
  initialsz = 0;

  status = nc__create(path, cmode, initialsz, &chunksizehint, ncidp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  mode = %d  file = %s", *ncidp, cmode, path);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "chunksizehint %d", chunksizehint);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));

  status = nc_set_fill(*ncidp, NC_NOFILL, &oldfill);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void cdf_open(const char *path, int omode, int *ncidp)
{
  static char func[] = "cdf_open";
  int status;
  struct stat filestat;
  size_t chunksizehint;

  if ( stat(path, &filestat) != 0 )
    SysError(func, path);

  chunksizehint = (size_t) filestat.st_blksize * 4;
  if ( chunksizehint < ChunkSizeMin ) chunksizehint = ChunkSizeMin;

  status = nc__open(path, omode, &chunksizehint, ncidp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  mode = %d  file = %s", *ncidp, omode, path);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "chunksizehint %d", chunksizehint);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void cdf_close(int ncid)
{
  static char func[] = "cdf_close";
  int status;

  status = nc_close(ncid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_redef(int ncid)
{
  static char func[] = "cdf_redef";
  int status;

  status = nc_redef(ncid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_enddef(int ncid)
{
  static char func[] = "cdf_enddef";
  int status;

  status = nc_enddef(ncid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq(int ncid, int *ndimsp, int *nvarsp, int *ngattsp, int *unlimdimidp)
{
  static char func[] = "cdf_inq";
  int status;

  status = nc_inq(ncid, ndimsp, nvarsp, ngattsp, unlimdimidp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d ndims = %d nvars = %d ngatts = %d unlimid = %d",
	    ncid, *ndimsp, *nvarsp, *ngattsp, *unlimdimidp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_def_dim(int ncid, const char *name, size_t len, int *dimidp)
{
  static char func[] = "cdf_def_dim";
  int status;

  status = nc_def_dim(ncid, name, len, dimidp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  name = %s  len = %d", ncid, name, len);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_dimid(int ncid, const char *name, int *dimidp)
{
  static char func[] = "cdf_inq_dimid";
  int status;

  status = nc_inq_dimid(ncid, name, dimidp);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d  name = %s  dimid= %d", ncid, name, *dimidp);

  if (status != NC_NOERR)
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_dim(int ncid, int dimid, char *name, size_t * lengthp)
{
  static char func[] = "cdf_inq_dim";
  int status;

  status = nc_inq_dim(ncid, dimid, name, lengthp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  dimid = %d  length = %d name = %s",
	    ncid, dimid, *lengthp, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_dimname(int ncid, int dimid, char *name)
{
  static char func[] = "cdf_inq_dimname";
  int status;

  status = nc_inq_dimname(ncid, dimid, name);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  dimid = %d  name = %s", ncid, dimid, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_dimlen(int ncid, int dimid, size_t * lengthp)
{
  static char func[] = "cdf_inq_dimlen";
  int status;

  status = nc_inq_dimlen(ncid, dimid, lengthp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d dimid = %d length = %d", ncid, dimid, *lengthp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_def_var(int ncid, const char *name, nc_type xtype, int ndims,
	    const int dimids[], int *varidp)
{
  static char func[] = "cdf_def_var";
  int status;

  status = nc_def_var(ncid, name, xtype, ndims, dimids, varidp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  name = %s  xtype = %d  ndims = %d  varid = %d",
	    ncid, name, xtype, ndims, *varidp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void cdf_inq_varid(int ncid, const char *name, int *varidp)
{
  static char func[] = "cdf_inq_varid";
  int status;

  status = nc_inq_varid(ncid, name, varidp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  name = %s  varid = %d ", ncid, name, *varidp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
void
cdf_inq_nvars(int ncid, int *nvarsp)
{
  static char func[] = "cdf_inq_nvars";
  int status;

  status = nc_inq_nvars(ncid, nvarsp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d  nvars = %d", ncid, *nvarsp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_var(int ncid, int varid, char *name, nc_type *xtypep, int *ndimsp,
	    int dimids[], int *nattsp)
{
  static char func[] = "cdf_inq_var";
  int status;

  status = nc_inq_var(ncid, varid, name, xtypep, ndimsp, dimids, nattsp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d ndims = %d xtype = %d name = %s",
	     ncid, varid, *ndimsp, *xtypep, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_varname(int ncid, int varid, char *name)
{
  static char func[] = "cdf_inq_varname";
  int status;

  status = nc_inq_varname(ncid, varid, name);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d name = %s", ncid, varid, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_vartype(int ncid, int varid, nc_type *xtypep)
{
  static char func[] = "cdf_inq_vartype";
  int status;

  status = nc_inq_vartype(ncid, varid, xtypep);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d xtype = %s", ncid, varid, *xtypep);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
void
cdf_inq_varndims(int ncid, int varid, int *ndimsp)
{
  static char func[] = "cdf_inq_varndims";
  int status;

  status = nc_inq_varndims(ncid, varid, ndimsp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_inq_varndims : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_vardimid(int ncid, int varid, int dimids[])
{
  static char func[] = "cdf_inq_vardimid";
  int status;

  status = nc_inq_vardimid(ncid, varid, dimids);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_inq_vardimid : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_varnatts(int ncid, int varid, int *nattsp)
{
  static char func[] = "cdf_inq_varnatts";
  int status;

  status = nc_inq_varnatts(ncid, varid, nattsp);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d nattsp = %d", ncid, varid, *nattsp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_var_text(int ncid, int varid, const char *tp)
{
  static char func[] = "cdf_put_var_text";
  int status;

  status = nc_put_var_text(ncid, varid, tp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_var_text : %d %d %s \n", ncid, varid, tp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}


void
cdf_put_var_short(int ncid, int varid, const short *sp)
{
  static char func[] = "cdf_put_var_short";
  int status;

  status = nc_put_var_short(ncid, varid, sp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_var_short : %d %d %hd \n", ncid, varid, *sp);

  if (status != NC_NOERR)
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_var_int(int ncid, int varid, const int *ip)
{
  static char func[] = "cdf_put_var_int";
  int status;

  status = nc_put_var_int(ncid, varid, ip);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_var_int : %d %d %d \n", ncid, varid, *ip);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_var_long(int ncid, int varid, const long *lp)
{
  static char func[] = "cdf_put_var_long";
  int status;

  status = nc_put_var_long(ncid, varid, lp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_var_long : %d %d %ld \n", ncid, varid, *lp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_var_float(int ncid, int varid, const float *fp)
{
  static char func[] = "cdf_put_var_float";
  int status;

  status = nc_put_var_float(ncid, varid, fp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_var_float : %d %d %f \n", ncid, varid, *fp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void 
cdf_put_vara_double (int ncid, int varid, const size_t start[],
		     const size_t count[], const double *dp)
{
  static char func[] = "cdf_put_vara_double";
  int status;

  status = nc_put_vara_double(ncid, varid, start, count, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d val0 = %f", ncid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void 
cdf_get_vara_int (int ncid, int varid, const size_t start[],
		  const size_t count[], int *dp)
{
  static char func[] = "cdf_get_vara_int";
  int status;

  status = nc_get_vara_int(ncid, varid, start, count, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void 
cdf_get_vara_double (int ncid, int varid, const size_t start[],
		     const size_t count[], double *dp)
{
  static char func[] = "cdf_get_vara_double";
  int status;

  status = nc_get_vara_double(ncid, varid, start, count, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_var_double (int ncid, int varid, const double *dp)
{
  static char func[] = "cdf_put_var_double";
  int status;

  status = nc_put_var_double(ncid, varid, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d val0 = %f", ncid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void 
cdf_get_var1_double(int ncid, int varid, const size_t index[], double *dp)
{
  static char func[] = "cdf_get_var1_double";
  int status;

  status = nc_get_var1_double(ncid, varid, index, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_var1_double(int ncid, int varid, const size_t index[], const double *dp)
{
  static char func[] = "cdf_put_var1_double";
  int status;

  status = nc_put_var1_double(ncid, varid, index, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d val = %f", ncid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_var_text(int ncid, int varid, char *tp)
{
  static char func[] = "cdf_get_var_text";
  int status;

  status = nc_get_var_text(ncid, varid, tp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_get_var_text : %d %d \n", ncid, varid);

  if (status != NC_NOERR)
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_var_short(int ncid, int varid, short *sp)
{
  static char func[] = "cdf_get_var_short";
  int status;

  status = nc_get_var_short(ncid, varid, sp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_get_var_short : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_var_int(int ncid, int varid, int *ip)
{
  static char func[] = "cdf_get_var_int";
  int status;

  status = nc_get_var_int(ncid, varid, ip);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_get_var_int : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_var_long(int ncid, int varid, long *lp)
{
  static char func[] = "cdf_get_var_long";
  int status;

  status = nc_get_var_long(ncid, varid, lp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_get_var_long : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_var_float(int ncid, int varid, float *fp)
{
  static char func[] = "cdf_get_var_float";
  int status;

  status = nc_get_var_float(ncid, varid, fp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_var_float : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_var_double(int ncid, int varid, double *dp)
{
  static char func[] = "cdf_get_var_double";
  int status;

  status = nc_get_var_double(ncid, varid, dp);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d val[0] = %f", ncid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_copy_att(int ncid_in, int varid_in, const char *name, int ncid_out,
	     int varid_out)
{
  static char func[] = "cdf_copy_att";
  int status;

  status = nc_copy_att(ncid_in, varid_in, name, ncid_out, varid_out);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_copy_att : %d %d %s %d %d\n", ncid_in, varid_out,
	     name, ncid_out, varid_out);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_att_text(int ncid, int varid, const char *name, size_t len,
		 const char *tp)
{
  static char func[] = "cdf_put_att_text";
  int status;

  status = nc_put_att_text(ncid, varid, name, len, tp);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d att = %s text = %s",
	    ncid, varid, name, tp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_att_int(int ncid, int varid, const char *name, nc_type xtype,
		size_t len, const int *ip)
{
  static char func[] = "cdf_put_att_int";
  int status;

  status = nc_put_att_int(ncid, varid, name, xtype, len, ip);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d att = %s val = %d",
	    ncid, varid, name, *ip);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_put_att_double(int ncid, int varid, const char *name, nc_type xtype,
		   size_t len, const double *dp)
{
  static char func[] = "cdf_put_att_double";
  int status;

  status = nc_put_att_double(ncid, varid, name, xtype, len, dp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_put_att_double : %d %d %f \n", ncid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_att_text(int ncid, int varid, char *name, char *tp)
{
  static char func[] = "cdf_get_att_text";
  int status;

  status = nc_get_att_text(ncid, varid, name, tp);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d name = %s", ncid, varid, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_get_att_int(int ncid, int varid, char *name, int *ip)
{
  static char func[] = "cdf_get_att_int";
  int status;

  status = nc_get_att_int(ncid, varid, name, ip);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d att = %s val = %d",
	    ncid, varid, name, *ip);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void cdf_get_att_double(int ncid, int varid, char *name, double *dp)
{
  static char func[] = "cdf_get_att_double";
  int status;

  status = nc_get_att_double(ncid, varid, name, dp);

  if ( CDF_Debug || status != NC_NOERR )
    Message(func, "ncid = %d varid = %d att = %s val = %.9g",
	    ncid, varid, name, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void cdf_inq_att(int ncid, int varid, const char *name, nc_type *xtypep,
	    size_t *lenp)
{
  static char func[] = "cdf_inq_att";
  int status;

  status = nc_inq_att(ncid, varid, name, xtypep, lenp);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_inq_att : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_atttype(int ncid, int varid, const char *name, nc_type * xtypep)
{
  static char func[] = "cdf_inq_atttype";
  int status;

  status = nc_inq_atttype(ncid, varid, name, xtypep);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_inq_atttype : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_attlen(int ncid, int varid, const char *name, size_t * lenp)
{
  static char func[] = "cdf_inq_attlen";
  int status;

  status = nc_inq_attlen(ncid, varid, name, lenp);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d name = %s len = %d",
	    ncid, varid, name, *lenp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_attname(int ncid, int varid, int attnum, char *name)
{
  static char func[] = "cdf_inq_attname";
  int status;

  status = nc_inq_attname(ncid, varid, attnum, name);

  if (CDF_Debug || status != NC_NOERR)
    Message(func, "ncid = %d varid = %d attnum = %d name = %s",
	    ncid, varid, attnum, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
cdf_inq_attid(int ncid, int varid, const char *name, int *attnump)
{
  static char func[] = "cdf_inq_attid";
  int status;

  status = nc_inq_attid(ncid, varid, name, attnump);

  if (CDF_Debug || status != NC_NOERR)
    fprintf (stderr, "cdf_inq_attid : %d %d \n", ncid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

#endif
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




extern int HDF_Fatal;
extern int HDF_Verbose;
extern int HDF_Debug;

#if  defined  (HAVE_LIBHDF5)

int hdf_create(const char *path, int cmode)
{
  static char func[] = "hdf_create";
  int hfid;

  hfid = H5Fcreate(path, cmode, H5P_DEFAULT, H5P_DEFAULT);

  if ( HDF_Debug || hfid < 0 )
    Message(func, "hfid = %d  mode = %d  file = %s", hfid, cmode, path);

  if ( hfid < 0 )
    {
      H5Eprint(NULL);
      Error(func, "%s", path);
    }

  return (hfid);
}

int hdf_open(const char *path, int omode)
{
  static char func[] = "hdf_open";
  int hfid;

  hfid = H5Fopen(path, omode, H5P_DEFAULT);

  if ( HDF_Debug || hfid < 0 )
    Message(func, "hfid = %d  mode = %d  file = %s", hfid, omode, path);

  if ( hfid < 0 )
    {
      H5Eprint(NULL);
      Error(func, "%s", path);
    }

  return (hfid);
}

void hdf_close(int hfid)
{
  static char func[] = "hdf_close";
  int status;

  status = H5Fclose(hfid);

  if ( status < 0 )
    {
      H5Eprint(NULL);
      Error(func, "close problem on %d", hfid);
    }
}
/*
void
hdf_redef(int hfid)
{
  static char func[] = "hdf_redef";
  int status;

  status = nc_redef(hfid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_enddef(int hfid)
{
  static char func[] = "hdf_enddef";
  int status;

  status = nc_enddef(hfid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_def_dim(int hfid, const char *name, size_t len, int *dimidp)
{
  static char func[] = "hdf_def_dim";
  int status;

  status = nc_def_dim(hfid, name, len, dimidp);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d  name = %s  len = %d", hfid, name, len);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_inq_dimid(int hfid, const char *name, int *dimidp)
{
  static char func[] = "hdf_inq_dimid";
  int status;

  status = nc_inq_dimid(hfid, name, dimidp);

  if (HDF_Debug || status != NC_NOERR)
    Message(func, "hfid = %d  name = %s  dimid= %d", hfid, name, *dimidp);

  if (status != NC_NOERR)
    Error(func, "%s", nc_strerror(status));
}

void
hdf_inq_dim(int hfid, int dimid, char *name, size_t * lengthp)
{
  static char func[] = "hdf_inq_dim";
  int status;

  status = nc_inq_dim(hfid, dimid, name, lengthp);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d  dimid = %d  length = %d name = %s",
	    hfid, dimid, *lengthp, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_inq_dimname(int hfid, int dimid, char *name)
{
  static char func[] = "hdf_inq_dimname";
  int status;

  status = nc_inq_dimname(hfid, dimid, name);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d  dimid = %d  name = %s", hfid, dimid, name);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_inq_dimlen(int hfid, int dimid, size_t * lengthp)
{
  static char func[] = "hdf_inq_dimlen";
  int status;

  status = nc_inq_dimlen(hfid, dimid, lengthp);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d dimid = %d length = %d", hfid, dimid, *lengthp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void hdf_def_var(int hfid, const char *name, int xtype, int ndims, const int dims[], int *varidp, int plistid)
{
  static char func[] = "hdf_def_var";
  int dataspace;
  hsize_t hdims[9], maxdims[9];
  int i;

  for ( i = 0; i < ndims; i++ )
    {
      hdims[i] = dims[i];
      maxdims[i] = dims[i];
    }

  if (  dims[0] == -1 )
    {
      hdims[0] = 1;
      maxdims[0] = H5S_UNLIMITED;
    }

  dataspace = H5Screate_simple(ndims, hdims, maxdims);
  *varidp   = H5Dcreate(hfid, name, xtype, dataspace, plistid);
  H5Sclose(dataspace);
  /*
  for ( i = 0; i < ndims; i++ ) printf("%s: dim %d size %d\n", func, i, dims[i]);
  */

  if ( HDF_Debug || *varidp < 0 )
    {
      int i;
      for ( i = 0; i < ndims; i++ ) printf("%s: dim %d size %d\n", func, i, dims[i]);
      Message(func, "hfid = %d  name = %s  xtype = %d  ndims = %d  varid = %d  plistid = %d",
	      hfid, name, xtype, ndims, *varidp, plistid);
    }

  if ( *varidp < 0 )
    {
      H5Eprint(NULL);
      Error(func, "%s", name);
    }
}

void hdf_inq_varid(int hfid, const char *name, int *varidp)
{
  static char func[] = "hdf_inq_varid";
  int status = 0;

  Message(func, "hfid = %d  name = %s  varid = %d ", hfid, name, *varidp);
  Error(func, "not implemented");

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d  name = %s  varid = %d ", hfid, name, *varidp);
  /*
  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
  */
}

int hdf_inq_ngatts(int hfid)
{
  int status;
  int obj;
  int ngatts = 0;

  obj = H5Gopen(hfid, "/");

  ngatts = H5Aget_num_attrs(obj);

  status = H5Gclose(obj);

  return (ngatts);
}

int hdf_inq_nvars(int hfid)
{
  static char func[] = "hdf_inq_nvars";
  int status;
  int nvars = 0;
  int groupID;
  char name[128];
  hsize_t num_obj, idx;

  groupID = H5Gopen(hfid, "/");
  status = H5Gget_num_objs(groupID, &num_obj);
  for ( idx = 0; idx < num_obj; idx++ )
    {
      if ( H5Gget_objtype_by_idx(groupID, idx) == H5G_DATASET )
	{
	  nvars++;
	}
      else if ( H5Gget_objtype_by_idx(groupID, idx) == H5G_GROUP )
	{
	  hsize_t num_obj2, idx2;
	  int groupID2;
	  H5Gget_objname_by_idx(groupID, idx, name, (size_t) 128);
	  groupID2 = H5Gopen(hfid, name);
	  status = H5Gget_num_objs(groupID2, &num_obj2);
	  for ( idx2 = 0; idx2 < num_obj2; idx2++ )
	    {
	      if ( H5Gget_objtype_by_idx(groupID2, idx2) == H5G_DATASET )
		{
		  nvars++;
		}
	      else if ( H5Gget_objtype_by_idx(groupID2, idx2) == H5G_GROUP )
		{
		  printf("group level2 not supported\n"); 
		}  
	    }
	  H5Gclose(groupID2);
	}
    }
  H5Gclose(groupID);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d  nvars = %d", hfid, nvars);

  return (nvars);
}
/*

void
hdf_inq_vartype(int hfid, int varid, nc_type *xtypep)
{
  static char func[] = "hdf_inq_vartype";
  int status;

  status = nc_inq_vartype(hfid, varid, xtypep);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d varid = %d xtype = %s", hfid, varid, *xtypep);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
int hdf_inq_varndims(int varid)
{
  static char func[] = "hdf_inq_varndims";
  int status;
  int varspaceid;
  int ndims;

  varspaceid = H5Dget_space(varid);
  ndims = H5Sget_simple_extent_ndims(varspaceid);
  status = H5Sclose(varspaceid);

  if ( HDF_Debug || status < 0 )
    Message(func, "varid = %d\n", varid);

  return (ndims);
}
/*

int hdf_inq_varxtype(int varid)
{
  static char func[] = "hdf_inq_varxtype";
  int status;
  int varspaceid;
  int xtype;

  varspaceid = H5Dget_space(varid);
  status = H5Sclose(varspaceid);

  if ( HDF_Debug || status < 0 )
    Message(func, "varid = %d\n", varid);
    Message(func, "varid = %d not implemented\n", varid);

  return (xtype);
}

void
hdf_inq_vardimid(int hfid, int varid, int dimids[])
{
  static char func[] = "hdf_inq_vardimid";
  int status;

  status = nc_inq_vardimid(hfid, varid, dimids);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_inq_vardimid : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_inq_varnatts(int hfid, int varid, int *nattsp)
{
  static char func[] = "hdf_inq_varnatts";
  int status;

  status = nc_inq_varnatts(hfid, varid, nattsp);

  if (HDF_Debug || status != NC_NOERR)
    Message(func, "hfid = %d varid = %d nattsp = %d", hfid, varid, *nattsp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_put_var_text(int hfid, int varid, const char *tp)
{
  static char func[] = "hdf_put_var_text";
  int status;

  status = nc_put_var_text(hfid, varid, tp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_put_var_text : %d %d %s \n", hfid, varid, tp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}


void
hdf_put_var_short(int hfid, int varid, const short *sp)
{
  static char func[] = "hdf_put_var_short";
  int status;

  status = nc_put_var_short(hfid, varid, sp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_put_var_short : %d %d %hd \n", hfid, varid, *sp);

  if (status != NC_NOERR)
    Error(func, "%s", nc_strerror(status));
}
*/
void
hdf_put_var_int(int hfid, int varid, const int *ip)
{
  static char func[] = "hdf_put_var_int";
  int status;

  status = H5Dwrite(varid, H5T_NATIVE_INT, H5S_ALL, H5S_ALL, H5P_DEFAULT, ip);

  if ( HDF_Debug || status < 0 )
    fprintf (stderr, "hdf_put_var_int : %d %d %d \n", hfid, varid, *ip);

  if ( status < 0 )
    {
      H5Eprint(NULL);
      Error(func, "write problem");
    }
}
/*
void
hdf_put_var_long(int hfid, int varid, const long *lp)
{
  static char func[] = "hdf_put_var_long";
  int status;

  status = nc_put_var_long(hfid, varid, lp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_put_var_long : %d %d %ld \n", hfid, varid, *lp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_put_var_float(int hfid, int varid, const float *fp)
{
  static char func[] = "hdf_put_var_float";
  int status;

  status = nc_put_var_float(hfid, varid, fp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_put_var_float : %d %d %f \n", hfid, varid, *fp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void  hdf_put_vara_double(int hfid, int varid, const size_t start[],
			  const size_t count[], const double *dp)
{
  static char func[] = "hdf_put_vara_double";
  int status;
  int i, ndims;
  int dataspace, filespace;
  int memspace;
  hsize_t hcount[9];
  hssize_t hstart[9];


  dataspace = H5Dget_space(varid);
  filespace = H5Dget_space(varid);

  ndims = H5Sget_simple_extent_ndims(dataspace);

  for ( i = 0; i < ndims; i++ )
    {
      /* printf("%s: %5d %5d\n", func, start[i], count[i]); */
      hstart[i] = start[i];
      hcount[i] = count[i];
      /* printf("%s: %5lld %5lld\n", func, hstart[i], hcount[i]); */
    }
  memspace = H5Screate_simple(ndims, hcount, NULL);

  status = H5Sselect_hyperslab(filespace, H5S_SELECT_SET, hstart, NULL, hcount, NULL);
  /*
  for ( i = 0; i < ndims; i++ )
    {
      printf("%s: %5d %5d\n", func, start[i], count[i]);
    }
  */
  /*
  if ( status < 0 ) H5Eprint(NULL);

  {
    hsize_t hdims[9], hmaxdims[9];

  H5Sget_simple_extent_dims(dataspace, hdims, hmaxdims);
  printf("data : %d", varid);
  for ( i = 0; i < ndims; i++ )
    printf("%4lld %4lld ", hdims[i], hmaxdims[i]);
  printf("\n");
  H5Sget_simple_extent_dims(filespace, hdims, hmaxdims);
  printf("file : %d", varid);
  for ( i = 0; i < ndims; i++ )
    printf("%4lld %4lld ", hdims[i], hmaxdims[i]);
  printf("\n");
  H5Sget_simple_extent_dims(memspace, hdims, hmaxdims);
  printf("mem  : %d", varid);
  for ( i = 0; i < ndims; i++ )
    printf("%4lld %4lld ", hdims[i], hmaxdims[i]);
  printf("\n");
  }
  */
  status = H5Dwrite(varid, H5T_NATIVE_DOUBLE, memspace, filespace, H5P_DEFAULT, dp);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d val0 = %f", hfid, varid, *dp);

  if ( status < 0 )
    {
      H5Eprint(NULL);
      Error(func, "write problem");
    }

  H5Sclose(memspace);
  H5Sclose(filespace);
  H5Sclose(dataspace);
}
/*
void 
hdf_get_vara_int (int hfid, int varid, const size_t start[],
		  const size_t count[], int *dp)
{
  static char func[] = "hdf_get_vara_int";
  int status;

  status = nc_get_vara_int(hfid, varid, start, count, dp);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d varid = %d val0 = %d", hfid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void 
hdf_get_vara_double (int hfid, int varid, const size_t start[],
		     const size_t count[], double *dp)
{
  static char func[] = "hdf_get_vara_double";
  int status;

  status = nc_get_vara_double(hfid, varid, start, count, dp);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d varid = %d val0 = %f", hfid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void
hdf_put_var_double(int hfid, int varid, const double *dp)
{
  static char func[] = "hdf_put_var_double";
  int status;

  status = H5Dwrite(varid, H5T_NATIVE_DOUBLE, H5S_ALL, H5S_ALL, H5P_DEFAULT, dp);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d val0 = %f", hfid, varid, *dp);

  if ( status < 0 )
    {
      H5Eprint(NULL);
      Error(func, "write problem");
    }
}
/*
void 
hdf_get_var1_double(int hfid, int varid, const size_t index[], double *dp)
{
  static char func[] = "hdf_get_var1_double";
  int status;

  status = nc_get_var1_double(hfid, varid, index, dp);

  if ( HDF_Debug || status != NC_NOERR )
    Message(func, "hfid = %d varid = %d val = %f", hfid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void
hdf_put_var1_double(int hfid, int varid, const size_t index[], const double *dp)
{
  static char func[] = "hdf_put_var1_double";
  int status;
  int filespace;
  int memspace;
  hsize_t hcount[1];
  hssize_t hstart[1];
    
  filespace = H5Dget_space(varid);

  hstart[0] = index[0];
  hcount[0] = 1;

  memspace = H5Screate_simple(1, hcount, NULL); 

  status = H5Sselect_hyperslab(filespace, H5S_SELECT_SET, hstart, NULL, hcount, NULL);

  if ( status < 0 ) H5Eprint(NULL);

  status = H5Dwrite(varid, H5T_NATIVE_DOUBLE, memspace, filespace, H5P_DEFAULT, dp);

  /*
  status = nc_put_var1_double(hfid, varid, index, dp);
  */
  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d val = %f", hfid, varid, *dp);

  if ( status < 0 )
    {
      H5Eprint(NULL);
      Error(func, "write problem");
    }

  H5Sclose(memspace);
  H5Sclose(filespace);
}
/*
void
hdf_get_var_text(int hfid, int varid, char *tp)
{
  static char func[] = "hdf_get_var_text";
  int status;

  status = nc_get_var_text(hfid, varid, tp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_get_var_text : %d %d \n", hfid, varid);

  if (status != NC_NOERR)
    Error(func, "%s", nc_strerror(status));
}

void
hdf_get_var_short(int hfid, int varid, short *sp)
{
  static char func[] = "hdf_get_var_short";
  int status;

  status = nc_get_var_short(hfid, varid, sp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_get_var_short : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_get_var_int(int hfid, int varid, int *ip)
{
  static char func[] = "hdf_get_var_int";
  int status;

  status = nc_get_var_int(hfid, varid, ip);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_get_var_int : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_get_var_long(int hfid, int varid, long *lp)
{
  static char func[] = "hdf_get_var_long";
  int status;

  status = nc_get_var_long(hfid, varid, lp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_get_var_long : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_get_var_float(int hfid, int varid, float *fp)
{
  static char func[] = "hdf_get_var_float";
  int status;

  status = nc_get_var_float(hfid, varid, fp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_put_var_float : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_get_var_double(int hfid, int varid, double *dp)
{
  static char func[] = "hdf_get_var_double";
  int status;

  status = nc_get_var_double(hfid, varid, dp);

  if (HDF_Debug || status != NC_NOERR)
    Message(func, "hfid = %d varid = %d val[0] = %f", hfid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_copy_att(int hfid_in, int varid_in, const char *name, int hfid_out,
	     int varid_out)
{
  static char func[] = "hdf_copy_att";
  int status;

  status = nc_copy_att(hfid_in, varid_in, name, hfid_out, varid_out);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_copy_att : %d %d %s %d %d\n", hfid_in, varid_out,
	     name, hfid_out, varid_out);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void hdf_put_att_text(int hfid, int varid, const char *name, size_t len, const char *tp)
{
  static char func[] = "hdf_put_att_text";
  int status;
  int aid, atype, obj, att;

  if ( varid == -1 )
    obj = H5Gopen(hfid, "/");
  else
    obj = varid;

  aid = H5Screate(H5S_SCALAR);
  atype = H5Tcopy(H5T_C_S1);
  H5Tset_size(atype, len);
  att = H5Acreate(obj, name, atype, aid, H5P_DEFAULT);
  status = H5Awrite(att, atype, tp);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d att = %s text = %s", hfid, varid, name, tp);

  if ( status < 0 )
    Error(func, "att problem");

  status = H5Sclose(aid);
  status = H5Tclose(atype);
  status = H5Aclose(att);
  if ( varid == -1 )
    status = H5Gclose(obj);
}
/*
void
hdf_put_att_int(int hfid, int varid, const char *name, nc_type xtype,
		size_t len, const int *ip)
{
  static char func[] = "hdf_put_att_int";
  int status;

  status = nc_put_att_int(hfid, varid, name, xtype, len, ip);

  if (HDF_Debug || status != NC_NOERR)
    Message(func, "hfid = %d varid = %d att = %s val = %d",
	    hfid, varid, name, *ip);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_put_att_double(int hfid, int varid, const char *name, nc_type xtype,
		   size_t len, const double *dp)
{
  static char func[] = "hdf_put_att_double";
  int status;

  status = nc_put_att_double(hfid, varid, name, xtype, len, dp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_put_att_double : %d %d %f \n", hfid, varid, *dp);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void hdf_get_att_text(int hfid, int varid, char *name, char *tp)
{
  static char func[] = "hdf_get_att_text";
  int status;
  int aid, atype, obj, att;

  if ( varid == -1 )
    obj = H5Gopen(hfid, "/");
  else
    obj = varid;

  att = H5Aopen_name(obj, name);
  atype = H5Aget_type(att);
  aid = H5Aget_space(att);

  status = H5Aread(att, atype, tp);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d name = %s", hfid, varid, name);
  /*

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
  */

  status = H5Sclose(aid);
  status = H5Tclose(atype);
  status = H5Aclose(att);
  if ( varid == -1 )
    status = H5Gclose(obj);
}

void hdf_get_att_int(int hfid, int varid, char *name, int *ip)
{
  static char func[] = "hdf_get_att_int";
  int status;
  int obj, att;

  if ( varid == -1 )
    obj = H5Gopen(hfid, "/");
  else
    obj = varid;

  att = H5Aopen_name(obj, name);

  status = H5Aread(att, H5T_NATIVE_INT, ip);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d att = %s val = %d",
	    hfid, varid, name, *ip);
  /*

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
  */

  status = H5Aclose(att);
  if ( varid == -1 )
    status = H5Gclose(obj);
}

void hdf_get_att_double(int hfid, int varid, char *name, double *dp)
{
  static char func[] = "hdf_get_att_double";
  int status;
  int obj, att;

  if ( varid == -1 )
    obj = H5Gopen(hfid, "/");
  else
    obj = varid;

  att = H5Aopen_name(obj, name);

  status = H5Aread(att, H5T_NATIVE_DOUBLE, dp);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d att = %s val = %d",
	    hfid, varid, name, *dp);
  /*

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
  */

  status = H5Aclose(att);
  if ( varid == -1 )
    status = H5Gclose(obj);
}

/*
void
hdf_inq_att(int hfid, int varid, const char *name, nc_type *xtypep,
	    size_t *lenp)
{
  static char func[] = "hdf_inq_att";
  int status;

  status = nc_inq_att(hfid, varid, name, xtypep, lenp);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_inq_att : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}

void
hdf_inq_atttype(int hfid, int varid, const char *name, nc_type * xtypep)
{
  static char func[] = "hdf_inq_atttype";
  int status;

  status = nc_inq_atttype(hfid, varid, name, xtypep);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_inq_atttype : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/
void hdf_inq_attlen(int hfid, int varid, const char *name, size_t *lenp)
{
  static char func[] = "hdf_inq_attlen";
  int status = 0;
  int atype, obj, att;

  if ( varid == -1 )
    obj = H5Gopen(hfid, "/");
  else
    obj = varid;

  att = H5Aopen_name(obj, name);
  atype = H5Aget_type(att);

  *lenp = H5Tget_size(atype);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d name = %s len = %d",
	    hfid, varid, name, *lenp);
  /*
  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
  */

  status = H5Tclose(atype);
  status = H5Aclose(att);
  if ( varid == -1 )
    status = H5Gclose(obj);
}

void hdf_inq_attname(int hfid, int varid, int attnum, char *name)
{
  static char func[] = "hdf_inq_attname";
  int status;
  int obj, attid;
  size_t len;

  if ( varid == -1 )
    obj = H5Gopen(hfid, "/");
  else
    obj = varid;

  attid = H5Aopen_idx(obj, attnum);
  len = (size_t) H5Aget_name(attid, (size_t) 128, name);

  status = H5Aclose(attid);
  if ( varid == -1 )
    status = H5Gclose(obj);

  if ( HDF_Debug || status < 0 )
    Message(func, "hfid = %d varid = %d attnum = %d name = %s",
	    hfid, varid, attnum, name);

  /*
  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
  */
}
/*
void
hdf_inq_attid(int hfid, int varid, const char *name, int *attnump)
{
  static char func[] = "hdf_inq_attid";
  int status;

  status = nc_inq_attid(hfid, varid, name, attnump);

  if (HDF_Debug || status != NC_NOERR)
    fprintf (stderr, "hdf_inq_attid : %d %d \n", hfid, varid);

  if ( status != NC_NOERR )
    Error(func, "%s", nc_strerror(status));
}
*/

#endif
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif


static char UnknownError[] = "Unknown Error";

const char *cdiStringError(int cdiErrno)
{
  switch (cdiErrno) {
  case CDI_ESYSTEM:
    {
      const char *cp = (const char *) strerror(errno);
      if ( cp == NULL ) break;
      return cp;
    }
  case CDI_EUFTYPE:
    return "Unsupported file type";
  case CDI_ELIBNAVAIL:
    return "Unsupported file type (library not available)";
  case CDI_EUFSTRUCT:
    return "Unsupported file structure";
  }

  return UnknownError;
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





int cdiDefaultInstID  = CDI_UNDEFID;
int cdiDefaultModelID = CDI_UNDEFID;
int cdiDefaultTableID = CDI_UNDEFID;

double cdiDefaultMissval = -9.E33;


char *Filetypes[] = {
  "UNKNOWN",
  "GRIB",
  "GRIB2",
  "netCDF",
  "netCDF2",
  "SERVICE",
  "EXTRA",
  "HDF5",
  "BIN",
};

#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID

CDITABLE *streams = 0;
int streamsSize = 0;

int CDI_Debug   = 0;    /* If set to 1, debugging           */


char *strfiletype(int filetype)
{
  char *name;
  int size = sizeof(Filetypes)/sizeof(char *);

  if ( filetype > 0 && filetype < size )
    name = Filetypes[filetype];
  else
    name = Filetypes[0];  

  return (name);
}

void streamCheckID(const char *func, int streamID)
{
  if ( streamID == CDI_UNDEFID )
    Error(func, "streamID undefined!");

  if ( streamID < 0 || streamID >= streamsSize )
    Error(func, "streamID %d out of range!", streamID);

  if ( streams[streamID].filename == NULL )
    Error(func, "streamID %d not open!", streamID);
}

int cdiDefaultLeveltype = -1;
static int cdiDataUnreduced = 0;
static int cdiDataCompress = 0;


int cdiDefGlobal(const char *string, int val)
{
  int ret = 0;

  if ( strcmp(string, "CD_REGULARGRID") == 0 )
    {
      cdiDataUnreduced = val;
      ret = 1;
    }

  return (ret);
}

void cdiDefCompress(int level)
{
  cdiDataCompress = level;
}

long cdiGetenvInt(char *envName)
{
  static char func[] = "cdiGetenv";
  char *envString;
  long envValue = -1;
  long fact = 1;

  envString = getenv(envName);

  if ( envString )
    {
      int loop, len;

      len = (int) strlen(envString);
      for ( loop = 0; loop < len; loop++ )
	{
	  if ( ! isdigit((int) envString[loop]) )
	    {
	      switch ( tolower((int) envString[loop]) )
		{
		case 'k':  fact = 1024;        break;
		case 'm':  fact = 1048576;     break;
		case 'g':  fact = 1073741824;  break;
		default:
		  fact = 0;
		  Message(func, "Invalid number string in %s: %s", envName, envString);
		  Warning(func, "%s must comprise only digits [0-9].",envName);
		}
	      break;
	    }
	}

      if ( fact ) envValue = fact*atol(envString);

      if ( CDI_Debug ) Message(func, "set %s to %ld", envName, envValue);
    }

  return (envValue);
}

void cdiInitialize(void)
{
  static int Init_CDI = FALSE;
  char *envString;
  long value;

  if ( ! Init_CDI )
    {
      Init_CDI = TRUE;

      value = cdiGetenvInt("CD_REGULARGRID");
      if ( value >= 0 ) cdiDataUnreduced = (int) value;

      value = cdiGetenvInt("CD_LEVELTYPE");
      if ( value >= 0 ) cdiDefaultLeveltype = (int) value;

      envString = getenv("CD_MISSVAL");
      if ( envString ) cdiDefaultMissval = atof(envString);
    }
}

void cdiDefMissval(double missval)
{
  cdiInitialize();

  cdiDefaultMissval = missval;

}

double cdiInqMissval(void)
{
  cdiInitialize();

  return (cdiDefaultMissval);;
}

void streamsInitEntry(int streamID)
{
  static char func[] = "streamsInitEntry";
  int i;

  if ( streamID < 0 || streamID >= streamsSize )
    Error(func, "streamID %d undefined!", streamID);

  cdiInitialize();

  streams[streamID].accesstype        = UNDEFID;
  streams[streamID].accessmode        = 0;
  streams[streamID].filetype          = UNDEFID;
  streams[streamID].byteorder         = UNDEFID;
  streams[streamID].fileID            = 0;
  streams[streamID].dimgroupID        = UNDEFID;
  streams[streamID].filemode          = 0;
  streams[streamID].filename          = NULL;
  streams[streamID].ctlname           = NULL;
  streams[streamID].ctlfp             = NULL;
  streams[streamID].record            = NULL;
  streams[streamID].varsAllocated     = 0;
  streams[streamID].nrecs             = 0;
  streams[streamID].nvars             = 0;
  streams[streamID].vars              = NULL;
  streams[streamID].varinit           = 0;
  streams[streamID].ncmode            = 0;
  streams[streamID].curTsID           = UNDEFID;
  streams[streamID].rtsteps           = 0;
  streams[streamID].ntsteps           = UNDEFID;
  streams[streamID].numTimestep       = 0;
  streams[streamID].tsteps            = NULL;
  streams[streamID].tstepsTableSize   = 0;
  streams[streamID].tstepsNextID      = 0;
  streams[streamID].historyID         = UNDEFID;
  streams[streamID].vlistID           = UNDEFID;
  streams[streamID].globalatts        = 0;
  streams[streamID].localatts         = 0;
  streams[streamID].vct.ilev          = 0;
  streams[streamID].vct.mlev          = 0;
  streams[streamID].vct.ilevID        = UNDEFID;
  streams[streamID].vct.mlevID        = UNDEFID;
  streams[streamID].unreduced         = cdiDataUnreduced;
  streams[streamID].compress          = cdiDataCompress;

  basetimeInit(&streams[streamID].basetime);

  for ( i = 0; i < MAX_GRIDS; i++ ) streams[streamID].xdimID[i]   = UNDEFID;
  for ( i = 0; i < MAX_GRIDS; i++ ) streams[streamID].ydimID[i]   = UNDEFID;
  for ( i = 0; i < MAX_ZAXIS; i++ ) streams[streamID].zaxisID[i]  = UNDEFID;
  for ( i = 0; i < MAX_GRIDS; i++ ) streams[streamID].ncxvarID[i] = UNDEFID;
  for ( i = 0; i < MAX_GRIDS; i++ ) streams[streamID].ncyvarID[i] = UNDEFID;
  for ( i = 0; i < MAX_GRIDS; i++ ) streams[streamID].ncavarID[i] = UNDEFID;
}

int streamsNewEntry(int filetype)
{
  static char func[] = "streamsNewEntry";
  int streamsMax = 1024;
  int streamID = 0;

  /*
    Look for a free slot in streams.
    (Create the table the first time through).
  */
  if ( !streamsSize )
    {
      int i;

      streamsSize = 2;
      streams = (CDITABLE *) malloc(streamsSize*sizeof(CDITABLE));
      if( streams == NULL )
	{
          Message(func, "streamsSize = %d", streamsSize);
	  SysError(func, "Allocation of CDITABLE failed");
	}

      for( i = 0; i < streamsSize; i++ )
	streamsInitEntry(i);
    }
  else
    {
      while( streamID < streamsSize )
	{
	  if ( streams[streamID].filetype == UNDEFID ) break;
	  streamID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if( streamID == streamsSize )
    {
      int i;

      if ( streamsSize == streamsMax )
	Error(func, "CDI maximum table size of %d reached", streamsMax);

      streamsSize = 2*streamsSize;
      streams = (CDITABLE *) realloc(streams, streamsSize*sizeof(CDITABLE));
      if( streams == NULL )
	{
          Message(func, "streamsSize = %d", streamsSize);
	  SysError(func, "Reallocation of CDITABLE failed");
	}
      streamID = streamsSize/2;

      for( i = streamID; i < streamsSize; i++ )
	streamsInitEntry(i);
    }

  streamsInitEntry(streamID);

  streams[streamID].filetype = filetype;

  return (streamID);
}

void cdiCheckContents(int streamID)
{
  static char func[] = "cdiCheckContents";
  int index, nzaxis, zaxisID;
  int vlistID;

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);
  nzaxis = vlistNzaxis(vlistID);

  for ( index = 0; index < nzaxis; index++ )
    {
      zaxisID = vlistZaxis(vlistID, index);
      if ( zaxisInqType(zaxisID) == ZAXIS_GENERIC )
	cdiCheckZaxis(zaxisID);
    }
    
}

int streamInqFileID(int streamID)
{
  return (streams[streamID].fileID);
}

void streamDefineTaxis(int streamID)
{
  static char func[] = "streamDefineTaxis";

  if ( streams[streamID].tsteps == NULL )
    {
      int varID, nvars;
      int vlistID;
  
      vlistID = streamInqVlist(streamID);

      nvars = vlistNvars(vlistID);
      for ( varID = 0; varID < nvars; varID++ )
	if ( vlistInqVarTime(vlistID, varID) == TIME_VARIABLE ) break;

      if ( varID == nvars )
	{
	  int taxisID;

	  taxisID = vlistInqTaxis(vlistID);
	  if ( taxisID == CDI_UNDEFID )
	    {
	      taxisID = taxisNew(TAXIS_ABSOLUTE);
	      vlistDefTaxis(vlistID, taxisID);
	    }
	    
	  (void) streamDefTimestep(streamID, 0);
	}
      else
	Error(func, "time axis undefined");
    }
}

void streamDefDimgroupID(int streamID, int dimgroupID)
{
  streams[streamID].dimgroupID = dimgroupID;
}

int streamInqDimgroupID(int streamID)
{
  return (streams[streamID].dimgroupID);
}

void cdiDefAccesstype(int streamID, int type)
{
  static char func[] = "cdiDefAccesstype";

  if ( streams[streamID].accesstype == UNDEFID )
    {
      streams[streamID].accesstype = type;
    }
  else
    {
      if ( streams[streamID].accesstype != type )
	{
	  if ( streams[streamID].accesstype == TYPE_REC )
	    Error(func, "Change access type from REC to VAR not allowed!");
	  else
	    Error(func, "Change access type from VAR to REC not allowed!");
	}
    }
}

int cdiInqAccesstype(int streamID)
{
  return (streams[streamID].accesstype);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





void cdiPrintDefaults(void)
{
  fprintf (stderr, "default instID     :  %d\n", cdiDefaultInstID); 
  fprintf (stderr, "default modelID    :  %d\n", cdiDefaultModelID); 
  fprintf (stderr, "default tableID    :  %d\n", cdiDefaultTableID); 
  fprintf (stderr, "default missval    :  %g\n", cdiDefaultMissval); 
}


void cdiDebug(int level)
{
  static char func[] = "cdiDebug";

  if ( level == 1 || level &  2 ) CDI_Debug = 1;

  if ( CDI_Debug ) Message(func, "debug level %d", level);

  if ( level == 1 || level &  4 ) memDebug(1);

  if ( level == 1 || level &  8 ) fileDebug(1);

  if ( level == 1 || level & 16 )
    {
#if  defined  (HAVE_LIBGRIB)
      gribSetDebug(1);
#endif
#if  defined  (HAVE_LIBNETCDF)
      cdfDebug(1);
#endif
#if  defined  (HAVE_LIBHDF5)
      hdfDebug(1);
#endif
#if  defined  (HAVE_LIBSERVICE)
      srvDebug(1);
#endif
#if  defined  (HAVE_LIBEXTRA)
      extDebug(1);
#endif
    }

  if ( CDI_Debug )
    {
      cdiPrintDefaults();
      cdiPrintDatatypes();
    }
}


int getFiletype(const char *filename)
{
  static char func[] = "getFiletype";
  int filetype = CDI_EUFTYPE;
  int fileID;
  int swap;
  long recpos;
  char buffer[4];

  fileID = fileOpen(filename, "r");

  if ( fileID == CDI_UNDEFID )            return (CDI_ESYSTEM);
  if ( fileRead(fileID, buffer, 4) != 4 ) return (CDI_EUFTYPE);

  fileRewind(fileID);

  if ( strncmp(buffer, "GRIB", 4) == 0 )
    {
      filetype = FILETYPE_GRB;
      if ( CDI_Debug ) Message(func, "found GRIB file = %s", filename);
    }
  else if ( strncmp(buffer, "CDF\001", 4) == 0 )
    {
      filetype = FILETYPE_NC;
      if ( CDI_Debug ) Message(func, "found CDF1 file = %s", filename);
    }
  else if ( strncmp(buffer, "CDF\002", 4) == 0 )
    {
      filetype = FILETYPE_NC2;
      if ( CDI_Debug ) Message(func, "found CDF2 file = %s", filename);
    }
  else if ( strncmp(buffer+1, "HDF", 3) == 0 )
    {
      filetype = FILETYPE_H5;
      if ( CDI_Debug ) Message(func, "found HDF file = %s", filename);
    }
#if  defined  (HAVE_LIBSERVICE)
  else if ( srvCheckFiletype(fileID, &swap) )
    {
      filetype = FILETYPE_SRV;
      if ( CDI_Debug ) Message(func, "found SRV file = %s", filename);
    }
#endif
#if  defined  (HAVE_LIBEXTRA)
  else if ( extCheckFiletype(fileID, &swap) )
    {
      filetype = FILETYPE_EXT;
      if ( CDI_Debug ) Message(func, "found EXT file = %s", filename);
    }
#endif
  else if ( gribFileSeek(fileID, &recpos) == 0 )
    {
      filetype = FILETYPE_GRB;
      if ( CDI_Debug ) Message(func, "found seek GRIB file = %s", filename);
    }

  fileClose(fileID);

  return (filetype);
}


/*
@Function  streamInqFiletype
@Title     Get the filetype

@Prototype int streamInqFiletype(int streamID)
@Parameter
    @Item  streamID  Stream identifier

@Description
The function {\tt streamInqFiletype} gets the filetype of a stream.

@Result
{\tt streamInqFiletype} return the type of the file format,
one of the set of predefined CDI file format types.
The valid CDI file format types are {\tt FILETYPE_GRB}, {\tt FILETYPE_NC},
{\tt FILETYPE_NC2}, {\tt FILETYPE_SRV}, and {\tt FILETYPE_EXT}.

@EndFunction
*/
int streamInqFiletype(int streamID)
{
  static char func[] = "streamInqFiletype";

  streamCheckID(func, streamID);

  return (streams[streamID].filetype);
}


#undef  IsBigendian
#define IsBigendian()  ( u_byteorder.c[sizeof(long) - 1] )

#define  CDI_BIGENDIAN            0   /* Data type BIGENDIAN     */
#define  CDI_LITTLEENDIAN         1   /* Data type LITTLEENDIAN  */


void streamDefByteorder(int streamID, int byteorder)
{
  static char func[] = "streamDefByteorder";
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  int filetype, fileID;

  streamCheckID(func, streamID);

  streams[streamID].byteorder = byteorder;
  filetype = streams[streamID].filetype;
  fileID   = streams[streamID].fileID;

  switch (filetype)
    {
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
	if ( IsBigendian() )
	  {
	    if ( byteorder == CDI_LITTLEENDIAN ) srvDefByteswap(fileID);
	  }
	else
	  {
	    if ( byteorder == CDI_BIGENDIAN ) srvDefByteswap(fileID);
	  }

	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
	if ( IsBigendian() )
	  {
	    if ( byteorder == CDI_LITTLEENDIAN ) extDefByteswap(fileID);
	  }
	else
	  {
	    if ( byteorder == CDI_BIGENDIAN ) extDefByteswap(fileID);
	  }

	break;
      }
#endif
    }
}


int streamInqByteorder(int streamID)
{
  static char func[] = "streamInqByteorder";

  streamCheckID(func, streamID);

  return (streams[streamID].byteorder);
}


char *streamFilesuffix(int filetype)
{
  static char *fileSuffix[] = {"", ".grb", ".g2", ".nc", ".nc2", ".srv", ".ext", ".h5", ".dat"};
  int size = sizeof(fileSuffix)/sizeof(char *);

  if ( filetype > 0 && filetype < size )
    return (fileSuffix[filetype]);
  else
    return (fileSuffix[0]);
}


char *streamFilename(int streamID)
{
  static char func[] = "streamFilename";

  streamCheckID(func, streamID);

  return (streams[streamID].filename);
}


int cdiInqTimeSize(int streamID)
{
  static char func[] = "cdiInqTimeSize";
  int ntsteps;
  int tsID = 0, nrecs;

  streamCheckID(func, streamID);

  ntsteps = streams[streamID].ntsteps;

  if ( ntsteps == CDI_UNDEFID )
    while ( (nrecs = streamInqTimestep(streamID, tsID++)) )

  ntsteps = streams[streamID].ntsteps;

  return (ntsteps);
}

int cdiInqContents(int streamID)
{
  static char func[] = "cdiInqContents";
  int filetype;
  int vlistID;
  int taxisID;
  int status = 0;

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        status = grbInqContents(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        status = srvInqContents(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        status = extInqContents(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
        cdfInqContents(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
        hdfInqContents(streamID);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }

  if ( status == 0 )
    {
      vlistID = streamInqVlist(streamID);
      taxisID = vlistInqTaxis(vlistID);
      if ( taxisID != -1 )
	ptaxisCopy(taxisPtr(taxisID), &streams[streamID].tsteps[0].taxis);
    }

  return (status);
}

void cdiReadByteorder(int streamID)
{
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  int byteorder = -1;
  int filetype, fileID;

  filetype = streams[streamID].filetype;
  fileID   = streams[streamID].fileID;

  switch (filetype)
    {
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
	if ( IsBigendian() )
	  {
	    if ( srvInqByteswap(fileID) ) byteorder = CDI_LITTLEENDIAN;
	    else                          byteorder = CDI_BIGENDIAN;
	  }
	else
	  {
	    if ( srvInqByteswap(fileID) ) byteorder = CDI_BIGENDIAN;
	    else                          byteorder = CDI_LITTLEENDIAN;
	  }
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
	if ( IsBigendian() )
	  {
	    if ( extInqByteswap(fileID) ) byteorder = CDI_LITTLEENDIAN;
	    else                          byteorder = CDI_BIGENDIAN;
	  }
	else
	  {
	    if ( extInqByteswap(fileID) ) byteorder = CDI_BIGENDIAN;
	    else                          byteorder = CDI_LITTLEENDIAN;
	  }
	break;
      }
#endif
    default:
      {
	if ( IsBigendian() )
	  byteorder = CDI_BIGENDIAN;
	else
	  byteorder = CDI_LITTLEENDIAN;
	
	break;
      }
    }

  streams[streamID].byteorder = byteorder;
}

int streamOpen(const char *filename, const char *filemode, int filetype)
{
  static char func[] = "streamOpen";
  int fileID = CDI_UNDEFID;
  int streamID = CDI_ESYSTEM;
  int status;
  Record *record = NULL;

  if ( CDI_Debug )
    Message(func, "Open %s mode %c file %s", strfiletype(filetype), (int) *filemode, filename);

  if ( ! filename || ! filemode || filetype < 0 ) return (CDI_EINVAL);

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        fileID = gribOpen(filename, filemode);
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        fileID = srvOpen(filename, filemode);
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        fileID = extOpen(filename, filemode);
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
      {
	fileID = cdfOpen(filename, filemode);
	break;
      }
    case FILETYPE_NC2:
      {
	fileID = cdfOpen64(filename, filemode);
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
	fileID = hdfOpen(filename, filemode);
	break;
      }
#endif
    default:
      {
	if ( CDI_Debug ) Message(func, "%s library not available!", strfiletype(filetype));
	return (CDI_ELIBNAVAIL);
      }
    }

  if ( fileID < 0 )
    {
      streamID = fileID;
    }
  else
    {
      streamID = streamsNewEntry(filetype);

      streams[streamID].record   = record;
      streams[streamID].filetype = filetype;
      streams[streamID].filemode = tolower(*filemode);

      streams[streamID].filename = strdup(filename);

      streams[streamID].fileID   = fileID;

      if ( streams[streamID].filemode == 'r' )
	{
	  streams[streamID].vlistID = vlistNew();
	  cdiReadByteorder(streamID);
	  status = cdiInqContents(streamID);
	  if ( status < 0 ) return (status);
	  vlist[streams[streamID].vlistID].ntsteps = streamNtsteps(streamID);
	}

      if ( streams[streamID].filemode == 'w' )
	{
	  if ( filetype == FILETYPE_H5 ) hdfDefDimgroup(streamID);
	}
    }
 
  return (streamID);
}

int streamOpenAtest(const char *filename, const char *filemode, int filetype)
{
  static char func[] = "streamOpenAtest";
  int fileID = CDI_UNDEFID;
  int streamID = CDI_ESYSTEM;
  int status;
  Record *record = NULL;

  if ( CDI_Debug )
    Message(func, "Open %s mode %c file %s", strfiletype(filetype), (int) *filemode, filename);

  if ( ! filename || ! filemode || filetype < 0 ) return (CDI_EINVAL);

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        fileID = gribOpen(filename, "r");
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        fileID = srvOpen(filename, "r");
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        fileID = extOpen(filename, "r");
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
      {
	fileID = cdfOpen(filename, "r");
	break;
      }
    case FILETYPE_NC2:
      {
	fileID = cdfOpen64(filename, "r");
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
	fileID = hdfOpen(filename, "r");
	break;
      }
#endif
    default:
      {
	if ( CDI_Debug ) Message(func, "%s library not available!", strfiletype(filetype));
	return (CDI_ELIBNAVAIL);
      }
    }

  if ( fileID == CDI_UNDEFID || fileID == CDI_ELIBNAVAIL )
    {
      streamID = fileID;
      return (streamID);
    }
  else
    {
      streamID = streamsNewEntry(filetype);

      streams[streamID].record   = record;
      streams[streamID].filetype = filetype;
      streams[streamID].fileID   = fileID;
      streams[streamID].filemode = tolower(*filemode);
      streams[streamID].filename = strdup(filename);

      streams[streamID].vlistID = vlistNew();
      cdiReadByteorder(streamID);
      status = cdiInqContents(streamID);
      if ( status < 0 ) return (status);
      vlist[streams[streamID].vlistID].ntsteps = cdiInqTimeSize(streamID);
    }
 
  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
      case FILETYPE_GRB:
	{
	  gribClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBSERVICE)
      case FILETYPE_SRV:
	{
	  srvClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBEXTRA)
      case FILETYPE_EXT:
	{
	  extClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBNETCDF)
      case FILETYPE_NC:
      case FILETYPE_NC2:
	{
	  cdfClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBHDF5)
      case FILETYPE_H5:
	{
	  hdfClose(fileID);
	  break;
	}
#endif
      default:
	{
	  if ( CDI_Debug ) Message(func, "%s library not available!", strfiletype(filetype));
	  return (CDI_ELIBNAVAIL);
	}
    }

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        fileID = gribOpen(filename, filemode);
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        fileID = srvOpen(filename, filemode);
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        fileID = extOpen(filename, filemode);
	record = (Record *) malloc(sizeof(Record));
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
      {
	fileID = cdfOpen(filename, filemode);
	break;
      }
    case FILETYPE_NC2:
      {
	fileID = cdfOpen64(filename, filemode);
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
	fileID = hdfOpen(filename, filemode);
	break;
      }
#endif
    default:
      {
	if ( CDI_Debug ) Message(func, "%s library not available!", strfiletype(filetype));
	return (CDI_ELIBNAVAIL);
      }
    }

  if ( fileID == CDI_UNDEFID )
    streamID = CDI_UNDEFID;
  else
    streams[streamID].fileID   = fileID;

  return (streamID);
}


/*
@Function  streamOpenRead
@Title     Open a file for reading

@Prototype int streamOpenRead(const char *filename)
@Parameter
    @Item  filename  The file name of the dataset to be read

@Description
The function {\tt streamOpenRead} opens an existing file for reading.

@Result
Upon successful completion {\tt streamOpenRead} return an identifier to the
open stream. Otherwise, a negative number with the error status is returned.

@Errors
@List
   @Item  CDI_ESYSTEM     Operating system error
   @Item  CDI_EINVAL      Invalid argument
   @Item  CDI_EUFILETYPE  Unsupported file type
   @Item  CDI_ELIBNAVAIL  Library not available
@EndList

@Example
Here is an example using {\tt streamOpenRead} to open an existing netCDF
file named {\tt foo.nc} for reading:

@Source
   ...
int streamID;
   ...
streamID = streamOpenRead("foo.nc");
if ( streamID < 0 ) handle_error(streamID);
   ...
@EndSource
@EndFunction
*/
int streamOpenRead(const char *filename)
{
  int filetype;
  int streamID;

  filetype = getFiletype(filename);

  if ( filetype < 0 ) return (filetype);

  streamID = streamOpen(filename, "r", filetype);

  return (streamID);
}


int streamOpenAppend(const char *filename)
{
  int filetype;
  int streamID;

  filetype = getFiletype(filename);

  if ( filetype < 0 ) return (filetype);

  streamID = streamOpenAtest(filename, "a", filetype);

  return (streamID);
}


/*
@Function  streamOpenWrite
@Title     Open a file for writing

@Prototype int streamOpenWrite(const char *filename, int filetype)
@Parameter
    @Item  filename  The file name of the dataset to be read
    @Item  filetype  The type of the file format, one of the set of predefined CDI file format types.
                     The valid CDI file format types are {\tt FILETYPE_GRB}, {\tt FILETYPE_NC},
                     {\tt FILETYPE_NC2}, {\tt FILETYPE_SRV}, and {\tt FILETYPE_EXT}.

@Description
The function {\tt streamOpenWrite} create a new file for writing.

@Result
Upon successful completion {\tt streamOpenWrite} return an identifier to the
open stream. Otherwise, a negative number with the error status is returned.

@Errors
@List
   @Item  CDI_ESYSTEM     Operating system error
   @Item  CDI_EINVAL      Invalid argument
   @Item  CDI_EUFILETYPE  Unsupported file type
   @Item  CDI_ELIBNAVAIL  Library not available
@EndList

@Example
Here is an example using {\tt streamOpenWrite} to create a new netCDF file 
named {\tt foo.nc} for writing:

@Source
   ...
int streamID;
   ...
streamID = streamOpenWrite("foo.nc", FILETYPE_NC);
if ( streamID < 0 ) handle_error(streamID);
   ...
@EndSource
@EndFunction
*/
int streamOpenWrite(const char *filename, int filetype)
{
  return (streamOpen(filename, "w", filetype));
}


/*
@Function  streamClose
@Title     Close an Open file

@Prototype  void streamClose(int streamID)
@Parameter
    @Item  streamID  Identifier, from a previous call to {\tt streamOpenRead}
                     or {\tt streamOpenWrite}

@Description
The function {\tt streamClose} closes an open file.

@EndFunction
*/
void streamClose(int streamID)
{
  static char func[] = "streamClose";
  int filetype;
  int fileID;
  int index;
  int vlistID;

  streamCheckID(func, streamID);

  if ( CDI_Debug )
    Message(func, "fileID = %d filename = %s", streamID, streams[streamID].filename);

  fileID   = streams[streamID].fileID;
  filetype = streams[streamID].filetype;
  vlistID  = streamInqVlist(streamID);

  if ( fileID == CDI_UNDEFID )
    Warning(func, "File %s not open!", streams[streamID].filename);
  else
    switch (filetype)
      {
#if  defined  (HAVE_LIBGRIB)
      case FILETYPE_GRB:
	{
	  gribClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBSERVICE)
      case FILETYPE_SRV:
	{
	  srvClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBEXTRA)
      case FILETYPE_EXT:
	{
	  extClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBNETCDF)
      case FILETYPE_NC:
      case FILETYPE_NC2:
	{
	  cdfClose(fileID);
	  break;
	}
#endif
#if  defined  (HAVE_LIBHDF5)
      case FILETYPE_H5:
	{
	  hdfClose(fileID);
	  break;
	}
#endif
      default:
	{
	  Error(func, "%s library not available!", strfiletype(filetype));
	  break;
	}
      }

  if ( streams[streamID].record ) free(streams[streamID].record);

  streams[streamID].filetype = 0;
  if ( streams[streamID].filename ) free(streams[streamID].filename);

  for ( index = 0; index < streams[streamID].nvars; index++ )
    {
      if ( streams[streamID].vars[index].level )
	free(streams[streamID].vars[index].level);
    }
  free(streams[streamID].vars);

  streamsInitEntry(streamID);

  if ( vlistID != -1 )
    {
      vlistFree(vlistID);
    }
}


/*
@Function  streamDefTimestep
@Title     Define timestep

@Prototype int streamDefTimestep(int streamID, int tsID)
@Parameter
    @Item  streamID  Stream identifier
    @Item  tsID      Timestep identifier

@Description
The function {\tt streamDefTimestep} defines the timestep of a stream.

@Result
{\tt streamDefTimestep} return the number of records of the timestep.

@EndFunction
*/
int streamDefTimestep(int streamID, int tsID)
{
  static char func[] = "streamDefTimestep";
  int newtsID;
  int taxisID;
  int vlistID;

  if ( CDI_Debug )
    Message(func, "streamID = %d  tsID = %d", streamID, tsID);

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);
  taxisID = vlistInqTaxis(vlistID);
  if ( taxisID == CDI_UNDEFID )
    {
      Warning(func, "taxisID undefined for fileID = %d! Using absolute time axis.", streamID);
      taxisID = taxisNew(TAXIS_ABSOLUTE);
      vlistDefTaxis(vlistID, taxisID);
    }

  newtsID = tstepsNewEntry(streamID);

  if ( tsID != newtsID )
    Error(func, "Internal problem: tsID = %d newtsID = %d", tsID, newtsID);

  streams[streamID].curTsID = tsID;

  ptaxisCopy(&streams[streamID].tsteps[tsID].taxis, taxisPtr(taxisID));

  streams[streamID].ntsteps = tsID + 1;

  if ( (streams[streamID].filetype == FILETYPE_NC || streams[streamID].filetype == FILETYPE_NC2)
       && vlistHasTime(vlistID) )
    cdfDefTimestep(streamID, tsID);

  if ( streams[streamID].filetype == FILETYPE_H5 && vlistHasTime(vlistID) )
    hdfDefTimestep(streamID, tsID);

  cdiCreateRecords(streamID, tsID);

  return (streams[streamID].ntsteps);
}


/*
@Function  streamInqTimestep
@Title     Get timestep

@Prototype int streamInqTimestep(int streamID, int tsID)
@Parameter
    @Item  streamID  Stream identifier
    @Item  tsID      Timestep identifier

@Description
The function {\tt streamInqTimestep} gets the timestep of a stream.

@Result
{\tt streamInqTimestep} return the number of records of the timestep.

@EndFunction
*/
int streamInqTimestep(int streamID, int tsID)
{
  static char func[] = "streamInqTimestep";
  int filetype;
  int nrecs = 0;
  int taxisID;
  int vlistID;

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);

  if ( tsID < streams[streamID].rtsteps )
    {
      streams[streamID].curTsID = tsID;
      nrecs = streams[streamID].tsteps[tsID].nrecs;
      streams[streamID].tsteps[tsID].curRecID = CDI_UNDEFID;
      taxisID = vlistInqTaxis(vlistID);
      if ( taxisID == -1 )
	Error(func, "Timestep undefined for fileID = %d", streamID);
      ptaxisCopy(taxisPtr(taxisID), &streams[streamID].tsteps[tsID].taxis);

      return (nrecs);
    }

  if ( tsID >= streams[streamID].ntsteps && streams[streamID].ntsteps != CDI_UNDEFID )
    {
      return (0);
    }

  filetype = streams[streamID].filetype;

  if ( CDI_Debug )
    Message(func, "streamID = %d  tsID = %d  filetype = %d", streamID, tsID, filetype);

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        nrecs = grbInqTimestep(streamID, tsID);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        nrecs = srvInqTimestep(streamID, tsID);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        nrecs = extInqTimestep(streamID, tsID);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
        nrecs = cdfInqTimestep(streamID, tsID);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }

  taxisID = vlistInqTaxis(vlistID);
  if ( taxisID == -1 )
    Error(func, "Timestep undefined for fileID = %d", streamID);

  ptaxisCopy(taxisPtr(taxisID), &streams[streamID].tsteps[tsID].taxis);

  return (nrecs);
}


/*
@Function  streamReadVar
@Title     Read a variable

@Prototype void streamReadVar(int streamID, int varID, double *data, int *nmiss)
@Parameter
    @Item  streamID  Stream identifier
    @Item  varID     Variable identifier
    @Item  data      Data
    @Item  nmiss     Number of missing values

@EndFunction
*/
void streamReadVar(int streamID, int varID, double *data, int *nmiss)
{
  static char func[] = "streamReadVar";
  int filetype;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  *nmiss = 0;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        grbReadVarDP(streamID, varID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        srvReadVarDP(streamID, varID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        extReadVarDP(streamID, varID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
        cdfReadVarDP(streamID, varID, data, nmiss);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
}


/*
@Function  streamWriteVar
@Title     Write a variable

@Prototype void streamWriteVar(int streamID, int varID, double *data, int nmiss)
@Parameter
    @Item  streamID  Stream identifier
    @Item  varID     Variable identifier
    @Item  data      Data
    @Item  nmiss     Number of missing values

@EndFunction
*/
void streamWriteVar(int streamID, int varID, double *data, int nmiss)
{
  static char func[] = "streamWriteVar";
  int filetype;

  if ( CDI_Debug )
    Message(func, "streamID = %d varID = %d", streamID, varID);

  streamCheckID(func, streamID);

  streamDefineTaxis(streamID);

  filetype = streams[streamID].filetype;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        grbWriteVarDP(streamID, varID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        srvWriteVarDP(streamID, varID, data);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        extWriteVarDP(streamID, varID, data);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
	if ( streams[streamID].accessmode == 0 ) cdfEndDef(streamID);
        cdfWriteVarDP(streamID, varID, data, nmiss);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
}


/*
@Function  streamReadVarSlice
@Title     Read a horizontal slice of a variable

@Prototype void streamReadVarSlice(int streamID, int varID, int levelID, double *data, int *nmiss)
@Parameter
    @Item  streamID  Stream identifier
    @Item  varID     Variable identifier
    @Item  levelID   Level identifier
    @Item  data      Data
    @Item  nmiss     Number of missing values

@EndFunction
*/
void streamReadVarSlice(int streamID, int varID, int levelID, double *data, int *nmiss)
{
  static char func[] = "streamReadVarSlice";
  int filetype;
  int ierr = 0;

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  *nmiss = 0;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        grbReadVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        srvReadVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        extReadVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
        ierr = cdfReadVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
}


/*
@Function  streamWriteVarSlice
@Title     Write a horizontal slice of a variable

@Prototype void streamWriteVarSlice(int streamID, int varID, int levelID, double *data, int nmiss)
@Parameter
    @Item  streamID  Stream identifier
    @Item  varID     Variable identifier
    @Item  levelID   Level identifier
    @Item  data      Data
    @Item  nmiss     Number of missing values

@EndFunction
*/
void streamWriteVarSlice(int streamID, int varID, int levelID, double *data, int nmiss)
{
  static char func[] = "streamWriteVarSlice";
  int filetype;
  int ierr = 0;

  if ( CDI_Debug )
    Message(func, "streamID = %d varID = %d", streamID, varID);

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        grbWriteVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        srvWriteVarSliceDP(streamID, varID, levelID, data);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        extWriteVarSliceDP(streamID, varID, levelID, data);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
	if ( streams[streamID].accessmode == 0 ) cdfEndDef(streamID);
        ierr = cdfWriteVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
	ierr = hdfWriteVarSliceDP(streamID, varID, levelID, data, nmiss);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
}

void streamWriteContents(int streamID, char *cname)
{
  static char func[] = "streamWriteContents";
  FILE *cnp;
  int tsID, recID, varID, levelID;
  long recsize;
  int nrecs, nvars;
  int code, gridID, zaxisID, timeID, datatype;
  int ngrids, nzaxis;
  int filetype, gridtype;
  int xsize, ysize;
  int date, time;
  int i;
  off_t recpos, position;
  int vlistID;

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);

  cnp = fopen(cname, "w");

  if ( cnp == NULL ) SysError(func, cname);

  fprintf(cnp, "#CDI library version %s\n", cdiLibraryVersion());
  fprintf(cnp, "#\n");

  fprintf(cnp, "filename: %s\n", streams[streamID].filename);
  filetype = streams[streamID].filetype;
  fprintf(cnp, "filetype: %s\n", strfiletype(filetype));

  fprintf(cnp, "#\n");
  fprintf(cnp, "#grids:\n");

  ngrids = vlistNgrids(vlistID);
  for ( i = 0; i < ngrids; i++ )
    {
      gridID   = vlistGrid(vlistID, i);
      gridtype = gridInqType(gridID);
      xsize    = gridInqXsize(gridID);
      ysize    = gridInqYsize(gridID);
      fprintf(cnp, "%4d:%4d:%4d:%4d\n", i+1, gridtype, xsize, ysize);
    }
  nzaxis = vlistNzaxis(vlistID);

  fprintf(cnp, "#\n");

  fprintf(cnp, "varID:code:gridID:zaxisID:timeID:datatype\n");

  nvars = vlistNvars(vlistID);
  for ( varID = 0; varID < nvars; varID++ )
    {
      code     = vlistInqVarCode(vlistID, varID);
      gridID   = vlistInqVarGrid(vlistID, varID);
      zaxisID  = vlistInqVarZaxis(vlistID, varID);
      timeID   = vlistInqVarTime(vlistID, varID);
      datatype = vlistInqVarDatatype(vlistID, varID);
      fprintf(cnp, "%4d:%4d:%4d:%4d:%4d:%4d:\n",
	      varID+1, code, gridID, zaxisID, timeID, datatype);
    }

  fprintf(cnp, "#\n");

  fprintf(cnp, "tsID:nrecs:date:time\n");
  
  tsID = 0;
  while (1)
    {
      nrecs = streams[streamID].tsteps[tsID].nallrecs;
      date  = streams[streamID].tsteps[tsID].taxis.vdate;
      time  = streams[streamID].tsteps[tsID].taxis.vtime;
      position = streams[streamID].tsteps[tsID].position;

      fprintf(cnp, "%4d:%4d:%4d:%4d:%ld\n",
	      tsID, nrecs, date, time, (long) position);

      if ( streams[streamID].tsteps[tsID].next )
	tsID++;
      else
	break;
    }

  fprintf(cnp, "#\n");

  fprintf(cnp, "tsID:recID:varID:levID:size:pos\n");

  tsID = 0;
  while (1)
    {
      nrecs = streams[streamID].tsteps[tsID].nallrecs;
      for ( recID = 0; recID < nrecs; recID++ )
	{
	  varID   = streams[streamID].tsteps[tsID].records[recID].varID;
	  levelID = streams[streamID].tsteps[tsID].records[recID].levelID;
	  recpos  = streams[streamID].tsteps[tsID].records[recID].position;
	  recsize = streams[streamID].tsteps[tsID].records[recID].size;
	  fprintf(cnp, "%4d:%4d:%4d:%4d:%4ld:%ld\n",
		  tsID, recID, varID, levelID, recsize, (long) recpos);
	}

      if ( streams[streamID].tsteps[tsID].next )
	tsID++;
      else
	break;
    }

  fclose(cnp);
}

void cdiDefTableID(int tableID)
{
  int modelID, instID;

  cdiDefaultTableID = tableID;

  modelID = tableInqModel(tableID);
  cdiDefaultModelID = modelID;

  instID = modelInqInstitut(modelID);
  cdiDefaultInstID = instID;
}

void cdiPrintVersion(void)
{
  fprintf(stderr, "    CDI library version : %s\n", cdiLibraryVersion());
#if  defined  (HAVE_LIBGRIB)
  fprintf(stderr, "   GRIB library version : %s\n", gribLibraryVersion());
#endif
#if  defined  (HAVE_LIBNETCDF)
  fprintf(stderr, " netCDF library version : %s\n", cdfLibraryVersion());
#endif
#if  defined  (HAVE_LIBHDF5)
  fprintf(stderr, "   HDF5 library version : %s\n", hdfLibraryVersion());
#endif
#if  defined  (HAVE_LIBSERVICE)
  fprintf(stderr, "SERVICE library version : %s\n", srvLibraryVersion());
#endif
#if  defined  (HAVE_LIBEXTRA)
  fprintf(stderr, "  EXTRA library version : %s\n", extLibraryVersion());
#endif
  fprintf(stderr, "   FILE library version : %s\n", fileLibraryVersion());
}

int streamNtsteps(int streamID)
{
  static char func[] = "streamNtsteps";

  streamCheckID(func, streamID);

  return (streams[streamID].ntsteps);
}


/*
@Function  streamDefVlist
@Title     Define the variable list

@Prototype streamDefVlist(int streamID, int vlistID)
@Parameter
    @Item  streamID  Stream identifier
    @Item  vlistID   Variable list identifier

@Description
The function {\tt streamDefVlist} defines the variable list of a stream.

@EndFunction
*/
void streamDefVlist(int streamID, int vlistID)
{
  static char func[] = "streamDefVlist";
  int nvars, varID;
  int gridID, zaxisID;

  streamCheckID(func, streamID);

  if ( streams[streamID].vlistID == CDI_UNDEFID )
    {
      streams[streamID].vlistID = vlistDuplicate(vlistID);

      nvars = vlistNvars(vlistID);
      for ( varID = 0; varID < nvars; varID++ )
	{
	  gridID  = vlistInqVarGrid(vlistID, varID);
	  zaxisID = vlistInqVarZaxis(vlistID, varID);
	  streamNewVar(streamID, gridID, zaxisID);
	}

      if ( streams[streamID].filemode == 'w' )
	{
	  if ( streams[streamID].filetype == FILETYPE_NC || streams[streamID].filetype == FILETYPE_NC2 )
	    cdfDefVars(streamID);
	}
    }
  else
    {
      Warning(func, "vlist allready defined for %s!", streams[streamID].filename);
    }
}


/*
@Function  streamInqVlist
@Title     Get the variable list

@Prototype int streamInqVlist(int streamID)
@Parameter
    @Item  streamID  Stream identifier

@Description
The function {\tt streamInqVlist} gets the variable list of a stream.

@Result
{\tt streamInqVlist} return an identifier to the variable list.

@EndFunction
*/
int streamInqVlist(int streamID)
{
  static char func[] = "streamInqVlist";
  
  streamCheckID(func, streamID);

  return (streams[streamID].vlistID);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





void streamDefHistory(int streamID, int length, const char *history)
{
  static char func[] = "streamDefHistory";

  if ( streams[streamID].filetype == FILETYPE_NC || streams[streamID].filetype == FILETYPE_NC2 )
    {
      char *histstring;
      size_t len;
      if ( history )
	{
	  len = strlen(history);
	  if ( len )
	    {
	      histstring = strdup(history);
	      cdfDefHistory(streamID, length, histstring);
	      free(histstring);
	    }
	}
    }
}

int streamInqHistorySize(int streamID)
{
  int size = 0;

  if ( streams[streamID].filetype == FILETYPE_NC || streams[streamID].filetype == FILETYPE_NC2 )
    {
      size = cdfInqHistorySize(streamID);
    }

  return (size);
}

void streamInqHistoryString(int streamID, char *history)
{

  if ( streams[streamID].filetype == FILETYPE_NC || streams[streamID].filetype == FILETYPE_NC2 )
    {
      cdfInqHistoryString(streamID, history);
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID

typedef struct {
  int code;
  int table;
  int level1;
  int level2;
  int ltype;
} COMPVAR; 

int gribGetGridType(int *isec2)
{
  /*  static char func[] = "gribGetGridType"; */
  int gridtype = 0;

  switch (ISEC2_GridType)
    {
    case   0:
    case  10:
      {
	gridtype = GRID_LONLAT;
	break;
      }
    case   4:
      {
	if ( ISEC2_Reduced )
	  gridtype = GRID_GAUSSIAN_REDUCED;
	else
	  gridtype = GRID_GAUSSIAN;
	break;
      }
    case  50:
      {
	gridtype = GRID_SPECTRAL;
	break;
      }
    case 192:
      {
	gridtype = GRID_TRIANGULAR;
	break;
      }
    default:
      {
	gridtype = GRID_GENERIC;
	break;
      }
    }

  return (gridtype);
}

int gribGetIsRotated(int *isec2)
{
  /*  static char func[] = "gribGetIsRotated"; */
  int isRotated = 0;

  if ( ISEC2_GridType == 10 )
    {
      isRotated = 1;
    }

  return (isRotated);
}

int grbInqRecord(int streamID, int *varID, int *levelID)
{
  static char func[] = "grbInqRecord";
  int ierr = 0;
  int fileID;
  void *gribbuffer;
  int iret = 0, iword = 0;
  int isec4size = 0;
  int isec0[2], isec1[4096], isec2[4096], isec3[2], isec4[512];
  double fsec2[512], fsec3[2], *fsec4 = NULL;
  int gridID = -1, zaxisID = -1;
  int xsize, ysize;
  int gridtype;
  off_t recpos;
  int gribsize;
  size_t readsize;
  int vlistID;

  streamCheckID(func, streamID);

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);

  *varID   = -1;
  *levelID = -1;

  gribsize = gribGetSize(fileID);
  if ( gribsize == 0 ) return (0);

  recpos  = fileGetPos(fileID);

  gribbuffer = streams[streamID].record->buffer;
  gribbuffer = realloc(gribbuffer, gribsize);

  streams[streamID].record->buffer = gribbuffer;
  streams[streamID].record->buffersize = gribsize;

  readsize = gribsize;
  ierr = gribRead(fileID, (unsigned char *) gribbuffer, &readsize);
  if ( ierr ) return (-1);

  gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, fsec4,
	   isec4size, (int *) gribbuffer, gribsize, &iword, "J", &iret);

  *varID = vlistInqVarID(vlistID, ISEC1_Parameter);

  if ( *varID == UNDEFID )
    Error(func, "code %d undefined", ISEC1_Parameter);

  gridID  = vlistInqVarGrid(vlistID, *varID);
  zaxisID = vlistInqVarZaxis(vlistID, *varID);

  gridtype = gribGetGridType(isec2);

  switch (gridtype)
    {
    case GRID_LONLAT:
      {
	xsize = ISEC2_NumLon;
	ysize = ISEC2_NumLat;
	if ( gridInqType(gridID) == GRID_TRAJECTORY )
	  {
	    double xfirst, yfirst;
	    xfirst = ISEC2_FirstLon * 0.001;
	    yfirst = ISEC2_FirstLat * 0.001;
	    gridDefXvals(gridID, &xfirst);
	    gridDefYvals(gridID, &yfirst);
	  }
	break;
      }
    case GRID_GAUSSIAN:
      {
	if ( ISEC4_NumValues != ISEC2_NumLon*ISEC2_NumLat )
	  Error(func, "wrong datasize! isec4len = %d isec2len = %d",
		ISEC4_NumValues, ISEC2_NumLon*ISEC2_NumLat);
	xsize = ISEC2_NumLon;
	ysize = ISEC2_NumLat;
	break;
      }
    case GRID_SPECTRAL:
      {
	xsize = ISEC4_NumValues;
	ysize = 0;
	break;
      }
    case GRID_TRIANGULAR:
      {
	xsize = ISEC4_NumValues;
	ysize = 0;
	break;
      }
    default:
      {
	Error(func, "%s grid unsupported", gridNamePtr(gridtype));
	break;
      }
    }

  streams[streamID].record->code     = ISEC1_Parameter;
  streams[streamID].record->level    = ISEC1_Level1;
  gribDateTime(isec1, &streams[streamID].record->date, &streams[streamID].record->time);
  streams[streamID].record->gridID   = gridID;
  streams[streamID].record->zaxisID  = zaxisID;
  streams[streamID].record->nrec++;

  *levelID = zaxisInqLevelID(zaxisID, (double) ISEC1_Level1);

  ierr = 1;

  return (ierr);
}

int grbDefRecord(int streamID)
{
  static char func[] = "grbDefRecord";
  int fileID;
  int gridID;
  int ierr = 0;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);
  gridID = streams[streamID].record->gridID;

  return (ierr);
}

int grbDecodeDataDP(unsigned char *gribbuffer, int gribsize, double *data, int gridsize,
		    int unreduced, int *nmiss)
{
  int ierr = 0;
  int iret = 0, iword = 0;
  int isec0[2], isec1[4096], isec2[4096], isec3[2], isec4[512];
  double fsec2[512], fsec3[2];
  char hoper[2];

  if ( unreduced ) strcpy(hoper, "R");
  else             strcpy(hoper, "D");

  FSEC3_MissVal = cdiDefaultMissval;

  gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, data,
	   gridsize, (int *) gribbuffer, gribsize, &iword, hoper, &iret);

  if ( ISEC1_Sec2Or3Flag & 64 )
    *nmiss = ISEC4_NumValues - ISEC4_NumNonMissValues;
  else
    *nmiss = 0;

  return (ierr);
}


int grbReadRecord(int streamID, double *data, int *nmiss)
{
  static char func[] = "grbReadRecord";
  int ierr = 0;
  unsigned char *gribbuffer;
  int fileID;
  int recID, vrecID, tsID, gridID, varID;
  long recsize;
  off_t recpos;
  int gridsize;
  int vlistID;

  streamCheckID(func, streamID);

  gribbuffer = (unsigned char *) streams[streamID].record->buffer;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);
  tsID    = streams[streamID].curTsID;
  vrecID  = streams[streamID].tsteps[tsID].curRecID;
  recID   = streams[streamID].tsteps[tsID].recIDs[vrecID];
  recpos  = streams[streamID].tsteps[tsID].records[recID].position;
  recsize = streams[streamID].tsteps[tsID].records[recID].size;
  varID   = streams[streamID].tsteps[tsID].records[recID].varID;

  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);

  fileSetPos(fileID, recpos, SEEK_SET);

  fileRead(fileID, gribbuffer, recsize);

  grbDecodeDataDP(gribbuffer, recsize, data, gridsize, streams[streamID].unreduced, nmiss);

  return (ierr);
}


int gribGetZaxisType(int grbleveltype)
{
  int leveltype = 0;

  switch (grbleveltype)
    {
    case 1:
      {
	leveltype = ZAXIS_SURFACE;
	break;
      }
    case 99:
    case 100:
      {
	leveltype = ZAXIS_PRESSURE;
	break;
      }
    case 105:
      {
	leveltype = ZAXIS_HEIGHT;
	break;
      }
    case 109:
    case 110:
      {
	leveltype = ZAXIS_HYBRID;
	break;
      }
    case 111:
    case 112:
      {
	leveltype = ZAXIS_DEPTH_BELOW_LAND;
	break;
      }
    case 160:
      {
	leveltype = ZAXIS_DEPTH_BELOW_SEA;
	break;
      }
    default:
      {
	leveltype = ZAXIS_GENERIC;
	break;
      }
    }

  return (leveltype);
}

int gribGetZaxisHasBounds(int grbleveltype)
{
  int lbounds = 0;

  switch (grbleveltype)
    {
    case LTYPE_HYBRID_LAYER:
    case LTYPE_LANDDEPTH_LAYER:
      {
	lbounds = 1;
	break;
      }
    }

  return (lbounds);
}


int gribTimeUnit(int *isec1)
{
  static char func[] = "gribTimeUnit";
  int timeunit = -1;
  static int lprint = TRUE;

  switch ( ISEC1_TimeUnit )
    {
    case ISEC1_TABLE4_MINUTE:  timeunit = TUNIT_MINUTE; break;
    case ISEC1_TABLE4_HOUR:    timeunit = TUNIT_HOUR;   break;
    case ISEC1_TABLE4_DAY:     timeunit = TUNIT_DAY;    break;
    default:
      if ( lprint )
	{
	  Message(func, "Time unit %d unsupported", ISEC1_TimeUnit);
	  lprint = FALSE;
	}
    }

  return (timeunit);
}


int grbScanTimestep(int streamID)
{
  static char func[] = "grbScanTimestep";
  int *isec0, *isec1, *isec2, *isec3, *isec4;
  double fsec2[512], fsec3[2], *fsec4 = NULL;
  long recsize = 0;
  off_t recpos = 0;
  unsigned char *gribbuffer;
  long buffersize = 0;
  int iret = 0, ipunp = 0, iword = 0;
  int ierr;
  int fileID;
  int rcode = 0, level1 = 0, level2 = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  int gridtype;
  int tsID;
  int recID;
  int numavg;
  int warn_numavg = TRUE;
  size_t readsize;
  int taxisID = -1;
  TAXIS *taxis;
  int vlistID;
  int rindex, nrecs = 0;
  COMPVAR compVar, compVar0;

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);

  if ( CDI_Debug )
    {
      Message(func, "streamID = %d", streamID);
      Message(func, "cts = %d", streams[streamID].curTsID);
      Message(func, "rts = %d", streams[streamID].rtsteps);
      Message(func, "nts = %d", streams[streamID].ntsteps);
    }

  isec0 = streams[streamID].record->sec0;
  isec1 = streams[streamID].record->sec1;
  isec2 = streams[streamID].record->sec2;
  isec3 = streams[streamID].record->sec3;
  isec4 = streams[streamID].record->sec4;

  tsID  = streams[streamID].rtsteps;
  taxis = &streams[streamID].tsteps[tsID].taxis;

  if ( streams[streamID].tsteps[tsID].recordSize == 0 )
    {
      gribbuffer = (unsigned char *) streams[streamID].record->buffer;
      buffersize = streams[streamID].record->buffersize;

      cdiCreateRecords(streamID, tsID);

      nrecs = streams[streamID].tsteps[1].nrecs;

      streams[streamID].tsteps[tsID].nrecs = nrecs;
      streams[streamID].tsteps[tsID].recIDs = (int *) malloc(nrecs*sizeof(int));
      for ( recID = 0; recID < nrecs; recID++ )
	streams[streamID].tsteps[tsID].recIDs[recID] = streams[streamID].tsteps[1].recIDs[recID];

      fileID = streamInqFileID(streamID);

      fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);

      for ( rindex = 0; rindex <= nrecs; rindex++ )
	{
	  recsize = gribGetSize(fileID);
	  recpos  = fileGetPos(fileID);
	  if ( recsize == 0 )
	    {
	      streams[streamID].ntsteps = streams[streamID].rtsteps + 1;
	      break;
	    }
	  if ( recsize > buffersize )
	    {
	      buffersize = recsize;
	      gribbuffer = (unsigned char *) realloc(gribbuffer, buffersize);
	    }

	  readsize = recsize;
	  ierr = gribRead(fileID, gribbuffer, &readsize);
	  if ( ierr )
	    {
	      Error(func, "Inconsistent timestep %d (GRIB record %d/%d)!\n", tsID+1, rindex+1,
		    streams[streamID].tsteps[tsID].recordSize);
	      break;
	    }
	  gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, fsec4,
		   ipunp, (int *) gribbuffer, recsize, &iword, "J", &iret);
	  rcode    = ISEC1_Parameter;
	  gridtype = gribGetGridType(isec2);
	  level1   = ISEC1_Level1;
	  level2   = ISEC1_Level2;
	  if ( ISEC1_LevelType == 100 ) level1 *= 100;

	  gribDateTime(isec1, &vdate, &vtime);

	  numavg = ISEC1_AvgNum;

	  if ( rindex == nrecs ) break;

	  if ( rindex == 0 )
	    {
	      datetime0.date = vdate;
	      datetime0.time = vtime;
	      taxisID = vlistInqTaxis(vlistID);
	      if ( taxisInqType(taxisID) == TAXIS_RELATIVE )
		{
		  taxis->type  = TAXIS_RELATIVE;
		  taxis->rdate = gribRefDate(isec1);
		  taxis->rtime = gribRefTime(isec1);
		  taxis->unit  = gribTimeUnit(isec1);
		}
	      else
		{
		  taxis->type  = TAXIS_ABSOLUTE;
		}
	      taxis->vdate = vdate;
	      taxis->vtime = vtime;
	    }
	  else
	    {
	      datetime.date = vdate;
	      datetime.time = vtime;
	    }

	  if ( ISEC1_AvgNum )
	    {
	      if (  taxis->numavg && warn_numavg &&
		   (taxis->numavg != ISEC1_AvgNum) )
		{
	      /*
		  Message(func, "Change numavg from %d to %d not allowed!",
			  streams[streamID].tsteps[tsID].taxis.numavg, ISEC1_AvgNum);
	      */
		  warn_numavg = FALSE;
		}
	      else
		{
		  taxis->numavg = ISEC1_AvgNum;
		}
	    }
	  
	  compVar.code   = rcode;
          compVar.table  = ISEC1_CodeTable;
          compVar.level1 = level1;
          compVar.level2 = level2;
          compVar.ltype  = ISEC1_LevelType;
	  for ( recID = 0; recID < nrecs; recID++ )
	    {
	      compVar0.code   = streams[streamID].tsteps[tsID].records[recID].code;
	      compVar0.table  = streams[streamID].tsteps[tsID].records[recID].table;
	      compVar0.level1 = streams[streamID].tsteps[tsID].records[recID].ilevel;
	      compVar0.level2 = streams[streamID].tsteps[tsID].records[recID].ilevel2;
	      compVar0.ltype  = streams[streamID].tsteps[tsID].records[recID].ltype;
	      if ( memcmp(&compVar0, &compVar, sizeof(COMPVAR)) == 0 )
		{
		  streams[streamID].tsteps[tsID].records[recID].used = TRUE;
		  streams[streamID].tsteps[tsID].recIDs[rindex] = recID;
		  break;
		}
	    }
	  if ( recID == nrecs )
	    {
	      Warning(func, "code %d level %d not found at timestep %d", rcode, level1, tsID+1);
	      return (CDI_EUFSTRUCT);
	    }

	  if ( CDI_Debug )
	    Message(func, "%4d %8d %4d %8d %8d %6d", rindex+1, (int)recpos, rcode, level1, vdate, vtime);

	  compVar0.code   = streams[streamID].tsteps[tsID].records[recID].code;
	  compVar0.table  = streams[streamID].tsteps[tsID].records[recID].table;
	  compVar0.level1 = streams[streamID].tsteps[tsID].records[recID].ilevel;
	  compVar0.level2 = streams[streamID].tsteps[tsID].records[recID].ilevel2;
	  compVar0.ltype  = streams[streamID].tsteps[tsID].records[recID].ltype;

	  if ( memcmp(&compVar0, &compVar, sizeof(COMPVAR)) != 0 )
	    {
	      Message(func, "tsID = %d recID = %d code = %3d new %3d  level = %3d new %3d",
		      tsID, recID,
		      streams[streamID].tsteps[tsID].records[recID].code, rcode,
		      streams[streamID].tsteps[tsID].records[recID].ilevel, level1);
	      Error(func, "Invalid, unsupported or inconsistent record structure");
	    }
	  
	  streams[streamID].tsteps[tsID].records[recID].position = recpos;
	  streams[streamID].tsteps[tsID].records[recID].size = recsize;

	  if ( CDI_Debug )
	    Message(func, "%4d %8d %4d %8d %8d %6d", rindex, (int)recpos, rcode, level1, vdate, vtime);
	}

      streams[streamID].rtsteps++;

      if ( streams[streamID].ntsteps != streams[streamID].rtsteps )
	{
	  tsID = tstepsNewEntry(streamID);
	  if ( tsID != streams[streamID].rtsteps )
	    Error(func, "Internal error. tsID = %d", tsID);

	  streams[streamID].tsteps[tsID-1].next   = 1;
	  streams[streamID].tsteps[tsID].position = recpos;
	}

      fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);
      streams[streamID].tsteps[tsID].position = recpos;

      streams[streamID].record->buffer     = gribbuffer;
      streams[streamID].record->buffersize = buffersize;
    }

  if ( nrecs > 0 && nrecs < streams[streamID].tsteps[tsID].nrecs )
    {
      Warning(func, "Incomplete timestep. Stop scanning at timestep %d.\n", tsID);
      streams[streamID].ntsteps = tsID;
    }

  return (streams[streamID].ntsteps);
}


int grbInqTimeSize(int streamID)
{
  static char func[] = "grbInqTimeSize";

  streamCheckID(func, streamID);

  while ( ! streams[streamID].ntsteps )
    grbScanTimestep(streamID);

  return (streams[streamID].ntsteps);
}


void grbAddRecord(int streamID, int code, int *isec1, int *isec2, double *fsec2,
		  int *isec4, long recsize, off_t position, int prec)
{
  static char func[] = "grbAddRecord";
  int gridtype;
  int leveltype;
  int gridID = UNDEFID, varID;
  int levelID = 0;
  int tsID, recID;
  int level1, level2;
  int numavg;
  int lbounds = 0;
  RECORD *record;
  GRID grid;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  tsID    = streams[streamID].curTsID;
  recID   = recordNewEntry(streamID, tsID);
  record  = &streams[streamID].tsteps[tsID].records[recID];

  numavg  = ISEC1_AvgNum;

  level1  = ISEC1_Level1;
  if ( ISEC1_LevelType == 100 ) level1 *= 100;
  level2  = ISEC1_Level2;

  (*record).size     = recsize;
  (*record).position = position;
  (*record).code     = code;
  (*record).table    = ISEC1_CodeTable;
  (*record).ilevel   = level1;
  (*record).ilevel2  = level2;
  (*record).ltype    = ISEC1_LevelType;

  gridtype = gribGetGridType(isec2);

  if ( streams[streamID].unreduced && gridtype == GRID_GAUSSIAN_REDUCED )
    {
      gridtype = GRID_GAUSSIAN;
      ISEC2_NumLon = 2*ISEC2_NumLat;
      ISEC4_NumValues = ISEC2_NumLon*ISEC2_NumLat;
    }

  memset(&grid, 0, sizeof(GRID));
  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
      {
	if ( ISEC4_NumValues != ISEC2_NumLon*ISEC2_NumLat )
	  Error(func, "wrong datasize! isec4len = %d isec2len = %d",
		ISEC4_NumValues, ISEC2_NumLon*ISEC2_NumLat);
	grid.size  = ISEC4_NumValues;
	grid.xsize = ISEC2_NumLon;
	grid.ysize = ISEC2_NumLat;
	grid.xinc  = 0;
	grid.yinc  = 0;
	grid.xdef  = 0;
	/* if ( ISEC2_FirstLon != 0 || ISEC2_LastLon != 0 ) */
	  {
	    if ( grid.xsize > 1 )
	      {
		if ( ISEC2_ResFlag && ISEC2_LonIncr > 0 )
		  grid.xinc = ISEC2_LonIncr * 0.001;
		else
		  grid.xinc = (ISEC2_LastLon - ISEC2_FirstLon) * 0.001 / (grid.xsize - 1);
	      }
	    grid.xfirst = ISEC2_FirstLon * 0.001;
	    grid.xlast  = ISEC2_LastLon  * 0.001;
	    grid.xdef   = 2;	    
	  }
	grid.ydef  = 0;
	/* if ( ISEC2_FirstLat != 0 || ISEC2_LastLat != 0 ) */
	  {
	    if ( grid.ysize > 1 )
	      {
		if ( ISEC2_ResFlag && ISEC2_LatIncr > 0 )
		  grid.yinc = ISEC2_LatIncr * 0.001;
		else
		  grid.yinc = (ISEC2_LastLat - ISEC2_FirstLat) * 0.001 / (grid.ysize - 1);
	      }
	    grid.yfirst = ISEC2_FirstLat * 0.001;
	    grid.ylast  = ISEC2_LastLat  * 0.001;
	    grid.ydef   = 2;	    
	  }
	break;
      }
    case GRID_GAUSSIAN_REDUCED:
      {
	grid.size   = ISEC4_NumValues;
        grid.rowlon = ISEC2_RowLonPtr;
	grid.ysize  = ISEC2_NumLat;
	grid.xinc  = 0;
	grid.yinc  = 0;
	grid.xdef  = 0;
	/* if ( ISEC2_FirstLon != 0 || ISEC2_LastLon != 0 ) */
	  {
	    if ( grid.xsize > 1 )
	      {
		if ( ISEC2_ResFlag && ISEC2_LonIncr > 0 )
		  grid.xinc = ISEC2_LonIncr * 0.001;
		else
		  grid.xinc = (ISEC2_LastLon - ISEC2_FirstLon) * 0.001 / (grid.xsize - 1);
	      }
	    grid.xfirst = ISEC2_FirstLon * 0.001;
	    grid.xlast  = ISEC2_LastLon  * 0.001;
	    grid.xdef   = 2;	    
	  }
	grid.ydef  = 0;
	/* if ( ISEC2_FirstLat != 0 || ISEC2_LastLat != 0 ) */
	  {
	    if ( grid.ysize > 1 )
	      {
		if ( ISEC2_ResFlag && ISEC2_LatIncr > 0 )
		  grid.yinc = ISEC2_LatIncr * 0.001;
		else
		  grid.yinc = (ISEC2_LastLat - ISEC2_FirstLat) * 0.001 / (grid.ysize - 1);
	      }
	    grid.yfirst = ISEC2_FirstLat * 0.001;
	    grid.ylast  = ISEC2_LastLat  * 0.001;
	    grid.ydef   = 2;	    
	  }
	break;
      }
    case GRID_SPECTRAL:
      {
	grid.size  = ISEC4_NumValues;
	grid.trunc = ISEC2_PentaJ;
	break;
      }
    case GRID_TRIANGULAR:
      {
	grid.size  = ISEC4_NumValues;
	grid.nd    = ISEC2_TRI_ND;
	grid.ni    = ISEC2_TRI_NI;
	grid.ni2   = ISEC2_TRI_NI2;
	grid.ni3   = ISEC2_TRI_NI3;
	break;
      }
    case GRID_GENERIC:
      {
	grid.size  = ISEC4_NumValues;
	grid.xsize = 0;
	grid.ysize = 0;
	break;
      }
    default:
      {
	Error(func, "%s grid unsupported", gridNamePtr(gridtype));
	break;
      }
    }

  grid.isRotated = FALSE;
  if ( gribGetIsRotated(isec2) )
    {
      grid.isRotated = TRUE;
      grid.ypole     = - ISEC2_LatSP * 0.001;
      grid.xpole     =   ISEC2_LonSP * 0.001 - 180;
      grid.angle     = 0;
    }

  grid.xvals = NULL;
  grid.yvals = NULL;
  grid.type  = gridtype;

  gridID = varDefGrid(vlistID, grid, 0);

  leveltype = gribGetZaxisType(ISEC1_LevelType);

  if ( leveltype == ZAXIS_HYBRID )
    {
      int vctsize = ISEC2_NumVCP;
      double *vctptr = &fsec2[10];

      varDefVCT(vctsize, vctptr);
    }

  if ( prec > DATATYPE_PACK3 ) prec = DATATYPE_PACK3;
  if ( prec < DATATYPE_PACK  ) prec = DATATYPE_PACK;

  lbounds = gribGetZaxisHasBounds(ISEC1_LevelType);
  varAddRecord(recID, code, gridID, leveltype, lbounds, level1, level2,
	       prec, &varID, &levelID, numavg, ISEC1_CodeTable);

  (*record).varID   = varID;
  (*record).levelID = levelID;

  if ( varInqInst(varID) == UNDEFID )
    {
      int center, subcenter, instID;
      center    = ISEC1_CenterID;
      subcenter = ISEC1_SubCenterID;
      instID    = institutInq(center, subcenter, NULL, NULL);
      if ( instID == UNDEFID )
	instID = institutDef(center, subcenter, NULL, NULL);
      varDefInst(varID, instID);
    }

  if ( varInqModel(varID) == UNDEFID )
    {
      int modelID;
      modelID = modelInq(varInqInst(varID), ISEC1_ModelID, NULL);
      if ( modelID == UNDEFID )
	modelID = modelDef(varInqInst(varID), ISEC1_ModelID, NULL);
      varDefModel(varID, modelID);
    }

  if ( varInqTable(varID) == UNDEFID )
    {
      int tableID;
      tableID = tableInq(varInqModel(varID), ISEC1_CodeTable, NULL);
      if ( tableID == UNDEFID )
	tableID = tableDef(varInqModel(varID), ISEC1_CodeTable, NULL);
      varDefTable(varID, tableID);
    }

  streams[streamID].tsteps[tsID].nallrecs++;
  streams[streamID].nrecs++;

  if ( CDI_Debug )
    Message(func, "varID = %d  code = %d  leveltype = %d  gridID = %d  levelID = %d",
	    varID, code, leveltype, gridID, levelID);
}


void grbScanTimestep1(int streamID)
{
  static char func[] = "grbScanTimestep1";
  int *isec0, *isec1, *isec2, *isec3, *isec4;
  double fsec2[512], fsec3[2], *fsec4 = NULL;
  off_t recpos = 0;
  unsigned char *gribbuffer = NULL;
  long buffersize = 0;
  int iret = 0, ipunp = 0, iword = 0;
  int ierr;
  int fileID;
  int rcode = 0, level1 = 0, level2 = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  int tsID;
  int varID;
  size_t readsize;
  int nrecords, nrecs, recID;
  int prec;
  long recsize = 0;
  int warn_numavg = TRUE;
  int taxisID = -1;
  int rdate = 0, rtime = 0, tunit = 0, fcast = 0;
  TAXIS *taxis;
  int vlistID;
  COMPVAR compVar, compVar0;

  streamCheckID(func, streamID);

  streams[streamID].curTsID = 0;

  isec0 = streams[streamID].record->sec0;
  isec1 = streams[streamID].record->sec1;
  isec2 = streams[streamID].record->sec2;
  isec3 = streams[streamID].record->sec3;
  isec4 = streams[streamID].record->sec4;

  tsID  = tstepsNewEntry(streamID);
  taxis = &streams[streamID].tsteps[tsID].taxis;

  if ( tsID != 0 )
    Error(func, "Internal problem! tstepsNewEntry returns %d", tsID);

  fileID = streamInqFileID(streamID);

  nrecs = 0;
  while ( TRUE )
    {
      recsize = gribGetSize(fileID);
      recpos  = fileGetPos(fileID);

      if ( recsize == 0 )
	{
	  streams[streamID].ntsteps = 1;
	  break;
	}
      if ( recsize > buffersize )
	{
	  buffersize = recsize;
	  gribbuffer = (unsigned char *) realloc(gribbuffer, buffersize);
	}

      readsize = recsize;
      ierr = gribRead(fileID, gribbuffer, &readsize);
      if ( ierr ) break;

      gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, fsec4,
	       ipunp, (int *) gribbuffer, recsize, &iword, "J", &iret);

      rcode    = ISEC1_Parameter;
      level1   = ISEC1_Level1;
      level2   = ISEC1_Level2;
      if ( ISEC1_LevelType == 100 ) level1 *= 100;

      switch (ISEC4_NumBits)
	{
	case 8:
	  prec = DATATYPE_PACK1;
          break;
	case 16:
	  prec = DATATYPE_PACK2;
          break;
	case 24:
	  prec = DATATYPE_PACK3;
          break;
	default:
	  prec = DATATYPE_PACK;
          break;
	}

      gribDateTime(isec1, &vdate, &vtime);

      if ( nrecs == 0 )
	{
	  datetime0.date = vdate;
	  datetime0.time = vtime;
	  rdate = gribRefDate(isec1);
	  rtime = gribRefTime(isec1);
	  tunit = gribTimeUnit(isec1);
	  fcast = gribTimeIsFC(isec1);
	}
      else
	{
	  datetime.date  = vdate;
	  datetime.time  = vtime;
	  compVar.code   = rcode;
          compVar.table  = ISEC1_CodeTable;
          compVar.level1 = level1;
          compVar.level2 = level2;
          compVar.ltype  = ISEC1_LevelType;
	  for ( recID = 0; recID < nrecs; recID++ )
	    {
	      compVar0.code   = streams[streamID].tsteps[0].records[recID].code;
	      compVar0.table  = streams[streamID].tsteps[0].records[recID].table;
	      compVar0.level1 = streams[streamID].tsteps[0].records[recID].ilevel;
	      compVar0.level2 = streams[streamID].tsteps[0].records[recID].ilevel2;
	      compVar0.ltype  = streams[streamID].tsteps[0].records[recID].ltype;

	      if ( memcmp(&compVar0, &compVar, sizeof(COMPVAR)) == 0 ) break;
	    }
	  if ( recID < nrecs ) break;
	  if ( memcmp(&datetime, &datetime0, sizeof(DateTime)) )
	    Warning(func, "Inconsistent verification time for code %d level %d", rcode, level1);
	}

      if ( ISEC1_AvgNum )
	{
	  if (  taxis->numavg && warn_numavg && (taxis->numavg != ISEC1_AvgNum) )
	    {
	      Message(func, "Change numavg from %d to %d not allowed!",
		      taxis->numavg, ISEC1_AvgNum);
	      warn_numavg = FALSE;
	    }
	  else
	    {
	      taxis->numavg = ISEC1_AvgNum;
	    }
	}

      nrecs++;

      if ( CDI_Debug )
	Message(func, "%4d %8d %4d  %8d %8d %6d", nrecs, (int)recpos, rcode, level1, vdate, vtime);

      grbAddRecord(streamID, rcode, isec1, isec2, fsec2, isec4, recsize, recpos, prec);
    }

  streams[streamID].rtsteps = 1;

  cdiGenVars(streamID);

  if ( fcast )
    {
      taxisID = taxisNew(TAXIS_RELATIVE);
      taxis->type  = TAXIS_RELATIVE;
      taxis->rdate = rdate;
      taxis->rtime = rtime;
      taxis->unit  = tunit;
    }
  else
    {
      taxisID = taxisNew(TAXIS_ABSOLUTE);
      taxis->type  = TAXIS_ABSOLUTE;
    }

  taxis->vdate = datetime0.date;
  taxis->vtime = datetime0.time;

  vlistID = streamInqVlist(streamID);
  vlistDefTaxis(vlistID, taxisID);

  nrecords = streams[streamID].tsteps[0].nallrecs;
  if ( nrecords < streams[streamID].tsteps[0].recordSize )
    {
      streams[streamID].tsteps[0].recordSize = nrecords;
      streams[streamID].tsteps[0].records =
      (RECORD *) realloc(streams[streamID].tsteps[0].records, nrecords*sizeof(RECORD));
    }

  streams[streamID].tsteps[0].recIDs = (int *) malloc(nrecords*sizeof(int));
  streams[streamID].tsteps[0].nrecs = nrecords;
  for ( recID = 0; recID < nrecords; recID++ )
    streams[streamID].tsteps[0].recIDs[recID] = recID;

  streams[streamID].record->buffer     = gribbuffer;
  streams[streamID].record->buffersize = buffersize;

  if ( streams[streamID].ntsteps == -1 )
    {
      tsID = tstepsNewEntry(streamID);
      if ( tsID != streams[streamID].rtsteps )
	Error(func, "Internal error. tsID = %d", tsID);

      streams[streamID].tsteps[tsID-1].next   = TRUE;
      streams[streamID].tsteps[tsID].position = recpos;
    }

  if ( streams[streamID].ntsteps == 1 )
    {
      if ( taxis->vdate == 0 && taxis->vtime == 0 )
	{
	  streams[streamID].ntsteps = 0;
	  for ( varID = 0; varID < streams[streamID].nvars; varID++ )
	    {
	      vlistDefVarTime(vlistID, varID, TIME_CONSTANT);
	    }
	}
    }
}


int grbScanTimestep2(int streamID)
{
  static char func[] = "grbScanTimestep2";
  int *isec0, *isec1, *isec2, *isec3, *isec4;
  double fsec2[512], fsec3[2], *fsec4 = NULL;
  off_t recpos = 0;
  unsigned char *gribbuffer = NULL;
  long buffersize = 0;
  int iret = 0, ipunp = 0, iword = 0;
  int ierr;
  int fileID;
  int rcode = 0, level1 = 0, level2 = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  int tsID;
  int varID, gridID;
  size_t readsize;
  int nrecords, nrecs, recID, rindex;
  long recsize = 0;
  int warn_numavg = TRUE;
  int taxisID = -1;
  int nextstep;
  TAXIS *taxis;
  int vlistID;
  COMPVAR compVar, compVar0;

  streamCheckID(func, streamID);

  streams[streamID].curTsID = 1;

  isec0 = streams[streamID].record->sec0;
  isec1 = streams[streamID].record->sec1;
  isec2 = streams[streamID].record->sec2;
  isec3 = streams[streamID].record->sec3;
  isec4 = streams[streamID].record->sec4;

  fileID  = streamInqFileID(streamID);
  vlistID = streamInqVlist(streamID);
  taxisID = vlistInqTaxis(vlistID);

  gribbuffer = (unsigned char *) streams[streamID].record->buffer;
  buffersize = streams[streamID].record->buffersize;
                                          
  tsID = streams[streamID].rtsteps;
  if ( tsID != 1 )
    Error(func, "Internal problem! unexpeceted timestep %d", tsID+1);

  taxis = &streams[streamID].tsteps[tsID].taxis;

  fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);

  cdiCreateRecords(streamID, tsID);

  nrecords = streams[streamID].tsteps[tsID].nallrecs;
  streams[streamID].tsteps[1].recIDs = (int *) malloc(nrecords*sizeof(int));
  streams[streamID].tsteps[1].nrecs = 0;
  for ( recID = 0; recID < nrecords; recID++ )
    streams[streamID].tsteps[1].recIDs[recID] = -1;
      
  for ( recID = 0; recID < nrecords; recID++ )
    {
      varID = streams[streamID].tsteps[0].records[recID].varID;
      streams[streamID].tsteps[tsID].records[recID].position = 
	streams[streamID].tsteps[0].records[recID].position;
      streams[streamID].tsteps[tsID].records[recID].size     = 
	streams[streamID].tsteps[0].records[recID].size;
    }

  for ( rindex = 0; rindex <= nrecords; rindex++ )
    {
      recsize = gribGetSize(fileID);
      recpos  = fileGetPos(fileID);
      if ( recsize == 0 )
	{
	  streams[streamID].ntsteps = 2;
	  break;
	}
      if ( recsize > buffersize )
	{
	  buffersize = recsize;
	  gribbuffer = (unsigned char *) realloc(gribbuffer, buffersize);
	}

      readsize = recsize;
      ierr = gribRead(fileID, gribbuffer, &readsize);
      if ( ierr ) break;

      gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, fsec4,
	       ipunp, (int *) gribbuffer, recsize, &iword, "J", &iret);

      rcode     = ISEC1_Parameter;
      level1    = ISEC1_Level1;
      level2    = ISEC1_Level2;
      if ( ISEC1_LevelType == 100 ) level1 *= 100;

      gribDateTime(isec1, &vdate, &vtime);

      if ( rindex == 0 )
	{
	  datetime0.date = vdate;
	  datetime0.time = vtime;
	  if ( taxisInqType(taxisID) == TAXIS_RELATIVE )
	    {
	      taxis->type  = TAXIS_RELATIVE;
	      taxis->rdate = gribRefDate(isec1);
	      taxis->rtime = gribRefTime(isec1);
	      taxis->unit  = gribTimeUnit(isec1);
	    }
	  else
	    {
	      taxis->type  = TAXIS_ABSOLUTE;
	    }
	  taxis->vdate = vdate;
	  taxis->vtime = vtime;
	}
      else
	{
	  datetime.date = vdate;
	  datetime.time = vtime;
	}

      if ( ISEC1_AvgNum )
	{
	  if (  taxis->numavg && warn_numavg &&
		(taxis->numavg != ISEC1_AvgNum) )
	    {
	  /*
	      Message(func, "change numavg from %d to %d not allowed!",
		      taxis->numavg, ISEC1_AvgNum);
	  */
	      warn_numavg = FALSE;
	    }
	  else
	    {
	      taxis->numavg = ISEC1_AvgNum;
	    }
	}

      compVar.code   = rcode;
      compVar.table  = ISEC1_CodeTable;
      compVar.level1 = level1;
      compVar.level2 = level2;
      compVar.ltype  = ISEC1_LevelType;
      nextstep = FALSE;
      for ( recID = 0; recID < nrecords; recID++ )
	{
	  compVar0.code   = streams[streamID].tsteps[tsID].records[recID].code;
	  compVar0.table  = streams[streamID].tsteps[tsID].records[recID].table;
	  compVar0.level1 = streams[streamID].tsteps[tsID].records[recID].ilevel;
	  compVar0.level2 = streams[streamID].tsteps[tsID].records[recID].ilevel2;
	  compVar0.ltype  = streams[streamID].tsteps[tsID].records[recID].ltype;
	  if ( memcmp(&compVar0, &compVar, sizeof(COMPVAR)) == 0 )
	    {
	      if ( streams[streamID].tsteps[tsID].records[recID].used )
		{
		  nextstep = TRUE;
		}
	      else
		{
		  streams[streamID].tsteps[tsID].records[recID].used = TRUE;
		  streams[streamID].tsteps[tsID].recIDs[rindex] = recID;
		}
	      break;
	    }
	}
      if ( recID == nrecords )
	{
	  Warning(func, "code %d level %d not found at timestep %d", rcode, level1, tsID+1);
	  return (CDI_EUFSTRUCT);
	}

      if ( nextstep ) break;

      if ( CDI_Debug )
	Message(func, "%4d %8d %4d %8d %8d %6d", rindex+1, (int)recpos, rcode, level1, vdate, vtime);

      streams[streamID].tsteps[tsID].records[recID].size = recsize;

      compVar0.code   = streams[streamID].tsteps[tsID].records[recID].code;
      compVar0.table  = streams[streamID].tsteps[tsID].records[recID].table;
      compVar0.level1 = streams[streamID].tsteps[tsID].records[recID].ilevel;
      compVar0.level2 = streams[streamID].tsteps[tsID].records[recID].ilevel2;
      compVar0.ltype  = streams[streamID].tsteps[tsID].records[recID].ltype;

      if ( memcmp(&compVar0, &compVar, sizeof(COMPVAR)) != 0 )
	{
	  Message(func, "tsID = %d recID = %d code = %3d new %3d  level = %3d new %3d",
		  tsID, recID,
		  streams[streamID].tsteps[tsID].records[recID].code, rcode,
		  streams[streamID].tsteps[tsID].records[recID].ilevel, level1);
	  return (CDI_EUFSTRUCT);
	}

      streams[streamID].tsteps[1].records[recID].position = recpos;
      varID = streams[streamID].tsteps[tsID].records[recID].varID;
      gridID = vlistInqVarGrid(vlistID, varID);
      if ( gridInqSize(gridID) == 1 && gridInqType(gridID) == GRID_LONLAT )
	{
	  if ( gridInqXval(gridID, 0) != ISEC2_FirstLon*0.001 ||
	       gridInqYval(gridID, 0) != ISEC2_FirstLat*0.001 )
	    gridChangeType(gridID, GRID_TRAJECTORY);
	}
    }

  nrecs = 0;
  for ( recID = 0; recID < nrecords; recID++ )
    {
      if ( ! streams[streamID].tsteps[tsID].records[recID].used )
	{
	  varID = streams[streamID].tsteps[tsID].records[recID].varID;
	  vlistDefVarTime(vlistID, varID, TIME_CONSTANT);
	}
      else
	{
	  nrecs++;
	}
    }
  streams[streamID].tsteps[tsID].nrecs = nrecs;

  streams[streamID].rtsteps = 2;

  if ( streams[streamID].ntsteps == -1 )
    {
      tsID = tstepsNewEntry(streamID);
      if ( tsID != streams[streamID].rtsteps )
	Error(func, "Internal error. tsID = %d", tsID);

      streams[streamID].tsteps[tsID-1].next   = TRUE;
      streams[streamID].tsteps[tsID].position = recpos;
    }

  streams[streamID].record->buffer     = gribbuffer;
  streams[streamID].record->buffersize = buffersize;

  return (0);
}


int grbInqContents(int streamID)
{
  static char func[] = "grbInqContents";
  int fileID;
  int status = 0;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);

  streams[streamID].curTsID = 0;

  grbScanTimestep1(streamID);
 
  if ( streams[streamID].ntsteps == -1 ) status = grbScanTimestep2(streamID);

  fileSetPos(fileID, 0, SEEK_SET);

  return (status);
}


int grbInqTimestep(int streamID, int tsID)
{
  static char func[] = "grbInqTimestep";
  int ntsteps, nrecs;

  streamCheckID(func, streamID);

  if ( tsID == 0 && streams[streamID].rtsteps == 0 )
    Error(func, "Call to cdiInqContents missing!");

  if ( CDI_Debug )
    Message(func, "tsid = %d rtsteps = %d", tsID, streams[streamID].rtsteps);
  
  ntsteps = UNDEFID;
  while ( (tsID + 1) > streams[streamID].rtsteps && ntsteps == UNDEFID )
    {
      ntsteps = grbScanTimestep(streamID);
      if ( ntsteps == CDI_EUFSTRUCT )
	{
	  streams[streamID].ntsteps = streams[streamID].rtsteps;
	  break;
	}
    }

  if ( tsID >= streams[streamID].ntsteps && streams[streamID].ntsteps != CDI_UNDEFID )
    {
      nrecs = 0;
    }
  else
    {
      streams[streamID].curTsID = tsID;
      nrecs = streams[streamID].tsteps[tsID].nrecs;
    }

  return (nrecs);
}


void grbReadVarDP(int streamID, int varID, double *data, int *nmiss)
{
  static char func[] = "grbReadVarDP";
  int fileID;
  int levelID, nlevs, gridID, gridsize;
  unsigned char *gribbuffer;
  int tsID, recID;
  long recsize;
  off_t recpos, currentfilepos;
  int imiss;
  int vlistID;

  streamCheckID(func, streamID);

  gribbuffer = (unsigned char *) streams[streamID].record->buffer;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  tsID     = streams[streamID].curTsID;

  nlevs    = streams[streamID].vars[varID].nlevs;
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d", nlevs, gridID, gridsize);

  currentfilepos = fileGetPos(fileID);

  *nmiss = 0;
  for ( levelID = 0; levelID < nlevs; levelID++ )
    {
      recID   = streams[streamID].vars[varID].level[levelID];
      recpos  = streams[streamID].tsteps[tsID].records[recID].position;
      recsize = streams[streamID].tsteps[tsID].records[recID].size;

      fileSetPos(fileID, recpos, SEEK_SET);

      fileRead(fileID, gribbuffer, recsize);

      grbDecodeDataDP(gribbuffer, recsize, &data[levelID*gridsize], gridsize, streams[streamID].unreduced, &imiss);

      *nmiss += imiss;
    }

  fileSetPos(fileID, currentfilepos, SEEK_SET);
}

void grbReadVarSliceDP(int streamID, int varID, int levelID, double *data, int *nmiss)
{
  static char func[] = "grbReadVarSliceDP";
  int fileID;
  int gridID, gridsize;
  unsigned char *gribbuffer;
  long recsize;
  off_t recpos, currentfilepos;
  int tsID, recID;
  int vlistID;

  streamCheckID(func, streamID);

  gribbuffer = (unsigned char *) streams[streamID].record->buffer;

  vlistID  = streamInqVlist(streamID);
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  tsID     = streams[streamID].curTsID;

  if ( CDI_Debug )
    Message(func, "gridID = %d gridsize = %d", gridID, gridsize);

  fileID = streamInqFileID(streamID);

  currentfilepos = fileGetPos(fileID);

  recID   = streams[streamID].vars[varID].level[levelID];
  recpos  = streams[streamID].tsteps[tsID].records[recID].position;
  recsize = streams[streamID].tsteps[tsID].records[recID].size;

  if ( recsize == 0 )
    Error(func, "Internal problem! Recordsize is zero for record %d at timestep %d",
	  recID+1, tsID+1);

  fileSetPos(fileID, recpos, SEEK_SET);

  fileRead(fileID, gribbuffer, recsize);

  grbDecodeDataDP(gribbuffer, recsize, data, gridsize, streams[streamID].unreduced, nmiss);

  fileSetPos(fileID, currentfilepos, SEEK_SET);
}

void grbDefInstitut(int *isec1, int center, int subcenter)
{
  ISEC1_CenterID    = center;
  ISEC1_SubCenterID = subcenter;
}

void grbDefModel(int *isec1, int model)
{
  ISEC1_ModelID = model;
}

void grbDefCode(int *isec1, int code, int codetable)
{
  ISEC1_CodeTable = codetable;
  if ( code < 0 ) code = -code;
  ISEC1_Parameter = code;
}

void grbDefTime(int *isec1, int date, int time, int numavg, int timeID)
{
  int year, month, day, hour, minute;
  int century;
  int timetype = -1;

  if ( timeID != -1 ) timetype = taxisInqType(timeID);

  if ( timetype == TAXIS_RELATIVE )
    {
      sUnit tunit = {0, 1};
      int rdate, rtime;
      double value;
      
      rdate   = taxisInqRdate(timeID);
      rtime   = taxisInqRtime(timeID);
      year    =  rdate / 10000;
      month   = (rdate - year*10000) / 100;
      day     =  rdate - year*10000 - month*100;
      hour    =  rtime / 100;
      minute  =  rtime - hour*100;
      century =  year / 100;

      ISEC1_Year   = year - century*100;
      ISEC1_Month  = month;
      ISEC1_Day    = day;
      ISEC1_Hour   = hour;
      ISEC1_Minute = minute;
      /*
      printf("year %d, month %d, day %d, hour %d, minute %d\n", year, month, day, hour, minute);
      */
      InvCalendar(year, month, day, hour, minute, 0.0, tunit, &value);
      tunit.origin = value;
      switch (taxisInqTunit(timeID))
	{
	case TUNIT_MINUTE:  tunit.factor =    60; ISEC1_TimeUnit = ISEC1_TABLE4_MINUTE; break;
	case TUNIT_HOUR:    tunit.factor =  3600; ISEC1_TimeUnit = ISEC1_TABLE4_HOUR; break;
	case TUNIT_DAY:     tunit.factor = 86400; ISEC1_TimeUnit = ISEC1_TABLE4_DAY; break;
	default:            tunit.factor =  3600; ISEC1_TimeUnit = ISEC1_TABLE4_HOUR; break;
	}
      year   =  date / 10000;
      month  = (date - year*10000) / 100;
      day    =  date - year*10000 - month*100;
      hour   =  time / 100;
      minute =  time - hour*100;
      /*
      printf("date time %d %d\n", date, time);
      printf("year %d, month %d, day %d, hour %d, minute %d\n", year, month, day, hour, minute);
      */
      InvCalendar(year, month, day, hour, minute, 0.0, tunit, &value);
      /*
      printf("value = %f\n", value);
      */
      ISEC1_TimeRange = 0;
      ISEC1_TimePeriod1 = (int) value;
    }
  else
    {
      year    =  date / 10000;
      month   = (date - year*10000) / 100;
      day     =  date - year*10000 - month*100;
      hour    =  time / 100;
      minute  =  time - hour*100;
      century =  year / 100;

      ISEC1_Year     = year - century*100;
      ISEC1_Month    = month;
      ISEC1_Day      = day;
      ISEC1_Hour     = hour;
      ISEC1_Minute   = minute;

      ISEC1_TimeUnit = 0;

      if ( numavg > 0 )
	ISEC1_TimeRange = 0;
      else
	ISEC1_TimeRange = 10;

      ISEC1_TimePeriod1 = 0;
    }

  ISEC1_TimePeriod2    = 0;
  ISEC1_AvgNum         = numavg;
  ISEC1_AvgMiss        = 0;
  ISEC1_Century        = century + 1;
  ISEC1_DecScaleFactor = 0;
}


void grbDefGrid(int *isec1, int *isec2, int gridID)
{
  static char func[] = "grbDefGrid";
  int gridtype;

  ISEC1_Sec2Or3Flag = 128;
  
  gridtype = gridInqType(gridID);

  ISEC1_GridDefinition = 255;

  if ( gridtype == GRID_GENERIC )
    {
      size_t size, xsize, ysize;

      size  = gridInqSize(gridID);
      xsize = gridInqXsize(gridID);
      ysize = gridInqYsize(gridID);

      if ( (ysize == 32  || ysize == 48 || ysize == 64 ||
	    ysize == 96  || ysize == 160) && 
	   (xsize == 2*ysize || xsize == 1) )
	{
	  gridtype = GRID_GAUSSIAN;
	  gridChangeType(gridID, gridtype);
	}
      else if ( xsize == 1 && ysize == 1 )
	{
	  gridtype = GRID_LONLAT;
	  gridChangeType(gridID, gridtype);
	}
    }

  ISEC2_Reduced = FALSE;

  switch (gridtype)
    {
    case GRID_LONLAT:
    case GRID_GAUSSIAN:
    case GRID_GAUSSIAN_REDUCED:
    case GRID_TRAJECTORY:
      {
	int nlon = 0, nlat;

	if ( gridtype == GRID_GAUSSIAN_REDUCED )
	  {
	    ISEC2_Reduced = TRUE;
	    nlon = 0;
	    gridInqRowlon(gridID, ISEC2_RowLonPtr);
	  }
	else
	  {
	    nlon = (int) gridInqXsize(gridID);
	  }

	nlat = (int) gridInqYsize(gridID);
	if ( gridtype == GRID_GAUSSIAN || gridtype == GRID_GAUSSIAN_REDUCED )
	  ISEC2_GridType = 4;
	else if ( gridtype == GRID_LONLAT && gridIsRotated(gridID) )
	  ISEC2_GridType = 10;
	else
	  ISEC2_GridType = 0;

	ISEC2_NumLon   = nlon;
	ISEC2_NumLat   = nlat;
	ISEC2_FirstLat = NINT(gridInqYval(gridID,      0)*1000);
	ISEC2_LastLat  = NINT(gridInqYval(gridID, nlat-1)*1000);
	ISEC2_FirstLon = NINT(gridInqXval(gridID,      0)*1000);
	ISEC2_LastLon  = NINT(gridInqXval(gridID, nlon-1)*1000);
	ISEC2_LonIncr  = NINT(gridInqXinc(gridID)*1000);
	if ( fabs(gridInqXinc(gridID)*1000 - ISEC2_LonIncr) > FLT_EPSILON )
	  ISEC2_LonIncr = 0;

	if ( gridtype == GRID_GAUSSIAN )
	  ISEC2_NumPar = nlat/2;
	else
	  {
	    ISEC2_LatIncr = NINT(gridInqYinc(gridID)*1000);
	    if ( fabs(gridInqYinc(gridID)*1000 - ISEC2_LatIncr) > FLT_EPSILON )
	      ISEC2_LatIncr = 0;
	  }

	if ( ISEC2_LatIncr == 0 || ISEC2_LonIncr == 0 )
	  ISEC2_ResFlag = 0;
	else
	  ISEC2_ResFlag = 128;

	if ( gridIsRotated(gridID) )
	  {
	    ISEC2_LatSP = - NINT(gridInqYpole(gridID) * 1000);
	    ISEC2_LonSP =   NINT((gridInqXpole(gridID) + 180) * 1000);
	  }

	break;
      }
    case GRID_SPECTRAL:
      {
	ISEC2_GridType = 50;
	ISEC2_PentaJ  = gridInqTrunc(gridID);
	ISEC2_PentaK  = ISEC2_PentaJ;
	ISEC2_PentaM  = ISEC2_PentaJ;
	ISEC2_RepType = 1;
	ISEC2_RepMode = 1;
	break;
      }
    case GRID_TRIANGULAR:
      {
	ISEC2_GridType = 192;
	ISEC2_TRI_ND  = gridInqTriNd(gridID);
	ISEC2_TRI_NI  = gridInqTriNi(gridID);
	ISEC2_TRI_NI2 = gridInqTriNi2(gridID);
	ISEC2_TRI_NI3 = gridInqTriNi3(gridID);
	break;
      }
    default:
      Error(func, "%s grid unsupported!", gridNamePtr(gridtype));
    }

  ISEC2_ScanFlag = 0;
}


void grbDefLevel(int *isec1, int *isec2, double *fsec2, int zaxisID, int levelID)
{
  static char func[] = "grbDefLevel";
  double level;
  int ilevel, leveltype;
  static int warning = 1;
  static int vct_warning = 1;

  leveltype = zaxisInqType(zaxisID);

  if ( leveltype == ZAXIS_GENERIC )
    {
      size_t size;

      size  = zaxisInqSize(zaxisID);
 
	{
	  leveltype = ZAXIS_PRESSURE;
	  zaxisChangeType(zaxisID, leveltype);
	}
    }

  ISEC2_NumVCP = 0;

  switch (leveltype)
    {
    case ZAXIS_SURFACE:
      {
	ISEC1_LevelType = 1;
	ISEC1_Level1    = 0;
	ISEC1_Level2    = 0;
	break;
      }
    case ZAXIS_HYBRID:
      {
	int vctsize;

	if ( zaxisInqHasBounds(zaxisID) )
	  {
	    ISEC1_LevelType = LTYPE_HYBRID_LAYER;
	    ISEC1_Level1    = (int) zaxisInqLbound(zaxisID, levelID);
	    ISEC1_Level2    = (int) zaxisInqUbound(zaxisID, levelID);
	  }
	else
	  {
	    ISEC1_LevelType = LTYPE_HYBRID;
	    ISEC1_Level1    = (int) zaxisInqLevel(zaxisID, levelID);
	    ISEC1_Level2    = 0;
	  }

	vctsize = zaxisInqVctSize(zaxisID);
	if ( vctsize == 0 && warning )
	  {
	    Warning(func, "VCT missing. ( code = %d, zaxisID = %d )",
		    ISEC1_Parameter, zaxisID);
	    warning = 0;
	  }
	if ( vctsize > 255 )
	  {
	    ISEC2_NumVCP = 0;
	    if ( vct_warning )
	      {
		Warning(func, "VCT size of %d is to large (maximum is 255). Set to 0!", vctsize);
		vct_warning = 0;
	      }
	  }
	else
	  {
	    ISEC2_NumVCP = vctsize;
	    memcpy(&fsec2[10], zaxisInqVctPtr(zaxisID), vctsize*sizeof(double));
	  }
	break;
      }
    case ZAXIS_PRESSURE:
      {
	double dum;
	char units[128];

	level = zaxisInqLevel(zaxisID, levelID);
	if ( level < 0 )
	  Warning(func, "pressure level of %f Pa is below 0.", level);

	zaxisInqUnits(zaxisID, units);
	if ( strncmp(units, "hPa", 3) == 0 ||  strncmp(units, "mb",2 ) == 0 )
	  level = level*100;

	ilevel = (int) level;
	if ( level < 32768 && (level < 100 || modf(level/100, &dum) > 0) )
	  {
	    ISEC1_LevelType = LTYPE_99;
	    ISEC1_Level1    = ilevel;
	    ISEC1_Level2    = 0;
	  }
	else
	  {
	    ISEC1_LevelType = LTYPE_ISOBARIC;
	    ISEC1_Level1    = ilevel/100;
	    ISEC1_Level2    = 0;
	  }
	break;
      }
    case ZAXIS_HEIGHT:
      {
	level = zaxisInqLevel(zaxisID, levelID);

	ilevel = (int) level;
	ISEC1_LevelType = LTYPE_HEIGHT;
	ISEC1_Level1    = ilevel;
	ISEC1_Level2    = 0;

	break;
      }
    case ZAXIS_DEPTH_BELOW_LAND:
      {
	if ( zaxisInqHasBounds(zaxisID) )
	  {
	    ISEC1_LevelType = LTYPE_LANDDEPTH_LAYER;
	    ISEC1_Level1    = (int) zaxisInqLbound(zaxisID, levelID);
	    ISEC1_Level2    = (int) zaxisInqUbound(zaxisID, levelID);
	  }
	else
	  {
	    level = zaxisInqLevel(zaxisID, levelID);

	    ilevel = (int) level;
	    ISEC1_LevelType = LTYPE_LANDDEPTH;
	    ISEC1_Level1    = ilevel;
	    ISEC1_Level2    = 0;
	  }

	break;
      }
    case ZAXIS_DEPTH_BELOW_SEA:
      {
	level = zaxisInqLevel(zaxisID, levelID);

	ilevel = (int) level;
	ISEC1_LevelType = LTYPE_SEADEPTH;
	ISEC1_Level1    = ilevel;
	ISEC1_Level2    = 0;

	break;
      }
    case ZAXIS_ISENTROPIC:
      {
	level = zaxisInqLevel(zaxisID, levelID);

	ilevel = (int) level;
	ISEC1_LevelType = 113;
	ISEC1_Level1    = ilevel;
	ISEC1_Level2    = 0;

	break;
      }
    default:
      {
	Error(func, "leveltype >%s< unsupported", zaxisTypeNamePtr(leveltype));
	break;
      }
    }
}

void grbDefMask(int *isec3)
{
}

void grbDefData(int datatype, int varID, int *isec4, int gridID)
{
  ISEC4_NumValues = gridInqSize(gridID);

  if ( datatype != UNDEFID )
    {
      if ( datatype != DATATYPE_PACK  && datatype != DATATYPE_PACK1 &&
	   datatype != DATATYPE_PACK2 && datatype != DATATYPE_PACK3 )
	{
	  if   ( datatype == DATATYPE_REAL8 ) datatype = DATATYPE_PACK3;
	  else                           datatype = DATATYPE_PACK2;
	}
      datatype *= 8;
      if ( datatype == 8 || datatype == 16 || datatype == 24 )
	ISEC4_NumBits = datatype;
      else
	ISEC4_NumBits = 16;
    }
  else
    ISEC4_NumBits = 16;
}

void grbDefaultSec0(int *isec0)
{
  ISEC0_GRIB_Len     = 0;
  ISEC0_GRIB_Version = 0;
}

void grbDefaultSec1(int *isec1)
{
  ISEC1_CenterID    = 0;
  ISEC1_SubCenterID = 0;
  ISEC1_LocalFLag   = 0;
}

void grbDefaultSec4(int *isec4)
{
  isec4[2] = 0;
  isec4[3] = 0;
  isec4[4] = 0;
  isec4[5] = 0;
  isec4[6] = 0;
  isec4[7] = 0;
  isec4[8] = 0;
  isec4[9] = 0;
  isec4[10] = 0;
}

void grbWriteVarDP(int streamID, int varID, const double *data, int nmiss)
{
  static char func[] = "grbWriteVarDP";
  int fileID;
  int levelID, nlevs, gridID;
  int zaxisID;
  double level;
  int isec0[2], isec1[4096], isec2[4096], isec3[2], isec4[512];
  double fsec2[512], fsec3[2];
  unsigned char *gribbuffer = NULL;
  size_t gribbuffersize = 0;
  long datasize, gribsize;
  int ierr, iret = 0, iword = 0;
  int date, time, code;
  int numavg = 0;
  int tsID;
  int instID, modelID, tableID;
  int datatype;
  int vlistID;

  if ( CDI_Debug ) Message(func, "streamID = %d  varID = %d", streamID, varID);

  memset(isec1, 0, 32*sizeof(int));

  fileID  = streamInqFileID(streamID);
  vlistID = streamInqVlist(streamID);
  tsID    = streams[streamID].curTsID;

  gridID   = vlistInqVarGrid(vlistID, varID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);

  nlevs    = zaxisInqSize(zaxisID);

  code     = vlistInqVarCode(vlistID, varID);
  date     = streams[streamID].tsteps[tsID].taxis.vdate;
  time     = streams[streamID].tsteps[tsID].taxis.vtime;
  if ( vlistInqVarAverage(vlistID, varID) )
    numavg = streams[streamID].tsteps[tsID].taxis.numavg;
  datasize = gridInqSize(gridID);

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d datasize = %d",
	    nlevs, gridID, datasize);

  gribbuffersize = datasize*4+3000;
  gribbuffer = (unsigned char *) malloc(gribbuffersize);
  gribsize   = gribbuffersize / sizeof(int);

  grbDefaultSec0(isec0);
  grbDefaultSec1(isec1);
  grbDefaultSec4(isec4);

  if ( vlistInqInstitut(vlistID) != UNDEFID )
    instID = vlistInqInstitut(vlistID);
  else
    instID = vlistInqVarInstitut(vlistID, varID);

  if ( instID != UNDEFID )
    {
      int center, subcenter;
      center    = institutInqCenter(instID);
      subcenter = institutInqSubcenter(instID);
      grbDefInstitut(isec1, center, subcenter);
    }

  if ( vlistInqModel(vlistID) != UNDEFID )
    modelID = vlistInqModel(vlistID);
  else
    modelID = vlistInqVarModel(vlistID, varID);

  if ( modelID != UNDEFID )
    grbDefModel(isec1, modelInqGribID(modelID));

  tableID = vlistInqVarTable(vlistID, varID);
  datatype = vlistInqVarDatatype(vlistID, varID);

  grbDefCode(isec1, code, tableInqGribID(tableID));
  grbDefTime(isec1, date, time, numavg, vlistInqTaxis(vlistID));
  grbDefGrid(isec1, isec2, gridID);
  grbDefData(datatype, varID, isec4, gridID);

  if ( nmiss > 0 )
    {
      FSEC3_MissVal = vlistInqVarMissval(vlistID, varID);
      ISEC1_Sec2Or3Flag |= 64;
    }

  for (levelID = 0;  levelID< nlevs; levelID++)
    {
      level = zaxisInqLevel(zaxisID, levelID);

      grbDefLevel(isec1, isec2, fsec2, zaxisID, levelID);
      grbDefMask(isec3);

      gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, (double*) &data[levelID*datasize],
	       datasize, (int *) gribbuffer, gribsize, &iword, "C", &iret);
      
      ierr = gribWrite(fileID, gribbuffer, iword*sizeof(int));
    }

  if ( gribbuffer ) free(gribbuffer);
}

void grbWriteVarSliceDP(int streamID, int varID, int levelID, const double *data, int nmiss)
{
  static char func[] = "grbWriteVarSliceDP";
  int fileID;
  int nlevs, gridID;
  int zaxisID;
  double level;
  int isec0[2], isec1[4096], isec2[4096], isec3[2], isec4[512];
  double fsec2[512], fsec3[2];
  unsigned char *gribbuffer = NULL;
  size_t gribbuffersize = 0;
  long datasize, gribsize;
  int ierr, iret = 0, iword = 0;
  int date, time, code;
  int numavg = 0;
  int tsID;
  int instID, modelID, tableID;
  int datatype;
  int vlistID;

  memset(isec1, 0, 32*sizeof(int));

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  tsID     = streams[streamID].curTsID;

  gridID   = vlistInqVarGrid(vlistID, varID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);

  nlevs    = zaxisInqSize(zaxisID);
  level    = zaxisInqLevel(zaxisID, levelID);

  if ( CDI_Debug )
    Message(func, "gridID = %d zaxisID = %d", gridID, zaxisID);

  code     = vlistInqVarCode(vlistID, varID);
  date     = streams[streamID].tsteps[tsID].taxis.vdate;
  time     = streams[streamID].tsteps[tsID].taxis.vtime;
  if ( vlistInqVarAverage(vlistID, varID) )
    numavg = streams[streamID].tsteps[tsID].taxis.numavg;
  datasize = gridInqSize(gridID);

  gribbuffersize = datasize*4+3000;
  gribbuffer = (unsigned char *) malloc(gribbuffersize);
  gribsize   = gribbuffersize / sizeof(int);

  grbDefaultSec0(isec0);
  grbDefaultSec1(isec1);
  grbDefaultSec4(isec4);

  if ( vlistInqInstitut(vlistID) != UNDEFID )
    instID = vlistInqInstitut(vlistID);
  else
    instID = vlistInqVarInstitut(vlistID, varID);

  if ( instID != UNDEFID )
    {
      int center, subcenter;
      center    = institutInqCenter(instID);
      subcenter = institutInqSubcenter(instID);
      grbDefInstitut(isec1, center, subcenter);
    }

  if ( vlistInqModel(vlistID) != UNDEFID )
    modelID = vlistInqModel(vlistID);
  else
    modelID = vlistInqVarModel(vlistID, varID);

  if ( modelID != UNDEFID )
    grbDefModel(isec1, modelInqGribID(modelID));

  tableID = vlistInqVarTable(vlistID, varID);
  datatype = vlistInqVarDatatype(vlistID, varID);

  grbDefCode(isec1, code, tableInqGribID(tableID));
  grbDefTime(isec1, date, time, numavg, vlistInqTaxis(vlistID));
  grbDefGrid(isec1, isec2, gridID);
  grbDefLevel(isec1, isec2, fsec2, zaxisID, levelID);
  grbDefMask(isec3);
  grbDefData(datatype, varID, isec4, gridID);

  if ( nmiss > 0 )
    {
      FSEC3_MissVal = vlistInqVarMissval(vlistID, varID);
      ISEC1_Sec2Or3Flag |= 64;
    }

  gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, (double*) data,
	   datasize, (int *) gribbuffer, gribsize, &iword, "C", &iret);

  ierr = gribWrite(fileID, gribbuffer, iword*sizeof(int));

  if ( gribbuffer ) free(gribbuffer);
}

int grbCopyRecord(int ostreamID, int istreamID)
{
  static char func[] = "grbCopyRecord";
  int ifileID, ofileID;
  int tsID, recID, vrecID;
  long recsize;
  off_t recpos;
  int ierr = 0;
  char *buffer;

  streamCheckID(func, istreamID);
  streamCheckID(func, ostreamID);

  ifileID = streamInqFileID(istreamID);
  ofileID = streamInqFileID(ostreamID);

  tsID    = streams[istreamID].curTsID;
  vrecID  = streams[istreamID].tsteps[tsID].curRecID;
  recID   = streams[istreamID].tsteps[tsID].recIDs[vrecID];
  recpos  = streams[istreamID].tsteps[tsID].records[recID].position;
  recsize = streams[istreamID].tsteps[tsID].records[recID].size;

  fileSetPos(ifileID, recpos, SEEK_SET);

  buffer = (char *) malloc(recsize);

  fileRead(ifileID, buffer, recsize);

  fileWrite(ofileID, buffer, recsize);

  free(buffer);

  return (ierr);
}

int grbWriteRecord(int streamID, const double *data, int nmiss)
{
  static char func[] = "grbWriteRecord";
  int fileID;
  int ierr = 0;
  int levelID, nlevs, gridID;
  int zaxisID;
  double level;
  int isec0[2], isec1[4096], isec2[4096], isec3[2], isec4[512];
  double fsec2[512], fsec3[2];
  unsigned char *gribbuffer = NULL;
  size_t gribbuffersize = 0;
  long datasize, gribsize;
  int iret = 0, iword = 0;
  int date, time, code;
  int numavg = 0;
  int tsID;
  int instID, modelID, tableID;
  int varID;
  int datatype;
  int vlistID;

  streamCheckID(func, streamID);

  memset(isec1, 0, 32*sizeof(int));

  varID    = streams[streamID].record->varID;
  levelID  = streams[streamID].record->levelID;

  fileID   = streamInqFileID(streamID);
  vlistID  = streamInqVlist(streamID);
  tsID     = streams[streamID].curTsID;

  nlevs    = streams[streamID].vars[varID].nlevs;
  gridID   = vlistInqVarGrid(vlistID, varID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);
  level    = zaxisInqLevel(zaxisID, levelID);

  if ( CDI_Debug )
    Message(func, "gridID = %d zaxisID = %d", gridID, zaxisID);

  code     = vlistInqVarCode(vlistID, varID);
  date     = streams[streamID].tsteps[tsID].taxis.vdate;
  time     = streams[streamID].tsteps[tsID].taxis.vtime;
  if ( vlistInqVarAverage(vlistID, varID) )
    numavg = streams[streamID].tsteps[tsID].taxis.numavg;
  datasize = gridInqSize(gridID);

  gribbuffersize = datasize*4+3000;
  gribbuffer = (unsigned char *) malloc(gribbuffersize);
  gribsize   = gribbuffersize / sizeof(int);

  grbDefaultSec0(isec0);
  grbDefaultSec1(isec1);
  grbDefaultSec4(isec4);

  if ( vlistInqInstitut(vlistID) != UNDEFID )
    instID = vlistInqInstitut(vlistID);
  else
    instID = vlistInqVarInstitut(vlistID, varID);

  if ( instID != UNDEFID )
    {
      int center, subcenter;
      center    = institutInqCenter(instID);
      subcenter = institutInqSubcenter(instID);
      grbDefInstitut(isec1, center, subcenter);
    }

  if ( vlistInqModel(vlistID) != UNDEFID )
    modelID = vlistInqModel(vlistID);
  else
    modelID = vlistInqVarModel(vlistID, varID);

  if ( modelID != UNDEFID )
    grbDefModel(isec1, modelInqGribID(modelID));

  tableID = vlistInqVarTable(vlistID, varID);
  datatype = vlistInqVarDatatype(vlistID, varID);

  grbDefCode(isec1, code, tableInqGribID(tableID));
  grbDefTime(isec1, date, time, numavg, vlistInqTaxis(vlistID));
  grbDefGrid(isec1, isec2, gridID);
  grbDefLevel(isec1, isec2, fsec2, zaxisID, levelID);
  grbDefMask(isec3);
  grbDefData(datatype, varID, isec4, gridID);

  if ( nmiss > 0 )
    {
      FSEC3_MissVal = vlistInqVarMissval(vlistID, varID);
      ISEC1_Sec2Or3Flag |= 64;
    }

  gribExDP(isec0, isec1, isec2, fsec2, isec3, fsec3, isec4, (double*) data,
	   datasize, (int *) gribbuffer, gribsize, &iword, "C", &iret);

  /*  gribPrintSec2DP(isec0, isec2, fsec2); */
  ierr = gribWrite(fileID, gribbuffer, iword*sizeof(int));

  if ( gribbuffer ) free(gribbuffer);

  return (ierr);
}

void streamInqGinfo(int streamID, int *intnum, float *fltnum)
{
  static char func[] = "streamInqGinfo";
  int recID, vrecID, tsID;
  int gribsize;
  int filetype;
  void *gribbuffer;
  long recsize;
  off_t recpos;

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  if ( filetype == FILETYPE_GRB )
    {
      tsID    = streams[streamID].curTsID;
      vrecID  = streams[streamID].tsteps[tsID].curRecID;
      recID   = streams[streamID].tsteps[tsID].recIDs[vrecID];
      recpos  = streams[streamID].tsteps[tsID].records[recID].position;
      recsize = streams[streamID].tsteps[tsID].records[recID].size;

      gribsize   = streams[streamID].record->buffersize;
      gribbuffer = streams[streamID].record->buffer;

      gribGinfo(recpos, recsize, (unsigned char *) gribbuffer, intnum, fltnum);
    }
}

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID

#define SINGLE_PRECISION  4
#define DOUBLE_PRECISION  8

int srvInqDatatype(int prec)
{
  int datatype;

  if ( prec == DOUBLE_PRECISION ) datatype = DATATYPE_REAL8;
  else                            datatype = DATATYPE_REAL4;

  return (datatype);
}

int srvDefDatatype(int datatype)
{
  int prec;

  if ( datatype != DATATYPE_REAL4 && datatype != DATATYPE_REAL8 )
    datatype = DATATYPE_REAL4;

  if ( datatype == DATATYPE_REAL8 ) prec = DOUBLE_PRECISION;
  else                              prec = SINGLE_PRECISION;

  return (prec);
}

int srvInqRecord(int streamID, int *varID, int *levelID)
{
  static char func[] = "srvInqRecord";
  int ierr = 0;
  int fileID;
  int icode, ilevel, idate, itime, idimx, idimy;
  int gridID = -1, zaxisID = -1;
  int srvheader[8];
  int xsize, ysize;
  int vlistID;

  streamCheckID(func, streamID);

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);

  *varID   = -1;
  *levelID = -1;

  ierr = srvReadHeader(fileID, srvheader);

  if ( ierr == 0 ) return (0);

  icode  = srvheader[0];
  ilevel = srvheader[1];
  idate  = srvheader[2];
  itime  = srvheader[3];
  idimx  = srvheader[4];
  idimy  = srvheader[5];

  *varID = vlistInqVarID(vlistID, icode);

  if ( *varID == UNDEFID ) Error(func, "code %d undefined", icode);

  gridID  = vlistInqVarGrid(vlistID, *varID);
  zaxisID = vlistInqVarZaxis(vlistID, *varID);

  xsize = gridInqXsize(gridID);
  ysize = gridInqYsize(gridID);

  *levelID = zaxisInqLevelID(zaxisID, (double) ilevel);
  
  ierr = 1;

  return (ierr);
}

int srvReadRecord(int streamID, double *data, int *nmiss)
{
  static char func[] = "srvReadRecord";
  int vlistID, fileID;
  int ierr;
  int recID, vrecID, tsID;
  off_t recpos;
  int header[8];
  int varID, gridID;
  int i, size;
  double missval;

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);
  tsID    = streams[streamID].curTsID;
  vrecID  = streams[streamID].tsteps[tsID].curRecID;
  recID   = streams[streamID].tsteps[tsID].recIDs[vrecID];
  recpos  = streams[streamID].tsteps[tsID].records[recID].position;
  varID   = streams[streamID].tsteps[tsID].records[recID].varID;

  fileSetPos(fileID, recpos, SEEK_SET);

  srvReadHeader(fileID, header);

  ierr = srvReadDataDP(fileID, data);

  gridID  = vlistInqVarGrid(vlistID, varID);
  size    = gridInqSize(gridID);
  missval = vlistInqVarMissval(vlistID, varID);

  *nmiss = 0;
  for ( i = 0; i < size; i++ )
    if ( data[i] == missval || data[i] == (float)missval )
      {
	data[i] = missval;
	(*nmiss)++;
      }

  return (ierr);
}

int srvCopyRecord(int ostreamID, int istreamID)
{
  static char func[] = "srvCopyRecord";
  int ifileID, ofileID;
  int tsID, recID, vrecID;
  long recsize;
  off_t recpos;
  int ierr = 0;
  char *buffer;

  streamCheckID(func, istreamID);
  streamCheckID(func, ostreamID);

  ifileID = streamInqFileID(istreamID);
  ofileID = streamInqFileID(ostreamID);

  tsID    = streams[istreamID].curTsID;
  vrecID  = streams[istreamID].tsteps[tsID].curRecID;
  recID   = streams[istreamID].tsteps[tsID].recIDs[vrecID];
  recpos  = streams[istreamID].tsteps[tsID].records[recID].position;
  recsize = streams[istreamID].tsteps[tsID].records[recID].size;

  fileSetPos(ifileID, recpos, SEEK_SET);

  buffer = (char *) malloc(recsize);

  fileRead(ifileID, buffer, recsize);

  fileWrite(ofileID, buffer, recsize);

  free(buffer);

  return (ierr);
}

int srvDefRecord(int streamID)
{
  static char func[] = "srvDefRecord";
  int fileID;
  int gridID;
  int header[8];
  int ierr = 0;
  int xsize, ysize;
  int datatype;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);
  gridID = streams[streamID].record->gridID;

  header[0] = streams[streamID].record->code;
  header[1] = streams[streamID].record->level;
  header[2] = streams[streamID].record->date;
  header[3] = streams[streamID].record->time;
  xsize = gridInqXsize(gridID);
  ysize = gridInqYsize(gridID);
  if ( xsize == 0 || ysize == 0 )
    {
      xsize = gridInqSize(gridID);
      ysize = 1;
    }
  header[4] = xsize;
  header[5] = ysize;
  header[6] = 0;
  header[7] = 0;

  datatype = streams[streamID].record->prec;

  srvDefPrec(fileID, srvDefDatatype(datatype));

  srvWriteHeader(fileID, header);

  return (ierr);
}

int srvWriteRecord(int streamID, const double *data)
{
  static char func[] = "srvWriteRecord";
  int fileID;
  int ierr = 0;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);

  srvWriteDataDP(fileID, data);

  return (ierr);
}

void srvAddRecord(int streamID, int code, int level, int xsize, int ysize,
		  long recsize, off_t position, int prec)
{
  static char func[] = "srvAddRecord";
  int leveltype;
  int gridID = UNDEFID;
  int levelID = 0;
  int tsID, recID, varID;
  int datatype;
  RECORD *record;
  GRID grid;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  tsID    = streams[streamID].curTsID;
  recID   = recordNewEntry(streamID, tsID);
  record  = &streams[streamID].tsteps[tsID].records[recID];

  (*record).size     = recsize;
  (*record).position = position;
  (*record).code     = code;
  (*record).ilevel   = level;

  memset(&grid, 0, sizeof(GRID));
  grid.type  = GRID_GENERIC; 
  grid.size  = xsize*ysize;
  grid.xsize = xsize;
  grid.ysize = ysize;
  grid.xvals = NULL;
  grid.yvals = NULL;
  gridID = varDefGrid(vlistID, grid, 0);
  /*
  if ( level == 0 ) leveltype = ZAXIS_SURFACE;
  else              leveltype = ZAXIS_GENERIC;
  */
  leveltype = ZAXIS_GENERIC;

  datatype = srvInqDatatype(prec);

  varAddRecord(recID, code, gridID, leveltype, 0, level, 0,
	       datatype, &varID, &levelID, 0, 0);

  (*record).varID   = varID;
  (*record).levelID = levelID;

  streams[streamID].tsteps[tsID].nallrecs++;
  streams[streamID].nrecs++;

  if ( CDI_Debug )
    Message(func, "varID = %d gridID = %d levelID = %d",
	    varID, gridID, levelID);
}

void srvCmpRecord(int streamID, int tsID, int recID, off_t position, int code,
		  int level, int xsize, int ysize)
{
  static char func[] = "srvCmpRecord";
  int varID = 0;
  int levelID = 0;
  RECORD *record;

  record  = &streams[streamID].tsteps[tsID].records[recID];

  if ( code != (*record).code || level != (*record).ilevel )
    Error(func, "inconsistent timestep");

  (*record).position = position;
  /*
  varID   = (*record).varID;
  levelID = (*record).levelID;

  streams[streamID].vars[varID].level[levelID] = recID;

  streams[streamID].tsteps[tsID].nallrecs++;
  streams[streamID].nrecs++;
  */
  if ( CDI_Debug )
    Message(func, "varID = %d levelID = %d", varID, levelID);
}

void srvScanTimestep1(int streamID)
{  
  static char func[] = "srvScanTimestep1";
  int header[8];
  int prec = 0;
  int irec;
  int fileID;
  int rxsize = 0, rysize = 0;
  int rcode = 0, rlevel = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  long levelcode, levelcode0 = 0;
  int tsID;
  int varID;
  long recsize;
  off_t recpos;
  int nrecords, nrecs, recID;
  int taxisID = -1;
  TAXIS *taxis;
  int vlistID;

  streamCheckID(func, streamID);

  streams[streamID].curTsID = 0;

  tsID  = tstepsNewEntry(streamID);
  taxis = &streams[streamID].tsteps[tsID].taxis;

  if ( tsID != 0 )
    Error(func, "Internal problem! tstepsNewEntry returns %d", tsID);

  fileID = streamInqFileID(streamID);

  nrecs = 0;
  while ( TRUE )
    {
      recpos = fileGetPos(fileID);
      irec = srvReadHeader(fileID, header);
      if ( irec <= 0 )
	{
	  streams[streamID].ntsteps = 1;
	  break;
	}
      recsize = fileGetPos(fileID) - recpos;

      prec   = srvInqPrec(fileID);
      rcode  = header[0];
      rlevel = header[1];
      vdate  = header[2];
      vtime  = header[3];
      rxsize = header[4];
      rysize = header[5];

      if ( nrecs == 0 )
	{
	  datetime0.date = vdate;
	  datetime0.time = vtime;
	}
      else
	{
	  datetime.date = vdate;
	  datetime.time = vtime;
	  levelcode = rlevel*1000 + rcode;
	  for ( recID = 0; recID < nrecs; recID++ )
	    {
	      levelcode0 = streams[streamID].tsteps[0].records[recID].ilevel*1000 +
	 	           streams[streamID].tsteps[0].records[recID].code;
	      if ( levelcode == levelcode0 ) break;
	    }
	  if ( recID < nrecs ) break;
	  if ( memcmp(&datetime, &datetime0, sizeof(DateTime)) )
	    Warning(func, "Inconsistent verification time for code %d level %d", rcode, rlevel);
	}

      nrecs++;

      if ( CDI_Debug )
	Message(func, "%4d%8d%4d%8d%8d%6d", nrecs, (int)recpos, rcode, rlevel, vdate, vtime);

      srvAddRecord(streamID, rcode, rlevel, rxsize, rysize, recsize, recpos, prec);
    }

  streams[streamID].rtsteps = 1;

  cdiGenVars(streamID);

  taxisID = taxisNew(TAXIS_ABSOLUTE);
  taxis->type  = TAXIS_ABSOLUTE;
  taxis->vdate = datetime0.date;
  taxis->vtime = datetime0.time;

  vlistID = streamInqVlist(streamID);
  vlistDefTaxis(vlistID, taxisID);

  cdiCheckContents(streamID);

  nrecords = streams[streamID].tsteps[0].nallrecs;
  if ( nrecords < streams[streamID].tsteps[0].recordSize )
    {
      streams[streamID].tsteps[0].recordSize = nrecords;
      streams[streamID].tsteps[0].records =
	(RECORD *) realloc(streams[streamID].tsteps[0].records, nrecords*sizeof(RECORD));
    }

  streams[streamID].tsteps[0].recIDs = (int *) malloc(nrecords*sizeof(int));
  streams[streamID].tsteps[0].nrecs = nrecords;
  for ( recID = 0; recID < nrecords; recID++ )
    streams[streamID].tsteps[0].recIDs[recID] = recID;

  if ( streams[streamID].ntsteps == -1 )
    {
      tsID = tstepsNewEntry(streamID);
      if ( tsID != streams[streamID].rtsteps )
	Error(func, "Internal error. tsID = %d", tsID);

      streams[streamID].tsteps[tsID-1].next   = TRUE;
      streams[streamID].tsteps[tsID].position = recpos;
    }

  if ( streams[streamID].ntsteps == 1 )
    {
      if ( taxis->vdate == 0 && taxis->vtime == 0 )
	{
	  streams[streamID].ntsteps = 0;
	  for ( varID = 0; varID < streams[streamID].nvars; varID++ )
	    {
	      vlistDefVarTime(vlistID, varID, TIME_CONSTANT);
	    }
	}
    }
}

int srvScanTimestep2(int streamID)
{  
  static char func[] = "srvScanTimestep2";
  int header[8];
  int prec = 0;
  int irec;
  int fileID;
  int rxsize = 0, rysize = 0;
  int rcode = 0, rlevel = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  long levelcode, levelcode0 = 0;
  int tsID;
  int varID;
  long recsize;
  off_t recpos = 0;
  int nrecords, nrecs, recID, rindex;
  int taxisID = -1;
  int nextstep;
  TAXIS *taxis;
  int vlistID;

  streamCheckID(func, streamID);

  streams[streamID].curTsID = 1;

  fileID = streamInqFileID(streamID);
  vlistID = streamInqVlist(streamID);
  taxisID = vlistInqTaxis(vlistID);

  tsID = streams[streamID].rtsteps;
  if ( tsID != 1 )
    Error(func, "Internal problem! unexpeceted timestep %d", tsID+1);

  taxis = &streams[streamID].tsteps[tsID].taxis;

  fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);

  cdiCreateRecords(streamID, tsID);

  nrecords = streams[streamID].tsteps[0].nallrecs;
  streams[streamID].tsteps[1].recIDs = (int *) malloc(nrecords*sizeof(int));
  streams[streamID].tsteps[1].nrecs = 0;
  for ( recID = 0; recID < nrecords; recID++ )
    streams[streamID].tsteps[1].recIDs[recID] = -1;

  for ( recID = 0; recID < nrecords; recID++ )
    {
      varID = streams[streamID].tsteps[0].records[recID].varID;
      streams[streamID].tsteps[tsID].records[recID].position = 
	streams[streamID].tsteps[0].records[recID].position;
      streams[streamID].tsteps[tsID].records[recID].size     = 
	streams[streamID].tsteps[0].records[recID].size;
    }

  for ( rindex = 0; rindex <= nrecords; rindex++ )
    {
      recpos = fileGetPos(fileID);
      irec = srvReadHeader(fileID, header);
      if ( irec <= 0 )
	{
	  streams[streamID].ntsteps = 2;
	  break;
	}
      recsize = fileGetPos(fileID) - recpos;

      prec   = srvInqPrec(fileID);
      rcode  = header[0];
      rlevel = header[1];
      vdate  = header[2];
      vtime  = header[3];
      rxsize = header[4];
      rysize = header[5];

      if ( rindex == 0 )
	{
	  datetime0.date = vdate;
	  datetime0.time = vtime;
	  taxis->type  = TAXIS_ABSOLUTE;
	  taxis->vdate = vdate;
	  taxis->vtime = vtime;
	}
      else
	{
	  datetime.date = vdate;
	  datetime.time = vtime;
	}

      levelcode = rlevel*1000 + rcode;
      nextstep = FALSE;
      for ( recID = 0; recID < nrecords; recID++ )
	{
	  levelcode0 = streams[streamID].tsteps[tsID].records[recID].ilevel*1000 +
	               streams[streamID].tsteps[tsID].records[recID].code;
	  if ( levelcode == levelcode0 )
	    {
	      if ( streams[streamID].tsteps[tsID].records[recID].used )
		{
		  nextstep = TRUE;
		}
	      else
		{
		  streams[streamID].tsteps[tsID].records[recID].used = TRUE;
		  streams[streamID].tsteps[tsID].recIDs[rindex] = recID;
		}
	      break;
	    }
	}
      if ( recID == nrecords )
	{
	  Warning(func, "code %d level %d not found at timestep %d", rcode, rlevel, tsID+1);
	  return (CDI_EUFSTRUCT);
	}

      if ( nextstep ) break;

      if ( CDI_Debug )
	Message(func, "%4d%8d%4d%8d%8d%6d", rindex+1, (int)recpos, rcode, rlevel, vdate, vtime);

      streams[streamID].tsteps[tsID].records[recID].size = recsize;

      levelcode0 = streams[streamID].tsteps[tsID].records[recID].ilevel*1000 +
	           streams[streamID].tsteps[tsID].records[recID].code;

      if ( levelcode != levelcode0 )
	{
	  Message(func, "tsID = %d recID = %d code = %3d new %3d  level = %3d new %3d",
		  tsID, recID,
		  streams[streamID].tsteps[tsID].records[recID].code, rcode,
		  streams[streamID].tsteps[tsID].records[recID].ilevel, rlevel);
	  return (CDI_EUFSTRUCT);
	}

      streams[streamID].tsteps[1].records[recID].position = recpos;
    }

  nrecs = 0;
  for ( recID = 0; recID < nrecords; recID++ )
    {
      if ( ! streams[streamID].tsteps[tsID].records[recID].used )
	{
	  varID = streams[streamID].tsteps[tsID].records[recID].varID;
	  vlistDefVarTime(vlistID, varID, TIME_CONSTANT);
	}
      else
	{
	  nrecs++;
	}
    }
  streams[streamID].tsteps[tsID].nrecs = nrecs;

  streams[streamID].rtsteps = 2;

  if ( streams[streamID].ntsteps == -1 )
    {
      tsID = tstepsNewEntry(streamID);
      if ( tsID != streams[streamID].rtsteps )
	Error(func, "Internal error. tsID = %d", tsID);

      streams[streamID].tsteps[tsID-1].next   = TRUE;
      streams[streamID].tsteps[tsID].position = recpos;
    }

  return (0);
}

int srvInqContents(int streamID)
{
  static char func[] = "srvInqContents";
  int fileID;
  int status = 0;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);

  streams[streamID].curTsID = 0;

  srvScanTimestep1(streamID);
 
  if ( streams[streamID].ntsteps == -1 ) status = srvScanTimestep2(streamID);

  fileSetPos(fileID, 0, SEEK_SET);

  return (status);
}

int srvScanTimestep(int streamID)
{
  static char func[] = "srvScanTimestep";
  int header[8];
  int prec;
  int irec;
  int fileID;
  int tsID;
  int rxsize = 0, rysize = 0;
  int rcode = 0, rlevel = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  long levelcode, levelcode0 = 0;
  long recsize = 0;
  off_t recpos = 0;
  int recID;
  TAXIS *taxis;
  int rindex, nrecs = 0;

  streamCheckID(func, streamID);

  if ( CDI_Debug )
    {
      Message(func, "streamID = %d", streamID);
      Message(func, "cts = %d", streams[streamID].curTsID);
      Message(func, "rts = %d", streams[streamID].rtsteps);
      Message(func, "nts = %d", streams[streamID].ntsteps);
    }

  if ( streams[streamID].rtsteps == 0 )
    Error(func, "Internal problem! Missing contents.");

  tsID  = streams[streamID].rtsteps;
  taxis = &streams[streamID].tsteps[tsID].taxis;

  if ( streams[streamID].tsteps[tsID].recordSize == 0 )
    {
      cdiCreateRecords(streamID, tsID);

      nrecs = streams[streamID].tsteps[1].nrecs;

      streams[streamID].tsteps[tsID].nrecs = nrecs;
      streams[streamID].tsteps[tsID].recIDs = (int *) malloc(nrecs*sizeof(int));
      for ( recID = 0; recID < nrecs; recID++ )
	streams[streamID].tsteps[tsID].recIDs[recID] = streams[streamID].tsteps[1].recIDs[recID];

      fileID = streamInqFileID(streamID);

      fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);

      for ( rindex = 0; rindex <= nrecs; rindex++ )
	{
	  recpos = fileGetPos(fileID);
	  irec = srvReadHeader(fileID, header);
	  if ( irec <= 0 )
	    {
	      streams[streamID].ntsteps = streams[streamID].rtsteps + 1;
	      break;
	    }
	  recsize = fileGetPos(fileID) - recpos;

	  prec = srvInqPrec(fileID);
	  rcode  = header[0];
	  rlevel = header[1];
	  vdate  = header[2];
	  vtime  = header[3];
	  rxsize = header[4];
	  rysize = header[5];

	  if ( rindex == nrecs ) break;
	  recID = streams[streamID].tsteps[tsID].recIDs[rindex];

	  if ( rindex == 0 )
	    {
	      datetime0.date = vdate;
	      datetime0.time = vtime;
	      taxis->type  = TAXIS_ABSOLUTE;
	      taxis->vdate = vdate;
	      taxis->vtime = vtime;
	    }
	  else
	    {
	      datetime.date = vdate;
	      datetime.time = vtime;
	    }
	  /*
	  srvCmpRecord(streamID, tsID, nrecs, recpos, rcode, rlevel, rxsize, rysize);
	  */
	  levelcode  = rlevel*1000 + rcode;
	  levelcode0 = streams[streamID].tsteps[tsID].records[recID].ilevel*1000 +
	               streams[streamID].tsteps[tsID].records[recID].code;

	  if ( levelcode != levelcode0 )
	    {
	      Message(func, "tsID = %d recID = %d code = %3d new %3d  level = %3d new %3d",
		      tsID, recID,
		      streams[streamID].tsteps[tsID].records[recID].code, rcode,
		      streams[streamID].tsteps[tsID].records[recID].ilevel, rlevel);
	      Error(func, "Invalid, unsupported or inconsistent record structure");
	    }

	  streams[streamID].tsteps[tsID].records[recID].position = recpos;
	  streams[streamID].tsteps[tsID].records[recID].size = recsize;

	  if ( CDI_Debug )
	    Message(func, "%4d%8d%4d%8d%8d%6d", rindex, (int)recpos, rcode, rlevel, vdate, vtime);
	}

      streams[streamID].rtsteps++;

      if ( streams[streamID].ntsteps != streams[streamID].rtsteps )
	{
	  tsID = tstepsNewEntry(streamID);
	  if ( tsID != streams[streamID].rtsteps )
	    Error(func, "Internal error. tsID = %d", tsID);

	  streams[streamID].tsteps[tsID-1].next   = 1;
	  streams[streamID].tsteps[tsID].position = recpos;
	}

      fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);
      streams[streamID].tsteps[tsID].position = recpos;
    }

  if ( nrecs > 0 && nrecs < streams[streamID].tsteps[tsID].nrecs )
    {
      Warning(func, "Incomplete timestep. Stop scanning at timestep %d.\n", tsID);
      streams[streamID].ntsteps = tsID;
    }

  return (streams[streamID].ntsteps);
}

int srvInqTimestep(int streamID, int tsID)
{
  static char func[] = "srvInqTimestep";
  int ntsteps, nrecs;

  streamCheckID(func, streamID);

  if ( tsID == 0 && streams[streamID].rtsteps == 0 )
    Error(func, "call to cdiInqContents missing");

  if ( CDI_Debug )
    Message(func, "tsID = %d rtsteps = %d", tsID, streams[streamID].rtsteps);
  
  ntsteps = UNDEFID;
  while ( ( tsID + 1 ) > streams[streamID].rtsteps && ntsteps == UNDEFID )
    ntsteps = srvScanTimestep(streamID);

  if ( tsID >= streams[streamID].ntsteps && streams[streamID].ntsteps != CDI_UNDEFID )
    {
      nrecs = 0;
    }
  else
    {
      streams[streamID].curTsID = tsID;
      nrecs = streams[streamID].tsteps[tsID].nrecs;
    }

  return (nrecs);
}

void srvReadVarDP(int streamID, int varID, double *data, int *nmiss)
{
  static char func[] = "srvReadVarDP";
  int vlistID, fileID;
  int levID, nlevs, gridID, gridsize;
  off_t recpos, currentfilepos;
  int header[8];
  int tsid;
  int recID;
  int i;
  double missval;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  nlevs    = streams[streamID].vars[varID].nlevs;
  missval  = vlistInqVarMissval(vlistID, varID);
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  tsid     = streams[streamID].curTsID;

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d", nlevs, gridID, gridsize);

  currentfilepos = fileGetPos(fileID);

  for (levID = 0; levID < nlevs; levID++)
    {
      recID = streams[streamID].vars[varID].level[levID];
      recpos = streams[streamID].tsteps[tsid].records[recID].position;
      fileSetPos(fileID, recpos, SEEK_SET);
      srvReadHeader(fileID, header);
      srvReadDataDP(fileID, &data[levID*gridsize]);
    }
  fileSetPos(fileID, currentfilepos, SEEK_SET);

  *nmiss = 0;
  for ( i = 0; i < nlevs*gridsize; i++ )
    if ( data[i] == missval || data[i] == (float)missval )
      {
	data[i] = missval;
	(*nmiss)++;
      }
}

void srvReadVarSliceDP(int streamID, int varID, int levID, double *data, int *nmiss)
{
  static char func[] = "srvReadVarSliceDP";
  int vlistID, fileID;
  int nlevs, gridID, gridsize;
  off_t recpos, currentfilepos;
  int header[8];
  int tsid;
  int recID;
  int i;
  double missval;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  nlevs    = streams[streamID].vars[varID].nlevs;
  missval  = vlistInqVarMissval(vlistID, varID);
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  tsid     = streams[streamID].curTsID;

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d",
	     nlevs, gridID, gridsize);

  currentfilepos = fileGetPos(fileID);

  recID = streams[streamID].vars[varID].level[levID];
  recpos = streams[streamID].tsteps[tsid].records[recID].position;
  fileSetPos(fileID, recpos, SEEK_SET);
  srvReadHeader(fileID, header);
  srvReadDataDP(fileID, data);

  fileSetPos(fileID, currentfilepos, SEEK_SET);

  *nmiss = 0;
  for ( i = 0; i < gridsize; i++ )
    if ( data[i] == missval || data[i] == (float)missval )
      {
	data[i] = missval;
	(*nmiss)++;
      }
}

void srvWriteVarDP(int streamID, int varID, const double *data)
{
  static char func[] = "srvWriteVarDP";
  int fileID;
  int levID, nlevs, gridID, gridsize;
  int zaxisID;
  double level;
  int header[8];
  int datatype;
  int tsID;
  int vlistID;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  tsID     = streams[streamID].curTsID;
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);
  nlevs    = zaxisInqSize(zaxisID);

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d", nlevs, gridID, gridsize);

  header[0] = vlistInqVarCode(vlistID, varID);
  header[2] = streams[streamID].tsteps[tsID].taxis.vdate;
  header[3] = streams[streamID].tsteps[tsID].taxis.vtime;
  header[4] = gridInqXsize(gridID);
  header[5] = gridInqYsize(gridID);
  if ( header[4] == 0 )
    {
      header[4] = gridInqSize(gridID);
      header[5] = 1;
    }
  header[6] = 0;
  header[7] = 0;

  datatype = vlistInqVarDatatype(vlistID, varID);

  srvDefPrec(fileID, srvDefDatatype(datatype));

  for ( levID = 0;  levID < nlevs; levID++ )
    {
      level = zaxisInqLevel(zaxisID, levID);

      header[1] = (int) level;
      srvWriteHeader(fileID, header);
      srvWriteDataDP(fileID, &data[levID*gridsize]);
    }
}

void srvWriteVarSliceDP(int streamID, int varID, int levID, const double *data)
{
  static char func[] = "srvWriteVarSliceDP";
  int fileID;
  int nlevs, gridID;
  int zaxisID;
  double level;
  int header[8];
  int datatype;
  int tsID;
  int vlistID;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  tsID     = streams[streamID].curTsID;
  nlevs    = streams[streamID].vars[varID].nlevs;
  gridID   = vlistInqVarGrid(vlistID, varID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);
  level    = zaxisInqLevel(zaxisID, levID);

  if ( CDI_Debug )
    Message(func, "gridID = %d zaxisID = %d", gridID, zaxisID);

  header[0] = vlistInqVarCode(vlistID, varID);
  header[1] = (int) level;
  header[2] = streams[streamID].tsteps[tsID].taxis.vdate;
  header[3] = streams[streamID].tsteps[tsID].taxis.vtime;
  header[4] = gridInqXsize(gridID);
  header[5] = gridInqYsize(gridID);
  if ( header[4] == 0 )
    {
      header[4] = gridInqSize(gridID);
      header[5] = 1;
    }
  header[6] = 0;
  header[7] = 0;

  datatype = vlistInqVarDatatype(vlistID, varID);

  srvDefPrec(fileID, srvDefDatatype(datatype));

  srvWriteHeader(fileID, header);
  srvWriteDataDP(fileID, data);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID

#define SINGLE_PRECISION  4
#define DOUBLE_PRECISION  8

int extInqDatatype(int prec)
{
  int datatype;

  if ( prec == DOUBLE_PRECISION ) datatype = DATATYPE_REAL8;
  else                            datatype = DATATYPE_REAL4;

  return (datatype);
}

int extDefDatatype(int datatype)
{
  int prec;

  if ( datatype != DATATYPE_REAL4 && datatype != DATATYPE_REAL8 )
    datatype = DATATYPE_REAL4;

  if ( datatype == DATATYPE_REAL8 ) prec = DOUBLE_PRECISION;
  else                              prec = SINGLE_PRECISION;

  return (prec);
}

int extInqRecord(int streamID, int *varID, int *levelID)
{
  static char func[] = "extInqRecord";
  int ierr = 0;
  int fileID;
  int icode, ilevel, idate, idimx, idimy;
  int gridID = -1, zaxisID = -1;
  int extheader[4];
  int xsize, ysize;
  int vlistID;

  streamCheckID(func, streamID);

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);

  *varID   = -1;
  *levelID = -1;

  ierr = extReadHeader(fileID, extheader);

  if ( ierr == 0 ) return (0);

  idate  = extheader[0];
  icode  = extheader[1];
  ilevel = extheader[2];
  idimx  = extheader[3];
  idimy  = 1;

  *varID = vlistInqVarID(vlistID, icode);

  if ( *varID == UNDEFID ) Error(func, "code %d undefined", icode);

  gridID  = vlistInqVarGrid(vlistID, *varID);
  zaxisID = vlistInqVarZaxis(vlistID, *varID);

  xsize = gridInqXsize(gridID);
  ysize = gridInqYsize(gridID);

  *levelID = zaxisInqLevelID(zaxisID, (double) ilevel);
  
  ierr = 1;

  return (ierr);
}

int extReadRecord(int streamID, double *data, int *nmiss)
{
  static char func[] = "extReadRecord";
  int vlistID, fileID;
  int ierr;
  int recID, vrecID, tsID;
  off_t recpos;
  int header[4];
  int varID, gridID;
  int i, size;
  double missval;

  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);
  tsID    = streams[streamID].curTsID;
  vrecID  = streams[streamID].tsteps[tsID].curRecID;
  recID   = streams[streamID].tsteps[tsID].recIDs[vrecID];
  recpos  = streams[streamID].tsteps[tsID].records[recID].position;
  varID   = streams[streamID].tsteps[tsID].records[recID].varID;

  fileSetPos(fileID, recpos, SEEK_SET);

  extReadHeader(fileID, header);

  ierr = extReadDataDP(fileID, data);

  gridID  = vlistInqVarGrid(vlistID, varID);
  size    = gridInqSize(gridID);
  missval = vlistInqVarMissval(vlistID, varID);

  *nmiss = 0;
  for ( i = 0; i < size; i++ )
    if ( data[i] == missval || data[i] == (float)missval )
      {
	data[i] = missval;
	(*nmiss)++;
      }

  return (ierr);
}

int extCopyRecord(int ostreamID, int istreamID)
{
  static char func[] = "extCopyRecord";
  int ifileID, ofileID;
  int tsID, recID, vrecID;
  long recsize;
  off_t recpos;
  int ierr = 0;
  char *buffer;

  streamCheckID(func, istreamID);
  streamCheckID(func, ostreamID);

  ifileID = streamInqFileID(istreamID);
  ofileID = streamInqFileID(ostreamID);

  tsID    = streams[istreamID].curTsID;
  vrecID  = streams[istreamID].tsteps[tsID].curRecID;
  recID   = streams[istreamID].tsteps[tsID].recIDs[vrecID];
  recpos  = streams[istreamID].tsteps[tsID].records[recID].position;
  recsize = streams[istreamID].tsteps[tsID].records[recID].size;

  fileSetPos(ifileID, recpos, SEEK_SET);

  buffer = (char *) malloc(recsize);

  fileRead(ifileID, buffer, recsize);

  fileWrite(ofileID, buffer, recsize);

  free(buffer);

  return (ierr);
}

int extDefRecord(int streamID)
{
  static char func[] = "extDefRecord";
  int fileID;
  int gridID;
  int header[4];
  int ierr = 0;
  int datatype;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);
  gridID = streams[streamID].record->gridID;

  header[0] = streams[streamID].record->date;
  header[1] = streams[streamID].record->code;
  header[2] = streams[streamID].record->level;
  header[3] = gridInqSize(gridID);

  datatype = streams[streamID].record->prec;

  extDefPrec(fileID, extDefDatatype(datatype));

  extWriteHeader(fileID, header);

  return (ierr);
}

int extWriteRecord(int streamID, const double *data)
{
  static char func[] = "extWriteRecord";
  int fileID;
  int ierr = 0;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);

  extWriteDataDP(fileID, data);

  return (ierr);
}

void extAddRecord(int streamID, int code, int level, int xysize,
		  long recsize, off_t position, int prec)
{
  static char func[] = "extAddRecord";
  int leveltype;
  int gridID = UNDEFID;
  int levelID = 0;
  int tsID, recID, varID;
  int datatype;
  RECORD *record;
  GRID grid;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  tsID    = streams[streamID].curTsID;
  recID   = recordNewEntry(streamID, tsID);
  record  = &streams[streamID].tsteps[tsID].records[recID];

  (*record).size     = recsize;
  (*record).position = position;
  (*record).code     = code;
  (*record).ilevel   = level;

  memset(&grid, 0, sizeof(GRID));
  grid.type  = GRID_GENERIC;
  grid.size  = xysize;
  grid.xsize = xysize;
  grid.ysize = 0;
  grid.xvals = NULL;
  grid.yvals = NULL;
  gridID = varDefGrid(vlistID, grid, 0);
  /*
  if ( level == 0 ) leveltype = ZAXIS_SURFACE;
  else              leveltype = ZAXIS_GENERIC;
  */
  leveltype = ZAXIS_GENERIC;

  datatype = extInqDatatype(prec);

  varAddRecord(recID, code, gridID, leveltype, 0, level, 0,
	       datatype, &varID, &levelID, 0, 0);

  (*record).varID   = varID;
  (*record).levelID = levelID;

  streams[streamID].tsteps[tsID].nallrecs++;
  streams[streamID].nrecs++;

  if ( CDI_Debug )
    Message(func, "varID = %d gridID = %d levelID = %d",
	    varID, gridID, levelID);
}

void extCmpRecord(int streamID, int tsID, int recID, off_t position, int code,
		  int level, int xysize)
{
  static char func[] = "extCmpRecord";
  int varID = 0;
  int levelID = 0;
  RECORD *record;

  record  = &streams[streamID].tsteps[tsID].records[recID];

  if ( code != (*record).code || level != (*record).ilevel )
    Error(func, "inconsistent timestep");

  (*record).position = position;
  /*
  varID   = (*record).varID;
  levelID = (*record).levelID;

  streams[streamID].vars[varID].level[levelID] = recID;

  streams[streamID].tsteps[tsID].nallrecs++;
  streams[streamID].nrecs++;
  */
  if ( CDI_Debug )
    Message(func, "varID = %d levelID = %d", varID, levelID);
}

void extScanTimestep1(int streamID)
{  
  static char func[] = "extScanTimestep1";
  int header[4];
  int prec = 0;
  int irec;
  int fileID;
  int rxysize = 0;
  int rcode = 0, rlevel = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  long levelcode, levelcode0 = 0;
  int tsID;
  int varID;
  long recsize;
  off_t recpos;
  int nrecords, nrecs, recID;
  int taxisID = -1;
  TAXIS *taxis;
  int vlistID;

  streamCheckID(func, streamID);

  streams[streamID].curTsID = 0;

  tsID  = tstepsNewEntry(streamID);
  taxis = &streams[streamID].tsteps[tsID].taxis;

  if ( tsID != 0 )
    Error(func, "Internal problem! tstepsNewEntry returns %d", tsID);

  fileID = streamInqFileID(streamID);

  nrecs = 0;
  while ( TRUE )
    {
      recpos = fileGetPos(fileID);
      irec = extReadHeader(fileID, header);
      if ( irec <= 0 )
	{
	  streams[streamID].ntsteps = 1;
	  break;
	}
      recsize = fileGetPos(fileID) - recpos;

      prec   = extInqPrec(fileID);
      vdate  = header[0];
      vtime  = 0;
      rcode  = header[1];
      rlevel = header[2];
      rxysize = header[3];

      if ( nrecs == 0 )
	{
	  datetime0.date = vdate;
	  datetime0.time = vtime;
	}
      else
	{
	  datetime.date = vdate;
	  datetime.time = vtime;
	  levelcode = rlevel*1000 + rcode;
	  for ( recID = 0; recID < nrecs; recID++ )
	    {
	      levelcode0 = streams[streamID].tsteps[0].records[recID].ilevel*1000 +
	 	           streams[streamID].tsteps[0].records[recID].code;
	      if ( levelcode == levelcode0 ) break;
	    }
	  if ( recID < nrecs ) break;
	  if ( memcmp(&datetime, &datetime0, sizeof(DateTime)) )
	    Warning(func, "Inconsistent verification time for code %d level %d", rcode, rlevel);
	}

      nrecs++;

      if ( CDI_Debug )
	Message(func, "%4d%8d%4d%8d%8d%6d", nrecs, (int)recpos, rcode, rlevel, vdate, vtime);

      extAddRecord(streamID, rcode, rlevel, rxysize, recsize, recpos, prec);
    }

  streams[streamID].rtsteps = 1;

  cdiGenVars(streamID);

  taxisID = taxisNew(TAXIS_ABSOLUTE);
  taxis->type  = TAXIS_ABSOLUTE;
  taxis->vdate = datetime0.date;
  taxis->vtime = datetime0.time;

  vlistID = streamInqVlist(streamID);
  vlistDefTaxis(vlistID, taxisID);

  cdiCheckContents(streamID);

  nrecords = streams[streamID].tsteps[0].nallrecs;
  if ( nrecords < streams[streamID].tsteps[0].recordSize )
    {
      streams[streamID].tsteps[0].recordSize = nrecords;
      streams[streamID].tsteps[0].records =
      (RECORD *) realloc(streams[streamID].tsteps[0].records, nrecords*sizeof(RECORD));
    }

  streams[streamID].tsteps[0].recIDs = (int *) malloc(nrecords*sizeof(int));
  streams[streamID].tsteps[0].nrecs = nrecords;
  for ( recID = 0; recID < nrecords; recID++ )
    streams[streamID].tsteps[0].recIDs[recID] = recID;

  if ( streams[streamID].ntsteps == -1 )
    {
      tsID = tstepsNewEntry(streamID);
      if ( tsID != streams[streamID].rtsteps )
	Error(func, "Internal error. tsID = %d", tsID);

      streams[streamID].tsteps[tsID-1].next   = TRUE;
      streams[streamID].tsteps[tsID].position = recpos;
    }

  if ( streams[streamID].ntsteps == 1 )
    {
      if ( taxis->vdate == 0 && taxis->vtime == 0 )
	{
	  streams[streamID].ntsteps = 0;
	  for ( varID = 0; varID < streams[streamID].nvars; varID++ )
	    {
	      vlistDefVarTime(vlistID, varID, TIME_CONSTANT);
	    }
	}
    }
}

int extScanTimestep2(int streamID)
{  
  static char func[] = "extScanTimestep2";
  int header[4];
  int prec = 0;
  int irec;
  int fileID;
  int rxysize = 0;
  int rcode = 0, rlevel = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  long levelcode, levelcode0 = 0;
  int tsID;
  int varID;
  long recsize;
  off_t recpos = 0;
  int nrecords, nrecs, recID, rindex;
  int taxisID = -1;
  int nextstep;
  TAXIS *taxis;
  int vlistID;

  streamCheckID(func, streamID);

  streams[streamID].curTsID = 1;

  fileID = streamInqFileID(streamID);
  vlistID = streamInqVlist(streamID);
  taxisID = vlistInqTaxis(vlistID);

  tsID = streams[streamID].rtsteps;
  if ( tsID != 1 )
    Error(func, "Internal problem! unexpeceted timestep %d", tsID+1);

  taxis = &streams[streamID].tsteps[tsID].taxis;

  fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);

  cdiCreateRecords(streamID, tsID);

  nrecords = streams[streamID].tsteps[0].nallrecs;
  streams[streamID].tsteps[1].recIDs = (int *) malloc(nrecords*sizeof(int));
  streams[streamID].tsteps[1].nrecs = 0;
  for ( recID = 0; recID < nrecords; recID++ )
    streams[streamID].tsteps[1].recIDs[recID] = -1;

  for ( recID = 0; recID < nrecords; recID++ )
    {
      varID = streams[streamID].tsteps[0].records[recID].varID;
      streams[streamID].tsteps[tsID].records[recID].position = 
	streams[streamID].tsteps[0].records[recID].position;
      streams[streamID].tsteps[tsID].records[recID].size     = 
	streams[streamID].tsteps[0].records[recID].size;
    }

  for ( rindex = 0; rindex <= nrecords; rindex++ )
    {
      recpos = fileGetPos(fileID);
      irec = extReadHeader(fileID, header);
      if ( irec <= 0 )
	{
	  streams[streamID].ntsteps = 2;
	  break;
	}
      recsize = fileGetPos(fileID) - recpos;

      prec   = extInqPrec(fileID);
      vdate  = header[0];
      vtime  = 0;
      rcode  = header[1];
      rlevel = header[2];
      rxysize = header[3];

      if ( rindex == 0 )
	{
	  datetime0.date = vdate;
	  datetime0.time = vtime;
	  taxis->type  = TAXIS_ABSOLUTE;
	  taxis->vdate = vdate;
	  taxis->vtime = vtime;
	}
      else
	{
	  datetime.date = vdate;
	  datetime.time = vtime;
	}

      levelcode = rlevel*1000 + rcode;
      nextstep = FALSE;
      for ( recID = 0; recID < nrecords; recID++ )
	{
	  levelcode0 = streams[streamID].tsteps[tsID].records[recID].ilevel*1000 +
	               streams[streamID].tsteps[tsID].records[recID].code;
	  if ( levelcode == levelcode0 )
	    {
	      if ( streams[streamID].tsteps[tsID].records[recID].used )
		{
		  nextstep = TRUE;
		}
	      else
		{
		  streams[streamID].tsteps[tsID].records[recID].used = TRUE;
		  streams[streamID].tsteps[tsID].recIDs[rindex] = recID;
		}
	      break;
	    }
	}
      if ( recID == nrecords )
	{
	  Warning(func, "code %d level %d not found at timestep %d", rcode, rlevel, tsID+1);
	  return (CDI_EUFSTRUCT);
	}

      if ( nextstep ) break;

      if ( CDI_Debug )
	Message(func, "%4d%8d%4d%8d%8d%6d", rindex+1, (int)recpos, rcode, rlevel, vdate, vtime);

      streams[streamID].tsteps[tsID].records[recID].size = recsize;

      levelcode0 = streams[streamID].tsteps[tsID].records[recID].ilevel*1000 +
	           streams[streamID].tsteps[tsID].records[recID].code;

      if ( levelcode != levelcode0 )
	{
	  Message(func, "tsID = %d recID = %d code = %3d new %3d  level = %3d new %3d",
		  tsID, recID,
		  streams[streamID].tsteps[tsID].records[recID].code, rcode,
		  streams[streamID].tsteps[tsID].records[recID].ilevel, rlevel);
	  return (CDI_EUFSTRUCT);
	}

      streams[streamID].tsteps[1].records[recID].position = recpos;
    }

  nrecs = 0;
  for ( recID = 0; recID < nrecords; recID++ )
    {
      if ( ! streams[streamID].tsteps[tsID].records[recID].used )
	{
	  varID = streams[streamID].tsteps[tsID].records[recID].varID;
	  vlistDefVarTime(vlistID, varID, TIME_CONSTANT);
	}
      else
	{
	  nrecs++;
	}
    }
  streams[streamID].tsteps[tsID].nrecs = nrecs;

  streams[streamID].rtsteps = 2;

  if ( streams[streamID].ntsteps == -1 )
    {
      tsID = tstepsNewEntry(streamID);
      if ( tsID != streams[streamID].rtsteps )
	Error(func, "Internal error. tsID = %d", tsID);

      streams[streamID].tsteps[tsID-1].next   = TRUE;
      streams[streamID].tsteps[tsID].position = recpos;
    }

  return (0);
}

int extInqContents(int streamID)
{
  static char func[] = "extInqContents";
  int fileID;
  int status = 0;

  streamCheckID(func, streamID);

  fileID = streamInqFileID(streamID);

  streams[streamID].curTsID = 0;

  extScanTimestep1(streamID);
 
  if ( streams[streamID].ntsteps == -1 ) status = extScanTimestep2(streamID);

  fileSetPos(fileID, 0, SEEK_SET);

  return (status);
}

int extScanTimestep(int streamID)
{
  static char func[] = "extScanTimestep";
  int header[4];
  int prec;
  int irec;
  int fileID;
  int tsID;
  int rxysize = 0;
  int rcode = 0, rlevel = 0, vdate = 0, vtime = 0;
  DateTime datetime, datetime0;
  long levelcode, levelcode0 = 0;
  long recsize = 0;
  off_t recpos = 0;
  int recID;
  TAXIS *taxis;
  int rindex, nrecs = 0;

  streamCheckID(func, streamID);

  if ( CDI_Debug )
    {
      Message(func, "streamID = %d", streamID);
      Message(func, "cts = %d", streams[streamID].curTsID);
      Message(func, "rts = %d", streams[streamID].rtsteps);
      Message(func, "nts = %d", streams[streamID].ntsteps);
    }

  if ( streams[streamID].rtsteps == 0 )
    Error(func, "Internal problem! Missing contents.");

  tsID  = streams[streamID].rtsteps;
  taxis = &streams[streamID].tsteps[tsID].taxis;

  if ( streams[streamID].tsteps[tsID].recordSize == 0 )
    {
      cdiCreateRecords(streamID, tsID);

      nrecs = streams[streamID].tsteps[1].nrecs;

      streams[streamID].tsteps[tsID].nrecs = nrecs;
      streams[streamID].tsteps[tsID].recIDs = (int *) malloc(nrecs*sizeof(int));
      for ( recID = 0; recID < nrecs; recID++ )
	streams[streamID].tsteps[tsID].recIDs[recID] = streams[streamID].tsteps[1].recIDs[recID];

      fileID = streamInqFileID(streamID);

      fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);

      for ( rindex = 0; rindex <= nrecs; rindex++ )
	{
	  recpos = fileGetPos(fileID);
	  irec = extReadHeader(fileID, header);
	  if ( irec <= 0 )
	    {
	      streams[streamID].ntsteps = streams[streamID].rtsteps + 1;
	      break;
	    }
	  recsize = fileGetPos(fileID) - recpos;

	  prec = extInqPrec(fileID);
	  vdate  = header[0];
	  vtime  = 0;
	  rcode  = header[1];
	  rlevel = header[2];
	  rxysize = header[3];

	  if ( rindex == nrecs ) break;
	  recID = streams[streamID].tsteps[tsID].recIDs[rindex];

	  if ( rindex == 0 )
	    {
	      datetime0.date = vdate;
	      datetime0.time = vtime;
	      taxis->type  = TAXIS_ABSOLUTE;
	      taxis->vdate = vdate;
	      taxis->vtime = vtime;
	    }
	  else
	    {
	      datetime.date = vdate;
	      datetime.time = vtime;
	    }
	  /*
	  extCmpRecord(streamID, tsID, nrecs, recpos, rcode, rlevel, rxysize);
	  */
	  levelcode  = rlevel*1000 + rcode;
	  levelcode0 = streams[streamID].tsteps[tsID].records[recID].ilevel*1000 +
	               streams[streamID].tsteps[tsID].records[recID].code;

	  if ( levelcode != levelcode0 )
	    {
	      Message(func, "tsID = %d recID = %d code = %3d new %3d  level = %3d new %3d",
		      tsID, recID,
		      streams[streamID].tsteps[tsID].records[recID].code, rcode,
		      streams[streamID].tsteps[tsID].records[recID].ilevel, rlevel);
	      Error(func, "Invalid, unsupported or inconsistent record structure");
	    }

	  streams[streamID].tsteps[tsID].records[recID].position = recpos;
	  streams[streamID].tsteps[tsID].records[recID].size = recsize;

	  if ( CDI_Debug )
	    Message(func, "%4d%8d%4d%8d%8d%6d", rindex, (int)recpos, rcode, rlevel, vdate, vtime);
	}

      streams[streamID].rtsteps++;

      if ( streams[streamID].ntsteps != streams[streamID].rtsteps )
	{
	  tsID = tstepsNewEntry(streamID);
	  if ( tsID != streams[streamID].rtsteps )
	    Error(func, "Internal error. tsID = %d", tsID);

	  streams[streamID].tsteps[tsID-1].next   = 1;
	  streams[streamID].tsteps[tsID].position = recpos;
	}

      fileSetPos(fileID, streams[streamID].tsteps[tsID].position, SEEK_SET);
      streams[streamID].tsteps[tsID].position = recpos;
    }

  if ( nrecs > 0 && nrecs < streams[streamID].tsteps[tsID].nrecs )
    {
      Warning(func, "Incomplete timestep. Stop scanning at timestep %d.\n", tsID);
      streams[streamID].ntsteps = tsID;
    }

  return (streams[streamID].ntsteps);
}

int extInqTimestep(int streamID, int tsID)
{
  static char func[] = "extInqTimestep";
  int ntsteps, nrecs;

  streamCheckID(func, streamID);

  if ( tsID == 0 && streams[streamID].rtsteps == 0 )
    Error(func, "call to cdiInqContents missing");

  if ( CDI_Debug )
    Message(func, "tsID = %d rtsteps = %d", tsID, streams[streamID].rtsteps);
  
  ntsteps = UNDEFID;
  while ( ( tsID + 1 ) > streams[streamID].rtsteps && ntsteps == UNDEFID )
    ntsteps = extScanTimestep(streamID);

  if ( tsID >= streams[streamID].ntsteps && streams[streamID].ntsteps != CDI_UNDEFID )
    {
      nrecs = 0;
    }
  else
    {
      streams[streamID].curTsID = tsID;
      nrecs = streams[streamID].tsteps[tsID].nrecs;
    }

  return (nrecs);
}

void extReadVarDP(int streamID, int varID, double *data, int *nmiss)
{
  static char func[] = "extReadVarDP";
  int vlistID, fileID;
  int levID, nlevs, gridID, gridsize;
  off_t recpos, currentfilepos;
  int header[4];
  int tsid;
  int recID;
  int i;
  double missval;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  nlevs    = streams[streamID].vars[varID].nlevs;
  missval  = vlistInqVarMissval(vlistID, varID);
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  tsid     = streams[streamID].curTsID;

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d", nlevs, gridID, gridsize);

  currentfilepos = fileGetPos(fileID);

  for (levID = 0; levID < nlevs; levID++)
    {
      recID = streams[streamID].vars[varID].level[levID];
      recpos = streams[streamID].tsteps[tsid].records[recID].position;
      fileSetPos(fileID, recpos, SEEK_SET);
      extReadHeader(fileID, header);
      extReadDataDP(fileID, &data[levID*gridsize]);
    }
  fileSetPos(fileID, currentfilepos, SEEK_SET);

  *nmiss = 0;
  for ( i = 0; i < nlevs*gridsize; i++ )
    if ( data[i] == missval || data[i] == (float)missval )
      {
	data[i] = missval;
	(*nmiss)++;
      }
}

void extReadVarSliceDP(int streamID, int varID, int levID, double *data, int *nmiss)
{
  static char func[] = "extReadVarSliceDP";
  int vlistID, fileID;
  int nlevs, gridID, gridsize;
  off_t recpos, currentfilepos;
  int header[4];
  int tsid;
  int recID;
  int i;
  double missval;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  nlevs    = streams[streamID].vars[varID].nlevs;
  missval  = vlistInqVarMissval(vlistID, varID);
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  tsid     = streams[streamID].curTsID;

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d",
	     nlevs, gridID, gridsize);

  currentfilepos = fileGetPos(fileID);

  recID = streams[streamID].vars[varID].level[levID];
  recpos = streams[streamID].tsteps[tsid].records[recID].position;
  fileSetPos(fileID, recpos, SEEK_SET);
  extReadHeader(fileID, header);
  extReadDataDP(fileID, data);

  fileSetPos(fileID, currentfilepos, SEEK_SET);

  *nmiss = 0;
  for ( i = 0; i < gridsize; i++ )
    if ( data[i] == missval || data[i] == (float)missval )
      {
	data[i] = missval;
	(*nmiss)++;
      }
}

void extWriteVarDP(int streamID, int varID, const double *data)
{
  static char func[] = "extWriteVarDP";
  int fileID;
  int levID, nlevs, gridID, gridsize;
  int zaxisID;
  double level;
  int header[4];
  int datatype;
  int tsID;
  int vlistID;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  tsID     = streams[streamID].curTsID;
  gridID   = vlistInqVarGrid(vlistID, varID);
  gridsize = gridInqSize(gridID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);
  nlevs    = zaxisInqSize(zaxisID);

  if ( CDI_Debug )
    Message(func, "nlevs = %d gridID = %d gridsize = %d", nlevs, gridID, gridsize);

  header[0] = streams[streamID].tsteps[tsID].taxis.vdate;
  header[1] = vlistInqVarCode(vlistID, varID);
  header[3] = gridInqSize(gridID);

  datatype = vlistInqVarDatatype(vlistID, varID);

  extDefPrec(fileID, extDefDatatype(datatype));

  for ( levID = 0;  levID < nlevs; levID++ )
    {
      level = zaxisInqLevel(zaxisID, levID);

      header[2] = (int) level;
      extWriteHeader(fileID, header);
      extWriteDataDP(fileID, &data[levID*gridsize]);
    }
}

void extWriteVarSliceDP(int streamID, int varID, int levID, const double *data)
{
  static char func[] = "extWriteVarSliceDP";
  int fileID;
  int nlevs, gridID;
  int zaxisID;
  double level;
  int header[4];
  int datatype;
  int tsID;
  int vlistID;

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);
  tsID     = streams[streamID].curTsID;
  nlevs    = streams[streamID].vars[varID].nlevs;
  gridID   = vlistInqVarGrid(vlistID, varID);
  zaxisID  = vlistInqVarZaxis(vlistID, varID);
  level    = zaxisInqLevel(zaxisID, levID);

  if ( CDI_Debug )
    Message(func, "gridID = %d zaxisID = %d", gridID, zaxisID);

  header[0] = streams[streamID].tsteps[tsID].taxis.vdate;
  header[1] = vlistInqVarCode(vlistID, varID);
  header[2] = (int) level;
  header[3] = gridInqSize(gridID);

  datatype = vlistInqVarDatatype(vlistID, varID);

  extDefPrec(fileID, extDefDatatype(datatype));

  extWriteHeader(fileID, header);
  extWriteDataDP(fileID, data);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#if  defined  (HAVE_LIBNETCDF)
#  include "netcdf.h"
#endif

#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID


void cdfDefTime(int streamID);
void cdfDefGlobalAtts(int streamID);
void cdfDefLocalAtts(int streamID);


#define  X_AXIS  1
#define  Y_AXIS  2
#define  Z_AXIS  3
#define  T_AXIS  4

typedef struct {
  int     ncvarid;
  int     dimtype;
  size_t  len;
  char    name[256];
}
NCDIM;

typedef struct {
  int      vartype;
  int      isvar;
  int      islon;
  int      islat;
  int      islev;
  int      warn;
  int      timeID;
  int      code;
  int      bounds;
  int      gridID;
  int      zaxisID;
  int      gridtype;
  int      zaxistype;
  int      xdim;
  int      ydim;
  int      zdim;
  int      xvarid;
  int      yvarid;
  int      zvarid;
  int      tvarid;
  int      varids[4];
  int      cellarea;
  int      calendar;
  int      tableID;
  int      truncation;
  int      defmiss;
  int      xtype;
  int      ndims;
  int      gmapid;
  int      dimids[8];
  int      dimtype[8];
  size_t   vlen;
  double  *vdata;
  double   missval;
  double   addoffset;
  double   scalefactor;
  char     name[256];
  char     longname[256];
  char     units[256];
}
NCVAR;


static void splitTimevalue(double timevalue, int timeunit, int *date, int *time)
{
  static char func[] = "splitTimevalue";
  int vdate = 0, vtime = 0;
  int hour, minute;

  if ( timeunit == TUNIT_HOUR )
    {
      timevalue /= 24;
      vdate = (int) timevalue;
      vtime = (int) ((timevalue - vdate)*1440 + 0.01);

      hour   = vtime / 60;
      minute = vtime - hour*60;
      vtime  = hour*100 + minute;
    }
  else if ( timeunit == TUNIT_DAY )
    {
      vdate = (int) timevalue;
      vtime = (int) ((timevalue - vdate)*1440 + 0.01);

      hour   = vtime / 60;
      minute = vtime - hour*60;
      vtime  = hour*100 + minute;
    }
  else if ( timeunit == TUNIT_MONTH )
    {
      vdate = (int) timevalue*100;
      vtime = 0;
    }
  else
    {
      Message(func, "Unsupported TIMEUNIT %s!", tunitNamePtr(timeunit));
    }

  *date = vdate;
  *time = vtime;
}

static int splitBasetime(char *timeunits, TAXIS *taxis)
{
  static char func[] = "splitBasetime";
  int len;
  char *ptu;
  int year, month, day;
  int hour = 0, minute = 0, second = 0;
  int timetype = TAXIS_ABSOLUTE;
  int rdate = -1, rtime = -1;
  int timeunit = -1;

  ptu = timeunits;
  len = strlen(timeunits);

  (*taxis).type = timetype;

  if      ( strncmp(ptu, "sec",    3) == 0 ) timeunit = TUNIT_SECOND;
  else if ( strncmp(ptu, "minute", 6) == 0 ) timeunit = TUNIT_MINUTE;
  else if ( strncmp(ptu, "hour",   4) == 0 ) timeunit = TUNIT_HOUR;
  else if ( strncmp(ptu, "day",    3) == 0 ) timeunit = TUNIT_DAY;
  else if ( strncmp(ptu, "month",  5) == 0 ) timeunit = TUNIT_MONTH;
  else if ( strncmp(ptu, "calendar_month", 14) == 0 ) timeunit = TUNIT_MONTH;
  else if ( strncmp(ptu, "year",   4) == 0 ) timeunit = TUNIT_YEAR;
  else
    {
      Message(func, "Unsupported TIMEUNIT %s!", ptu);
      return (1);
    }

  while ( ! isspace(*ptu) && *ptu != 0 ) ptu++;
  if ( *ptu )
    {
      while (   isspace(*ptu) ) ptu++;

      if ( strncmp(ptu, "as", 2) == 0 )
	timetype = TAXIS_ABSOLUTE;
      else if ( strncmp(ptu, "since", 5) == 0 )
	timetype = TAXIS_RELATIVE;

      while ( ! isspace(*ptu) && *ptu != 0 ) ptu++;
      if ( *ptu )
	{
	  while (   isspace(*ptu) ) ptu++;

	  if ( timetype == TAXIS_ABSOLUTE )
	    {
	      if ( strncmp(ptu, "%Y%m%d.%f", 9) != 0 && timeunit == TUNIT_DAY )
		{
		  Message(func, "Unsupported format %s for TIMEUNIT day!", ptu);
		  timeunit = -1;
		}
	      else if ( strncmp(ptu, "%Y%m.%f", 7) != 0 && timeunit == TUNIT_MONTH )
		{
		  Message(func, "Unsupported format %s for TIMEUNIT month!", ptu);
		  timeunit = -1;
		}
	    }
	  else if ( timetype == TAXIS_RELATIVE )
	    {
	      year = atoi(ptu);
	      while ( isdigit((int) *ptu) ) ptu++;
	      month = atoi(++ptu);
	      while ( isdigit((int) *ptu) ) ptu++;
	      day = atoi(++ptu);
	      while ( isdigit((int) *ptu) ) ptu++;

	      while ( isspace((int) *ptu) ) ptu++;

	      if ( *ptu )
		{
		  while ( ! isdigit((int) *ptu) ) ptu++;

		  hour = atoi(ptu);
		  while ( isdigit((int) *ptu) ) ptu++;
		  if ( *ptu == ':' )
		    {
		      ptu++;
		      minute = atoi(ptu);
		      while ( isdigit((int) *ptu) ) ptu++;
		      if ( *ptu == ':' )
			{
			  ptu++;
			  second = atoi(ptu);
			  if ( second != 0 )
			    Message(func, "Seconds not supported in time units!");
			}
		    }
		}

	      rdate = year*10000 + month*100 + day;
	      rtime = hour*100 + minute;
	      (*taxis).rdate = rdate;
	      (*taxis).rtime = rtime;
	    }
	}
    }

  (*taxis).type = timetype;
  (*taxis).unit = timeunit;

  if ( CDI_Debug )
    Message(func, "timetype = %d  unit = %d", timetype, timeunit);

  return (0);
}

#if  defined  (HAVE_LIBNETCDF)
int cdfInqDatatype(int xtype)
{
  int datatype;

  if      ( xtype == NC_BYTE  )  datatype = DATATYPE_INT1;
  else if ( xtype == NC_SHORT )  datatype = DATATYPE_INT2;
  else if ( xtype == NC_INT   )  datatype = DATATYPE_INT4;
  else if ( xtype == NC_FLOAT )  datatype = DATATYPE_REAL4;
  else                           datatype = DATATYPE_REAL8;

  return (datatype);
}
#endif

#if  defined  (HAVE_LIBNETCDF)
int cdfDefDatatype(int datatype)
{
  int xtype;

  if      ( datatype == DATATYPE_INT1  )  xtype = NC_BYTE;
  else if ( datatype == DATATYPE_INT2  )  xtype = NC_SHORT;
  else if ( datatype == DATATYPE_INT4  )  xtype = NC_INT;
  else if ( datatype == DATATYPE_REAL8 )  xtype = NC_DOUBLE;
  else                                    xtype = NC_FLOAT;

  return (xtype);
}
#endif

int cdfCopyRecord(int ostreamID, int istreamID)
{
  static char func[] = "cdfCopyRecord";
  double *data;
  size_t datasize;
  int itsID, otsID, irecID, orecID;
  int ivarID, gridID;
  int nmiss;
  int ierr = 0;
  int ivlistID, ovlistID;

  streamCheckID(func, istreamID);
  streamCheckID(func, ostreamID);

  ivlistID = streams[istreamID].vlistID;
  ovlistID = streams[ostreamID].vlistID;

  itsID = streams[istreamID].curTsID;
  otsID = streams[ostreamID].curTsID;

  irecID = streams[istreamID].tsteps[itsID].curRecID;
  orecID = streams[ostreamID].tsteps[otsID].curRecID;

  ivarID = streams[istreamID].tsteps[itsID].records[irecID].varID;

  gridID = vlistInqVarGrid(ivlistID, ivarID);

  datasize = gridInqSize(gridID);      

  data = (double *) malloc(datasize*sizeof(double));

  streamReadRecord(istreamID, data, &nmiss);
  streamWriteRecord(ostreamID, data, nmiss);

  free(data);

  return (ierr);
}
/* not used
int cdfInqRecord(int streamID, int *varID, int *levelID)
{
  static char func[] = "cdfInqRecord";
  int tsID, recID;

  streamCheckID(func, streamID);

  recID = streams[streamID].tsteps[0].curRecID++;
  printf("cdfInqRecord recID %d %d\n", recID, streams[streamID].tsteps[0].curRecID);
  printf("cdfInqRecord tsID %d\n", streams[streamID].curTsID);

  if ( streams[streamID].tsteps[0].curRecID >= 
       streams[streamID].tsteps[0].nrecs )
    {
      streams[streamID].tsteps[0].curRecID = 0;
    }

  *varID   = streams[streamID].tsteps[0].records[recID].varID;
  *levelID = streams[streamID].tsteps[0].records[recID].levelID;

  streams[streamID].record->varID   = *varID;
  streams[streamID].record->levelID = *levelID;

  if ( CDI_Debug )
    Message(func, "recID = %d  varID = %d  levelID = %d", recID, *varID, *levelID);
  
  return (recID+1);
}
*/
int cdfDefRecord(int streamID)
{
  static char func[] = "cdfDefRecord";
  int ierr = 0;

  if ( CDI_Debug )
    Message(func, "streamID = %d", streamID);

  streamCheckID(func, streamID);

  return (ierr);
}

void cdfWriteGridTraj(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  int tsID, fileID;
  int lonID, latID, gridindex;
  size_t index;
  double xlon, xlat;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  gridindex = vlistGridIndex(vlistID, gridID);
  lonID = streams[streamID].xdimID[gridindex];
  latID = streams[streamID].ydimID[gridindex];

  xlon = gridInqXval(gridID, 0);
  xlat = gridInqYval(gridID, 0);
  tsID = streams[streamID].curTsID;
  index = tsID;

  cdf_put_var1_double(fileID, lonID, &index, &xlon);
  cdf_put_var1_double(fileID, latID, &index, &xlat);
#endif
}

void cdfReadGridTraj(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  int tsID, fileID;
  int lonID, latID, gridindex;
  size_t index;
  double xlon, xlat;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  gridindex = vlistGridIndex(vlistID, gridID);
  lonID = streams[streamID].xdimID[gridindex];
  latID = streams[streamID].ydimID[gridindex];

  tsID = streams[streamID].curTsID;
  index = tsID;

  cdf_get_var1_double(fileID, lonID, &index, &xlon);
  cdf_get_var1_double(fileID, latID, &index, &xlat);

  gridDefXvals(gridID, &xlon);
  gridDefYvals(gridID, &xlat);
#endif
}

void cdfDefMissval(int streamID, int varID, int dtype)
{
#if  defined  (HAVE_LIBNETCDF)
  if ( streams[streamID].vars[varID].defmiss == FALSE )
    {
      int fileID;
      int ncvarid;
      double missval;
      int vlistID;
      int xtype;

      vlistID = streamInqVlist(streamID);
      fileID  = streamInqFileID(streamID);
      ncvarid = streams[streamID].vars[varID].ncvarid;
      missval = vlistInqVarMissval(vlistID, varID);
      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      xtype = cdfDefDatatype(dtype);

      cdf_put_att_double(fileID, ncvarid, "_FillValue", (nc_type) xtype, 1L, &missval);

      if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);

      streams[streamID].vars[varID].defmiss = TRUE;
    }
#endif
}

void cdfWriteRecord(int streamID, double *data, int nmiss)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfWriteRecord";
  int varID;
  int levelID;

  varID   = streams[streamID].record->varID;
  levelID = streams[streamID].record->levelID;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  cdfWriteVarSliceDP(streamID, varID, levelID, data, nmiss);
#endif
}

int cdfReadRecord(int streamID, double *data, int *nmiss)
{
  static char func[] = "cdfReadRecord";
  int ierr = 0;
  int levelID, varID, tsID, recID, vrecID;

  if ( CDI_Debug ) Message(func, "streamID = %d", streamID);

  tsID    = streams[streamID].curTsID;
  vrecID  = streams[streamID].tsteps[tsID].curRecID;
  recID   = streams[streamID].tsteps[tsID].recIDs[vrecID];
  varID   = streams[streamID].tsteps[tsID].records[recID].varID;
  levelID = streams[streamID].tsteps[tsID].records[recID].levelID;

  cdfReadVarSliceDP(streamID, varID, levelID, data, nmiss);

  return (ierr);
}

void cdfDefTimeValue(int streamID, int date, int time)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefTimeValue";
  int fileID, tsID;
  int hour, minute;
  double timevalue;
  int timevarid;
  size_t index;

  fileID = streamInqFileID(streamID);

  if ( CDI_Debug )
    Message(func, "streamID = %d, fileID = %d", streamID, fileID);

  tsID = streams[streamID].curTsID;

  hour   = time / 100;
  minute = time - hour*100;

  if ( streams[streamID].tsteps[0].taxis.type == TAXIS_ABSOLUTE )
    {
      if ( streams[streamID].tsteps[0].taxis.unit == TUNIT_MONTH )
	{
	  timevalue = date/100 + 0.5;
	}
      else
	timevalue = date + (hour*60 + minute)/1440.;
    }
  else
    timevalue = vtime2timeval(date, time, &streams[streamID].tsteps[0].taxis);

  if ( CDI_Debug )
    Message(func, "tsID = %d  timevalue = %f", tsID, timevalue);

  timevarid = streams[streamID].basetime.ncvarid;

  if ( streams[streamID].ncmode == 1 )
    {
      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  index = tsID;

  cdf_put_var1_double(fileID, timevarid, &index, &timevalue);
  /*
printf("fileID = %d %d %d %f\n", fileID, timevarid, index, timevalue);
  */
#endif
}

void cdfDefTimestep(int streamID, int tsID)
{
  int vdate, vtime;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  vdate = streams[streamID].tsteps[tsID].taxis.vdate;
  vtime = streams[streamID].tsteps[tsID].taxis.vtime;

  if ( vlistHasTime(vlistID) ) cdfDefTime(streamID);

  cdfDefTimeValue(streamID, vdate, vtime);
}

void cdfDefTime(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  int fileID;
  int varid;
  int dims[1];
  int year, month, day, hour, minute;
  char unitstring[80];
  TAXIS *taxis;

  if ( streams[streamID].basetime.ncvarid != UNDEFID ) return;

  fileID = streamInqFileID(streamID);

  if ( streams[streamID].ncmode == 0 ) streams[streamID].ncmode = 1;

  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

  cdf_def_dim(fileID, "time", NC_UNLIMITED, &streams[streamID].basetime.ncdimid);

  dims[0] = streams[streamID].basetime.ncdimid;
  cdf_def_var(fileID, "time", NC_DOUBLE, 1, dims, &varid);

  streams[streamID].basetime.ncvarid = varid;

  taxis = &streams[streamID].tsteps[0].taxis;

  if ( streams[streamID].tsteps[0].taxis.type == TAXIS_ABSOLUTE )
    {
      if ( streams[streamID].tsteps[0].taxis.unit == TUNIT_MONTH )
	sprintf(unitstring, "month as %s", "%Y%m.%f");
      else
	sprintf(unitstring, "day as %s", "%Y%m%d.%f");
    }
  else
    {
      int rdate, rtime;
      int timeunit;

      timeunit = (*taxis).unit;
      rdate  = (*taxis).rdate;
      rtime  = (*taxis).rtime;
      if ( rdate == -1 )
	{
	  rdate  = (*taxis).vdate;
	  rtime  = (*taxis).vtime;
	}
      year   =  rdate / 10000;
      month  = (rdate - year*10000) / 100;
      day    =  rdate - year*10000 - month*100;
      hour   =  rtime / 100;
      minute =  rtime - hour*100;
      sprintf(unitstring, "%s since %d-%02d-%02d %02d:%02d",
	      tunitNamePtr(timeunit), year, month, day, hour, minute);
    }

  cdf_put_att_text(fileID, varid, "units", strlen(unitstring), unitstring);

  if ( (*taxis).calendar != -1 )
    {
      if ( (*taxis).calendar == CALENDAR_NONE )
	cdf_put_att_text(fileID, varid, "calendar", 4, "none");
      else if ( (*taxis).calendar == CALENDAR_360DAYS )
	cdf_put_att_text(fileID, varid, "calendar", 7, "360_day");
      else if ( (*taxis).calendar == CALENDAR_365DAYS )
	cdf_put_att_text(fileID, varid, "calendar", 7, "365_day");
      else if ( (*taxis).calendar == CALENDAR_366DAYS )
	cdf_put_att_text(fileID, varid, "calendar", 7, "366_day");
    }

  if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);
#endif
}

void cdfDefComplex(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  char axisname[] = "complex";
  int index;
  int dimID = UNDEFID;
  int gridID0, gridtype0, gridindex;
  int ngrids;
  int fileID;
  int dimlen;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_SPECTRAL )
	    {
	      dimID = streams[streamID].xdimID[index];
	      break;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      dimlen = 2;

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void cdfDefSpc(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  /*
  char longname[] = "Spherical harmonic coefficient";
  */
  char axisname[5] = "spcX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID)/2;

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].ydimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_SPECTRAL )
	    {
	      dimlen0 = gridInqSize(gridID0)/2;
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].ydimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[3] = '\0';
      else           sprintf(&axisname[3], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].ydimID[gridindex] = dimID;

#endif
}

void cdfDefTrajLon(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefTrajLon";
  char units[256];
  char longname[256];
  char stdname[256];
  char axisname[256];
  int gridtype, gridindex;
  int dimID = UNDEFID;
  int fileID;
  int dimlen;
  size_t len;
  int ncvarid;
  int vlistID;
  int xtype = NC_DOUBLE;

  if ( gridInqPrec(gridID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  gridtype = gridInqType(gridID);
  dimlen = gridInqXsize(gridID);
  if ( dimlen != 1 ) Error(func, "Xsize isn't 1 for %s grid!", gridNamePtr(gridtype));

  gridindex = vlistGridIndex(vlistID, gridID);
  ncvarid = streams[streamID].xdimID[gridindex];

  gridInqXname(gridID, axisname);
  gridInqXlongname(gridID, longname);
  gridInqXstdname(gridID, stdname);
  gridInqXunits(gridID, units);

  if ( ncvarid == UNDEFID )
    {
      dimID = streams[streamID].basetime.ncvarid;

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_var(fileID, axisname, (nc_type) xtype, 1, &dimID, &ncvarid);
      if ( (len = strlen(longname)) )
	cdf_put_att_text(fileID, ncvarid, "long_name", len, longname);
      if ( (len = strlen(units)) )
	cdf_put_att_text(fileID, ncvarid, "units", len, units);
      if ( (len = strlen(stdname)) )
	cdf_put_att_text(fileID, ncvarid, "standard_name", len, stdname);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  streams[streamID].xdimID[gridindex] = ncvarid; /* var ID for trajectory !!! */

#endif
}

void cdfDefTrajLat(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefTrajLat";
  char units[] = "degrees_north";
  char longname[] = "latitude";
  char stdname[] = "latitude";
  char axisname[] = "tlat";
  int gridtype, gridindex;
  int dimID = UNDEFID;
  int fileID;
  int dimlen;
  size_t len;
  int ncvarid;
  int vlistID;
  int xtype = NC_DOUBLE;

  if ( gridInqPrec(gridID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID = streamInqFileID(streamID);

  gridtype = gridInqType(gridID);
  dimlen = gridInqYsize(gridID);
  if ( dimlen != 1 ) Error(func, "Ysize isn't 1 for %s grid!", gridNamePtr(gridtype));

  gridindex = vlistGridIndex(vlistID, gridID);
  ncvarid = streams[streamID].ydimID[gridindex];

  gridInqYname(gridID, axisname);
  gridInqYlongname(gridID, longname);
  gridInqYstdname(gridID, stdname);
  gridInqYunits(gridID, units);

  if ( ncvarid == UNDEFID )
    {
      dimID = streams[streamID].basetime.ncvarid;

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_var(fileID, axisname, (nc_type) xtype, 1, &dimID, &ncvarid);
      if ( (len = strlen(longname)) )
	cdf_put_att_text(fileID, ncvarid, "long_name", len, longname);
      if ( (len = strlen(units)) )
	cdf_put_att_text(fileID, ncvarid, "units", len, units);
      if ( (len = strlen(stdname)) )
	cdf_put_att_text(fileID, ncvarid, "standard_name", len, stdname);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  streams[streamID].ydimID[gridindex] = ncvarid; /* var ID for trajectory !!! */

#endif
}

void cdfDefXaxis(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefXaxis";
  char units[256];
  char longname[256];
  char stdname[256];
  char axisname[256];
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int dimIDs[2];
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  size_t len;
  int ncvarid = UNDEFID, ncbvarid = UNDEFID;
  int nvertex = 2, nvdimID = -1;
  int vlistID;
  int xtype = NC_DOUBLE;

  if ( gridInqPrec(gridID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqXsize(gridID);
  gridindex = vlistGridIndex(vlistID, gridID);

  gridInqXname(gridID, axisname);
  gridInqXlongname(gridID, longname);
  gridInqXstdname(gridID, stdname);
  gridInqXunits(gridID, units);

  if ( axisname[0] == 0 ) Error(func, "axis name undefined!\n");

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN    ||
	       gridtype0 == GRID_LONLAT      ||
	       gridtype0 == GRID_CURVILINEAR ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqXsize(gridID0);
	      if ( dimlen == dimlen0 )
		if ( gridInqXval(gridID0, 0) == gridInqXval(gridID, 0) &&
		     gridInqXval(gridID0, dimlen-1) == gridInqXval(gridID, dimlen-1) )
		  {
		    dimID = streams[streamID].xdimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].xdimID[index] == streams[streamID].xdimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz ) sprintf(&axisname[strlen(axisname)], "_%d", iz+1);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      if ( gridInqXboundsPtr(gridID) || gridInqYboundsPtr(gridID) )
	cdf_def_dim(fileID, "nv", nvertex, &nvdimID);

      if ( gridInqXvalsPtr(gridID) )
	{
	  cdf_def_var(fileID, axisname, (nc_type) xtype, 1, &dimID, &ncvarid);
	  if ( (len = strlen(longname)) )
	    cdf_put_att_text(fileID, ncvarid, "long_name", len, longname);
	  if ( (len = strlen(units)) )
	    cdf_put_att_text(fileID, ncvarid, "units", len, units);
	  if ( (len = strlen(stdname)) )
	    cdf_put_att_text(fileID, ncvarid, "standard_name", len, stdname);

	  if ( gridInqXboundsPtr(gridID) )
	    {
	      strcat(axisname, "_bounds");
	      dimIDs[0] = dimID;
	      dimIDs[1] = nvdimID;
	      cdf_def_var(fileID, axisname, (nc_type) xtype, 2, dimIDs, &ncbvarid);
	      cdf_put_att_text(fileID, ncvarid, "bounds", strlen(axisname), axisname);
	    }

	  /*
	  if ( gridIsRotated(gridID) )
	    {
	      double north_pole = gridInqXpole(gridID);
	      cdf_put_att_double(fileID, ncvarid, "north_pole", NC_DOUBLE, 1L, &north_pole);
	    }
	  */
	}

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( ncvarid  != UNDEFID ) cdf_put_var_double(fileID, ncvarid, gridInqXvalsPtr(gridID));
      if ( ncbvarid != UNDEFID ) cdf_put_var_double(fileID, ncbvarid, gridInqXboundsPtr(gridID));
    }

  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void cdfDefYaxis(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefYaxis";
  char units[256];
  char longname[256];
  char stdname[256];
  char axisname[256];
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int dimIDs[2];
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  size_t len;
  int ncvarid = UNDEFID, ncbvarid = UNDEFID;
  int nvdimID = -1;
  int vlistID;
  int xtype = NC_DOUBLE;

  if ( gridInqPrec(gridID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqYsize(gridID);
  gridindex = vlistGridIndex(vlistID, gridID);

  gridInqYname(gridID, axisname);
  gridInqYlongname(gridID, longname);
  gridInqYstdname(gridID, stdname);
  gridInqYunits(gridID, units);

  if ( axisname[0] == 0 ) Error(func, "axis name undefined!\n");

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].ydimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN    ||
	       gridtype0 == GRID_LONLAT      ||
	       gridtype0 == GRID_CURVILINEAR ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqYsize(gridID0);
	      if ( dimlen == dimlen0 )
		if ( gridInqYval(gridID0, 0) == gridInqYval(gridID, 0) &&
		     gridInqYval(gridID0, dimlen-1) == gridInqYval(gridID, dimlen-1) )
		  {
		    dimID = streams[streamID].ydimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].ydimID[index] == streams[streamID].ydimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz ) sprintf(&axisname[strlen(axisname)], "_%d", iz+1);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      if ( gridInqXboundsPtr(gridID) || gridInqYboundsPtr(gridID) )
	cdf_inq_dimid(fileID, "nv", &nvdimID);

      if ( gridInqYvalsPtr(gridID) )
	{
	  cdf_def_var(fileID, axisname, (nc_type) xtype, 1, &dimID, &ncvarid);
	  if ( (len = strlen(longname)) )
	    cdf_put_att_text(fileID, ncvarid, "long_name", len, longname);
	  if ( (len = strlen(units)) )
	    cdf_put_att_text(fileID, ncvarid, "units", len, units);
	  if ( (len = strlen(stdname)) )
	    cdf_put_att_text(fileID, ncvarid, "standard_name", len, stdname);

	  if ( gridInqYboundsPtr(gridID) )
	    {
	      strcat(axisname, "_bounds");
	      dimIDs[0] = dimID;
	      dimIDs[1] = nvdimID;
	      cdf_def_var(fileID, axisname, (nc_type) xtype, 2, dimIDs, &ncbvarid);
	      cdf_put_att_text(fileID, ncvarid, "bounds", strlen(axisname), axisname);
	    }
	  /*
	  if ( gridIsRotated(gridID) )
	    {
	      double north_pole = gridInqYpole(gridID);
	      cdf_put_att_double(fileID, ncvarid, "north_pole", NC_DOUBLE, 1L, &north_pole);
	    }
	  */
	}

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( ncvarid  != UNDEFID ) cdf_put_var_double(fileID, ncvarid, gridInqYvalsPtr(gridID));
      if ( ncbvarid != UNDEFID ) cdf_put_var_double(fileID, ncbvarid, gridInqYboundsPtr(gridID));
    }

  streams[streamID].ydimID[gridindex] = dimID;

#endif
}

void cdfDefLonLat2D(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  char xunits[256];
  char xlongname[256];
  char xstdname[256];
  char yunits[256];
  char ylongname[256];
  char ystdname[256];
  char xaxisname[256];
  char yaxisname[256];
  char xdimname[4] = "x";
  char ydimname[4] = "y";
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int xdimID = UNDEFID;
  int ydimID = UNDEFID;
  int dimIDs[3];
  int ngrids;
  int fileID;
  int xdimlen, ydimlen, dimlen0;
  size_t len;
  int ncxvarid = UNDEFID, ncyvarid = UNDEFID;
  int ncbxvarid = UNDEFID, ncbyvarid = UNDEFID, ncavarid = UNDEFID;
  int nvertex = 4, nvdimID = -1;
  int vlistID;
  int xtype = NC_DOUBLE;

  if ( gridInqPrec(gridID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  xdimlen = gridInqXsize(gridID);
  ydimlen = gridInqYsize(gridID);
  gridindex = vlistGridIndex(vlistID, gridID);

  gridInqXname(gridID, xaxisname);
  gridInqXlongname(gridID, xlongname);
  gridInqXstdname(gridID, xstdname);
  gridInqXunits(gridID, xunits);
  gridInqYname(gridID, yaxisname);
  gridInqYlongname(gridID, ylongname);
  gridInqYstdname(gridID, ystdname);
  gridInqYunits(gridID, yunits);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN    ||
	       gridtype0 == GRID_LONLAT      ||
	       gridtype0 == GRID_CURVILINEAR ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqXsize(gridID0);
	      if ( xdimlen == dimlen0 )
		if ( gridInqXval(gridID0, 0) == gridInqXval(gridID, 0) &&
		     gridInqXval(gridID0, xdimlen-1) == gridInqXval(gridID, xdimlen-1) )
		  {
		    xdimID = streams[streamID].xdimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].xdimID[index] == streams[streamID].xdimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( xdimID == UNDEFID )
    {
      if ( iz )
	{
	  sprintf(&xaxisname[strlen(xaxisname)], "_%d", iz+1);
	  sprintf(&yaxisname[strlen(yaxisname)], "_%d", iz+1);
	  sprintf(&xdimname[1], "_%d", iz+1);
	  sprintf(&ydimname[1], "_%d", iz+1);
	}

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, xdimname, xdimlen, &xdimID);
      cdf_def_dim(fileID, ydimname, ydimlen, &ydimID);

      if ( gridInqXboundsPtr(gridID) || gridInqYboundsPtr(gridID) )
	cdf_def_dim(fileID, "nv", nvertex, &nvdimID);

      dimIDs[0] = ydimID;
      dimIDs[1] = xdimID;

      if ( gridInqXvalsPtr(gridID) )
	{
	  cdf_def_var(fileID, xaxisname, (nc_type) xtype, 2, dimIDs, &ncxvarid);
	  if ( (len = strlen(xlongname)) )
	    cdf_put_att_text(fileID, ncxvarid, "long_name", len, xlongname);
	  if ( (len = strlen(xunits)) )
	    cdf_put_att_text(fileID, ncxvarid, "units", len, xunits);
	  if ( (len = strlen(xstdname)) )
	    cdf_put_att_text(fileID, ncxvarid, "standard_name", len, xstdname);

	  streams[streamID].ncxvarID[gridindex] = ncxvarid;

	  if ( gridInqXboundsPtr(gridID) )
	    {
	      strcat(xaxisname, "_bounds");
	      dimIDs[0] = ydimID;
	      dimIDs[1] = xdimID;
	      dimIDs[2] = nvdimID;
	      cdf_def_var(fileID, xaxisname, (nc_type) xtype, 3, dimIDs, &ncbxvarid);
	      cdf_put_att_text(fileID, ncxvarid, "bounds", strlen(xaxisname), xaxisname);
	    }
	}

      if ( gridInqYvalsPtr(gridID) )
	{
	  cdf_def_var(fileID, yaxisname, (nc_type) xtype, 2, dimIDs, &ncyvarid);
	  if ( (len = strlen(ylongname)) )
	    cdf_put_att_text(fileID, ncyvarid, "long_name", len, ylongname);
	  if ( (len = strlen(yunits)) )
	    cdf_put_att_text(fileID, ncyvarid, "units", len, yunits);
	  if ( (len = strlen(ystdname)) )
	    cdf_put_att_text(fileID, ncyvarid, "standard_name", len, ystdname);

	  streams[streamID].ncyvarID[gridindex] = ncyvarid;

	  if ( gridInqYboundsPtr(gridID) )
	    {
	      strcat(yaxisname, "_bounds");
	      dimIDs[0] = ydimID;
	      dimIDs[1] = xdimID;
	      dimIDs[2] = nvdimID;
	      cdf_def_var(fileID, yaxisname, (nc_type) xtype, 3, dimIDs, &ncbyvarid);
	      cdf_put_att_text(fileID, ncyvarid, "bounds", strlen(yaxisname), yaxisname);
	    }
	}

      if ( gridInqAreaPtr(gridID) )
	{
	  char yaxisname[] = "cell_area";
	  char units[] = "m2";
	  char longname[] = "area of grid cell";
	  char stdname[] = "area";

	  cdf_def_var(fileID, yaxisname, (nc_type) xtype, 2, dimIDs, &ncavarid);
	  cdf_put_att_text(fileID, ncavarid, "long_name", strlen(longname), longname);
	  cdf_put_att_text(fileID, ncavarid, "standard_name", strlen(stdname), stdname);
	  cdf_put_att_text(fileID, ncavarid, "units", strlen(units), units);

	  streams[streamID].ncavarID[gridindex] = ncavarid;
	}

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( ncxvarid  != UNDEFID ) cdf_put_var_double(fileID, ncxvarid,  gridInqXvalsPtr(gridID));
      if ( ncbxvarid != UNDEFID ) cdf_put_var_double(fileID, ncbxvarid, gridInqXboundsPtr(gridID));
      if ( ncyvarid  != UNDEFID ) cdf_put_var_double(fileID, ncyvarid,  gridInqYvalsPtr(gridID));
      if ( ncbyvarid != UNDEFID ) cdf_put_var_double(fileID, ncbyvarid, gridInqYboundsPtr(gridID));
      if ( ncavarid  != UNDEFID ) cdf_put_var_double(fileID, ncavarid,  gridInqAreaPtr(gridID));
    }

  streams[streamID].xdimID[gridindex] = xdimID;
  streams[streamID].ydimID[gridindex] = ydimID;

#endif
}

void cdfDefRgrid(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  char axisname[7] = "rgridX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN_REDUCED )
	    {
	      dimlen0 = gridInqSize(gridID0);
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].xdimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[5] = '\0';
      else           sprintf(&axisname[5], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void cdfDefGdim(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  char axisname[7] = "gsizeX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID);

  if ( gridInqYsize(gridID) == 0 )
    for ( index = 0; index < ngrids; index++ )
      {
	if ( streams[streamID].xdimID[index] != UNDEFID )
	  {
	    gridID0 = vlistGrid(vlistID, index);
	    gridtype0 = gridInqType(gridID0);
	    if ( gridtype0 == GRID_GENERIC )
	      {
		dimlen0 = gridInqSize(gridID0);
		if ( dimlen == dimlen0 )
		  {
		    dimID = streams[streamID].xdimID[index];
		    break;
		  }
		else
		  iz++;	
	      }
	  }
      }

  if ( gridInqXsize(gridID) == 0 )
    for ( index = 0; index < ngrids; index++ )
      {
	if ( streams[streamID].ydimID[index] != UNDEFID )
	  {
	    gridID0 = vlistGrid(vlistID, index);
	    gridtype0 = gridInqType(gridID0);
	    if ( gridtype0 == GRID_GENERIC )
	      {
		dimlen0 = gridInqSize(gridID0);
		if ( dimlen == dimlen0 )
		  {
		    dimID = streams[streamID].ydimID[index];
		    break;
		  }
		else
		  iz++;	
	      }
	  }
      }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[5] = '\0';
      else           sprintf(&axisname[5], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void cdfDefCell(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  char axisname[6] = "cellX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int ncxvarid = UNDEFID, ncyvarid = UNDEFID;
  int ncbxvarid = UNDEFID, ncbyvarid = UNDEFID, ncavarid = UNDEFID;
  int nvertex, nvdimID = -1;
  int vlistID;
  int xtype = NC_DOUBLE;

  if ( gridInqPrec(gridID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID);
  gridindex = vlistGridIndex(vlistID, gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_CELL )
	    {
	      dimlen0 = gridInqSize(gridID0);
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].xdimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[4] = '\0';
      else           sprintf(&axisname[4], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, axisname, dimlen, &dimID);

      nvertex = gridInqNvertex(gridID);
      if ( nvertex > 0 ) cdf_def_dim(fileID, "nv", nvertex, &nvdimID);
	
      if ( gridInqXvalsPtr(gridID) )
	{
	  char xaxisname[] = "lon";
	  char units[] = "degrees_east";
	  char longname[] = "longitude";

	  cdf_def_var(fileID, xaxisname, (nc_type) xtype, 1, &dimID, &ncxvarid);
	  cdf_put_att_text(fileID, ncxvarid, "long_name", strlen(longname), longname);
	  cdf_put_att_text(fileID, ncxvarid, "units", strlen(units), units);

	  streams[streamID].ncxvarID[gridindex] = ncxvarid;

	  if ( nvdimID != UNDEFID && gridInqXboundsPtr(gridID) )
	    {
	      char bxaxisname[] = "lon_vertices";
	      int dimIDs[2];
	      dimIDs[0] = dimID;
	      dimIDs[1] = nvdimID;
	      cdf_def_var(fileID, bxaxisname, (nc_type) xtype, 2, dimIDs, &ncbxvarid);
	      cdf_put_att_text(fileID, ncxvarid, "bounds", strlen(bxaxisname), bxaxisname);
	    }
	}

      if ( gridInqYvalsPtr(gridID) )
	{
	  char yaxisname[] = "lat";
	  char units[] = "degrees_north";
	  char longname[] = "latitude";

	  cdf_def_var(fileID, yaxisname, (nc_type) xtype, 1, &dimID, &ncyvarid);
	  cdf_put_att_text(fileID, ncyvarid, "long_name", strlen(longname), longname);
	  cdf_put_att_text(fileID, ncyvarid, "units", strlen(units), units);

	  streams[streamID].ncyvarID[gridindex] = ncyvarid;

	  if ( nvdimID != UNDEFID && gridInqYboundsPtr(gridID) )
	    {
	      char byaxisname[] = "lat_vertices";
	      int dimIDs[2];
	      dimIDs[0] = dimID;
	      dimIDs[1] = nvdimID;
	      cdf_def_var(fileID, byaxisname, (nc_type) xtype, 2, dimIDs, &ncbyvarid);
	      cdf_put_att_text(fileID, ncyvarid, "bounds", strlen(byaxisname), byaxisname);
	    }
	}

      if ( gridInqAreaPtr(gridID) )
	{
	  char yaxisname[] = "cell_area";
	  char units[] = "m2";
	  char longname[] = "area of grid cell";
	  char stdname[] = "area";

	  cdf_def_var(fileID, yaxisname, (nc_type) xtype, 1, &dimID, &ncavarid);
	  cdf_put_att_text(fileID, ncavarid, "long_name", strlen(longname), longname);
	  cdf_put_att_text(fileID, ncavarid, "standard_name", strlen(stdname), stdname);
	  cdf_put_att_text(fileID, ncavarid, "units", strlen(units), units);

	  streams[streamID].ncavarID[gridindex] = ncavarid;
	}

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( ncxvarid  != UNDEFID ) cdf_put_var_double(fileID, ncxvarid,  gridInqXvalsPtr(gridID));
      if ( ncbxvarid != UNDEFID ) cdf_put_var_double(fileID, ncbxvarid, gridInqXboundsPtr(gridID));
      if ( ncyvarid  != UNDEFID ) cdf_put_var_double(fileID, ncyvarid,  gridInqYvalsPtr(gridID));
      if ( ncbyvarid != UNDEFID ) cdf_put_var_double(fileID, ncbyvarid, gridInqYboundsPtr(gridID));
      if ( ncavarid  != UNDEFID ) cdf_put_var_double(fileID, ncavarid,  gridInqAreaPtr(gridID));
    }

  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void cdfDefVCT(int streamID, int zaxisID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefVCT";
  int type;

  type = zaxisInqType(zaxisID);

  if ( type == ZAXIS_HYBRID )
    {
      int i;
      int fileID;
      int ilev = zaxisInqVctSize(zaxisID)/2;
      int mlev = ilev - 1;
      size_t start;
      size_t count = 1;      
      int ncdimid, ncdimid2;
      int ncvarid, ncvarid2;
      int hyaiid, hybiid, hyamid, hybmid;
      int *ilevels = (int *) malloc(ilev*sizeof(int));
      const double *vctptr = zaxisInqVctPtr(zaxisID);
      double mval;
      char tmpname[256];

      if ( streams[streamID].vct.ilev > 0 )
	{
	  if ( streams[streamID].vct.ilev != ilev )
	    Error(func, "more than one VCT for each file unsupported!");
	  return;
	}

      if ( ilev == 0 )
	{
	  Warning(func, "VCT missing");
	  return;
	}

      fileID = streamInqFileID(streamID);

      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

      cdf_def_dim(fileID, "mlev", mlev, &ncdimid);
      cdf_def_dim(fileID, "ilev", ilev, &ncdimid2);

      streams[streamID].vct.mlev   = mlev;
      streams[streamID].vct.ilev   = ilev;
      streams[streamID].vct.mlevID = ncdimid;
      streams[streamID].vct.ilevID = ncdimid2;

      cdf_def_var(fileID, "mlev", NC_INT,    1, &ncdimid,  &ncvarid);
      cdf_def_var(fileID, "ilev", NC_INT,    1, &ncdimid2, &ncvarid2);
      cdf_def_var(fileID, "hyai", NC_DOUBLE, 1, &ncdimid2, &hyaiid);
      cdf_def_var(fileID, "hybi", NC_DOUBLE, 1, &ncdimid2, &hybiid);
      cdf_def_var(fileID, "hyam", NC_DOUBLE, 1, &ncdimid,  &hyamid);
      cdf_def_var(fileID, "hybm", NC_DOUBLE, 1, &ncdimid,  &hybmid);

      strcpy(tmpname, "hybrid level at layer midpoints");
      cdf_put_att_text(fileID, ncvarid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid_sigma_pressure");
      cdf_put_att_text(fileID, ncvarid, "standard_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "level");
      cdf_put_att_text(fileID, ncvarid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "down");
      cdf_put_att_text(fileID, ncvarid, "positive", strlen(tmpname), tmpname);
      strcpy(tmpname, "hyam hybm (mlev=hyam+hybm*aps)");
      cdf_put_att_text(fileID, ncvarid, "formula", strlen(tmpname), tmpname);
      strcpy(tmpname, "ap: hyam b: hybm ps: aps");
      cdf_put_att_text(fileID, ncvarid, "formula_terms", strlen(tmpname), tmpname);
      strcpy(tmpname, "ilev");
      cdf_put_att_text(fileID, ncvarid, "borders", strlen(tmpname), tmpname);

      strcpy(tmpname, "hybrid level at layer interfaces");
      cdf_put_att_text(fileID, ncvarid2, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid_sigma_pressure");
      cdf_put_att_text(fileID, ncvarid2, "standard_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "level");
      cdf_put_att_text(fileID, ncvarid2, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "down");
      cdf_put_att_text(fileID, ncvarid2, "positive", strlen(tmpname), tmpname);
      strcpy(tmpname, "hyai hybi (ilev=hyai+hybi*aps)");
      cdf_put_att_text(fileID, ncvarid2, "formula", strlen(tmpname), tmpname);
      strcpy(tmpname, "ap: hyai b: hybi ps: aps");
      cdf_put_att_text(fileID, ncvarid2, "formula_terms", strlen(tmpname), tmpname);

      strcpy(tmpname, "hybrid A coefficient at layer interfaces");
      cdf_put_att_text(fileID, hyaiid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "Pa");
      cdf_put_att_text(fileID, hyaiid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid B coefficient at layer interfaces");
      cdf_put_att_text(fileID, hybiid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "1");
      cdf_put_att_text(fileID, hybiid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid A coefficient at layer midpoints");
      cdf_put_att_text(fileID, hyamid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "Pa");
      cdf_put_att_text(fileID, hyamid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid B coefficient at layer midpoints");
      cdf_put_att_text(fileID, hybmid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "1");
      cdf_put_att_text(fileID, hybmid, "units", strlen(tmpname), tmpname);

      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      for ( i = 0; i < ilev; i++ ) ilevels[i] = i+1;
      cdf_put_var_int(fileID, ncvarid,  ilevels);
      cdf_put_var_int(fileID, ncvarid2, ilevels);
      free(ilevels);

      cdf_put_var_double(fileID, hyaiid, vctptr);
      cdf_put_var_double(fileID, hybiid, vctptr+ilev);

      for ( i = 0; i < mlev; i++ )
	{
	  start = i;
	  mval = (vctptr[i] + vctptr[i+1]) * 0.5;
	  cdf_put_vara_double(fileID, hyamid, &start, &count, &mval);
	  mval = (vctptr[ilev+i] + vctptr[ilev+i+1]) * 0.5;
	  cdf_put_vara_double(fileID, hybmid, &start, &count, &mval);	  
	}
    }

#endif
}

void cdfDefZaxis(int streamID, int zaxisID)
{
#if  defined  (HAVE_LIBNETCDF)
  char zaxisname0[256];
  char axisname[256];
  char longname[256];
  char units[256];
  char tmpname[256];
  int index;
  int zaxisID0;
  int dimID = UNDEFID;
  int fileID;
  int dimlen;
  size_t len;
  int ncvarid;
  int type;
  int nzaxis;
  int ilevel = 0;
  int vlistID;
  int zaxisindex;
  int xtype = NC_DOUBLE;

  if ( zaxisInqPrec(zaxisID) == DATATYPE_REAL4 ) xtype = NC_FLOAT;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);

  nzaxis = vlistNzaxis(vlistID);

  dimlen = zaxisInqSize(zaxisID);
  type   = zaxisInqType(zaxisID);

  if ( dimlen == 1 && type == ZAXIS_SURFACE ) return;

  zaxisInqName(zaxisID, axisname);

  for ( index = 0; index < zaxisindex; index++ )
    {
      if ( streams[streamID].zaxisID[index] != UNDEFID )
	{
	  zaxisID0 = vlistZaxis(vlistID, index);
	  zaxisInqName(zaxisID0, zaxisname0);
	  if ( strcmp(zaxisname0, axisname) == 0 ) ilevel++;
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( ilevel ) sprintf(&axisname[strlen(axisname)], "_%1d", ilevel+1);

      if ( type == ZAXIS_HYBRID || type == ZAXIS_HYBRID_HALF )
	{
	  size_t ilev = zaxisInqVctSize(zaxisID)/2;
	  size_t mlev = ilev - 1;

	  if ( type == ZAXIS_HYBRID )
	    {
	      if ( (int) mlev != dimlen )
		{
		  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

		  cdf_def_dim(fileID, axisname, dimlen, &dimID);
		  cdf_def_var(fileID, axisname, NC_INT, 1, &dimID,  &ncvarid);

		  strcpy(tmpname, "hybrid level at layer midpoints");
		  cdf_put_att_text(fileID, ncvarid, "long_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hybrid_sigma_pressure");
		  cdf_put_att_text(fileID, ncvarid, "standard_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "level");
		  cdf_put_att_text(fileID, ncvarid, "units", strlen(tmpname), tmpname);
		  strcpy(tmpname, "down");
		  cdf_put_att_text(fileID, ncvarid, "positive", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hyam hybm (mlev=hyam+hybm*aps)");
		  cdf_put_att_text(fileID, ncvarid, "formula", strlen(tmpname), tmpname);
		  strcpy(tmpname, "ap: hyam b: hybm ps: aps");
		  cdf_put_att_text(fileID, ncvarid, "formula_terms", strlen(tmpname), tmpname);
		  strcpy(tmpname, "ilev");
		  cdf_put_att_text(fileID, ncvarid, "borders", strlen(tmpname), tmpname);
  
		  cdf_enddef(fileID);
		  streams[streamID].ncmode = 2;

		  cdf_put_var_double(fileID, ncvarid, zaxisInqLevelsPtr(zaxisID));
		}
	    }

	  if ( type == ZAXIS_HYBRID_HALF )
	    {
	      if ( (int) ilev != dimlen )
		{
		  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

		  cdf_def_dim(fileID, axisname, dimlen, &dimID);
		  cdf_def_var(fileID, axisname, NC_INT, 1, &dimID,  &ncvarid);

		  strcpy(tmpname, "hybrid level at layer interfaces");
		  cdf_put_att_text(fileID, ncvarid, "long_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hybrid_sigma_pressure");
		  cdf_put_att_text(fileID, ncvarid, "standard_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "level");
		  cdf_put_att_text(fileID, ncvarid, "units", strlen(tmpname), tmpname);
		  strcpy(tmpname, "down");
		  cdf_put_att_text(fileID, ncvarid, "positive", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hyai hybi (ilev=hyai+hybi*aps)");
		  cdf_put_att_text(fileID, ncvarid, "formula", strlen(tmpname), tmpname);
		  strcpy(tmpname, "ap: hyai b: hybi ps: aps");
		  cdf_put_att_text(fileID, ncvarid, "formula_terms", strlen(tmpname), tmpname);
	      
		  cdf_enddef(fileID);
		  streams[streamID].ncmode = 2;

		  cdf_put_var_double(fileID, ncvarid, zaxisInqLevelsPtr(zaxisID));
		}
	    }

	  cdfDefVCT(streamID, zaxisID);

	  if ( dimID == UNDEFID )
	    {
	      if ( type == ZAXIS_HYBRID )
		streams[streamID].zaxisID[zaxisindex] = streams[streamID].vct.mlevID;
	      else
		streams[streamID].zaxisID[zaxisindex] = streams[streamID].vct.ilevID;
	    }
	}
      else
	{
	  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

	  cdf_def_dim(fileID, axisname, dimlen, &dimID);

	  zaxisInqLongname(zaxisID, longname);
	  zaxisInqUnits(zaxisID, units);

	  cdf_def_var(fileID, axisname, (nc_type) xtype, 1, &dimID, &ncvarid);
	  if ( (len = strlen(longname)) )
	    cdf_put_att_text(fileID, ncvarid, "long_name", len, longname);
	  if ( (len = strlen(units)) )
	    cdf_put_att_text(fileID, ncvarid, "units", len, units);
  
	  cdf_enddef(fileID);
	  streams[streamID].ncmode = 2;

	  cdf_put_var_double(fileID, ncvarid, zaxisInqLevelsPtr(zaxisID));
	}
    }

  if ( dimID != UNDEFID )
    streams[streamID].zaxisID[zaxisindex] = dimID;

#endif
}


void cdfDefPole(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  int fileID;
  int ncvarid = UNDEFID;
  double xpole, ypole;
  char varname[] = "rotated_pole";
  char mapname[] = "rotated_latitude_longitude";

  fileID  = streamInqFileID(streamID);

  ypole = gridInqYpole(gridID);
  xpole = gridInqXpole(gridID);

  cdf_redef(fileID);

  cdf_def_var(fileID, varname, (nc_type) NC_CHAR, 0, NULL, &ncvarid);
  cdf_put_att_text(fileID, ncvarid, "grid_mapping_name", strlen(mapname), mapname);
  cdf_put_att_double(fileID, ncvarid, "grid_north_pole_latitude", NC_DOUBLE, 1L, &ypole);
  cdf_put_att_double(fileID, ncvarid, "grid_north_pole_longitude", NC_DOUBLE, 1L, &xpole);

  cdf_enddef(fileID);
#endif
}


void cdfDefGrid(int streamID, int gridID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefGrid";
  int gridtype, size;
  int gridindex;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  gridindex = vlistGridIndex(vlistID, gridID);
  if ( streams[streamID].xdimID[gridindex] != UNDEFID ) return;

  gridtype = gridInqType(gridID);
  size     = gridInqSize(gridID);

  if ( CDI_Debug )
    Message(func, "gridtype = %d  size = %d", gridtype, size);

  if ( gridtype == GRID_GAUSSIAN ||
       gridtype == GRID_LONLAT   ||
       gridtype == GRID_GENERIC )
    {
      if ( gridInqXsize(gridID) == 0 || gridInqYsize(gridID) == 0 )
	{
	  cdfDefGdim(streamID, gridID);
	}
      else
	{
	  cdfDefXaxis(streamID, gridID);
	  cdfDefYaxis(streamID, gridID);
	}

      if ( gridIsRotated(gridID) ) cdfDefPole(streamID, gridID);
    }
  else if ( gridtype == GRID_CURVILINEAR )
    {   
      cdfDefLonLat2D(streamID, gridID);
    }
  else if ( gridtype == GRID_GAUSSIAN_REDUCED )
    {
      cdfDefRgrid(streamID, gridID);
    }
  else if ( gridtype == GRID_SPECTRAL )
    {
      cdfDefComplex(streamID, gridID);
      cdfDefSpc(streamID, gridID);
    }
  else if ( gridtype == GRID_TRAJECTORY )
    {
      cdfDefTrajLon(streamID, gridID);
      cdfDefTrajLat(streamID, gridID);
    }
  else if ( gridtype == GRID_CELL )
    {
      cdfDefCell(streamID, gridID);
    }
  else
    {
      Error(func, "%s grid unsupported!", gridNamePtr(gridtype));
    }
#endif
}


int cdfDefVar(int streamID, int varID)
{
  static char func[] = "cdfDefVar";
  int ncvarid = -1;
#if  defined  (HAVE_LIBNETCDF)
  int fileID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID, tid = UNDEFID;
  int code, gridID, zaxisID;
  char varname[9];
  char *name = NULL;
  char *longname = NULL;
  char *units = NULL;
  int dims[4];
  int tableID;
  int ndims = 0;
  int len;
  int timeID;
  int xtype;
  int gridindex, zaxisindex;
  int tablegribID;
  int vlistID;

  fileID  = streamInqFileID(streamID);

  if ( streams[streamID].vars[varID].ncvarid != UNDEFID )
    return (streams[streamID].vars[varID].ncvarid);

  vlistID = streamInqVlist(streamID);
  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);
  code    = vlistInqVarCode(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) != GRID_TRAJECTORY )
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  tid = streams[streamID].basetime.ncdimid;

  if ( timeID == TIME_VARIABLE )
    {
      if ( tid == UNDEFID ) Error(func, "Internal problem! Time undefined.");
      dims[ndims++] = tid;
    }
  if ( zid != UNDEFID ) dims[ndims++] = zid;
  if ( yid != UNDEFID ) dims[ndims++] = yid;
  if ( xid != UNDEFID ) dims[ndims++] = xid;

  tableID  = vlistInqVarTable(vlistID, varID);

  name     = vlistInqVarNamePtr(vlistID, varID);
  longname = vlistInqVarLongnamePtr(vlistID, varID);
  units    = vlistInqVarUnitsPtr(vlistID, varID);

  if ( name     == NULL )     name = tableInqParNamePtr(tableID, code);
  if ( longname == NULL ) longname = tableInqParLongnamePtr(tableID, code);
  if ( units    == NULL )    units = tableInqParUnitsPtr(tableID, code);
  if ( name == NULL )
    {
      if ( code < 0 ) code = -code;
      sprintf(varname, "var%d", code);
      name = varname;
      code = 0;
    }

  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

  xtype = cdfDefDatatype(vlistInqVarDatatype(vlistID, varID));

  cdf_def_var(fileID, name, (nc_type) xtype, ndims, dims, &ncvarid);

  if ( longname )
    cdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);

  if ( units )
    cdf_put_att_text(fileID, ncvarid, "units", strlen(units), units);

  if ( code > 0 )
    cdf_put_att_int(fileID, ncvarid, "code", NC_INT, 1L, &code);

  if ( tableID != UNDEFID )
    {
      tablegribID = tableInqGribID(tableID);
      if ( tablegribID > 0 )
	cdf_put_att_int(fileID, ncvarid, "table", NC_INT, 1L, &tablegribID);
    }

  if ( gridInqType(gridID) != GRID_GENERIC && 
       gridInqType(gridID) != GRID_LONLAT  && 
       gridInqType(gridID) != GRID_CURVILINEAR )
    {
      len = strlen(gridNamePtr(gridInqType(gridID)));
      if ( len > 0 )
	cdf_put_att_text(fileID, ncvarid, "grid_type", len,
			 gridNamePtr(gridInqType(gridID)));
    }

  if ( gridIsRotated(gridID) )
    {
      char mapping[] = "rotated_pole";
      cdf_put_att_text(fileID, ncvarid, "grid_mapping", strlen(mapping), mapping);
    }

  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      cdf_put_att_text(fileID, ncvarid, "coordinates", 9, "tlon tlat" );
    }

  if ( gridInqType(gridID) == GRID_CELL || gridInqType(gridID) == GRID_CURVILINEAR )
    {
      char coordinates[256] = "";
      char cellarea[256] = "area: ";
      int ncxvarID, ncyvarID, ncavarID;
      int gridindex;
      size_t len;

      gridindex = vlistGridIndex(vlistID, gridID);
      ncxvarID = streams[streamID].ncxvarID[gridindex];
      ncyvarID = streams[streamID].ncyvarID[gridindex];
      ncavarID = streams[streamID].ncavarID[gridindex];
      if ( ncxvarID != CDI_UNDEFID )
	cdf_inq_varname(fileID, ncxvarID, coordinates);
      len = strlen(coordinates);
      if ( ncyvarID != CDI_UNDEFID )
	{
	  if ( len ) coordinates[len++] = ' ';
	  cdf_inq_varname(fileID, ncyvarID, coordinates+len);
	}
      len = strlen(coordinates);
      if ( len )
	cdf_put_att_text(fileID, ncvarid, "coordinates", len, coordinates);

      if ( ncavarID != CDI_UNDEFID )
	{
	  len = strlen(cellarea);
	  cdf_inq_varname(fileID, ncavarID, cellarea+len);
	  len = strlen(cellarea);
	  cdf_put_att_text(fileID, ncvarid, "cell_measures", len, cellarea);
	}
    }

  if ( gridInqType(gridID) == GRID_SPECTRAL )
    {
      int gridTruncation = gridInqTrunc(gridID);

      cdf_put_att_int(fileID, ncvarid, "truncation", NC_INT, 1L, &gridTruncation);
    }

  if ( xtype == NC_BYTE || xtype == NC_SHORT || xtype == NC_INT )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;

      addoffset    = vlistInqVarAddoffset(vlistID, varID);
      scalefactor  = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = addoffset   != 0.0;
      lscalefactor = scalefactor != 1.0;

      if ( laddoffset )
	cdf_put_att_double(fileID, ncvarid, "add_offset", NC_FLOAT, 1L, &addoffset);

      if ( lscalefactor )
	cdf_put_att_double(fileID, ncvarid, "scale_factor", NC_FLOAT, 1L, &scalefactor);
    }

  streams[streamID].vars[varID].ncvarid = ncvarid;

  if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);

#endif
  return (ncvarid);
}


void cdfReadVarDP(int streamID, int varID, double *data, int *nmiss)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfReadVarDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int tsID;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex, zaxisindex;
  int vlistID;
  int i;
  double missval;
  int laddoffset, lscalefactor;
  double addoffset, scalefactor;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  tsID = streams[streamID].curTsID;

  if ( CDI_Debug ) Message(func, "tsID = %d", tsID);

  ncvarid = streams[streamID].vars[varID].ncvarid;

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      cdfReadGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = tsID;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = zaxisInqSize(zaxisID);
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = gridInqYsize(gridID);
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = gridInqXsize(gridID);
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  cdf_get_vara_double(fileID, ncvarid, start, count, data);

  *nmiss = 0;
  if ( vlistInqVarMissvalUsed(vlistID, varID) == TRUE  )
    {
      size    = gridInqSize(gridID)*zaxisInqSize(zaxisID);
      missval = vlistInqVarMissval(vlistID, varID);

      for ( i = 0; i < (int) size; i++ )
	if ( data[i] == missval ) *nmiss += 1;
    }

  addoffset    = vlistInqVarAddoffset(vlistID, varID);
  scalefactor  = vlistInqVarScalefactor(vlistID, varID);
  laddoffset   = addoffset   != 0.0;
  lscalefactor = scalefactor != 1.0;

  if ( laddoffset || lscalefactor )
    {
      size    = gridInqSize(gridID)*zaxisInqSize(zaxisID);
      missval = vlistInqVarMissval(vlistID, varID);

      if ( *nmiss > 0 )
	{
	  for ( i = 0; i < (int) size; i++ )
	    {
	      if ( data[i] != missval )
		{
		  if ( lscalefactor ) data[i] = data[i] * scalefactor;
		  if ( laddoffset )   data[i] = data[i] + addoffset;
		}
	    }
	}
      else
	{
	  for ( i = 0; i < (int) size; i++ )
	    {
	      if ( lscalefactor ) data[i] = data[i] * scalefactor;
	      if ( laddoffset )   data[i] = data[i] + addoffset;
	    }
	}
    }
#endif
}

void cdfWriteVarDP(int streamID, int varID, double *data, int nmiss)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfWriteVarDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int ntsteps;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex, zaxisindex;
  int i;
  int dtype;
  int vlistID;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ntsteps = streams[streamID].ntsteps;
  if ( CDI_Debug )
    Message(func, "ntsteps = %d", ntsteps); 

  if ( vlistHasTime(vlistID) ) cdfDefTime(streamID);

  ncvarid = cdfDefVar(streamID, varID);

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      cdfWriteGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = ntsteps - 1;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = zaxisInqSize(zaxisID);
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      cdf_inq_dimlen(fileID, yid, &size);
      /*      count[ndims] = gridInqYsize(gridID); */
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      cdf_inq_dimlen(fileID, xid, &size);
      /*      count[ndims] = gridInqXsize(gridID); */
      count[ndims] = size;
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  if ( streams[streamID].ncmode == 1 )
    {
      cdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  dtype = vlistInqVarDatatype(vlistID, varID);

  if ( nmiss > 0 ) cdfDefMissval(streamID, varID, dtype);

  if ( dtype == DATATYPE_INT1 || dtype == DATATYPE_INT2 || dtype == DATATYPE_INT4 )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;
      double missval;

      addoffset    = vlistInqVarAddoffset(vlistID, varID);
      scalefactor  = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = addoffset   != 0.0;
      lscalefactor = scalefactor != 1.0;

      if ( laddoffset || lscalefactor )
	{
	  gridID  = vlistInqVarGrid(vlistID, varID);
	  size    = gridInqSize(gridID)*zaxisInqSize(zaxisID);
	  missval = vlistInqVarMissval(vlistID, varID);

	  if ( nmiss > 0 )
	    {
	      for ( i = 0; i < (int) size; i++ )
		{
		  if ( data[i] != missval )
		    {
		      if ( laddoffset )   data[i] = data[i] - addoffset;
		      if ( lscalefactor ) data[i] = data[i] / scalefactor;
		    }
		}
	    }
	  else
	    {
	      for ( i = 0; i < (int) size; i++ )
		{
		  if ( laddoffset )   data[i] = data[i] - addoffset;
		  if ( lscalefactor ) data[i] = data[i] / scalefactor;
		}
	    }
	}
    }

  cdf_put_vara_double(fileID, ncvarid, start, count, data);
#endif
}

int cdfReadVarSliceDP(int streamID, int varID, int levelID, double *data, int *nmiss)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfReadVarSliceDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int tsID;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex;
  int zaxisindex;
  int vlistID;
  int i;
  double missval;
  int laddoffset, lscalefactor;
  double addoffset, scalefactor;


  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d  levelID = %d", streamID, varID, levelID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  tsID = streams[streamID].curTsID;
  if ( CDI_Debug )
    Message(func, "tsID = %d", tsID);

  ncvarid = streams[streamID].vars[varID].ncvarid;

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      cdfReadGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];
  /*
  printf("2 %d %d %d %s\n", streamID, zaxisindex, streams[streamID].zaxisID[zaxisindex], vlistInqVarNamePtr(vlistID, varID));
  */

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = tsID;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = levelID;
      count[ndims] = 1;
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      /* count[ndims] = gridInqYsize(gridID); */
      cdf_inq_dimlen(fileID, yid, &size);
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      /* count[ndims] = gridInqXsize(gridID); */
      cdf_inq_dimlen(fileID, xid, &size);
      count[ndims] = size;
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  cdf_get_vara_double(fileID, ncvarid, start, count, data);

  *nmiss = 0;
  if ( vlistInqVarMissvalUsed(vlistID, varID) == TRUE  )
    {
      size    = gridInqSize(gridID);
      missval = vlistInqVarMissval(vlistID, varID);

      for ( i = 0; i < (int) size; i++ )
	if ( data[i] == missval ) *nmiss += 1;
    }

  addoffset    = vlistInqVarAddoffset(vlistID, varID);
  scalefactor  = vlistInqVarScalefactor(vlistID, varID);
  laddoffset   = addoffset   != 0.0;
  lscalefactor = scalefactor != 1.0;

  if ( laddoffset || lscalefactor )
    {
      size    = gridInqSize(gridID);
      missval = vlistInqVarMissval(vlistID, varID);

      if ( *nmiss > 0 )
	{
	  for ( i = 0; i < (int) size; i++ )
	    {
	      if ( data[i] != missval )
		{
		  if ( lscalefactor ) data[i] = data[i] * scalefactor;
		  if ( laddoffset )   data[i] = data[i] + addoffset;
		}
	    }
	}
      else
	{
	  for ( i = 0; i < (int) size; i++ )
	    {
	      if ( lscalefactor ) data[i] = data[i] * scalefactor;
	      if ( laddoffset )   data[i] = data[i] + addoffset;
	    }
	}
    }

#endif
  return (0);
}

int cdfWriteVarSliceDP(int streamID, int varID, int levelID, double *data, int nmiss)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfWriteVarSliceDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int ntsteps;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex, zaxisindex;
  int i;
  int dtype;
  int vlistID;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  ntsteps = streams[streamID].ntsteps;
  if ( CDI_Debug ) Message(func, "ntsteps = %d", ntsteps);

  if ( vlistHasTime(vlistID) ) cdfDefTime(streamID);

  ncvarid = cdfDefVar(streamID, varID);

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      cdfWriteGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = ntsteps - 1;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = levelID;
      count[ndims] = 1;
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      cdf_inq_dimlen(fileID, yid, &size);
      /*      count[ndims] = gridInqYsize(gridID); */
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      cdf_inq_dimlen(fileID, xid, &size);
      /*      count[ndims] = gridInqXsize(gridID); */
      count[ndims] = size;
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  dtype = vlistInqVarDatatype(vlistID, varID);

  if ( nmiss > 0 ) cdfDefMissval(streamID, varID, dtype);

  if ( dtype == DATATYPE_INT1 || dtype == DATATYPE_INT2 || dtype == DATATYPE_INT4 )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;
      double missval;

      addoffset    = vlistInqVarAddoffset(vlistID, varID);
      scalefactor  = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = addoffset   != 0.0;
      lscalefactor = scalefactor != 1.0;

      if ( laddoffset || lscalefactor )
	{
	  gridID  = vlistInqVarGrid(vlistID, varID);
	  size    = gridInqSize(gridID);
	  missval = vlistInqVarMissval(vlistID, varID);

	  if ( nmiss > 0 )
	    {
	      for ( i = 0; i < (int) size; i++ )
		{
		  if ( data[i] != missval )
		    {
		      if ( laddoffset )   data[i] = data[i] - addoffset;
		      if ( lscalefactor ) data[i] = data[i] / scalefactor;
		    }
		}
	    }
	  else
	    {
	      for ( i = 0; i < (int) size; i++ )
		{
		  if ( laddoffset )   data[i] = data[i] - addoffset;
		  if ( lscalefactor ) data[i] = data[i] / scalefactor;
		}
	    }
	}
    }

  cdf_put_vara_double(fileID, ncvarid, start, count, data);

#endif
  return (0);
}

void cdfCreateRecords(int streamID, int tsID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfCreateRecords";
  int varID, levelID, recID, vrecID, zaxisID;
  int nvars, nlev, nrecs, nvrecs;
  RECORD *records;
  int *recIDs;
  int vlistID;

  vlistID  = streamInqVlist(streamID);

  if ( tsID < 0 || (tsID >= streams[streamID].ntsteps && tsID > 0) ) return;

  if ( streams[streamID].tsteps[tsID].nallrecs > 0 ) return;

  if ( tsID == 0 )
    {
      nvars = vlistNvars(vlistID);
      nrecs = vlistNrecs(vlistID);

      streams[streamID].nrecs += nrecs;

      records = (RECORD *) malloc(nrecs*sizeof(RECORD));
      streams[streamID].tsteps[tsID].records    = records;
      streams[streamID].tsteps[tsID].nrecs      = nrecs;
      streams[streamID].tsteps[tsID].nallrecs   = nrecs;
      streams[streamID].tsteps[tsID].recordSize = nrecs;
      streams[streamID].tsteps[tsID].curRecID   = UNDEFID;

      nvrecs = nrecs; /* use all records at first timestep */
      recIDs = (int *) malloc(nvrecs*sizeof(int));
      streams[streamID].tsteps[tsID].recIDs     = recIDs;
      for ( recID = 0; recID < nvrecs; recID++ )
	recIDs[recID] = recID;

      recID = 0;
      for ( varID = 0; varID < nvars; varID++ )
	{
	  zaxisID = vlistInqVarZaxis(vlistID, varID);
	  nlev    = zaxisInqSize(zaxisID);
	  for ( levelID = 0; levelID < nlev; levelID++ )
	    {
	      recordInitEntry(&records[recID]);
	      records[recID].varID   = varID;
	      records[recID].levelID = levelID;
	      recID++;
	    }
	}
    }
  else if ( tsID == 1 )
    {
      nvars = vlistNvars(vlistID);
      nrecs = vlistNrecs(vlistID);

      nvrecs = 0;
      for ( varID = 0; varID < nvars; varID++ )
	{
	  if ( vlistInqVarTime(vlistID, varID) == TIME_VARIABLE )
	    {
	      zaxisID = vlistInqVarZaxis(vlistID, varID);
	      nvrecs += zaxisInqSize(zaxisID);
	    }
	}

      streams[streamID].nrecs += nvrecs;

      records = (RECORD *) malloc(nrecs*sizeof(RECORD));
      streams[streamID].tsteps[tsID].records    = records;
      streams[streamID].tsteps[tsID].nrecs      = nvrecs;
      streams[streamID].tsteps[tsID].nallrecs   = nrecs;
      streams[streamID].tsteps[tsID].recordSize = nrecs;
      streams[streamID].tsteps[tsID].curRecID   = UNDEFID;

      memcpy(streams[streamID].tsteps[tsID].records,
	     streams[streamID].tsteps[0].records,
	     nrecs*sizeof(RECORD));

      recIDs = (int *) malloc(nvrecs*sizeof(int));
      streams[streamID].tsteps[tsID].recIDs     = recIDs;
      vrecID = 0;
      for ( recID = 0; recID < nrecs; recID++ )
	{
	  varID = records[recID].varID;
	  if ( vlistInqVarTime(vlistID, varID) == TIME_VARIABLE )
	    {
	      recIDs[vrecID++] = recID;
	    }
	}
    }
  else
    {
      nvars = vlistNvars(vlistID);
      nrecs = vlistNrecs(vlistID);

      nvrecs = streams[streamID].tsteps[1].nrecs;

      streams[streamID].nrecs += nvrecs;

      records = (RECORD *) malloc(nrecs*sizeof(RECORD));
      streams[streamID].tsteps[tsID].records    = records;
      streams[streamID].tsteps[tsID].nrecs      = nvrecs;
      streams[streamID].tsteps[tsID].nallrecs   = nrecs;
      streams[streamID].tsteps[tsID].recordSize = nrecs;
      streams[streamID].tsteps[tsID].curRecID   = UNDEFID;

      memcpy(streams[streamID].tsteps[tsID].records,
	     streams[streamID].tsteps[0].records,
	     nrecs*sizeof(RECORD));

      recIDs = (int *) malloc(nvrecs*sizeof(int));
      streams[streamID].tsteps[tsID].recIDs     = recIDs;

      memcpy(streams[streamID].tsteps[tsID].recIDs,
	     streams[streamID].tsteps[1].recIDs,
	     nvrecs*sizeof(int));
    }
#endif
}

int cdfTimeDimID(int fileID, int ndims, int nvars)
{
  int dimid = 0;
#if  defined  (HAVE_LIBNETCDF)
  char dimname[80];
  char timeunits[256];
  char attname[256];
  char name[256];
  nc_type xtype;
  int nvdims, nvatts;
  int dimids[9];
  int varid, iatt;

  for ( dimid = 0; dimid < ndims; dimid++ )
    {
      cdf_inq_dimname(fileID, dimid, dimname);
      if ( strncmp(dimname, "time", 4) == 0 ) break;
    }

  if ( dimid == ndims ) dimid = UNDEFID;

  for ( varid = 0; varid < nvars; varid++ )
    {
      if ( dimid != UNDEFID ) break;

      cdf_inq_var(fileID, varid, name, &xtype, &nvdims, dimids, &nvatts);
      if ( nvdims == 1 )
	{
	  for ( iatt = 0; iatt < nvatts; iatt++ )
	    {
	      cdf_inq_attname(fileID, varid, iatt, attname);
	      if ( strncmp(attname, "units", 5) == 0 )
		{
		  cdf_get_att_text(fileID, varid, "units", timeunits);
		  if ( strncmp(timeunits, "sec",    3) == 0 ||
		       strncmp(timeunits, "minute", 6) == 0 ||
		       strncmp(timeunits, "hour",   4) == 0 ||
		       strncmp(timeunits, "day",    3) == 0 ||
		       strncmp(timeunits, "month",  5) == 0 )
		    {
		      dimid = dimids[0];
		      break;
		    }
		}
	    }
	}
    }

#endif
  return (dimid);
}

void cdfSetVar(NCVAR *ncvars, int ncvarid, int isvar)
{
  static char func[] = "cdfSetVar";

  if ( isvar != TRUE && isvar != FALSE )
    Error(func, "Internal problem! var %s undefined", ncvars[ncvarid].name);

  if ( ncvars[ncvarid].isvar != UNDEFID &&
       ncvars[ncvarid].isvar != isvar   &&
       ncvars[ncvarid].warn  == FALSE )
    {
      Warning(func, "Inconsistent variable definition for %s!", ncvars[ncvarid].name);

      ncvars[ncvarid].warn = TRUE;
      isvar = FALSE;
    }

  ncvars[ncvarid].isvar = isvar;
}

void cdfSetDim(NCVAR *ncvars, int ncvarid, int dimid, int dimtype)
{
  static char func[] = "cdfSetDim";

  if ( ncvars[ncvarid].dimtype[dimid] != UNDEFID &&
       ncvars[ncvarid].dimtype[dimid] != dimtype )
    {
      Warning(func, "Inconsistent dimension definition for %s! dimid %d  oldtype %d  newtype %d",
	      ncvars[ncvarid].name, dimid, ncvars[ncvarid].dimtype[dimid], dimtype);
    }

  ncvars[ncvarid].dimtype[dimid] = dimtype;
}

void printNCvars(NCVAR *ncvars, int nvars)
{
  char axis[6];
  int ncvarid, i;
  int ndim;
  int iaxis[] = {'t', 'z', 'y', 'x'};

  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      ndim = 0;
      if ( ncvars[ncvarid].isvar )
	{
	  axis[ndim++] = 'v';
	  for ( i = 0; i < ncvars[ncvarid].ndims; i++ )
	    {
	      if ( ncvars[ncvarid].tvarid != -1 )
		axis[ndim++] = iaxis[0];
	      else if ( ncvars[ncvarid].zvarid != -1 )
		axis[ndim++] = iaxis[1];
	      else if ( ncvars[ncvarid].yvarid != -1 )
		axis[ndim++] = iaxis[2];
	      else if ( ncvars[ncvarid].xvarid != -1 )
		axis[ndim++] = iaxis[3];
	      else
		axis[ndim++] = '?';
	    }
	}
      else
	{
	  axis[ndim++] = 'c';
	  if ( ncvars[ncvarid].islev )
	    axis[ndim++] = iaxis[1];
	  else if ( ncvars[ncvarid].islat )
	    axis[ndim++] = iaxis[2];
	  else if ( ncvars[ncvarid].islon )
	    axis[ndim++] = iaxis[3];
	  else
	    axis[ndim++] = '?';
	}

      axis[ndim++] = 0;

      printf("%3d %3d %3d  %s %s\n", ncvarid, ncvars[ncvarid].isvar, ndim-2, axis, ncvars[ncvarid].name);
    }
}

void cdfInqContents(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfInqContents";
  int ndims, nvars, ngatts, unlimdimid;
  int varID, ncvarid, ncvarid2;
  int ncdimid;
  int varID1;
  int fileID;
  int nvdims, nvatts;
  int *dimidsp;
  nc_type xtype;
  size_t size = 0, xsize, ysize;
  size_t ntsteps;
  int timedimid = -1;
  int *varids;
  int nvarids = 0;
  size_t attlen;
  int  ilev;
  char name[256];
  char attname[256];
  char attstring[1024];
  char *pname, *plongname, *punits;
  int iatt, timehasunit = 0;
  size_t len;
  int nc_nvars;
  int nvcth_id = UNDEFID, vcta_id = UNDEFID, vctb_id = UNDEFID;
  GRID grid;
  int gridindex;
  int zaxisindex;
  size_t vctsize = 0;
  int tablenum, tableID;
  double *vct = NULL;
  int instID  = UNDEFID;
  int modelID = UNDEFID;
  int code;
  int taxisID;
  int i;
  int zprec;
  int calendar = UNDEFID;
  NCDIM *ncdims;
  NCVAR *ncvars;
  int vlistID;
  
  streamCheckID(func, streamID);

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  if ( CDI_Debug )
    Message(func, "streamID = %d, fileID = %d", streamID, fileID);

  cdf_inq(fileID, &ndims , &nvars, &ngatts, &unlimdimid);

  /* alloc ncdims */
  ncdims = (NCDIM *) malloc(ndims*sizeof(NCDIM));

  /* alloc ncvars */
  ncvars = (NCVAR *) malloc(nvars*sizeof(NCVAR));

  /* init ncdims */
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      ncdims[ncdimid].ncvarid      = UNDEFID;
      ncdims[ncdimid].dimtype      = UNDEFID;
      ncdims[ncdimid].len          = 0;
      ncdims[ncdimid].name[0]      = 0;
    }

  /* init ncvars */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {      
      ncvars[ncvarid].vartype      = UNDEFID;
      ncvars[ncvarid].isvar        = UNDEFID;
      ncvars[ncvarid].islon        = FALSE;
      ncvars[ncvarid].islat        = FALSE;
      ncvars[ncvarid].islev        = FALSE;
      ncvars[ncvarid].warn         = FALSE;
      ncvars[ncvarid].timeID       = TIME_CONSTANT;
      ncvars[ncvarid].code         = UNDEFID;
      ncvars[ncvarid].calendar     = FALSE;
      ncvars[ncvarid].bounds       = UNDEFID;
      ncvars[ncvarid].gridID       = UNDEFID;
      ncvars[ncvarid].zaxisID      = UNDEFID;
      ncvars[ncvarid].gridtype     = UNDEFID;
      ncvars[ncvarid].zaxistype    = UNDEFID;
      ncvars[ncvarid].xdim         = UNDEFID;
      ncvars[ncvarid].ydim         = UNDEFID;
      ncvars[ncvarid].zdim         = UNDEFID;
      ncvars[ncvarid].xvarid       = UNDEFID;
      ncvars[ncvarid].yvarid       = UNDEFID;
      ncvars[ncvarid].zvarid       = UNDEFID;
      ncvars[ncvarid].tvarid       = UNDEFID;
      ncvars[ncvarid].varids[0]    = UNDEFID;
      ncvars[ncvarid].varids[1]    = UNDEFID;
      ncvars[ncvarid].varids[2]    = UNDEFID;
      ncvars[ncvarid].varids[3]    = UNDEFID;
      ncvars[ncvarid].cellarea     = UNDEFID;
      ncvars[ncvarid].tableID      = UNDEFID;
      ncvars[ncvarid].gmapid       = UNDEFID;
      ncvars[ncvarid].vlen         = 0;
      ncvars[ncvarid].vdata        = NULL;
      ncvars[ncvarid].truncation   = 0;
      ncvars[ncvarid].defmiss      = 0;
      ncvars[ncvarid].missval      = 0;
      ncvars[ncvarid].addoffset    = 0;
      ncvars[ncvarid].scalefactor  = 1;
      ncvars[ncvarid].name[0]      = 0;
      ncvars[ncvarid].longname[0]  = 0;
      ncvars[ncvarid].units[0]     = 0;
    }

  /* read global attributtes*/
  for ( iatt = 0; iatt < ngatts; iatt++ )
    {
      cdf_inq_attname(fileID, NC_GLOBAL, iatt, attname);
      cdf_inq_atttype(fileID, NC_GLOBAL, attname, &xtype);

      if ( xtype != NC_CHAR ) continue;

      cdf_inq_attlen(fileID, NC_GLOBAL, attname, &attlen);
      if ( strcmp(attname, "history") == 0 )
	{
	  streams[streamID].historyID = iatt;
	}
      else if ( strcmp(attname, "institution") == 0 )
	{
	  cdf_get_att_text(fileID, NC_GLOBAL, attname, attstring);
	  attstring[attlen] = 0;
	  instID = institutInq(0, 0, NULL, attstring);
	  if ( instID == UNDEFID )
	    instID = institutDef(0, 0, NULL, attstring);
	}
      else if ( strcmp(attname, "source") == 0 )
	{
	  cdf_get_att_text(fileID, NC_GLOBAL, attname, attstring);
	  attstring[attlen] = 0;
	  modelID = modelInq(-1, 0, attstring);
	}
      else if ( strcmp(attname, "Conventions") == 0 )
	{
	}
      else if ( strcmp(attname, "CDI") == 0 )
	{
	}
      else if ( strcmp(attname, "CDO") == 0 )
	{
	}
      else
	{
	  cdf_get_att_text(fileID, NC_GLOBAL, attname, attstring);
	  attstring[attlen] = 0;
	  vlistDefAttribute(vlistID, attname, attstring);
	}
    }

  /* find time dim */
  if ( unlimdimid >= 0 )
    timedimid = unlimdimid;
  else
    timedimid = cdfTimeDimID(fileID, ndims, nvars);

  streams[streamID].basetime.ncdimid = timedimid;

  if ( timedimid != UNDEFID )
    cdf_inq_dimlen(fileID, timedimid, &ntsteps);
  else
    ntsteps = 0;

  streams[streamID].ntsteps = ntsteps;

  if ( CDI_Debug )
    Message(func, "time dimid = %d", streams[streamID].basetime.ncdimid);

  /* read ncdims */
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      cdf_inq_dimlen(fileID, ncdimid, &ncdims[ncdimid].len);
      cdf_inq_dimname(fileID, ncdimid, ncdims[ncdimid].name);
      if ( timedimid == ncdimid )
	ncdims[ncdimid].dimtype = T_AXIS;
    }

  /* read ncvars */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      dimidsp = ncvars[ncvarid].dimids;

      cdf_inq_var(fileID, ncvarid, name, &xtype, &nvdims, dimidsp, &nvatts);
      strcpy(ncvars[ncvarid].name, name);      

      for ( ncdimid = 0; ncdimid < nvdims; ncdimid++ )
	ncvars[ncvarid].dimtype[ncdimid] = -1;

      ncvars[ncvarid].xtype = xtype;
      ncvars[ncvarid].ndims = nvdims;

      if ( nvdims > 0 )
	if ( timedimid == dimidsp[0] )
	  {
	    ncvars[ncvarid].timeID = TIME_VARIABLE;
	    cdfSetDim(ncvars, ncvarid, 0, T_AXIS);
	  }

      for ( iatt = 0; iatt < nvatts; iatt++ )
	{
	  cdf_inq_attname(fileID, ncvarid, iatt, attname);
	  
	  if ( strcmp(attname, "long_name") == 0 )
	    {
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, ncvars[ncvarid].longname);
	      ncvars[ncvarid].longname[attlen] = 0;
      	    }
	  else if ( strcmp(attname, "units") == 0 )
	    {
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, ncvars[ncvarid].units);
	      ncvars[ncvarid].units[attlen] = 0;
      	    }
	  else if ( strcmp(attname, "calendar") == 0 )
	    {
	      ncvars[ncvarid].calendar = TRUE;
      	    }
	  else if ( strcmp(attname, "code") == 0 )
	    {
	      cdf_get_att_int(fileID, ncvarid, attname, &ncvars[ncvarid].code);
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "table") == 0 )
	    {
	      cdf_get_att_int(fileID, ncvarid, attname, &tablenum);
	      if ( tablenum > 0 )
		{
		  ncvars[ncvarid].tableID = tableInq(modelID, tablenum, NULL);
		  if ( ncvars[ncvarid].tableID == CDI_UNDEFID )
		    ncvars[ncvarid].tableID = tableDef(modelID, tablenum, NULL);
		}
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "trunc_type") == 0 )
	    {
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;
	      if      ( strncmp(attstring, "Triangular", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_SPECTRAL;
	    }
	  else if ( strcmp(attname, "grid_type") == 0 )
	    {
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;
	      if      ( strncmp(attstring, "gaussian", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_GAUSSIAN;
	      else if ( strncmp(attstring, "gaussian reduced", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_GAUSSIAN_REDUCED;
	      else if ( strncmp(attstring, "spectral", 8) == 0 )
		ncvars[ncvarid].gridtype = GRID_SPECTRAL;
	      else if ( strncmp(attstring, "trajectory", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_TRAJECTORY;
	      else if ( strncmp(attstring, "generic", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_GENERIC;
	      else if ( strncmp(attstring, "cell", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_CELL;
	      else if ( strncmp(attstring, "curvilinear", attlen) == 0 )
		ncvars[ncvarid].gridtype = GRID_CURVILINEAR;
	      else
		{
		  static int warn = TRUE;
		  if ( warn )
		    {
		      warn = FALSE;
		      Warning(func, "Gridtype %s unsupported!", attstring);
		    }
		}

	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "trunc_count") == 0 )
	    {
	      cdf_get_att_int(fileID, ncvarid, attname, &ncvars[ncvarid].truncation);
	    }
	  else if ( strcmp(attname, "truncation") == 0 )
	    {
	      cdf_get_att_int(fileID, ncvarid, attname, &ncvars[ncvarid].truncation);
	    }
	  else if ( strcmp(attname, "add_offset") == 0 )
	    {
	      cdf_get_att_double(fileID, ncvarid, attname, &ncvars[ncvarid].addoffset);
	      if ( xtype != NC_BYTE && xtype != NC_SHORT && xtype != NC_INT )
		if ( ncvars[ncvarid].addoffset != 0 )
		  Warning(func, "attribute add_offset not supported for xtype %d\n", xtype);
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "scale_factor") == 0 )
	    {
	      cdf_get_att_double(fileID, ncvarid, attname, &ncvars[ncvarid].scalefactor);
	      if ( xtype != NC_BYTE && xtype != NC_SHORT && xtype != NC_INT )
		if ( ncvars[ncvarid].scalefactor != 1 )
		  Warning(func, "attribute scale_factor not supported for xtype %d\n", xtype);
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "bounds") == 0 )
	    {
	      int status, ncboundsid;

	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;

	      status = nc_inq_varid(fileID, attstring, &ncboundsid);

	      if ( status == NC_NOERR )
		{
		  ncvars[ncvarid].bounds = ncboundsid;
		  cdfSetVar(ncvars, ncvars[ncvarid].bounds, FALSE);
		  cdfSetVar(ncvars, ncvarid, FALSE);
		}
	      else
		Warning(func, "%s %s", nc_strerror(status), attstring);
	    }
	  else if ( strcmp(attname, "cell_measures") == 0 )
	    {
	      char *pstring, *cell_measures = NULL, *cell_var = NULL;

	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;
	      pstring = attstring;

	      while ( isspace((int) *pstring) ) pstring++;
	      cell_measures = pstring;
	      while ( isalnum((int) *pstring) ) pstring++;
	      *pstring++ = 0;
	      while ( isspace((int) *pstring) ) pstring++;
	      cell_var = pstring;
	      while ( ! isspace((int) *pstring) && *pstring != 0 ) pstring++;
	      *pstring++ = 0;
	      /*
	      printf("cell_measures >%s<\n", cell_measures);
	      printf("cell_var >%s<\n", cell_var);
	      */
	      if ( strcmp(cell_measures, "area") == 0 )
		{
		  cdf_inq_varid(fileID, cell_var, &ncvars[ncvarid].cellarea);
		  cdfSetVar(ncvars, ncvars[ncvarid].cellarea, FALSE);
		}
	      else
		{
		  Warning(func, "%s has unexpected contents: %s", attname, cell_measures);
		}
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  /*
	  else if ( strcmp(attname, "coordinates") == 0 )
	    {
	      char *pstring, *xvarname = NULL, *yvarname = NULL;
	      
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;
	      pstring = attstring;

	      while ( isspace((int) *pstring) ) pstring++;
	      xvarname = pstring;
	      while ( isgraph((int) *pstring) ) pstring++;
	      *pstring++ = 0;
	      while ( isspace((int) *pstring) ) pstring++;
	      yvarname = pstring;
	      while ( isgraph((int) *pstring) ) pstring++;
	      *pstring++ = 0;

	      cdf_inq_varid(fileID, xvarname, &ncvars[ncvarid].xvarid);
	      cdf_inq_varid(fileID, yvarname, &ncvars[ncvarid].yvarid);

	      cdfSetVar(ncvars, ncvars[ncvarid].xvarid, FALSE);
	      cdfSetVar(ncvars, ncvars[ncvarid].yvarid, FALSE);
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  */
	  else if ( strcmp(attname, "associate") == 0 || 
		    strcmp(attname, "coordinates") == 0 )
	    {
	      int status;
	      char *pstring, *varname = NULL;
	      int lstop = FALSE;
	      
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;
	      pstring = attstring;

	      for ( i = 0; i < 4; i++ )
		{
		  while ( isspace((int) *pstring) ) pstring++;
		  if ( *pstring == 0 ) break;
		  varname = pstring;
		  while ( !isspace((int) *pstring) && *pstring != 0 ) pstring++;
		  if ( *pstring == 0 ) lstop = TRUE;
		  *pstring++ = 0;

		  status = nc_inq_varid(fileID, varname, &ncvars[ncvarid].varids[i]);
		  if ( status == NC_NOERR )
		    cdfSetVar(ncvars, ncvars[ncvarid].varids[i], FALSE);
		  else
		    Warning(func, "%s %s", nc_strerror(status), varname);

		  if ( lstop ) break;
		}
	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "grid_mapping") == 0 )
	    {
	      int status;
	      
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;

	      status = nc_inq_varid(fileID, attstring, &ncvars[ncvarid].gmapid);
	      if ( status == NC_NOERR )
		cdfSetVar(ncvars, ncvars[ncvarid].gmapid, FALSE);
	      else
		Warning(func, "%s %s", nc_strerror(status), attstring);

	      cdfSetVar(ncvars, ncvarid, TRUE);
	    }
	  else if ( strcmp(attname, "_FillValue") == 0 || 
		    strcmp(attname, "missing_value") == 0 )
	    {
	      cdf_get_att_double(fileID, ncvarid, attname, &ncvars[ncvarid].missval);
	      ncvars[ncvarid].defmiss = TRUE;
	      /* cdfSetVar(ncvars, ncvarid, TRUE); */
	    }
	  else if ( strcmp(attname, "axis") == 0 )
	    {
	      cdf_inq_attlen(fileID, ncvarid, attname, &attlen);
	      cdf_get_att_text(fileID, ncvarid, attname, attstring);
	      attstring[attlen] = 0;
	      attlen = strlen(attstring); /* check attlen */
	      if ( (int) attlen != nvdims )
		{
		  if ( nvdims > 0 )
		    Warning(func, "axis attribute length %d does not match nvdim %d for %s",
			    attlen, nvdims, name);
		}
	      else
		{
		  while ( attlen-- )
		    {
		      if ( tolower((int) attstring[attlen]) == 't' )
			{
			  if ( attlen != 0 )
			    Warning(func, "axis attribute 't' not on first position");
			  cdfSetDim(ncvars, ncvarid, attlen, T_AXIS);
			}
		      else if ( tolower((int) attstring[attlen]) == 'z' )
			{
			  ncvars[ncvarid].zdim = dimidsp[attlen];
			  cdfSetDim(ncvars, ncvarid, attlen, Z_AXIS);
			}
		      else if ( tolower((int) attstring[attlen]) == 'y' )
			{
			  ncvars[ncvarid].ydim = dimidsp[attlen];
			  cdfSetDim(ncvars, ncvarid, attlen, Y_AXIS);
			}
		      else if ( tolower((int) attstring[attlen]) == 'x' )
			{
			  ncvars[ncvarid].xdim = dimidsp[attlen];
			  cdfSetDim(ncvars, ncvarid, attlen, X_AXIS);
			}
		    }
		}
	    }
	}
    }

  /* printNCvars(ncvars, nvars); */

  /* find coordinate vars */
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
	{
	  if ( ncvars[ncvarid].ndims == 1 )
	    {
	      if ( ncvars[ncvarid].isvar != TRUE )
		cdfSetVar(ncvars, ncvarid, FALSE);
	      if ( ncdimid == ncvars[ncvarid].dimids[0] && ncdims[ncdimid].ncvarid == UNDEFID )
		if ( strcmp(ncvars[ncvarid].name, ncdims[ncdimid].name) == 0 )
		  {
		    ncdims[ncdimid].ncvarid = ncvarid;
		    ncvars[ncvarid].isvar = FALSE;
		  }
	    }
	}
    }

  /* find time var */
  if ( timedimid != UNDEFID )
    {
      if ( ncdims[timedimid].ncvarid != UNDEFID )
	streams[streamID].basetime.ncvarid = ncdims[timedimid].ncvarid;
      else
	{
	  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
	    if ( ncvars[ncvarid].ndims == 1 && timedimid == ncvars[ncvarid].dimids[0] )
	      {
		streams[streamID].basetime.ncvarid = ncvarid;
		break;
	      }
	}

      /* time varID */
      ncvarid = streams[streamID].basetime.ncvarid;

      if ( ncvarid == UNDEFID )
	Warning(func, "time variable not found!");
      else
	{
	  if ( ncvars[ncvarid].units[0] != 0 )
	    timehasunit = TRUE;
	}
    }

  /* check ncvars */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( timedimid != UNDEFID )
	if ( ncvars[ncvarid].isvar == -1 &&
	     ncvars[ncvarid].ndims > 1   &&
	     timedimid == ncvars[ncvarid].dimids[0] )
	  cdfSetVar(ncvars, ncvarid, TRUE);

      if ( ncvars[ncvarid].isvar == -1 && ncvars[ncvarid].ndims == 0 )
	cdfSetVar(ncvars, ncvarid, FALSE);

      if ( ncvars[ncvarid].isvar == -1 && ncvars[ncvarid].ndims > 1 )
	cdfSetVar(ncvars, ncvarid, TRUE);
	  
      if ( ncvars[ncvarid].isvar == -1 )
	Warning(func, "Variable %s has unknown type, skipped!", ncvars[ncvarid].name);
      if ( ncvars[ncvarid].ndims > 4 )
	Warning(func, "%d dimension variables unsupported. Skip variable %s",
		ncvars[ncvarid].ndims, ncvars[ncvarid].name);

      if ( ncvars[ncvarid].xtype == NC_CHAR )
	ncvars[ncvarid].isvar = 0;
    }

  /* verify coordinate vars (dimname == varname) */
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      ncvarid = ncdims[ncdimid].ncvarid;
      if ( ncvarid != -1 )
	{
	  if ( ncvars[ncvarid].dimids[0] == timedimid )
	    {
	      ncdims[ncdimid].dimtype = T_AXIS;
	      continue;
	    }

	  if ( ncvars[ncvarid].longname[0] != 0 )
	    {
	      if ( strncmp(ncvars[ncvarid].longname, "Longitude", 9) == 0 ||
		   strncmp(ncvars[ncvarid].longname, "longitude", 9) == 0 )
		{
		  ncvars[ncvarid].islon = TRUE;
		  cdfSetVar(ncvars, ncvarid, FALSE);
		  cdfSetDim(ncvars, ncvarid, 0, X_AXIS);
		  ncdims[ncdimid].dimtype = X_AXIS;
		  continue;
		}
	      else if ( strncmp(ncvars[ncvarid].longname, "Latitude", 8) == 0 || 
			strncmp(ncvars[ncvarid].longname, "latitude", 8) == 0 )
		{
		  ncvars[ncvarid].islat = TRUE;
		  cdfSetVar(ncvars, ncvarid, FALSE);
		  cdfSetDim(ncvars, ncvarid, 0, Y_AXIS);
		  ncdims[ncdimid].dimtype = Y_AXIS;
		  continue;
		}
	    }

	  if ( ncvars[ncvarid].units[0] != 0 )
	    {
	      if ( strcmp(ncvars[ncvarid].units, "degrees_east") == 0 ||
		   strcmp(ncvars[ncvarid].units, "degree_east")  == 0 ||
		   strcmp(ncvars[ncvarid].units, "degree_E")     == 0 ||
		   strcmp(ncvars[ncvarid].units, "degrees_E")    == 0 ||
		   strcmp(ncvars[ncvarid].units, "degreeE")      == 0 ||
		   strcmp(ncvars[ncvarid].units, "degreesE")     == 0 )
		{
		  ncvars[ncvarid].islon = TRUE;
		  cdfSetVar(ncvars, ncvarid, FALSE);
		  cdfSetDim(ncvars, ncvarid, 0, X_AXIS);
		  ncdims[ncdimid].dimtype = X_AXIS;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "degrees_north") == 0 ||
			strcmp(ncvars[ncvarid].units, "degree_north")  == 0 ||
			strcmp(ncvars[ncvarid].units, "degree_N")      == 0 ||
			strcmp(ncvars[ncvarid].units, "degrees_N")     == 0 ||
			strcmp(ncvars[ncvarid].units, "degreeN")       == 0 ||
			strcmp(ncvars[ncvarid].units, "degreesN")      == 0 )
		{
		  ncvars[ncvarid].islat = TRUE;
		  cdfSetVar(ncvars, ncvarid, FALSE);
		  cdfSetDim(ncvars, ncvarid, 0, Y_AXIS);
		  ncdims[ncdimid].dimtype = Y_AXIS;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "millibar") == 0 ||
			strncmp(ncvars[ncvarid].units, "mb", 2)   == 0 ||
			strcmp(ncvars[ncvarid].units, "hPa")      == 0 ||
			strcmp(ncvars[ncvarid].units, "Pa")       == 0 )
		{
		  ncvars[ncvarid].zaxistype = ZAXIS_PRESSURE;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "level") == 0 )
		{
		  if      ( strcmp(ncvars[ncvarid].longname, "hybrid level at layer midpoints") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_HYBRID;
		  else if ( strcmp(ncvars[ncvarid].longname, "hybrid level at layer interfaces") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_HYBRID_HALF;
		  else
		    ncvars[ncvarid].zaxistype = ZAXIS_GENERIC;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "cm")  == 0 )
		{
		  if ( strcmp(ncvars[ncvarid].longname, "depth below land")         == 0 ||
		       strcmp(ncvars[ncvarid].longname, "levels below the surface") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_DEPTH_BELOW_LAND;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "m")   == 0 )
		{
		  if ( strcmp(ncvars[ncvarid].longname, "depth below sea") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_DEPTH_BELOW_SEA;
		  else if ( strcmp(ncvars[ncvarid].longname, "height") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_HEIGHT;
		}
	    }

	  if ( ncvars[ncvarid].zaxistype != UNDEFID )
	    {
	      cdfSetVar(ncvars, ncvarid, FALSE);
	      cdfSetDim(ncvars, ncvarid, 0, Z_AXIS);
	      ncdims[ncdimid].dimtype = Z_AXIS;
	    }
	}
    }

  /* verify coordinate vars */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].isvar == 0 )
	{
	  if ( ncvars[ncvarid].longname[0] != 0 )
	    {
	      if ( strncmp(ncvars[ncvarid].longname, "Longitude", 9) == 0 ||
		   strncmp(ncvars[ncvarid].longname, "longitude", 9) == 0 )
		{
		  ncvars[ncvarid].islon = TRUE;
		  continue;
		}
	      else if ( strncmp(ncvars[ncvarid].longname, "Latitude", 8) == 0 || 
			strncmp(ncvars[ncvarid].longname, "latitude", 8) == 0 )
		{
		  ncvars[ncvarid].islat = TRUE;
		  continue;
		}
	    }

	  if ( ncvars[ncvarid].units[0] != 0 )
	    {
	      if ( strcmp(ncvars[ncvarid].units, "degrees_east") == 0 ||
		   strcmp(ncvars[ncvarid].units, "degree_east")  == 0 ||
		   strcmp(ncvars[ncvarid].units, "degree_E")     == 0 ||
		   strcmp(ncvars[ncvarid].units, "degrees_E")    == 0 ||
		   strcmp(ncvars[ncvarid].units, "degreeE")      == 0 ||
		   strcmp(ncvars[ncvarid].units, "degreesE")     == 0 )
		{
		  ncvars[ncvarid].islon = TRUE;
		  continue;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "degrees_north") == 0 ||
			strcmp(ncvars[ncvarid].units, "degree_north")  == 0 ||
			strcmp(ncvars[ncvarid].units, "degree_N")      == 0 ||
			strcmp(ncvars[ncvarid].units, "degrees_N")     == 0 ||
			strcmp(ncvars[ncvarid].units, "degreeN")       == 0 ||
			strcmp(ncvars[ncvarid].units, "degreesN")      == 0 )
		{
		  ncvars[ncvarid].islat = TRUE;
		  continue;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "millibar") == 0 ||
			strncmp(ncvars[ncvarid].units, "mb", 2)   == 0 ||
			strcmp(ncvars[ncvarid].units, "hPa")      == 0 ||
			strcmp(ncvars[ncvarid].units, "Pa")       == 0 )
		{
		  ncvars[ncvarid].zaxistype = ZAXIS_PRESSURE;
		  continue;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "level") == 0 )
		{
		  if      ( strcmp(ncvars[ncvarid].longname, "hybrid level at layer midpoints") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_HYBRID;
		  else if ( strcmp(ncvars[ncvarid].longname, "hybrid level at layer interfaces") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_HYBRID_HALF;
		  else
		    ncvars[ncvarid].zaxistype = ZAXIS_GENERIC;
		  continue;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "cm")  == 0 )
		{
		  if ( strcmp(ncvars[ncvarid].longname, "depth below land")         == 0 ||
		       strcmp(ncvars[ncvarid].longname, "levels below the surface") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_DEPTH_BELOW_LAND;
		  continue;
		}
	      else if ( strcmp(ncvars[ncvarid].units, "m")   == 0 )
		{
		  if ( strcmp(ncvars[ncvarid].longname, "depth below sea") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_DEPTH_BELOW_SEA;
		  else if ( strcmp(ncvars[ncvarid].longname, "height") == 0 )
		    ncvars[ncvarid].zaxistype = ZAXIS_HEIGHT;
		  continue;
		}
	    }
	}
    }

  /* printNCvars(ncvars, nvars); */

  /*
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      ncvarid = ncdims[ncdimid].ncvarid;
      if ( ncvarid != -1 )
	{
	  printf("coord var %d %s %s\n", ncvarid, ncvars[ncvarid].name, ncvars[ncvarid].units);
	  if ( ncdims[ncdimid].dimtype == X_AXIS )
	    printf("coord var %d %s is x dim\n", ncvarid, ncvars[ncvarid].name);
	  if ( ncdims[ncdimid].dimtype == Y_AXIS )
	    printf("coord var %d %s is y dim\n", ncvarid, ncvars[ncvarid].name);
	  if ( ncdims[ncdimid].dimtype == Z_AXIS )
	    printf("coord var %d %s is z dim\n", ncvarid, ncvars[ncvarid].name);
	  if ( ncdims[ncdimid].dimtype == T_AXIS )
	    printf("coord var %d %s is t dim\n", ncvarid, ncvars[ncvarid].name);

	  if ( ncvars[ncvarid].islon )
	    printf("coord var %d %s is lon\n", ncvarid, ncvars[ncvarid].name);
	  if ( ncvars[ncvarid].islat )
	    printf("coord var %d %s is lat\n", ncvarid, ncvars[ncvarid].name);
	  if ( ncvars[ncvarid].islev )
	    printf("coord var %d %s is lev\n", ncvarid, ncvars[ncvarid].name);
	}
    }
  */
  /* set dim type */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].isvar == TRUE )
	{
	  int lxdim = 0, lydim = 0, lzdim = 0, ltdim = 0;
	  ndims = ncvars[ncvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      ncdimid = ncvars[ncvarid].dimids[i];
	      if ( ncdims[ncdimid].dimtype == X_AXIS )
		cdfSetDim(ncvars, ncvarid, i, X_AXIS);
	      else if ( ncdims[ncdimid].dimtype == Y_AXIS )
		cdfSetDim(ncvars, ncvarid, i, Y_AXIS);
	      else if ( ncdims[ncdimid].dimtype == Z_AXIS )
		cdfSetDim(ncvars, ncvarid, i, Z_AXIS);
	      else if ( ncdims[ncdimid].dimtype == T_AXIS )
		cdfSetDim(ncvars, ncvarid, i, T_AXIS);
	    }

	  if ( CDI_Debug )
	    {
	      Message(func, "var %d %s", ncvarid, ncvars[ncvarid].name);
	      for ( i = 0; i < ndims; i++ )
		printf("  dim %d type %d  ", i, ncvars[ncvarid].dimtype[i]);
	      printf("\n");
	    }

	  for ( i = 0; i < ndims; i++ )
	    {
	      if      ( ncvars[ncvarid].dimtype[i] == X_AXIS ) lxdim = TRUE;
	      else if ( ncvars[ncvarid].dimtype[i] == Y_AXIS ) lydim = TRUE;
	      else if ( ncvars[ncvarid].dimtype[i] == Z_AXIS ) lzdim = TRUE;
	      else if ( ncvars[ncvarid].dimtype[i] == T_AXIS ) ltdim = TRUE;
	    }

	  for ( i = ndims-1; i >= 0; i-- )
	    {
	      if ( ncvars[ncvarid].dimtype[i] == -1 )
		{
		  /*
		  printf("undef dim: %d %d %d %d %d\n", i, lxdim, lydim, lzdim, ltdim);
		  */
		  if ( lxdim == FALSE )
		    {
		      cdfSetDim(ncvars, ncvarid, i, X_AXIS);
		      lxdim = TRUE;
		    }
		  else if ( lydim == FALSE )
		    {
		      cdfSetDim(ncvars, ncvarid, i, Y_AXIS);
		      lydim = TRUE;
		    }
		  else if ( lzdim == FALSE )
		    {
		      cdfSetDim(ncvars, ncvarid, i, Z_AXIS);
		      lzdim = TRUE;
		    }
		}
	    }	    	  
	}
    }
  /* set coordinate varids (att: associate)  */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].isvar == TRUE )
	{
	  ndims = ncvars[ncvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      if ( ncvars[ncvarid].varids[i] != -1 )
		{
		  if ( ncvars[ncvars[ncvarid].varids[i]].islon )
		    ncvars[ncvarid].xvarid = ncvars[ncvarid].varids[i];
		  else if ( ncvars[ncvars[ncvarid].varids[i]].islat )
		    ncvars[ncvarid].yvarid = ncvars[ncvarid].varids[i];
		  else if ( ncvars[ncvars[ncvarid].varids[i]].islev )
		    ncvars[ncvarid].zvarid = ncvars[ncvarid].varids[i];
		}
	    }
	}
    }
  
  /* printNCvars(ncvars, nvars); */

  /* define grid */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].isvar && ncvars[ncvarid].gridID == UNDEFID )
	{
	  int xdimid = -1, ydimid = -1;
	  int xvarid = -1, yvarid = -1;
	  int islon = 0, islat = 0;
	  int nbdims;
	  double xinc = 0, yinc = 0;

	  xsize = 0;
	  ysize = 0;

	  ndims = ncvars[ncvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      if ( ncvars[ncvarid].dimtype[i] == X_AXIS )
		xdimid = ncvars[ncvarid].dimids[i];
	      else if ( ncvars[ncvarid].dimtype[i] == Y_AXIS )
		ydimid = ncvars[ncvarid].dimids[i];
	    }
	  
	  /*
	  if ( ncvars[ncvarid].xvarid != UNDEFID )
	    xvarid = ncvars[ncvarid].xvarid;
	  else if ( xdimid != UNDEFID )
	    xvarid = ncdims[xdimid].ncvarid;

	  if ( ncvars[ncvarid].yvarid != UNDEFID )
	    yvarid = ncvars[ncvarid].yvarid;
	  else if ( ydimid != UNDEFID )
	    yvarid = ncdims[ydimid].ncvarid;
	  */
	  
	  if ( xdimid != UNDEFID )
	    xvarid = ncdims[xdimid].ncvarid;
	  if ( xvarid == UNDEFID && ncvars[ncvarid].xvarid != UNDEFID )
	    xvarid = ncvars[ncvarid].xvarid;

	  if ( ydimid != UNDEFID )
	    yvarid = ncdims[ydimid].ncvarid;
	  if ( yvarid == UNDEFID && ncvars[ncvarid].yvarid != UNDEFID )
	    yvarid = ncvars[ncvarid].yvarid;

	  if ( xdimid != UNDEFID )
	    cdf_inq_dimlen(fileID, xdimid, &xsize);

	  if ( ydimid != UNDEFID )
	    cdf_inq_dimlen(fileID, ydimid, &ysize);

	  memset(&grid, 0, sizeof(GRID));

	  grid.prec = DATATYPE_REAL8;
	  grid.trunc = ncvars[ncvarid].truncation;
	  
	  if ( ncvars[ncvarid].gridtype == GRID_TRAJECTORY )
	    {
	      if ( ncvars[ncvarid].xvarid == UNDEFID )
		Error(func, "Longitude coordinate undefined for %s!", name);
	      if ( ncvars[ncvarid].yvarid == UNDEFID )
		Error(func, "Latitude coordinate undefined for %s!", name);
	    }
	  else
	    {
	      if ( xvarid != UNDEFID )
		{
		  islon = ncvars[xvarid].islon;
		  if ( ncvars[xvarid].ndims == 2 )
		    {
		      ncvars[ncvarid].gridtype = GRID_CURVILINEAR;
		      size = xsize*ysize;
		    }
		  else
		    {
		      size = xsize;
		    }
		  grid.xvals = (double *) malloc(size*sizeof(double));
		  if ( ncvars[xvarid].xtype == NC_FLOAT ) grid.prec = DATATYPE_REAL4;
		  cdf_get_var_double(fileID, xvarid, grid.xvals);
		  strcpy(grid.xname, ncvars[xvarid].name);
		  strcpy(grid.xlongname, ncvars[xvarid].longname);
		  strcpy(grid.xunits, ncvars[xvarid].units);
		  if ( (len = strlen(grid.xname)) > 2 )
		    if ( grid.xname[len-2] == '_' && isdigit((int) grid.xname[len-1]) )
		      grid.xname[len-2] = 0;

		  if ( islon && xsize > 1 )
		    {
		      xinc = fabs(grid.xvals[0] - grid.xvals[1]);
		      for ( i = 2; i < (int) xsize; i++ )
			if ( (fabs(grid.xvals[i-1] - grid.xvals[i]) - xinc) > (xinc/1000) ) break;
		  
		      if ( i < (int) xsize ) xinc = 0;
		    }
		}
	      if ( yvarid != UNDEFID )
		{
		  islat = ncvars[yvarid].islat;
		  if ( ncvars[yvarid].ndims == 2 )
		    {
		      ncvars[ncvarid].gridtype = GRID_CURVILINEAR;
		      size = xsize*ysize;
		    }
		  else
		    {
		      if ( (int) ysize == 0 ) size = xsize;
		      else                    size = ysize;
		    }

		  grid.yvals = (double *) malloc(size*sizeof(double));
		  if ( ncvars[yvarid].xtype == NC_FLOAT ) grid.prec = DATATYPE_REAL4;
		  cdf_get_var_double(fileID, yvarid, grid.yvals);
		  strcpy(grid.yname, ncvars[yvarid].name);
		  strcpy(grid.ylongname, ncvars[yvarid].longname);
		  strcpy(grid.yunits, ncvars[yvarid].units);
		  if ( (len = strlen(grid.yname)) > 2 )
		    if ( grid.yname[len-2] == '_' && isdigit((int) grid.yname[len-1]) )
		      grid.yname[len-2] = 0;

		  if ( islon && (int) ysize > 1 )
		    {
		      yinc = fabs(grid.yvals[0] - grid.yvals[1]);
		      for ( i = 2; i < (int) ysize; i++ )
			if ( (fabs(grid.yvals[i-1] - grid.yvals[i]) - yinc) > (yinc/1000) ) break;
		  
		      if ( i < (int) ysize ) yinc = 0;
		    }
		}

	      if      ( (int) ysize == 0 ) size = xsize;
	      else if ( (int) xsize == 0 ) size = ysize;
	      else                         size = xsize*ysize;
	    }

	  if ( ncvars[ncvarid].gridtype == UNDEFID )
	    {
	      if ( islat && islon )
		{
		  int lgauss = FALSE;
		  if ( yinc == 0 && (int) ysize > 2 ) /* check if gaussian */
		    {
		      double *yvals, *yw;
		      yvals = (double *) malloc(ysize*sizeof(double));
		      yw    = (double *) malloc(ysize*sizeof(double));
		      gaussaw(yvals, yw, ysize);
		      free(yw);
		      for ( i = 0; i < (int) ysize; i++ )
			yvals[i] = asin(yvals[i])/M_PI*180.0;

		      for ( i = 0; i < (int) ysize; i++ )
			if ( fabs(yvals[i] - grid.yvals[i]) >
			     ((yvals[0] - yvals[1])/500) ) break;
		      
		      if ( i == (int) ysize ) lgauss = TRUE;

		      /* check S->N */
		      if ( lgauss == FALSE )
			{		  
			  for ( i = 0; i < (int) ysize; i++ )
			    if ( fabs(yvals[i] - grid.yvals[ysize-i-1]) >
				 ((yvals[0] - yvals[1])/500) ) break;
		      
			  if ( i == (int) ysize ) lgauss = TRUE;
			}

		      free(yvals);
		    }

		  if ( lgauss )
		    ncvars[ncvarid].gridtype = GRID_GAUSSIAN;
		  else
		    ncvars[ncvarid].gridtype = GRID_LONLAT;
		}
	      else
		ncvars[ncvarid].gridtype = GRID_GENERIC;
	    }

	  switch (ncvars[ncvarid].gridtype)
	    {
	    case GRID_GENERIC:
	    case GRID_LONLAT:
	    case GRID_GAUSSIAN:
	    case GRID_CELL:
	    case GRID_CURVILINEAR:
	      {
		grid.size  = size;
		grid.xsize = xsize;
		grid.ysize = ysize;
		if ( xvarid != UNDEFID )
		  {
		    grid.xdef  = 1;
		    if ( ncvars[xvarid].bounds != UNDEFID )
		      {
			nbdims = ncvars[ncvars[xvarid].bounds].ndims;
			if ( nbdims == 2 || nbdims == 3 )
			  {
			    size_t nvertex;
			    cdf_inq_dimlen(fileID, ncvars[ncvars[xvarid].bounds].dimids[nbdims-1], &nvertex);
			    grid.nvertex = (int) nvertex;
			    grid.xbounds = (double *) malloc(nvertex*size*sizeof(double));
			    cdf_get_var_double(fileID, ncvars[xvarid].bounds, grid.xbounds);
			  }
		      }
		  }
		if ( yvarid != UNDEFID )
		  {
		    grid.ydef  = 1;
		    if ( ncvars[yvarid].bounds != UNDEFID )
		      {
			nbdims = ncvars[ncvars[yvarid].bounds].ndims;
			if ( nbdims == 2 || nbdims == 3 )
			  {
			    size_t nvertex;
			    cdf_inq_dimlen(fileID, ncvars[ncvars[yvarid].bounds].dimids[nbdims-1], &nvertex);
			    /*
			    if ( nvertex != grid.nvertex )
			      Warning(func, "nvertex problem! nvertex x %d, nvertex y %d",
				      grid.nvertex, (int) nvertex);
			    */
			    grid.ybounds = (double *) malloc(nvertex*size*sizeof(double));
			    cdf_get_var_double(fileID, ncvars[yvarid].bounds, grid.ybounds);
			  }
		      }
		  }

		if ( ncvars[ncvarid].cellarea != UNDEFID )
		  {
		    grid.area = (double *) malloc(size*sizeof(double));
		    cdf_get_var_double(fileID, ncvars[ncvarid].cellarea, grid.area);
		  }

		break;
	      }
	    case GRID_SPECTRAL:
	      {
		grid.size = size;
		break;
	      }
	    case GRID_TRAJECTORY:
	      {
		grid.size = 1;
		break;
	      }
	    }

	  grid.type = ncvars[ncvarid].gridtype;

	  if ( grid.size == 0 )
	    {
	      Warning(func, "Variable %s has unsupported grid, skipped!", ncvars[ncvarid].name);
	      ncvars[ncvarid].isvar = -1;
	      continue;
	    }

	  if ( ncvars[ncvarid].gmapid >= 0 )
	    {
	      cdf_inq_varnatts(fileID, ncvars[ncvarid].gmapid, &nvatts);

	      for ( iatt = 0; iatt < nvatts; iatt++ )
		{
		  cdf_inq_attname(fileID, ncvars[ncvarid].gmapid, iatt, attname);

		  if ( strcmp(attname, "grid_mapping_name") == 0 )
		    {
		      cdf_inq_attlen(fileID, ncvars[ncvarid].gmapid, attname, &attlen);
		      cdf_get_att_text(fileID, ncvars[ncvarid].gmapid, attname, attstring);
		      attstring[attlen] = 0;

		      if ( strcmp(attstring, "rotated_latitude_longitude") == 0 )
			grid.isRotated = TRUE;
		    }
		  else if ( strcmp(attname, "grid_north_pole_latitude") == 0 )
		    {
		      cdf_get_att_double(fileID, ncvars[ncvarid].gmapid, attname, &grid.ypole);
		    }
		  else if ( strcmp(attname, "grid_north_pole_longitude") == 0 )
		    {
		      cdf_get_att_double(fileID, ncvars[ncvarid].gmapid, attname, &grid.xpole);
		    }
		}

	      grid.angle  = 0.0;
	    }

	  ncvars[ncvarid].gridID = varDefGrid(vlistID, grid, 1);

	  gridindex = vlistGridIndex(vlistID, ncvars[ncvarid].gridID);
	  streams[streamID].xdimID[gridindex] = xdimid;
	  streams[streamID].ydimID[gridindex] = ydimid;

	  if ( grid.xvals )   free(grid.xvals);
	  if ( grid.yvals )   free(grid.yvals);
	  if ( grid.xbounds ) free(grid.xbounds);
	  if ( grid.ybounds ) free(grid.ybounds);
	  if ( grid.area )    free(grid.area);

	  if ( CDI_Debug )
	    Message(func, "gridID %d %d %s", ncvars[ncvarid].gridID, ncvarid, ncvars[ncvarid].name);

	  for ( ncvarid2 = ncvarid+1; ncvarid2 < nvars; ncvarid2++ )
	    if ( ncvars[ncvarid2].isvar == TRUE && ncvars[ncvarid2].gridID == UNDEFID )
	      {
		int xdimid2 = -1, ydimid2 = -1;
		ndims = ncvars[ncvarid2].ndims;
		for ( i = 0; i < ndims; i++ )
		  {
		    if ( ncvars[ncvarid2].dimtype[i] == X_AXIS )
		      xdimid2 = ncvars[ncvarid2].dimids[i];
		    else if ( ncvars[ncvarid2].dimtype[i] == Y_AXIS )
		      ydimid2 = ncvars[ncvarid2].dimids[i];
		  }
		if ( xdimid == xdimid2 && ydimid == ydimid2 )
		  {
		    if ( CDI_Debug )
		      Message(func, "gridID %d %d %s",
			      ncvars[ncvarid].gridID, ncvarid2, ncvars[ncvarid2].name);
		    ncvars[ncvarid2].gridID = ncvars[ncvarid].gridID;
		  }
	      }
	}
    }

  /* find VCT */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].ndims == 1 )
	{
	  if ( strncmp(ncvars[ncvarid].name, "hyai", 4) == 0 )
	    {
	      vcta_id = ncvarid;
	      nvcth_id = ncvars[ncvarid].dimids[0];
	      continue;
	    }
	  if ( strncmp(ncvars[ncvarid].name, "hybi", 4) == 0 )
	    {
	      vctb_id = ncvarid;
	      nvcth_id = ncvars[ncvarid].dimids[0];
	      continue;
	    }
	}
    }

  /* read VCT */
  if ( nvcth_id != UNDEFID && vcta_id != UNDEFID && vctb_id != UNDEFID )
    {
      cdf_inq_dimlen(fileID, nvcth_id, &vctsize);
      vctsize *= 2;
      vct = (double *) malloc(vctsize*sizeof(double));
      cdf_get_var_double(fileID, vcta_id, vct);
      cdf_get_var_double(fileID, vctb_id, vct+vctsize/2);
    }

  /* define zaxis */
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].isvar == TRUE && ncvars[ncvarid].zaxisID == UNDEFID )
	{
	  int zdimid = UNDEFID;
	  int zvarid = UNDEFID;
	  size_t zsize = 1;
	  double *zvar = NULL;
	  int zaxisType;

	  ndims = ncvars[ncvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      if ( ncvars[ncvarid].dimtype[i] == Z_AXIS )
		zdimid = ncvars[ncvarid].dimids[i];
	    }

	  if ( zdimid != UNDEFID )
	    zvarid = ncdims[zdimid].ncvarid;

	  if ( zdimid != UNDEFID )
	    cdf_inq_dimlen(fileID, zdimid, &zsize);

	  if ( CDI_Debug ) Message(func, "nlevs = %ld", zsize);
    
	  zvar = (double *) malloc(zsize*sizeof(double));

	  zaxisType = UNDEFID;

	  if ( zvarid != UNDEFID ) zaxisType = ncvars[zvarid].zaxistype;
	  
	  if ( zaxisType == UNDEFID )  zaxisType = ZAXIS_GENERIC;

	  zprec = DATATYPE_REAL8;

	  if ( zvarid != UNDEFID )
	    {
	      pname     = ncvars[zvarid].name;
	      plongname = ncvars[zvarid].longname;
	      punits    = ncvars[zvarid].units;
	      if ( ncvars[zvarid].xtype == NC_FLOAT ) zprec = DATATYPE_REAL4;
	      if ( (len = strlen(pname)) > 2 )
		if ( pname[len-2] == '_' && isdigit((int) pname[len-1]) )
		  pname[len-2] = 0;
	      
	      cdf_get_var_double(fileID, zvarid, zvar);
	    }
	  else
	    {
	      pname     = NULL;
	      plongname = NULL;
	      punits    = NULL;

	      if ( zsize == 1 )
		{
		  zaxisType = ZAXIS_SURFACE;
		  zvar[0] = 0;
		  /*
		  if ( zdimid == UNDEFID )
		    zvar[0] = 9999;
		  else
		    zvar[0] = 0;
		  */
		}
	      else
		{
		  for ( ilev = 0; ilev < (int)zsize; ilev++ ) zvar[ilev] = ilev + 1;
		}
	    }

      	  ncvars[ncvarid].zaxisID = varDefZaxis(vlistID, zaxisType, (int) zsize, zvar, 0, NULL, NULL,
						vctsize, vct, pname, plongname, punits, zprec, 1);
	  free(zvar);

	  zaxisindex = vlistZaxisIndex(vlistID, ncvars[ncvarid].zaxisID);
	  streams[streamID].zaxisID[zaxisindex]  = zdimid;	  

	  if ( CDI_Debug )
	    Message(func, "zaxisID %d %d %s", ncvars[ncvarid].zaxisID, ncvarid, ncvars[ncvarid].name);

	  for ( ncvarid2 = ncvarid+1; ncvarid2 < nvars; ncvarid2++ )
	    if ( ncvars[ncvarid2].isvar == TRUE && ncvars[ncvarid2].zaxisID == UNDEFID )
	      {
		int zdimid2 = -1;
		ndims = ncvars[ncvarid2].ndims;
		for ( i = 0; i < ndims; i++ )
		  {
		    if ( ncvars[ncvarid2].dimtype[i] == Z_AXIS )
		      zdimid2 = ncvars[ncvarid2].dimids[i];
		  }
		if ( zdimid == zdimid2 )
		  {
		    if ( CDI_Debug )
		      Message(func, "zaxisID %d %d %s",
			      ncvars[ncvarid].zaxisID, ncvarid2, ncvars[ncvarid2].name);
		    ncvars[ncvarid2].zaxisID = ncvars[ncvarid].zaxisID;
		  }
	      }
	}
    }

  if ( vct ) free(vct);

  /* select vars */
  varids = (int *) malloc(nvars*sizeof(int));
  for ( ncvarid = 0; ncvarid < nvars; ncvarid++ )
    {
      if ( ncvars[ncvarid].isvar == TRUE ) varids[nvarids++] = ncvarid;
    }
  nc_nvars = nvars;

  if ( CDI_Debug )
    Message(func, "time varid = %d", streams[streamID].basetime.ncvarid);

  if ( CDI_Debug )
    Message(func, "ntsteps = %d", streams[streamID].ntsteps);

  nvars = nvarids;
  if ( CDI_Debug )
    Message(func, "nvars = %d", nvars);

  for ( varID1 = 0; varID1 < nvars; varID1++ )
    {
      ncvarid = varids[varID1];

      varID = streamNewVar(streamID, ncvars[ncvarid].gridID, ncvars[ncvarid].zaxisID);
      varID = vlistDefVar(vlistID, ncvars[ncvarid].gridID, ncvars[ncvarid].zaxisID, ncvars[ncvarid].timeID);

      streams[streamID].vars[varID1].level   = NULL;
      streams[streamID].vars[varID1].defmiss = 0;
      streams[streamID].vars[varID1].nlevs   = zaxisInqSize(ncvars[ncvarid].zaxisID);
      streams[streamID].vars[varID1].ncvarid = ncvarid;

      vlistDefVarName(vlistID, varID, ncvars[ncvarid].name);
      if ( ncvars[ncvarid].code != UNDEFID )  vlistDefVarCode(vlistID, varID, ncvars[ncvarid].code);
      if ( ncvars[ncvarid].longname[0] )      vlistDefVarLongname(vlistID, varID, ncvars[ncvarid].longname);
      if ( ncvars[ncvarid].units[0] )         vlistDefVarUnits(vlistID, varID, ncvars[ncvarid].units);
      if ( ncvars[ncvarid].addoffset != 0 )   vlistDefVarAddoffset(vlistID, varID, ncvars[ncvarid].addoffset);
      if ( ncvars[ncvarid].scalefactor != 1 ) vlistDefVarScalefactor(vlistID, varID, ncvars[ncvarid].scalefactor);

      vlistDefVarDatatype(vlistID, varID, cdfInqDatatype(ncvars[ncvarid].xtype));

      vlistDefVarInstitut(vlistID, varID, instID);
      vlistDefVarModel(vlistID, varID, modelID);
      vlistDefVarTable(vlistID, varID, ncvars[ncvarid].tableID);

      if ( ncvars[ncvarid].defmiss == TRUE ) vlistDefVarMissval(vlistID, varID, ncvars[ncvarid].missval);

      if ( CDI_Debug )
	Message(func, "varID = %d  gridID = %d  zaxisID = %d", varID,
		vlistInqVarGrid(vlistID, varID), vlistInqVarZaxis(vlistID, varID));
    }

  if ( varids ) free(varids);

  for ( varID = 0; varID < nvars; varID++ )
    {
      if ( vlistInqVarCode(vlistID, varID) == -varID-1 )
	{
	  char *pname;
	  pname = vlistInqVarNamePtr(vlistID, varID);
	  len = strlen(pname);
	  if ( len > 3 && isdigit((int) pname[3]) )
	    if ( strncmp("var", pname, 3) == 0 )
	      {
		vlistDefVarCode(vlistID, varID, atoi(pname+3));
		vlistFreeVarName(vlistID, varID);
	      }
	}
      if ( vlistInqVarCode(vlistID, varID) == -varID-1 )
	{
	  char *pname;
	  pname = vlistInqVarNamePtr(vlistID, varID);
	  len = strlen(pname);
	  if ( len > 4 && isdigit((int) pname[4]) )
	    if ( strncmp("code", pname, 4) == 0 )
	      {
		vlistDefVarCode(vlistID, varID, atoi(pname+4));
		vlistFreeVarName(vlistID, varID);
	      }
	}
    }

  for ( varID = 0; varID < nvars; varID++ )
    {
      instID  = vlistInqVarInstitut(vlistID, varID);
      modelID = vlistInqVarModel(vlistID, varID);
      tableID = vlistInqVarTable(vlistID, varID);
      code    = vlistInqVarCode(vlistID, varID);
      if ( cdiDefaultTableID != UNDEFID )
	{
	  if ( tableInqParNamePtr(cdiDefaultTableID, code) )
	    {
	      vlistFreeVarName(vlistID, varID);
	      vlistFreeVarLongname(vlistID, varID);
	      vlistFreeVarUnits(vlistID, varID);

	      if ( tableID != UNDEFID )
		{
		  vlistDefVarName(vlistID, varID, tableInqParNamePtr(cdiDefaultTableID, code));
		  if ( tableInqParLongnamePtr(cdiDefaultTableID, code) )
		    vlistDefVarLongname(vlistID, varID, tableInqParLongnamePtr(cdiDefaultTableID, code));
		  if ( tableInqParUnitsPtr(cdiDefaultTableID, code) )
		    vlistDefVarUnits(vlistID, varID, tableInqParUnitsPtr(cdiDefaultTableID, code));
		}
	      else
		{
		  tableID = cdiDefaultTableID;
		}
	    }
	  if ( cdiDefaultModelID != UNDEFID )
	    modelID = cdiDefaultModelID;
	  if ( cdiDefaultInstID != UNDEFID )
	    instID = cdiDefaultInstID;
	}
      if ( instID  != UNDEFID ) vlistDefVarInstitut(vlistID, varID, instID);
      if ( modelID != UNDEFID ) vlistDefVarModel(vlistID, varID, modelID);
      if ( tableID != UNDEFID ) vlistDefVarTable(vlistID, varID, tableID);
    }

  cdiCreateTimesteps(streamID);

  /* time varID */
  ncvarid = streams[streamID].basetime.ncvarid;

  if ( timehasunit )
    {
      TAXIS *taxis;
      taxis = &streams[streamID].tsteps[0].taxis;

      cdf_inq_attlen(fileID, ncvarid, "units", &attlen);
      cdf_get_att_text(fileID, ncvarid, "units", attstring);
      attstring[attlen] = 0;
      if ( splitBasetime(attstring, taxis) == 1 )
	streams[streamID].basetime.ncvarid = UNDEFID;
    }

  if ( ncvarid != -1 )
    if ( ncvars[ncvarid].calendar == TRUE )
      {
	cdf_inq_attlen(fileID, ncvarid, "calendar", &attlen);
	cdf_get_att_text(fileID, ncvarid, "calendar", attstring);
	attstring[attlen] = 0;

	if ( strcmp(attstring, "standard")  == 0 ||
	     strcmp(attstring, "gregorian") == 0 )
	  calendar = CALENDAR_STANDARD;
	else if ( strcmp(attstring, "none") == 0 )
	  calendar = CALENDAR_NONE;
	else if ( strncmp(attstring, "360", 3) == 0 )
	  calendar = CALENDAR_360DAYS;
	else if ( strncmp(attstring, "365", 3) == 0 ||
		  strcmp(attstring, "noleap")  == 0 )
	  calendar = CALENDAR_365DAYS;
	else if ( strncmp(attstring, "366", 3)  == 0 ||
		  strcmp(attstring, "all_leap") == 0 )
	  calendar = CALENDAR_366DAYS;
	else
	  Warning(func, "calendar >%s< unsupported!", attstring);
      }

  if ( streams[streamID].tsteps[0].taxis.type == TAXIS_RELATIVE )
    taxisID = taxisNew(TAXIS_RELATIVE);
  else
    taxisID = taxisNew(TAXIS_ABSOLUTE);

  if ( calendar != UNDEFID )
    {
      TAXIS *taxis;
      taxis = &streams[streamID].tsteps[0].taxis;

      taxis->calendar = calendar;
      taxisDefCalendar(taxisID, calendar);
    }

  vlistDefTaxis(vlistID, taxisID);

  streams[streamID].curTsID = 0;
  streams[streamID].rtsteps = 1;

  (void) cdfInqTimestep(streamID, 0);

  cdfCreateRecords(streamID, 0);

  /* free ncdims */
  free (ncdims);

  /* free ncvars */
  free (ncvars);

#endif
}

int cdfInqTimestep(int streamID, int tsID)
{
  static char func[] = "cdfInqTimestep";
  long nrecs = 0;
#if  defined  (HAVE_LIBNETCDF)
  double timevalue;
  int nctimevarid;
  int fileID;
  size_t index;
  int vdate = 0, vtime = 0;

  if ( CDI_Debug )
    Message(func, "streamID = %d  tsID = %d", streamID, tsID);

  streamCheckID(func, streamID);
    
  if ( tsID < 0 ) Error(func, "unexpected tsID = %d", tsID);

  if ( tsID < streams[streamID].ntsteps && streams[streamID].ntsteps > 0 )
    {
      cdfCreateRecords(streamID, tsID);

      if ( tsID > 0 )
	ptaxisCopy(&streams[streamID].tsteps[tsID].taxis,
		   &streams[streamID].tsteps[0].taxis);

      timevalue = tsID;

      nctimevarid = streams[streamID].basetime.ncvarid;
      if ( nctimevarid != UNDEFID )
	{
	  fileID = streamInqFileID(streamID);
	  index  = tsID;
	  cdf_get_var1_double(fileID, nctimevarid, &index, &timevalue);
	}

      if ( streams[streamID].tsteps[0].taxis.type == TAXIS_ABSOLUTE )
	{
	  int timeunit;
	  timeunit = streams[streamID].tsteps[0].taxis.unit;
	  splitTimevalue(timevalue, timeunit, &vdate, &vtime);
	}
      else
	timeval2vtime(timevalue, &streams[streamID].tsteps[tsID].taxis, &vdate, &vtime);

      streams[streamID].tsteps[tsID].taxis.vdate = vdate;
      streams[streamID].tsteps[tsID].taxis.vtime = vtime;
    }

  streams[streamID].curTsID = tsID;
  nrecs = streams[streamID].tsteps[tsID].nrecs;

#endif
  return ((int) nrecs);
}

void cdfEndDef(int streamID)
{
  int varID, ncvarid;
  int nvars;

  cdfDefGlobalAtts(streamID);
  cdfDefLocalAtts(streamID);
  if ( streams[streamID].accessmode == 0 )
    {
      nvars =  streams[streamID].nvars;

      for ( varID = 0; varID < nvars; varID++ )
	{
	  ncvarid = cdfDefVar(streamID, varID);
	}
      streams[streamID].accessmode = 1;
    }
}

void cdfDefInstitut(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  int fileID, instID;
  char *longname;
  size_t len;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);
  instID  = vlistInqInstitut(vlistID);

  if ( instID != UNDEFID )
    {
      longname = institutInqLongnamePtr(instID);
      if ( longname )
	{
	  len = strlen(longname);
	  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);
	  cdf_put_att_text(fileID, NC_GLOBAL, "institution", len, longname);
	  if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);
	}
    }
#endif
}

void cdfDefSource(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  int fileID, modelID;
  char *longname;
  size_t len;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);
  modelID = vlistInqModel(vlistID);

  if ( modelID != UNDEFID )
    {
      longname = modelInqNamePtr(modelID);
      if ( longname )
	{
	  len = strlen(longname);
	  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);
	  cdf_put_att_text(fileID, NC_GLOBAL, "source", len, longname);
	  if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);
	}
    }
#endif
}

void cdfDefGlobalAtts(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  int fileID, vlistID;
  int iatt;
  size_t len;

  if ( streams[streamID].globalatts ) return;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  if ( vlist[vlistID].natts > 0 )
    {
      if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);
      for ( iatt = 0; iatt < vlist[vlistID].natts; iatt++ )
	{
	  if ( vlist[vlistID].attstrings[iatt] )
	    {
	      len = strlen(vlist[vlistID].attstrings[iatt]);
	      cdf_put_att_text(fileID, NC_GLOBAL, vlist[vlistID].attnames[iatt],
			       len, vlist[vlistID].attstrings[iatt]);
	    }
	}
      if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);
    }

  cdfDefSource(streamID);
  cdfDefInstitut(streamID);

  streams[streamID].globalatts = 1;
#endif
}

void cdfDefLocalAtts(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  int varID, instID, fileID;
  char *name;
  size_t len;
  int ncvarid;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  if ( streams[streamID].localatts ) return;
  if ( vlistInqInstitut(vlistID) != UNDEFID ) return;

  streams[streamID].localatts = 1;

  if ( streams[streamID].ncmode == 2 ) cdf_redef(fileID);

  for ( varID = 0; varID < streams[streamID].nvars; varID++ )
    {
      instID = vlistInqVarInstitut(vlistID, varID);
      if ( instID != UNDEFID )
	{
          ncvarid = streams[streamID].vars[varID].ncvarid;
  	  name = institutInqNamePtr(instID);
	  if ( name )
	    {
	      len = strlen(name);
	      cdf_put_att_text(fileID, ncvarid, "institution", len, name);
	    }
	}
      }
  
  if ( streams[streamID].ncmode == 2 ) cdf_enddef(fileID);
#endif
}

void cdfDefHistory(int streamID, int size, char *history)
{
#if  defined  (HAVE_LIBNETCDF)
  int ncid;

  ncid = streams[streamID].fileID;
  cdf_put_att_text(ncid, NC_GLOBAL, "history", (size_t) size, history);
#endif
}

int cdfInqHistorySize(int streamID)
{
  size_t size = 0;
#if  defined  (HAVE_LIBNETCDF)
  int ncid;

  ncid = streams[streamID].fileID;
  if ( streams[streamID].historyID != UNDEFID )
    cdf_inq_attlen(ncid, NC_GLOBAL, "history", &size);

#endif
  return ((int) size);
}

void cdfInqHistoryString(int streamID, char *history)
{
#if  defined  (HAVE_LIBNETCDF)
  int ncid;

  ncid = streams[streamID].fileID;
  if ( streams[streamID].historyID != UNDEFID )
    cdf_get_att_text(ncid, NC_GLOBAL, "history", history);

#endif
}

void cdfDefVars(int streamID)
{
#if  defined  (HAVE_LIBNETCDF)
  static char func[] = "cdfDefVars";
  int index, gridID, zaxisID, vlistID;
  int nvars, ngrids, nzaxis;
  /*
  int  ncvarid;
  */

  vlistID = streamInqVlist(streamID);
  if ( vlistID == UNDEFID )
    Error(func, "Internal problem! vlist undefined for streamID %d\n", streamID);

  nvars  = vlistNvars(vlistID);
  ngrids = vlistNgrids(vlistID);
  nzaxis = vlistNzaxis(vlistID);
  /*
  if ( vlistHasTime(vlistID) ) cdfDefTime(streamID);
  */
  for ( index = 0; index < ngrids; index++ )
    {
      gridID = vlistGrid(vlistID, index);
      cdfDefGrid(streamID, gridID);
    }

  for ( index = 0; index < nzaxis; index++ )
    {
      zaxisID = vlistZaxis(vlistID, index);
      if ( streams[streamID].zaxisID[index] == UNDEFID ) cdfDefZaxis(streamID, zaxisID);
    }
  /*
    define time first!!!
  for (varID = 0; varID < nvars; varID++ )
    {
      ncvarid = cdfDefVar(streamID, varID);
    }
  */
#endif
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#if  defined  (HAVE_LIBHDF5)
#  include "hdf5.h"
#endif

#undef  UNDEFID
#define UNDEFID  CDI_UNDEFID

#define NC_BYTE     1
#define NC_CHAR     1
#define NC_SHORT    2
#define NC_FLOAT    4


void hdfDefTime(int streamID);
int  hdfDefVar(int streamID, int varid);
void hdfDefGlobalAtts(int streamID);
void hdfDefLocalAtts(int streamID);


#define  DIMTYPE_GX  1
#define  DIMTYPE_GY  2
#define  DIMTYPE_Z   3
#define  DIMTYPE_T   4

typedef struct {
  int     ncvarid;
  int     dimtype;
  size_t  len;
  char    name[128];
}
HDFDIM;

typedef struct {
  int     objID;
  int     isvar;
  int     islon;
  int     islat;
  int     islev;
  int     warn;
  int     timeID;
  int     code;
  int     bounds;
  int     gridID;
  int     zaxisID;
  int     gridtype;
  int     zaxistype;
  int     xdim;
  int     ydim;
  int     zdim;
  int     xvarid;
  int     yvarid;
  int     cellarea;
  int     tableID;
  int     truncation;
  int     defmiss;
  int     xtype;
  int     ndims;
  int     dimids[8];
  int     dimtype[8];
  size_t  vlen;
  double  levelscale;
  double *vdata;
  double  missval;
  double  addoffset;
  double  scalefactor;
  char    name[128];
  char    longname[128];
  char    units[128];
}
HDFVAR;

#if defined (XYZ)
static void splitTimevalue(double timevalue, int timeunit, int *date, int *time)
{
  static char func[] = "splitTimevalue";
  int vdate, vtime;
  int hour, minute;

  if ( timeunit == TUNIT_HOUR )
    {
      timevalue /= 24;
      vdate = (int) timevalue;
      vtime = (int) ((timevalue - vdate)*1440 + 0.01);

      hour   = vtime / 60;
      minute = vtime - hour*60;
      vtime  = hour*100 + minute;
    }
  else if ( timeunit == TUNIT_DAY )
    {
      vdate = (int) timevalue;
      vtime = (int) ((timevalue - vdate)*1440 + 0.01);

      hour   = vtime / 60;
      minute = vtime - hour*60;
      vtime  = hour*100 + minute;
    }
  else if ( timeunit == TUNIT_MONTH )
    {
      vdate = (int) timevalue*100;
      vtime = 0;
    }
  else
    {
      Message(func, "Unsupported TIMEUNIT %s!", tunitNamePtr(timeunit));
      return;
    }

  *date = vdate;
  *time = vtime;
}

static int splitBasetime(char *timeunits, TAXIS *taxis)
{
  static char func[] = "splitBasetime";
  int len;
  char *ptu;
  int year, month, day;
  int hour = 0, minute = 0, second = 0;
  int timetype = TAXIS_ABSOLUTE;
  int rdate = -1, rtime = -1;
  int timeunit = -1;

  ptu = timeunits;
  len = strlen(timeunits);

  (*taxis).type = timetype;

  if      ( strncmp(ptu, "sec",    3) == 0 ) timeunit = TUNIT_SECOND;
  else if ( strncmp(ptu, "minute", 6) == 0 ) timeunit = TUNIT_MINUTE;
  else if ( strncmp(ptu, "hour",   4) == 0 ) timeunit = TUNIT_HOUR;
  else if ( strncmp(ptu, "day",    3) == 0 ) timeunit = TUNIT_DAY;
  else if ( strncmp(ptu, "month",  5) == 0 ) timeunit = TUNIT_MONTH;
  else if ( strncmp(ptu, "calendar_month", 14) == 0 ) timeunit = TUNIT_MONTH;
  else if ( strncmp(ptu, "year",   4) == 0 ) timeunit = TUNIT_YEAR;
  else
    {
      Message(func, "Unsupported TIMEUNIT %s!", ptu);
      return (1);
    }

  while ( ! isspace(*ptu) ) ptu++;
  while (   isspace(*ptu) ) ptu++;

  if ( strncmp(ptu, "as", 2) == 0 )
    timetype = TAXIS_ABSOLUTE;
  else if ( strncmp(ptu, "since", 5) == 0 )
    timetype = TAXIS_RELATIVE;

  while ( ! isspace(*ptu) ) ptu++;
  while (   isspace(*ptu) ) ptu++;

  if ( timetype == TAXIS_ABSOLUTE )
    {
      if ( strncmp(ptu, "%Y%m%d.%f", 9) == 0 && timeunit == TUNIT_DAY )
	{
	  (*taxis).type = timetype;
	  (*taxis).unit = timeunit;
	}
      else if ( strncmp(ptu, "%Y%m.%f", 9) == 0 && timeunit == TUNIT_MONTH )
	{ 
	  (*taxis).type = timetype;
	  (*taxis).unit = timeunit;
	}
      else
	{
	  (*taxis).type = timetype;
	  (*taxis).unit = timeunit;
	  /*
	  Message(func, "Unsupported TIMEUNIT %s!", ptu);
	  return (1);
	  */
	}
    }
  else if ( timetype == TAXIS_RELATIVE )
    {
      year = atoi(ptu);
      while ( isdigit((int) *ptu) ) ptu++;
      month = atoi(++ptu);
      while ( isdigit((int) *ptu) ) ptu++;
      day = atoi(++ptu);
      while ( isdigit((int) *ptu) ) ptu++;

      while ( ! isdigit((int) *ptu) ) ptu++;

      hour = atoi(ptu);
      while ( isdigit((int) *ptu) ) ptu++;
      if ( *ptu == ':' )
	{
	  ptu++;
	  minute = atoi(ptu);
	  while ( isdigit((int) *ptu) ) ptu++;
	  if ( *ptu == ':' )
	    {
	      ptu++;
	      second = atoi(ptu);
	      if ( second != 0 )
		Message(func, "Seconds not supported in time units!");
	    }
	}

      (*taxis).type = timetype;

      rdate = year*10000 + month*100 + day;
      rtime = hour*100 + minute;
      (*taxis).rdate = rdate;
      (*taxis).rtime = rtime;
      (*taxis).unit  = timeunit;
    }

  if ( CDI_Debug )
    Message(func, "timetype = %d  unit = %d", timetype, timeunit);

  return (0);
}
#endif /*XYZ*/

void hdfDefDimgroup(int streamID)
{
#if  defined  (HAVE_LIBHDF5)
  int fileID;
  int hgid;

  fileID = streamInqFileID(streamID);

  hgid = H5Gcreate(fileID, "coordinates", 0);

  streamDefDimgroupID(streamID, hgid);
#endif
}

#if defined (XYZ)

#if  defined  (HAVE_LIBHDF5)
int hdfInqDatatype(int xtype)
{
  int datatype;

  if      ( xtype == H5T_NATIVE_CHAR  )  datatype = DATATYPE_INT1;
  else if ( xtype == H5T_NATIVE_SHORT )  datatype = DATATYPE_INT2;
  else if ( xtype == H5T_NATIVE_INT   )  datatype = DATATYPE_INT4;
  else if ( xtype == H5T_NATIVE_FLOAT )  datatype = DATATYPE_REAL4;
  else                                   datatype = DATATYPE_REAL8;

  return (datatype);
}
#endif
#endif /*XYZ*/

#if  defined  (HAVE_LIBHDF5)
int hdfDefDatatype(int datatype)
{
  int xtype;

  if      ( datatype == DATATYPE_INT1  )  xtype = H5T_NATIVE_CHAR;
  else if ( datatype == DATATYPE_INT2  )  xtype = H5T_NATIVE_SHORT;
  else if ( datatype == DATATYPE_INT4  )  xtype = H5T_NATIVE_INT;
  else if ( datatype == DATATYPE_REAL8 )  xtype = H5T_NATIVE_DOUBLE;
  else                                    xtype = H5T_NATIVE_FLOAT;

  return (xtype);
}
#endif

#if defined (XYZ)

int hdfCopyRecord(int ostreamID, int istreamID)
{
  static char func[] = "hdfCopyRecord";
  double *data;
  size_t datasize;
  int itsID, otsID, irecID, orecID;
  int ivarID, gridID;
  int nmiss;
  int ierr = 0;
  int ivlistID, ovlistID;

  streamCheckID(func, istreamID);
  streamCheckID(func, ostreamID);

  ivlistID = streams[istreamID].vlistID;
  ovlistID = streams[ostreamID].vlistID;

  itsID = streams[istreamID].curTsID;
  otsID = streams[ostreamID].curTsID;

  irecID = streams[istreamID].tsteps[itsID].curRecID;
  orecID = streams[ostreamID].tsteps[otsID].curRecID;

  ivarID = streams[istreamID].tsteps[itsID].records[irecID].varID;

  gridID = vlistInqVarGrid(ivlistID, ivarID);

  datasize = gridInqSize(gridID);      

  data = (double *) malloc(datasize*sizeof(double));

  streamReadRecord(istreamID, data, &nmiss);
  streamWriteRecord(ostreamID, data, nmiss);

  free(data);

  return (ierr);
}

int hdfInqRecord(int streamID, int *varID, int *levelID)
{
  static char func[] = "hdfInqRecord";
  int tsID, recID;

  streamCheckID(func, streamID);

  tsID = 
  recID = streams[streamID].tsteps[0].curRecID++;

  if ( streams[streamID].tsteps[0].curRecID >= 
       streams[streamID].tsteps[0].nrecords )
    {
      streams[streamID].tsteps[0].curRecID = 0;
      /*     return (0);*/
    }

  *varID   = streams[streamID].tsteps[0].records[recID].varID;
  *levelID = streams[streamID].tsteps[0].records[recID].levelID;

  streams[streamID].record->varID = *varID;
  streams[streamID].record->levelID = *levelID;

  if ( CDI_Debug )
    Message(func, "recID = %d  varID = %d  levelID = %d",
	    recID, *varID, *levelID);
  
  return (recID+1);
}
#endif /*XYZ*/

int hdfDefRecord(int streamID)
{
  static char func[] = "hdfDefRecord";
  int ierr = 0;

  if ( CDI_Debug )
    Message(func, "streamID = %d", streamID);

  streamCheckID(func, streamID);

  return (ierr);
}

#if defined (XYZ)
void hdfWriteGridTraj(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  int tsID, fileID;
  int lonID, latID, gridindex;
  size_t index;
  double xlon, xlat;

  fileID = streamInqFileID(streamID);

  gridindex = vlistGridIndex(vlistID, gridID);
  lonID = streams[streamID].xdimID[gridindex];
  latID = streams[streamID].ydimID[gridindex];

  xlon = gridInqXval(gridID, 0);
  xlat = gridInqYval(gridID, 0);
  tsID = streams[streamID].curTsID;
  index = tsID;

  hdf_put_var1_double(fileID, lonID, &index, &xlon);
  hdf_put_var1_double(fileID, latID, &index, &xlat);
#endif
}

void hdfReadGridTraj(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  int tsID, fileID;
  int lonID, latID, gridindex;
  size_t index;
  double xlon, xlat;

  fileID = streamInqFileID(streamID);

  gridindex = vlistGridIndex(vlistID, gridID);
  lonID = streams[streamID].xdimID[gridindex];
  latID = streams[streamID].ydimID[gridindex];

  tsID = streams[streamID].curTsID;
  index = tsID;

  hdf_get_var1_double(fileID, lonID, &index, &xlon);
  hdf_get_var1_double(fileID, latID, &index, &xlat);

  gridDefXvals(gridID, &xlon);
  gridDefYvals(gridID, &xlat);
#endif
}

void hdfDefMissval(int streamID, int varID, int dtype)
{
#if  defined  (HAVE_LIBHDF5)
  if ( streams[streamID].vars[varID].defmiss == FALSE )
    {
      int fileID;
      int ncvarid;
      double missval;

      fileID  = streamInqFileID(streamID);
      ncvarid = streams[streamID].vars[varID].ncvarid;
      missval = vlistInqVarMissval(vlistID, varID);
      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      if ( dtype == DATATYPE_REAL8 )
	hdf_put_att_double(fileID, ncvarid, "_FillValue", H5T_NATIVE_DOUBLE, 1L, &missval);
      else
	hdf_put_att_double(fileID, ncvarid, "_FillValue", NC_FLOAT, 1L, &missval);
      if ( streams[streamID].ncmode == 2 ) hdf_enddef(fileID);

      streams[streamID].vars[varID].defmiss = TRUE;
    }
#endif
}
#endif /*XYZ*/

void hdfWriteRecord(int streamID, double *data, int nmiss)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfWriteRecord";
  int fileID;
  int gridID;
  int zaxisID;
  int zid = UNDEFID;
  int ncvarid;
  int ntsteps;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int varID;
  int timeID;
  int gridindex, zaxisindex;
  int i;
  int dtype;
  int levelID;
  hsize_t hsize[9];
  int status;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  varID   = streams[streamID].record->varID;
  levelID = streams[streamID].record->levelID;
  
  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  fileID  = streamInqFileID(streamID);

  ntsteps = streams[streamID].ntsteps;
  if ( CDI_Debug )
    Message(func, "ntsteps = %d", ntsteps); 

  if ( vlistHasTime(vlistID) ) hdfDefTime(streamID);

  ncvarid = hdfDefVar(streamID, varID);

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  /*
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      hdfWriteGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }
  */

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = ntsteps - 1;
      count[ndims] = 1;
      hsize[ndims] = ntsteps;
      ndims++;
    }
  /*
  if ( zid != UNDEFID )
    {
      start[ndims] = levelID;
      count[ndims] = 1;
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      hdf_inq_dimlen(fileID, yid, &size);
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      hdf_inq_dimlen(fileID, xid, &size);
      count[ndims] = size;
      ndims++;
    }
  */
  if ( zaxisID != UNDEFID )
    {
      size_t size = zaxisInqSize(zaxisID);
      if ( ! (zaxisInqType(zaxisID) == ZAXIS_SURFACE && size == 1) )
	{
	  start[ndims] = levelID;
	  count[ndims] = 1;
	  hsize[ndims] = size;
	  ndims++;
	}
    }
  if ( gridID != UNDEFID )
    {
      int xsize, ysize;
      if ( gridInqType(gridID) == GRID_SPECTRAL )
	{
	  xsize = 2;
	  ysize = gridInqSize(gridID)/2;
	}
      else
	{
	  xsize = gridInqXsize(gridID);
	  ysize = gridInqYsize(gridID);
	}
      start[ndims] = 0;
      count[ndims] = ysize;
      hsize[ndims] = ysize;
      ndims++;
      start[ndims] = 0;
      count[ndims] = xsize;
      hsize[ndims] = xsize;
      ndims++;
    }


  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  dtype = vlistInqVarDatatype(vlistID, varID);

  /*
  if ( nmiss > 0 ) hdfDefMissval(streamID, varID, dtype);
  */

  if ( dtype == DATATYPE_INT1 || dtype == DATATYPE_INT2 || dtype == DATATYPE_INT4 )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;

      addoffset   = vlistInqVarAddoffset(vlistID, varID);
      scalefactor = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = (fabs(addoffset   - 0.0) > 0.0);
      lscalefactor = (fabs(scalefactor - 1.0) > 0.0);

      if ( laddoffset || lscalefactor )
	{
	  gridID   = vlistInqVarGrid(vlistID, varID);
	  size     = gridInqSize(gridID);

	  for ( i = 0; i < (int) size; i++ )
	    {
	      if ( laddoffset )   data[i] = data[i] - addoffset;
	      if ( lscalefactor ) data[i] = data[i] / scalefactor;
	    }
	}
    }

  if ( levelID == 0 )
    status = H5Dextend(ncvarid, hsize);

  hdf_put_vara_double(fileID, ncvarid, start, count, data);
#endif
}
#if defined (XYZ)

int hdfReadRecord(int streamID, double *data, int *nmiss)
{
  static char func[] = "hdfReadRecord";
  int ierr = 0;
  int levelID, varID, tsID, recID, gridID;
  int size, i;
  int laddoffset, lscalefactor;
  double addoffset, scalefactor;

  if ( CDI_Debug ) Message(func, "streamID = %d", streamID);

  tsID    = streams[streamID].curTsID;
  recID   = streams[streamID].tsteps[tsID].curRecID;
  varID   = streams[streamID].tsteps[tsID].records[recID].varID;
  levelID = streams[streamID].tsteps[tsID].records[recID].levelID;

  hdfReadVarSliceDP(streamID, varID, levelID, data, nmiss);

  addoffset   = vlistInqVarAddoffset(vlistID, varID);
  scalefactor = vlistInqVarScalefactor(vlistID, varID);
  laddoffset   = (fabs(addoffset) > 0.0);
  lscalefactor = (fabs(scalefactor - 1.0) > 0.0);

  if ( laddoffset || lscalefactor )
    {
      gridID   = vlistInqVarGrid(vlistID, varID);
      size     = gridInqSize(gridID);
      
      for ( i = 0; i < size; i++ )
	{
	  if ( lscalefactor ) data[i] = data[i] * scalefactor;
	  if ( laddoffset )   data[i] = data[i] + addoffset;
	}
    }

  return (ierr);
}
#endif /*XYZ*/

void hdfDefTimeValue(int streamID, int date, int time)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfDefTimeValue";
  int fileID, tsID;
  int hour, minute;
  double timevalue;
  int timevarid;
  size_t index;
  hsize_t hsize[1];
  int status;

  fileID = streamInqFileID(streamID);

  if ( CDI_Debug )
    Message(func, "streamID = %d, fileID = %d", streamID, fileID);

  tsID = streams[streamID].curTsID;

  hour   = time / 100;
  minute = time - hour*100;

  if ( streams[streamID].tsteps[0].taxis.type == TAXIS_ABSOLUTE )
    {
      if ( streams[streamID].tsteps[0].taxis.unit == TUNIT_MONTH )
	{
	  timevalue = date/100 + 0.5;
	}
      else
	timevalue = date + (hour*60 + minute)/1440.;
    }
  else
    timevalue = vtime2timeval(date, time, &streams[streamID].tsteps[0].taxis);

  if ( CDI_Debug )
    Message(func, "tsID = %d  timevalue = %f", tsID, timevalue);

  timevarid = streams[streamID].basetime.ncvarid;
  /*
  if ( streams[streamID].ncmode == 1 )
    {
      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }
  */
  index = tsID;

  hsize[0] = tsID+1;
  status = H5Dextend(timevarid, hsize);

  hdf_put_var1_double(fileID, timevarid, &index, &timevalue);
  /*
printf("fileID = %d %d %d %f\n", fileID, timevarid, index, timevalue);
  */
#endif
}

void hdfDefTimestep(int streamID, int tsID)
{
  int vdate, vtime;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  vdate = streams[streamID].tsteps[tsID].taxis.vdate;
  vtime = streams[streamID].tsteps[tsID].taxis.vtime;

  if ( vlistHasTime(vlistID) ) hdfDefTime(streamID);

  hdfDefTimeValue(streamID, vdate, vtime);
}

void hdfDefTime(int streamID)
{
#if  defined  (HAVE_LIBHDF5)
  int fileID;
  int varid;
  int dims[1];
  int year, month, day, hour, minute;
  char unitstring[80];
  int plistid;
  hsize_t cdims[1];

  if ( streams[streamID].basetime.ncvarid != UNDEFID ) return;

  /*  fileID = streamInqFileID(streamID); */
  fileID = streamInqDimgroupID(streamID);

  if ( streams[streamID].ncmode == 0 ) streams[streamID].ncmode = 1;

  /*
  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
  hdf_def_dim(fileID, "time", -1, &streams[streamID].basetime.ncdimid);
  dims[0] = streams[streamID].basetime.ncdimid;
  */
  dims[0] = -1;
  cdims[0] = 1;
  plistid = H5Pcreate(H5P_DATASET_CREATE);
  H5Pset_chunk(plistid, 1, cdims);
  hdf_def_var(fileID, "time", H5T_NATIVE_DOUBLE, 1, dims, &varid, plistid);
  H5Pclose(plistid);

  streams[streamID].basetime.ncvarid = varid;

  if ( streams[streamID].tsteps[0].taxis.type == TAXIS_ABSOLUTE )
    {
      if ( streams[streamID].tsteps[0].taxis.unit == TUNIT_MONTH )
	sprintf(unitstring, "month as %s", "%Y%m.%f");
      else
	sprintf(unitstring, "day as %s", "%Y%m%d.%f");
    }
  else
    {
      int rdate, rtime;
      int timeunit;
      TAXIS *taxis;
      taxis = &streams[streamID].tsteps[0].taxis;
      timeunit = (*taxis).unit;
      rdate  = (*taxis).rdate;
      rtime  = (*taxis).rtime;
      if ( rdate == -1 )
	{
	  rdate  = (*taxis).vdate;
	  rtime  = (*taxis).vtime;
	}
      year   =  rdate / 10000;
      month  = (rdate - year*10000) / 100;
      day    =  rdate - year*10000 - month*100;
      hour   =  rtime / 100;
      minute =  rtime - hour*100;
      sprintf(unitstring, "%s since %d-%d-%d %02d:%02d",
	      tunitNamePtr(timeunit), year, month, day, hour, minute);
    }

  hdf_put_att_text(fileID, varid, "units", strlen(unitstring), unitstring);
  /*
  if ( streams[streamID].ncmode == 2 ) hdf_enddef(fileID);
  */
#endif
}

#if defined (XYZ)

void hdfDefComplex(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char axisname[] = "complex";
  int index;
  int dimID = UNDEFID;
  int gridID0, gridtype0, gridindex;
  int ngrids;
  int fileID;
  int dimlen;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_SPECTRAL )
	    {
	      dimID = streams[streamID].xdimID[index];
	      break;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      dimlen = 2;

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void hdfDefSpc(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  /*
  char longname[] = "Spherical harmonic coefficient";
  */
  char axisname[5] = "spcX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID)/2;

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].ydimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_SPECTRAL )
	    {
	      dimlen0 = gridInqSize(gridID0)/2;
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].ydimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[3] = '\0';
      else           sprintf(&axisname[3], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].ydimID[gridindex] = dimID;

#endif
}

void hdfDefTrajLon(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfDefTrajLon";
  char unitstring[] = "degrees_east";
  char longname[] = "longitude";
  char stdname[] = "longitude";
  char axisname[] = "tlon";
  int gridtype, gridindex;
  int dimID = UNDEFID;
  int fileID;
  int dimlen;
  int ncvarid;

  fileID = streamInqFileID(streamID);

  gridtype = gridInqType(gridID);
  dimlen = gridInqXsize(gridID);
  if ( dimlen != 1 ) Error(func, "Xsize isn't 1 for %s grid!", gridNamePtr(gridtype));

  gridindex = vlistGridIndex(vlistID, gridID);
  ncvarid = streams[streamID].xdimID[gridindex];

  if ( ncvarid == UNDEFID )
    {
      dimID = streams[streamID].basetime.ncvarid;

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncvarid, H5P_DEFAULT);
      hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
      hdf_put_att_text(fileID, ncvarid, "units", strlen(unitstring), unitstring);
      hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(stdname), stdname);

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  streams[streamID].xdimID[gridindex] = ncvarid; /* var ID for trajectory !!! */

#endif
}

void hdfDefTrajLat(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfDefTrajLat";
  char unitstring[] = "degrees_north";
  char longname[] = "latitude";
  char stdname[] = "latitude";
  char axisname[] = "tlat";
  int gridtype, gridindex;
  int dimID = UNDEFID;
  int fileID;
  int dimlen;
  int ncvarid;

  fileID = streamInqFileID(streamID);

  gridtype = gridInqType(gridID);
  dimlen = gridInqYsize(gridID);
  if ( dimlen != 1 ) Error(func, "Ysize isn't 1 for %s grid!", gridNamePtr(gridtype));

  gridindex = vlistGridIndex(vlistID, gridID);
  ncvarid = streams[streamID].ydimID[gridindex];

  if ( ncvarid == UNDEFID )
    {
      dimID = streams[streamID].basetime.ncvarid;

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncvarid, H5P_DEFAULT);
      hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
      hdf_put_att_text(fileID, ncvarid, "units", strlen(unitstring), unitstring);
      hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(stdname), stdname);

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  streams[streamID].ydimID[gridindex] = ncvarid; /* var ID for trajectory !!! */

#endif
}
#endif /*XYZ*/

void hdfDefLon(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char unitstring[] = "degrees_east";
  char longname[] = "longitude";
  char stdname[] = "longitude";
  char axisname[5] = "lonX";
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int ncvarid;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqDimgroupID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqXsize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN ||
	       gridtype0 == GRID_LONLAT   ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqXsize(gridID0);
	      if ( dimlen == dimlen0 )
		if ( gridInqXval(gridID0, 0) == gridInqXval(gridID, 0) &&
		     gridInqXval(gridID0, dimlen-1) == gridInqXval(gridID, dimlen-1) )
		  {
		    dimID = streams[streamID].xdimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].xdimID[index] == streams[streamID].xdimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[3] = '\0';
      else           sprintf(&axisname[3], "%1d", iz+1);
      /*
      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
      */
      /*
      hdf_def_dim(fileID, axisname, dimlen, &dimID);
      */
      if ( gridInqXvalsPtr(gridID) )
	{
	  hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimlen, &ncvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncvarid, "units", strlen(unitstring), unitstring);
	  hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(stdname), stdname);
	}
      /*
      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
      */
      if ( gridInqXvalsPtr(gridID) )
	hdf_put_var_double(fileID, ncvarid, gridInqXvalsPtr(gridID));
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = ncvarid;

#endif
}

void hdfDefLat(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char unitstring[] = "degrees_north";
  char longname[] = "latitude";
  char stdname[] = "latitude";
  char axisname[5] = "latX";
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int ncvarid;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqDimgroupID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqYsize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].ydimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN ||
	       gridtype0 == GRID_LONLAT   ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqYsize(gridID0);
	      if ( dimlen == dimlen0 )
		if ( gridInqYval(gridID0, 0) == gridInqYval(gridID, 0) &&
		     gridInqYval(gridID0, dimlen-1) == gridInqYval(gridID, dimlen-1) )
		  {
		    dimID = streams[streamID].ydimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].ydimID[index] == streams[streamID].ydimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[3] = '\0';
      else           sprintf(&axisname[3], "%1d", iz+1);
      /*
      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
      */
      /*
      hdf_def_dim(fileID, axisname, dimlen, &dimID);
      */
      if ( gridInqYvalsPtr(gridID) )
	{
	  hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimlen, &ncvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncvarid, "units", strlen(unitstring), unitstring);
	  hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(stdname), stdname);
	}
      /*
      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
      */
      if ( gridInqYvalsPtr(gridID) )
	hdf_put_var_double(fileID, ncvarid, gridInqYvalsPtr(gridID));
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].ydimID[gridindex] = ncvarid;

#endif
}

#if defined (XYZ)

void hdfDefLonRot(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char unitstring[] = "degrees";
  char longname[] = "longitude in rotated pole grid";
  char stdname[] = "grid_longitude";
  char axisname[6] = "rlonX";
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int ncvarid;
  double north_pole;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqXsize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID && gridIsRotated(gridID) )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN ||
	       gridtype0 == GRID_LONLAT   ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqXsize(gridID0);
	      if ( dimlen == dimlen0 )
		if ( gridInqXval(gridID0, 0) == gridInqXval(gridID, 0) &&
		     gridInqXval(gridID0, dimlen-1) == gridInqXval(gridID, dimlen-1) )
		  {
		    dimID = streams[streamID].xdimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].xdimID[index] == streams[streamID].xdimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[4] = '\0';
      else           sprintf(&axisname[4], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      if ( gridInqXvalsPtr(gridID) )
	{
	  hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncvarid, "units", strlen(unitstring), unitstring);
	  hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(stdname), stdname);
	  north_pole = gridInqXpole(gridID);
	  hdf_put_att_double(fileID, ncvarid, "north_pole", H5T_NATIVE_DOUBLE, 1L, &north_pole);
	}

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( gridInqXvalsPtr(gridID) )
	hdf_put_var_double(fileID, ncvarid, gridInqXvalsPtr(gridID));
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void hdfDefLatRot(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char unitstring[] = "degrees";
  char longname[] = "latitude in rotated pole grid";
  char stdname[] = "grid_latitude";
  char axisname[6] = "rlatX";
  int index, index2, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int ncvarid;
  double north_pole;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqYsize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].ydimID[index] != UNDEFID && gridIsRotated(gridID) )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN ||
	       gridtype0 == GRID_LONLAT   ||
	       gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqYsize(gridID0);
	      if ( dimlen == dimlen0 )
		if ( gridInqYval(gridID0, 0) == gridInqYval(gridID, 0) &&
		     gridInqYval(gridID0, dimlen-1) == gridInqYval(gridID, dimlen-1) )
		  {
		    dimID = streams[streamID].ydimID[index];
		    break;
		  }
	      for ( index2 = 0; index2 < index; index2++ )
		if ( streams[streamID].ydimID[index] == streams[streamID].ydimID[index2] )
		  break;
	      if ( index2 == index ) iz++;
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[4] = '\0';
      else           sprintf(&axisname[4], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      if ( gridInqYvalsPtr(gridID) )
	{
	  hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncvarid, "units", strlen(unitstring), unitstring);
	  hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(stdname), stdname);
	  north_pole = gridInqYpole(gridID);
	  hdf_put_att_double(fileID, ncvarid, "north_pole", H5T_NATIVE_DOUBLE, 1L, &north_pole);
	}

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( gridInqYvalsPtr(gridID) )
	hdf_put_var_double(fileID, ncvarid, gridInqYvalsPtr(gridID));
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].ydimID[gridindex] = dimID;

#endif
}

void hdfDefRgrid(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char axisname[7] = "rgridX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GAUSSIAN_REDUCED )
	    {
	      dimlen0 = gridInqSize(gridID0);
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].xdimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[5] = '\0';
      else           sprintf(&axisname[5], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void hdfDefGdim(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char axisname[7] = "xydimX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_GENERIC )
	    {
	      dimlen0 = gridInqSize(gridID0);
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].xdimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[5] = '\0';
      else           sprintf(&axisname[5], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  gridindex = vlistGridIndex(vlistID, gridID);
  streams[streamID].xdimID[gridindex] = dimID;

#endif
}

void hdfDefCell(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  char axisname[6] = "cellX";
  int index, iz = 0;
  int gridID0, gridtype0, gridindex;
  int dimID = UNDEFID;
  int ngrids;
  int fileID;
  int dimlen, dimlen0;
  int ncxvarid = UNDEFID, ncyvarid = UNDEFID, ncavarid = UNDEFID;
  int ncbxvarid, ncbyvarid;
  int nvertex, nvdimID = -1;

  fileID  = streamInqFileID(streamID);

  ngrids = vlistNgrids(vlistID);

  dimlen = gridInqSize(gridID);
  gridindex = vlistGridIndex(vlistID, gridID);

  for ( index = 0; index < ngrids; index++ )
    {
      if ( streams[streamID].xdimID[index] != UNDEFID )
	{
	  gridID0 = vlistGrid(vlistID, index);
	  gridtype0 = gridInqType(gridID0);
	  if ( gridtype0 == GRID_CELL )
	    {
	      dimlen0 = gridInqSize(gridID0);
	      if ( dimlen == dimlen0 )
		{
		  dimID = streams[streamID].xdimID[index];
		  break;
		}
	      else
		iz++;	
	    }
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( iz == 0 ) axisname[4] = '\0';
      else           sprintf(&axisname[4], "%1d", iz+1);

      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

      hdf_def_dim(fileID, axisname, dimlen, &dimID);

      nvertex = gridInqNvertex(gridID);
      if ( nvertex > 0 )
	hdf_def_dim(fileID, "nv", nvertex, &nvdimID);
	
      if ( gridInqXvalsPtr(gridID) )
	{
	  char xaxisname[] = "lon";
	  char unitstring[] = "degrees_east";
	  char longname[] = "longitude";

	  hdf_def_var(fileID, xaxisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncxvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncxvarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncxvarid, "units", strlen(unitstring), unitstring);

	  streams[streamID].ncxvarID[gridindex] = ncxvarid;

	  if ( nvdimID != -1 && gridInqXboundsPtr(gridID) )
	    {
	      char bxaxisname[] = "lon_vertices";
	      int dimIDs[2];
	      dimIDs[0] = dimID;
	      dimIDs[1] = nvdimID;
	      hdf_def_var(fileID, bxaxisname, H5T_NATIVE_DOUBLE, 2, dimIDs, &ncbxvarid, H5P_DEFAULT);
	      hdf_put_att_text(fileID, ncxvarid, "bounds", strlen(bxaxisname), bxaxisname);
	    }
	}

      if ( gridInqYvalsPtr(gridID) )
	{
	  char yaxisname[] = "lat";
	  char unitstring[] = "degrees_north";
	  char longname[] = "latitude";

	  hdf_def_var(fileID, yaxisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncyvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncyvarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncyvarid, "units", strlen(unitstring), unitstring);

	  streams[streamID].ncyvarID[gridindex] = ncyvarid;

	  if ( nvdimID != -1 && gridInqYboundsPtr(gridID) )
	    {
	      char byaxisname[] = "lat_vertices";
	      int dimIDs[2];
	      dimIDs[0] = dimID;
	      dimIDs[1] = nvdimID;
	      hdf_def_var(fileID, byaxisname, H5T_NATIVE_DOUBLE, 2, dimIDs, &ncbyvarid, H5P_DEFAULT);
	      hdf_put_att_text(fileID, ncyvarid, "bounds", strlen(byaxisname), byaxisname);
	    }
	}

      if ( gridInqAreaPtr(gridID) )
	{
	  char yaxisname[] = "cell_area";
	  char unitstring[] = "m2";
	  char longname[] = "area of grid cell";
	  char stdname[] = "area";

	  hdf_def_var(fileID, yaxisname, H5T_NATIVE_DOUBLE, 1, &dimID, &ncavarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncavarid, "long_name", strlen(longname), longname);
	  hdf_put_att_text(fileID, ncavarid, "standard_name", strlen(stdname), stdname);
	  hdf_put_att_text(fileID, ncavarid, "units", strlen(unitstring), unitstring);

	  streams[streamID].ncavarID[gridindex] = ncavarid;
	}

      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;

      if ( gridInqXvalsPtr(gridID) )
	hdf_put_var_double(fileID, ncxvarid, gridInqXvalsPtr(gridID));

      if ( gridInqYvalsPtr(gridID) )
	hdf_put_var_double(fileID, ncyvarid, gridInqYvalsPtr(gridID));

      if ( gridInqXboundsPtr(gridID) )
	hdf_put_var_double(fileID, ncbxvarid, gridInqXboundsPtr(gridID));

      if ( gridInqYboundsPtr(gridID) )
	hdf_put_var_double(fileID, ncbyvarid, gridInqYboundsPtr(gridID));

      if ( gridInqAreaPtr(gridID) )
	hdf_put_var_double(fileID, ncavarid, gridInqAreaPtr(gridID));
    }

  streams[streamID].xdimID[gridindex] = dimID;

#endif
}
#endif /*XYZ*/

void hdfDefVCT(int streamID, int zaxisID)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfDefVCT";
  int type;

  type = zaxisInqType(zaxisID);

  if ( type == ZAXIS_HYBRID )
    {
      int i;
      int fileID;
      int ilev = zaxisInqVctSize(zaxisID)/2;
      int mlev = ilev - 1;
      size_t start;
      size_t count = 1;      
      int ncvarid, ncvarid2;
      int hyaiid, hybiid, hyamid, hybmid;
      int *ilevels = (int *) malloc(ilev*sizeof(int));
      const double *vctptr = zaxisInqVctPtr(zaxisID);
      double mval;
      char tmpname[128];

      if ( streams[streamID].vct.ilev > 0 )
	{
	  if ( streams[streamID].vct.ilev != ilev )
	    Error(func, "more than one VCT for each file unsupported!");
	  return;
	}

      if ( ilev == 0 )
	{
	  Warning(func, "VCT missing");
	  return;
	}

      fileID = streamInqDimgroupID(streamID);
      /*
      if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
      */
      /*
      hdf_def_dim(fileID, "mlev", mlev, &ncdimid);
      hdf_def_dim(fileID, "ilev", ilev, &ncdimid2);
      */

      streams[streamID].vct.mlev   = mlev;
      streams[streamID].vct.ilev   = ilev;
      /*
      streams[streamID].vct.mlevID = ncdimid;
      streams[streamID].vct.ilevID = ncdimid2;
      */

      hdf_def_var(fileID, "mlev", H5T_NATIVE_INT,    1, &mlev, &ncvarid, H5P_DEFAULT);
      hdf_def_var(fileID, "ilev", H5T_NATIVE_INT,    1, &ilev, &ncvarid2, H5P_DEFAULT);
      hdf_def_var(fileID, "hyai", H5T_NATIVE_DOUBLE, 1, &ilev, &hyaiid, H5P_DEFAULT);
      hdf_def_var(fileID, "hybi", H5T_NATIVE_DOUBLE, 1, &ilev, &hybiid, H5P_DEFAULT);
      hdf_def_var(fileID, "hyam", H5T_NATIVE_DOUBLE, 1, &mlev, &hyamid, H5P_DEFAULT);
      hdf_def_var(fileID, "hybm", H5T_NATIVE_DOUBLE, 1, &mlev, &hybmid, H5P_DEFAULT);

      strcpy(tmpname, "hybrid level at layer midpoints");
      hdf_put_att_text(fileID, ncvarid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid_sigma_pressure");
      hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "level");
      hdf_put_att_text(fileID, ncvarid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "down");
      hdf_put_att_text(fileID, ncvarid, "positive", strlen(tmpname), tmpname);
      strcpy(tmpname, "hyam hybm (mlev=hyam+hybm*aps)");
      hdf_put_att_text(fileID, ncvarid, "formula", strlen(tmpname), tmpname);
      strcpy(tmpname, "ap: hyam b: hybm ps: aps");
      hdf_put_att_text(fileID, ncvarid, "formula_terms", strlen(tmpname), tmpname);
      strcpy(tmpname, "ilev");
      hdf_put_att_text(fileID, ncvarid, "borders", strlen(tmpname), tmpname);

      strcpy(tmpname, "hybrid level at layer interfaces");
      hdf_put_att_text(fileID, ncvarid2, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid_sigma_pressure");
      hdf_put_att_text(fileID, ncvarid2, "standard_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "level");
      hdf_put_att_text(fileID, ncvarid2, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "down");
      hdf_put_att_text(fileID, ncvarid2, "positive", strlen(tmpname), tmpname);
      strcpy(tmpname, "hyai hybi (ilev=hyai+hybi*aps)");
      hdf_put_att_text(fileID, ncvarid2, "formula", strlen(tmpname), tmpname);
      strcpy(tmpname, "ap: hyai b: hybi ps: aps");
      hdf_put_att_text(fileID, ncvarid2, "formula_terms", strlen(tmpname), tmpname);

      strcpy(tmpname, "hybrid A coefficient at layer interfaces");
      hdf_put_att_text(fileID, hyaiid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "Pa");
      hdf_put_att_text(fileID, hyaiid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid B coefficient at layer interfaces");
      hdf_put_att_text(fileID, hybiid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "1");
      hdf_put_att_text(fileID, hybiid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid A coefficient at layer midpoints");
      hdf_put_att_text(fileID, hyamid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "Pa");
      hdf_put_att_text(fileID, hyamid, "units", strlen(tmpname), tmpname);
      strcpy(tmpname, "hybrid B coefficient at layer midpoints");
      hdf_put_att_text(fileID, hybmid, "long_name", strlen(tmpname), tmpname);
      strcpy(tmpname, "1");
      hdf_put_att_text(fileID, hybmid, "units", strlen(tmpname), tmpname);
      /*
      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
      */
      for ( i = 0; i < ilev; i++ ) ilevels[i] = i+1;
      hdf_put_var_int(fileID, ncvarid,  ilevels);
      hdf_put_var_int(fileID, ncvarid2, ilevels);
      free(ilevels);

      hdf_put_var_double(fileID, hyaiid, vctptr);
      hdf_put_var_double(fileID, hybiid, vctptr+ilev);

      for ( i = 0; i < mlev; i++ )
	{
	  start = i;
	  mval = (vctptr[i] + vctptr[i+1]) * 0.5;
	  hdf_put_vara_double(fileID, hyamid, &start, &count, &mval);
	  mval = (vctptr[ilev+i] + vctptr[ilev+i+1]) * 0.5;
	  hdf_put_vara_double(fileID, hybmid, &start, &count, &mval);	  
	}
    }

#endif
}

void hdfDefLev(int streamID, int zaxisID)
{
#if  defined  (HAVE_LIBHDF5)
  char units[128];
  char longname[128];
  char tmpname[128];
  char axisname[5] = "levX";
  int index, index2;
  int zaxisID0, zaxistype0;
  int dimID = UNDEFID;
  int fileID;
  int dimlen, dimlen0;
  int levelID;
  int ncvarid;
  int type;
  int nzaxis;
  int ilevel = 0;
  int vlistID;
  int zaxisindex;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqDimgroupID(streamID);

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);

  nzaxis = vlistNzaxis(vlistID);

  dimlen = zaxisInqSize(zaxisID);
  type   = zaxisInqType(zaxisID);

  if ( dimlen == 1 && type == ZAXIS_SURFACE ) return;

  for ( index = 0; index < nzaxis; index++ )
    {
      if ( streams[streamID].zaxisID[index] != UNDEFID )
	{
	  zaxisID0 = vlistZaxis(vlistID, index);
	  zaxistype0 = zaxisInqType(zaxisID0);

	  dimlen0 = zaxisInqSize(zaxisID0);
	  if ( dimlen == dimlen0 && type == zaxistype0 )
	    {
	      for ( levelID = 0; levelID < dimlen; levelID++ )
		{
		  if ( fabs(zaxisInqLevel(zaxisID0, levelID) - zaxisInqLevel(zaxisID, levelID)) )
		    break;
		}
	      if ( levelID == dimlen )
		{
		  dimID = streams[streamID].zaxisID[index];
		  break;
		}
	    }
	  for ( index2 = 0; index2 < index; index2++ )
	    if ( streams[streamID].zaxisID[index] == streams[streamID].zaxisID[index2] )
	      break;
	  if ( index2 == index ) ilevel++;
	}
    }

  if ( dimID == UNDEFID )
    {
      if ( ilevel == 0 ) axisname[3] = '\0';
      else               sprintf(&axisname[3], "%1d", ilevel+1);

      if ( type == ZAXIS_HYBRID || type == ZAXIS_HYBRID_HALF )
	{
	  size_t ilev = zaxisInqVctSize(zaxisID)/2;
	  size_t mlev = ilev - 1;

	  if ( type == ZAXIS_HYBRID )
	    {
	      if ( (int) mlev != dimlen )
		{
		  /*
		  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
		  */
		  /*
		  hdf_def_dim(fileID, axisname, dimlen, &dimID);
		  */
		  hdf_def_var(fileID, axisname, H5T_NATIVE_INT, 1, &dimlen,  &ncvarid, H5P_DEFAULT);

		  strcpy(tmpname, "hybrid level at layer midpoints");
		  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hybrid_sigma_pressure");
		  hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "level");
		  hdf_put_att_text(fileID, ncvarid, "units", strlen(tmpname), tmpname);
		  strcpy(tmpname, "down");
		  hdf_put_att_text(fileID, ncvarid, "positive", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hyam hybm (mlev=hyam+hybm*aps)");
		  hdf_put_att_text(fileID, ncvarid, "formula", strlen(tmpname), tmpname);
		  strcpy(tmpname, "ap: hyam b: hybm ps: aps");
		  hdf_put_att_text(fileID, ncvarid, "formula_terms", strlen(tmpname), tmpname);
		  strcpy(tmpname, "ilev");
		  hdf_put_att_text(fileID, ncvarid, "borders", strlen(tmpname), tmpname);
		  /*
		  hdf_enddef(fileID);
		  streams[streamID].ncmode = 2;
		  */
		  hdf_put_var_double(fileID, ncvarid, zaxisInqLevelsPtr(zaxisID));
		}
	    }

	  if ( type == ZAXIS_HYBRID_HALF )
	    {
	      if ( (int) ilev != dimlen )
		{
		  /*
		  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
		  */
		  /*
		  hdf_def_dim(fileID, axisname, dimlen, &dimID);
		  */
		  hdf_def_var(fileID, axisname, H5T_NATIVE_INT, 1, &dimlen,  &ncvarid, H5P_DEFAULT);

		  strcpy(tmpname, "hybrid level at layer interfaces");
		  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hybrid_sigma_pressure");
		  hdf_put_att_text(fileID, ncvarid, "standard_name", strlen(tmpname), tmpname);
		  strcpy(tmpname, "level");
		  hdf_put_att_text(fileID, ncvarid, "units", strlen(tmpname), tmpname);
		  strcpy(tmpname, "down");
		  hdf_put_att_text(fileID, ncvarid, "positive", strlen(tmpname), tmpname);
		  strcpy(tmpname, "hyai hybi (ilev=hyai+hybi*aps)");
		  hdf_put_att_text(fileID, ncvarid, "formula", strlen(tmpname), tmpname);
		  strcpy(tmpname, "ap: hyai b: hybi ps: aps");
		  hdf_put_att_text(fileID, ncvarid, "formula_terms", strlen(tmpname), tmpname);
		  /*
		  hdf_enddef(fileID);
		  streams[streamID].ncmode = 2;
		  */
		  hdf_put_var_double(fileID, ncvarid, zaxisInqLevelsPtr(zaxisID));
		}
	    }

	  hdfDefVCT(streamID, zaxisID);

	  if ( dimID == UNDEFID )
	    {
	      if ( type == ZAXIS_HYBRID )
		streams[streamID].zaxisID[zaxisindex] = streams[streamID].vct.mlevID;
	      else
		streams[streamID].zaxisID[zaxisindex] = streams[streamID].vct.ilevID;
	    }
	}
      else
	{
	  /*
	  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
	  */
	  /*
	  hdf_def_dim(fileID, axisname, dimlen, &dimID);
	  */

	  zaxisInqLongname(zaxisID, longname);
	  zaxisInqUnits(zaxisID, units);

	  hdf_def_var(fileID, axisname, H5T_NATIVE_DOUBLE, 1, &dimlen, &ncvarid, H5P_DEFAULT);
	  hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);
	  if ( strlen(units) )
	    hdf_put_att_text(fileID, ncvarid, "units", strlen(units), units);
	  /*
	  hdf_enddef(fileID);
	  streams[streamID].ncmode = 2;
	  */
	  hdf_put_var_double(fileID, ncvarid, zaxisInqLevelsPtr(zaxisID));
	}
    }

  if ( dimID != UNDEFID )
    streams[streamID].zaxisID[zaxisindex] = dimID;

#endif
}

void hdfDefGrid(int streamID, int gridID)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfDefGrid";
  int gridtype, size;
  int gridindex;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  gridindex = vlistGridIndex(vlistID, gridID);
  if ( streams[streamID].xdimID[gridindex] != UNDEFID ) return;

  gridtype = gridInqType(gridID);
  size = gridInqSize(gridID);

  if ( CDI_Debug )
    Message(func, "gridtype = %d  size = %d", gridtype, size);

  if ( gridtype == GRID_GAUSSIAN || gridtype == GRID_LONLAT )
    {
      /*
      if ( gridIsRotated(gridID) )
	{
	  hdfDefLonRot(streamID, gridID);
	  hdfDefLatRot(streamID, gridID);
	}
      else
      */
	{
	  hdfDefLon(streamID, gridID);
	  hdfDefLat(streamID, gridID);
	}
    }
  else if ( gridtype == GRID_GENERIC )
    {   
      int xsize, ysize;
      xsize = gridInqXsize(gridID);
      ysize = gridInqYsize(gridID);
      /*
      if ( xsize == 0 || ysize == 0 )
	{
	  hdfDefGdim(streamID, gridID);
	}
      else
      */
	{
	  hdfDefLon(streamID, gridID);
	  hdfDefLat(streamID, gridID);
	}
    }
  /*
  else if ( gridtype == GRID_GAUSSIAN_REDUCED )
    {
      hdfDefRgrid(streamID, gridID);
    }
  */
  else if ( gridtype == GRID_SPECTRAL )
    {
      /*
      hdfDefComplex(streamID, gridID);
      hdfDefSpc(streamID, gridID);
      */
    }
  /*
  else if ( gridtype == GRID_TRAJECTORY )
    {
      hdfDefTrajLon(streamID, gridID);
      hdfDefTrajLat(streamID, gridID);
    }
  else if ( gridtype == GRID_CELL )
    {
      hdfDefCell(streamID, gridID);
    }
  */
  else
    {
      Error(func, "%s grid unsupported!", gridNamePtr(gridtype));
    }
#endif
}

void hdfDefZaxis(int streamID, int zaxisID)
{
#if  defined  (HAVE_LIBHDF5)
  int vlistID, zaxisindex;

  vlistID    = streamInqVlist(streamID);
  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);

  if ( streams[streamID].zaxisID[zaxisindex] != UNDEFID ) return;

  hdfDefLev(streamID, zaxisID);
#endif
}

int hdfDefVar(int streamID, int varID)
{
  int ncvarid = -1;
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfDefVar";
  int fileID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID, tid = UNDEFID; /* varid !!! */
  int code, gridID, zaxisID;
  char varname[9];
  char *name = NULL;
  char *longname = NULL;
  char *units = NULL;
  int dims[4];
  int tableID;
  int ndims = 0;
  int len;
  int timeID;
  int xtype;
  int gridindex, zaxisindex;
  int tablegribID;
  hsize_t cdims[9];
  int plistid;
  int compressLevel;
  int vlistID;

  vlistID = streamInqVlist(streamID);
  fileID  = streamInqFileID(streamID);

  if ( streams[streamID].vars[varID].ncvarid != UNDEFID )
    return (streams[streamID].vars[varID].ncvarid);

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);
  code    = vlistInqVarCode(vlistID, varID);

  hdfDefGrid(streamID, gridID);

  hdfDefZaxis(streamID, zaxisID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) != GRID_TRAJECTORY )
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  tid = streams[streamID].basetime.ncvarid;
  /* printf("%d %d %d %d\n", tid, zid, yid, xid); */

  if ( timeID == TIME_VARIABLE )
    {
      if ( tid == UNDEFID ) Error(func, "Internal problem! Time undefined.");

      cdims[ndims] = 1;
      /* dims[ndims++] = tid; */
      dims[ndims++] = -1;
    }
  /*
  if ( zid != UNDEFID ) dims[ndims++] = zid;
  if ( yid != UNDEFID ) dims[ndims++] = yid;
  if ( xid != UNDEFID ) dims[ndims++] = xid;
  */
  if ( zaxisID != UNDEFID )
    {
      size_t size = zaxisInqSize(zaxisID);
      if ( ! (zaxisInqType(zaxisID) == ZAXIS_SURFACE && size == 1) )
	{
	  cdims[ndims] = 1;
	  dims[ndims++] = zaxisInqSize(zaxisID);
	}
    }
  if ( gridID != UNDEFID )
    {
      int xsize, ysize;
      if ( gridInqType(gridID) == GRID_SPECTRAL )
	{
	  xsize = 2;
	  ysize = gridInqSize(gridID)/2;
	}
      else
	{
	  xsize = gridInqXsize(gridID);
	  ysize = gridInqYsize(gridID);
	}
      cdims[ndims] = ysize;
      dims[ndims]  = ysize;
      ndims++;
      cdims[ndims] = xsize;
      dims[ndims]  = xsize;
      ndims++;
    }


  tableID  = vlistInqVarTable(vlistID, varID);

  name     = vlistInqVarNamePtr(vlistID, varID);
  longname = vlistInqVarLongnamePtr(vlistID, varID);
  units    = vlistInqVarUnitsPtr(vlistID, varID);

  if ( name     == NULL )     name = tableInqParNamePtr(tableID, code);
  if ( longname == NULL ) longname = tableInqParLongnamePtr(tableID, code);
  if ( units    == NULL )    units = tableInqParUnitsPtr(tableID, code);
  if ( name == NULL )
    {
      if ( code < 0 ) code = -code;
      sprintf(varname, "var%d", code);
      name = varname;
      code = 0;
    }
  /*
  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
  */
  xtype = hdfDefDatatype(vlistInqVarDatatype(vlistID, varID));

  plistid = H5Pcreate(H5P_DATASET_CREATE);
  H5Pset_chunk(plistid, ndims, cdims);

  compressLevel = streams[streamID].compress;
  if ( compressLevel )
    H5Pset_deflate(plistid, compressLevel);

  hdf_def_var(fileID, name, xtype, ndims, dims, &ncvarid, plistid);

  H5Pclose(plistid);

  if ( longname )
    hdf_put_att_text(fileID, ncvarid, "long_name", strlen(longname), longname);

  if ( units )
    hdf_put_att_text(fileID, ncvarid, "units", strlen(units), units);

  /*
  if ( code > 0 )
    hdf_put_att_int(fileID, ncvarid, "code", H5T_NATIVE_INT, 1L, &code);
  */

  if ( tableID != UNDEFID )
    {
      tablegribID = tableInqGribID(tableID);
      /*
      if ( tablegribID > 0 )
	hdf_put_att_int(fileID, ncvarid, "table", H5T_NATIVE_INT, 1L, &tablegribID);
      */
    }

  if ( gridInqType(gridID) != GRID_GENERIC && gridInqType(gridID) != GRID_LONLAT )
    {
      len = strlen(gridNamePtr(gridInqType(gridID)));
      if ( len > 0 )
	hdf_put_att_text(fileID, ncvarid, "grid_type", len,
			 gridNamePtr(gridInqType(gridID)));
    }

  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      hdf_put_att_text(fileID, ncvarid, "coordinates", 9, "tlon tlat" );
    }
  /*
  if ( gridInqType(gridID) == GRID_CELL )
    {
      char coordinates[128] = "";
      char cellarea[128] = "area: ";
      int ncxvarID, ncyvarID, ncavarID;
      int gridindex;
      size_t len;

      gridindex = vlistGridIndex(vlistID, gridID);
      ncxvarID = streams[streamID].ncxvarID[gridindex];
      ncyvarID = streams[streamID].ncyvarID[gridindex];
      ncavarID = streams[streamID].ncavarID[gridindex];
      if ( ncxvarID != CDI_UNDEFID )
	hdf_inq_varname(fileID, ncxvarID, coordinates);
      len = strlen(coordinates);
      if ( ncyvarID != CDI_UNDEFID )
	{
	  if ( len ) coordinates[len++] = ' ';
	  hdf_inq_varname(fileID, ncyvarID, coordinates+len);
	}
      len = strlen(coordinates);
      if ( len )
	hdf_put_att_text(fileID, ncvarid, "coordinates", len, coordinates);

      if ( ncavarID != CDI_UNDEFID )
	{
	  len = strlen(cellarea);
	  hdf_inq_varname(fileID, ncavarID, cellarea+len);
	  len = strlen(cellarea);
	  hdf_put_att_text(fileID, ncvarid, "cell_measures", len, cellarea);
	}
    }
  */
  if ( gridInqType(gridID) == GRID_SPECTRAL )
    {
      /*
      int gridTruncation = gridInqTrunc(gridID);
      hdf_put_att_int(fileID, ncvarid, "truncation", H5T_NATIVE_INT, 1L, &gridTruncation);
      */
    }

  if ( xtype == NC_BYTE || xtype == NC_SHORT || xtype == H5T_NATIVE_INT )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;

      addoffset   = vlistInqVarAddoffset(vlistID, varID);
      scalefactor = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = (fabs(addoffset - 0.0) > 0.0);
      lscalefactor = (fabs(scalefactor - 1.0) > 0.0);
      /*
      if ( laddoffset )
	hdf_put_att_double(fileID, ncvarid, "add_offset", NC_FLOAT, 1L, &addoffset);

      if ( lscalefactor )
	hdf_put_att_double(fileID, ncvarid, "scale_factor", NC_FLOAT, 1L, &scalefactor);
      */
    }

  streams[streamID].vars[varID].ncvarid = ncvarid;
  /*
  if ( streams[streamID].ncmode == 2 ) hdf_enddef(fileID);
  */
#endif
  return (ncvarid);
}

#if defined (XYZ)

void hdfReadVarDP(int streamID, int varID, double *data, int *nmiss)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfReadVarDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int tsID;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex, zaxisindex;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  fileID  = streamInqFileID(streamID);

  tsID = streams[streamID].curTsID;

  if ( CDI_Debug ) Message(func, "tsID = %d", tsID);

  ncvarid = streams[streamID].vars[varID].ncvarid;

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      hdfReadGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = tsID;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = zaxisInqSize(zaxisID);
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = gridInqYsize(gridID);
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = gridInqXsize(gridID);
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  hdf_get_vara_double(fileID, ncvarid, start, count, data);
#endif
}

void hdfWriteVarDP(int streamID, int varID, double *data, int nmiss)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfWriteVarDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int ntsteps;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex, zaxisindex;
  int i;
  int dtype;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d", streamID, varID);

  fileID = streamInqFileID(streamID);

  ntsteps = streams[streamID].ntsteps;
  if ( CDI_Debug )
    Message(func, "ntsteps = %d", ntsteps); 

  if ( vlistHasTime(vlistID) ) hdfDefTime(streamID);

  ncvarid = hdfDefVar(streamID, varID);

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      hdfWriteGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = ntsteps - 1;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = zaxisInqSize(zaxisID);
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      hdf_inq_dimlen(fileID, yid, &size);
      /*      count[ndims] = gridInqYsize(gridID); */
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      hdf_inq_dimlen(fileID, xid, &size);
      /*      count[ndims] = gridInqXsize(gridID); */
      count[ndims] = size;
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  if ( streams[streamID].ncmode == 1 )
    {
      hdf_enddef(fileID);
      streams[streamID].ncmode = 2;
    }

  dtype = vlistInqVarDatatype(vlistID, varID);

  if ( nmiss > 0 ) hdfDefMissval(streamID, varID, dtype);

  if ( dtype == DATATYPE_INT1 || dtype == DATATYPE_INT2 || dtype == DATATYPE_INT4 )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;

      addoffset   = vlistInqVarAddoffset(vlistID, varID);
      scalefactor = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = (fabs(addoffset   - 0.0) > 0.0);
      lscalefactor = (fabs(scalefactor - 1.0) > 0.0);

      if ( laddoffset || lscalefactor )
	{
	  gridID   = vlistInqVarGrid(vlistID, varID);
	  size     = gridInqSize(gridID);

	  for ( i = 0; i < size; i++ )
	    {
	      if ( laddoffset )   data[i] = data[i] - addoffset;
	      if ( lscalefactor ) data[i] = data[i] / scalefactor;
	    }
	}
    }

  hdf_put_vara_double(fileID, ncvarid, start, count, data);
#endif
}

int hdfReadVarSliceDP(int streamID, int varID, int levelID, double *data, int *nmiss)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfReadVarSliceDP";
  int fileID;
  int gridID;
  int zaxisID;
  int xid = UNDEFID, yid = UNDEFID, zid = UNDEFID;
  int ncvarid;
  int tsID;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex;
  int zaxisindex;

  if ( CDI_Debug )
    Message(func, "streamID = %d  varID = %d  levelID = %d", streamID, varID, levelID);

  fileID = streamInqFileID(streamID);

  tsID = streams[streamID].curTsID;
  if ( CDI_Debug )
    Message(func, "tsID = %d", tsID);

  ncvarid = streams[streamID].vars[varID].ncvarid;

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      hdfReadGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = tsID;
      count[ndims] = 1;
      ndims++;
    }
  if ( zid != UNDEFID )
    {
      start[ndims] = levelID;
      count[ndims] = 1;
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      /* count[ndims] = gridInqYsize(gridID); */
      hdf_inq_dimlen(fileID, yid, &size);
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      /* count[ndims] = gridInqXsize(gridID); */
      hdf_inq_dimlen(fileID, xid, &size);
      count[ndims] = size;
      ndims++;
    }

  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  hdf_get_vara_double(fileID, ncvarid, start, count, data);

  *nmiss = 0;
  if ( vlistInqVarMissvalUsed(vlistID, varID) == TRUE  )
    {
      int i;
      double missval;

      missval = vlistInqVarMissval(vlistID, varID);
      gridID  = vlistInqVarGrid(vlistID, varID);
      size    = gridInqSize(gridID);

      for ( i = 0; i < size; i++ )
	if ( data[i] == missval ) *nmiss += 1;
    }

#endif
  return (0);
}
#endif /*XYZ*/

int hdfWriteVarSliceDP(int streamID, int varID, int levelID, double *data, int nmiss)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfWriteVarSliceDP";
  int fileID;
  int gridID;
  int zaxisID;
  int zid = UNDEFID;
  int ncvarid;
  int ntsteps;
  size_t size;
  size_t start[4];
  size_t count[4];
  int ndims = 0;
  int idim;
  int timeID;
  int gridindex, zaxisindex;
  int i;
  int dtype;
  hsize_t hsize[9];
  int status;
  int vlistID;
    
  if ( CDI_Debug )
    Message(func, "streamID = %d  varid = %d", streamID, varID);

  vlistID  = streamInqVlist(streamID);
  fileID   = streamInqFileID(streamID);

  ntsteps   = streams[streamID].ntsteps;
  if ( CDI_Debug )
    Message(func, "ntsteps = %d", ntsteps);
  /*
  if ( vlistHasTime(vlistID) ) hdfDefTime(streamID);
  */
  ncvarid = hdfDefVar(streamID, varID);

  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  timeID  = vlistInqVarTime(vlistID, varID);

  gridindex = vlistGridIndex(vlistID, gridID);
  /*
  if ( gridInqType(gridID) == GRID_TRAJECTORY )
    {
      hdfWriteGridTraj(streamID, gridID);
    }
  else
    {
      xid = streams[streamID].xdimID[gridindex];
      yid = streams[streamID].ydimID[gridindex];
    }
  */

  zaxisindex = vlistZaxisIndex(vlistID, zaxisID);
  zid = streams[streamID].zaxisID[zaxisindex];

  if ( timeID == TIME_VARIABLE )
    {
      start[ndims] = ntsteps - 1;
      count[ndims] = 1;
      hsize[ndims] = ntsteps;
      ndims++;
    }
  /*
  if ( zid != UNDEFID )
    {
      start[ndims] = levelID;
      count[ndims] = 1;
      ndims++;
    }
  if ( yid != UNDEFID )
    {
      start[ndims] = 0;
      hdf_inq_dimlen(fileID, yid, &size);
      count[ndims] = size;
      ndims++;
    }
  if ( xid != UNDEFID )
    {
      start[ndims] = 0;
      hdf_inq_dimlen(fileID, xid, &size);
      count[ndims] = size;
      ndims++;
    }
  */
  if ( zaxisID != UNDEFID )
    {
      size_t size = zaxisInqSize(zaxisID);
      if ( ! (zaxisInqType(zaxisID) == ZAXIS_SURFACE && size == 1) )
	{
	  start[ndims] = levelID;
	  count[ndims] = 1;
	  hsize[ndims] = size;
	  ndims++;
	}
    }
  if ( gridID != UNDEFID )
    {
      start[ndims] = 0;
      count[ndims] = gridInqYsize(gridID);
      hsize[ndims] = gridInqYsize(gridID);
      ndims++;
      start[ndims] = 0;
      count[ndims] = gridInqXsize(gridID);
      hsize[ndims] = gridInqXsize(gridID);
      ndims++;
    }


  if ( CDI_Debug )
    for (idim = 0; idim < ndims; idim++)
      Message(func, "dim = %d  start = %d  count = %d", idim, start[idim], count[idim]);

  dtype = vlistInqVarDatatype(vlistID, varID);
  /*
  if ( nmiss > 0 ) hdfDefMissval(streamID, varID, dtype);
  */
  if ( dtype == DATATYPE_INT1 || dtype == DATATYPE_INT2 || dtype == DATATYPE_INT4 )
    {
      int laddoffset, lscalefactor;
      double addoffset, scalefactor;

      addoffset   = vlistInqVarAddoffset(vlistID, varID);
      scalefactor = vlistInqVarScalefactor(vlistID, varID);
      laddoffset   = (fabs(addoffset   - 0.0) > 0.0);
      lscalefactor = (fabs(scalefactor - 1.0) > 0.0);

      if ( laddoffset || lscalefactor )
	{
	  gridID   = vlistInqVarGrid(vlistID, varID);
	  size     = gridInqSize(gridID);

	  for ( i = 0; i < (int) size; i++ )
	    {
	      if ( laddoffset )   data[i] = data[i] - addoffset;
	      if ( lscalefactor ) data[i] = data[i] / scalefactor;
	    }
	}
    }

  if ( levelID == 0 )
    {
      status = H5Dextend(ncvarid, hsize);
      if ( status < 0 )
	{
	  H5Eprint(NULL);
	  Error(func, "write problem");
	}
    }

  hdf_put_vara_double(fileID, ncvarid, start, count, data);

#endif
  return (0);
}
#if defined (XYZ)
void hdfCreateRecords(int streamID, int tsID)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfCreateRecords";
  int varID, levelID, recordID;
  int nrecords = 0,  nvars, nlev;
  RECORD *records;

  if ( tsID < 0 || (tsID >= streams[streamID].ntsteps && tsID > 0) ) return;

  if ( streams[streamID].tsteps[tsID].nrecords > 0 ) return;

  nvars    = streams[streamID].nvars;

  for ( varID = 0; varID < nvars; varID++ )
    {
      if ( tsID > 0 && vlistInqVarTime(vlistID, varID) == TIME_CONSTANT )
	continue;
      nlev = streams[streamID].vars[varID].nlevs;
      nrecords += nlev;
    }

  streams[streamID].nrecs += nrecords;

  records = (RECORD *) malloc(nrecords*sizeof(RECORD));
  streams[streamID].tsteps[tsID].records    = records;
  streams[streamID].tsteps[tsID].nrecords   = nrecords;
  streams[streamID].tsteps[tsID].recordSize = nrecords;
  streams[streamID].tsteps[tsID].curRecID   = UNDEFID;

  recordID = 0;
  for ( varID = 0; varID < nvars; varID++ )
    {
      if ( tsID > 0 && vlistInqVarTime(vlistID, varID) == TIME_CONSTANT )
	continue;

      nlev = streams[streamID].vars[varID].nlevs;
      
      for ( levelID = 0; levelID < nlev; levelID++ )
	{
	  recordInitEntry(&records[recordID]);
	  records[recordID].varID   = varID;
	  records[recordID].levelID = levelID;
	  recordID++;
	}
    }
#endif
}

int hdfTimeDimID(int fileID, int ndims, int nvars)
{
  int dimid = 0;
#if  defined  (HAVE_LIBHDF5)
  char dimname[80];
  char timeunits[128];
  char attname[128];
  char name[128];
  int xtype;
  int nvdims, nvatts;
  int dimids[9];
  int varid, iatt;

  for ( dimid = 0; dimid < ndims; dimid++ )
    {
      hdf_inq_dimname(fileID, dimid, dimname);
      if ( strncmp(dimname, "time", 4) == 0 ) break;
    }

  if ( dimid == ndims ) dimid = UNDEFID;

  for ( varid = 0; varid < nvars; varid++ )
    {
      if ( dimid != UNDEFID ) break;

      hdf_inq_var(fileID, varid, name, &xtype, &nvdims, dimids, &nvatts);
      if ( nvdims == 1 )
	{
	  for ( iatt = 0; iatt < nvatts; iatt++ )
	    {
	      hdf_inq_attname(fileID, varid, iatt, attname);
	      if ( strncmp(attname, "units", 5) == 0 )
		{
		  hdf_get_att_text(fileID, varid, "units", timeunits);
		  if ( strncmp(timeunits, "sec",    3) == 0 ||
		       strncmp(timeunits, "minute", 6) == 0 ||
		       strncmp(timeunits, "hour",   4) == 0 ||
		       strncmp(timeunits, "day",    3) == 0 ||
		       strncmp(timeunits, "month",  5) == 0 )
		    {
		      dimid = dimids[0];
		      break;
		    }
		}
	    }
	}
    }

#endif
  return (dimid);
}
#endif /*XYZ*/

void hdfSetVar(HDFVAR *ncvars, int ncvarid, int isvar)
{
  static char func[] = "hdfSetVar";

  if ( isvar != TRUE && isvar != FALSE )
    Error(func, "Internal problem! isvar = %d", isvar);

  if ( ncvars[ncvarid].isvar != UNDEFID &&
       ncvars[ncvarid].isvar != isvar   &&
       ncvars[ncvarid].warn  == FALSE )
    {
      Warning(func, "Inconsistent variable definition for %s!", ncvars[ncvarid].name);

      ncvars[ncvarid].warn = TRUE;
      isvar = FALSE;
    }

  ncvars[ncvarid].isvar = isvar;
}

void hdfSetDim(HDFVAR *ncvars, int ncvarid, int dimid, int dimtype)
{
  static char func[] = "hdfSetDim";

  if ( ncvars[ncvarid].dimtype[dimid] != UNDEFID &&
       ncvars[ncvarid].dimtype[dimid] != dimtype )
    {
      Warning(func, "Inconsistent dimension definition for %s! dimid %d  oldtype %d  newtype %d",
	      ncvars[ncvarid].name, dimid, ncvars[ncvarid].dimtype[dimid], dimtype);
    }

  ncvars[ncvarid].dimtype[dimid] = dimtype;
}

void printHDFvars(HDFVAR *hdfvars, int nvars)
{
  int hdfvarid;

  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      printf("%3d %3d %s\n", hdfvarid, hdfvars[hdfvarid].isvar, hdfvars[hdfvarid].name);
    }
}
/*
 * Operator function.
 */
#if  defined  (HAVE_LIBHDF5)
herr_t group_info(hid_t loc_id, const char *name, void *opdata)
{
  hid_t did;  /* dataset identifier  */
  hid_t tid;  /* datatype identifier */
  H5T_class_t t_class;
  hid_t pid;  /* data_property identifier */
  hsize_t chunk_dims_out[5];
  int i;

  int  rank_chunk;

  /* avoid warnings */
  opdata = opdata;

  /*
   * Open the datasets using their names.
   */
  did = H5Dopen(loc_id, name);
 
  /*
   * Display dataset name.
   */
  printf("\n");
  printf("Name : ");
  puts(name);
  
  /*    
   * Display dataset information.
   */
  tid = H5Dget_type(did);  /* get datatype*/
  pid = H5Dget_create_plist(did); /* get creation property list */
  
  /*
   * Check if dataset is chunked.
   */
  if(H5D_CHUNKED == H5Pget_layout(pid)){
    /*
     * get chunking information: rank and dimensions.
     */
    rank_chunk = H5Pget_chunk(pid, 5, chunk_dims_out);
    printf("chunk rank %d, dimensions ", rank_chunk);
    for ( i = 0; i < rank_chunk; i++)
      {
	printf("%lu ", (unsigned long)(chunk_dims_out[i]));
	if ( i + 1 < rank_chunk ) printf(" x ");
      }
    printf("\n");
  } 
  else{
    t_class = H5Tget_class(tid);
    if(t_class < 0){ 
      puts(" Invalid datatype.\n");
    }
    else {
      if(t_class == H5T_INTEGER)
      puts(" Datatype is 'H5T_NATIVE_INTEGER'.\n");
      if(t_class == H5T_FLOAT)
      puts(" Datatype is 'H5T_NATIVE_FLOAT'.\n");
      if(t_class == H5T_STRING)
      puts(" Datatype is 'H5T_NATIVE_STRING'.\n");
      if(t_class == H5T_BITFIELD)
      puts(" Datatype is 'H5T_NATIVE_BITFIELD'.\n");
      if(t_class == H5T_OPAQUE)
      puts(" Datatype is 'H5T_NATIVE_OPAQUE'.\n");
      if(t_class == H5T_COMPOUND)
      puts(" Datatype is 'H5T_NATIVE_COMPOUND'.\n");
    }
  }
    

  H5Dclose(did);
  H5Pclose(pid);
  H5Tclose(tid);

  return 0;
 }
#endif
/*
 * Operator function.
 */
#if  defined  (HAVE_LIBHDF5)
herr_t file_info(hid_t loc_id, const char *name, void *opdata)
{
    /* avoid warnings */
    loc_id = loc_id;
    opdata = opdata;

    /*
     * Display group name. The name is passed to the function by 
     * the Library. Some magic :-)
     */
    printf("\n");
    printf("Name : ");
    puts(name);
   
    return 0;
 }
#endif

void hdfOpenVars(int fileID, HDFVAR *hdfvars, int nvars)
{
#if  defined  (HAVE_LIBHDF5)
  char name[128];
  int groupID, varID;
  int status;
  hsize_t num_obj, idx;
  int hdfvarid = 0;

  groupID = H5Gopen(fileID, "/");
  status = H5Gget_num_objs(groupID, &num_obj);
  printf("num_obj %d\n", (int) num_obj);
  for ( idx = 0; idx < num_obj; idx++ )
    {
      if ( H5Gget_objtype_by_idx(groupID, idx) == H5G_DATASET )
	{
	  H5Gget_objname_by_idx(groupID, idx, name, (size_t) 128);
	  printf("  name: %s %s\n", "/", name);
	  varID = H5Dopen(groupID, name);
	  /*	  hdfvars[hdfvarid].groupID = groupID; */
	  hdfvars[hdfvarid].objID = varID;
	  strcpy(hdfvars[hdfvarid].name, name);
	  hdfvarid++;
	}
      else if ( H5Gget_objtype_by_idx(groupID, idx) == H5G_GROUP )
	{
	  hsize_t num_obj2, idx2;
	  int groupID2;
	  char name2[128];
	  H5Gget_objname_by_idx(groupID, idx, name, (size_t) 128);
	  groupID2 = H5Gopen(fileID, name);
	  status = H5Gget_num_objs(groupID2, &num_obj2);
	  for ( idx2 = 0; idx2 < num_obj2; idx2++ )
	    {
	      if ( H5Gget_objtype_by_idx(groupID2, idx2) == H5G_DATASET )
		{
		  H5Gget_objname_by_idx(groupID2, idx2, name2, (size_t) 128);
		  printf("  name: %s %s\n", name, name2);
		  varID = H5Dopen(groupID2, name2);
		  /*	  hdfvars[hdfvarid].groupID = groupID; */
		  hdfvars[hdfvarid].objID = varID;
		  strcpy(hdfvars[hdfvarid].name, name2);
		  hdfvarid++;
		}
	      else if ( H5Gget_objtype_by_idx(groupID2, idx2) == H5G_GROUP )
		{
		  printf("group level2 not supported\n");
		}  
	    }
	  H5Gclose(groupID2);
	  printf("num_obj2 %d\n", (int) num_obj2);
	}
    }
  printf("num_obj  %d\n", (int) num_obj);
  printf("hdfvarid %d\n", (int) hdfvarid);

  H5Gclose(groupID);
#endif
}

void hdfInqContents(int streamID)
{
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfInqContents";
  int fileID;
  int ndims, hdfvarid;
  int hdfobjID;
  int nvars, ngatts, unlimdimid;
  int ncdimid;
  int nvdims, nvatts;
  int *dimidsp;
  int xtype;
  size_t ntsteps = 0;
  int timedimid = -1;
  int iatt;
  size_t attlen;
  char name[128];
  char attname[128];
  char atttext[1024];
  int tablenum;
  int instID  = UNDEFID;
  int modelID = UNDEFID;
  HDFVAR *hdfvars;
  int i;
  int status;
  int groupID;
  hsize_t num_obj, idx;
  hsize_t dims[9], maxdims[9];
  int varspaceid;
  int vlistID;
  
  streamCheckID(func, streamID);

  fileID  = streamInqFileID(streamID);
  vlistID = streamInqVlist(streamID);

  if ( CDI_Debug )
    Message(func, "streamID = %d, fileID = %d", streamID, fileID);

  groupID = H5Gopen(fileID, "/");
  status = H5Gget_num_objs(groupID, &num_obj);
  printf("num_obj %d\n", (int) num_obj);
  for ( idx = 0; idx < num_obj; idx++ )
    {
      if ( H5Gget_objtype_by_idx(groupID, idx) == H5G_DATASET )
	{
	  H5Gget_objname_by_idx(groupID, idx, name, (size_t) 128);
	  printf("  name: %s %s\n", "/", name);
	  hdfvarid = H5Dopen(groupID, name);

	  varspaceid = H5Dget_space(hdfvarid);
	  ndims = H5Sget_simple_extent_dims(varspaceid, dims, maxdims);
	  for ( i = 0; i < ndims; i++ )
	    printf("    id %d  dim %4d  maxdim %4d\n", i, (int) dims[i], (int) maxdims[i]);
	}
      else if ( H5Gget_objtype_by_idx(groupID, idx) == H5G_GROUP )
	{
	  hsize_t num_obj2, idx2;
	  int groupID2;
	  char name2[128];
	  H5Gget_objname_by_idx(groupID, idx, name, (size_t) 128);
	  groupID2 = H5Gopen(fileID, name);
	  status = H5Gget_num_objs(groupID2, &num_obj2);
	  for ( idx2 = 0; idx2 < num_obj2; idx2++ )
	    {
	      if ( H5Gget_objtype_by_idx(groupID2, idx2) == H5G_DATASET )
		{
		  H5Gget_objname_by_idx(groupID2, idx2, name2, (size_t) 128);
		  printf("  name: %s %s\n", name, name2);
		  hdfvarid = H5Dopen(groupID2, name2);

		  varspaceid = H5Dget_space(hdfvarid);
		  ndims = H5Sget_simple_extent_dims(varspaceid, dims, maxdims);
		  for ( i = 0; i < ndims; i++ )
		    printf("    id %d  dim %4d  maxdim %4d\n", i, (int) dims[i], (int) maxdims[i]);
		}
	      else if ( H5Gget_objtype_by_idx(groupID2, idx2) == H5G_GROUP )
		{
		  printf("group level2 not supported\n");
		}  
	    }
	  H5Gclose(groupID2);
	  printf("num_obj2 %d\n", (int) num_obj2);
	}
    }
  printf("num_obj %d\n", (int) num_obj);

  H5Gclose(groupID);
  hdfvarid = H5Dopen(fileID, "//coordinates/lon");
  H5Iget_name(hdfvarid, name, (size_t) 128 );
  printf("name : >%s<\n", name);
  H5Dclose(hdfvarid);


  nvars  = hdf_inq_nvars(fileID);
  ngatts = hdf_inq_ngatts(fileID);
  ndims  = 0;
  unlimdimid = -1;
  printf("nvars = %d\n", nvars);
  printf("ngatts = %d\n", ngatts);

  /* hdf_inq(fileID, &ndims , &nvars, &ngatts, &unlimdimid); */

  /* alloc hdfvars */
  /* ncdims = (HDFDIM *) malloc(ndims*sizeof(HDFDIM)); */

  /* alloc hdfvars */
  hdfvars = (HDFVAR *) malloc(nvars*sizeof(HDFVAR));

  /* init ncdims */
  /*
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      ncdims[ncdimid].hdfvarid     = UNDEFID;
      ncdims[ncdimid].dimtype      = UNDEFID;
      ncdims[ncdimid].len          = 0;
      ncdims[ncdimid].name[0]      = 0;
    }
  */
  /* init hdfvars */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      hdfvars[hdfvarid].objID        = UNDEFID;
      hdfvars[hdfvarid].isvar        = UNDEFID;
      hdfvars[hdfvarid].islon        = FALSE;
      hdfvars[hdfvarid].islat        = FALSE;
      hdfvars[hdfvarid].islev        = FALSE;
      hdfvars[hdfvarid].warn         = FALSE;
      hdfvars[hdfvarid].timeID       = TIME_CONSTANT;
      hdfvars[hdfvarid].code         = UNDEFID;
      hdfvars[hdfvarid].bounds       = UNDEFID;
      hdfvars[hdfvarid].gridID       = UNDEFID;
      hdfvars[hdfvarid].zaxisID      = UNDEFID;
      hdfvars[hdfvarid].gridtype     = UNDEFID;
      hdfvars[hdfvarid].zaxistype    = UNDEFID;
      hdfvars[hdfvarid].xdim         = UNDEFID;
      hdfvars[hdfvarid].ydim         = UNDEFID;
      hdfvars[hdfvarid].zdim         = UNDEFID;
      hdfvars[hdfvarid].xvarid       = UNDEFID;
      hdfvars[hdfvarid].yvarid       = UNDEFID;
      hdfvars[hdfvarid].cellarea     = UNDEFID;
      hdfvars[hdfvarid].tableID      = UNDEFID;
      hdfvars[hdfvarid].vlen         = 0;
      hdfvars[hdfvarid].vdata        = NULL;
      hdfvars[hdfvarid].truncation   = 0;
      hdfvars[hdfvarid].defmiss      = 0;
      hdfvars[hdfvarid].levelscale   = 1;
      hdfvars[hdfvarid].missval      = 0;
      hdfvars[hdfvarid].addoffset    = 0;
      hdfvars[hdfvarid].scalefactor  = 1;
      hdfvars[hdfvarid].name[0]      = 0;
      hdfvars[hdfvarid].longname[0]  = 0;
      hdfvars[hdfvarid].units[0]     = 0;
    }

  hdfOpenVars(fileID, hdfvars, nvars);

  /* read global attributtes*/
  for ( iatt = 0; iatt < ngatts; iatt++ )
    {
      hdf_inq_attname(fileID, HDF_GLOBAL, iatt, attname);
      if ( strcmp(attname, "history") == 0 )
	{
	  streams[streamID].historyID = iatt;
	}
      if ( strcmp(attname, "institution") == 0 )
	{
	  hdf_inq_attlen(fileID, HDF_GLOBAL, attname, &attlen);
	  hdf_get_att_text(fileID, HDF_GLOBAL, attname, atttext);
	  atttext[attlen] = 0;
	  instID = institutInq(0, 0, NULL, atttext);
	  if ( instID == UNDEFID )
	    instID = institutDef(0, 0, NULL, atttext);
	}
      if ( strcmp(attname, "source") == 0 )
	{
	  hdf_inq_attlen(fileID, HDF_GLOBAL, attname, &attlen);
	  hdf_get_att_text(fileID, HDF_GLOBAL, attname, atttext);
	  atttext[attlen] = 0;
	  modelID = modelInq(-1, 0, atttext);
	}
    }

  /* find time dim */
  /*
  if ( unlimdimid >= 0 )
    timedimid = unlimdimid;
  else
    timedimid = hdfTimeDimID(fileID, ndims, nvars);
  */
  streams[streamID].basetime.ncdimid = timedimid;
  /*
  if ( timedimid != UNDEFID )
    hdf_inq_dimlen(fileID, timedimid, &ntsteps);
  else
    ntsteps = 0;
  */
  streams[streamID].ntsteps = ntsteps;

  if ( CDI_Debug )
    Message(func, "time dimid = %d", streams[streamID].basetime.ncdimid);


  /* read ncdims */
  /*
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      hdf_inq_dimlen(fileID, ncdimid, &ncdims[ncdimid].len);
      hdf_inq_dimname(fileID, ncdimid, ncdims[ncdimid].name);
      if ( timedimid == ncdimid )
	ncdims[ncdimid].dimtype = DIMTYPE_T;
    }
  */
  /* read hdfvars */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      dimidsp = hdfvars[hdfvarid].dimids;

      hdfobjID = hdfvars[hdfvarid].objID;
      printf("hdfobjid %d %d\n", hdfvarid, hdfobjID);
      H5Iget_name(hdfobjID, name, (size_t) 128 );
      printf("name : >%s<\n", name);
      /*
      hdf_inq_var(fileID, hdfobjID, name, &xtype, &nvdims, dimidsp, &nvatts);
      */
      nvdims = hdf_inq_varndims(hdfobjID);
      continue;

      for ( ncdimid = 0; ncdimid < nvdims; ncdimid++ )
	hdfvars[hdfvarid].dimtype[ncdimid] = -1;

      hdfvars[hdfvarid].xtype = xtype;
      hdfvars[hdfvarid].ndims = nvdims;

      if ( nvdims > 0 )
	if ( timedimid == dimidsp[0] )
	  {
	    hdfvars[hdfvarid].timeID = TIME_VARIABLE;
	    hdfSetDim(hdfvars, hdfvarid, 0, DIMTYPE_T);
	  }

      for ( iatt = 0; iatt < nvatts; iatt++ )
	{
	  hdf_inq_attname(fileID, hdfvarid, iatt, attname);
	  
	  if ( strcmp(attname, "long_name") == 0 )
	    {
	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, hdfvars[hdfvarid].longname);
	      hdfvars[hdfvarid].longname[attlen] = 0;
      	    }
	  else if ( strcmp(attname, "units") == 0 )
	    {
	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, hdfvars[hdfvarid].units);
	      hdfvars[hdfvarid].units[attlen] = 0;
      	    }
	  else if ( strcmp(attname, "code") == 0 )
	    {
	      hdf_get_att_int(fileID, hdfvarid, attname, &hdfvars[hdfvarid].code);
	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "table") == 0 )
	    {
	      hdf_get_att_int(fileID, hdfvarid, attname, &tablenum);
	      if ( tablenum > 0 )
		{
		  hdfvars[hdfvarid].tableID = tableInq(modelID, tablenum, NULL);
		  if ( hdfvars[hdfvarid].tableID == CDI_UNDEFID )
		    hdfvars[hdfvarid].tableID = tableDef(modelID, tablenum, NULL);
		}
	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "grid_type") == 0 )
	    {
	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, atttext);
	      atttext[attlen] = 0;
	      if      ( strncmp(atttext, "gaussian", attlen) == 0 )
		hdfvars[hdfvarid].gridtype = GRID_GAUSSIAN;
	      else if ( strncmp(atttext, "gaussian reduced", attlen) == 0 )
		hdfvars[hdfvarid].gridtype = GRID_GAUSSIAN_REDUCED;
	      else if ( strncmp(atttext, "spectral", 8) == 0 )
		hdfvars[hdfvarid].gridtype = GRID_SPECTRAL;
	      else if ( strncmp(atttext, "trajectory", attlen) == 0 )
		hdfvars[hdfvarid].gridtype = GRID_TRAJECTORY;
	      else if ( strncmp(atttext, "generic", attlen) == 0 )
		hdfvars[hdfvarid].gridtype = GRID_GENERIC;
	      else if ( strncmp(atttext, "cell", attlen) == 0 )
		hdfvars[hdfvarid].gridtype = GRID_CELL;
	      else
		{
		  static int warn = 0;
		  if ( ! warn )
		    {
		      warn = 1;
		      Warning(func, "Gridtype %s unsupported!", atttext);
		    }
		  hdfvars[hdfvarid].gridtype = GRID_GENERIC;
		}

	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "truncation") == 0 )
	    {
	      hdf_get_att_int(fileID, hdfvarid, "truncation", &hdfvars[hdfvarid].truncation);
	    }
	  else if ( strcmp(attname, "add_offset") == 0 )
	    {
	      hdf_get_att_double(fileID, hdfvarid, "add_offset", &hdfvars[hdfvarid].addoffset);
	      if ( xtype != NC_BYTE && xtype != NC_SHORT && xtype != H5T_NATIVE_INT )
		if ( hdfvars[hdfvarid].addoffset != 0 )
		  Warning(func, "attribute add_offset not supported for xtype %d\n", xtype);
	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "scale_factor") == 0 )
	    {
	      hdf_get_att_double(fileID, hdfvarid, "scale_factor", &hdfvars[hdfvarid].scalefactor);	      
	      if ( xtype != NC_BYTE && xtype != NC_SHORT && xtype != H5T_NATIVE_INT )
		if ( hdfvars[hdfvarid].scalefactor != 1 )
		  Warning(func, "attribute scale_factor not supported for xtype %d\n", xtype);
	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "bounds") == 0 )
	    {
	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, atttext);
	      atttext[attlen] = 0;

	      hdf_inq_varid(fileID, atttext, &hdfvars[hdfvarid].bounds);
	      hdfSetVar(hdfvars, hdfvars[hdfvarid].bounds, FALSE);

	      hdfSetVar(hdfvars, hdfvarid, FALSE);
	    }
	  else if ( strcmp(attname, "cell_measures") == 0 )
	    {
	      char *pstring, *cell_measures = NULL, *cell_var = NULL;

	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, atttext);
	      atttext[attlen] = 0;
	      pstring = atttext;

	      while ( isspace((int) *pstring) ) pstring++;
	      cell_measures = pstring;
	      while ( isalnum((int) *pstring) ) pstring++;
	      *pstring++ = 0;
	      while ( isspace((int) *pstring) ) pstring++;
	      cell_var = pstring;
	      while ( ! isspace((int) *pstring) && *pstring != 0 ) pstring++;
	      *pstring++ = 0;
	      /*
	      printf("cell_measures >%s<\n", cell_measures);
	      printf("cell_var >%s<\n", cell_var);
	      */
	      if ( strcmp(cell_measures, "area") == 0 )
		{
		  hdf_inq_varid(fileID, cell_var, &hdfvars[hdfvarid].cellarea);
		  hdfSetVar(hdfvars, hdfvars[hdfvarid].cellarea, FALSE);
		}
	      else
		{
		  Warning(func, "%s has unexpected contents: %s", attname, cell_measures);
		}
	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "coordinates") == 0 )
	    {
	      char *pstring, *xvarname = NULL, *yvarname = NULL;
	      
	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, atttext);
	      atttext[attlen] = 0;
	      pstring = atttext;

	      while ( isspace((int) *pstring) ) pstring++;
	      xvarname = pstring;
	      while ( isalnum((int) *pstring) ) pstring++;
	      *pstring++ = 0;
	      while ( isspace((int) *pstring) ) pstring++;
	      yvarname = pstring;
	      while ( isalnum((int) *pstring) ) pstring++;
	      *pstring++ = 0;
	      /*
	      printf("xvarname >%s<\n", xvarname);
	      printf("yvarname >%s<\n", yvarname);
	      */
	      hdf_inq_varid(fileID, xvarname, &hdfvars[hdfvarid].xvarid);
	      hdf_inq_varid(fileID, yvarname, &hdfvars[hdfvarid].yvarid);

	      hdfSetVar(hdfvars, hdfvars[hdfvarid].xvarid, FALSE);
	      hdfSetVar(hdfvars, hdfvars[hdfvarid].yvarid, FALSE);
	      hdfSetVar(hdfvars, hdfvarid, TRUE);
	    }
	  else if ( strcmp(attname, "_FillValue") == 0 )
	    {
	      hdf_get_att_double(fileID, hdfvarid, "_FillValue", &hdfvars[hdfvarid].missval);
	      hdfvars[hdfvarid].defmiss = TRUE;
	      /* hdfSetVar(hdfvars, hdfvarid, TRUE); */
	    }
	  else if ( strcmp(attname, "axis") == 0 )
	    {
	      hdf_inq_attlen(fileID, hdfvarid, attname, &attlen);
	      hdf_get_att_text(fileID, hdfvarid, attname, atttext);
	      atttext[attlen] = 0;
	      if ( attlen != (size_t) nvdims )
		Warning(func, "axis attribute length %d does not match nvdim %d", attlen, nvdims);
	      else
		{
		  while ( attlen-- )
		    {
		      if ( atttext[attlen] == 't' )
			{
			  if ( attlen != 0 )
			    Warning(func, "axis attribute 't' not on first position");
			  hdfSetDim(hdfvars, hdfvarid, attlen, DIMTYPE_T);
			}
		      else if ( atttext[attlen] == 'z' )
			{
			  hdfvars[hdfvarid].zdim = dimidsp[attlen];
			  hdfSetDim(hdfvars, hdfvarid, attlen, DIMTYPE_Z);
			}
		      else if ( atttext[attlen] == 'y' )
			{
			  hdfvars[hdfvarid].ydim = dimidsp[attlen];
			  hdfSetDim(hdfvars, hdfvarid, attlen, DIMTYPE_GY);
			}
		      else if ( atttext[attlen] == 'x' )
			{
			  hdfvars[hdfvarid].xdim = dimidsp[attlen];
			  hdfSetDim(hdfvars, hdfvarid, attlen, DIMTYPE_GX);
			}
		    }
		}
	    }
	}
    }

  printHDFvars(hdfvars, nvars);

  printf(">>>baustelle<<<\n");
  exit(EXIT_FAILURE);
#if defined (XYZ)
  /* find coordinate vars */
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
	{
	  if ( hdfvars[hdfvarid].ndims == 1 && hdfvars[hdfvarid].isvar != TRUE )
	    {
	      hdfSetVar(hdfvars, hdfvarid, FALSE);
	      if ( ncdimid == hdfvars[hdfvarid].dimids[0] && ncdims[ncdimid].hdfvarid == UNDEFID )
		if ( strcmp(hdfvars[hdfvarid].name, ncdims[ncdimid].name) == 0 )
		  {
		    ncdims[ncdimid].hdfvarid = hdfvarid;
		  }
	    }
	}
    }

  /* find time var */
  if ( timedimid != UNDEFID )
    {
      if ( ncdims[timedimid].hdfvarid != UNDEFID )
	streams[streamID].basetime.hdfvarid = ncdims[timedimid].hdfvarid;
      else
	{
	  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
	    if ( hdfvars[hdfvarid].ndims == 1 && timedimid == hdfvars[hdfvarid].dimids[0] )
	      {
		streams[streamID].basetime.hdfvarid = hdfvarid;
		break;
	      }
	}
      if ( streams[streamID].basetime.hdfvarid == UNDEFID )
	Warning(func, "time variable not found!");
      else
	{
	  if ( hdfvars[streams[streamID].basetime.hdfvarid].units[0] != 0 )
	    timehasunit = TRUE;
	}
    }

  /* check hdfvars */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      if ( timedimid != UNDEFID )
	if ( hdfvars[hdfvarid].ndims > 1 && timedimid == hdfvars[hdfvarid].dimids[0] )
	  hdfSetVar(hdfvars, hdfvarid, TRUE);

      if ( hdfvars[hdfvarid].isvar == -1 && hdfvars[hdfvarid].ndims == 0 )
	hdfSetVar(hdfvars, hdfvarid, FALSE);

      if ( hdfvars[hdfvarid].isvar == -1 && hdfvars[hdfvarid].ndims > 1 )
	hdfSetVar(hdfvars, hdfvarid, TRUE);
	  
      if ( hdfvars[hdfvarid].isvar == -1 )
	Warning(func, "variable %s has unknown type, skipped!", hdfvars[hdfvarid].name);
      if ( hdfvars[hdfvarid].ndims > 4 )
	Warning(func, "%d dimension variables unsupported. Skip variable %s",
		hdfvars[hdfvarid].ndims, hdfvars[hdfvarid].name);

      if ( hdfvars[hdfvarid].xtype == NC_CHAR )
	hdfvars[hdfvarid].isvar = -1;
    }

  /* verify coordinate vars */
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      hdfvarid = ncdims[ncdimid].hdfvarid;
      if ( hdfvarid != -1 )
	{
	  if ( hdfvars[hdfvarid].dimids[0] == timedimid )
	    {
	      ncdims[ncdimid].dimtype = DIMTYPE_T;
	      continue;
	    }

	  if ( hdfvars[hdfvarid].longname[0] != 0 )
	    {
	      if ( strcmp(hdfvars[hdfvarid].longname, "Longitude") == 0 ||
		   strcmp(hdfvars[hdfvarid].longname, "longitude") == 0 )
		{
		  hdfvars[hdfvarid].islon = TRUE;
		  hdfSetVar(hdfvars, hdfvarid, FALSE);
		  hdfSetDim(hdfvars, hdfvarid, 0, DIMTYPE_GX);
		  ncdims[ncdimid].dimtype = DIMTYPE_GX;
		  continue;
		}
	      else if ( strcmp(hdfvars[hdfvarid].longname, "Latitude") == 0 || 
			strcmp(hdfvars[hdfvarid].longname, "latitude") == 0 )
		{
		  hdfvars[hdfvarid].islat = TRUE;
		  hdfSetVar(hdfvars, hdfvarid, FALSE);
		  hdfSetDim(hdfvars, hdfvarid, 0, DIMTYPE_GY);
		  ncdims[ncdimid].dimtype = DIMTYPE_GY;
		  continue;
		}
	    }

	  if ( hdfvars[hdfvarid].units[0] != 0 )
	    {
	      if ( strcmp(hdfvars[hdfvarid].units, "degrees_east") == 0 ||
		   strcmp(hdfvars[hdfvarid].units, "degree_E")     == 0 ||
		   strcmp(hdfvars[hdfvarid].units, "degrees_E")    == 0 ||
		   strcmp(hdfvars[hdfvarid].units, "degreeE")      == 0 ||
		   strcmp(hdfvars[hdfvarid].units, "degreesE")     == 0 )
		{
		  hdfvars[hdfvarid].islon = TRUE;
		  hdfSetVar(hdfvars, hdfvarid, FALSE);
		  hdfSetDim(hdfvars, hdfvarid, 0, DIMTYPE_GX);
		  ncdims[ncdimid].dimtype = DIMTYPE_GX;
		}
	      else if ( strcmp(hdfvars[hdfvarid].units, "degrees_north") == 0 ||
			strcmp(hdfvars[hdfvarid].units, "degree_N")      == 0 ||
			strcmp(hdfvars[hdfvarid].units, "degrees_N")     == 0 ||
			strcmp(hdfvars[hdfvarid].units, "degreeN")       == 0 ||
			strcmp(hdfvars[hdfvarid].units, "degreesN")      == 0 )
		{
		  hdfvars[hdfvarid].islat = TRUE;
		  hdfSetVar(hdfvars, hdfvarid, FALSE);
		  hdfSetDim(hdfvars, hdfvarid, 0, DIMTYPE_GY);
		  ncdims[ncdimid].dimtype = DIMTYPE_GY;
		}
	      else if ( strcmp(hdfvars[hdfvarid].units, "millibar") == 0 ||
			strcmp(hdfvars[hdfvarid].units, "hPa")      == 0 )
		{
		  hdfvars[hdfvarid].zaxistype = ZAXIS_PRESSURE;
		  hdfvars[hdfvarid].levelscale = 100;
		  /*  for ( ilev = 0; ilev < nlevs; ilev++ ) dlevels[ilev] *= 100; */
		}
	      else if ( strcmp(hdfvars[hdfvarid].units, "Pa") == 0 )
		{
		  hdfvars[hdfvarid].zaxistype = ZAXIS_PRESSURE;
		  hdfvars[hdfvarid].levelscale = 1;
		}
	      else if ( strcmp(hdfvars[hdfvarid].units, "level") == 0)
		{
		  if      ( strcmp(hdfvars[hdfvarid].longname, "hybrid level at layer midpoints") == 0 )
		    hdfvars[hdfvarid].zaxistype = ZAXIS_HYBRID;
		  else if ( strcmp(hdfvars[hdfvarid].longname, "hybrid level at layer interfaces") == 0 )
		    hdfvars[hdfvarid].zaxistype = ZAXIS_HYBRID_HALF;
		}
	      else if ( strcmp(hdfvars[hdfvarid].units, "cm")  == 0 )
		{
		  if ( strcmp(hdfvars[hdfvarid].longname, "depth below land")         == 0 ||
		       strcmp(hdfvars[hdfvarid].longname, "levels below the surface") == 0 )
		    hdfvars[hdfvarid].zaxistype = ZAXIS_DEPTH_BELOW_LAND;
		}
	      else if ( strcmp(hdfvars[hdfvarid].units, "m")   == 0 )
		{
		  if ( strcmp(hdfvars[hdfvarid].longname, "depth below sea") == 0 )
		    hdfvars[hdfvarid].zaxistype = ZAXIS_DEPTH_BELOW_SEA;
		  else if ( strcmp(hdfvars[hdfvarid].longname, "height") == 0 )
		    hdfvars[hdfvarid].zaxistype = ZAXIS_HEIGHT;
		}
	    }

	  if ( hdfvars[hdfvarid].zaxistype != UNDEFID )
	    {
	      hdfSetVar(hdfvars, hdfvarid, FALSE);
	      hdfSetDim(hdfvars, hdfvarid, 0, DIMTYPE_Z);
	      ncdims[ncdimid].dimtype = DIMTYPE_Z;
	    }
	}
    }
  /*
  for ( ncdimid = 0; ncdimid < ndims; ncdimid++ )
    {
      hdfvarid = ncdims[ncdimid].hdfvarid;
      if ( hdfvarid != -1 )
	{
	  printf("coord var %d %s %s\n", hdfvarid, hdfvars[hdfvarid].name, hdfvars[hdfvarid].units);
	  if ( ncdims[ncdimid].dimtype == DIMTYPE_GX )
	    printf("coord var %d %s is x dim\n", hdfvarid, hdfvars[hdfvarid].name);
	  if ( ncdims[ncdimid].dimtype == DIMTYPE_GY )
	    printf("coord var %d %s is y dim\n", hdfvarid, hdfvars[hdfvarid].name);
	  if ( ncdims[ncdimid].dimtype == DIMTYPE_Z )
	    printf("coord var %d %s is z dim\n", hdfvarid, hdfvars[hdfvarid].name);
	  if ( ncdims[ncdimid].dimtype == DIMTYPE_T )
	    printf("coord var %d %s is t dim\n", hdfvarid, hdfvars[hdfvarid].name);

	  if ( hdfvars[hdfvarid].islon )
	    printf("coord var %d %s is lon\n", hdfvarid, hdfvars[hdfvarid].name);
	  if ( hdfvars[hdfvarid].islat )
	    printf("coord var %d %s is lat\n", hdfvarid, hdfvars[hdfvarid].name);
	  if ( hdfvars[hdfvarid].islev )
	    printf("coord var %d %s is lev\n", hdfvarid, hdfvars[hdfvarid].name);
	}
    }
  */
  /* set dim type */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      if ( hdfvars[hdfvarid].isvar == TRUE )
	{
	  int lxdim = 0, lydim = 0, lzdim = 0, ltdim = 0;
	  ndims = hdfvars[hdfvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      ncdimid = hdfvars[hdfvarid].dimids[i];
	      if ( ncdims[ncdimid].dimtype == DIMTYPE_GX )
		hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_GX);
	      else if ( ncdims[ncdimid].dimtype == DIMTYPE_GY )
		hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_GY);
	      else if ( ncdims[ncdimid].dimtype == DIMTYPE_Z )
		hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_Z);
	      else if ( ncdims[ncdimid].dimtype == DIMTYPE_T )
		hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_T);
	    }

	  if ( CDI_Debug )
	    {
	      Message(func, "var %d %s", hdfvarid, hdfvars[hdfvarid].name);
	      for ( i = 0; i < ndims; i++ )
		printf("  dim %d type %d  ", i, hdfvars[hdfvarid].dimtype[i]);
	      printf("\n");
	    }

	  for ( i = 0; i < ndims; i++ )
	    {
	      if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_GX )
		{
		  lxdim = TRUE;
		}
	      else if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_GY )
		{
		  lydim = TRUE;
		}
	      else if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_Z )
		{
		  lzdim = TRUE;
		}
	      else if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_T )
		{
		  ltdim = TRUE;
		}
	    }

	  for ( i = ndims-1; i >= 0; i-- )
	    {
	      if ( hdfvars[hdfvarid].dimtype[i] == -1 )
		{
		  /*
		  printf("undef dim: %d %d %d %d %d\n", i, lxdim, lydim, lzdim, ltdim);
		  */
		  if ( lxdim == FALSE )
		    {
		      hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_GX);
		      lxdim = TRUE;
		    }
		  else if ( lydim == FALSE )
		    {
		      hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_GY);
		      lydim = TRUE;
		    }
		  else if ( lzdim == FALSE )
		    {
		      hdfSetDim(hdfvars, hdfvarid, i, DIMTYPE_Z);
		      lzdim = TRUE;
		    }
		}
	    }	    	  
	}
    }

  /* define grid */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      if ( hdfvars[hdfvarid].isvar == TRUE && hdfvars[hdfvarid].gridID == UNDEFID )
	{
	  int xdimid = -1, ydimid = -1;
	  int xvarid = -1, yvarid = -1;
	  int islon = 0, islat = 0;
	  double *xvar = NULL, *yvar = NULL;

	  xsize = 0;
	  ysize = 0;

	  ndims = hdfvars[hdfvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_GX )
		xdimid = hdfvars[hdfvarid].dimids[i];
	      else if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_GY )
		ydimid = hdfvars[hdfvarid].dimids[i];
	    }
	  
	  /*
	  if ( hdfvars[hdfvarid].xvarid != UNDEFID )
	    xvarid = hdfvars[hdfvarid].xvarid;
	  else if ( xdimid != UNDEFID )
	    xvarid = ncdims[xdimid].hdfvarid;

	  if ( hdfvars[hdfvarid].yvarid != UNDEFID )
	    yvarid = hdfvars[hdfvarid].yvarid;
	  else if ( ydimid != UNDEFID )
	    yvarid = ncdims[ydimid].hdfvarid;
	  */
	  
	  if ( xdimid != UNDEFID )
	    xvarid = ncdims[xdimid].hdfvarid;
	  if ( xvarid == UNDEFID && hdfvars[hdfvarid].xvarid != UNDEFID )
	    xvarid = hdfvars[hdfvarid].xvarid;

	  if ( ydimid != UNDEFID )
	    yvarid = ncdims[ydimid].hdfvarid;
	  if ( yvarid == UNDEFID && hdfvars[hdfvarid].yvarid != UNDEFID )
	    yvarid = hdfvars[hdfvarid].yvarid;


	  if ( xdimid != UNDEFID )
	    hdf_inq_dimlen(fileID, xdimid, &xsize);

	  if ( ydimid != UNDEFID )
	    hdf_inq_dimlen(fileID, ydimid, &ysize);

	  memset(&grid, 0, sizeof(GRID));

	  grid.trunc = hdfvars[hdfvarid].truncation;
	  
	  if ( hdfvars[hdfvarid].gridtype == GRID_TRAJECTORY )
	    {
	      if ( hdfvars[hdfvarid].xvarid == UNDEFID )
		Error(func, "Longitude coordinate undefined for %s!", name);
	      if ( hdfvars[hdfvarid].yvarid == UNDEFID )
		Error(func, "Latitude coordinate undefined for %s!", name);
	    }
	  else
	    {
	      if ( xvarid != UNDEFID )
		{
		  islon = hdfvars[xvarid].islon;
		  xvar = (double *) malloc(xsize*sizeof(double));
		  hdf_get_var_double(fileID, xvarid, xvar);
		}
	      if ( yvarid != UNDEFID )
		{
		  islat = hdfvars[yvarid].islat;
		  if ( ysize == 0 ) size = xsize;
		  else              size = ysize;
		  yvar = (double *) malloc(size*sizeof(double));
		  hdf_get_var_double(fileID, yvarid, yvar);
		  latinc = 0.0;
		  if ( ysize > 2 )
		    {
		      latinc = fabs(yvar[0] - yvar[1]);
		      for ( i = 2; i < ysize; i++ )
			if ( (fabs(yvar[i-1] - yvar[i]) - latinc) > 0.0 ) break;
		  
		      if ( i < ysize ) latinc = 0.0;
		    }
		}

	      if ( ysize == 0 ) size = xsize;
	      else              size = xsize*ysize;
	    }

	  if ( hdfvars[hdfvarid].gridtype == UNDEFID )
	    {
	      if ( islat && islon && latinc > 0.0 )
		hdfvars[hdfvarid].gridtype = GRID_LONLAT;
	      else
		hdfvars[hdfvarid].gridtype = GRID_GENERIC;
	    }

	  grid.xvals   = NULL;
	  grid.yvals   = NULL;
	  grid.xbounds = NULL;
	  grid.ybounds = NULL;
	  grid.area    = NULL;

	  switch (hdfvars[hdfvarid].gridtype)
	    {
	    case GRID_GENERIC:
	    case GRID_LONLAT:
	    case GRID_GAUSSIAN:
	    case GRID_CELL:
	      {
		grid.size  = size;
		grid.xsize = xsize;
		grid.ysize = ysize;
		if ( xvarid != UNDEFID )
		  {
		    grid.xdef  = TRUE;
		    grid.xvals = xvar;
		    if ( hdfvars[xvarid].bounds != UNDEFID )
		      {
			if ( hdfvars[hdfvars[xvarid].bounds].ndims == 2 )
			  {
			    size_t nvertex;
			    hdf_inq_dimlen(fileID, hdfvars[hdfvars[xvarid].bounds].dimids[1], &nvertex);
			    grid.nvertex = (int) nvertex;
			    grid.xbounds = (double *) malloc(nvertex*size*sizeof(double));
			    hdf_get_var_double(fileID, hdfvars[xvarid].bounds, grid.xbounds);
			  }
		      }
		  }
		if ( yvarid != UNDEFID )
		  {
		    grid.ydef  = TRUE;
		    grid.yvals = yvar;
		    if ( hdfvars[yvarid].bounds != UNDEFID )
		      {
			if ( hdfvars[hdfvars[yvarid].bounds].ndims == 2 )
			  {
			    size_t nvertex;
			    hdf_inq_dimlen(fileID, hdfvars[hdfvars[yvarid].bounds].dimids[1], &nvertex);
			    if ( nvertex != grid.nvertex )
			      Warning(func, "nvertex problem! nvertex x %d, nvertex y %d",
				      grid.nvertex, (int) nvertex);
			    grid.ybounds = (double *) malloc(nvertex*size*sizeof(double));
			    hdf_get_var_double(fileID, hdfvars[yvarid].bounds, grid.ybounds);
			  }
		      }
		  }

		if ( hdfvars[hdfvarid].cellarea != UNDEFID )
		  {
		    grid.area = (double *) malloc(size*sizeof(double));
		    hdf_get_var_double(fileID, hdfvars[hdfvarid].cellarea, grid.area);
		  }

		break;
	      }
	    case GRID_SPECTRAL:
	      {
		grid.size = size;
		break;
	      }
	    case GRID_TRAJECTORY:
	      {
		grid.size = 1;
		break;
	      }
	    }

	  grid.type = hdfvars[hdfvarid].gridtype;

	  hdfvars[hdfvarid].gridID = varDefGrid(vlistID, grid, 0);

	  gridindex = vlistGridIndex(vlistID, hdfvars[hdfvarid].gridID);
	  streams[streamID].xdimID[gridindex] = xdimid;
	  streams[streamID].ydimID[gridindex] = ydimid;

	  if ( xvar ) free(xvar);
	  if ( yvar ) free(yvar);
	  if ( grid.xbounds ) free(grid.xbounds);
	  if ( grid.ybounds ) free(grid.ybounds);
	  if ( grid.area )    free(grid.area);

	  if ( CDI_Debug )
	    Message(func, "gridID %d %d %s",
		    hdfvars[hdfvarid].gridID, hdfvarid, hdfvars[hdfvarid].name);

	  for ( hdfvarid2 = hdfvarid+1; hdfvarid2 < nvars; hdfvarid2++ )
	    if ( hdfvars[hdfvarid2].isvar == TRUE && hdfvars[hdfvarid2].gridID == UNDEFID )
	      {
		int xdimid2 = -1, ydimid2 = -1;
		ndims = hdfvars[hdfvarid2].ndims;
		for ( i = 0; i < ndims; i++ )
		  {
		    if ( hdfvars[hdfvarid2].dimtype[i] == DIMTYPE_GX )
		      xdimid2 = hdfvars[hdfvarid2].dimids[i];
		    else if ( hdfvars[hdfvarid2].dimtype[i] == DIMTYPE_GY )
		      ydimid2 = hdfvars[hdfvarid2].dimids[i];
		  }
		if ( xdimid == xdimid2 && ydimid == ydimid2 )
		  {
		    if ( CDI_Debug )
		      Message(func, "gridID %d %d %s",
			      hdfvars[hdfvarid].gridID, hdfvarid2, hdfvars[hdfvarid2].name);
		    hdfvars[hdfvarid2].gridID = hdfvars[hdfvarid].gridID;
		  }
	      }
	}
    }

  /* find VCT */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      if ( hdfvars[hdfvarid].ndims == 1 )
	{
	  if ( strncmp(hdfvars[hdfvarid].name, "hyai", 4) == 0 )
	    {
	      vcta_id = hdfvarid;
	      nvcth_id = hdfvars[hdfvarid].dimids[0];
	      continue;
	    }
	  if ( strncmp(hdfvars[hdfvarid].name, "hybi", 4) == 0 )
	    {
	      vctb_id = hdfvarid;
	      nvcth_id = hdfvars[hdfvarid].dimids[0];
	      continue;
	    }
	}
    }

  /* read VCT */
  if ( nvcth_id != UNDEFID && vcta_id != UNDEFID && vctb_id != UNDEFID )
    {
      hdf_inq_dimlen(fileID, nvcth_id, &vctsize);
      vctsize *= 2;
      vct = (double *) malloc(vctsize*sizeof(double));
      hdf_get_var_double(fileID, vcta_id, vct);
      hdf_get_var_double(fileID, vctb_id, vct+vctsize/2);
    }

  /* define zaxis */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      if ( hdfvars[hdfvarid].isvar == TRUE && hdfvars[hdfvarid].zaxisID == UNDEFID )
	{
	  int zdimid = -1;
	  int zvarid = -1;
	  size_t zsize = 1;
	  double *zvar = NULL;
	  int zaxisType;

	  ndims = hdfvars[hdfvarid].ndims;
	  for ( i = 0; i < ndims; i++ )
	    {
	      if ( hdfvars[hdfvarid].dimtype[i] == DIMTYPE_Z )
		zdimid = hdfvars[hdfvarid].dimids[i];
	    }

	  if ( zdimid != UNDEFID )
	    zvarid = ncdims[zdimid].hdfvarid;

	  if ( zdimid != UNDEFID )
	    hdf_inq_dimlen(fileID, zdimid, &zsize);

	  if ( CDI_Debug ) Message(func, "nlevs = %ld", zsize);
    
	  zvar = (double *) malloc(zsize*sizeof(double));

	  zaxisType = UNDEFID;

	  if ( zvarid != UNDEFID ) zaxisType = hdfvars[zvarid].zaxistype;
	  
	  if ( zaxisType == UNDEFID )  zaxisType = ZAXIS_GENERIC;

	  if ( zvarid != UNDEFID )
	    {
	      hdf_get_var_double(fileID, zvarid, zvar);
	      if ( zaxisType == ZAXIS_PRESSURE )
		for ( ilev = 0; ilev < zsize; ilev++ ) zvar[ilev] *= hdfvars[zvarid].levelscale;
	    }
	  else
	    {
	      if ( zsize == 1 )
		{
		  zaxisType = ZAXIS_SURFACE;
		  zvar[0] = 0;
		}
	      else
		{
		  for ( ilev = 0; ilev < zsize; ilev++ ) zvar[ilev] = ilev + 1;
		}
	    }

      	  hdfvars[hdfvarid].zaxisID = varDefZaxis(streamID, zaxisType, (int) zsize, zvar, 0, NULL, NULL,
						  vctsize, vct, NULL, NULL, NULL, 0, 1);
	  free(zvar);

	  zaxisindex = vlistZaxisIndex(vlistID, hdfvars[hdfvarid].zaxisID);
	  streams[streamID].zaxisID[zaxisindex]  = zdimid;

	  if ( CDI_Debug )
	    Message(func, "zaxisID %d %d %s",
		    hdfvars[hdfvarid].zaxisID, hdfvarid, hdfvars[hdfvarid].name);

	  for ( hdfvarid2 = hdfvarid+1; hdfvarid2 < nvars; hdfvarid2++ )
	    if ( hdfvars[hdfvarid2].isvar == TRUE && hdfvars[hdfvarid2].zaxisID == UNDEFID )
	      {
		int zdimid2 = -1;
		ndims = hdfvars[hdfvarid2].ndims;
		for ( i = 0; i < ndims; i++ )
		  {
		    if ( hdfvars[hdfvarid2].dimtype[i] == DIMTYPE_Z )
		      zdimid2 = hdfvars[hdfvarid2].dimids[i];
		  }
		if ( zdimid == zdimid2 )
		  {
		    if ( CDI_Debug )
		      Message(func, "zaxisID %d %d %s",
			      hdfvars[hdfvarid].zaxisID, hdfvarid2, hdfvars[hdfvarid2].name);
		    hdfvars[hdfvarid2].zaxisID = hdfvars[hdfvarid].zaxisID;
		  }
	      }
	}
    }

  if ( vct ) free(vct);

  /* select vars */
  for ( hdfvarid = 0; hdfvarid < nvars; hdfvarid++ )
    {
      if ( hdfvars[hdfvarid].isvar == TRUE ) varids[nvarids++] = hdfvarid;
    }
  nc_nvars = nvars;

  if ( CDI_Debug )
    Message(func, "time varid = %d", streams[streamID].basetime.hdfvarid);

  if ( CDI_Debug )
    Message(func, "ntsteps = %d", streams[streamID].ntsteps);

  nvars = nvarids;
  if ( CDI_Debug )
    Message(func, "nvars = %d", nvars);

  for ( varID1 = 0; varID1 < nvars; varID1++ )
    {
      hdfvarid = varids[varID1];

      varID = streamNewVar(streamID, hdfvars[hdfvarid].gridID, hdfvars[hdfvarid].zaxisID);
      varID = vlistDefVar(vlistID, hdfvars[hdfvarid].gridID, hdfvars[hdfvarid].zaxisID, hdfvars[hdfvarid].timeID);

      streams[streamID].vars[varID1].level   = NULL;
      streams[streamID].vars[varID1].defmiss = 0;
      streams[streamID].vars[varID1].nlevs   = zaxisInqSize(hdfvars[hdfvarid].zaxisID);
      streams[streamID].vars[varID1].hdfvarid = hdfvarid;

      vlistDefVarName(vlistID, varID, hdfvars[hdfvarid].name);
      if ( hdfvars[hdfvarid].code != UNDEFID )  vlistDefVarCode(vlistID, varID, hdfvars[hdfvarid].code);
      if ( hdfvars[hdfvarid].longname[0] )      vlistDefVarLongname(vlistID, varID, hdfvars[hdfvarid].longname);
      if ( hdfvars[hdfvarid].units[0] )         vlistDefVarUnits(vlistID, varID, hdfvars[hdfvarid].units);
      if ( hdfvars[hdfvarid].addoffset != 0 )   vlistDefVarAddoffset(vlistID, varID, hdfvars[hdfvarid].addoffset);
      if ( hdfvars[hdfvarid].scalefactor != 1 ) vlistDefVarScalefactor(vlistID, varID, hdfvars[hdfvarid].scalefactor);

      vlistDefVarDatatype(vlistID, varID, hdfInqDatatype(hdfvars[hdfvarid].xtype));

      vlistDefVarInstitut(vlistID, varID, instID);
      vlistDefVarModel(vlistID, varID, modelID);
      vlistDefVarTable(vlistID, varID, hdfvars[hdfvarid].tableID);

      if ( hdfvars[hdfvarid].defmiss == TRUE ) vlistDefVarMissval(vlistID, varID, hdfvars[hdfvarid].missval);

      if ( CDI_Debug )
	Message(func, "varID = %d  gridID = %d  zaxisID = %d", varID,
		vlistInqVarGrid(vlistID, varID), vlistInqVarZaxis(vlistID, varID));
    }

  for ( varID = 0; varID < nvars; varID++ )
    {
      if ( vlistInqVarCode(vlistID, varID) == -varID-1 )
	{
	  char *pname;
	  pname = vlistInqVarNamePtr(vlistID, varID);
	  len = strlen(pname);
	  if ( len > 3 && isdigit((int) pname[3]) )
	    if ( strncmp("var", pname, 3) == 0 )
	      {
		vlistDefVarCode(vlistID, varID, atoi(pname+3));
		streamFreeVarName(vlistID, varID);
	      }
	}
      if ( vlistInqVarCode(vlistID, varID) == -varID-1 )
	{
	  char *pname;
	  pname = vlistInqVarNamePtr(vlistID, varID);
	  len = strlen(pname);
	  if ( len > 4 && isdigit((int) pname[4]) )
	    if ( strncmp("code", pname, 4) == 0 )
	      {
		vlistDefVarCode(vlistID, varID, atoi(pname+4));
		streamFreeVarName(vlistID, varID);
	      }
	}
    }

  for ( varID = 0; varID < nvars; varID++ )
    {
      instID  = vlistInqVarInstitut(vlistID, varID);
      modelID = vlistInqVarModel(vlistID, varID);
      tableID = vlistInqVarTable(vlistID, varID);
      code    = vlistInqVarCode(vlistID, varID);
      if ( cdiDefaultTableID != UNDEFID )
	{
	  if ( tableInqParNamePtr(cdiDefaultTableID, code) )
	    {
	      streamFreeVarName(vlistID, varID);
	      streamFreeVarLongname(vlistID, varID);
	      streamFreeVarUnits(vlistID, varID);

	      if ( tableID != UNDEFID )
		{
		  vlistDefVarName(vlistID, varID, tableInqParNamePtr(cdiDefaultTableID, code));
		  if ( tableInqParLongnamePtr(cdiDefaultTableID, code) )
		    vlistDefVarLongname(vlistID, varID, tableInqParLongnamePtr(cdiDefaultTableID, code));
		  if ( tableInqParUnitsPtr(cdiDefaultTableID, code) )
		    vlistDefVarUnits(vlistID, varID, tableInqParUnitsPtr(cdiDefaultTableID, code));
		}
	      else
		{
		  tableID = cdiDefaultTableID;
		}
	    }
	  if ( cdiDefaultModelID != UNDEFID )
	    modelID = cdiDefaultModelID;
	  if ( cdiDefaultInstID != UNDEFID )
	    instID = cdiDefaultInstID;
	}
      if ( instID  != UNDEFID ) vlistDefVarInstitut(vlistID, varID, instID);
      if ( modelID != UNDEFID ) vlistDefVarModel(vlistID, varID, modelID);
      if ( tableID != UNDEFID ) vlistDefVarTable(vlistID, varID, tableID);
    }

  cdiCreateTimesteps(streamID);

  if ( timehasunit )
    {
      TAXIS *taxis;
      taxis = &streams[streamID].tsteps[0].taxis;

      hdf_inq_attlen(fileID, streams[streamID].basetime.hdfvarid, "units", &attlen);
      hdf_get_att_text(fileID, streams[streamID].basetime.hdfvarid, "units", atttext);
      atttext[attlen] = 0;
      if ( splitBasetime(atttext, taxis) == 1 )
	streams[streamID].basetime.hdfvarid = UNDEFID;	
    }

  if ( streams[streamID].tsteps[0].taxis.type == TAXIS_RELATIVE )
    taxisID = taxisNew(TAXIS_RELATIVE);
  else
    taxisID = taxisNew(TAXIS_ABSOLUTE);

  vlistDefTaxis(vlistID, taxisID);

  streams[streamID].curTsID    = 0;
  streams[streamID].rtsteps = 1;

  (void) hdfInqTimestep(streamID, 0);

  hdfCreateRecords(streamID, 0);

  /* free ncdims */
  free (ncdims);
#endif /*XYZ*/

  /* free hdfvars */
  free (hdfvars);

#endif
}

#if defined (XYZ)

int hdfInqTimestep(int streamID, int tsID)
{
  static char func[] = "hdfInqTimestep";
  long nrecs = 0;
#if  defined  (HAVE_LIBHDF5)
  double timevalue;
  int nctimevarid;
  int fileID;
  size_t index;
  int vdate = 0, vtime = 0;

  if ( CDI_Debug )
    Message(func, "streamID = %d  tsID = %d", streamID, tsID);

  streamCheckID(func, streamID);
    
  if ( tsID < 0 )
    {
      Error(func, "unexpected tsID = %d", tsID);
    }
  else if ( tsID == 0 && streams[streamID].ntsteps == 0 )
    {
      streams[streamID].curTsID = tsID;
      nrecs = streams[streamID].tsteps[tsID].nrecords;
    }
  else if ( tsID < streams[streamID].ntsteps )
    {
      hdfCreateRecords(streamID, tsID);
      if ( tsID > 0 )
	ptaxisCopy(&streams[streamID].tsteps[tsID].taxis,
		     &streams[streamID].tsteps[0].taxis);

      timevalue = tsID;

      nctimevarid = streams[streamID].basetime.hdfvarid;
      if ( nctimevarid != UNDEFID )
	{
	  fileID = streamInqFileID(streamID);
	  index  = tsID;
	  hdf_get_var1_double(fileID, nctimevarid, &index, &timevalue);
	}

      if ( streams[streamID].tsteps[0].taxis.type == TAXIS_ABSOLUTE )
	{
	  int timeunit;
	  timeunit = streams[streamID].tsteps[0].taxis.unit;
	  splitTimevalue(timevalue, timeunit, &vdate, &vtime);
	}
      else
	timeval2vtime(timevalue, &streams[streamID].tsteps[tsID].taxis, &vdate, &vtime);

      streams[streamID].tsteps[tsID].taxis.vdate = vdate;
      streams[streamID].tsteps[tsID].taxis.vtime = vtime;

      streams[streamID].curTsID = tsID;
      nrecs = streams[streamID].tsteps[tsID].nrecords;
    }

#endif
  return ((int) nrecs);
}

void hdfEndDef(int streamID)
{
  int varID, hdfvarid;
  int nvars;

  hdfDefGlobalAtts(streamID);
  hdfDefLocalAtts(streamID);
  if ( streams[streamID].accessmode == 0 )
    {
      nvars =  streams[streamID].nvars;

      for ( varID = 0; varID < nvars; varID++ )
	{
	  hdfvarid = hdfDefVar(streamID, varID);
	}
      streams[streamID].accessmode = 1;
    }
}

void hdfDefInstitut(int streamID)
{
#if  defined  (HAVE_LIBHDF5)
  int fileID, instID;
  char *longname;
  size_t len;

  fileID  = streamInqFileID(streamID);
  instID  = vlistInqInstitut(vlistID);

  if ( instID != UNDEFID )
    {
      longname = institutInqLongnamePtr(instID);
      if ( longname )
	{
	  len = strlen(longname);
	  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
	  hdf_put_att_text(fileID, HDF_GLOBAL, "institution", len, longname);
	  if ( streams[streamID].ncmode == 2 ) hdf_enddef(fileID);
	}
    }
#endif
}

void hdfDefSource(int streamID)
{
#if  defined  (HAVE_LIBHDF5)
  int fileID, modelID;
  char *longname;
  size_t len;

  fileID  = streamInqFileID(streamID);
  modelID = vlistInqModel(vlistID);

  if ( modelID != UNDEFID )
    {
      longname = modelInqNamePtr(modelID);
      if ( longname )
	{
	  len = strlen(longname);
	  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);
	  hdf_put_att_text(fileID, HDF_GLOBAL, "source", len, longname);
	  if ( streams[streamID].ncmode == 2 ) hdf_enddef(fileID);
	}
    }
#endif
}

void hdfDefGlobalAtts(int streamID)
{
  if ( streams[streamID].globalatts ) return;

  hdfDefSource(streamID);
  hdfDefInstitut(streamID);

  streams[streamID].globalatts = 1;
}

void hdfDefLocalAtts(int streamID)
{
#if  defined  (HAVE_LIBHDF5)
  int varID, instID, fileID;
  char *name;
  size_t len;
  int hdfvarid;

  fileID  = streamInqFileID(streamID);

  if ( streams[streamID].localatts ) return;
  if ( vlistInqInstitut(vlistID) != UNDEFID ) return;

  streams[streamID].localatts = 1;

  if ( streams[streamID].ncmode == 2 ) hdf_redef(fileID);

  for ( varID = 0; varID < streams[streamID].nvars; varID++ )
    {
      instID = vlistInqVarInstitut(vlistID, varID);
      if ( instID != UNDEFID )
	{
          hdfvarid = streams[streamID].vars[varID].hdfvarid;
  	  name = institutInqNamePtr(instID);
	  if ( name )
	    {
	      len = strlen(name);
	      hdf_put_att_text(fileID, hdfvarid, "institution", len, name);
	    }
	}
      }
  
  if ( streams[streamID].ncmode == 2 ) hdf_enddef(fileID);
#endif
}

void hdfDefHistory(int streamID, int size, char *history)
{
#if  defined  (HAVE_LIBHDF5)
  int ncid;

  ncid = streams[streamID].fileID;
  hdf_put_att_text(ncid, HDF_GLOBAL, "history", (size_t) size, history);
#endif
}

int hdfInqHistorySize(int streamID)
{
  size_t size = 0;
#if  defined  (HAVE_LIBHDF5)
  int ncid;

  ncid = streams[streamID].fileID;
  if ( streams[streamID].historyID != UNDEFID )
    hdf_inq_attlen(ncid, HDF_GLOBAL, "history", &size);

#endif
  return ((int) size);
}

void hdfInqHistoryString(int streamID, char *history)
{
#if  defined  (HAVE_LIBHDF5)
  int ncid;

  ncid = streams[streamID].fileID;
  if ( streams[streamID].historyID != UNDEFID )
    hdf_get_att_text(ncid, HDF_GLOBAL, "history", history);

#endif
}
#endif /*XYZ*/
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





static void streamvarInitEntry(int streamID, int varID)
{
  streams[streamID].vars[varID].ncvarid      = CDI_UNDEFID;
  streams[streamID].vars[varID].defmiss      = 0;
  streams[streamID].vars[varID].nlevs        = 0;
  streams[streamID].vars[varID].level        = NULL;
  streams[streamID].vars[varID].lindex       = NULL;

  streams[streamID].vars[varID].timeID       = CDI_UNDEFID;
  streams[streamID].vars[varID].gridID       = CDI_UNDEFID;
  streams[streamID].vars[varID].zaxisID      = CDI_UNDEFID;
  streams[streamID].vars[varID].level        = NULL;
  streams[streamID].vars[varID].nlevs        = 0;
}

static int streamvarNewEntry(int streamID)
{
  static char func[] = "streamvarNewEntry";
  int varID = 0;
  int streamvarSize;
  SVARINFO *streamvar;

  streamvarSize = streams[streamID].varsAllocated;
  streamvar     = streams[streamID].vars;
  /*
    Look for a free slot in streamvar.
    (Create the table the first time through).
  */
  if ( ! streamvarSize )
    {
      int i;

      streamvarSize = 2;
      streamvar = (SVARINFO *) malloc(streamvarSize*sizeof(SVARINFO));
      if ( streamvar == NULL )
	{
          Message(func, "streamvarSize = %d", streamvarSize);
	  SysError(func, "Allocation of SVARINFO failed");
	}

      for ( i = 0; i < streamvarSize; i++ )
	streamvar[i].isUsed = FALSE;
    }
  else
    {
      while ( varID < streamvarSize )
	{
	  if ( ! streamvar[varID].isUsed ) break;
	  varID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( varID == streamvarSize )
    {
      int i;

      streamvarSize = 2*streamvarSize;
      streamvar = (SVARINFO *) realloc(streamvar, streamvarSize*sizeof(SVARINFO));
      if ( streamvar == NULL )
	{
          Message(func, "streamvarSize = %d", streamvarSize);
	  SysError(func, "Reallocation of SVARINFO failed");
	}
      varID = streamvarSize/2;

      for ( i = varID; i < streamvarSize; i++ )
	streamvar[i].isUsed = FALSE;
    }

  streams[streamID].varsAllocated = streamvarSize;
  streams[streamID].vars          = streamvar;

  streamvarInitEntry(streamID, varID);

  streams[streamID].vars[varID].isUsed = TRUE;

  return (varID);
}

int streamNewVar(int streamID, int gridID, int zaxisID)
{
  static char func[] = "streamNewVar";
  int varID;
  int *level;
  int *lindex;
  int nlevs;
  int levID;

  if ( CDI_Debug )
    Message(func, "gridID = %d  zaxisID = %d", gridID, zaxisID);

  varID = streamvarNewEntry(streamID);

  streams[streamID].nvars++;

  streams[streamID].vars[varID].gridID  = gridID;
  streams[streamID].vars[varID].zaxisID = zaxisID;

  nlevs = zaxisInqSize(zaxisID);

  level  = (int *) malloc(nlevs*sizeof(int));
  lindex = (int *) malloc(nlevs*sizeof(int));

  for ( levID = 0; levID < nlevs; levID++ )
    level[levID] = CDI_UNDEFID;

  for ( levID = 0; levID < nlevs; levID++ )
    lindex[levID] = levID;

  streams[streamID].vars[varID].nlevs  = nlevs;
  streams[streamID].vars[varID].level  = level;
  streams[streamID].vars[varID].lindex = lindex;

  return (varID);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





void recordInitEntry(RECORD *record)
{
  (*record).position = CDI_UNDEFID;
  (*record).size     = 0;
  (*record).code     = 0;
  (*record).ilevel   = CDI_UNDEFID;
  (*record).used     = FALSE;
  (*record).varID    = CDI_UNDEFID;
  (*record).levelID  = CDI_UNDEFID;
}

int recordNewEntry(int streamID, int tsID)
{
  static char func[] = "recordNewEntry";
  int recordID = 0;
  int recordSize;
  RECORD *records;

  recordSize = streams[streamID].tsteps[tsID].recordSize;
  records    = streams[streamID].tsteps[tsID].records;
  /*
    Look for a free slot in record.
    (Create the table the first time through).
  */
  if ( ! recordSize )
    {
      int i;
      recordSize = 1;   /*  <<<<----  */
      records = (RECORD *) malloc(recordSize*sizeof(RECORD));
      if ( records == NULL )
	{
          Message(func, "recordSize = %d", recordSize);
	  SysError(func, "Allocation of RECORDTABLE failed");
	}

      for ( i = 0; i < recordSize; i++ )
	records[i].used = CDI_UNDEFID;
    }
  else
    {
      while ( recordID < recordSize )
	{
	  if ( records[recordID].used == CDI_UNDEFID ) break;
	  recordID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( recordID == recordSize )
    {
      int i;

      recordSize = 2*recordSize;
      records    = (RECORD *) realloc(records, recordSize*sizeof(RECORD));
      if ( records == NULL )
	{
          Message(func, "recordSize = %d", recordSize);
	  SysError(func, "Reallocation of RECORDTABLE failed");
	}
      recordID = recordSize/2;

      for ( i = recordID; i < recordSize; i++ )
	records[i].used = CDI_UNDEFID;
    }


  recordInitEntry(&records[recordID]);

  records[recordID].used = 1;

  streams[streamID].tsteps[tsID].recordSize = recordSize;
  streams[streamID].tsteps[tsID].records    = records;

  return (recordID);
}

void cdiInitRecord(int streamID)
{
  static char func[] = "cdiInitRecord";

  streams[streamID].record = (Record *) malloc(sizeof(Record));

  streams[streamID].record->used       = 0;
  streams[streamID].record->nrec       = 0;
  streams[streamID].record->dataread   = 1;
  streams[streamID].record->code       = 0;
  streams[streamID].record->level      = 0;
  streams[streamID].record->date       = 0;
  streams[streamID].record->time       = 0;
  streams[streamID].record->gridID     = 0;
  streams[streamID].record->zaxisID    = 0;
  streams[streamID].record->buffer     = 0;
  streams[streamID].record->buffersize = 0;
  streams[streamID].record->position   = 0;
  streams[streamID].record->varID      = 0;
  streams[streamID].record->levelID    = CDI_UNDEFID;
  streams[streamID].record->recid      = 0;
}

void streamInqRecord(int streamID, int *varID, int *levelID)
{
  static char func[] = "streamInqRecord";
  int rec = 0;
  int recID, tsID, rindex;
  int lindex;

  streamCheckID(func, streamID);

  cdiDefAccesstype(streamID, TYPE_REC);

  if ( ! streams[streamID].record ) cdiInitRecord(streamID);

  tsID   = streams[streamID].curTsID;
  rindex = streams[streamID].tsteps[tsID].curRecID + 1;

  if ( rindex >= streams[streamID].tsteps[tsID].nrecs )
    Error(func, "record %d not available at timestep %d", rindex+1, tsID+1);

  recID  = streams[streamID].tsteps[tsID].recIDs[rindex];

  if ( recID == -1 || recID >= streams[streamID].tsteps[tsID].nallrecs )
    Error(func, "Internal problem! tsID = %d recID = %d", tsID, recID);

  *varID   = streams[streamID].tsteps[tsID].records[recID].varID;
  lindex   = streams[streamID].tsteps[tsID].records[recID].levelID;

  *levelID = streams[streamID].vars[*varID].lindex[lindex];

  if ( CDI_Debug )
    Message(func, "tsID = %d, recID = %d, varID = %d, levelID = %d\n",
	    tsID, recID, *varID, *levelID);

  streams[streamID].curTsID = tsID;
  streams[streamID].tsteps[tsID].curRecID = rindex;

  rec = recID + 1;
  /*
  filetype = streams[streamID].filetype;

  switch ( filetype )
    {
    case FILETYPE_GRB:
      {
        rec = grbInqRecord(streamID, varID, levelID);
	break;
      }
    case FILETYPE_SRV:
      {
        rec = srvInqRecord(streamID, varID, levelID);
	break;
      }
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
	rec = cdfInqRecord(streamID, varID, levelID);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
  */
}

void streamDefRecord(int streamID, int varID, int levelID)
{
  static char func[] = "streamDefRecord";
  int ierr = 0;
  int filetype;
  int code, gridID, zaxisID, level;
  int tsID;
  int vlistID;

  streamCheckID(func, streamID);

  tsID = streams[streamID].curTsID;

  if ( tsID == CDI_UNDEFID )
    {
      tsID++;
      streamDefTimestep(streamID, tsID);
    }

  if ( ! streams[streamID].record ) cdiInitRecord(streamID);

  vlistID = streamInqVlist(streamID);
  gridID  = vlistInqVarGrid(vlistID, varID);
  zaxisID = vlistInqVarZaxis(vlistID, varID);
  code    = vlistInqVarCode(vlistID, varID);

  level = (int) zaxisInqLevel(zaxisID, levelID);

  streams[streamID].record->varID    = varID;
  streams[streamID].record->levelID  = levelID;
  streams[streamID].record->code     = code;
  streams[streamID].record->level    = level;
  streams[streamID].record->date     = streams[streamID].tsteps[tsID].taxis.vdate;
  streams[streamID].record->time     = streams[streamID].tsteps[tsID].taxis.vtime;
  streams[streamID].record->gridID   = gridID;
  streams[streamID].record->zaxisID  = zaxisID;
  streams[streamID].record->prec     = vlistInqVarDatatype(vlistID, varID);

  filetype = streams[streamID].filetype;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        ierr = grbDefRecord(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        ierr = srvDefRecord(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        ierr = extDefRecord(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
	if ( streams[streamID].accessmode == 0 ) cdfEndDef(streamID);
	ierr = cdfDefRecord(streamID);
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
	ierr = hdfDefRecord(streamID);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
}

void streamReadRecord(int streamID, double *data, int *nmiss)
{
  static char func[] = "streamReadRecord";
  int ierr = 0;
  int filetype;

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  *nmiss = 0;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        ierr = grbReadRecord(streamID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        ierr = srvReadRecord(streamID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        ierr = extReadRecord(streamID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
	ierr = cdfReadRecord(streamID, data, nmiss);
	break;
      }
#endif
    default:
      {
	char *filename;
	filename = streams[streamID].filename;
	Error(func, "file %s filetype %d unknown", filename, filetype);
	break;
      }
    }
}

void streamWriteRecord(int streamID, double *data, int nmiss)
{
  static char func[] = "streamWriteRecord";
  int ierr = 0;
  int filetype;

  streamCheckID(func, streamID);

  filetype = streams[streamID].filetype;

  switch (filetype)
    {
#if  defined  (HAVE_LIBGRIB)
    case FILETYPE_GRB:
      {
        ierr = grbWriteRecord(streamID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBSERVICE)
    case FILETYPE_SRV:
      {
        ierr = srvWriteRecord(streamID, data);
	break;
      }
#endif
#if  defined  (HAVE_LIBEXTRA)
    case FILETYPE_EXT:
      {
        ierr = extWriteRecord(streamID, data);
	break;
      }
#endif
#if  defined  (HAVE_LIBNETCDF)
    case FILETYPE_NC:
    case FILETYPE_NC2:
      {
	cdfWriteRecord(streamID, data, nmiss);
	break;
      }
#endif
#if  defined  (HAVE_LIBHDF5)
    case FILETYPE_H5:
      {
	hdfWriteRecord(streamID, data, nmiss);
	break;
      }
#endif
    default:
      {
	Error(func, "%s library not available!", strfiletype(filetype));
	break;
      }
    }
}

void streamCopyRecord(int ostreamID, int istreamID)
{
  static char func[] = "streamCopyRecord";
  int ierr = 0;
  int iofiletype = CDI_UNDEFID, ifiletype, ofiletype;

  streamCheckID(func, istreamID);
  streamCheckID(func, ostreamID);

  ifiletype = streams[istreamID].filetype;
  ofiletype = streams[ostreamID].filetype;

  if ( ifiletype == ofiletype ) iofiletype = ofiletype;

  if ( iofiletype == FILETYPE_GRB )
    {
      ierr = grbCopyRecord(ostreamID, istreamID);
    }
#if  defined  (HAVE_LIBEXTRA)
  else if ( iofiletype == FILETYPE_SRV )
    {
      ierr = srvCopyRecord(ostreamID, istreamID);
    }
#endif
#if  defined  (HAVE_LIBEXTRA)
  else if ( iofiletype == FILETYPE_EXT )
    {
      ierr = extCopyRecord(ostreamID, istreamID);
    }
#endif
  else
    {
      ierr = cdfCopyRecord(ostreamID, istreamID);
    }
}

void cdiCreateRecords(int streamID, int tsID)
{
  static char func[] = "cdiCreateRecords";
  int nrecords, maxrecords;
  int nvars, varID, recID;
  RECORD *records;
  int vlistID;

  streamCheckID(func, streamID);

  if ( streams[streamID].tsteps[tsID].records ) return;

  vlistID  = streamInqVlist(streamID);

  if ( tsID == 0 )
    {
      maxrecords = 0;
      nvars = streams[streamID].nvars;
      for ( varID = 0; varID < nvars; varID++)
	maxrecords += streams[streamID].vars[varID].nlevs;
    }
  else
    maxrecords = streams[streamID].tsteps[0].recordSize;

  if ( tsID == 0 )
    {
      nrecords = maxrecords;
    }
  else if ( tsID == 1 )
    {
      nrecords = 0;
      maxrecords = streams[streamID].tsteps[0].recordSize;
      for ( recID = 0; recID < maxrecords; recID++ )
	{
	  varID = streams[streamID].tsteps[0].records[recID].varID;
	  if ( varID != -1 ) /* varID = -1 for write mode !!! */
	    if ( vlistInqVarTime(vlistID, varID) == TIME_CONSTANT )
	      continue;
	  nrecords++;
	}
    }
  else
    nrecords = streams[streamID].tsteps[1].nallrecs;

  records = (RECORD *) malloc(maxrecords*sizeof(RECORD));
  streams[streamID].tsteps[tsID].records    = records;
  streams[streamID].tsteps[tsID].recordSize = maxrecords;
  streams[streamID].tsteps[tsID].nallrecs   = nrecords;

  if ( tsID == 0 )
    {
      for ( recID = 0; recID < maxrecords; recID++ )
	recordInitEntry(&streams[streamID].tsteps[tsID].records[recID]);
    }
  else
    {
      memcpy(streams[streamID].tsteps[tsID].records,
	     streams[streamID].tsteps[0].records,
	     maxrecords*sizeof(RECORD));

      for ( recID = 0; recID < maxrecords; recID++ )
	{
	  varID = streams[streamID].tsteps[0].records[recID].varID;
	  if ( varID != -1 ) /* varID = -1 for write mode !!! */
	    if ( vlistInqVarTime(vlistID, varID) == TIME_VARIABLE )
	      {
		streams[streamID].tsteps[tsID].records[recID].position = CDI_UNDEFID;
		streams[streamID].tsteps[tsID].records[recID].size     = 0;
		streams[streamID].tsteps[tsID].records[recID].used     = FALSE;
	      }
	}
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




static void tstepsInitEntry(int streamID, int tsID)
{
  streams[streamID].tsteps[tsID].curRecID     = CDI_UNDEFID;
  streams[streamID].tsteps[tsID].position     = 0;
  streams[streamID].tsteps[tsID].records      = NULL;
  streams[streamID].tsteps[tsID].recordSize   = 0;
  streams[streamID].tsteps[tsID].nallrecs     = 0;
  streams[streamID].tsteps[tsID].recIDs       = NULL;
  streams[streamID].tsteps[tsID].nrecs        = 0;
  streams[streamID].tsteps[tsID].next         = 0;

  ptaxisInit(&streams[streamID].tsteps[tsID].taxis);
}

int tstepsNewEntry(int streamID)
{
  static char func[] = "tstepsNewEntry";
  int tsID = 0;
  int tstepsTableSize;
  TSTEPS *tstepsTable;

  tsID            = streams[streamID].tstepsNextID++;
  tstepsTableSize = streams[streamID].tstepsTableSize;
  tstepsTable     = streams[streamID].tsteps;

  /*
    If the table overflows, double its size.
  */
  if ( tsID == tstepsTableSize )
    {
      if ( tstepsTableSize == 0 ) tstepsTableSize = 1;
      tstepsTableSize = 2*tstepsTableSize;
      tstepsTable = (TSTEPS *) realloc(tstepsTable, tstepsTableSize*sizeof(TSTEPS));
      if ( tstepsTable == NULL )
	{
          Message(func, "tstepsTableSize = %d", tstepsTableSize);
	  SysError(func, "Reallocation of TSTEPS failed");
	}
    }

  streams[streamID].tstepsTableSize = tstepsTableSize;
  streams[streamID].tsteps          = tstepsTable;

  tstepsInitEntry(streamID, tsID);

  streams[streamID].tsteps[tsID].taxis.used = TRUE;

  return (tsID);
}

void cdiCreateTimesteps(int streamID)
{
  static char func[] = "cdiCreateTimesteps";
  int ntsteps;
  int tsID;

  if ( streams[streamID].ntsteps < 0 || streams[streamID].tstepsTableSize > 0 )
    return;

  if ( streams[streamID].ntsteps == 0 ) ntsteps = 1;    /* <<<<<-------- */
  else ntsteps = streams[streamID].ntsteps;

  streams[streamID].tsteps = (TSTEPS *) malloc(ntsteps*sizeof(TSTEPS));
  if ( streams[streamID].tsteps == NULL )
    SysError(func, "Allocation of TSTEPS failed");

  streams[streamID].tstepsTableSize = ntsteps;
  streams[streamID].tstepsNextID    = ntsteps;

  for ( tsID = 0; tsID < ntsteps; tsID++ )
    {
      tstepsInitEntry(streamID, tsID);
      streams[streamID].tsteps[tsID].taxis.used = TRUE;
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif





#if ! defined (HAVE_MMAP)
#  if defined (__sun) || defined (__i386) || defined (__ia64)
#    define HAVE_MMAP
#  endif
#endif

#if defined (HAVE_MMAP)
#  include <sys/mman.h> /* mmap() is defined in this header */
#endif


#if ! defined   (FALSE)
#  define  FALSE  0
#endif

#if ! defined   (TRUE)
#  define  TRUE   1
#endif

typedef struct
{
  int             used;           /* table entry in use            */
  int             flag;           /* access and error flag         */
  int             eof;            /* end of file flag              */
  int             fd;             /* file descriptor used for read */
  FILE           *fp;             /* FILE pointer used for write   */
  int             mode;           /* file access mode              */
  char           *name;           /* file name                     */
  off_t           size;           /* file size                     */
  off_t           position;       /* file position                 */
  long            access;         /* file access                   */
  off_t           byteTrans;      /*                               */
  size_t          blockSize;      /* file block size               */
  int             bufferType;     /* buffer type ( 1:std 2:mmap )  */
  size_t          bufferSize;     /* file buffer size              */
  size_t          mappedSize;     /* mmap buffer size              */
  char           *buffer;         /* file buffer                   */
  long            bufferNumFill;  /* number of buffer fill         */
  char           *bufferPtr;      /* file buffer pointer           */
  off_t           bufferPos;
  off_t           bufferStart;
  off_t           bufferEnd;
  size_t          bufferCnt;
}
F_I_L_E;

enum F_I_L_E_Flags
  {
    FILE_READ  =  01,
    FILE_WRITE =  02,
    FILE_UNBUF =  04,
    FILE_EOF   = 010,
    FILE_ERROR = 020
  };

static F_I_L_E *fileTable;
static int  fileTableSize = 0;

#undef FILE_CHECKID

static int  FileInit = 0;
static int  FileInfo = 0;


#if ! defined (MIN_BUF_SIZE)
#  define  MIN_BUF_SIZE  131072L
#endif


static size_t FileBufferSizeMin = MIN_BUF_SIZE;
static long   FileBufferSizeEnv = -1;
static int    FileBufferTypeEnv =  0;

static int  FILE_Debug = 0;   /* If set to 1, debugging */


static void fileTablePrint(void);

/*
 * A version string.
 */

#undef   LIBVERSION
#define  LIBVERSION      1.3.2
#define  XSTRING(x)	 #x
#define  STRING(x) 	 XSTRING(x)
const char file_libvers[] = STRING(LIBVERSION) " of "__DATE__" "__TIME__;

/*
  21/05/2004  1.3.2 set min I/O Buffersize to 128k
 */


const char *
fileLibraryVersion(void)
{
  return (file_libvers);
}

#ifndef POSIXIO_DEFAULT_PAGESIZE
#define POSIXIO_DEFAULT_PAGESIZE 4096
#endif

static int
pagesize(void)
{
#if defined (HAVE_MMAP)
  return ((int) getpagesize());
#else
  return ((int) POSIXIO_DEFAULT_PAGESIZE);
#endif
}

void fileDebug(int debug)
{
  static char func[] = "fileDebug";

  FILE_Debug = debug;

  if ( FILE_Debug )
    Message(func, "Debug level %d", debug);
}

static void fileCheckID(const char *func, int fileID)
{
  if ( fileID < 0 || fileID >= fileTableSize )
    Error(func, "fileID %d undefined!", fileID);

  if ( ! fileTable[fileID].used )
    {
      if ( FILE_Debug )
	fileTablePrint();
	  
      Error(func, "fileID %d undefined!", fileID);
    }
}

int fileSetBufferType(int fileID, int type)
{
  static char func[] = "fileSetBufferType";
  int ret = 0;

  switch (type)
    {
    case FILE_TYPE_STD:
    case FILE_TYPE_MMAP:
      fileTable[fileID].bufferType = type;
      break;
    default:
      Error(func, "File type %d not implemented!", type);
    }

#if ! defined (HAVE_MMAP)
  if ( type == FILE_TYPE_MMAP ) ret = 1;
#endif

  return (ret);
}

int fileGetBufferType(int fileID)
{
  return (fileTable[fileID].bufferType);
}

int fileFlush(int fileID)
{
#if defined (FILE_CHECKID)
  static char func[] = "fileFlush";

  fileCheckID(func, fileID);
#endif

  return (fflush(fileTable[fileID].fp));
}

void fileClearerr(int fileID)
{
  if ( fileTable[fileID].mode != 'r' )
    clearerr(fileTable[fileID].fp);
}

int fileEOF(int fileID)
{
  return ((fileTable[fileID].flag & FILE_EOF) != 0 );
}

int fileError(int fileID)
{
  return ((fileTable[fileID].flag & FILE_ERROR) != 0 );
}

void fileRewind(int fileID)
{
  fileSetPos(fileID, (off_t) 0, SEEK_SET);
  fileClearerr(fileID);
}

off_t fileGetPos(int fileID)
{
  static char func[] = "fileGetPos";
  off_t filepos = 0;

#if defined (FILE_CHECKID)
  fileCheckID(func, fileID);
#endif

  if ( fileTable[fileID].mode == 'r' )
    filepos = fileTable[fileID].position;
  else
    filepos = ftell(fileTable[fileID].fp);

  if ( FILE_Debug ) Message(func, "Position %ld", filepos);

  return (filepos);
}

int fileSetPos(int fileID, off_t offset, int whence)
{
  static char func[] = "fileSetPos";
  int status = 0;
  off_t position;

#if defined (FILE_CHECKID)
  fileCheckID(func, fileID);
#endif

  if ( FILE_Debug ) Message(func, "Offset %8ld  Whence %3d", (long) offset, whence);

  switch (whence)
    {
    case SEEK_SET:
      if ( fileTable[fileID].mode == 'r' )
	{
	  position = offset;
	  fileTable[fileID].position = position;
	  if ( position < fileTable[fileID].bufferStart ||
	       position > fileTable[fileID].bufferEnd )
	    {
	      if ( fileTable[fileID].bufferType == FILE_TYPE_STD )
		fileTable[fileID].bufferPos = position;
	      else
		fileTable[fileID].bufferPos = position - position % pagesize();

	      fileTable[fileID].bufferCnt = 0;
	      fileTable[fileID].bufferPtr = NULL;
	    }
	  else
	    {
	      if ( fileTable[fileID].bufferPos != fileTable[fileID].bufferEnd + 1 )
		{
		  if ( FILE_Debug )
		    Message(func, "Reset buffer pos from %ld to %ld",
			    fileTable[fileID].bufferPos, fileTable[fileID].bufferEnd + 1);
			    
		  fileTable[fileID].bufferPos = fileTable[fileID].bufferEnd + 1;
		}
	      fileTable[fileID].bufferCnt = fileTable[fileID].bufferEnd - position + 1;
	      fileTable[fileID].bufferPtr = fileTable[fileID].buffer + position -
		                            fileTable[fileID].bufferStart;
	    }
	}
      else
	{
	  status = fseek(fileTable[fileID].fp, offset, whence);
	}
      break;
    case SEEK_CUR:
      if ( fileTable[fileID].mode == 'r' )
	{
	  fileTable[fileID].position += offset;
	  position = fileTable[fileID].position;
	  if ( position < fileTable[fileID].bufferStart ||
	       position > fileTable[fileID].bufferEnd )
	    {
	      if ( fileTable[fileID].bufferType == FILE_TYPE_STD )
		fileTable[fileID].bufferPos = position;
	      else
		fileTable[fileID].bufferPos = position - position % pagesize();

	      fileTable[fileID].bufferCnt = 0;
	      fileTable[fileID].bufferPtr = NULL;
	    }
	  else
	    {
	      if ( fileTable[fileID].bufferPos != fileTable[fileID].bufferEnd + 1 )
		{
		  if ( FILE_Debug )
		    Message(func, "Reset buffer pos from %ld to %ld",
			    fileTable[fileID].bufferPos, fileTable[fileID].bufferEnd + 1);
			    
		  fileTable[fileID].bufferPos = fileTable[fileID].bufferEnd + 1;
		}
	      fileTable[fileID].bufferCnt -= offset;
	      fileTable[fileID].bufferPtr += offset;
	    }
	}
      else
	{
	  status = fseek(fileTable[fileID].fp, offset, whence);
	}
      break;
    default:
      Error(func, "Whence = %d not implemented", whence);
    }

  if ( fileTable[fileID].position < fileTable[fileID].size )
    if ( (fileTable[fileID].flag & FILE_EOF) != 0 )
      fileTable[fileID].flag -= FILE_EOF;

  return (status);
}

static void fileTablePrint(void)
{
  int fileID;
  int lprintHeader = 1;

  for ( fileID = 0; fileID < fileTableSize; fileID++ )
    {
      if ( fileTable[fileID].used )
	{
	  if ( lprintHeader )
	    {
	      fprintf(stderr, "\nFile table:\n");
	      fprintf(stderr, "+-----+---------+");
	      fprintf(stderr, "----------------------------------------------------+\n");
	      fprintf(stderr, "|  ID |  Mode   |");
	      fprintf(stderr, "  Name                                              |\n");
	      fprintf(stderr, "+-----+---------+");
	      fprintf(stderr, "----------------------------------------------------+\n");
	      fprintf(stderr, "| %3d | ", fileID);
	      lprintHeader = 0;
	    }

	  switch ( fileTable[fileID].mode )
	    {
	    case 'r':
	      fprintf(stderr, "read   ");
	      break;
	    case 'w':
	      fprintf(stderr, "write  ");
	      break;
	    case 'a':
	      fprintf(stderr, "append ");
	      break;
	    default:
	      fprintf(stderr, "unknown");
	    }

          fprintf(stderr, " | %-51s|\n", fileTable[fileID].name);
	}
    }

  if ( lprintHeader == 0 )
    {
      fprintf(stderr, "+-----+---------+");
      fprintf(stderr, "----------------------------------------------------+\n");
    }
}

char *fileInqName(int fileID)
{
  return (fileTable[fileID].name);
}

int fileInqMode(int fileID)
{
#if defined (FILE_CHECKID)
  static char func[] = "fileInqMode";

  fileCheckID(func, fileID);
#endif

  return (fileTable[fileID].mode);
}

static void fileTableInitEntry(int fileID)
{
  static char func[] = "fileTableInitEntry";

  if ( fileID < 0 || fileID >= fileTableSize )
    Error(func, "fileID %d undefined!", fileID);


  fileTable[fileID].used          = FALSE;
  fileTable[fileID].flag          = 0;
  fileTable[fileID].fd            = -1;
  fileTable[fileID].fp            = NULL;
  fileTable[fileID].mode          = 0;
  fileTable[fileID].size          = 0;
  fileTable[fileID].name          = NULL;
  fileTable[fileID].access        = 0;
  fileTable[fileID].position      = 0;
  fileTable[fileID].byteTrans     = 0;
  fileTable[fileID].bufferType    = 0;
  fileTable[fileID].bufferSize    = 0;
  fileTable[fileID].mappedSize    = 0;
  fileTable[fileID].buffer        = NULL;
  fileTable[fileID].bufferNumFill = 0;
  fileTable[fileID].bufferStart   = 0;
  fileTable[fileID].bufferEnd     = -1;
  fileTable[fileID].bufferPos     = 0;
  fileTable[fileID].bufferCnt     = 0;
  fileTable[fileID].bufferPtr     = NULL;
}

static int fileTableNewEntry(void)
{
  static char func[] = "fileTableNewEntry";
  int fileID = 0;

  /*
    Look for a free slot in fileTable.
    (Create the table the first time through).
  */
  if ( !fileTableSize )
    {
      int i;

      fileTableSize = 2;
      fileTable = (F_I_L_E *) malloc(fileTableSize*sizeof(F_I_L_E));
      if( fileTable == NULL )
	SysError(func, "Allocation of F_I_L_E failed!");

      for( i = 0; i < fileTableSize; i++ )
	fileTableInitEntry(i);
    }
  else
    {
      while( fileID < fileTableSize )
	{
	  if ( ! fileTable[fileID].used ) break;
	  fileID++;
	}
    }
  /*
    If the table overflows, double its size.
  */
  if ( fileID == fileTableSize )
    {
      int i;

      fileTableSize = 2*fileTableSize;
      fileTable = (F_I_L_E *) realloc(fileTable, fileTableSize*sizeof(F_I_L_E));
      if( fileTable == NULL )
	SysError(func, "Reallocation of F_I_L_E failed!");

      for( i = fileID; i < fileTableSize; i++ )
	fileTableInitEntry(i);
    }

  fileTable[fileID].used = TRUE;

  return (fileID);
}

static void fileTableDelete(void)
{
  static char func[] = "fileTableDelete";
  int fileID;

  for (fileID = 0; fileID < fileTableSize; fileID++)
    if ( fileTable[fileID].used ) fileClose(fileID);

  if ( fileTable )
    {
      free(fileTable);
      fileTableSize = 0;
    }
}

static long fileGetenv(char *envName)
{
  static char func[] = "fileGetenv";
  char *envString;
  long envValue = -1;
  long fact = 1;

  envString = getenv(envName);

  if ( envString )
    {
      int loop;

      for ( loop = 0; loop < (int) strlen(envString); loop++ )
	{
	  if ( ! isdigit((int) envString[loop]) )
	    {
	      switch ( tolower((int) envString[loop]) )
		{
		case 'k':  fact = 1024;        break;
		case 'm':  fact = 1048576;     break;
		case 'g':  fact = 1073741824;  break;
		default:
		  fact = 0;
		  Message(func, "Invalid number string in %s: %s", envName, envString);
		  Warning(func, "%s must comprise only digits [0-9].",envName);
		}
	      break;
	    }
	}

      if ( fact ) envValue = fact*atol(envString);

      if ( FILE_Debug ) Message(func, "Set %s to %ld", envName, envValue);
    }

  return (envValue);
}

static void fileInitialize(void)
{
  static char func[] = "fileInitialize";
  long value;

  FileInit = 1;

  value = fileGetenv("FILE_DEBUG");
  if ( value >= 0 ) FILE_Debug = (int) value;

  FileInfo = (int) fileGetenv("FILE_INFO");

  value  = fileGetenv("FILE_BUFSIZE");
  if ( value >= 0 ) FileBufferSizeEnv = value;

  value = fileGetenv("FILE_TYPE");
#if ! defined (HAVE_MMAP)
  if ( value == FILE_TYPE_MMAP )
    {
      Warning(func, "MMAP not available!");
      value = 0;
    }
#endif
  if ( value > 0 )
    {
      switch (value)
	{
	case FILE_TYPE_STD:
	case FILE_TYPE_MMAP:
	  FileBufferTypeEnv = value;
	  break;
	default:
	  Warning(func, "File type %d not implemented!", value);
	}
    }

  if ( FILE_Debug ) atexit(fileTablePrint);

  atexit(fileTableDelete);
}

static void fileSetBuffer(int fileID)
{
  static char func[] = "fileSetBuffer";
  size_t buffersize = 0;

#if defined (FILE_CHECKID)
  fileCheckID(func, fileID);
#endif

  if ( fileTable[fileID].mode == 'r' )
    {
      if ( FileBufferTypeEnv )
	fileTable[fileID].bufferType = FileBufferTypeEnv;
      else if ( fileTable[fileID].bufferType == 0 )
	fileTable[fileID].bufferType = FILE_TYPE_STD;

      if ( FileBufferSizeEnv >= 0 )
	buffersize = FileBufferSizeEnv;
      else if ( fileTable[fileID].bufferSize > 0 )
	buffersize = fileTable[fileID].bufferSize;
      else
	{
	  buffersize = fileTable[fileID].blockSize * 4;
	  if ( buffersize < FileBufferSizeMin ) buffersize = FileBufferSizeMin;
	}

      if ( (size_t) fileTable[fileID].size < buffersize )
	buffersize = fileTable[fileID].size;

      if ( fileTable[fileID].bufferType == FILE_TYPE_MMAP )
	{
	  size_t blocksize = pagesize();
	  size_t minblocksize = 4 * blocksize;
	  buffersize = buffersize - buffersize % minblocksize;

	  if ( buffersize < (size_t) fileTable[fileID].size && buffersize < minblocksize )
	    buffersize = minblocksize;
	}
    }
  else
    {
      fileTable[fileID].bufferType = FILE_TYPE_STD;

      if ( FileBufferSizeEnv >= 0 )
	buffersize = FileBufferSizeEnv;
      else if ( fileTable[fileID].bufferSize > 0 )
	buffersize = fileTable[fileID].bufferSize;
      else
	{
	  buffersize = fileTable[fileID].blockSize * 4;
	  if ( buffersize < FileBufferSizeMin ) buffersize = FileBufferSizeMin;
	}
    }

  if ( buffersize == 0 ) buffersize = 1;

  if ( fileTable[fileID].bufferType == FILE_TYPE_STD )
    {
      fileTable[fileID].buffer = (char *) malloc(buffersize);
      if ( fileTable[fileID].buffer == NULL )
	SysError(func, "Allocation of file buffer failed!");
    }	

  if ( fileTable[fileID].mode != 'r' )
    if ( setvbuf(fileTable[fileID].fp, fileTable[fileID].buffer, _IOFBF, buffersize) )
      SysError(func, "setvbuf failed");

  fileTable[fileID].bufferSize = buffersize;
}

static int fileFillBuffer(int fileID)
{
  static char func[] = "fileFillBuffer";
  long nread;
  int fd;
  int ret;
  long offset = 0;
  off_t retseek;
  
  if ( FILE_Debug )
    Message(func, "fileID = %d  Cnt = %ld", fileID, fileTable[fileID].bufferCnt);

  if ( (fileTable[fileID].flag & FILE_EOF) != 0 ) return (EOF);

  if ( fileTable[fileID].buffer == NULL ) fileSetBuffer(fileID);
  
  if ( fileTable[fileID].bufferSize == 0 ) return (EOF);

  fd = fileTable[fileID].fd;

#if defined (HAVE_MMAP)
  if ( fileTable[fileID].bufferType == FILE_TYPE_MMAP )
    {
      if ( fileTable[fileID].bufferPos >= fileTable[fileID].size )
	{
	  nread = 0;
	}
      else
	{
	  nread = fileTable[fileID].bufferSize;
	  if ( (nread + fileTable[fileID].bufferPos) > fileTable[fileID].size )
	    nread = fileTable[fileID].size - fileTable[fileID].bufferPos;

	  if ( fileTable[fileID].buffer )
	    {
	      ret = munmap(fileTable[fileID].buffer, fileTable[fileID].mappedSize);
	      if ( ret == -1 )
		SysError(func, "munmap error for read %s", fileTable[fileID].name);
	      fileTable[fileID].buffer = NULL;
	    }

	  fileTable[fileID].mappedSize = (size_t) nread;

	  fileTable[fileID].buffer =
            (char *) mmap(0, (size_t) nread, PROT_READ, MAP_SHARED, fd, fileTable[fileID].bufferPos);

	  if ( (int) fileTable[fileID].buffer == -1 )
	    SysError(func, "mmap error for read %s", fileTable[fileID].name);

	  offset = fileTable[fileID].position - fileTable[fileID].bufferPos;
	}
    }
  else
#endif
    {
      retseek = lseek(fileTable[fileID].fd, fileTable[fileID].bufferPos, SEEK_SET);
      if ( retseek == (off_t)-1 )
	SysError(func, "lseek error at pos %ld file %s", (long) fileTable[fileID].bufferPos, fileTable[fileID].name);
	
      nread = (long) read(fd, fileTable[fileID].buffer, fileTable[fileID].bufferSize);
    }

  if ( nread <= 0 )
    {
      if ( nread == 0 )
	fileTable[fileID].flag |= FILE_EOF;
      else
	fileTable[fileID].flag |= FILE_ERROR;

      fileTable[fileID].bufferCnt = 0;
      return (EOF);
    }

  fileTable[fileID].bufferPtr = fileTable[fileID].buffer;
  fileTable[fileID].bufferCnt = nread;

  fileTable[fileID].bufferStart = fileTable[fileID].bufferPos;
  fileTable[fileID].bufferPos  += nread;
  fileTable[fileID].bufferEnd   = fileTable[fileID].bufferPos - 1;

  if ( FILE_Debug )
    {
      Message(func, "fileID = %d  Val     = %d",  fileID, (int) fileTable[fileID].buffer[0]);
      Message(func, "fileID = %d  Start   = %ld", fileID, fileTable[fileID].bufferStart);
      Message(func, "fileID = %d  End     = %ld", fileID, fileTable[fileID].bufferEnd);
      Message(func, "fileID = %d  nread   = %ld", fileID, nread);
      Message(func, "fileID = %d  offset  = %ld", fileID, offset);
      Message(func, "fileID = %d  Pos     = %ld", fileID, fileTable[fileID].bufferPos);
      Message(func, "fileID = %d  postion = %ld", fileID, fileTable[fileID].position);
    }

  if ( offset > 0 )
    {
      if ( offset > nread )
	Error(func, "Internal problem with buffer handling. nread = %d offset = %d", nread, offset);

      fileTable[fileID].bufferPtr += offset;
      fileTable[fileID].bufferCnt -= offset;
    }

  fileTable[fileID].bufferNumFill++;

  return ((unsigned char) *fileTable[fileID].bufferPtr);
}

static void fileCopyFromBuffer(int fileID, void *ptr, size_t size)
{
  static char func[] = "fileCopyFromBuffer";

  if ( FILE_Debug )
    Message(func, "size = %ld  Cnt = %ld", size, fileTable[fileID].bufferCnt);

  if ( fileTable[fileID].bufferCnt < size )
    Error(func, "Buffer to small. bufferCnt = %d", fileTable[fileID].bufferCnt);

  if ( size == 1 )
    {
      ((char *)ptr)[0] = fileTable[fileID].bufferPtr[0];

      fileTable[fileID].bufferPtr++;
      fileTable[fileID].bufferCnt--;
    }
  else
    {
      memcpy(ptr, fileTable[fileID].bufferPtr, size);

      fileTable[fileID].bufferPtr += size;
      fileTable[fileID].bufferCnt -= size;
    }
}

static size_t
fileReadFromBuffer(int fileID, void *ptr, size_t size)
{
  static char func[] = "fileReadFromBuffer";
  size_t nread, rsize;
  size_t offset = 0;

  if ( FILE_Debug )
    Message(func, "size = %ld  Cnt = %d", size, (int) fileTable[fileID].bufferCnt);

  if ( ((int)fileTable[fileID].bufferCnt) < 0 )
    Error(func, "Internal problem. bufferCnt = %d", (int) fileTable[fileID].bufferCnt);

  rsize = size;

  while ( fileTable[fileID].bufferCnt < rsize )
    {
      nread = fileTable[fileID].bufferCnt;
      /*
      fprintf(stderr, "rsize = %d nread = %d\n", (int) rsize, (int) nread);
      */
      if ( nread > (size_t) 0 )
	fileCopyFromBuffer(fileID, (char *)ptr+offset, nread);
      offset += nread;
      if ( nread < rsize )
	rsize -= nread;
      else
	rsize = 0;

      if ( fileFillBuffer(fileID) == -1 ) break;
    }

  nread = size - offset;

  if ( fileTable[fileID].bufferCnt < nread ) nread = fileTable[fileID].bufferCnt;

  if ( nread > (unsigned) 0 )
    fileCopyFromBuffer(fileID, (char *)ptr+offset, nread);

  return (nread+offset);
}

void fileSetBufferSize(int fileID, long buffersize)
{
  fileTable[fileID].bufferSize = buffersize;
}

/* 
 *   Open a file. Returns file ID, or -1 on error
 */
int fileOpen(const char *filename, const char *mode)
{
  static char func[] = "fileOpen";
  FILE *fp = NULL;    /* file pointer    (used for write) */
  int fd = -1;        /* file descriptor (used for read)  */
  int fileID = FILE_UNDEFID;
  int fmode = 0;

  if ( ! FileInit ) fileInitialize();

  fmode = tolower((int) mode[0]);

  switch ( fmode )
    {
    case 'r':  fd =  open(filename, O_RDONLY); break;
    case 'w':  fp = fopen(filename, "w");      break;
    case 'a':  fp = fopen(filename, "a");      break;
    default:   Error(func, "Mode %c unexpected\n", fmode);
    }

  if ( FILE_Debug )
    if ( fp == NULL && fd == -1 )
      Message(func, "Open failed on %s mode %c", filename, fmode);

  if ( fp )
    {
      struct stat filestat;

      fileID = fileTableNewEntry();

      fileTable[fileID].fp   = fp;
      fileTable[fileID].mode = fmode;
      fileTable[fileID].name = strdup(filename);

      if ( stat(fileTable[fileID].name, &filestat) != 0 )
	SysError(func, fileTable[fileID].name);

      fileTable[fileID].blockSize = filestat.st_blksize;

      if ( fmode == 'r' )
	fileTable[fileID].size = filestat.st_size;

      if ( FILE_Debug )
	Message(func, "File %s opened with ID %d", filename, fileID);
    }
  else if ( fd >= 0 )
    {
      struct stat filestat;

      fileID = fileTableNewEntry();

      fileTable[fileID].fd   = fd;
      fileTable[fileID].mode = fmode;
      fileTable[fileID].name = strdup(filename);
 
      if ( fstat(fd, &filestat) != 0 ) SysError(func, filename);

      fileTable[fileID].blockSize = filestat.st_blksize;

      if ( fmode == 'r' ) fileTable[fileID].size = filestat.st_size;

      if ( FILE_Debug )
	Message(func, "File %s opened with ID %d", filename, fileID);      
    }

  return (fileID);
}

/* 
 *   Close a file.
 */
void fileClose(int fileID)
{
  static char func[] = "fileClose";
  char *name;
  int ret;
  char *ftname[] = {"unknown", "standard", "mmap"};

  fileCheckID(func, fileID);

  name = fileTable[fileID].name;

  if ( FILE_Debug )
    Message(func, "fileID = %d  filename = %s", fileID, name);

  if ( FileInfo > 0 )
    {
      fprintf(stderr, "____________________________________________\n");
      fprintf(stderr, " file ID          : %d\n",  fileID);
      fprintf(stderr, " file name        : %s\n",  fileTable[fileID].name);
      if ( fileTable[fileID].mode == 'r' )
	fprintf(stderr, " file descriptor  : %d\n",  fileTable[fileID].fd);
      else
	fprintf(stderr, " file pointer     : %p\n",  (void *) fileTable[fileID].fp);

      fprintf(stderr, " file mode        : %c\n",  fileTable[fileID].mode);

      if ( sizeof(off_t) > sizeof(long) )
	{
	  fprintf(stderr, " file size        : %lld\n", (long long) fileTable[fileID].size);
	  fprintf(stderr, " file position    : %lld\n", (long long) fileTable[fileID].position);
	  fprintf(stderr, " bytes transfered : %lld\n", (long long) fileTable[fileID].byteTrans);
	}
      else
	{
	  fprintf(stderr, " file size        : %ld\n", (long) fileTable[fileID].size);
	  fprintf(stderr, " file position    : %ld\n", (long) fileTable[fileID].position);
	  fprintf(stderr, " bytes transfered : %ld\n", (long) fileTable[fileID].byteTrans);
	}

      fprintf(stderr, " file access      : %ld\n", fileTable[fileID].access);
      fprintf(stderr, " buffer type      : %d (%s)\n",  fileTable[fileID].bufferType, ftname[fileTable[fileID].bufferType]);
      fprintf(stderr, " num buffer fill  : %ld\n", fileTable[fileID].bufferNumFill);
      fprintf(stderr, " buffer size      : %lu\n", (unsigned long) fileTable[fileID].bufferSize);
      fprintf(stderr, " block size       : %lu\n", (unsigned long) fileTable[fileID].blockSize);
#if defined (HAVE_MMAP)
      fprintf(stderr, " page size        : %d\n",  pagesize());
#endif
      fprintf(stderr, "--------------------------------------------\n");
    }

  if ( fileTable[fileID].mode == 'r' )
    {
#if defined (HAVE_MMAP)
      if ( fileTable[fileID].buffer && fileTable[fileID].mappedSize )
	{
	  ret = munmap(fileTable[fileID].buffer, fileTable[fileID].mappedSize);
	  if ( ret == -1 )
	    SysError(func, "munmap error for close %s", fileTable[fileID].name);
	  fileTable[fileID].buffer = NULL;
	}
#endif
      ret = close(fileTable[fileID].fd);
      if ( ret == -1 )
	SysError(func, "EOF returned for close of %s\n", name);
    }
  else
    {
      ret = fclose(fileTable[fileID].fp);
      if ( ret == EOF )
	SysError(func, "EOF returned for close of %s\n", name);
    }

  if ( fileTable[fileID].name )    free((void*) fileTable[fileID].name);
  if ( fileTable[fileID].buffer )  free((void*) fileTable[fileID].buffer);

  fileTableInitEntry(fileID);
}

int fileGetc(int fileID)
{
  int ivalue = -1;
  int fillret = 0;

  if ( fileTable[fileID].bufferCnt == 0 ) fillret = fileFillBuffer(fileID);

  if ( fillret >= 0 )
    {
      ivalue = (unsigned char) *fileTable[fileID].bufferPtr++;
      fileTable[fileID].bufferCnt--;

      fileTable[fileID].position++;
      fileTable[fileID].byteTrans++;
      fileTable[fileID].access++;
    }

  return (ivalue);
}

size_t fileRead(int fileID, void *ptr, size_t size)
{
  static char func[] = "fileRead";
  size_t nread;
  
#if defined (FILE_CHECKID)
  fileCheckID(func, fileID);
#endif

  nread = fileReadFromBuffer(fileID, ptr, size);

  fileTable[fileID].position  += nread;
  fileTable[fileID].byteTrans += nread;
  fileTable[fileID].access++;

  if ( FILE_Debug ) Message(func, "size %ld  nread %ld", size, nread);

  return (nread);
}

size_t fileWrite(int fileID, const void *ptr, size_t size)
{
#if defined (FILE_CHECKID)
  static char func[] = "fileWrite";
#endif
  size_t nwrite;
  FILE *fp;

#if defined (FILE_CHECKID)
  fileCheckID(func, fileID);
#endif

  if ( fileTable[fileID].buffer == NULL ) fileSetBuffer(fileID);

  fp = fileTable[fileID].fp;

  nwrite = fwrite(ptr, 1, size, fp);

  fileTable[fileID].position  += nwrite;
  fileTable[fileID].byteTrans += nwrite;
  fileTable[fileID].access++;

  return (nwrite);
}

/* Generated automatically from m214003 on Fr Apr  1 19:51:54 CEST 2005 */

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



#ifndef _GRIB_INT_H
#define _GRIB_INT_H



#if ! defined   (_GRIB_H)
#  include "grib.h"
#endif
#if ! defined   (_ERROR_H)
#  include "error.h"
#endif
#if ! defined   (_DTYPES_H)
#  include "dtypes.h"
#endif

#if ! defined   (FALSE)
#  define  FALSE  0
#endif

#if ! defined   (TRUE)
#  define  TRUE  1
#endif

#if ! defined   (UCHAR)
#  define  UCHAR  unsigned char
#endif

#if  defined  (INT32)
#  define  GRIBPACK     INT32
#  define  PACK_GRIB    packInt32
#  define  UNPACK_GRIB  unpackInt32
#else
#  define  GRIBPACK     INT64
#  define  PACK_GRIB    packInt64
#  define  UNPACK_GRIB  unpackInt64
#endif


#define POW_2_M24  0.000000059604644775390625  /*  pow(2.0, -24.0) */


extern FILE *grprsm;

extern int  GRB_Debug;

void   gprintf(const char *caller, const char *fmt, ...);

void   grsdef(void);

void   prtbin(int kin, int knbit, int *kout, int *kerr);
void   confp3(double pval, int *kexp, int *kmant, int kbits, int kround);
double decfp2(int kexp, int kmant);
void   ref2ibm(double *pref, int kbits);

void   scaleComplex(double *fpdata, int pcStart, int pcScale, int truncation);
void   scatterComplex(double *fpdata, int pcStart, int truncation, int dimSP);
void   scm0(double *pdl, double *pdr, double *pfl, double *pfr, int klg);
int    rowina2(double *p, int ko, int ki, double *pw,
	       int kcode, double msval, int *kret);
int    qu2reg2(double *pfield, int *kpoint, int klat, int klon,
	       double *ztemp, double msval, int *kret);

#if  defined  (INT32)
long   packInt32(INT32 *up, char *cp, long bc, long tc);
#endif
long   packInt64(INT64 *up, char *cp, long bc, long tc);
#if  defined  (INT32)
long   unpackInt32(unsigned char *cp, INT32 *up, long bc, long tc);
#endif
long   unpackInt64(unsigned char *cp, INT64 *up, long bc, long tc);

void  gribEncode(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
		 double *fsec3, int *isec4, double *fsec4, int klenp, int *kgrib,
		 int kleng, int *kword, int efunc, int *kret);

void  gribDecode(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
		 double *fsec3, int *isec4, double *fsec4, int klenp, int *kgrib,
		 int kleng, int *kword, int dfunc, int *kret);

#endif  /* _GRIB_INT_H */
#ifndef _GRIBDECODE_H
#define _GRIBDECODE_H

#define  UNDEFINED          9.999e20


#define  GET_INT3(a,b,c)    ((1-(int) ((unsigned) (a & 128) >> 6)) * (int) (((a & 127) << 16)+(b<<8)+c))
#define  GET_INT2(a,b)      ((1-(int) ((unsigned) (a & 128) >> 6)) * (int) (((a & 127) << 8) + b))

/* this requires a 32-bit default integer machine */
#define  GET_UINT4(a,b,c,d) ((int) ((a << 24) + (b << 16) + (c << 8) + (d)))
#define  GET_UINT3(a,b,c)   ((int) ((a << 16) + (b << 8)  + (c)))
#define  GET_UINT2(a,b)     ((int) ((a << 8)  + (b)))
#define  GET_UINT1(a)       ((int)  (a))


/* Section 0: Indicator Section (IS) */

#define  IS_GRIB_Len         GET_INT3(is[ 4], is[ 5], is[ 6])
#define  IS_GRIB_Version     GET_UINT1(is[ 7])

/* Section 1: Product Definition Section (PDS) */

#define  PDS_Len             GET_UINT3(pds[ 0], pds[ 1], pds[ 2])
#define  PDS_CodeTable       GET_UINT1(pds[ 3])
#define  PDS_CenterID        GET_UINT1(pds[ 4])
#define  PDS_ModelID         GET_UINT1(pds[ 5])
#define  PDS_GridDefinition  GET_UINT1(pds[ 6])
#define  PDS_Sec2Or3Flag     GET_UINT1(pds[ 7])
#define  PDS_HAS_GDS         ((pds[7] & 128) != 0)
#define  PDS_HAS_BMS         ((pds[7] &  64) != 0)
#define  PDS_Parameter       GET_UINT1(pds[ 8])
#define  PDS_LevelType       GET_UINT1(pds[ 9])
#define  PDS_Level1          (pds[10])
#define  PDS_Level2	     (pds[11])
#define  PDS_Level	     GET_UINT2(pds[10], pds[11])
#define  PDS_Year            GET_UINT1(pds[12])
#define  PDS_Month           GET_UINT1(pds[13])
#define  PDS_Day             GET_UINT1(pds[14])
#define  PDS_Hour            GET_UINT1(pds[15])
#define  PDS_Minute          GET_UINT1(pds[16])
#define  PDS_Date            (PDS_Year*10000+PDS_Month*100+PDS_Day)
#define  PDS_Time            (PDS_Hour*100+PDS_Minute)
#define  PDS_TimeUnit        GET_UINT1(pds[17])
#define  PDS_TimePeriod1     GET_UINT1(pds[18])
#define  PDS_TimePeriod2     GET_UINT1(pds[19])
#define  PDS_TimeRange       GET_UINT1(pds[20])
#define  PDS_AvgNum          GET_UINT2(pds[21], pds[22])
#define  PDS_AvgMiss         GET_UINT1(pds[23])
#define  PDS_Century         GET_UINT1(pds[24])
#define  PDS_Subcenter       GET_UINT1(pds[25])
#define  PDS_DecimalScale    GET_INT2(pds[26],pds[27])


/* Section 2: Grid Description Section (GDS) */

#define  GDS_Len             ((gds) == NULL ? 0 : GET_UINT3(gds[ 0], gds[ 1], gds[ 2]))
#define  GDS_NV              GET_UINT1(gds[ 3])
#define  GDS_PVPL            GET_UINT1(gds[ 4])
#define  GDS_PV	             ((gds[3] == 0) ? -1 : (int) gds[4] - 1)
#define  GDS_PL	             ((gds[4] == 255) ? -1 : (int) gds[3] * 4 + (int) gds[4] - 1)
#define  GDS_GridType        GET_UINT1(gds[ 5])


/* Triangular grid of DWD */
#define  GDS_TRI_NI2         GET_UINT2(gds[ 6], gds[ 7])
#define  GDS_TRI_NI3         GET_UINT2(gds[ 8], gds[ 9])
#define  GDS_TRI_ND          GET_UINT3(gds[10], gds[11], gds[12])
#define  GDS_TRI_NI          GET_UINT3(gds[13], gds[14], gds[15])
#define  GDS_TRI_AFlag       GET_UINT1(gds[16])
#define  GDS_TRI_LatPP       GET_INT3(gds[17], gds[18], gds[19])
#define  GDS_TRI_LonPP       GET_INT3(gds[20], gds[21], gds[22])
#define  GDS_TRI_LonMPL      GET_INT3(gds[23], gds[24], gds[25])
#define  GDS_TRI_BFlag       GET_UINT1(gds[27])

/* Spectral */
#define  GDS_PentaJ          GET_UINT2(gds[ 6], gds[ 7])
#define  GDS_PentaK          GET_UINT2(gds[ 8], gds[ 9])
#define  GDS_PentaM          GET_UINT2(gds[10], gds[11])
#define  GDS_RepType         GET_UINT1(gds[12])
#define  GDS_RepMode         GET_UINT1(gds[13])

/* Regular grid */
#define  GDS_NumLon          GET_UINT2(gds[ 6], gds[ 7])
#define  GDS_NumLat          GET_UINT2(gds[ 8], gds[ 9])
#define  GDS_FirstLat        GET_INT3(gds[10], gds[11], gds[12])
#define  GDS_FirstLon        GET_INT3(gds[13], gds[14], gds[15])
#define  GDS_ResFlag         GET_UINT1(gds[16])
#define  GDS_LastLat         GET_INT3(gds[17], gds[18], gds[19])
#define  GDS_LastLon         GET_INT3(gds[20], gds[21], gds[22])
#define  GDS_LonIncr         GET_INT2(gds[23], gds[24])
#define  GDS_LatIncr         GET_INT2(gds[25], gds[26])
#define  GDS_NumPar          GET_INT2(gds[25], gds[26])
#define  GDS_ScanFlag        GET_UINT1(gds[27])
#define  GDS_LatSP           GET_INT3(gds[32], gds[33], gds[34])
#define  GDS_LonSP           GET_INT3(gds[35], gds[36], gds[37])
#define  GDS_RotAngle        GET_Real(&(gds[38]))

/* Section 3: Bit Map Section (BMS) */

#define  BMS_Len	     ((bms) == NULL ? 0 : (int) (bms[0]<<16)+(bms[1]<<8)+bms[2])
#define  BMS_UnusedBits      (bms[3])
#define  BMS_Numeric         
#define  BMS_Bitmap	     ((bms) == NULL ? NULL : (bms)+6)
#define  BMS_BitmapSize      (((((bms[0]<<16)+(bms[1]<<8)+bms[2]) - 6)<<3) - bms[3])

/* Section 4: Binary Data Section (BDS) */

#define  BDS_Len	    ((int) ((bds[0]<<16)+(bds[1]<<8)+bds[2]))
#define  BDS_Flag	    (bds[3])
#define  BDS_BinScale       GET_INT2(bds[ 4], bds[ 5])
#define  BDS_RefValue       decfp2((int)bds[ 6], GET_UINT3(bds[ 7], bds[ 8], bds[ 9]))
#define  BDS_NumBits        ((int) bds[10])
#define  BDS_RealCoef       decfp2((int)bds[11], GET_UINT3(bds[12], bds[13], bds[14]))
#define  BDS_Power          GET_INT2(bds[13], bds[14])

/* Section 5: End Section (ES) */

#endif  /* _GRIBDECODE_H */
#ifndef _GRIBENCODE_H
#define _GRIBENCODE_H


#define PutnZero(n) \
{ \
  int i; \
  for ( i = z; i < z+n; i++ ) lGrib[i] = 0; \
  z += n; \
}

#define Put1Byte(Value)  (lGrib[z++] = (Value))
#define Put2Byte(Value) ((lGrib[z++] = (Value) >>  8), \
                         (lGrib[z++] = (Value)))
#define Put3Byte(Value) ((lGrib[z++] = (Value) >> 16), \
                         (lGrib[z++] = (Value) >>  8), \
                         (lGrib[z++] = (Value)))

#define Put3Int(Value)  {ival = Value; if ( ival < 0 ) ival = 8388608 - ival; Put3Byte(ival);}

#define Put1Real(Value)          \
{                                \
  confp3(Value, &exponent, &mantissa, BitsPerInt, 1); \
  Put1Byte(exponent);            \
  Put3Byte(mantissa);            \
}

#endif  /* _GRIBENCODE_H */


double _pow2tab[158] = {
 /* pow(2.0,  0.0) */  1.0,
 /* pow(2.0,  1.0) */  2.0,
 /* pow(2.0,  2.0) */  4.0,
 /* pow(2.0,  3.0) */  8.0,
 /* pow(2.0,  4.0) */  16.0,
 /* pow(2.0,  5.0) */  32.0,
 /* pow(2.0,  6.0) */  64.0,
 /* pow(2.0,  7.0) */  128.0,
 /* pow(2.0,  8.0) */  256.0,
 /* pow(2.0,  9.0) */  512.0,
 /* pow(2.0, 10.0) */  1024.0,
 /* pow(2.0, 11.0) */  2048.0,
 /* pow(2.0, 12.0) */  4096.0,
 /* pow(2.0, 13.0) */  8192.0,
 /* pow(2.0, 14.0) */  16384.0,
 /* pow(2.0, 15.0) */  32768.0,
 /* pow(2.0, 16.0) */  65536.0,
 /* pow(2.0, 17.0) */  131072.0,
 /* pow(2.0, 18.0) */  262144.0,
 /* pow(2.0, 19.0) */  524288.0,
 /* pow(2.0, 20.0) */  1048576.0,
 /* pow(2.0, 21.0) */  2097152.0,
 /* pow(2.0, 22.0) */  4194304.0,
 /* pow(2.0, 23.0) */  8388608.0,
 /* pow(2.0, 24.0) */  16777216.0,
 /* pow(2.0, 25.0) */  33554432.0,
 /* pow(2.0, 26.0) */  67108864.0,
 /* pow(2.0, 27.0) */  134217728.0,
 /* pow(2.0, 28.0) */  268435456.0,
 /* pow(2.0, 29.0) */  536870912.0,
 /* pow(2.0, 30.0) */  1073741824.0,
 /* pow(2.0, 31.0) */  2147483648.0,
 /* pow(2.0, 32.0) */  4294967296.0,
 /* pow(2.0, 33.0) */  8589934592.0,
 /* pow(2.0, 34.0) */  17179869184.0,
 /* pow(2.0, 35.0) */  34359738368.0,
 /* pow(2.0, 36.0) */  68719476736.0,
 /* pow(2.0, 37.0) */  137438953472.0,
 /* pow(2.0, 38.0) */  274877906944.0,
 /* pow(2.0, 39.0) */  549755813888.0,
 /* pow(2.0, 40.0) */  1099511627776.0,
 /* pow(2.0, 41.0) */  2199023255552.0,
 /* pow(2.0, 42.0) */  4398046511104.0,
 /* pow(2.0, 43.0) */  8796093022208.0,
 /* pow(2.0, 44.0) */  17592186044416.0,
 /* pow(2.0, 45.0) */  35184372088832.0,
 /* pow(2.0, 46.0) */  70368744177664.0,
 /* pow(2.0, 47.0) */  140737488355328.0,
 /* pow(2.0, 48.0) */  281474976710656.0,
 /* pow(2.0, 49.0) */  562949953421312.0,
 /* pow(2.0, 50.0) */  1125899906842624.0,
 /* pow(2.0, 51.0) */  2251799813685248.0,
 /* pow(2.0, 52.0) */  4503599627370496.0,
 /* pow(2.0, 53.0) */  9007199254740992.0,
 /* pow(2.0, 54.0) */  18014398509481984.0,
 /* pow(2.0, 55.0) */  36028797018963968.0,
 /* pow(2.0, 56.0) */  72057594037927936.0,
 /* pow(2.0, 57.0) */  144115188075855872.0,
 /* pow(2.0, 58.0) */  288230376151711744.0,
 /* pow(2.0, 59.0) */  576460752303423488.0,
 /* pow(2.0, 60.0) */  1152921504606846976.0,
 /* pow(2.0, 61.0) */  2305843009213693952.0,
 /* pow(2.0, 62.0) */  4611686018427387904.0,
 /* pow(2.0, 63.0) */  9223372036854775808.0,
 /* pow(2.0, 64.0) */  18446744073709551616.0,
 /* pow(2.0, 65.0) */  36893488147419103232.0,
 /* pow(2.0, 66.0) */  73786976294838206464.0,
 /* pow(2.0, 67.0) */  147573952589676412928.0,
 /* pow(2.0, 68.0) */  295147905179352825856.0,
 /* pow(2.0, 69.0) */  590295810358705651712.0,
 /* pow(2.0, 70.0) */  1180591620717411303424.0,
 /* pow(2.0, 71.0) */  2361183241434822606848.0,
 /* pow(2.0, 72.0) */  4722366482869645213696.0,
 /* pow(2.0, 73.0) */  9444732965739290427392.0,
 /* pow(2.0, 74.0) */  18889465931478580854784.0,
 /* pow(2.0, 75.0) */  37778931862957161709568.0,
 /* pow(2.0, 76.0) */  75557863725914323419136.0,
 /* pow(2.0, 77.0) */  151115727451828646838272.0,
 /* pow(2.0, 78.0) */  302231454903657293676544.0,
 /* pow(2.0, 79.0) */  604462909807314587353088.0,
 /* pow(2.0, 80.0) */  1208925819614629174706176.0,
 /* pow(2.0, 81.0) */  2417851639229258349412352.0,
 /* pow(2.0, 82.0) */  4835703278458516698824704.0,
 /* pow(2.0, 83.0) */  9671406556917033397649408.0,
 /* pow(2.0, 84.0) */  19342813113834066795298816.0,
 /* pow(2.0, 85.0) */  38685626227668133590597632.0,
 /* pow(2.0, 86.0) */  77371252455336267181195264.0,
 /* pow(2.0, 87.0) */  154742504910672534362390528.0,
 /* pow(2.0, 88.0) */  309485009821345068724781056.0,
 /* pow(2.0, 89.0) */  618970019642690137449562112.0,
 /* pow(2.0, 90.0) */  1237940039285380274899124224.0,
 /* pow(2.0, 91.0) */  2475880078570760549798248448.0,
 /* pow(2.0, 92.0) */  4951760157141521099596496896.0,
 /* pow(2.0, 93.0) */  9903520314283042199192993792.0,
 /* pow(2.0, 94.0) */  19807040628566084398385987584.0,
 /* pow(2.0, 95.0) */  39614081257132168796771975168.0,
 /* pow(2.0, 96.0) */  79228162514264337593543950336.0,
 /* pow(2.0, 97.0) */  158456325028528675187087900672.0,
 /* pow(2.0, 98.0) */  316912650057057350374175801344.0,
 /* pow(2.0, 99.0) */  633825300114114700748351602688.0,
 /* pow(2.0, 100.0) */  1267650600228229401496703205376.0,
 /* pow(2.0, 101.0) */  2535301200456458802993406410752.0,
 /* pow(2.0, 102.0) */  5070602400912917605986812821504.0,
 /* pow(2.0, 103.0) */  10141204801825835211973625643008.0,
 /* pow(2.0, 104.0) */  20282409603651670423947251286016.0,
 /* pow(2.0, 105.0) */  40564819207303340847894502572032.0,
 /* pow(2.0, 106.0) */  81129638414606681695789005144064.0,
 /* pow(2.0, 107.0) */  162259276829213363391578010288128.0,
 /* pow(2.0, 108.0) */  324518553658426726783156020576256.0,
 /* pow(2.0, 109.0) */  649037107316853453566312041152512.0,
 /* pow(2.0, 110.0) */  1298074214633706907132624082305024.0,
 /* pow(2.0, 111.0) */  2596148429267413814265248164610048.0,
 /* pow(2.0, 112.0) */  5192296858534827628530496329220096.0,
 /* pow(2.0, 113.0) */  10384593717069655257060992658440192.0,
 /* pow(2.0, 114.0) */  20769187434139310514121985316880384.0,
 /* pow(2.0, 115.0) */  41538374868278621028243970633760768.0,
 /* pow(2.0, 116.0) */  83076749736557242056487941267521536.0,
 /* pow(2.0, 117.0) */  166153499473114484112975882535043072.0,
 /* pow(2.0, 118.0) */  332306998946228968225951765070086144.0,
 /* pow(2.0, 119.0) */  664613997892457936451903530140172288.0,
 /* pow(2.0, 120.0) */  1329227995784915872903807060280344576.0,
 /* pow(2.0, 121.0) */  2658455991569831745807614120560689152.0,
 /* pow(2.0, 122.0) */  5316911983139663491615228241121378304.0,
 /* pow(2.0, 123.0) */  10633823966279326983230456482242756608.0,
 /* pow(2.0, 124.0) */  21267647932558653966460912964485513216.0,
 /* pow(2.0, 125.0) */  42535295865117307932921825928971026432.0,
 /* pow(2.0, 126.0) */  85070591730234615865843651857942052864.0,
 /* pow(2.0, 127.0) */  170141183460469231731687303715884105728.0,
 /* pow(2.0, 128.0) */  340282366920938463463374607431768211456.0,
 /* pow(2.0, 129.0) */  680564733841876926926749214863536422912.0,
 /* pow(2.0, 130.0) */  1361129467683753853853498429727072845824.0,
 /* pow(2.0, 131.0) */  2722258935367507707706996859454145691648.0,
 /* pow(2.0, 132.0) */  5444517870735015415413993718908291383296.0,
 /* pow(2.0, 133.0) */  10889035741470030830827987437816582766592.0,
 /* pow(2.0, 134.0) */  21778071482940061661655974875633165533184.0,
 /* pow(2.0, 135.0) */  43556142965880123323311949751266331066368.0,
 /* pow(2.0, 136.0) */  87112285931760246646623899502532662132736.0,
 /* pow(2.0, 137.0) */  174224571863520493293247799005065324265472.0,
 /* pow(2.0, 138.0) */  348449143727040986586495598010130648530944.0,
 /* pow(2.0, 139.0) */  696898287454081973172991196020261297061888.0,
 /* pow(2.0, 140.0) */  1393796574908163946345982392040522594123776.0,
 /* pow(2.0, 141.0) */  2787593149816327892691964784081045188247552.0,
 /* pow(2.0, 142.0) */  5575186299632655785383929568162090376495104.0,
 /* pow(2.0, 143.0) */  11150372599265311570767859136324180752990208.0,
 /* pow(2.0, 144.0) */  22300745198530623141535718272648361505980416.0,
 /* pow(2.0, 145.0) */  44601490397061246283071436545296723011960832.0,
 /* pow(2.0, 146.0) */  89202980794122492566142873090593446023921664.0,
 /* pow(2.0, 147.0) */  178405961588244985132285746181186892047843328.0,
 /* pow(2.0, 148.0) */  356811923176489970264571492362373784095686656.0,
 /* pow(2.0, 149.0) */  713623846352979940529142984724747568191373312.0,
 /* pow(2.0, 150.0) */  1427247692705959881058285969449495136382746624.0,
 /* pow(2.0, 151.0) */  2854495385411919762116571938898990272765493248.0,
 /* pow(2.0, 152.0) */  5708990770823839524233143877797980545530986496.0,
 /* pow(2.0, 153.0) */  11417981541647679048466287755595961091061972992.0,
 /* pow(2.0, 154.0) */  22835963083295358096932575511191922182123945984.0,
 /* pow(2.0, 155.0) */  45671926166590716193865151022383844364247891968.0,
 /* pow(2.0, 156.0) */  91343852333181432387730302044767688728495783936.0,
 /* pow(2.0, 157.0) */  182687704666362864775460604089535377456991567872.0,
};


void gen_pow2tab(void)
{
  int jloop;

  for ( jloop = 0; jloop < 158; jloop++ )
    printf(" /* pow(2.0, %2d.0) */  %.1f,\n", jloop,  pow(2.0, (double) jloop));
}


double _pow16tab[71] = {
 /* pow(16.0,  0.0) */  1.0,
 /* pow(16.0,  1.0) */  16.0,
 /* pow(16.0,  2.0) */  256.0,
 /* pow(16.0,  3.0) */  4096.0,
 /* pow(16.0,  4.0) */  65536.0,
 /* pow(16.0,  5.0) */  1048576.0,
 /* pow(16.0,  6.0) */  16777216.0,
 /* pow(16.0,  7.0) */  268435456.0,
 /* pow(16.0,  8.0) */  4294967296.0,
 /* pow(16.0,  9.0) */  68719476736.0,
 /* pow(16.0, 10.0) */  1099511627776.0,
 /* pow(16.0, 11.0) */  17592186044416.0,
 /* pow(16.0, 12.0) */  281474976710656.0,
 /* pow(16.0, 13.0) */  4503599627370496.0,
 /* pow(16.0, 14.0) */  72057594037927936.0,
 /* pow(16.0, 15.0) */  1152921504606846976.0,
 /* pow(16.0, 16.0) */  18446744073709551616.0,
 /* pow(16.0, 17.0) */  295147905179352825856.0,
 /* pow(16.0, 18.0) */  4722366482869645213696.0,
 /* pow(16.0, 19.0) */  75557863725914323419136.0,
 /* pow(16.0, 20.0) */  1208925819614629174706176.0,
 /* pow(16.0, 21.0) */  19342813113834066795298816.0,
 /* pow(16.0, 22.0) */  309485009821345068724781056.0,
 /* pow(16.0, 23.0) */  4951760157141521099596496896.0,
 /* pow(16.0, 24.0) */  79228162514264337593543950336.0,
 /* pow(16.0, 25.0) */  1267650600228229401496703205376.0,
 /* pow(16.0, 26.0) */  20282409603651670423947251286016.0,
 /* pow(16.0, 27.0) */  324518553658426726783156020576256.0,
 /* pow(16.0, 28.0) */  5192296858534827628530496329220096.0,
 /* pow(16.0, 29.0) */  83076749736557242056487941267521536.0,
 /* pow(16.0, 30.0) */  1329227995784915872903807060280344576.0,
 /* pow(16.0, 31.0) */  21267647932558653966460912964485513216.0,
 /* pow(16.0, 32.0) */  340282366920938463463374607431768211456.0,
 /* pow(16.0, 33.0) */  5444517870735015415413993718908291383296.0,
 /* pow(16.0, 34.0) */  87112285931760246646623899502532662132736.0,
 /* pow(16.0, 35.0) */  1393796574908163946345982392040522594123776.0,
 /* pow(16.0, 36.0) */  22300745198530623141535718272648361505980416.0,
 /* pow(16.0, 37.0) */  356811923176489970264571492362373784095686656.0,
 /* pow(16.0, 38.0) */  5708990770823839524233143877797980545530986496.0,
 /* pow(16.0, 39.0) */  91343852333181432387730302044767688728495783936.0,
 /* pow(16.0, 40.0) */  1461501637330902918203684832716283019655932542976.0,
 /* pow(16.0, 41.0) */  23384026197294446691258957323460528314494920687616.0,
 /* pow(16.0, 42.0) */  374144419156711147060143317175368453031918731001856.0,
 /* pow(16.0, 43.0) */  5986310706507378352962293074805895248510699696029696.0,
 /* pow(16.0, 44.0) */  95780971304118053647396689196894323976171195136475136.0,
 /* pow(16.0, 45.0) */  1532495540865888858358347027150309183618739122183602176.0,
 /* pow(16.0, 46.0) */  24519928653854221733733552434404946937899825954937634816.0,
 /* pow(16.0, 47.0) */  392318858461667547739736838950479151006397215279002157056.0,
 /* pow(16.0, 48.0) */  6277101735386680763835789423207666416102355444464034512896.0,
 /* pow(16.0, 49.0) */  100433627766186892221372630771322662657637687111424552206336.0,
 /* pow(16.0, 50.0) */  1606938044258990275541962092341162602522202993782792835301376.0,
 /* pow(16.0, 51.0) */  25711008708143844408671393477458601640355247900524685364822016.0,
 /* pow(16.0, 52.0) */  411376139330301510538742295639337626245683966408394965837152256.0,
 /* pow(16.0, 53.0) */  6582018229284824168619876730229402019930943462534319453394436096.0,
 /* pow(16.0, 54.0) */  105312291668557186697918027683670432318895095400549111254310977536.0,
 /* pow(16.0, 55.0) */  1684996666696914987166688442938726917102321526408785780068975640576.0,
 /* pow(16.0, 56.0) */  26959946667150639794667015087019630673637144422540572481103610249216.0,
 /* pow(16.0, 57.0) */  431359146674410236714672241392314090778194310760649159697657763987456.0,
 /* pow(16.0, 58.0) */  6901746346790563787434755862277025452451108972170386555162524223799296.0,
 /* pow(16.0, 59.0) */  110427941548649020598956093796432407239217743554726184882600387580788736.0,
 /* pow(16.0, 60.0) */  1766847064778384329583297500742918515827483896875618958121606201292619776.0,
 /* pow(16.0, 61.0) */  28269553036454149273332760011886696253239742350009903329945699220681916416.0,
 /* pow(16.0, 62.0) */  452312848583266388373324160190187140051835877600158453279131187530910662656.0,
 /* pow(16.0, 63.0) */  7237005577332262213973186563042994240829374041602535252466099000494570602496.0,
 /* pow(16.0, 64.0) */  115792089237316195423570985008687907853269984665640564039457584007913129639936.0,
 /* pow(16.0, 65.0) */  1852673427797059126777135760139006525652319754650249024631321344126610074238976.0,
 /* pow(16.0, 66.0) */  29642774844752946028434172162224104410437116074403984394101141506025761187823616.0,
 /* pow(16.0, 67.0) */  474284397516047136454946754595585670566993857190463750305618264096412179005177856.0,
 /* pow(16.0, 68.0) */  7588550360256754183279148073529370729071901715047420004889892225542594864082845696.0,
 /* pow(16.0, 69.0) */  121416805764108066932466369176469931665150427440758720078238275608681517825325531136.0,
 /* pow(16.0, 70.0) */  1942668892225729070919461906823518906642406839052139521251812409738904285205208498176.0,
};


void gen_pow16tab(void)
{
  double pval;
  int iexp;

  for ( iexp = 0; iexp < 71; iexp++ )
    {
      pval = pow(16.0, (double)(iexp));
      printf(" /* pow(16.0, %2d.0) */  %.1f,\n", iexp, pval);
    }
}

#define  NINT(x)  ((x) < 0 ? (int)((x)-.5) : (int)((x)+.5))


void confp3(double pval, int *kexp, int *kmant, int kbits, int kround)
{
  /*

    Purpose:
    --------

    Convert floating point number from machine
    representation to GRIB representation.

    Input Parameters:
    -----------------

       pval    - Floating point number to be converted.
       kbits   - Number of bits in computer word.
       kround  - Conversion type.
                 0 , Closest number in GRIB format less than
                     original number.
                 1 , Closest number in GRIB format to the
                     original number (equal to, greater than or
                     less than original number).

    Output Parameters:
    ------------------

       kexp    - 8 Bit signed exponent.
       kmant   - 24 Bit mantissa.

    Method:
    -------

    Floating point number represented as 8 bit signed
    exponent and 24 bit mantissa in integer values.

    Externals.
    ----------

    decfp2    - Decode from IBM floating point format.

    Reference:
    ----------

    WMO Manual on Codes re GRIB representation.

    Comments:
    ---------

    Routine aborts if an invalid conversion type parameter
    is used or if a 24 bit mantissa is not produced.

    Author:
    -------
     
    John Hennessy   ECMWF   18.06.91

    Modifications:
    --------------

    Uwe Schulzweida   MPIfM   01/04/2001

    Convert to C from EMOS library version 130

    Uwe Schulzweida   MPIfM   02/08/2002

     - speed up by factor 1.6 on NEC SX6
        - replace 1.0 / pow(16.0, (double)(iexp - 70)) by rpow16m70tab[iexp]
  */

  static char func[] = "confp3";
  double zval, rpowref;
  double zref, zeps;
  int iexp, isign;
  int iround;
  extern int GRB_Debug;
  extern double _pow16tab[71];

  /* ----------------------------------------------------------------- */
  /*   Section 1 . Initialise                                          */
  /* ----------------------------------------------------------------- */

  /*  Check conversion type parameter. */

  iround = kround;
  if ( iround != 0 && iround != 1 )
    {
      Error(func, "Invalid conversion type = %d", iround);

      /*  If not aborting, arbitrarily set rounding to 'up'. */
     iround = 1;
    }

  /* ----------------------------------------------------------------- */
  /*   Section 2 . Convert value of zero.                              */
  /* ----------------------------------------------------------------- */

  if ( ! fabs(pval) )
    {
      *kexp  = 0;
      *kmant = 0;
      iexp   = 0;
      isign  = 0;
      goto LABEL900;
    }

  /* ----------------------------------------------------------------- */
  /*   Section 3 . Convert other values.                               */
  /* ----------------------------------------------------------------- */

  zeps = 1.0e-12;
  if ( kbits == 32 ) zeps = 1.0e-8;
  zref = pval;

  /*  Sign of value. */

  isign = 0;
  if ( zref < 0.0 )
    {
      isign = 128;
      zref  = - zref;
    }

  /*  Exponent. */

  iexp = (int) (log(zref)/log(16.0) + 65.0 + zeps);

  /* only ANSI C99 has log2 */
  /* iexp = (int) (log2(zref) * 0.25 + 65.0 + zeps); */

  if ( iexp < 0   ) iexp = 0;
  if ( iexp > 127 ) iexp = 127;

  /*
  rpowref = zref / pow(16.0, (double)(iexp - 70));
  */

  if ( (iexp - 70) < 0 )
    rpowref = zref * _pow16tab[-(iexp - 70)];
  else
    rpowref = zref / _pow16tab[(iexp - 70)];

  /*  Mantissa. */

  if ( iround == 0 )
    {
      /*  Closest number in GRIB format less than original number. */
      /*  Truncate for positive numbers. */
      /*  Round up for negative numbers. */

      if ( isign == 0 )
	*kmant = (int) rpowref;
      else
	*kmant = NINT(rpowref + 0.5);
    }
  else
    {
      /*  Closest number in GRIB format to the original number   */
      /*  (equal to, greater than or less than original number). */

      *kmant = NINT(rpowref);
    }

  /*  Check that mantissa value does not exceed 24 bits. */
  /*  If it does, adjust the exponent upwards and recalculate */
  /*  the mantissa. */
  /*  16777215 = 2**24 - 1 */

  if ( *kmant > 16777215 )
    {

    LABEL350:

      ++iexp;

      /*  Check for exponent overflow during adjustment  */

      if ( iexp > 127 )
	{
          Message(func, "Exponent overflow");
          Message(func, "Original number = %30.20f", pval);
          Message(func, "Sign = %3d, Exponent = %3d, Mantissa = %12d",
		  isign, iexp, *kmant);

	  Error(func, "Exponent overflow");

	  /*  If not aborting, arbitrarily set value to zero  */

          Message(func, "Value arbitrarily set to zero.");
          *kexp  = 0;
          *kmant = 0;
          iexp  = 0;
          isign = 0;
          goto LABEL900;
	}

      if ( (iexp - 70) < 0 )
	rpowref = zref * _pow16tab[-(iexp - 70)];
      else
	rpowref = zref / _pow16tab[(iexp - 70)];

      if ( iround == 0 )
	{
	  /*  Closest number in GRIB format less than original number. */
	  /*  Truncate for positive numbers. */
	  /*  Round up for negative numbers. */

	  if ( isign == 0 )
	    *kmant = (int) rpowref;
	  else
	    *kmant = NINT(rpowref + 0.5);
	}
      else
	{
	  /*  Closest number in GRIB format to the original number */
	  /*  (equal to, greater or less than original number). */

	  *kmant = NINT(rpowref);
	}

      /*  Repeat calculation (with modified exponent) if still have */
      /*  mantissa overflow. */

      if ( *kmant > 16777215 ) goto LABEL350;
    }

  /*  Add sign bit to exponent. */

  *kexp = iexp + isign;

  /* ----------------------------------------------------------------- */
  /*   Section 9. Return                                               */
  /* ----------------------------------------------------------------- */

LABEL900:

  if ( GRB_Debug )
    {
      Message(func, "Conversion type parameter = %4d", kround);
      Message(func, "Original number = %30.20f", pval);

      zval = decfp2(*kexp, *kmant);

      Message(func, "Converted to      %30.20f", zval);
      Message(func, "Sign = %3d, Exponent = %3d, Mantissa = %12d",
	      isign, iexp, *kmant);
    }

  return;
} /* confp3 */


double decfp2(int kexp, int kmant)
{
  /*

    Purpose:
    --------

    Convert GRIB representation of a floating point
    number to machine representation.

    Input Parameters:
    -----------------

    kexp    - 8 Bit signed exponent.
    kmant   - 24 Bit mantissa.

    Output Parameters:
    ------------------

    Return value   - Floating point number represented
                     by kexp and kmant.

    Method:
    -------

    Floating point number represented as 8 bit exponent
    and 24 bit mantissa in integer values converted to
    machine floating point format.

    Externals:
    ----------

    None.

    Reference:
    ----------

    WMO Manual on Codes re GRIB representation.

    Comments:
    ---------

    Rewritten from DECFP, to conform to programming standards.
    Sign bit on 0 value now ignored, if present.
    If using 32 bit reals, check power of 16 is not so small as to
    cause overflows (underflows!); this causes warning to be given
    on Fujitsus.

    Author:
    -------

    John Hennessy   ECMWF   18.06.91

    Modifications:
    --------------

    Uwe Schulzweida   MPIfM   01/04/2001

     - Convert to C from EMOS library version 130
     
    Uwe Schulzweida   MPIfM   02/08/2002

     - speed up by factor 2 on NEC SX6
        - replace pow(2.0, -24.0) by constant POW_2_M24
        - replace pow(16.0, (double)(iexp - 64)) by pow16m64tab[iexp]
  */

  static char func[] = "decfp2";
  double pval;
  int iexp, isign;
  extern int GRB_Debug;
  extern double _pow16tab[71];
  
  /* ----------------------------------------------------------------- */
  /*   Section 1 . Convert value of 0.0. Ignore sign bit.              */
  /* ----------------------------------------------------------------- */

  if ( GRB_Debug ) Message(func, "KEXP = %d  KMANT = %d", kexp, kmant);
  /*
  if ( (kexp == 128 || kexp == 0) && kmant == 0 )
  */
  if ( (kexp == 128) || (kexp == 0) || (kexp == 255) )
    {
      pval = 0.0;
      goto LABEL900;
    }

  /* ----------------------------------------------------------------- */
  /*   Section 2 . Convert other values.                               */
  /* ----------------------------------------------------------------- */

  /*  Sign of value. */

  iexp  = kexp;
  isign = 1;

  if ( iexp >= 128 )
    {
      iexp -= 128;
      isign = -1;
    }

  /*  Decode value. */

  /* pval = isign * pow(2.0, -24.0) * kmant * pow(16.0, (double)(iexp - 64)); */

  iexp -= 64;

  if ( iexp < 0 )
    pval = 1./_pow16tab[-iexp];
  else
    pval = _pow16tab[iexp];

  pval *= isign * POW_2_M24 * kmant;

  /* ----------------------------------------------------------------- */
  /*   Section 9. Return to calling routine.                           */
  /* ----------------------------------------------------------------- */

LABEL900:

  if ( GRB_Debug ) Message(func, "Returned value = %f", pval);

  return (pval);
} /* decfp2 */




int gribRefDate(int *isec1)
{
  int date, ryear, rmonth, rday;

  ryear = ISEC1_Year;
  if ( ryear != 255 )
    ryear = ((ISEC1_Century-1)*100 + ISEC1_Year);
  else
    ryear = 1;

  rmonth  = ISEC1_Month;
  rday    = ISEC1_Day;

  date = ryear*10000 + rmonth*100 + rday;

  return (date) ;
}

int gribRefTime(int *isec1)
{
  int time, rhour, rminute;

  rhour   = ISEC1_Hour;
  rminute = ISEC1_Minute;

  time = rhour*100 + rminute;

  return (time) ;
}

int gribTimeIsFC(int *isec1)
{
  int isFC = FALSE;

  if ( ISEC1_TimePeriod1 > 0 )
    {
      if ( ISEC1_TimeRange == 0 || ISEC1_TimeRange == 10 ) isFC = TRUE;
    }

  return (isFC);
}

void gribDateTime(int *isec1, int *date, int *time)
{
  static char func[] = "gribDateTime";
  static int lprint = TRUE;
  int ryear, rmonth, rday, rhour, rminute;
  double second = 0.0;
  double rvalue;
  double add;
  sUnit unit = {0, 1};

  ryear = ISEC1_Year;

  if ( ISEC1_Century )
    {
      if ( ryear != 255 )
	ryear = ((ISEC1_Century-1)*100 + ISEC1_Year);
      else
	ryear = 1;
    }

  rmonth  = ISEC1_Month;
  rday    = ISEC1_Day;

  rhour   = ISEC1_Hour;
  rminute = ISEC1_Minute;

  /* printf("ref %d/%d/%d %d:%d\n", ryear, rmonth, rday, rhour, rminute); */
  
  if ( ISEC1_TimePeriod1 > 0 )
    {
      if ( ISEC1_TimeRange == 0 || ISEC1_TimeRange == 10 )
	{
	  InvCalendar(ryear, rmonth, rday, rhour, rminute, second, unit, &rvalue);

	  add = 0;
	  switch ( ISEC1_TimeUnit )
	    {
	    case ISEC1_TABLE4_MINUTE:  add =    60 * ISEC1_TimePeriod1; break;
	    case ISEC1_TABLE4_HOUR:    add =  3600 * ISEC1_TimePeriod1; break;
	    case ISEC1_TABLE4_DAY:     add = 86400 * ISEC1_TimePeriod1; break;
	    default:
	      if ( lprint )
		{
		  gprintf(func, "Time unit %d unsupported", ISEC1_TimeUnit);
		  lprint = FALSE;
		}
	    }
	  rvalue += add;

	  Calendar(rvalue, unit, &ryear, &rmonth, &rday, &rhour, &rminute, &second);
	}
    }
  /*
  printf("new %d/%d/%d %d:%d\n", ryear, rmonth, rday, rhour, rminute);
  */
  *date = ryear*10000 + rmonth*100 + rday;
  *time = rhour*100 + rminute;

  return;
}

void gprintf(const char *caller, const char *fmt, ...)
{
  va_list args;
	
  va_start(args, fmt);

   fprintf(grprsm, "%-18s : ", caller);
  vfprintf(grprsm, fmt, args);
   fprintf(grprsm, "\n");

  va_end(args);
}


void
gribExDP(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
	 double *fsec3, int *isec4, double *fsec4, int klenp, int *kgrib,
	 int kleng, int *kword, char *hoper, int *kret)
{
  static char func[] = "gribExDP";
  int yfunc = *hoper;

  if ( yfunc == 'D' || yfunc == 'J' || yfunc == 'R' )
    gribDecode(isec0, isec1, isec2, fsec2, isec3,
	       fsec3, isec4, fsec4, klenp, kgrib,
	       kleng, kword, yfunc, kret);
  else if ( *hoper == 'C' )
    gribEncode(isec0, isec1, isec2, fsec2, isec3,
	       fsec3, isec4, fsec4, klenp, kgrib,
	       kleng, kword, yfunc, kret);
  else
    {
      Error(func, "oper %c unsupported\n", yfunc);
      *kret=-9;
    }
}


void
gribExSP(int *isec0, int *isec1, int *isec2, float *fsec2sp, int *isec3,
	 float *fsec3sp, int *isec4, float *fsec4sp, int klenp, int *kgrib,
	 int kleng, int *kword, char *hoper, int *kret)
{
  static char func[] = "gribExSP";
  int inum, j;
  double fsec2dp[1024];
  double fsec3dp[2];
  double *fsec4dp = NULL;
  int yfunc = *hoper;

  if ( yfunc == 'C' )
    {
      inum = 10 + isec2[11];
      for ( j = 0; j < inum; j++ ) fsec2dp[j] = fsec2sp[j];

      fsec3dp[0] = fsec3sp[0];
      fsec3dp[1] = fsec3sp[1];

      inum = isec4[0];
      fsec4dp = (double *) malloc(inum*sizeof(double));
      if ( fsec4dp == NULL ) SysError(func, "No Memory!");

      for ( j = 0; j < inum; j++ ) fsec4dp[j] = fsec4sp[j];

      gribExDP(isec0, isec1, isec2, fsec2dp, isec3,
	       fsec3dp, isec4, fsec4dp, klenp, kgrib,
	       kleng, kword, hoper, kret);

      free(fsec4dp);
    }
  else if ( yfunc == 'D' || yfunc == 'J' || yfunc == 'R' )
    {
      fsec4dp = (double *) malloc(klenp*sizeof(double));
      if ( fsec4dp == NULL ) SysError(func, "No Memory!");

      for ( j = 0; j < 10; j++ ) fsec2dp[j] = 0.0;
      for ( j = 0; j <  2; j++ ) fsec3dp[j] = 0.0;

      gribExDP(isec0, isec1, isec2, fsec2dp, isec3,
	       fsec3dp, isec4, fsec4dp, klenp, kgrib,
	       kleng, kword, hoper, kret);

      inum = 10 + isec2[11];
      for ( j = 0; j < inum; j++ ) fsec2sp[j] = fsec2dp[j];

      fsec3sp[0] = fsec3dp[0];
      fsec3sp[1] = fsec3dp[1];

      inum = isec4[0];
      for ( j = 0; j < inum; j++ )
	{
	  if ( fsec4dp[j] > -FLT_MIN && fsec4dp[j] < FLT_MIN )
	    fsec4sp[j] = 0;
	  else if ( fsec4dp[j] > FLT_MAX )
	    fsec4sp[j] = FLT_MAX;
	  else if ( fsec4dp[j] < -FLT_MAX )
	    fsec4sp[j] = -FLT_MAX;
	  else
	    fsec4sp[j] = fsec4dp[j];
	}

      free(fsec4dp);
    }
  else
    {
      Error(func, "oper %c unsupported\n", yfunc);
      *kret=-9;
    }
}

int GRB_Debug    = 0;    /* If set to 1, debugging */

void gribSetDebug(int debug)
{
  static char func[] = "gribDebug";

  GRB_Debug = debug;

  if ( GRB_Debug )
    Message(func, "debug level %d", debug);
}

void gribSetRound(int round)
{
}

void gribSetRefDP(double refval)
{
}

void gribSetRefSP(float refval)
{
  gribSetRefDP((double) refval);
}

void gribSetValueCheck(int vcheck)
{
}



void gribPrintSec0(int *isec0)
{
  /*

    Print the information in the Indicator
    Section (Section 0) of decoded GRIB data.

    Input Parameters:

       isec0 - Array of decoded integers from Section 0


    Converted from EMOS routine GRPRS0.

       Uwe Schulzweida   MPIfM   01/04/2001

  */

  grsdef();

  fprintf(grprsm, " \n");
  fprintf(grprsm, " Section 0 - Indicator Section.       \n");
  fprintf(grprsm, " -------------------------------------\n");
  fprintf(grprsm, " Length of GRIB message (octets).     %9d\n", ISEC0_GRIB_Len);
  fprintf(grprsm, " GRIB Edition Number.                 %9d\n", ISEC0_GRIB_Version);
}

void gribPrintSec1(int *isec0, int *isec1)
{
  /*

    Print the information in the Product Definition
    Section (Section 1) of decoded GRIB data.

    Input Parameters:

       isec0 - Array of decoded integers from Section 0

       isec1 - Array of decoded integers from Section 1

    Comments:

       When decoding data from Experimental Edition or Edition 0,
       routine GRIBEX adds the additional fields available in
       Edition 1.


    Converted from EMOS routine GRPRS1.

       Uwe Schulzweida   MPIfM   01/04/2001

  */

  int iprev, icurr, icount, ioffset;
  int ibit, ierr, iout, iyear;
  int jloop, jiloop;
  float value;

  char hversion[9];
  /*
  char hfirst[121], hsecond[121], hthird[121], hfourth[121];
  */

  grsdef();

  /*
    -----------------------------------------------------------------
    Section 0 . Print required information.
    -----------------------------------------------------------------
  */

  fprintf(grprsm, " \n");
  fprintf(grprsm, " Section 1 - Product Definition Section.\n");
  fprintf(grprsm, " ---------------------------------------\n");

  fprintf(grprsm, " Code Table 2 Version Number.         %9d\n", isec1[0]);
  fprintf(grprsm, " Originating centre identifier.       %9d\n", isec1[1]);
  fprintf(grprsm, " Model identification.                %9d\n", isec1[2]);
  fprintf(grprsm, " Grid definition.                     %9d\n", isec1[3]);

  ibit = 8;
  prtbin(isec1[4], ibit, &iout, &ierr);
  fprintf(grprsm, " Flag (Code Table 1)                   %8.8d\n", iout);
  fprintf(grprsm, " Parameter identifier (Code Table 2). %9d\n", isec1[5]);

  /*
      IERR = CHKTAB2(ISEC1,HFIRST,HSECOND,HTHIRD,HFOURTH)
      IF( IERR .EQ. 0 ) THEN
       DO JLOOP = 121, 1, -1
          IF( HSECOND(JLOOP:JLOOP).NE.' ' ) THEN
            IOFFSET = JLOOP
            GOTO 110
          ENDIF
        ENDDO
        GOTO 120
 110    CONTINUE
        WRITE(*,'(2H ",A,1H")') HSECOND(1:IOFFSET)
 120    CONTINUE
      ENDIF
  */

  if ( isec1[5] != 127 )
    {
      fprintf(grprsm, " Type of level (Code Table 3).        %9d\n", isec1[6]);
      fprintf(grprsm, " Value 1 of level (Code Table 3).     %9d\n", isec1[7]);
      fprintf(grprsm, " Value 2 of level (Code Table 3).     %9d\n", isec1[8]);
    }
  else
    {
      fprintf(grprsm, " Satellite identifier.                %9d\n", isec1[6]);
      fprintf(grprsm, " Spectral band.                       %9d\n", isec1[7]);
    }

  iyear = isec1[9];
  if ( iyear != 255 )
    {
      iyear  = ((isec1[20]-1)*100 + isec1[9]);
      fprintf(grprsm, " Year of reference time of data.      %9d  (%4d)\n", isec1[9], iyear);
    }
  else
    {
      fprintf(grprsm, " Year of reference time of data MISSING  (=255)\n");
    }

  fprintf(grprsm, " Month of reference time of data.     %9d\n", isec1[10]);
  fprintf(grprsm, " Day of reference time of data.       %9d\n", isec1[11]);
  fprintf(grprsm, " Hour of reference time of data.      %9d\n", isec1[12]);
  fprintf(grprsm, " Minute of reference time of data.    %9d\n", isec1[13]);
  fprintf(grprsm, " Time unit (Code Table 4).            %9d\n", isec1[14]);
  fprintf(grprsm, " Time range one.                      %9d\n", isec1[15]);
  fprintf(grprsm, " Time range two.                      %9d\n", isec1[16]);
  fprintf(grprsm, " Time range indicator (Code Table 5)  %9d\n", isec1[17]);
  fprintf(grprsm, " Number averaged.                     %9d\n", isec1[18]);
  fprintf(grprsm, " Number missing from average.         %9d\n", isec1[19]);
  /*
     All ECMWF data in GRIB Editions before Edition 1 is decoded
     as 20th century data. Other centres are decoded as missing.
  */
  if ( isec0[1] < 1 && isec1[1] != 98 )
    fprintf(grprsm, " Century of reference time of data.   Not given\n");
  else
    fprintf(grprsm, " Century of reference time of data.   %9d\n", isec1[20]);

  /*   Print sub-centre  */
  fprintf(grprsm, " Sub-centre identifier.               %9d\n", isec1[21]);

  /*   Decimal scale factor  */
  fprintf(grprsm, " Units decimal scaling factor.        %9d\n", isec1[22]);

  /*
    -----------------------------------------------------------------
    Section 1 . Print local DWD information.
    -----------------------------------------------------------------
  */
  if ( (isec1[ 1] == 78 && isec1[36] == 253) ||
       (isec1[ 1] == 78 && isec1[36] == 254) )
    {
      fprintf(grprsm, " DWD local usage identifier.          %9d\n", isec1[36]);
      if ( isec1[36] == 253 )
	fprintf(grprsm, " (Database labelling and ensemble forecast)\n");
      if ( isec1[36] == 254 )
	fprintf(grprsm, " (Database labelling)\n");

      fprintf(grprsm, " Year of database entry                     %3d  (%4d)\n", isec1[43], 1900+isec1[43]);
      fprintf(grprsm, " Month of database entry                    %3d\n", isec1[44]);
      fprintf(grprsm, " Day of database entry                      %3d\n", isec1[45]);
      fprintf(grprsm, " Hour of database entry                     %3d\n", isec1[46]);
      fprintf(grprsm, " Minute of database entry                   %3d\n", isec1[47]);
      fprintf(grprsm, " DWD experiment number                %9d\n",isec1[48]);
      fprintf(grprsm, " DWD run type                         %9d\n",isec1[49]);
      if ( isec1[36] == 253 ) 
	{
	  fprintf(grprsm, " User id                              %9d\n",isec1[50]);
	  fprintf(grprsm, " Experiment identifier                %9d\n",isec1[51]);
	  fprintf(grprsm, " Ensemble identification type         %9d\n",isec1[52]);
	  fprintf(grprsm, " Number of ensemble members           %9d\n",isec1[53]);
	  fprintf(grprsm, " Actual number of ensemble member     %9d\n",isec1[54]);
	  fprintf(grprsm, " Model version                            %2d.%2.2d\n",isec1[55],isec1[56]);
	}
    }

  /*
    -----------------------------------------------------------------
    Section 2 . Print local ECMWF information.
    -----------------------------------------------------------------
  */
  /*
    Regular MARS labelling, or reformatted Washington EPS products.
  */
  if ( (isec1[ 1] == 98 && isec1[23] ==  1) ||
       (isec1[21] == 98 && isec1[23] ==  1) ||
       (isec1[ 1] ==  7 && isec1[21] == 98) )
    {
      /*   Parameters common to all definitions.  */

      fprintf(grprsm, " ECMWF local usage identifier.        %9d\n", isec1[36]);
      if ( isec1[36] == 1 )
	fprintf(grprsm, " (Mars labelling or ensemble forecast)\n");
      if ( isec1[36] == 2 )
        fprintf(grprsm, " (Cluster means and standard deviations)\n");
      if ( isec1[36] == 3 )
        fprintf(grprsm, " (Satellite image data)\n");
      if ( isec1[36] == 4 )
        fprintf(grprsm, " (Ocean model data)\n");
      if ( isec1[36] == 5 )
        fprintf(grprsm, " (Forecast probability data)\n");
      if ( isec1[36] == 6 )
        fprintf(grprsm, " (Surface temperature data)\n");
      if ( isec1[36] == 7 )
        fprintf(grprsm, " (Sensitivity data)\n");
      if ( isec1[36] == 8 )
        fprintf(grprsm, " (ECMWF re-analysis data)\n");
      if ( isec1[36] == 9 )
        fprintf(grprsm, " (Singular vectors and ensemble perturbations)\n");
      if ( isec1[36] == 10 )
        fprintf(grprsm, " (EPS tubes)\n");
      if ( isec1[36] == 11 )
        fprintf(grprsm, " (Supplementary data used by analysis)\n");
      if ( isec1[36] == 13 )
        fprintf(grprsm, " (Wave 2D spectra direction and frequency)\n");

      fprintf(grprsm, " Class.                               %9d\n", isec1[37]);
      fprintf(grprsm, " Type.                                %9d\n", isec1[38]);
      fprintf(grprsm, " Stream.                              %9d\n", isec1[39]);

      sprintf(hversion, "%8d", isec1[40]);
      fprintf(grprsm, " Version number or Experiment identifier.  %4s\n", &hversion[4]);
      /*
	ECMWF Local definition 1.
	(MARS labelling or ensemble forecast data)
      */
      if ( isec1[36] == 1 )
	{
	  fprintf(grprsm, " Forecast number.                     %9d\n", isec1[41]);
	  if ( isec1[39] != 1090 )
	    fprintf(grprsm, " Total number of forecasts.           %9d\n", isec1[42]);

	  return;
	}
      /*
	ECMWF Local definition 2.
	(Cluster means and standard deviations)
      */
      if ( isec1[36] == 2 )
	{
	  fprintf(grprsm, " Cluster number.                      %9d\n", isec1[41]);
	  fprintf(grprsm, " Total number of clusters.            %9d\n", isec1[42]);
	  fprintf(grprsm, " Clustering method.                   %9d\n", isec1[43]);
	  fprintf(grprsm, " Start time step when clustering.     %9d\n", isec1[44]);
	  fprintf(grprsm, " End time step when clustering.       %9d\n", isec1[45]);
	  fprintf(grprsm, " Northern latitude of domain.         %9d\n", isec1[46]);
	  fprintf(grprsm, " Western longitude of domain.         %9d\n", isec1[47]);
	  fprintf(grprsm, " Southern latitude of domain.         %9d\n", isec1[48]);
	  fprintf(grprsm, " Eastern longitude of domain.         %9d\n", isec1[49]);
	  fprintf(grprsm, " Operational forecast in cluster      %9d\n", isec1[50]);
	  fprintf(grprsm, " Control forecast in cluster          %9d\n", isec1[51]);
	  fprintf(grprsm, " Number of forecasts in cluster.      %9d\n", isec1[52]);

	  for (jloop = 0; jloop < isec1[52]; jloop++)
	    fprintf(grprsm, " Forecast number                      %9d\n", isec1[jloop+53]);

	  return;
	}
      /*
	ECMWF Local definition 3.
	(Satellite image data)
      */
      if ( isec1[36] == 3 )
	{
	  fprintf(grprsm, " Satellite spectral band.             %9d\n", isec1[41]);
	  fprintf(grprsm, " Function code.                       %9d\n", isec1[42]);
	  return;
	}
      /*
	ECMWF Local definition 4.
	(Ocean model data)
      */
      if ( isec1[36] == 4 )
	{
	  fprintf(grprsm, " Satellite spectral band.             %9d\n", isec1[41]);
	  if ( isec1[39] != 1090 )
	    fprintf(grprsm, " Function code.                       %9d\n", isec1[42]);
	  fprintf(grprsm, " Coordinate structure definition.\n");
	  fprintf(grprsm, " Fundamental spatial reference system.%9d\n", isec1[43]);
	  fprintf(grprsm, " Fundamental time reference.          %9d\n", isec1[44]);
	  fprintf(grprsm, " Space unit flag.                     %9d\n", isec1[45]);
	  fprintf(grprsm, " Vertical coordinate definition.      %9d\n", isec1[46]);
	  fprintf(grprsm, " Horizontal coordinate definition.    %9d\n", isec1[47]);
	  fprintf(grprsm, " Time unit flag.                      %9d\n", isec1[48]);
	  fprintf(grprsm, " Time coordinate definition.          %9d\n", isec1[49]);
	  fprintf(grprsm, " Position definition.     \n");
	  fprintf(grprsm, " Mixed coordinate field flag.         %9d\n", isec1[50]);
	  fprintf(grprsm, " Coordinate 1 flag.                   %9d\n", isec1[51]);
	  fprintf(grprsm, " Averaging flag.                      %9d\n", isec1[52]);
	  fprintf(grprsm, " Position of level 1.                 %9d\n", isec1[53]);
	  fprintf(grprsm, " Position of level 2.                 %9d\n", isec1[54]);
	  fprintf(grprsm, " Coordinate 2 flag.                   %9d\n", isec1[55]);
	  fprintf(grprsm, " Averaging flag.                      %9d\n", isec1[56]);
	  fprintf(grprsm, " Position of level 1.                 %9d\n", isec1[57]);
	  fprintf(grprsm, " Position of level 2.                 %9d\n", isec1[58]);
	  fprintf(grprsm, " Grid Definition.\n");
	  fprintf(grprsm, " Coordinate 3 flag (x-axis)           %9d\n", isec1[59]);
	  fprintf(grprsm, " Coordinate 4 flag (y-axis)           %9d\n", isec1[60]);
	  fprintf(grprsm, " Coordinate 4 of first grid point.    %9d\n", isec1[61]);
	  fprintf(grprsm, " Coordinate 3 of first grid point.    %9d\n", isec1[62]);
	  fprintf(grprsm, " Coordinate 4 of last grid point.     %9d\n", isec1[63]);
	  fprintf(grprsm, " Coordinate 3 of last grid point.     %9d\n", isec1[64]);
	  fprintf(grprsm, " i - increment.                       %9d\n", isec1[65]);
	  fprintf(grprsm, " j - increment.                       %9d\n", isec1[66]);
	  fprintf(grprsm, " Flag for irregular grid coordinates. %9d\n", isec1[67]);
	  fprintf(grprsm, " Flag for normal or staggered grids.  %9d\n", isec1[68]);
	  fprintf(grprsm, " Further information.\n");
	  fprintf(grprsm, " Further information flag.            %9d\n", isec1[69]);
	  fprintf(grprsm, " Auxiliary information.\n");
	  fprintf(grprsm, " No. entries in horizontal coordinate %9d\n", isec1[70]);
	  fprintf(grprsm, " No. entries in mixed coordinate defn.%9d\n", isec1[71]);
	  fprintf(grprsm, " No. entries in grid coordinate list. %9d\n", isec1[72]);
	  fprintf(grprsm, " No. entries in auxiliary array.      %9d\n", isec1[73]);
	  /*
	    Horizontal coordinate supplement.
	  */
	  fprintf(grprsm, " Horizontal coordinate supplement.\n");
	  if ( isec1[70] == 0 )
	    {
	      fprintf(grprsm, "(None).\n");
	    }
	  else
	    {
	      fprintf(grprsm, "Number of items = %d\n", isec1[70]);
	      for (jloop = 0; jloop < isec1[70]; jloop++)
		fprintf(grprsm, "         %12d\n", isec1[74+jloop]);
	    }
	  /*
	    Mixed coordinate definition.
	  */
	  fprintf(grprsm, " Mixed coordinate definition.\n");
	  if ( isec1[71] == 0 )
	    {
	      fprintf(grprsm, "(None).\n");
	    }
	  else
	    {
	      fprintf(grprsm, "Number of items = %d\n", isec1[71]);
	      ioffset = 74 + isec1[70];
	      for (jloop = 0; jloop < isec1[71]; jloop++)
		fprintf(grprsm, "         %12d\n", isec1[ioffset+jloop]);
	    }
	  /*
	    Grid coordinate list.
	  */
	  fprintf(grprsm, " Grid coordinate list. \n");
	  if ( isec1[72] == 0 )
	    {
	      fprintf(grprsm, "(None).\n");
	    }
	  else
	    {
	      fprintf(grprsm, "Number of items = %d\n", isec1[72]);
	      ioffset = 74 + isec1[70] + isec1[71];
	      for (jloop = 0; jloop < isec1[72]; jloop++)
		fprintf(grprsm, "         %12d\n", isec1[ioffset+jloop]);
	    }
	  /*
	    Auxiliary array.
	  */
	  fprintf(grprsm, " Auxiliary array.      \n");
	  if ( isec1[73] == 0 )
	    {
	      fprintf(grprsm, "(None).\n");
	    }
	  else
	    {
	      fprintf(grprsm, "Number of items = %d\n", isec1[73]);
	      ioffset = 74 + isec1[70] + isec1[71] + isec1[72];
	      for (jloop = 0; jloop < isec1[73]; jloop++)
		fprintf(grprsm, "         %12d\n", isec1[ioffset+jloop]);
	    }
	  /*
	    Post-auxiliary array.
	  */
	  fprintf(grprsm, " Post-auxiliary array. \n");
	  ioffset = 74 + isec1[70] + isec1[71] + isec1[72] + isec1[73];
	  if ( isec1[ioffset] == 0 )
	    {
	      fprintf(grprsm, "(None).\n");
	    }
	  else
	    {
	      fprintf(grprsm, "Number of items = %d\n", isec1[ioffset]);
	      for (jloop = 1; jloop < isec1[ioffset]; jloop++)
		fprintf(grprsm, "         %12d\n", isec1[ioffset+jloop]);
	    }

	  return;
	}
      /*
	ECMWF Local definition 5.
	(Forecast probability data)
      */
      if ( isec1[36] == 5 )
	{
	  fprintf(grprsm, " Forecast probability number          %9d\n", isec1[41]);
	  fprintf(grprsm, " Total number of forecast probabilities %7d\n", isec1[42]);
	  fprintf(grprsm, " Threshold units decimal scale factor %9d\n", isec1[43]);
	  fprintf(grprsm, " Threshold indicator(1=lower,2=upper,3=both) %2d\n", isec1[44]);
	  if ( isec1[44]  !=  2 )
	    fprintf(grprsm, " Lower threshold value                %9d\n", isec1[45]);
	  if ( isec1[44]  !=  1 )
	    fprintf(grprsm, " Upper threshold value                %9d\n", isec1[46]);
	  return;
	}
      /*
	ECMWF Local definition 6.
	(Surface temperature data)
      */
      if ( isec1[36] == 6 )
	{
	  iyear = isec1[43];
	  if ( iyear > 100 )
	    {
	      if ( iyear < 19000000 ) iyear = iyear + 19000000;
	      fprintf(grprsm, " Date of SST field used               %9d\n", iyear);
	    }
	  else
	    fprintf(grprsm, "Date of SST field used               Not given\n");
	}
      if ( isec1[44] == 0 )
	fprintf(grprsm, " Type of SST field (= climatology)    %9d\n", isec1[44]);
      if ( isec1[44] == 1 )
	fprintf(grprsm, " Type of SST field (= 1/1 degree)     %9d\n", isec1[44]);
      if ( isec1[44] == 2 )
	fprintf(grprsm, " Type of SST field (= 2/2 degree)     %9d\n", isec1[44]);

      fprintf(grprsm, " Number of ICE fields used:           %9d\n", isec1[45]);

      for (jloop = 1; jloop <= isec1[45]; jloop++)
	{
	  iyear = isec1[44+(jloop*2)];
	  if ( iyear > 100 )
	    {
              if ( iyear < 19000000 ) iyear = iyear + 19000000;
	      fprintf(grprsm, " Date of ICE field%3d                 %9d\n", jloop, iyear);
	      fprintf(grprsm, " Satellite number (ICE field%3d)      %9d\n", jloop,
		     isec1[45+(jloop*2)]);
	    }
	  else
	    fprintf(grprsm, "Date of SST field used               Not given\n");
	}
      /*
	ECMWF Local definition 7.
	(Sensitivity data)
      */
      if ( isec1[36] == 7 )
	{
	  if ( isec1[38]  ==  51 )
	    fprintf(grprsm, " Forecast number                      %9d\n", isec1[41]);
	  if ( isec1[38]  !=  51 )
	    fprintf(grprsm, " Iteration number                     %9d\n", isec1[41]);
	  if ( isec1[38]  !=  52 )
	    fprintf(grprsm, " Total number of diagnostics          %9d\n", isec1[42]);
	  if ( isec1[38]  ==  52 )
	    fprintf(grprsm, " No.interations in diag. minimisation %9d\n", isec1[42]);
	  fprintf(grprsm, " Domain(0=Global,1=Europe,2=N.Hem.,3=S.Hem.) %2d\n", isec1[43]);
	  fprintf(grprsm, " Diagnostic number                    %9d\n", isec1[44]);
	}
      /*
	ECMWF Local definition 8.
	(ECMWF re-analysis data)
      */
      if ( isec1[36] == 8 )
	{
	  if ( (isec1[39] == 1043) ||
	       (isec1[39] == 1070) ||
	       (isec1[39] == 1071) )
	    {
	      fprintf(grprsm, " Interval between reference times     %9d\n", isec1[41]);
	      for (jloop = 43; jloop <= 54; jloop++)
		{
		  jiloop = jloop + 8;
		  fprintf(grprsm, " ERA section 1 octet %2d.              %9d\n",
			 jiloop, isec1[jloop-1]);
		}
	    }
	  else
	    {
	      for (jloop = 42; jloop <= 54; jloop++)
		{
		  jiloop = jloop + 8;
		  fprintf(grprsm, " ERA section 1 octet %2d.              %9d\n",
			 jiloop, isec1[jloop-1]);
		}
	    }
	  return;
	}

      if ( isec1[38] > 4  && isec1[38] < 9 )
	{
	  fprintf(grprsm, " Simulation number.                   %9d\n", isec1[41]);
	  fprintf(grprsm, " Total number of simulations.         %9d\n", isec1[42]);
	}
      /*
	ECMWF Local definition 9.
	(Singular vectors and ensemble perturbations)
      */
      if ( isec1[36] == 9 )
	{
	  if ( isec1[38] == 60 )
	    fprintf(grprsm, " Perturbed ensemble forecast number   %9d\n", isec1[41]);
	  if ( isec1[38] == 61 )
	    fprintf(grprsm, " Initial state perturbation number    %9d\n", isec1[41]);
	  if ( isec1[38] == 62 )
	    fprintf(grprsm, " Singular vector number               %9d\n", isec1[41]);
	  if ( isec1[38] == 62 )
	    {
	      fprintf(grprsm, " Number of iterations                 %9d\n", isec1[42]);
	      fprintf(grprsm, " Number of singular vectors computed  %9d\n", isec1[43]);
	      fprintf(grprsm, " Norm used at initial time            %9d\n", isec1[44]);
	      fprintf(grprsm, " Norm used at final time              %9d\n", isec1[45]);
	      fprintf(grprsm, " Multiplication factor                %9d\n", isec1[46]);
    	      fprintf(grprsm, " Latitude of north-west corner        %9d\n", isec1[47]);
    	      fprintf(grprsm, " Longitude of north-west corner       %9d\n", isec1[48]);
	      fprintf(grprsm, " Latitude of south-east corner        %9d\n", isec1[49]);
	      fprintf(grprsm, " Longitude of south-east corner       %9d\n", isec1[50]);
	      fprintf(grprsm, " Accuracy                             %9d\n", isec1[51]);
	      fprintf(grprsm, " Number of singular vectors evolved   %9d\n", isec1[52]);
	      fprintf(grprsm, " Ritz number one                      %9d\n", isec1[53]);
	      fprintf(grprsm, " Ritz number two                      %9d\n", isec1[54]);
	    }
	}
      /*
	ECMWF Local definition 10.
	(EPS tubes)
      */
      if ( isec1[36] == 10 )
	{
	  fprintf(grprsm, " Tube number                          %9d\n", isec1[41]);
          fprintf(grprsm, " Total number of tubes                %9d\n", isec1[42]);
          fprintf(grprsm, " Central cluster definition           %9d\n", isec1[43]);
          fprintf(grprsm, " Parameter                            %9d\n", isec1[44]);
          fprintf(grprsm, " Type of level                        %9d\n", isec1[45]);
          fprintf(grprsm, " Northern latitude of domain of tubing%9d\n", isec1[46]);
          fprintf(grprsm, " Western longitude of domain of tubing%9d\n", isec1[47]);
          fprintf(grprsm, " Southern latitude of domain of tubing%9d\n", isec1[48]);
          fprintf(grprsm, " Eastern longitude of domain of tubing%9d\n", isec1[49]);
          fprintf(grprsm, " Tube number of operational forecast  %9d\n", isec1[50]);
          fprintf(grprsm, " Tube number of control forecast      %9d\n", isec1[51]);
          fprintf(grprsm, " Height/pressure of level             %9d\n", isec1[52]);
          fprintf(grprsm, " Reference step                       %9d\n", isec1[53]);
          fprintf(grprsm, " Radius of central cluster            %9d\n", isec1[54]);
          fprintf(grprsm, " Ensemble standard deviation          %9d\n", isec1[55]);
          fprintf(grprsm, " Dist.of tube extreme to ensemble mean%9d\n", isec1[56]);
          fprintf(grprsm, " Number of forecasts in the tube      %9d\n", isec1[57]);

          fprintf(grprsm, " List of ensemble forecast numbers:\n");
          for (jloop = 1; jloop <=  isec1[57]; jloop++)
	    fprintf(grprsm, "    %9d\n", isec1[57+jloop]);
	}
      /*
	ECMWF Local definition 11.
	(Supplementary data used by the analysis)
      */
      if ( isec1[36] == 11 )
	{
	  fprintf(grprsm, " Details of analysis which used the supplementary data:\n");
	  fprintf(grprsm, "   Class                              %9d\n", isec1[41]);
	  fprintf(grprsm, "   Type                               %9d\n", isec1[42]);
	  fprintf(grprsm, "   Stream                             %9d\n", isec1[43]);
	  sprintf(hversion, "%8d", isec1[44]);
	  fprintf(grprsm, "   Version number/experiment identifier:   %4s\n", &hversion[4]);
	  iyear = isec1[45];
	  if ( iyear > 50 )
	    iyear = iyear + 1900;
	  else
	    iyear = iyear + 2000;

	  fprintf(grprsm, "   Year                               %9d\n", iyear);
	  fprintf(grprsm, "   Month                              %9d\n", isec1[46]);
	  fprintf(grprsm, "   Day                                %9d\n", isec1[47]);
	  fprintf(grprsm, "   Hour                               %9d\n", isec1[48]);
	  fprintf(grprsm, "   Minute                             %9d\n", isec1[49]);
	  fprintf(grprsm, "   Century                            %9d\n", isec1[50]);
	  fprintf(grprsm, "   Originating centre                 %9d\n", isec1[51]);
	  fprintf(grprsm, "   Sub-centre                         %9d\n", isec1[52]);
	}
      /*
	ECMWF Local definition 12.
      */
      if ( isec1[36] == 12 )
	{
	  fprintf(grprsm, " (Mean, average, etc)\n");
          fprintf(grprsm, " Start date of the period              %8d\n", isec1[41]);
          fprintf(grprsm, " Start time of the period                  %4.4d\n", isec1[42]);
          fprintf(grprsm, " Finish date of the period             %8d\n", isec1[43]);
          fprintf(grprsm, " Finish time of the period                 %4.4d\n", isec1[44]);
          fprintf(grprsm, " Verifying date of the period          %8d\n", isec1[45]);
          fprintf(grprsm, " Verifying time of the period              %4.4d\n", isec1[46]);
          fprintf(grprsm, " Code showing method                   %8d\n", isec1[47]);
          fprintf(grprsm, " Number of different time intervals used  %5d\n", isec1[48]);
          fprintf(grprsm, " List of different time intervals used:\n");
          iprev  = isec1[49];
          icurr  = 0;
          icount = 0;
          for (jloop = 1; jloop <= isec1[48]; jloop++)
	    {
	      icurr = isec1[48+jloop];
	      if ( icurr != iprev )
		{
		  if ( icount == 1 )
		    fprintf(grprsm, "  - interval %5.4d used       once\n", iprev);
		  if ( icount == 2 )
		    fprintf(grprsm, "  - interval %5.4d used       twice\n", iprev);
		  if ( icount > 2 )
		    fprintf(grprsm, "  - interval %5.4d used %5d times\n",  iprev, icount);
		  iprev  = icurr;
		  icount = 1;
		}
	      else
		icount = icount + 1;
	    }
	  if ( icount == 1 )
	    fprintf(grprsm, "  - interval %5.4d used       once\n", iprev);
	  if ( icount == 2 )
	    fprintf(grprsm, "  - interval %5.4d used       twice\n", iprev);
	  if ( icount > 2 )
	    fprintf(grprsm, "  - interval %5.4d used %5d times\n",  iprev, icount);
	}
      /*
	ECMWF Local definition 13.
	(Wave 2D spectra direction and frequency)
      */
      if ( isec1[36] == 13 )
	{
          fprintf(grprsm, " Direction number                     %9d\n", isec1[43]);
	  fprintf(grprsm, " Frequency number                     %9d\n", isec1[44]);
	  fprintf(grprsm, " Total number of directions           %9d\n", isec1[45]);
	  fprintf(grprsm, " Total number of frequencies          %9d\n", isec1[46]);
	  fprintf(grprsm, " Scale factor applied to directions   %9d\n", isec1[47]);
	  fprintf(grprsm, " Scale factor applied to frequencies  %9d\n", isec1[48]);
	  fprintf(grprsm, " List of directions:\n");
          for (jloop = 1; jloop <= isec1[45]; jloop++)
            {
	      value = (float)(isec1[48+jloop])/(float)(isec1[47]);
	      if ( isec1[43] == jloop )
		fprintf(grprsm, " %2.2d:%15.7f   <-- this field value\n",  jloop, value);
	      else
		fprintf(grprsm, "%2.2d:%15.7f\n",  jloop, value);
            }
	  fprintf(grprsm, " List of frequencies:\n");
          for (jloop = 1; jloop <= isec1[46]; jloop++)
	    {
	      value = (float)(isec1[48+isec1[45]+jloop])/(float)(isec1[48]);
	      if ( isec1[44] == jloop )
		fprintf(grprsm, " %2.2d:%15.7f   <-- this field value\n",  jloop, value);
	      else
		fprintf(grprsm, "%2.2d:%15.7f\n",  jloop, value);

	      if ( isec1[49+isec1[45]+isec1[46]] != 0 )
		{
		  fprintf(grprsm, " System number (65535 = missing)      %9d\n",
			 isec1[49+isec1[45]+isec1[46]]);
		  fprintf(grprsm, " Method number (65535 = missing)      %9d\n",
			 isec1[50+isec1[45]+isec1[46]]);
		}
	    }
	  /*
	    ECMWF Local definition 14.
	    (Brightness temperature)
	  */
	  if ( isec1[36] == 14 )
	    {
	      fprintf(grprsm, " Channel number                       %9d\n", isec1[43]);
	      fprintf(grprsm, " Scale factor applied to frequencies  %9d\n", isec1[44]);
	      fprintf(grprsm, " Total number of frequencies          %9d\n", isec1[45]);
	      fprintf(grprsm, " List of frequencies:\n");
              for (jloop = 1; jloop <= isec1[45]; jloop++)
		{
		  value = (float)(isec1[45+jloop])/(float)(isec1[44]);
		  if ( isec1[43] == jloop )
		    fprintf(grprsm, " %3d:%15.9f   <-- this channel\n", jloop, value);
		  else
		    fprintf(grprsm, " %3d:%15.9f\n", jloop, value);
		}
	    }
	  /*
	    ECMWF Local definition 15.
	    (Ocean ensemble seasonal forecast)
	  */
	  if ( isec1[36] == 15 )
	    {
	      fprintf(grprsm, " Ensemble member number               %9d\n", isec1[41]);
	      fprintf(grprsm, " System number                        %9d\n", isec1[42]);
	      fprintf(grprsm, " Method number                        %9d\n", isec1[43]);
	    }
	  /*
	    ECMWF Local definition 16.
	    (Seasonal forecast monthly mean atmosphere data)
	  */
        if ( isec1[36] == 16 )
	  {
	    fprintf(grprsm, " Ensemble member number               %9d\n", isec1[41]);
	    fprintf(grprsm, " System number                        %9d\n", isec1[43]);
	    fprintf(grprsm, " Method number                        %9d\n", isec1[44]);
	    fprintf(grprsm, " Verifying month                      %9d\n", isec1[45]);
	    fprintf(grprsm, " Averaging period                     %9d\n", isec1[46]);
	  }
	/*
	  ECMWF Local definition 17.
	  (Sst or sea-ice used by analysis)
	*/
        if ( isec1[36] == 17 )
	  {
	    iyear = isec1[43];
	    if ( iyear > 100 )
	      {
		if ( iyear < 19000000 ) iyear = iyear + 19000000;
		fprintf(grprsm, " Date of sst/ice field used           %9d\n", iyear);
	      }
	    else
              fprintf(grprsm, " Date of sst/ice field used           Not given\n");
      
	    if ( isec1[44] == 0 )
	      fprintf(grprsm, " Type of sst/ice field (= climatology)%9d\n", isec1[44]);
	    if ( isec1[44] == 1 )
	      fprintf(grprsm, " Type of sst/ice field (= 1/1 degree) %9d\n", isec1[44]);
	    if ( isec1[44] == 2 )
	      fprintf(grprsm, " Type of sst/ice field (= 2/2 degree) %9d\n", isec1[44]);

	    fprintf(grprsm, " Number of ICE fields used:           %9d\n", isec1[45]);

	    for (jloop = 1; jloop < isec1[45]; jloop++)
	      {
		iyear = isec1[44+(jloop*2)];
		if ( iyear > 100 )
		  {
		    if ( iyear < 19000000 ) iyear = iyear + 19000000;
		    fprintf(grprsm, " Date of ICE field%3d                 %9d\n", jloop,
			   iyear);
		    fprintf(grprsm, " Satellite number (ICE field%3d)      %9d\n", jloop,
			   isec1[45+(jloop*2)]);
		  }
		else
		  fprintf(grprsm, "Date of sst/ice field used           Not given\n");
	      } 
	  }
	}
    }
  /*
    -----------------------------------------------------------------
    Section 3 . Print Washington ensemble product information.
    -----------------------------------------------------------------
  */
  /*
    Washington EPS products (but not reformatted Washington EPS
    products.
  */
  if ( (isec1[1] == 7 && isec1[23] == 1) && (! isec1[21] == 98) )
    {
      /*   CALL KWPRS1 (iSEC0,iSEC1)*/
    }
}

void printQuasi(int *isec2)
{
  /*

    Print the qusai-regular information in the Grid Description
    Section (Section 2) of decoded GRIB data.

    Input Parameters:

       isec2 - Array of decoded integers from Section 2.

    Comments:

       Only data representation types catered for are Gaussian
       grid, latitude/longitude grid, Spherical Harmonics,
       Polar stereographic and Space view perspective.

    Converted from EMOS routine PTQUASI.

       Uwe Schulzweida   MPIfM   01/04/2001

  */

  char yout[64];
  int nextlat, nrepeat, latcnt;
  int j;
  int ntos;

  /*
    -----------------------------------------------------------------
    Section 1. Print quasi-grid data.
    -----------------------------------------------------------------
  */
  /*
    See if scanning is north->south or south->north
  */
  fprintf(grprsm, "  Number of points along a parallel varies.\n");

  ntos = ( fmod((double) isec2[10], 128.) < 64 );

  if ( ntos )
    fprintf(grprsm, "  Number of points.   Parallel. (North to South)\n");
  else
    fprintf(grprsm, "  Number of points.   Parallel. (South to North)\n");

  /*  Display number of points for each latitude */
  latcnt  = isec2[2];
  nextlat = 0;
  memset(yout, ' ', (size_t) 11);

  for ( j = 0; j < latcnt; j++ )
    {
      nextlat = nextlat + 1;
      sprintf(yout, "%4d", nextlat);

      /*       Finished?  */
      if ( nextlat > latcnt ) break;
      if ( nextlat == latcnt )
	{
	  fprintf(grprsm, " %5d                %-12s\n", isec2[nextlat+21], yout);
	  break;
	}
      /*
	Look for neighbouring latitudes with same number of points
      */
      nrepeat = 0;

    LABEL110:
      /*
	If neighbouring latitudes have same number of points
	increase the repeat count.
      */
      if ( isec2[nextlat+21+1] == isec2[nextlat+21] )
	{
          nrepeat = nrepeat + 1;
          nextlat = nextlat + 1;
	  if ( nextlat < latcnt ) goto LABEL110;
	}
      /*
	Display neighbouring latitudes with same number of points as
	'nn to mm'.
      */
      if ( nrepeat >= 1 )
	{
	  strncpy(yout+4, " to", 3);
	  sprintf(yout+7, "%5d", nextlat);
        }
      fprintf(grprsm, " %5d                %-12s\n", isec2[nextlat+21], yout);
      memset(yout, ' ', (size_t) 11);
    }
}

void gribPrintSec2DP(int *isec0, int *isec2, double *fsec2)
{
  /*

    Print the information in the Grid Description
    Section (Section 2) of decoded GRIB data.

    Input Parameters:

       isec0  - Array of decoded integers from Section 0

       isec2  - Array of decoded integers from Section 2

       fsec2  - Array of decoded floats from Section 2

    Comments:

       Only data representation types catered for are Gaussian
       grid, latitude/longitude grid, Spherical Harmonics,
       Polar stereographic and Space view perspective.


    Converted from EMOS routine GRPRS2.

       Uwe Schulzweida   MPIfM   01/04/2001

  */

  int i, ibit, iedit, ierr, iout, iresol;

  grsdef();
  /*
    -----------------------------------------------------------------
    Section 1 . Print GRIB Edition number.
    -----------------------------------------------------------------
  */
  iedit = isec0[1];
  fprintf(grprsm, " \n");
  fprintf(grprsm, " Section 2 - Grid Description Section.\n");
  fprintf(grprsm, " -------------------------------------\n");
  /*
    -----------------------------------------------------------------
    Section 2 . Print spherical harmonic data.
    -----------------------------------------------------------------
  */
  if ( isec2[0] == 50 || isec2[0] == 60 || 
       isec2[0] == 70 || isec2[0] == 80 )
    {
      fprintf(grprsm, " Data represent type = spectral     (Table 6) %9d\n", isec2[0]);
      fprintf(grprsm, " J - Pentagonal resolution parameter.         %9d\n", isec2[1]);
      fprintf(grprsm, " K - Pentagonal resolution parameter.         %9d\n", isec2[2]);
      fprintf(grprsm, " M - Pentagonal resolution parameter.         %9d\n", isec2[3]);
      fprintf(grprsm, " Representation type (Table 9)                %9d\n", isec2[4]);
      fprintf(grprsm, " Representation mode (Table 10).              %9d\n", isec2[5]);
      for (i = 7; i <= 11; i++)
        fprintf(grprsm, " Not used.                                    %9d\n", isec2[i-1]);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Section 3 . Print Gaussian grid data.
    -----------------------------------------------------------------
  */
  if ( isec2[0] ==  4 || isec2[0] == 14 || 
       isec2[0] == 24 || isec2[0] == 34 )
    {
      fprintf(grprsm, " (Southern latitudes and Western longitudes are negative.)\n");
      fprintf(grprsm, " Data represent type = gaussian     (Table 6) %9d\n", isec2[0]);
      /*
	Quasi-regular grids introduced in Edition 1.
      */
      if ( isec2[16] == 0 || iedit < 1 )
	fprintf(grprsm, " Number of points along a parallel.           %9d\n", isec2[1]);
      else
      	printQuasi(isec2);

      fprintf(grprsm, " Number of points along a meridian.           %9d\n", isec2[2]);
      fprintf(grprsm, " Latitude of first grid point.                %9d\n", isec2[3]);
      fprintf(grprsm, " Longitude of first grid point.               %9d\n", isec2[4]);

      ibit = 8;
      iresol = isec2[5] + isec2[17] + isec2[18];
      prtbin(iresol, ibit, &iout, &ierr);

      fprintf(grprsm, " Resolution and components flag.               %8.8d\n", iout);
      fprintf(grprsm, " Latitude of last grid point.                 %9d\n", isec2[6]);
      fprintf(grprsm, " Longitude of last grid point.                %9d\n", isec2[7]);
      /*
	Print increment if given.
      */
      if ( isec2[5] == 128 )
	fprintf(grprsm, " i direction (East-West) increment.           %9d\n", isec2[8]);
      else
	fprintf(grprsm, " i direction (East-West) increment            Not given\n");

      fprintf(grprsm, " Number of parallels between pole and equator.%9d\n", isec2[9]);

      ibit = 8;
      prtbin(isec2[10], ibit, &iout, &ierr);

      fprintf(grprsm, " Scanning mode flags (Code Table 8)            %8.8d\n", iout);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Section 4 . Print Latitude / longitude grid data.
    -----------------------------------------------------------------
  */
  if ( isec2[0] ==  0 || isec2[0] == 10 || 
       isec2[0] == 20 || isec2[0] == 30 )
    {
      fprintf(grprsm, " (Southern latitudes and Western longitudes are negative.)\n");
      fprintf(grprsm, " Data represent type = lat/long     (Table 6) %9d\n", isec2[0]);
      /*
	Quasi-regular lat/long grids also possible.
      */
      if ( isec2[16] == 0 )
	fprintf(grprsm, " Number of points along a parallel.           %9d\n", isec2[1]);
      else
        printQuasi(isec2);

      fprintf(grprsm, " Number of points along a meridian.           %9d\n", isec2[2]);
      fprintf(grprsm, " Latitude of first grid point.                %9d\n", isec2[3]);
      fprintf(grprsm, " Longitude of first grid point.               %9d\n", isec2[4]);

      ibit = 8;
      iresol = isec2[5] + isec2[17] + isec2[18];
      prtbin(iresol, ibit, &iout, &ierr);

      fprintf(grprsm, " Resolution and components flag.               %8.8d\n", iout);
      fprintf(grprsm, " Latitude of last grid point.                 %9d\n", isec2[6]);
      fprintf(grprsm, " Longitude of last grid point.                %9d\n", isec2[7]);
      /*
	Print increment if given.
      */
      if ( isec2[8] < 0 )
	fprintf(grprsm, " i direction (East-West) increment            Not given\n");
      else
	fprintf(grprsm, " i direction (East-West) increment.           %9d\n", isec2[8]);

      if ( isec2[9] < 0 )
	fprintf(grprsm, " j direction (North-South) increment          Not given\n");
      else
	fprintf(grprsm, " j direction (North-South) increment.         %9d\n", isec2[9]);
    
      ibit = 8;
      prtbin(isec2[10], ibit, &iout, &ierr);

      fprintf(grprsm, " Scanning mode flags (Code Table 8)            %8.8d\n", iout);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Section 5 . Print polar stereographic data.
    -----------------------------------------------------------------
  */
  if ( isec2[0] == 5 )
    {
      fprintf(grprsm, " (Southern latitudes and Western longitudes are negative.)\n");
      fprintf(grprsm, " Data represent type = polar stereo (Table 6) %9d\n", isec2[0]);
      fprintf(grprsm, " Number of points along X axis.               %9d\n", isec2[1]);
      fprintf(grprsm, " Number of points along Y axis.               %9d\n", isec2[2]);
      fprintf(grprsm, " Latitude of first grid point.                %9d\n", isec2[3]);
      fprintf(grprsm, " Longitude of first grid point.               %9d\n", isec2[4]);
      ibit = 8;
      iresol = isec2[17] + isec2[18];
      prtbin(iresol, ibit, &iout, &ierr);
      fprintf(grprsm, " Resolution and components flag.               %8.8d\n", iout);
      fprintf(grprsm, " Orientation of the grid.                     %9d\n", isec2[6]);
      fprintf(grprsm, " X direction increment.                       %9d\n", isec2[8]);
      fprintf(grprsm, " Y direction increment.                       %9d\n", isec2[9]);
      ibit = 8;
      prtbin(isec2[10], ibit, &iout, &ierr);
      fprintf(grprsm, " Scanning mode flags (Code Table 8)            %8.8d\n", iout);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      fprintf(grprsm, " Projection centre flag.                      %9d\n", isec2[12]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Section 6 . Print Lambert conformal data.
    -----------------------------------------------------------------
  */
  if ( isec2[0] == 3 )
    {
      fprintf(grprsm, " (Southern latitudes and Western longitudes are negative.)\n");
      fprintf(grprsm, " Data represent type = Lambert      (Table 6) %9d\n", isec2[0]);
      fprintf(grprsm, " Number of points along X axis.               %9d\n", isec2[1]);
      fprintf(grprsm, " Number of points along Y axis.               %9d\n", isec2[2]);
      fprintf(grprsm, " Latitude of first grid point.                %9d\n", isec2[3]);
      fprintf(grprsm, " Longitude of first grid point.               %9d\n", isec2[4]);
      ibit = 8;
      iresol = isec2[17] + isec2[18] + isec2[5];
      prtbin(iresol, ibit, &iout, &ierr);
      fprintf(grprsm, " Resolution and components flag.               %8.8d\n", iout);
      fprintf(grprsm, " Orientation of the grid.                     %9d\n", isec2[6]);
      fprintf(grprsm, " X direction increment.                       %9d\n", isec2[8]);
      fprintf(grprsm, " Y direction increment.                       %9d\n", isec2[9]);
      ibit = 8;
      prtbin(isec2[10], ibit, &iout, &ierr);
      fprintf(grprsm, " Scanning mode flags (Code Table 8)            %8.8d\n", iout);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      fprintf(grprsm, " Projection centre flag.                      %9d\n", isec2[12]);
      fprintf(grprsm, " Latitude intersection 1 - Latin 1 -.         %9d\n", isec2[13]);
      fprintf(grprsm, " Latitude intersection 2 - Latin 2 -.         %9d\n", isec2[14]);
      fprintf(grprsm, " Latitude of Southern Pole.                   %9d\n", isec2[19]);
      fprintf(grprsm, " Longitude of Southern Pole.                  %9d\n", isec2[20]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Section 7 . Print space view perspective or orthographic data.
    -----------------------------------------------------------------
  */
  if ( isec2[0] == 90 )
    {
      fprintf(grprsm, " (Southern latitudes and Western longitudes are negative.)\n");
      fprintf(grprsm, " Data represent type = space/ortho  (Table 6) %9d\n", isec2[0]);
      fprintf(grprsm, " Number of points along X axis.               %9d\n", isec2[1]);
      fprintf(grprsm, " Number of points along Y axis.               %9d\n", isec2[2]);
      fprintf(grprsm, " Latitude of sub-satellite point.             %9d\n", isec2[3]);
      fprintf(grprsm, " Longitude of sub-satellite point.            %9d\n", isec2[4]);
      iresol = isec2[17] + isec2[18];
      fprintf(grprsm, " Diameter of the earth in x direction.        %9d\n", isec2[6]);
      fprintf(grprsm, " Y coordinate of sub-satellite point.         %9d\n", isec2[9]);
      ibit = 8;
      prtbin(isec2[10], ibit, &iout, &ierr);
      fprintf(grprsm, " Scanning mode flags (Code Table 8)            %8.8d\n", iout);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      fprintf(grprsm, " Orientation of the grid.                     %9d\n", isec2[6]);
      fprintf(grprsm, " Altitude of the camera.                      %9d\n", isec2[13]);
      fprintf(grprsm, " Y coordinate of origin of sector image.      %9d\n", isec2[14]);
      fprintf(grprsm, " X coordinate of origin of sector image.      %9d\n", isec2[15]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Section 7.5 . Print ocean data
    -----------------------------------------------------------------
  */
  /*
  if ( isec2[0] == 192 && isec1[1] == 98 )
    {
      fprintf(grprsm, " Data represent type = ECMWF ocean  (Table 6) %9d\n", isec2[0]);
      if ( isec2[1] ==  32767 )
	fprintf(grprsm, " Number of points along the first axis.       Not used\n");
      else
	fprintf(grprsm, " Number of points along the first axis.       %9d\n", isec2[1]);

      if ( isec2[2] ==  32767 )
	fprintf(grprsm, " Number of points along the second axis.      Not used\n");
      else
	fprintf(grprsm, " Number of points along the second axis.      %9d\n", isec2[2]);

      ibit = 8;
      prtbin(isec2[10], ibit, &iout, &ierr);
      fprintf(grprsm, " Scanning mode flags (Code Table 8)            %8.8d\n", iout);
      goto LABEL800;
    }
    */
  /*
    -----------------------------------------------------------------
    Section 7.6 . Print triangular data
    -----------------------------------------------------------------
  */
  if ( isec2[0] == 192 /* && isec1[1] == 78 */ )
    {
      fprintf(grprsm, " Data represent type = triangular   (Table 6) %9d\n", isec2[0]);
      fprintf(grprsm, " Number of factor 2 in factorisation of Ni.   %9d\n", isec2[1]);
      fprintf(grprsm, " Number of factor 3 in factorisation of Ni.   %9d\n", isec2[2]);
      fprintf(grprsm, " Number of diamonds (Nd).                     %9d\n", isec2[3]);
      fprintf(grprsm, " Number of triangular subdivisions of the\n");
      fprintf(grprsm, "           icosahedron (Ni).                  %9d\n", isec2[4]);
      fprintf(grprsm, " Flag for orientation of diamonds (Table A).  %9d\n", isec2[5]);
      fprintf(grprsm, " Latitude of pole point.                      %9d\n", isec2[6]);
      fprintf(grprsm, " Longitude of pole point.                     %9d\n", isec2[7]);
      fprintf(grprsm, " Longitude of the first diamond.              %9d\n", isec2[8]);
      fprintf(grprsm, " Flag for storage sequence (Table B).         %9d\n", isec2[9]);
      fprintf(grprsm, " Number of vertical coordinate parameters.    %9d\n", isec2[11]);
      goto LABEL800;
    }
  /*
    -----------------------------------------------------------------
    Drop through to here => representation type not catered for.
    -----------------------------------------------------------------
  */
  fprintf(grprsm, "GRPRS2 :Data representation type not catered for -%d\n", isec2[0]);

  goto LABEL900;
  /*
    -----------------------------------------------------------------
    Section 8 . Print vertical coordinate parameters,
                rotated grid information,
                stretched grid information, if any.
    -----------------------------------------------------------------
  */
 LABEL800:;
  /*
    Vertical coordinate parameters ...
  */
  if ( isec2[11] != 0 )
    {
      fprintf(grprsm, " \n");
      fprintf(grprsm, " Vertical Coordinate Parameters.\n");
      fprintf(grprsm, " -------------------------------\n");
      for ( i = 10; i < isec2[11]+10; i++ )
	fprintf(grprsm, "    %20.12f\n", fsec2[i]);
    }
  /*
    Rotated and stretched grids introduced in Edition 1.
  */
  if ( iedit < 1 ) goto LABEL900;
  /*
    Rotated grid information ...
  */
  if ( isec2[0] == 10 || isec2[0] == 30 || 
       isec2[0] == 14 || isec2[0] == 34 || 
       isec2[0] == 60 || isec2[0] == 80 || 
       isec2[0] == 30 )
    {
      fprintf(grprsm, " \n");
      fprintf(grprsm, " Latitude of southern pole of rotation.       %9d\n", isec2[12]);
      fprintf(grprsm, " Longitude of southern pole of rotation.      %9d\n", isec2[13]);
      fprintf(grprsm, " Angle of rotation.                     %20.10f\n", fsec2[0]);
    }
  /*
    Stretched grid information ...
  */
  if ( isec2[0] == 20 || isec2[0] == 30 || 
       isec2[0] == 24 || isec2[0] == 34 || 
       isec2[0] == 70 || isec2[0] == 80 )
    {
      fprintf(grprsm, " \n");
      fprintf(grprsm, " Latitude of pole of stretching.              %9d\n", isec2[14]);
      fprintf(grprsm, " Longitude of pole of stretching.             %9d\n", isec2[15]);
      fprintf(grprsm, " Stretching factor.                     %20.10f\n", fsec2[1]);
    }

 LABEL900:;

  return;
}

void gribPrintSec2SP(int *isec0, int *isec2, float  *fsec2sp)
{
  static char func[] = "grprs2sp";
  int inum;
  int j;
  double *fsec2;

  inum = 10 + isec2[11];

  fsec2 = (double *) malloc(inum*sizeof(double));
  if ( fsec2 == NULL ) SysError(func, "No Memory!");

  for ( j = 0; j < inum; j++ )
     fsec2[j] = fsec2sp[j];
  
  gribPrintSec2DP(isec0, isec2, fsec2);

  free(fsec2);
}

void gribPrintSec3DP(int *isec0, int *isec3, double *fsec3)
{
  /*

    Print the information in the Bit-Map Section
    (Section 3) of decoded GRIB data.

    Input Parameters:

       isec0  - Array of decoded integers from Section 0

       isec3  - Array of decoded integers from Section 3

       fsec3  - Array of decoded floats from Section 3


    Converted from EMOS routine GRPRS3.

       Uwe Schulzweida   MPIfM   01/04/2001

  */

  grsdef();

  fprintf(grprsm, " \n");
  fprintf(grprsm, " Section 3 - Bit-map Section.\n");
  fprintf(grprsm, " -------------------------------------\n");

  if ( isec3[0] != 0 )
    fprintf(grprsm, " Predetermined bit-map number.                %9d\n", isec3[0]);
  else
    fprintf(grprsm, " No predetermined bit-map.\n");

  fprintf(grprsm, " Missing data value for integer data.    %14d\n", isec3[1]);

  fprintf(grprsm, " Missing data value for real data. %20.6g\n", fsec3[1]);
}

void gribPrintSec3SP(int *isec0, int *isec3, float  *fsec3sp)
{
  double fsec3[2];

  fsec3[0] = fsec3sp[0];
  fsec3[1] = fsec3sp[1];
  
  gribPrintSec3DP(isec0, isec3, fsec3);
}

void gribPrintSec4DP(int *isec0, int *isec4, double *fsec4)
{
  /*

    Print the information in the Binary Data Section
    (Section 4) of decoded GRIB data.

    Input Parameters:

       isec0  - Array of decoded integers from Section 0

       isec4  - Array of decoded integers from Section 4

       fsec4  - Array of decoded floats from Section 4


    Converted from EMOS routine GRPRS4.

       Uwe Schulzweida   MPIfM   01/04/2001

  */

  int inum;
  int j;

  grsdef();

  /*
    -----------------------------------------------------------------
    Section 1 . Print integer information from isec4.
    -----------------------------------------------------------------
  */
  fprintf(grprsm, " \n");
  fprintf(grprsm, " Section 4 - Binary Data  Section.\n");
  fprintf(grprsm, " -------------------------------------\n");

  fprintf(grprsm, " Number of data values coded/decoded.         %9d\n", isec4[0]);
  fprintf(grprsm, " Number of bits per data value.               %9d\n", isec4[1]);
  fprintf(grprsm, " Type of data       (0=grid pt, 128=spectral).%9d\n", isec4[2]);
  fprintf(grprsm, " Type of packing    (0=simple, 64=complex).   %9d\n", isec4[3]);
  fprintf(grprsm, " Type of data       (0=float, 32=integer).    %9d\n", isec4[4]);
  fprintf(grprsm, " Additional flags   (0=none, 16=present).     %9d\n", isec4[5]);
  fprintf(grprsm, " Reserved.                                    %9d\n", isec4[6]);
  fprintf(grprsm, " Number of values   (0=single, 64=matrix).    %9d\n", isec4[7]);
  fprintf(grprsm, " Secondary bit-maps (0=none, 32=present).     %9d\n", isec4[8]);
  fprintf(grprsm, " Values width       (0=constant, 16=variable).%9d\n", isec4[9]);
  /*
    If complex packing ..
  */
  if ( isec4[3] == 64 )
    {
      if ( isec4[2] == 128 )
	{
	  fprintf(grprsm, " Byte offset of start of packed data (N).     %9d\n", isec4[15]);
	  fprintf(grprsm, " Power (P * 1000).                            %9d\n", isec4[16]);
	  fprintf(grprsm, " Pentagonal resolution parameter J for subset.%9d\n", isec4[17]);
	  fprintf(grprsm, " Pentagonal resolution parameter K for subset.%9d\n", isec4[18]);
	  fprintf(grprsm, " Pentagonal resolution parameter M for subset.%9d\n", isec4[19]);
	}
      else
	{
	  fprintf(grprsm, " Bits number of 2nd order values    (none=>0).%9d\n", isec4[10]);
	  fprintf(grprsm, " General extend. 2-order packing (0=no,8=yes).%9d\n", isec4[11]);
	  fprintf(grprsm, " Boustrophedonic ordering        (0=no,4=yes).%9d\n", isec4[12]);
	  fprintf(grprsm, " Spatial differencing order          (0=none).%9d\n", isec4[13]+isec4[14]);
        }
    }
  /*
    Number of non-missing values
  */
  if ( isec4[20] != 0 )
    fprintf(grprsm, " Number of non-missing values                 %9d\n", isec4[20]);
  /*
    Information on matrix of values , if present.
  */
  if ( isec4[7] == 64 )
    {
      fprintf(grprsm, " First dimension (rows) of each matrix.       %9d\n", isec4[49]);
      fprintf(grprsm, " Second dimension (columns) of each matrix.   %9d\n", isec4[50]);
      fprintf(grprsm, " First dimension coordinate values definition.%9d\n", isec4[51]);
      fprintf(grprsm, " (Code Table 12)\n");
      fprintf(grprsm, " NC1 - Number of coefficients for 1st dimension.%7d\n", isec4[52]);
      fprintf(grprsm, " Second dimension coordinate values definition.%8d\n", isec4[53]);
      fprintf(grprsm, " (Code Table 12)\n");
      fprintf(grprsm, " NC2 - Number of coefficients for 2nd dimension.%7d\n", isec4[54]);
      fprintf(grprsm, " 1st dimension physical signifance (Table 13). %8d\n", isec4[55]);
      fprintf(grprsm, " 2nd dimension physical signifance (Table 13).%8d\n", isec4[56]);
    }
  /*
    -----------------------------------------------------------------
    Section 2. Print values from fsec4.
    -----------------------------------------------------------------
  */

  inum = isec4[0];
  if ( inum <  0 ) inum = - inum;
  if ( inum > 20 ) inum = 20;
  /*
    Print first inum values.
  */
  fprintf(grprsm, " \n");
  fprintf(grprsm, " First %4d data values.\n", inum);

  if ( isec4[4] == 0 )
    {
      /*
	Print real values ...
      */
      for ( j = 0; j < inum; j++ )
	{
	  if ( fabs(fsec4[j]) > 0 )
	    {
	      if ( fabs(fsec4[j]) >= 0.1 && fabs(fsec4[j]) <= 1.e8 )
		fprintf(grprsm, " %#16.8G    \n", fsec4[j]);
	      else
		fprintf(grprsm, " %#20.8E\n", fsec4[j]);
	    }
	  else
	    fprintf(grprsm, " %#16.0f    \n", fabs(fsec4[j]));
	}
    }
  else
    {
      /*
	Print integer values ...
      */
      fprintf(grprsm, " Print of integer values not supported\n");
      /*
        CALL SETPAR(IBIT,IDUM,IDUM)
        DO 212 J=1,INUM
           INSPT = 0
           CALL INXBIT(IVALUE,1,INSPT,FSEC4(J),1,IBIT,IBIT,'C',IRET)
           WRITE (*,9033) IVALUE
 9033 FORMAT(' ',I15)
  212   CONTINUE
      ENDIF
      */
    }
}

void gribPrintSec4SP(int *isec0, int *isec4, float  *fsec4sp)
{
  int inum;
  int j;
  double fsec4[20];

  inum = isec4[0];
  if ( inum <  0 ) inum = -inum;
  if ( inum > 20 ) inum = 20;

  for ( j = 0; j < inum; j++ ) fsec4[j] = fsec4sp[j];
  
  gribPrintSec4DP(isec0, isec4, fsec4);
}

void gribPrintSec4Wave(int *isec4)
{
  /*

    Print the wave coordinate information in the Binary Data
    Section (Section 4) of decoded GRIB data.

    Input Parameters:

       isec4 - Array of decoded integers from Section 4

    Comments:

       Wave coordinate information held in isec4 are 32-bit floats,
       hence the PTEMP and NTEMP used for printing are 4-byte variables.


    Converted from EMOS routine GRPRS4W.

       Uwe Schulzweida   MPIfM   01/04/2001

  */
  int    jloop;
  int    ntemp[100];
  float *ptemp;

  grsdef();

  /*
    -----------------------------------------------------------------
    Section 1 . Print integer information from isec4.
    -----------------------------------------------------------------
  */
  fprintf(grprsm, " Coefficients defining first dimension coordinates:\n");
  for ( jloop = 0; jloop < isec4[52]; jloop++ )
    {
      ntemp[jloop] = isec4[59 + jloop];
      ptemp = (float *) &ntemp[jloop];
      fprintf(grprsm, "%20.10f\n", *ptemp);
    }
  fprintf(grprsm, " Coefficients defining second dimension coordinates:\n");
  for ( jloop = 0; jloop < isec4[54]; jloop++ )
    {
      ntemp[jloop] = isec4[59 + isec4[52] + jloop];
      ptemp = (float *) &ntemp[jloop];
      fprintf(grprsm, "%20.10f\n", *ptemp);
    }
}


#define COMP_Z      1
#define COMP_SZ     2
#define COMP_JASPER 3

#define COMPRESS  COMP_SZ

/* #define HAVE_LIBZ 1      */
/* #define HAVE_LIBSZ 1     */
/* #define HAVE_LIBJASPER 1 */

int  BitsPerInt = sizeof(int) * 8;


/* GRIB block 0 - indicator block */

void encodeIS(GRIBPACK *lGrib, int *gribLen)
{
  int z = *gribLen;

  lGrib[0] = 'G';
  lGrib[1] = 'R';
  lGrib[2] = 'I';
  lGrib[3] = 'B';

  /* 
   * lGrib[4]-lGrib[6] contains full length of grib record. 
   * included before finished CODEGB
   */

  z = 7;   
  Put1Byte(1); 
  z = 8;

  *gribLen = z;
}


/* GRIB block 5 - end block */

void encodeES(GRIBPACK *lGrib, int *gribLen)
{
  int z = *gribLen;

  lGrib[z++] = '7';
  lGrib[z++] = '7';
  lGrib[z++] = '7';
  lGrib[z++] = '7';

  lGrib[4] = z >> 16;
  lGrib[5] = z >>  8;
  lGrib[6] = z;

  while ( z & 7 ) lGrib[z++] = 0;

  *gribLen = z;
}

/* GRIB block 1 - product definition block. */

#define DWD_extension_253_len 37
#define DWD_extension_254_len 26

int getLocalExtLen(int *isec1)
{
  int extlen = 0;

  if ( ISEC1_LocalFLag )
    {
      if ( ISEC1_CenterID == 78 ) 
	{
	  if ( isec1[36] == 254 ) 
	    {
	      extlen = DWD_extension_254_len;
	    }
	  else if ( isec1[36] == 253 )
	    { 
	      extlen = DWD_extension_253_len;
	    }
	}
    }

  return (extlen);
}


int getPdsLen(int *isec1)
{
  int pdslen = 28;

  pdslen += getLocalExtLen(isec1);

  return (pdslen);
}


void encodePDS_DWD_local_Extension_254(GRIBPACK *lGrib, int *zs, int *isec1)
{
  int i, localextlen, isvn;
  int z = *zs;

  localextlen = getLocalExtLen(isec1);
  for ( i = 0; i < localextlen-2; i++ )
    {
      Put1Byte(isec1[24+i]);
    }

  isvn = isec1[49] << 15 | isec1[48]; /* DWD experiment identifier    */
  Put2Byte(isvn);             /* DWD run type (0=main, 2=ass, 3=test) */

  *zs = z;
}


void encodePDS_DWD_local_Extension_253(GRIBPACK *lGrib, int *zs, int *isec1)
{
  int i, localextlen, isvn;
  int z = *zs;

  localextlen = DWD_extension_254_len;
  for ( i = 0; i < localextlen-2; i++ )
    {
      Put1Byte(isec1[24+i]);
    }

  isvn = isec1[49] << 15 | isec1[48]; /* DWD experiment identifier    */
  Put2Byte(isvn);             /* DWD run type (0=main, 2=ass, 3=test) */
  Put1Byte(isec1[50]);        /* 55 User id, specified by table       */
  Put2Byte(isec1[51]);        /* 56 Experiment identifier             */
  Put2Byte(isec1[52]);        /* 58 Ensemble identification by table  */
  Put2Byte(isec1[53]);        /* 60 Number of ensemble members        */
  Put2Byte(isec1[54]);        /* 62 Actual number of ensemble member  */
  Put1Byte(isec1[55]);        /* 64 Model major version number        */ 
  Put1Byte(isec1[56]);        /* 65 Model minor version number        */ 

  *zs = z;
}


/* GRIB BLOCK 1 - PRODUCT DESCRIPTION SECTION */

void encodePDS(GRIBPACK *lpds, int pdsLen, int *isec1)
{
  GRIBPACK *lGrib = lpds;
  int z = 0;

  Put3Byte(pdsLen);               /*  0 Length of Block 1        */
  Put1Byte(ISEC1_CodeTable);      /*  3 Local table number       */
  Put1Byte(ISEC1_CenterID);       /*  4 Identification of centre */
  Put1Byte(ISEC1_ModelID);        /*  5 Identification of model  */
  Put1Byte(ISEC1_GridDefinition); /*  6 Grid definition          */
  Put1Byte(ISEC1_Sec2Or3Flag);    /*  7 Block 2 included         */
  Put1Byte(ISEC1_Parameter);      /*  8 Parameter Code           */
  Put1Byte(ISEC1_LevelType);      /*  9 Type of level            */
  if ( (ISEC1_LevelType !=  20) &&
       (ISEC1_LevelType !=  99) &&
       (ISEC1_LevelType != 100) &&
       (ISEC1_LevelType != 103) &&
       (ISEC1_LevelType != 105) &&
       (ISEC1_LevelType != 107) &&
       (ISEC1_LevelType != 109) &&
       (ISEC1_LevelType != 111) &&
       (ISEC1_LevelType != 113) &&
       (ISEC1_LevelType != 115) &&
       (ISEC1_LevelType != 117) &&
       (ISEC1_LevelType != 125) &&
       (ISEC1_LevelType != 127) &&
       (ISEC1_LevelType != 160) &&
       (ISEC1_LevelType != 210) )
    {
      Put1Byte(ISEC1_Level1);
      Put1Byte(ISEC1_Level2);
    }
  else
    {
      Put2Byte(ISEC1_Level1);     /* 10 Level                    */    
    }
  Put1Byte(ISEC1_Year);           /* 12 Year of Century          */
  Put1Byte(ISEC1_Month);          /* 13 Month                    */
  Put1Byte(ISEC1_Day);            /* 14 Day                      */
  Put1Byte(ISEC1_Hour);           /* 15 Hour                     */
  Put1Byte(ISEC1_Minute);         /* 16 Minute                   */
  if ( ISEC1_AvgNum > 0 )
    {
      Put1Byte(2);                    /* 17 Time unit                */
      Put1Byte(0);                    /* 18 Time 1                   */
      Put1Byte(0);                    /* 19 Time 2                   */
      Put1Byte(3);                    /* 20 Timerange flag           */
      Put2Byte(ISEC1_AvgNum);     /* 21 Average                  */
    }
  else
    {
      Put1Byte(ISEC1_TimeUnit);   /* 17 Time unit                */
      if ( ISEC1_TimeRange == 10 )
	{
	  Put1Byte(ISEC1_TimePeriod1);
	  Put1Byte(ISEC1_TimePeriod2);
	}
      else if ( ISEC1_TimeRange == 113 || ISEC1_TimeRange ==   0 )
	{
	  Put1Byte(ISEC1_TimePeriod1);
          Put1Byte(0);
	}
      else if ( ISEC1_TimeRange ==   4 || ISEC1_TimeRange ==   2 )
	{
          Put1Byte(0);
	  Put1Byte(ISEC1_TimePeriod2);
	}
      else
	{
          Put1Byte(0);
          Put1Byte(0); 
	}
      Put1Byte(ISEC1_TimeRange);      /* 20 Timerange flag           */
      Put2Byte(ISEC1_AvgNum);         /* 21 Average                  */
    }

  Put1Byte(ISEC1_AvgMiss);            /* 23 Missing from averages    */
  Put1Byte(ISEC1_Century);            /* 24 Century                  */
  Put1Byte(ISEC1_SubCenterID);        /* 25 Subcenter                */
  Put2Byte(ISEC1_DecScaleFactor);     /* 26 Decimal scale factor     */

  if ( ISEC1_LocalFLag )
    {
      if ( ISEC1_CenterID == 78 ) 
	{
	  if ( isec1[36] == 254 ) 
	    {
	      encodePDS_DWD_local_Extension_254(lGrib, &z, isec1);
	    }
	  else if ( isec1[36] == 253 )
	    { 
	      encodePDS_DWD_local_Extension_253(lGrib, &z, isec1);
	    }
	}
      else
	{
	  int i, localextlen;
	  localextlen = getLocalExtLen(isec1);
	  for ( i = 0; i < localextlen; i++ )
	    {
	      Put1Byte(isec1[24+i]);
	    }
	}
    }
}


/* GRIB BLOCK 2 - GRID DESCRIPTION SECTION */

void encodeGDS(GRIBPACK *lGrib, int *gribLen, int *isec1, int *isec2, double *fsec2)
{
  int z = *gribLen;
  int exponent, mantissa;
  int i;
  int ival;
  int pvoffset = 255;
  int gdslen = 32;

  if ( ISEC2_GridType == GTYPE_LATLON_ROT )  gdslen += 10;

  if ( ISEC2_NumVCP || ISEC2_Reduced ) pvoffset = gdslen + 1;

  if ( ISEC2_Reduced ) gdslen += 2 * ISEC2_NumLat;

  gdslen += ISEC2_NumVCP * 4;

  Put3Byte(gdslen);             /*  0- 2 Length of Block 2 Byte 0 */
  Put1Byte(ISEC2_NumVCP);       /*  3    NV */
  Put1Byte(pvoffset);           /*  4    PV */
  Put1Byte(ISEC2_GridType);     /*  5    LatLon=0 Gauss=4 Spectral=50 */

  if ( ISEC2_GridType == GTYPE_SPECTRAL )
    {
      Put2Byte(ISEC2_PentaJ);   /*  6- 7 Pentagonal resolution J  */
      Put2Byte(ISEC2_PentaK);   /*  8- 9 Pentagonal resolution K  */
      Put2Byte(ISEC2_PentaM);   /* 10-11 Pentagonal resolution M  */
      Put1Byte(ISEC2_RepType);  /* 12    Representation type      */
      Put1Byte(ISEC2_RepMode);  /* 13    Representation mode      */
      PutnZero(18);             /* 14-31 reserved                 */
    }
  else if ( ISEC2_GridType == GTYPE_TRIANGULAR )
    {
      Put2Byte(ISEC2_TRI_NI2);
      Put2Byte(ISEC2_TRI_NI3);
      Put3Byte(ISEC2_TRI_ND);
      Put3Byte(ISEC2_TRI_NI);
      Put1Byte(ISEC2_TRI_AFlag);
      Put3Int(ISEC2_TRI_LatPP);
      Put3Int(ISEC2_TRI_LonPP);
      Put3Int(ISEC2_TRI_LonMPL);
      Put1Byte(ISEC2_TRI_BFlag);
      PutnZero(5);
    }
  else
    {
      Put2Byte(ISEC2_NumLon);          /*  6- 7 Longitudes               */

      Put2Byte(ISEC2_NumLat);          /*  8- 9 Latitudes                */
      Put3Int(ISEC2_FirstLat);
      Put3Int(ISEC2_FirstLon);
      Put1Byte(ISEC2_ResFlag);         /* 16    Resolution flag          */
      Put3Int(ISEC2_LastLat);
      Put3Int(ISEC2_LastLon);
      Put2Byte(ISEC2_LonIncr);                  /* 23-24 i - direction increment  */
      if ( ISEC2_GridType == GTYPE_GAUSSIAN )
	Put2Byte(ISEC2_NumPar);        /* 25-26 Latitudes Pole->Equator  */
      else
	Put2Byte(ISEC2_LatIncr);              /* 25-26 j - direction increment  */

      Put1Byte(ISEC2_ScanFlag);        /* 27    Scanning mode            */
      PutnZero(4);                     /* 28-31 reserved                 */

      if ( ISEC2_GridType == GTYPE_LATLON_ROT )
	{
	  Put3Int(ISEC2_LatSP);
	  Put3Int(ISEC2_LonSP);
	  Put1Real(FSEC2_RotAngle);
	}
    }

#if defined (SX)
#pragma vdir novector     /* vectorization gives wrong results on NEC */
#endif
  for ( i = 0; i < ISEC2_NumVCP; ++i )
    {
      Put1Real(fsec2[10+i]);
    }

  if ( ISEC2_Reduced )
    for ( i = 0; i < ISEC2_NumLat; i++ ) Put2Byte(ISEC2_RowLon(i));

  *gribLen = z;
}


/* GRIB BLOCK 3 - BIT MAP SECTION */

void encodeBMS(GRIBPACK *lGrib, int *gribLen, double *fsec3, int *isec4, double *data, int *datasize)
{
  static char func[] = "encodeBMS";
  GRIBPACK *bitmap;
  int bitmapSize;
  int i;
  int bmsLen, bmsUnusedBits;
  int fsec4size;
  int z = *gribLen;
  unsigned int *imask;
  /*  unsigned int c, imask; */

  bitmapSize = ISEC4_NumValues;
  bitmap = &lGrib[z+6];
  fsec4size = 0;
  /*
  for ( i = 0; i < bitmapSize/8; i++ ) bitmap[i] = 0;

  for ( i = 0; i < bitmapSize; i++ )
    {
      if ( data[i] != FSEC3_MissVal )
	{
	  data[fsec4size++] = data[i];
	  bitmap[i/8] |= 1<<(7-(i&7));
	}
    }
  */

  imask = (unsigned int *) malloc(bitmapSize*sizeof(int));
  memset(imask, 0, bitmapSize*sizeof(int));

#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
  for ( i = 0; i < bitmapSize; i++ )
    {
      if ( data[i] != FSEC3_MissVal )
	{
	  data[fsec4size++] = data[i];
	  imask[i] = 1;
	}
    }

#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
  for ( i = 0; i < bitmapSize/8; i++ )
    {
      bitmap[i] = (imask[i*8+0] << 7) | (imask[i*8+1] << 6) |
	          (imask[i*8+2] << 5) | (imask[i*8+3] << 4) |
	          (imask[i*8+4] << 3) | (imask[i*8+5] << 2) |
	          (imask[i*8+6] << 1) | (imask[i*8+7]);
    }

  free(imask);

  bmsLen = bitmapSize/8 + 6;
  bmsUnusedBits = bitmapSize%8;

  Put3Byte(bmsLen);   /*  0- 2 Length of Block 3 Byte 0 */
  Put1Byte(bmsUnusedBits);
  Put2Byte(0);

  *gribLen += bmsLen;

  *datasize = fsec4size;
}


/* GRIB BLOCK 4 - BINARY DATA SECTION */

int encodeBDS(GRIBPACK *lGrib, int *gribLen, int decscale, int *isec2, int *isec4, int datasize, double data[],
	      int *datstart, int *datsize)
{
  /* Uwe Schulzweida, 11/04/2003 : Check that number of bits per value is not exceeded */
  /* Uwe Schulzweida,  6/05/2003 : Copy result to fpval to prevent integer overflow */

  static char func[] = "encodeBDS";
  static int lwarn_cplx = TRUE;
  int z = *gribLen;
  int i, jloop;
  int blockLength, PackStart, Flag;
  int binscale = 0, pval;
  int byte_per_value;
  int nbpv, ibits = BitsPerInt;
  int max_nbpv_pow2;
  int exponent, mantissa;        \
  double fpval;
  double factor = 1, fmin, fmax, zref;
  double range, rangec;
  double jpepsln = 1.0e-12;     /* -----> tolerance used to check equality     */
                                /*        of floating point numbers - needed   */
		                /*        on some platforms (eg vpp700, linux) */
  extern double _pow2tab[158];

  if ( isec4[3] == 64 && lwarn_cplx )
    {
      lwarn_cplx = FALSE;
      Message(func, "complex packing of spectral data unsupported, using simple packing!");
    }

  byte_per_value = ISEC4_NumBits >> 3;

  if ( ISEC2_GridType == GTYPE_SPECTRAL )
    {
      PackStart   = 1;
      Flag        = 128 + 8;
      blockLength = 16 + byte_per_value*(datasize - 1);
    }
  else
    {
      PackStart   = 0;
      Flag        = 8;
      blockLength = 12 + byte_per_value*datasize;
    }

  if ( decscale )
    {
      double scale = pow(10.0, decscale);
      for ( i = PackStart; i < datasize; ++i ) data[i] *= scale;
    }

  fmin = fmax = data[PackStart];

#if   defined (CRAY)
#pragma _CRI ivdep
#elif defined (SX)
#pragma vdir nodep
#elif defined (__uxp__)
#pragma loop novrec
#endif
  for ( i = PackStart+1; i < datasize; ++i )
    {
      if ( fmin > data[i] ) fmin = data[i];
      if ( fmax < data[i] ) fmax = data[i];
    }

  zref = fmin;

  /*
    Adjust number of bits per value if full integer length to
    avoid hitting most significant bit (sign bit).
  */
  nbpv = ISEC4_NumBits;
  /* if( nbpv == ibits ) nbpv = nbpv - 1; */
  /*
    Calculate the binary scaling factor to spread the range of
    values over the number of bits per value.
    Limit scaling to 2**-126 to 2**127 (using IEEE 32-bit floats
    as a guideline).           
  */
  range = fabs(fmax - fmin);
  /*
    Have to allow tolerance in comparisons on some platforms
    (eg vpp700 and linux), such as 0.9999999999999999 = 1.0,
    to avoid clipping ranges which are a power of 2.
  */
  if ( range <= jpepsln )
    {
      binscale = 0;
    }
  else if ( (fmin != 0.0) && (fabs(range/fmin) <= jpepsln) )
    {
      binscale = 0;
    }
  else if ( fabs(range-1.0) <= jpepsln )
    {
      binscale = 1 - nbpv;
    }
  else if ( range > 1.0 )
    {
      rangec = range + jpepsln;
      for ( jloop = 1; jloop < 128; jloop++ )
	{
	  if ( _pow2tab[jloop] > rangec ) break;
	}
      if ( jloop == 128 )
	{
	  gprintf(func, "Problem calculating binary scale value for encode");
	  gprintf(func, "> range %g rangec %g fmin %g fmax %g", range, rangec, fmin, fmax);
	  return (707);
	}
      else
	{
	  binscale = jloop - nbpv;
	}
    }
  else
    {
      rangec = range - jpepsln;
      for ( jloop = 1; jloop < 127; jloop++ )
	{
	  if ( 1.0/_pow2tab[jloop] < rangec ) break;
	}
      if ( jloop == 127 )
	{
	  gprintf(func, "Problem calculating binary scale value for encode");
	  gprintf(func, "< range %g rangec %g fmin %g fmax %g", range, rangec, fmin, fmax);
	  return (707);
	}
      else
	{
	  binscale = 1 - jloop - nbpv;
	}
    }

  if ( binscale != 0 )
    {
      if ( binscale < 0 ) factor =     _pow2tab[-binscale];
      else                factor = 1.0/_pow2tab[ binscale];
    }

  max_nbpv_pow2 = (int) _pow2tab[nbpv] - 1;

  ref2ibm(&zref, BitsPerInt);

  Put3Byte(blockLength);      /*  0-2 Length of Block 4        */
  Put1Byte(Flag);             /*  3   Flag & Unused bits       */
  if (binscale < 0) binscale = 32768 - binscale;
  Put2Byte(binscale);         /*  4-5 Scale factor             */
  Put1Real(zref);             /*  6-9 Reference value          */
  Put1Byte(nbpv);             /*   10 Packing size             */

  if ( PackStart ) Put1Real(data[0]);

  *datstart = z;
  *datsize  = (datasize-PackStart)*byte_per_value;

  if      ( ISEC4_NumBits ==  8 )
    {
#if   defined (CRAY)
#pragma _CRI ivdep
#elif defined (SX)
#pragma vdir nodep
#elif defined (__uxp__)
#pragma loop novrec
#endif
      for ( i = PackStart ; i < datasize; i++ )
	{
          fpval = ((data[i] - zref) * factor + 0.5);
	  if ( fpval > max_nbpv_pow2 ) fpval = max_nbpv_pow2;
	  if ( fpval < 0 ) fpval = 0;
	  pval = (int) fpval;
	  lGrib[z  ] = pval;
          z++;
	}
    }
  else if ( ISEC4_NumBits == 16 )
    {
#if   defined (CRAY)
#pragma _CRI ivdep
#elif defined (SX)
#pragma vdir nodep
#elif defined (__uxp__)
#pragma loop novrec
#endif
      for ( i = PackStart ; i < datasize; i++ )
	{
	  fpval = ((data[i] - zref) * factor + 0.5);
	  if ( fpval > max_nbpv_pow2 ) fpval = max_nbpv_pow2;
	  if ( fpval < 0 ) fpval = 0;
	  pval = (int) fpval;
	  lGrib[z  ] = pval >>  8;
          lGrib[z+1] = pval;
	  z += 2;
	}
    }
  else if ( ISEC4_NumBits == 24 )
    {
#if   defined (CRAY)
#pragma _CRI ivdep
#elif defined (SX)
#pragma vdir nodep
#elif defined (__uxp__)
#pragma loop novrec
#endif
      for ( i = PackStart ; i < datasize; i++ )
	{
          fpval = ((data[i] - zref) * factor + 0.5);
	  if ( fpval > max_nbpv_pow2 ) fpval = max_nbpv_pow2;
	  if ( fpval < 0 ) fpval = 0;
	  pval = (int) fpval;
          lGrib[z  ] =  pval >> 16;
          lGrib[z+1] =  pval >>  8;
          lGrib[z+2] =  pval;
          z += 3;
	}
    }
  else
    {
      Error(func, "Unimplemented packing factor %d", ISEC4_NumBits);
    }

  Put1Byte(0);              /*  Fillbyte                     */

  *gribLen = z;

  return (0);
}


void gribEncode(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
		double *fsec3, int *isec4, double *fsec4, int klenp, int *kgrib,
		int kleng, int *kword, int efunc, int *kret)
{
  static char func[] = "gribEncode";
  int gribLen = 0; /* Counter of GRIB length for output */ 
  long isLen, pdsLen;
  GRIBPACK *lpds;
  char *CGrib;
  int iret;
  int fsec4size = 0;
  int bmsIncluded;
  size_t len;
  GRIBPACK *lGrib;
  int datstart, datsize, bdsstart, bdsend;

  CGrib = (char *) kgrib;

  len = (klenp * 3 + 2000); /* only for maximum 24 bit packing */

  lGrib = (GRIBPACK *) malloc(len*sizeof(GRIBPACK));
  if ( lGrib == NULL ) SysError(func, "No Memory!");

  isLen = 8;
  encodeIS(lGrib, &gribLen);
  lpds = &lGrib[isLen];
  pdsLen = getPdsLen(isec1);

  encodePDS(lpds, pdsLen, isec1);
  gribLen += pdsLen;

  encodeGDS(lGrib, &gribLen, isec1, isec2, fsec2);
  /*
    ----------------------------------------------------------------
    BMS Bit-Map Section Section (Section 3)
    ----------------------------------------------------------------
  */ 
  bmsIncluded = ISEC1_Sec2Or3Flag & 64;

  if ( bmsIncluded )
    {
      encodeBMS(lGrib, &gribLen, fsec3, isec4, fsec4, &fsec4size);
    }
  else
    {
      fsec4size = ISEC4_NumValues;
    }

  bdsstart = gribLen;
  iret = encodeBDS(lGrib, &gribLen, ISEC1_DecScaleFactor, isec2, isec4, fsec4size, fsec4, &datstart, &datsize);
  bdsend = gribLen;
  encodeES(lGrib, &gribLen);

  if ( (size_t) gribLen > len )
    Error(func, "lGrib buffer to small! len = %d  gribLen = %d", len, gribLen);

  if ( (size_t) gribLen > kleng*sizeof(int) )
    Error(func, "kgrib buffer to small! kleng = %d  gribLen = %d", kleng, gribLen);

  (void) PACK_GRIB(lGrib, (char *)CGrib, gribLen, -1L);

  if ( isec4[3] == 128 )
    {
#if  COMPRESS == COMP_Z
#  if  defined  (HAVE_LIBZ)
      {
#   include "zlib.h"
      int status;
      int level = 6;
      Bytef *dest, *source;
      uLongf destLen, sourceLen;
      /*  z_stream strm; */

      destLen = len;
      sourceLen = datsize;
      dest = (char *) lGrib;
      source = CGrib + datstart;

      /* deflateInit2 (&strm, 6, Z_DEFLATED, 15, 8, Z_DEFAULT_STRATEGY); */
      /* Perform compression from the source to the destination buffer */
      status = compress2(dest, &destLen, source, sourceLen, level);

      /* Check for various zlib errors */
      if (Z_BUF_ERROR==status)
	Warning(func, "overflow");
      else if (Z_MEM_ERROR==status)
	Warning(func, "deflate memory error");
      else if (Z_OK!=status)
	Warning(func, "other deflate error");

      if ( destLen < datsize )
	{
	  int zz;
	  memcpy(CGrib + datstart, dest, destLen);
	  gribLen = datstart + destLen;
	  destLen += (bdsend - bdsstart - datsize);
	  CGrib[bdsstart  ] = 255 & (destLen >> 16);
	  CGrib[bdsstart+1] = 255 & (destLen >>  8);
	  CGrib[bdsstart+2] = 255 & (destLen);

	  CGrib[gribLen++] = 0;
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';

	  CGrib[4] = 255 & (gribLen >> 16);
	  CGrib[5] = 255 & (gribLen >>  8);
	  CGrib[6] = 255 & (gribLen);

	  zz = gribLen;
	  while ( zz & 7 ) CGrib[zz++] = 0;
	}
      }
#  else
      {
      static int libzwarn = 1;
      if ( libzwarn )
	{
	  Warning(func, "Compression disabled, zlib not available!");
	  libzwarn = 0;
	}
      }
#  endif
#elif COMPRESS == COMP_SZ
#  if  defined  (HAVE_LIBSZ)
#  define UINT32ENCODE(p, i) {						      \
   *(p) = (unsigned char)( (i)        & 0xff); (p)++;				      \
   *(p) = (unsigned char)(((i) >>  8) & 0xff); (p)++;				      \
   *(p) = (unsigned char)(((i) >> 16) & 0xff); (p)++;				      \
   *(p) = (unsigned char)(((i) >> 24) & 0xff); (p)++;				      \
}
      {
#   include "szlib.h"
      int status;
      SZ_com_t sz_param;          /* szip parameter block */
      char *dest, *source;
      size_t destLen, sourceLen;

      destLen = len;
      sourceLen = datsize;
      dest = (char *) lGrib;
      source = CGrib + datstart;

      sz_param.options_mask        = SZ_RAW_OPTION_MASK | SZ_MSB_OPTION_MASK | SZ_NN_OPTION_MASK;
      sz_param.bits_per_pixel      = ISEC4_NumBits;
      sz_param.pixels_per_block    = 8;
      sz_param.pixels_per_scanline = fsec4size/8;

      UINT32ENCODE(dest, sourceLen);

      status= SZ_BufftoBuffCompress(dest, &destLen, source, sourceLen, &sz_param);
      if ( SZ_OK != status )
	Warning(func, "sz error: %d", status);
      /*
      fprintf(stderr, "%3d %3d %5d %2d in: %5d out: %5d\n", ISEC1_Parameter, ISEC1_Level1, fsec4size, ISEC4_NumBits, sourceLen, destLen);
      */
      if ( destLen < datsize )
	{
	  int zz;
	  destLen += 4;
	  memcpy(CGrib + datstart, dest, destLen);
	  gribLen = datstart + destLen;
	  destLen += (bdsend - bdsstart - datsize);
	  CGrib[bdsstart  ] = 255 & (destLen >> 16);
	  CGrib[bdsstart+1] = 255 & (destLen >>  8);
	  CGrib[bdsstart+2] = 255 & (destLen);

	  CGrib[gribLen++] = 0;
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';

	  CGrib[4] = 255 & (gribLen >> 16);
	  CGrib[5] = 255 & (gribLen >>  8);
	  CGrib[6] = 255 & (gribLen);

	  zz = gribLen;
	  while ( zz & 7 ) CGrib[zz++] = 0;
	}
      }
#  else
      {
      static int libzwarn = 1;
      if ( libzwarn )
	{
	  Warning(func, "Compression disabled, szlib not available!");
	  libzwarn = 0;
	}
      }
#  endif
#elif COMPRESS == COMP_JASPER
#  if  defined  (HAVE_LIBJASPER)
      {
#   include "jasper/jasper.h"
      int status;
      char *dest, *source;
      size_t destLen, sourceLen;
      int width, height, nbits;
      int ier,rwcnt;
      jas_image_t image;
      jas_stream_t *jpcstream,*istream;
      jas_image_cmpt_t cmpt,*pcmpt;
#define MAXOPTSSIZE 1024
      char opts[MAXOPTSSIZE];

      opts[0]=(char)0; /* lossless compression !*/

      destLen = len;
      sourceLen = datsize;
      dest = (char *) lGrib;
      source = CGrib + datstart;

      width  = fsec4size/8;
      height = 8;
      nbits  = ISEC4_NumBits;

      /*     Initialize the JasPer image structure describing the grayscale */
      /*     image to encode into the JPEG2000 code stream.*/

      image.tlx_=0;
      image.tly_=0;

      image.brx_=(jas_image_coord_t)width;
      image.bry_=(jas_image_coord_t)height;

      image.numcmpts_=1;
      image.maxcmpts_=1;

      image.clrspc_=JAS_CLRSPC_SGRAY;         /* grayscale Image */
      image.cmprof_=0; 

      image.inmem_=1;

      cmpt.tlx_=0;
      cmpt.tly_=0;
      cmpt.hstep_=1;
      cmpt.vstep_=1;

      cmpt.width_=(jas_image_coord_t)width;
      cmpt.height_=(jas_image_coord_t)height;
      cmpt.type_=JAS_IMAGE_CT_COLOR(JAS_CLRSPC_CHANIND_GRAY_Y);

      cmpt.prec_=nbits;
      cmpt.sgnd_=0;
      cmpt.cps_=(nbits+7)/8;

      pcmpt=&cmpt;
      image.cmpts_=&pcmpt;

      /*    Open a JasPer stream containing the input grayscale values */

      istream=jas_stream_memopen(source, height*width*cmpt.cps_);
      cmpt.stream_=istream;

      /*    Open an output stream that will contain the encoded jpeg2000 */
      /*    code stream. */

      jpcstream=jas_stream_memopen(dest, destLen);
      
      /*     Encode image. */

      status=jpc_encode(&image, jpcstream, opts);
      if ( status != 0 )
	Warning(func, "jasper error: %d", status);

      /*    Clean up JasPer work structures. */
    
      destLen=jpcstream->rwcnt_;
      ier=jas_stream_close(istream);
      ier=jas_stream_close(jpcstream);

      /*
      fprintf(stderr, "%3d %3d %5d %2d in: %5d out: %5d\n", ISEC1_Parameter, ISEC1_Level1, fsec4size, ISEC4_NumBits, sourceLen, destLen);
      */
      if ( destLen < datsize )
	{
	  int zz;
	  memcpy(CGrib + datstart, dest, destLen);
	  gribLen = datstart + destLen;
	  destLen += (bdsend - bdsstart - datsize);
	  CGrib[bdsstart  ] = 255 & (destLen >> 16);
	  CGrib[bdsstart+1] = 255 & (destLen >>  8);
	  CGrib[bdsstart+2] = 255 & (destLen);

	  CGrib[gribLen++] = 0;
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';
	  CGrib[gribLen++] = '7';

	  CGrib[4] = 255 & (gribLen >> 16);
	  CGrib[5] = 255 & (gribLen >>  8);
	  CGrib[6] = 255 & (gribLen);

	  zz = gribLen;
	  while ( zz & 7 ) CGrib[zz++] = 0;
	}
      }
#  else
      {
      static int libzwarn = 1;
      if ( libzwarn )
	{
	  Warning(func, "Compression disabled, szlib not available!");
	  libzwarn = 0;
	}
      }
#  endif
#else
      {
      static int libzwarn = 1;
      if ( libzwarn )
	{
	  Warning(func, "Compression disabled, not available!");
	  libzwarn = 0;
	}
      }
#endif
    }

  free(lGrib);

  ISEC0_GRIB_Len     = gribLen;
  ISEC0_GRIB_Version = 1;

  *kword = gribLen / sizeof(int);
  if ( (size_t) gribLen != *kword * sizeof(int) ) *kword += 1;

  *kret = 0;
}



int gribVersion(unsigned char *is, size_t buffersize)
{
  static char func[] = "gribVersion";

  if ( buffersize < 8 )
    Error(func, "buffer to small (current size %d)!\n", (int) buffersize);

  return (IS_GRIB_Version);
}


double GET_Real(unsigned char *grib)
{
  int iexp, imant;

  iexp  = GET_UINT1(grib[0]);
  imant = GET_UINT3(grib[1], grib[2], grib[3]);

  return (decfp2(iexp, imant));
}


int decodeIS(unsigned char *is, int *isec0, int *iret)
{
  static char func[] = "decodeIS";
  int isLen = 0;
  int grib1offset;
  int lgrib = FALSE, lbudg = FALSE, ltide = FALSE;

  /*
    Octets 1 - 4 : The letters G R I B.
    Four 8 bit fields.
  */
  /*
    Check letters -> GRIB, BUDG or TIDE.
  */
  /*
    Check that 'GRIB' is found where expected.
  */
  if ( is[0] == 'G' && is[1] == 'R' && is[2] == 'I' && is[3] == 'B' ) lgrib = TRUE;
  /*
    ECMWF pseudo-grib data uses 'BUDG' and 'TIDE'.
  */
  if ( is[0] == 'B' && is[1] == 'U' && is[2] == 'D' && is[3] == 'G' ) lbudg = TRUE;
  if ( is[0] == 'T' && is[1] == 'I' && is[2] == 'D' && is[3] == 'E' ) ltide = TRUE;
  /*
    Data is not GRIB or pseudo-grib.
  */
  if ( lgrib == FALSE && lbudg == FALSE && ltide == FALSE )
    {
      *iret = 305;
      gprintf(func, "Input data is not GRIB or pseudo-grib.");
      gprintf(func, "Return code = %d", *iret);
    }
  if ( lbudg == TRUE || ltide == TRUE )
    {
      *iret = 305;
      gprintf(func, "Pseudo-grib data unsupported.");
      gprintf(func, "Return code = %d", *iret);
    }

  /*
    Octets 5 - 7 : Length of message.
    One 24 bit field.
  */
  ISEC0_GRIB_Len = IS_GRIB_Len;
  /*
    Octet 8 : GRIB Edition Number.
    One 8 bit field.
  */
  ISEC0_GRIB_Version = IS_GRIB_Version;

  if ( ISEC0_GRIB_Version > 1 )
    Error(func, "GRIB version %d unsupported!", ISEC0_GRIB_Version);

  grib1offset = ISEC0_GRIB_Version * 4;

  isLen = 4 + grib1offset;

  return (isLen);
}


void decodePDS_DWD_local_Extension_254(unsigned char *pds, int *isec1)
{
  int i, isvn;

  isec1[36] = GET_UINT1(pds[40]); /* extension identifier */
  for ( i = 0; i < 11; i++) 
    { 
      isec1[37+i] =  GET_UINT1(pds[41+i]);
    } 

  isvn = GET_UINT2(pds[52],pds[53]);
  
  isec1[48] =  isvn % 0x8000;              /* DWD experiment identifier            */
  isec1[49] =  isvn >> 15;                 /* DWD run type (0=main, 2=ass, 3=test) */

}


void decodePDS_DWD_local_Extension_253(unsigned char *pds, int *isec1)
{
  int i, isvn;

  isec1[36] = GET_UINT1(pds[40]); /* extension identifier */
  for ( i = 0; i < 11; i++) 
    { 
      isec1[37+i] =  GET_UINT1(pds[41+i]);
    } 

  isvn = GET_UINT2(pds[52],pds[53]);
  
  isec1[48] =  isvn % 0x8000;              /* DWD experiment identifier            */
  isec1[49] =  isvn >> 15;                 /* DWD run type (0=main, 2=ass, 3=test) */
  isec1[50] =  GET_UINT1(pds[54]);         /* User id, specified by table          */
  isec1[51] =  GET_UINT2(pds[55],pds[56]); /* Experiment identifier                */
  isec1[52] =  GET_UINT2(pds[57],pds[58]); /* Ensemble identification by table     */
  isec1[53] =  GET_UINT2(pds[59],pds[60]); /* Number of ensemble members           */
  isec1[54] =  GET_UINT2(pds[61],pds[62]); /* Actual number of ensemble member     */
  isec1[55] =  GET_UINT1(pds[63]);         /* Model major version number           */
  isec1[56] =  GET_UINT1(pds[64]);         /* Model minor version number           */

}


int decodePDS(unsigned char *pds, int *isec0, int *isec1)
{
  int pdsLen;

  pdsLen = PDS_Len;

  ISEC1_CodeTable      = PDS_CodeTable;
  ISEC1_CenterID       = PDS_CenterID;
  ISEC1_ModelID        = PDS_ModelID;
  ISEC1_GridDefinition = PDS_GridDefinition;
  ISEC1_Sec2Or3Flag    = PDS_Sec2Or3Flag;
  ISEC1_Parameter      = PDS_Parameter;
  ISEC1_LevelType      = PDS_LevelType;

  if ( (ISEC1_LevelType !=  20) && 
       (ISEC1_LevelType !=  99) && 
       (ISEC1_LevelType != 100) && 
       (ISEC1_LevelType != 103) && 
       (ISEC1_LevelType != 105) && 
       (ISEC1_LevelType != 107) && 
       (ISEC1_LevelType != 109) && 
       (ISEC1_LevelType != 111) && 
       (ISEC1_LevelType != 113) && 
       (ISEC1_LevelType != 115) && 
       (ISEC1_LevelType != 117) && 
       (ISEC1_LevelType != 125) && 
       (ISEC1_LevelType != 127) && 
       (ISEC1_LevelType != 160) && 
       (ISEC1_LevelType != 210) )
    {
      ISEC1_Level1 = PDS_Level1;
      ISEC1_Level2 = PDS_Level2;
    }
  else
    {
      ISEC1_Level1 = PDS_Level;
      ISEC1_Level2 = 0;
    }

  ISEC1_Year           = PDS_Year;
  ISEC1_Month          = PDS_Month;
  ISEC1_Day            = PDS_Day;
  ISEC1_Hour           = PDS_Hour;
  ISEC1_Minute         = PDS_Minute;
  ISEC1_TimeUnit       = PDS_TimeUnit;
  ISEC1_TimePeriod1    = PDS_TimePeriod1;
  ISEC1_TimePeriod2    = PDS_TimePeriod2;
  ISEC1_TimeRange      = PDS_TimeRange;
  ISEC1_AvgNum         = PDS_AvgNum;
  ISEC1_AvgMiss        = PDS_AvgMiss;

  if ( ISEC0_GRIB_Version == 1 )
    {
      ISEC1_Century        = PDS_Century;
      ISEC1_SubCenterID    = PDS_Subcenter;
      ISEC1_DecScaleFactor = PDS_DecimalScale;
    }
  else
    {
      ISEC1_Century        = 1;
      ISEC1_SubCenterID    = 0;
      ISEC1_DecScaleFactor = 0;
    }

  ISEC1_LocalFLag = 0;
  if ( pdsLen > 28 )
    {
      int localextlen;
      localextlen = pdsLen-28;

      ISEC1_LocalFLag = 1;

      if ( ISEC1_CenterID == 78 ) 
	{
	  if ( pds[40] == 254 ) 
	    {
	      decodePDS_DWD_local_Extension_254(pds, isec1);
	    }
	  else if ( pds[40] == 253 )
	    { 
	      decodePDS_DWD_local_Extension_253(pds, isec1);
	    }
	}
      else   
	{
	  int i;
	  for ( i = 0; i < localextlen; i++ )
	    {
	      isec1[24+i] = pds[28+i];
	    }
	}
    }

  return (pdsLen);
}


int decodeGDS(unsigned char  *gds, int *isec0, int *isec2, double *fsec2, int dfunc)
{
  static char func[] = "decodeGDS";
  int imisng;
  int  ReducedGrid = FALSE, VertCoorTab = FALSE;
  int  locnv = 0, locnl;
  int  jlenl;
  int  i;
  int iexp, imant;
  int ipvpl, ipl;
  int gdsLen = 0;
#if defined (SX)
  unsigned char *igrib;
  GRIBPACK *lgrib = NULL;
  size_t lGribLen = 0;
#endif

  imisng = 0;

  gdsLen = GDS_Len;

  ipvpl = GDS_PVPL;
  if ( ipvpl == 0 ) ipvpl = 255;

  if ( ipvpl != 255 )
    { /* Either vct or regrid */
      if ( GDS_NV != 0 )
	{ /* we have vct */
	  VertCoorTab = TRUE;
	  ipl =  4*GDS_NV + ipvpl - 1;
	  if ( ipl < gdsLen )
	    {
	      ReducedGrid = TRUE;
	    }
	}
      else
	{
	  VertCoorTab = FALSE;
	  ReducedGrid = TRUE;
	}
      /*	  ReducedGrid = (gdsLen - 32 - 4*GDS_NV); */
    }
 
  if ( ISEC0_GRIB_Version == 0 )
    {
      if ((gdsLen - 32) > 0) VertCoorTab = TRUE;
      else                   VertCoorTab = FALSE;
    }
  
  if ( ReducedGrid )
    {
      ISEC2_Reduced = TRUE;
      locnl = GDS_PVPL - 1 + (VertCoorTab * 4 * GDS_NV);
      jlenl = (gdsLen - locnl)  >> 1;
      for ( i = 0; i < jlenl; i++ )
	{
	  ISEC2_RowLon(i) = GET_UINT2(gds[locnl+2*i], gds[locnl+2*i+1]);
	}
    }

  ISEC2_GridType = GDS_GridType;

  /*
     Gaussian grid definition.
  */
  if ( ISEC2_GridType == GTYPE_LATLON    ||
       ISEC2_GridType == GTYPE_GAUSSIAN  ||
       ISEC2_GridType == GTYPE_LATLON_ROT )
    {
      if ( ! ReducedGrid ) ISEC2_NumLon = GDS_NumLon;
      ISEC2_NumLat    = GDS_NumLat;
      ISEC2_FirstLat  = GDS_FirstLat;
      ISEC2_FirstLon  = GDS_FirstLon;
      ISEC2_ResFlag   = GDS_ResFlag;
      ISEC2_LastLat   = GDS_LastLat;
      ISEC2_LastLon   = GDS_LastLon;
      ISEC2_LonIncr   = GDS_LonIncr;
      ISEC2_NumPar    = GDS_NumPar;
      ISEC2_ScanFlag  = GDS_ScanFlag;
      if ( ISEC2_GridType == GTYPE_LATLON_ROT )
	{
	  ISEC2_LatSP     = GDS_LatSP;
	  ISEC2_LonSP     = GDS_LonSP;
	  FSEC2_RotAngle  = GDS_RotAngle;
	}
      /*
	if ( Lons != Longitudes || Lats != Latitudes )
	Error(func, "Latitude/Longitude Conflict");
      */
    }
  else if ( ISEC2_GridType == GTYPE_GAUSSIAN     ||
	    ISEC2_GridType == GTYPE_GAUSSIAN_ROT ||
	    ISEC2_GridType == GTYPE_GAUSSIAN_STR ||
	    ISEC2_GridType == GTYPE_GAUSSIAN_ROTSTR )
    {
      /*
      iret = decodeGDS_GG(gds, gdspos, isec0, isec2, imisng);
      */
    }
  else if ( ISEC2_GridType == GTYPE_LATLON     ||
	    ISEC2_GridType == GTYPE_LATLON_ROT ||
	    ISEC2_GridType == GTYPE_LATLON_STR ||
	    ISEC2_GridType == GTYPE_LATLON_ROTSTR )
    {
      /*
      iret = decodeGDS_LL(gds, gdspos, isec0, isec2, imisng);
      */
    }
  else if ( ISEC2_GridType == GTYPE_SPECTRAL )
    {
      ISEC2_PentaJ  = GDS_PentaJ; /* Truncation */
      ISEC2_PentaK  = GDS_PentaK;
      ISEC2_PentaM  = GDS_PentaM;
      ISEC2_RepType = GDS_RepType;
      ISEC2_RepMode = GDS_RepMode;
      isec2[ 6] = 0;
      isec2[ 7] = 0;
      isec2[ 8] = 0;
      isec2[ 9] = 0;
      isec2[10] = 0;
      /*
      iret = decodeGDS_SH(gds, gdspos, isec0, isec2, imisng);
      */
    }
  else if ( ISEC2_GridType == GTYPE_TRIANGULAR )
    {
      ISEC2_TRI_NI2    = GDS_TRI_NI2;
      ISEC2_TRI_NI3    = GDS_TRI_NI3;
      ISEC2_TRI_ND     = GDS_TRI_ND;
      ISEC2_TRI_NI     = GDS_TRI_NI;
      ISEC2_TRI_AFlag  = GDS_TRI_AFlag;
      ISEC2_TRI_LatPP  = GDS_TRI_LatPP;
      ISEC2_TRI_LonPP  = GDS_TRI_LonPP;
      ISEC2_TRI_LonMPL = GDS_TRI_LonMPL;
      ISEC2_TRI_BFlag  = GDS_TRI_BFlag;
      /*
      iret = decodeGDS_TR(gds, gdspos, isec0, isec2, imisng);
      */
    }
  else
    Message(func, "Gridtype %d unsupported", ISEC2_GridType);

      /*    vertical coordinate parameters for hybrid levels.     */
      /*    get number of vertical coordinate parameters, if any. */

  ISEC2_NumVCP = 0;

  isec2[17] = 0;
  isec2[18] = 0;

  if ( VertCoorTab == TRUE )
    {
      if ( ISEC0_GRIB_Version  == 0 )
	{
	  locnv = 32;
	  ISEC2_NumVCP = (gdsLen - 32) >> 2;
	}
      else
	{
	  locnv = GDS_PVPL - 1;
	  ISEC2_NumVCP = GDS_NV;
	}
#if defined (SX)
      lGribLen = 4*ISEC2_NumVCP;	      
      lgrib    = (GRIBPACK *) malloc(lGribLen*sizeof(GRIBPACK));

      igrib = &gds[locnv];
      if ( ISEC2_NumVCP > 0 ) (void) UNPACK_GRIB(igrib, lgrib, lGribLen, -1L);
      for ( i = 0; i < ISEC2_NumVCP; i++ )
	{
	  iexp   = (lgrib[4*i  ]);
	  imant  =((lgrib[4*i+1]) << 16) +
	          ((lgrib[4*i+2]) <<  8) +
	           (lgrib[4*i+3]);
	  fsec2[10+i] = POW_2_M24 * imant * pow(16.0, (double)(iexp - 64));
	}

      free(lgrib);
#else
      for ( i = 0; i < ISEC2_NumVCP; i++ )
	{
	  iexp   = (gds[locnv+4*i  ]);
	  imant  =((gds[locnv+4*i+1]) << 16) +
	          ((gds[locnv+4*i+2]) <<  8) +
	           (gds[locnv+4*i+3]);
	  fsec2[10+i] = decfp2(iexp,imant);
	}
#endif
    }

  return (gdsLen);
}


int decodeBDS(int decscale, unsigned char *bds, int *isec2, int *isec4, double *fsec4, int fsec4len, int dfunc, int *iret)
{
  static char func[] = "decodeBDS";
  unsigned char *igrib;
  GRIBPACK *lgrib = NULL;
  int cplx, jup, kup, mup;
  int locnd;
  int jlend, jlenc;
  int i;
  int iflag, irep, lnil, jscale, imiss;
  int ioff;
  double fmin = 0., zscale = 0.;
  int iexp, imant;
  int pcStart, pcScale;
  double *fpdata = fsec4;
  extern double _pow2tab[158];

  int bdsLen;

  *iret = 0;
  igrib = bds;

  memset(isec4, 0, 42*sizeof(int));

  /* get length of binary data block. */

  bdsLen = BDS_Len;

  /* 4 bit flag / 4 bit count of unused bits at end of block octet. */

  iflag = BDS_Flag;

  /* 0------- grid point           */
  /* 1------- spherical harmonics  */

  irep  = iflag >> 7;

  if ( irep == 0 ) isec4[2] = 0;
  else             isec4[2] = 128;

  /* -0------  simple packing */
  /* -1------ complex packing */

  cplx  = (iflag >> 6) & 1;

  if ( cplx > 0 ) isec4[3] = 64;
  else            isec4[3] =  0;

  /* ----++++ number of unused bits at end of section) */

  lnil  = iflag & 15;
  
  /* scale factor (2 bytes) */;

  jscale = BDS_BinScale;

  /* check for missing data indicators. */

  iexp  = bds[ 6];
  imant = GET_UINT3(bds[ 7], bds[ 8], bds[ 9]);

  imiss = (jscale == 65535 && iexp == 255 && imant == 16777215);

  /* convert reference value and scale factor. */

  if ( imiss == 0 )
    {
      fmin = BDS_RefValue;

      if ( jscale < 0 )
	zscale = 1.0/_pow2tab[-jscale];
      else
	zscale = _pow2tab[jscale];

      if ( decscale )
	{
	  double scale;
	  scale = pow(10.0, - decscale);
	  fmin   *= scale;
	  zscale *= scale;
	}
    }

  /* get number of bits in each data value. */

  ISEC4_NumBits = BDS_NumBits;

  /* octet number of start of packed data */
  /* calculated from start of block 4 - 1 */

  locnd = 11;

  /* if data is in spherical harmonic form, distinguish   */
  /* between simple/complex packing (cplx = 0/1)          */

  if ( irep == 1 && cplx == 0 )
    {
      /*    no unpacked binary data present */

      jup = kup = mup = 0;

      /*    octet number of start of packed data */
      /*    calculated from start of block 4 - 1 */

      locnd = 15;

      /*    get real (0,0) coefficient in grib format and     */
      /*    convert to floating point.                        */

      if ( dfunc != 'J' )
	{
	  if ( imiss ) *fpdata++ = 0.0;
	  else         *fpdata++ = BDS_RealCoef;
	}
    }

  ioff = irep;

  if ( irep == 1 && cplx == 1 )
    {
      /*    scaling factor */
      isec4[16] = BDS_Power;

      /*    pentagonal resolution parameters of the */
      /*    unpacked section of data field          */

      jup = bds[15];
      kup = bds[16];
      mup = bds[17];

      isec4[17] = jup;
      isec4[18] = kup;
      isec4[19] = mup;

      /*    unpacked binary data */

      locnd = 18;

      if ( dfunc != 'J' )
	for (i = 0; i < ((jup+1)*(jup+2)); i++)
	  {
	    iexp   = (bds[locnd+4*i  ]);
	    imant  =((bds[locnd+4*i+1]) << 16) +
	            ((bds[locnd+4*i+2]) <<  8) +
                     (bds[locnd+4*i+3]);

	    if ( imiss ) *fpdata++ = 0.0;
	    else         *fpdata++ = decfp2(iexp,imant);
	  }
      locnd = 18 + 4*(jup+1)*(jup+2);
      ioff = (jup+1)*(jup+2);
    }

  /* decode data values to floating point and store in fsec4. */
  /* first calculate the number of data values.                */
  /* Take into account that spherical harmonics can be packed  */
  /* simple (cplx = 0) or complex (cplx = 1)                   */

  jlend = bdsLen - locnd;
  if ( ISEC4_NumBits == 0 )
    {
      if ( jlend > 1 )
	Error(func, "Number of bits per data value = 0");

      jlend = ISEC2_NumLon*ISEC2_NumLat;
    }
  else
    jlend = (jlend * 8 - lnil) / ISEC4_NumBits;


  ISEC4_NumValues        = jlend + ioff;
  ISEC4_NumNonMissValues = 0;

  if ( dfunc == 'J' ) return (bdsLen);

  /* check length of output array. */
  
  if ( ! (dfunc == 'J') )
    if ( jlend+ioff > fsec4len )
      {
	*iret = 710;
	gprintf(func, " Output array too small. Length = %d", fsec4len);
	gprintf(func, " Number of values = %d", jlend+ioff);
	gprintf(func, " Return code =  %d", *iret);
	return (0);
      }

  if ( imiss ) memset((char *)fpdata, 0, jlend*sizeof(double));
  else
    {
      igrib += locnd;
      jlenc = jlend * ISEC4_NumBits / 8;
      if ( ISEC4_NumBits ==  8 || ISEC4_NumBits == 16 ||
	   ISEC4_NumBits == 24 || ISEC4_NumBits == 32 )
	{
	  if ( jlenc > 0 ) 
	    {
	      lgrib = (GRIBPACK *) malloc(jlenc*sizeof(GRIBPACK));
	      if ( lgrib == NULL ) SysError(func, "No Memory!");

	      (void) UNPACK_GRIB(igrib, lgrib, jlenc, -1L);
	      /*
		for ( i = 0; i < jlenc; ++i ) lgrib[i] = (long) igrib[i];
	      */
	    }
	}

      if ( ISEC4_NumBits ==  0 )
	{
	  for ( i = 0; i < jlend; i++ )
	    fpdata[i] = fmin;
	}
      else if ( ISEC4_NumBits ==  8 )
         for ( i = 0; i < jlend; i++ )
	   {
             fpdata[i] = fmin + zscale * lgrib[i];
	   }
      else if ( ISEC4_NumBits == 16 )
         for ( i = 0; i < jlend; i++ )
	   {
             fpdata[i] = fmin + zscale *
                         ((lgrib[2*i  ] <<  8) +  lgrib[2*i+1]);
	   }
      else if ( ISEC4_NumBits == 24 )
         for ( i = 0; i < jlend; i++ )
	   {
             fpdata[i] = fmin + zscale *
                         ((lgrib[3*i  ] << 16) + (lgrib[3*i+1] <<  8) +
                           lgrib[3*i+2]);
	   }
      else if ( ISEC4_NumBits == 32 )
         for ( i = 0; i < jlend; i++ )
	   {
             fpdata[i] = fmin + zscale *
                         ((lgrib[4*i  ] << 24) + (lgrib[4*i+1] << 16) +
                          (lgrib[4*i+2] <<  8) +  lgrib[4*i+3]);
	   }
      else if ( ISEC4_NumBits <= 25 )
	{
	  unsigned char *bits = igrib;
	  unsigned int jmask;
	  int tbits = 0;
	  int n_bits = ISEC4_NumBits;
	  int t_bits = 0;
	  jmask = (1 << n_bits) - 1;
	  /* code from wgrib routine BDS_unpack */
	  for ( i = 0; i < jlend; i++ )
	    {
	      while ( t_bits < n_bits )
		{
		  tbits = (tbits * 256) + *bits++;
		  t_bits += 8;
                }
	      t_bits -= n_bits;
	      fpdata[i] = (tbits >> t_bits) & jmask;
            }
	  /* at least this vectorizes :) */
	  for ( i = 0; i < jlend; i++ )
	    fpdata[i] = fmin + zscale*fpdata[i];
	}
      else
	{
	  fprintf(stderr," Unimplemented packing factor %d\n", ISEC4_NumBits);
	  exit(EXIT_FAILURE);
	}
    }

  if ( lgrib ) free(lgrib);

  if ( irep == 1 && cplx == 1 )
    {
      pcStart = isec4[19];
      pcScale = isec4[16];
      scatterComplex(fsec4, pcStart, ISEC2_PentaJ, ISEC4_NumValues);
      scaleComplex(fsec4, pcStart, pcScale, ISEC2_PentaJ);
    }

  return (bdsLen);
}


void gribDecode(int *isec0, int *isec1, int *isec2, double *fsec2, int *isec3,
		double *fsec3, int *isec4, double *fsec4, int fsec4len, int *kgrib,
		int kleng, int *kword, int dfunc, int *iret)
{
  static char func[] = "gribDecode";
  UCHAR *is = NULL, *pds = NULL, *gds = NULL, *bms = NULL, *bds = NULL;
  int isLen = 0, pdsLen = 0, gdsLen = 0, bmsLen = 0, bdsLen = 0, esLen = 0;
  int gribLen = 0;
  int gdsIncluded = FALSE;
  int bmsIncluded = FALSE;
  int bitmapSize = 0;
  int ldebug = FALSE;
  int llarge = FALSE, l_iorj = FALSE;
  int lsect2 = FALSE, lsect3 = FALSE;
  int fsec4off;

  *iret = 0;

  grsdef();

  ISEC2_Reduced = FALSE;

  /*
    ----------------------------------------------------------------
    IS Indicator Section (Section 0)
    ----------------------------------------------------------------
  */
  is = (unsigned char *) &kgrib[0];

  isLen = decodeIS(is, isec0, iret);

  /*
    If count is negative, have to rescale by factor of -120.
    This is a fixup to get round the restriction on product lengths
    due to the count being only 24 bits. It is only possible because
    the (default) rounding for GRIB products is 120 bytes.
  */
  if (  ISEC0_GRIB_Len < 0 )
    {
      if ( ldebug )
	gprintf(func, "Special case, negative length multiplied by -120");
      llarge = TRUE;
      ISEC0_GRIB_Len *= (-120);
    }
  /*
    When decoding or calculating length, previous editions
    of the GRIB code must be taken into account.

    In the table below, covering sections 0 and 1 of the GRIB
    code, octet numbering is from the beginning of the GRIB
    message;
    * indicates that the value is not available in the code edition;
    R indicates reserved, should be set to 0;
    Experimental edition is considered as edition -1.

    GRIB code edition -1 has fixed length of 20 octets for
    section 1, the length not included in the message.
    GRIB code edition 0 has fixed length of 24 octets for
    section 1, the length being included in the message.
    GRIB code edition 1 can have different lengths for section
    1, the minimum being 28 octets, length being included in
    the message.

                                         Octet numbers for code
                                                  editions

                 Contents.                   -1      0      1
                 ---------                ----------------------
       Letters GRIB                          1-4    1-4    1-4
       Total length of GRIB message.          *      *     5-7
       GRIB code edition number               *      *      8
       Length of Section 1.                   *     5-7    9-11
       Reserved octet (R).                    *      8(R)   *
       Version no. of Code Table 2.           *      *     12
       Identification of centre.              5      9     13
       Generating process.                    6     10     14
       Grid definition .                      7     11     15
       Flag (Code Table 1).                   8     12     16
       Indicator of parameter.                9     13     17
       Indicator of type of level.           10     14     18
       Height, pressure etc of levels.      11-12  15-16  19-20
       Year of century.                      13     17     21
       Month.                                14     18     22
       Day.                                  15     19     23
       Hour.                                 16     20     24
       Minute.                               17     21     25
       Indicator of unit of time.            18     22     26
       P1 - Period of time.                  19     23     27
       P2 - Period of time                  20(R)   24     28
       or reserved octet (R).
       Time range indicator.                21(R)   25     29
       or reserved octet (R).
       Number included in average.       22-23(R)  26-27  30-31
       or reserved octet (R).
       Number missing from average.         24(R)  28(R)   32
       or reserved octet (R).
       Century of data.                       *      *     33
       Designates sub-centre if not 0.        *      *     34
       Decimal scale factor.                  *      *    35-36
       Reserved. Set to 0.                    *      *    37-48
       (Need not be present)
       For originating centre use only.       *      *    49-nn
       (Need not be present)

    Identify which GRIB code edition is being decoded.

    In GRIB edition 1, the edition number is in octet 8.
    In GRIB edition 0, octet 8 is reserved and set to 0.
    In GRIB edition -1, octet 8 is a flag field and can have a
    a valid value of 0, 1, 2 or 3.

    However, GRIB edition number 0 has a fixed
    length of 24, included in the message, for section 1, so
    if the value extracted from octets 5-7 is 24 and that from
    octet 8 is 0, it is safe to assume edition 0 of the code.

  */
  if ( ISEC0_GRIB_Len == 24 && ISEC0_GRIB_Version == 0 )
    {
      /*
	Set length of GRIB message to missing data value.
      */
      ISEC0_GRIB_Len = 0;
    }
  /*
    If Grib Edition 1 and only length is required, go to section 9.
  */
  if ( dfunc == 'L' ) goto LABEL900;

  /*
    ----------------------------------------------------------------
    PDS Product Definition Section (Section 1)
    ----------------------------------------------------------------
  */ 
  pds = is + isLen;

  pdsLen = decodePDS(pds, isec0, isec1);

  /*
    ----------------------------------------------------------------
    GDS Grid Description Section (Section 2)
    ----------------------------------------------------------------
  */
  gdsIncluded = ISEC1_Sec2Or3Flag & 128;

  if ( gdsIncluded )
    {
      gds = is + isLen + pdsLen;

      gdsLen = decodeGDS(gds, isec0, isec2, fsec2, dfunc);
    }

  /*
    ----------------------------------------------------------------
    BMS Bit-Map Section Section (Section 3)
    ----------------------------------------------------------------
  */ 
  bmsIncluded = ISEC1_Sec2Or3Flag & 64;

  isec3[0] = 0;
  if ( bmsIncluded )
    {
      bms = is + isLen + pdsLen + gdsLen;

      bmsLen = BMS_Len;
      bitmapSize = ((bmsLen - 6)<<3) - BMS_UnusedBits;
      /*
      fprintf(stderr," bitmapSize = %d\n", bitmapSize);
      */
    }

  /*
    ----------------------------------------------------------------
    BDS Binary Data Section (Section 4)
    ----------------------------------------------------------------
  */
  bds = is + isLen + pdsLen + gdsLen + bmsLen;

  bdsLen = decodeBDS(ISEC1_DecScaleFactor, bds, isec2, isec4, fsec4, fsec4len, dfunc, iret);

  if ( *iret != 0 ) return;

  if ( bitmapSize > 0 )
    {
      ISEC4_NumNonMissValues = ISEC4_NumValues;
      ISEC4_NumValues        = bitmapSize;

      if ( ! (dfunc == 'J') )
	{
	  int i, j;
	  GRIBPACK bitmap;
	  GRIBPACK *imask;

	  fsec4off = bitmapSize - ISEC4_NumNonMissValues;

	  /*
	  unsigned char *bitmap;
	  bitmap = BMS_Bitmap;
	  j = ISEC4_NumNonMissValues;
	  for ( i = ISEC4_NumValues-1; i >= 0; i-- )
	    {
	      if ( (bitmap[i/8]>>(7-(i&7)))&1 )
		fsec4[i] = fsec4[--j];
	      else
		fsec4[i] = FSEC3_MissVal;
	    }
	  */

	  imask = (GRIBPACK *) malloc(bitmapSize*sizeof(GRIBPACK));

	  (void) UNPACK_GRIB(BMS_Bitmap, imask, bitmapSize/8, -1L);

#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
	  for ( i = bitmapSize/8-1; i >= 0; i-- )
	    {
	      bitmap = imask[i];
	      imask[i*8+0] = 1 & (bitmap >> 7);
	      imask[i*8+1] = 1 & (bitmap >> 6);
	      imask[i*8+2] = 1 & (bitmap >> 5);
	      imask[i*8+3] = 1 & (bitmap >> 4);
	      imask[i*8+4] = 1 & (bitmap >> 3);
	      imask[i*8+5] = 1 & (bitmap >> 2);
	      imask[i*8+6] = 1 & (bitmap >> 1);
	      imask[i*8+7] = 1 & (bitmap);
	    }
	  /*
#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
	  for ( i = ISEC4_NumNonMissValues-1; i >= 0 ; i-- )
	    fsec4[fsec4off+i] = fsec4[i];
	  */
	  j = ISEC4_NumNonMissValues;

#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
	  for ( i = ISEC4_NumValues-1; i >= 0; i-- )
	    fsec4[i] = imask[i] ? fsec4[--j] : FSEC3_MissVal;

	  /*
	  for ( i = 0; i < ISEC4_NumValues; i++ )
	    fsec4[i] = imask[i] ? fsec4[fsec4off++] : FSEC3_MissVal;
	  */

	  free(imask);
	}
    }

  if ( dfunc == 'R' && ISEC2_Reduced )
    {
      double *ztemp;
      int  nlon, nlat;
      ISEC2_Reduced = 0;
      ISEC2_NumLon = ISEC2_NumLat*2;
      nlon = ISEC2_NumLon;
      nlat = ISEC2_NumLat;
      ISEC4_NumValues = nlon*nlat;

      ztemp = (double *) malloc(ISEC4_NumValues*sizeof(double));
      if ( ztemp == NULL ) SysError(func, "No Memory!");
      (void) qu2reg2(fsec4, ISEC2_RowLonPtr, nlat, nlon, ztemp, FSEC3_MissVal, iret);
      free(ztemp);

      if ( bitmapSize > 0 )
	{
	  int i, j = 0;

	  for ( i = 0; i < ISEC4_NumValues; i++ )
	    if ( fsec4[i] != FSEC3_MissVal ) j++;

	  ISEC4_NumNonMissValues = j;
	}
    }


  if ( ISEC0_GRIB_Version == 1 ) isLen = 8;
  esLen = 4;

  gribLen = isLen + pdsLen + gdsLen + bmsLen + bdsLen + esLen;

  if ( ISEC0_GRIB_Len )
    if ( gribLen != ISEC0_GRIB_Len )
      {
	Warning(func, "grib1Len = %d gribLen = %d", ISEC0_GRIB_Len, gribLen);
      }

  ISEC0_GRIB_Len = gribLen;

  *kword = gribLen / sizeof(int);
  if ( (size_t) gribLen != *kword * sizeof(int) ) *kword += 1;

  /*
    ----------------------------------------------------------------
    Section 9 . Abort/return to calling routine.
    ----------------------------------------------------------------
  */
 LABEL900:;

  if ( ldebug )
    {
      gprintf(func, "Section 9.");
      gprintf(func, "Output values set -");

      gribPrintSec0(isec0);
      gribPrintSec1(isec0, isec1);
      /*
	Print section 2 if present.
      */
      if ( lsect2 ) gribPrintSec2DP(isec0, isec2, fsec2);

      if ( ! l_iorj )
	{
	  /*
	    Print section 3 if present.
	  */
	  if ( lsect3 ) gribPrintSec3DP(isec0, isec3, fsec3);

	  gribPrintSec4DP(isec0, isec4, fsec4);
	  /*
	    Special print for 2D spectra wave field real values in
	    section 4
	  */
	  if ( (isec1[ 0] ==  140) && 
	       (isec1[ 1] ==   98) && 
	       (isec1[23] ==    1) && 
	       ((isec1[39] == 1045) || (isec1[39] == 1081))  && 
	       ((isec1[ 5] ==  250) || (isec1[ 5] ==  251)) )
	    gribPrintSec4Wave(isec4);
	}
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




int gribOpen(const char *filename, const char *mode)
{
  int fileID;

  fileID = fileOpen(filename, mode);

#if defined (__sun)
  if ( fileID != FILE_UNDEFID && tolower(*mode) == 'r' )
    {
      fileSetBufferType(fileID, FILE_TYPE_MMAP);
    }
#endif

  return (fileID);  
}

void gribClose(int fileID)
{
  fileClose(fileID);
}

off_t gribGetPos(int fileID)
{
  return (fileGetPos(fileID));
}

int gribCheckFiletype(int fileID)
{
  static char func[] = "gribCheckFiletype";
  int ierr;
  int found = 0;
  char buffer[4];

  if ( fileRead(fileID, buffer, 4) != 4 ) return(found);

  if ( strncmp(buffer, "GRIB", 4) == 0 )
    {
      found = 1;
      if ( GRB_Debug ) Message(func, "found GRIB file = %s", fileInqName(fileID));
    }
  else
    {
      long offset;

      ierr = gribFileSeek(fileID, &offset);
      fileRewind(fileID);
      if ( !ierr )
	{
	  found = 1;
	  if ( GRB_Debug ) Message(func, "found seek GRIB file = %s", fileInqName(fileID));
	}
    }

  return (found);
}

int gribFileSeek(int fileID, long *offset)
{
  /* position file pointer after GRIB */
  static char func[] = "gribFileSeek";
  int buffersize = 4096;
  unsigned char buffer[4096];
  int retry = 4096;
  int i;

  *offset = 0;

  buffer[0] = fileGetc(fileID);
  buffer[1] = fileGetc(fileID);
  buffer[2] = fileGetc(fileID);
  buffer[3] = fileGetc(fileID);
  /*
  fileRead(fileID, buffer, 4);
  */

  while ( retry-- )
    {
      for (i = 0; i < buffersize-4; i++)
	{
	  if (buffer[i  ] == 'G' && 
	      buffer[i+1] == 'R' &&
	      buffer[i+2] == 'I' &&
	      buffer[i+3] == 'B')
	    {
	      if ( GRB_Debug )
		Message(func, "record offset = %d", (int) *offset);
	      return (0);
	    }
	  else
	    {
	      if ( fileEOF(fileID) ) return (-1);
	      buffer[i+4] = fileGetc(fileID);
	      (*offset)++;
	    }
	}
      buffer[0] = buffer[i  ];
      buffer[1] = buffer[i+1];
      buffer[2] = buffer[i+2];
      buffer[3] = buffer[i+3];
    }

  if ( GRB_Debug )
    Message(func, "record offset = %d", (int) *offset);

  return (1);
}

int gribReadSize(int fileID)
{
  static char func[] = "gribReadSize";
  int gribversion, gribsize;
  off_t pos;

  pos = fileGetPos(fileID); 

  gribsize = (fileGetc(fileID) << 16) + (fileGetc(fileID) << 8) + fileGetc(fileID);

  gribversion = fileGetc(fileID);

  if ( gribsize == 24 )
    {
      if ( gribversion != 1 && gribversion != 2 ) gribversion = 0;
    }

  if ( GRB_Debug )
    Message(func, "gribversion = %d", gribversion);

  if ( gribversion == 0 )
    {
      int pdssize = 0, gdssize = 0, bmssize = 0, bdssize = 0;
      int issize = 4, essize = 4;
      int flag;

      pdssize = gribsize;
      fileSetPos(fileID, (off_t) 3, SEEK_CUR);
      if ( GRB_Debug )
	Message(func, "pdssize     = %d", pdssize);
      flag = fileGetc(fileID);
      if ( GRB_Debug )
	Message(func, "flag        = %d", flag);
  
      fileSetPos(fileID, (off_t) pdssize-8, SEEK_CUR);

      if ( flag & 128 )
	{
	  gdssize = (fileGetc(fileID) << 16) + (fileGetc(fileID) << 8) + fileGetc(fileID);
	  fileSetPos(fileID, (off_t) gdssize-3, SEEK_CUR);
	}
      if ( GRB_Debug )
	Message(func, "gdssize     = %d", gdssize);

      if ( flag & 64 )
	{
	  bmssize = (fileGetc(fileID) << 16) + (fileGetc(fileID) << 8) + fileGetc(fileID);
	  fileSetPos(fileID, (off_t) bmssize-3, SEEK_CUR);
	}
      if ( GRB_Debug )
	Message(func, "bmssize     = %d", bmssize);

      bdssize = (fileGetc(fileID) << 16) + (fileGetc(fileID) << 8) + fileGetc(fileID);

      if ( GRB_Debug )
	Message(func, "bdssize     = %d", bdssize);

      gribsize = issize + pdssize + gdssize + bmssize + bdssize + essize;
    }
  else if ( gribversion == 2 )
    {
      int i;
      /* we set gribsize the following way because it doesn't matter then
	 whether int is 4 or 8 bytes long - we don't have to care if the size
	 really fits: if it does not, the record can not be read at all */

      gribsize = 0;
      for ( i = 0; i < 8; i++ ) gribsize = (gribsize << 8) | fileGetc(fileID);
    }
  else if ( gribversion != 1 )
    {
      gribsize = 0;
      Error(func, "GRIB version %d unsupported!", gribversion);
    }

  if ( fileEOF(fileID) ) gribsize = 0;

  if ( GRB_Debug )
    Message(func, "gribsize    = %d", gribsize);

  fileSetPos(fileID, pos, SEEK_SET);

  return (gribsize);
}

int gribGetSize(int fileID)
{
  static char func[] = "gribGetSize";
  size_t recsize;
  long offset;
  int ierr;

  ierr = gribFileSeek(fileID, &offset); /* position file pointer after GRIB */
  if ( ierr > 0 ) Error(func, "GRIB record not found\n");
  if ( ierr == -1 )
    return (0);
  else if ( ierr == 1 )
    return (0);

  recsize = gribReadSize(fileID);

  if ( GRB_Debug )
    Message(func, "recsize = %d\n", recsize);

  fileSetPos(fileID, (off_t) -4, SEEK_CUR);

  return (recsize);
}

int gribRead(int fileID, unsigned char *buffer, size_t *buffersize)
{
  static char func[] = "gribRead";
  long offset;
  int ierr = 0;
  size_t nread, recsize, recsize0;

  ierr = gribFileSeek(fileID, &offset); /* position file pointer after GRIB */
  if ( ierr > 0 ) Error(func, "GRIB record not found\n");
  if ( ierr == -1 )
    {
      *buffersize = 0;
      return (-1);
    }
  else if ( ierr == 1 )
    {
      *buffersize = 0;
      return (-2);
    }

  recsize = gribReadSize(fileID);

  buffer[0] = 'G';
  buffer[1] = 'R';
  buffer[2] = 'I';
  buffer[3] = 'B';

  recsize0 = recsize;

  if ( recsize > *buffersize )
    {
      recsize = *buffersize;
      ierr = -3;
    }

  *buffersize = recsize0;

  nread = fileRead(fileID, &buffer[4], recsize-4);

  if ( nread != recsize-4 ) ierr = 1;

  return (ierr);
}

int gribWrite(int fileID, unsigned char *buffer, size_t buffersize)
{
  static char func[] = "gribWrite";
  int  nwrite = 0;

  if( (nwrite = fileWrite(fileID, buffer, buffersize)) != (int) buffersize )
    {
      perror(func);
      nwrite = -1;
    }

  return ((int) nwrite);
}


/* ============ */
/* scaleComplex */
/* ============ */

void scaleComplex(double *fpdata, int pcStart, int pcScale, int truncation)
{
  static char func[] = "scaleComplex";
  double power;
  double *scale = (double *) malloc((truncation+1)*sizeof(double));
  int  n, m;
  int  index;

  if ( scale == NULL ) SysError(func, "No Memory!");

  if ( pcScale < -10000 || pcScale > 10000 )
    {
      fprintf(stderr, " scaleComplex: Invalid power given %6d\n", pcScale);
      return;
   }

  /* Setup scaling factors = n(n+1)^^p for n = 1 to truncation */

  if ( pcScale == 0 ) return;

  power = (double) pcScale / 1000.;
  scale[0] = 1.0;

  for ( n = 1; n <= truncation; n++ )
    {
      if (pcScale != 1000)
         scale[n] = 1.0 / pow((double) (n*(n+1)), power);
      else
         scale[n] = 1.0 /     (double) (n*(n+1));
    }

  /* Scale the values */

  index = 0;

  for (m = 0; m < pcStart;     m++)
  for (n = m; n <= truncation; n++)
    {
      if ( n >= pcStart )
	{
          fpdata[index  ] *= scale[n];
          fpdata[index+1] *= scale[n];
	}
      index += 2;
    }

  for (m = pcStart; m <= truncation; m++)
  for (n = m;       n <= truncation; n++)
    {
      fpdata[index  ] *= scale[n];
      fpdata[index+1] *= scale[n];
      index += 2;
    }

  free(scale);
}

/* ============== */
/* ScatterComplex */
/* ============== */

void scatterComplex(double *fpdata, int pcStart, int truncation, int dimSP)
{
  static char func[] = "scatterComplex";
  double *fphelp = (double *) malloc(dimSP*sizeof(double));
  int  m, n;
  int  index, inext;

  if ( fphelp == NULL ) SysError(func, "No Memory!");

  index = inext = 0;

  for (m = 0; m <= pcStart;    m++)
  for (n = m; n <= truncation; n++)
    {
      if ( pcStart >= n )
	{
          fphelp[index  ] = fpdata[inext++];
          fphelp[index+1] = fpdata[inext++];
	}
      index += 2;
    }
  index = 0;
  for (m = 0; m <= truncation; m++)
  for (n = m; n <= truncation; n++)
    {
      if ( n > pcStart )
	{
	  fphelp[index  ] = fpdata[inext++];
	  fphelp[index+1] = fpdata[inext++];
	}
      index += 2;
    }
  for (m = 0; m < dimSP; m++) fpdata[m] = fphelp[m];

  free(fphelp);
}

void scm0(double *pdl, double *pdr, double *pfl, double *pfr, int klg)
{
  /* System generated locals */
  double r_1;

  /* Local variables */
  double zfac, zeps, zbeta;
  int jl;
  double zalpha;

  /* **** SCM0   - Apply SCM0 limiter to derivative estimates. */
  /* output: */
  /*   pdl   = the limited derivative at the left edge of the interval */
  /*   pdr   = the limited derivative at the right edge of the interval */
  /* inputs */
  /*   pdl   = the original derivative at the left edge */
  /*   pdr   = the original derivative at the right edge */
  /*   pfl   = function value at the left edge of the interval */
  /*   pfr   = function value at the right edge of the interval */
  /*   klg   = number of intervals where the derivatives are limited */

  /*  define constants */

  zeps = 1.0e-12;
  zfac = (1.0 - zeps) * 3.0;

  for ( jl = 0; jl < klg; ++jl )
    {
      if ( (r_1 = pfr[jl] - pfl[jl], fabs(r_1)) > zeps )
	{
	  zalpha = pdl[jl] / (pfr[jl] - pfl[jl]);
	  zbeta  = pdr[jl] / (pfr[jl] - pfl[jl]);
	  if ( zalpha <= 0.0 ) pdl[jl] = 0.0;
	  if ( zbeta  <= 0.0 ) pdr[jl] = 0.0;
	  if ( zalpha > zfac ) pdl[jl] = zfac * (pfr[jl] - pfl[jl]);
	  if ( zbeta  > zfac ) pdr[jl] = zfac * (pfr[jl] - pfl[jl]);
	}
      else
	{
	  pdl[jl] = 0.0;
	  pdr[jl] = 0.0;
	}
    }
} /* scm0 */

int rowina2(double *p, int ko, int ki, double *pw,
	    int kcode, double msval, int *kret)
{
  /* System generated locals */
  int pw_dim1, pw_offset, i_1;

  /* Local variables */
  double zwt1, zrdi, zpos;
  int jl, ip;
  double zdo, zwt;

  /* Parameter adjustments */
  --p;
  pw_dim1 = ko + 3;
  pw_offset = pw_dim1;
  pw -= pw_offset;

  /* **** ROWINA2 - Interpolation of row of values. */
  /*     Input Parameters. */
  /*     ----------------- */
  /*     P      - Row of values to be interpolated. */
  /*              Dimension must be at least KO. */
  /*     KO     - Number of values required. */
  /*     KI     - Number of values in P on input. */
  /*     PW     - Working array. */
  /*              Dimension must be at least (0:KO+2,3). */
  /*     KCODE  - Interpolation required. */
  /*              1 , linear. */
  /*              3 , cubic. */
  /*     PMSVAL - Value used for missing data indicator. */

  /*     Output Parameters. */
  /*     ------------------ */
  /*     P     - Now contains KO values. */
  /*     KRET  - Return code */
  /*             0, OK */
  /*             Non-zero, error */

  /*     Author. */
  /*     ------- */
  /*     J.D.Chambers    ECMWF     22.07.94 */

  /*     ********************************    */
  /*     Section 1.  Linear interpolation .. */
  /*     ********************************    */

  *kret = 0;

  if ( kcode == 1 )
    {
      /*    Move input values to work array */
      for ( jl = 1; jl <= ki; ++jl )
	pw[jl + pw_dim1] = p[jl];

      /*    Arrange wrap-around value in work array */
      pw[ki + 1 + pw_dim1] = p[1];

      /*    Set up constants to be used to figure out weighting for */
      /*    values in interpolation. */
      zrdi = (double) ki;
      zdo = 1.0 / (double) ko;

      /*    Loop through the output points */
      for ( jl = 1; jl <= ko; ++jl )
	{

	  /*    Calculate weight from the start of row */
	  zpos = (jl - 1) * zdo;
	  zwt = zpos * zrdi;

	  /*    Get the current array position(minus 1) from the weight - */
	  /*    note the implicit truncation. */
	  ip = (int) zwt;

	  /*    If the left value is missing, use the right value */
	  if (pw[ip + 1 + pw_dim1] == msval)
	    {
	      p[jl] = pw[ip + 2 + pw_dim1];
	    }
	  /*    If the right value is missing, use the left value */
	  else if (pw[ip + 2 + pw_dim1] == msval)
	    {
	      p[jl] = pw[ip + 1 + pw_dim1];
	    }
	  /*    If neither missing, interpolate ... */
	  else
	    {

	      /*       Adjust the weight to range (0.0 to 1.0) */
	      zwt -= ip;

	      /*       Interpolate using the weighted values on either side */
	      /*       of the output point position */
	      p[jl] = (1.0 - zwt) * pw[ip + 1 + pw_dim1] +
		zwt * pw[ip + 2 + pw_dim1];
	    }
	}

      /*     *******************************    */
      /*     Section 2.  Cubic interpolation .. */
      /*     *******************************    */

    }
  else if ( kcode == 3 )
    {
      i_1 = ki;
      for ( jl = 1; jl <= i_1; ++jl )
	{
          if ( p[jl] == msval )
	    {
	      fprintf(stderr," ROWINA2: ");
	      fprintf(stderr," Cubic interpolation not supported");
	      fprintf(stderr," for fields containing missing data.\n");
	      *kret = 1;
	      goto L900;
	    }
          pw[jl + pw_dim1] = p[jl];
	}
      pw[pw_dim1] = p[ki];
      pw[ki + 1 + pw_dim1] = p[1];
      pw[ki + 2 + pw_dim1] = p[2];
      i_1 = ki;
      for ( jl = 1; jl <= i_1; ++jl )
	{
          pw[jl + (pw_dim1 << 1)] =
	        - pw[jl - 1 + pw_dim1] / 3.0 -
	          pw[jl     + pw_dim1] * 0.5 +
	          pw[jl + 1 + pw_dim1] - pw[jl + 2 + pw_dim1] / 6.0;
          pw[jl + 1 + pw_dim1 * 3] =
                  pw[jl - 1 + pw_dim1] / 6.0 -
                  pw[jl     + pw_dim1] +
                  pw[jl + 1 + pw_dim1] * 0.5 +
                  pw[jl + 2 + pw_dim1] / 3.0;
	}

      scm0(&pw[(pw_dim1 << 1) + 1], &pw[pw_dim1 * 3 + 2],
	   &pw[pw_dim1 + 1], &pw[pw_dim1 + 2], ki);

      zrdi = (double) ki;
      zdo = 1.0 / (double) ko;
      for ( jl = 1; jl <= ko; ++jl )
	{
          zpos = (jl - 1) * zdo;
          zwt = zpos * zrdi;
          ip = (int) zwt + 1;
          zwt = zwt + 1.0 - ip;
          zwt1 = 1.0 - zwt;
          p[jl] = ((3.0 - zwt1 * 2.0) * pw[ip + pw_dim1] +
                  zwt * pw[ip + (pw_dim1 << 1)]) * zwt1 * zwt1 +
                  ((3.0 - zwt * 2.0) * pw[ip + 1 + pw_dim1] -
                  zwt1 * pw[ip + 1 + pw_dim1 * 3]) * zwt * zwt;
	}

    }
  else
    {
      /*    **************************************    */
      /*    Section 3.  Invalid interpolation code .. */
      /*    **************************************    */
      fprintf(stderr," ROWINA2:");
      fprintf(stderr," Invalid interpolation code = %2d\n",kcode);
      *kret = 2;
    }

L900:
    return 0;
} /* rowina2 */

int qu2reg2(double *pfield, int *kpoint, int klat, int klon,
	    double *ztemp, double msval, int *kret)
{
   static char func[] = "qu2reg2";

   /* System generated locals */
   int i_1, i_2;
   int kcode = 1;

   /* Local variables */
   int ilii, ilio, icode;
   double *zline = NULL;
   double zwork[1929];   /* was [643][3] */
   int iregno, iquano, j210, j220, j230, j240, j225;


   zline = (double *) malloc(klon*sizeof(double));
   if ( zline == NULL ) SysError(func, "No Memory!");

   /* Parameter adjustments */
   --pfield;
   --kpoint;

/* **** QU2REG - Convert quasi-regular grid data to regular. */
/*     Input Parameters. */
/*     ----------------- */
/*     PFIELD     - Array containing quasi-regular grid */
/*                  data. */
/*     KPOINT     - Array containing list of the number of */
/*                  points on each latitude (or longitude) of */
/*                  the quasi-regular grid. */
/*     KLAT       - Number of latitude lines */
/*     KLON       - Number of longitude lines */
/*     KCODE      - Interpolation required. */
/*                  1 , linear - data quasi-regular on */
/*                               latitude lines. */
/*                  3 , cubic -  data quasi-regular on */
/*                               latitude lines. */
/*                  11, linear - data quasi-regular on */
/*                               longitude lines. */
/*                  13, cubic -  data quasi-regular on */
/*                               longitude lines. */
/*     PMSVAL     - Value used for missing data indicator. */
/*     Output Parameters. */
/*     ------------------ */
/*     KRET       - return code */
/*                  0 = OK */
/*                  non-zero indicates fatal error */
/*     PFIELD     - Array containing regular grid data. */
/*     Author. */
/*     ------- */
/*     J.D.Chambers     ECMWF      22.07.94 */
/*     J.D.Chambers     ECMWF      13.09.94 */
/*     Add return code KRET and remove calls to ABORT. */


/* ------------------------------ */
/* Section 1. Set initial values. */
/* ------------------------------ */

   *kret = 0;

/* Check input parameters. */

   if (kcode != 1 && kcode != 3 && kcode != 11 && kcode != 13) {
      fprintf(stderr," QU2REG :");
      fprintf(stderr," Invalid interpolation type code = %2d\n",kcode);
      *kret = 1;
      goto L900;
   }

/* Set array indices to 0. */

   ilii = 0;
   ilio = 0;

/* Establish values of loop parameters. */

   if (kcode > 10) {

/*    Quasi-regular along longitude lines. */

      iquano = klon;
      iregno = klat;
      icode = kcode - 10;
   } else {

/*    Quasi-regular along latitude lines. */

      iquano = klat;
      iregno = klon;
      icode = kcode;
   }

/*     -------------------------------------------------------- */
/**    Section 2. Interpolate field from quasi to regular grid. */
/*     -------------------------------------------------------- */

   i_1 = iquano;
   for (j230 = 1; j230 <= i_1; ++j230) {

      if (iregno != kpoint[j230]) {

/*       Line contains less values than required,so */
/*       extract quasi-regular grid values for a line */

         i_2 = kpoint[j230];
         for (j210 = 1; j210 <= i_2; ++j210) {
            ++ilii;
            zline[j210 - 1] = pfield[ilii];
         }

/*       and interpolate this line. */

         rowina2(zline, iregno, kpoint[j230], zwork, icode, msval, kret);
         if (*kret != 0) goto L900;

/*       Add regular grid values for this line to the
         temporary array. */

         i_2 = iregno;
         for (j220 = 1; j220 <= i_2; ++j220) {
            ++ilio;
            ztemp[ilio - 1] = zline[j220 - 1];
         }

      } else {

/*       Line contains the required number of values, so add */
/*       this line to the temporary array. */

         i_2 = iregno;
         for (j225 = 1; j225 <= i_2; ++j225) {
            ++ilio;
            ++ilii;
            ztemp[ilio - 1] = pfield[ilii];
         }
      }
   }

/* Copy temporary array to user array. */

   i_1 = klon * klat;
   for (j240 = 1; j240 <= i_1; ++j240) {
      pfield[j240] = ztemp[j240 - 1];
   }

/* -------------------------------------------------------- */
/* Section 9. Return to calling routine. Format statements. */
/* -------------------------------------------------------- */

L900:

   free(zline);

   return 0;
} /* qu2reg2_ */


FILE *grprsm;
double fref;
double fmaxval;
int nfref;
int nfmaxval;
int nrnd;
int ndbg;
int nvck;
int nonoff;
int noabort;
int num2ok;
int next2o;
int nloc2o;
int nsubce;


void
grsdef(void)
{
  /*
C---->
C**** GRSDEF - Initial (default) setting of common area variables
C              for GRIBEX package.
C
C     Purpose.
C     --------
C
C     Sets initial values for common area variables for all
C     routines of GRIBEX package, if not already done.
C
C**   Interface.
C     ----------
C
C     CALL GRSDEF
C
C     Input Parameters.
C     -----------------
C
C     None.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Self-explanatory.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     See subroutine GRIBEX.
C
C     Comments.
C     ---------
C
C     None
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - March 1998.
C
C     Modifications.
C     --------------
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Add variable NSUBCE.
C     Use a static variable to determine if initialisation has already
C     been done. NUSER removed .
C     Reverse defaults for NEXT2O and NLOC2O, for consistency with
C     version 13.023 of software .
C
  */
  static char func[] = "grsdef";
  /*
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
  */
  char *hndbg, *hnvck;
  char *env_stream;
  static int lfirst = TRUE;

  if ( ! lfirst ) return;

  /*
    ----------------------------------------------------------------
    Section 1 . Set values, conditionally.
    ----------------------------------------------------------------
  */
  /*
    Common area variables have not been set. Set them.
    
    User supplied reference value.
  */
  fref   = 0.0;
  /*
    Reference value supplied by user flag. Set to off.
  */
  nfref  = 0;
  /*
    User supplied maximum value.
  */
  fmaxval   = 0.0;
  /*
    Maximum value supplied by user flag. Set to off.
  */
  nfmaxval  = 0;
  /*
    Set rounding to 120 bytes on.
  */
  nrnd   = 1;
  /*
    Set debug print off.
  */
  ndbg   = 0;
  
  hndbg = getenv("GRIBEX_DEBUG");
  if ( hndbg != NULL )
    {
      if ( !strncmp(hndbg, "ON", 2) )
        ndbg = 1;
      else if( *hndbg == '1')
        ndbg = 1;
      else if( *hndbg == '2')
        ndbg = 2;
      else
        ndbg = 0;
    }
  /*
    Set GRIB value checking on.
  */
  nvck   = 1;
  
  hnvck = getenv("GRIBEX_CHECK");
  if ( hnvck )
    {
      if ( !strncmp(hnvck, "OFF", 3) )
        nvck = 0;
      else
        nvck = 1;
    }
  /*
    See if output stream needs changing
  */
  grprsm = stdout;
  env_stream = getenv("GRPRS_STREAM");
  if ( env_stream )
    {
      if ( isdigit((int) env_stream[0]) )
	{
	  int unit;
	  unit = atoi(env_stream);
	  if ( unit < 1 || unit > 99 )
	    Warning(func, "Invalid number for GRPRS_STREAM: %d\n", unit);
	  else if ( unit == 2 )
	    grprsm = stderr;
	  else if ( unit == 6 )
	    grprsm = stdout;
	  else
	    {
	      char filename[] = "unit.00";
	      sprintf(filename, "%2.2d", unit);
	      grprsm = fopen(filename, "w");
	      if ( ! grprsm )
		SysError(func, "GRPRS_STREAM = %d", unit);
	    }
	}
      else
	{
	  if ( env_stream[0] )
	    {
	      grprsm = fopen(env_stream, "w");
	      if ( ! grprsm )
		SysError(func, "GRPRS_STREAM = %s", env_stream);
	    }
	}
    }
  /*
    Set P factor switch to default, user supplies the P factor.
  */
  nonoff = 0;
  /*
    Set abort flag to NO abort
  */
  noabort = 1;
  /*
    Mark common area values set by user.
  */
  lfirst = FALSE;
  /*
    Exhaustive use of all possible second-order packing methods
    for HOPER='K'. Set to off.
  */
  num2ok  = 0;
  /*
    Use of extended second-order packing methods for grid-point
    encoding (HOPER='C' and 'K'). Set to on.
  */
  next2o  = 1;
  /*
    Use of non-local second-order packing methods for grid-point
    encoding (HOPER='C' and 'K'). Set to on.
  */
  nloc2o  = 1;
  /*
    Use of (all valid) sub-centre values for ECMWF fields encoding .
    encoding. Set to off.
  */
  nsubce  = 0;
}

#undef  IsBigendian
#define IsBigendian()  ( u_byteorder.c[sizeof(long) - 1] )

/* pack 8-bit bytes from 64-bit words to a packed buffer */
/* same as : for ( int i = 0; i < bc; ++i ) cp[i] = (char) up[i]; */

long packInt64(INT64 *up, char *cp, long bc, long tc)
{
#if defined (CRAY)
  (void) _pack(up, cp, bc, tc);
#else
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  char *cp0;
  INT64 upi, *up0, *ip0, *ip1, *ip2, *ip3, *ip4, *ip5, *ip6, *ip7;
  long head, trail, inner, i, j;
  int ipack = sizeof(INT64);
  
  /* Bytes until first word boundary in destination buffer */

  head = ( (long) cp ) & (ipack-1);
  if ( head != 0 ) head = ipack - head;

  inner = bc - head;

  /* Trailing bytes which do not make a full word */

  trail = inner & (ipack-1);

  /* Number of bytes/words to be processed in fast loop */

  inner -= trail;
  inner /= ipack;

  ip0 = up + head;
  ip1 = ip0 + 1;
  ip2 = ip0 + 2;
  ip3 = ip0 + 3;
  ip4 = ip0 + 4;
  ip5 = ip0 + 5;
  ip6 = ip0 + 6;
  ip7 = ip0 + 7;

  up0 = (INT64 *) (cp + head);

  /* Here we should process any bytes until the first word boundary 
   * of our destination buffer 
   * That code is missing so far  because our output buffer is 
   * word aligned by FORTRAN 
   */

  j = 0;

  if ( IsBigendian() )
    {
#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
      for ( i = 0 ; i < inner ; i++ )
	{
	  upi =             (   ip0[j]         << 56 ) 
	                 |  ( ( ip1[j] & 255 ) << 48 )
	                 |  ( ( ip2[j] & 255 ) << 40 )
	                 |  ( ( ip3[j] & 255 ) << 32 )
	                 |  ( ( ip4[j] & 255 ) << 24 ) ;
	  up0[i] = upi   |  ( ( ip5[j] & 255 ) << 16 )
	                 |  ( ( ip6[j] & 255 ) <<  8 )
	                 |    ( ip7[j] & 255 ) ;
	  j += ipack;
	}
    }
  else
    {
      for ( i = 0 ; i < inner ; i++ )
	{
	  upi =             (   ip7[j]         << 56 ) 
	                 |  ( ( ip6[j] & 255 ) << 48 )
                         |  ( ( ip5[j] & 255 ) << 40 )
                         |  ( ( ip4[j] & 255 ) << 32 )
                         |  ( ( ip3[j] & 255 ) << 24 ) ;
	  up0[i] = upi   |  ( ( ip2[j] & 255 ) << 16 )
                         |  ( ( ip1[j] & 255 ) <<  8 )
                         |    ( ip0[j] & 255 ) ;
	  j += ipack;
	}
    }

  cp0 = (char *) ( up0 + inner );
  if ( trail > 0 )
    {
      up0[inner] = 0;
      for ( i = 0 ; i < trail ; i ++ )
	{
	  *cp0 = (char ) ip0[ipack*inner+i];
	  cp0++;
	}
    }

  if ( tc != -1 )
    {
      bc++;
      *cp0 = (char) tc;
    }
#endif
  return (bc);
}

/* unpack 8-bit bytes from a packed buffer with 64-bit words */
/* same as : for ( int i = 0; i < bc; ++i ) up[i] = (INT64) cp[i]; */

long
unpackInt64(unsigned char *cp, INT64 *up, long bc, long tc)
{
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  unsigned char *cp0;
  unsigned INT64 *up0;
  INT64 *ip0, *ip1, *ip2, *ip3, *ip4, *ip5, *ip6, *ip7;
  long head, trail, inner, i, j;
  long offset;
  int ipack = sizeof(INT64);

  /* Bytes until first word boundary in source buffer */

  head = ( (long) cp ) & (ipack-1);
  if ( head != 0 ) head = ipack - head;
  if ( head > bc ) head = bc;

  inner = bc - head;

  /* Trailing bytes which do not make a full word */
 
  trail = inner & (ipack-1);
 
  /* Number of bytes/words to be processed in fast loop */

  inner -= trail;
  inner /= ipack;

  ip0 = up + head;
  ip1 = ip0 + 1;
  ip2 = ip0 + 2;
  ip3 = ip0 + 3;
  ip4 = ip0 + 4;
  ip5 = ip0 + 5;
  ip6 = ip0 + 6;
  ip7 = ip0 + 7;

  up0 = (unsigned INT64 *) (cp + head);

  /* Process any bytes until the first word boundary 
   * of our source buffer 
   */
  for ( i = 0 ; i < head ; i++ ) up[i] = (INT64) cp[i];

  j = 0;

  if ( IsBigendian() )
    {
#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
      for ( i = 0 ; i < inner ; i++ )
	{
	  ip0[j] = (up0[i] >> 56) & 255;
	  ip1[j] = (up0[i] >> 48) & 255;
	  ip2[j] = (up0[i] >> 40) & 255;
	  ip3[j] = (up0[i] >> 32) & 255;
	  ip4[j] = (up0[i] >> 24) & 255;
	  ip5[j] = (up0[i] >> 16) & 255;
	  ip6[j] = (up0[i] >>  8) & 255;
	  ip7[j] = (up0[i])       & 255;

	  j += ipack;
	}
    }
  else
    {
      for ( i = 0 ; i < inner ; i++ )
	{
	  ip7[j] = (up0[i] >> 56) & 255;
	  ip6[j] = (up0[i] >> 48) & 255;
	  ip5[j] = (up0[i] >> 40) & 255;
	  ip4[j] = (up0[i] >> 32) & 255;
	  ip3[j] = (up0[i] >> 24) & 255;
	  ip2[j] = (up0[i] >> 16) & 255;
	  ip1[j] = (up0[i] >>  8) & 255;
	  ip0[j] = (up0[i])       & 255;

	  j += ipack;
	}
    }

  if ( trail > 0 )
    {
      offset = head + ipack*inner;
      cp0 = cp + offset;
      for ( i = 0 ; i < trail ; i++ ) up[i+offset] = (INT64) cp0[i];
    }
  /*
  if ( tc != -1 ) {
    bc++;
    *cp0 = (char) tc;
  }
  */
  return (bc);
}

/* pack 8-bit bytes from 32-bit words to a packed buffer */
/* same as : for ( int i = 0; i < bc; ++i ) cp[i] = (char) up[i]; */

#if  defined  (INT32)
long packInt32(INT32 *up, char *cp, long bc, long tc)
{
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  char *cp0;
  INT32 *up0, *ip0, *ip1, *ip2, *ip3;
  long head, trail, inner, i, j;
  int ipack = sizeof(INT32);
  
  /* Bytes until first word boundary in destination buffer */

  head = ( (long) cp ) & (ipack-1);
  if ( head != 0 ) head = ipack - head;

  inner = bc - head;

  /* Trailing bytes which do not make a full word */

  trail = inner & (ipack-1);

  /* Number of bytes/words to be processed in fast loop */

  inner -= trail;
  inner /= ipack;

  ip0 = up + head;
  ip1 = ip0 + 1;
  ip2 = ip0 + 2;
  ip3 = ip0 + 3;

  up0 = (INT32 *) (cp + head);

  /* Here we should process any bytes until the first word boundary 
   * of our destination buffer 
   * That code is missing so far  because our output buffer is 
   * word aligned by FORTRAN 
   */

  j = 0;

  if ( IsBigendian() )
    {
#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
      for ( i = 0 ; i < inner ; i++ )
	{
	  up0[i] =          (   ip0[j]         << 24 ) 
	                 |  ( ( ip1[j] & 255 ) << 16 )
	                 |  ( ( ip2[j] & 255 ) <<  8 )
	                 |    ( ip3[j] & 255 ) ;
	  j += ipack;
	}
    }
  else
    {
      for ( i = 0 ; i < inner ; i++ )
	{
	  up0[i] =          (   ip3[j]         << 24 ) 
	                 |  ( ( ip2[j] & 255 ) << 16 )
                         |  ( ( ip1[j] & 255 ) <<  8 )
                         |    ( ip0[j] & 255 ) ;
	  j += ipack;
	}
    }

  cp0 = (char *) ( up0 + inner );
  if ( trail > 0 )
    {
      up0[inner] = 0;
      for ( i = 0 ; i < trail ; i ++ )
	{
	  *cp0 = (char ) ip0[ipack*inner+i];
	  cp0++;
	}
    }

  if ( tc != -1 )
    {
      bc++;
      *cp0 = (char) tc;
    }

  return (bc);
}
#endif

/* unpack 8-bit bytes from a packed buffer with 32-bit words */
/* same as : for ( int i = 0; i < bc; ++i ) up[i] = (INT32) cp[i]; */

#if  defined  (INT32)
long unpackInt32(unsigned char *cp, INT32 *up, long bc, long tc)
{
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  unsigned char *cp0;
  unsigned INT32 *up0;
  INT32 *ip0, *ip1, *ip2, *ip3;
  long head, trail, inner, i, j;
  long offset;
  int ipack = sizeof(INT32);

  /* Bytes until first word boundary in source buffer */

  head = ( (long) cp ) & (ipack-1);
  if ( head != 0 ) head = ipack - head;
  if ( head > bc ) head = bc;

  inner = bc - head;

  /* Trailing bytes which do not make a full word */
 
  trail = inner & (ipack-1);
 
  /* Number of bytes/words to be processed in fast loop */

  inner -= trail;
  inner /= ipack;

  ip0 = up + head;
  ip1 = ip0 + 1;
  ip2 = ip0 + 2;
  ip3 = ip0 + 3;

  up0 = (unsigned INT32 *) (cp + head);

  /* Process any bytes until the first word boundary 
   * of our source buffer 
   */
  for ( i = 0 ; i < head ; i++ ) up[i] = (INT32) cp[i];

  j = 0;

  if ( IsBigendian() )
    {
#if defined (CRAY)
#pragma _CRI ivdep
#endif
#if defined (SX)
#pragma vdir nodep
#endif
#ifdef __uxpch__
#pragma loop novrec
#endif
      for ( i = 0 ; i < inner ; i++ )
	{
	  ip0[j] = (up0[i] >> 24) & 255;
	  ip1[j] = (up0[i] >> 16) & 255;
	  ip2[j] = (up0[i] >>  8) & 255;
	  ip3[j] = (up0[i])       & 255;

	  j += ipack;
	}
    }
  else
    {
      for ( i = 0 ; i < inner ; i++ )
	{
	  ip3[j] = (up0[i] >> 24) & 255;
	  ip2[j] = (up0[i] >> 16) & 255;
	  ip1[j] = (up0[i] >>  8) & 255;
	  ip0[j] = (up0[i])       & 255;

	  j += ipack;
	}
    }

  if ( trail > 0 )
    {
      offset = head + ipack*inner;
      cp0 = cp + offset;
      for ( i = 0 ; i < trail ; i++ ) up[i+offset] = (INT32) cp0[i];
    }
  /*
  if ( tc != -1 ) {
    bc++;
    *cp0 = (char) tc;
  }
  */
  return (bc);
}
#endif

void prtbin(int kin, int knbit, int *kout, int *kerr)
{
  /*

    Produces a decimal number with ones and zeroes
    corresponding to the ones and zeroes of the input
    binary number.
    eg input number 1011 binary, output number 1011 decimal.


    Input Parameters:
    
       kin   - Integer variable containing binary number.

       knbit - Number of bits in binary number.

    Output Parameters:

       kout  - Integer variable containing decimal value
               with ones and zeroes corresponding to those of
	       the input binary number.

       kerr  - 0, If no error.
               1, Number of bits in binary number exceeds
	          maximum allowed or is less than 1.


    Converted from EMOS routine PRTBIN.

       Uwe Schulzweida   MPIfM   01/04/2001

  */
  int idec;
  int ik;
  int itemp;
  int j;

  /*
    Check length of binary number to ensure decimal number
    generated will fit in the computer word - in this case will
    it fit in a Cray 48 bit integer?
  */
  if ( knbit < 1 || knbit > 14 )
    {
      *kerr = 1;
      printf(" prtbin : Error in binary number length - %3d bits.\n", knbit);
      return;
    }
  else
    *kerr = 0;
  /*
    -----------------------------------------------------------------
    Section 1. Generate required number.
    -----------------------------------------------------------------
  */
  *kout = 0;
  ik    = kin;
  idec  = 1;

  for ( j = 0; j < knbit; j++ )
    {
      itemp = ik - ( (ik/2)*2 );
      *kout = (*kout) + itemp * idec;
      ik    = ik / 2;
      idec  = idec * 10;
    }

  return;
}


void ref2ibm(double *pref, int kbits)
{
  /*

    Purpose:
    --------

    Code and check reference value in IBM format

    Input Parameters:
    -----------------

    pref       - Reference value
    kbits      - Number of bits per computer word.

    Output Parameters:
    ------------------

    pref       - Reference value

    Method:
    -------

    Codes in IBM format, then decides to ensure that reference 
    value used for packing is not different from that stored
    because of packing differences.

    Externals.
    ----------

    confp3    - Encode into IBM floating point format.
    decfp2    - Decode from IBM floating point format.

    Reference:
    ----------

    None.

    Comments:
    --------

    None.

    Author:
    -------

    J.D.Chambers     ECMWF      17:05:94

    Modifications:
    --------------

    Uwe Schulzweida   MPIfM   01/04/2001

    Convert to C from EMOS library version 130

  */

  static char func[] = "ref2ibm";
  static int itrnd;
  static int kexp, kmant;
  static double ztemp, zdumm;
  extern int GRB_Debug;

  /* ----------------------------------------------------------------- */
  /*   Section 1. Convert to and from IBM format.                      */
  /* ----------------------------------------------------------------- */

  /*  Convert floating point reference value to IBM representation. */

  itrnd = 1;
  zdumm = ztemp = *pref;
  confp3(zdumm, &kexp, &kmant, kbits, itrnd);

  if ( kexp == 0 && kmant == 0 ) return;

  /*  Set reference value to that actually stored in the GRIB code. */

  *pref = decfp2(kexp, kmant);

  /*  If the nearest number which can be represented in */
  /*  GRIB format is greater than the reference value,  */
  /*  find the nearest number in GRIB format lower      */
  /*  than the reference value.                         */

  if ( ztemp < *pref )
    {
      /*  Convert floating point to GRIB representation */
      /*  using truncation to ensure that the converted */
      /*  number is smaller than the original one.      */

      itrnd = 0;
      zdumm = *pref = ztemp;
      confp3(zdumm, &kexp, &kmant, kbits, itrnd);

      /*  Set reference value to that stored in the GRIB code. */

      *pref = decfp2(kexp, kmant);

      if ( ztemp < *pref )
	{
	  if ( GRB_Debug )
	    {
	      Message(func, "Reference value error.");
	      Message(func, "Notify Met.Applications Section.");
	      Message(func, "ZTEMP = ", ztemp);
	      Message(func, "PREF = ", pref);
	    }
	  *pref = ztemp;
	}
    }

  return;
} /* ref2ibm */


int gribSections(unsigned char *gribbuffer, long recsize, unsigned char **pdsp, unsigned char **gdsp,
		 unsigned char **bmsp, unsigned char **bdsp)
{
  unsigned char *pds, *gds, *bms, *bds;
  unsigned char *bufpointer, *is;
  int gribversion, grib1offset;
  long gribsize = 0;

  is = gribbuffer;
  if ( is[0] != 'G' || is[1] != 'R' || is[2] != 'I' || is[3] != 'B' )
    {
      fprintf(stderr, "wrong indicator section >%c%c%c%c<\n",
		 is[0], is[1], is[2], is[3]);
      return (-1);
    }

  gribversion = IS_GRIB_Version;
  if ( IS_GRIB_Len == 24 && gribversion == 0 ) gribversion = 0;

  if ( gribversion == 1 )
    grib1offset = 4;
  else
    grib1offset = 0;

  pds = is + 4 + grib1offset;
  bufpointer = pds + PDS_Len;
  gribsize += 4 + grib1offset + PDS_Len;

  if ( PDS_HAS_GDS )
    {
      gds = bufpointer;
      bufpointer += GDS_Len;
      gribsize += GDS_Len;
    }
  else
    {
      gds = NULL;
    }

  if ( PDS_HAS_BMS )
    {
      bms = bufpointer;
      bufpointer += BMS_Len;
      gribsize += BMS_Len;
    }
  else
    {
      bms = NULL;
    }

  bds = bufpointer;
  bufpointer += BDS_Len;
  gribsize += BDS_Len;
  gribsize += 4;
  if ( gribsize > recsize )
    {
      fprintf(stderr, "GRIB buffer size %ld to small! Min size = %ld\n", recsize, gribsize);
      return (1);
    }

  *pdsp = pds;
  *gdsp = gds;
  *bmsp = bms;
  *bdsp = bds;

  /* end section - "7777" in ascii */
  if ( bufpointer[0] != 0x37 || bufpointer[1] != 0x37 ||
       bufpointer[2] != 0x37 || bufpointer[3] != 0x37 )
    {
      fprintf(stderr, "Missing end section >%2x %2x %2x %2x<\n",
	      bufpointer[0], bufpointer[1], bufpointer[2], bufpointer[3]);
    }

  return (0);
}

int gribGinfo(long recpos, long recsize, unsigned char *gribbuffer,
	      int *intnum, float *fltnum)
{
  unsigned char *pds, *gds, *bms, *bds;
  unsigned char *bufpointer, *is;
  int gribversion, grib1offset;
  long gribsize = 0;
  int dpos, bpos = 0;
  float bsf;

  is = gribbuffer;
  if ( is[0] != 'G' || is[1] != 'R' || is[2] != 'I' || is[3] != 'B' )
    {
      fprintf(stderr, "wrong indicator section >%c%c%c%c<\n",
		 is[0], is[1], is[2], is[3]);
      return (-1);
    }

  gribversion = IS_GRIB_Version;
  if ( IS_GRIB_Len == 24 && gribversion == 0 ) gribversion = 0;

  if ( gribversion == 1 )
    grib1offset = 4;
  else
    grib1offset = 0;

  pds = is + 4 + grib1offset;
  bufpointer = pds + PDS_Len;
  gribsize += 4 + grib1offset + PDS_Len;

  if ( PDS_HAS_GDS )
    {
      gds = bufpointer;
      bufpointer += GDS_Len;
      gribsize += GDS_Len;
    }
  else
    {
      gds = NULL;
    }

  if ( PDS_HAS_BMS )
    {
      bms = bufpointer;
      bufpointer += BMS_Len;

      bpos = recpos + gribsize + 6;

      gribsize += BMS_Len;
    }
  else
    {
      bms = NULL;
    }

  bds = bufpointer;
  bufpointer += BDS_Len;

  dpos = recpos + gribsize + 11;

  gribsize += BDS_Len;
  gribsize += 4;
  if ( gribsize > recsize )
    {
      fprintf(stderr, "GRIB buffer size %ld to small! Min size = %ld\n", recsize, gribsize);
      return (1);
    }

  /* end section - "7777" in ascii */
  if ( bufpointer[0] != 0x37 || bufpointer[1] != 0x37 ||
       bufpointer[2] != 0x37 || bufpointer[3] != 0x37 )
    {
      fprintf(stderr, "Missing end section >%2x %2x %2x %2x<\n",
	      bufpointer[0], bufpointer[1], bufpointer[2], bufpointer[3]);
    }

  bsf = BDS_BinScale;
  if ( bsf > 32767 ) bsf = 32768-bsf;
  bsf = pow(2.0,(double)bsf);

  intnum[0] = dpos;
  if ( bms ) intnum[1] = bpos;
  else       intnum[1] = -999;
  intnum[2] = BDS_NumBits;
  fltnum[0] = 1.0;
  fltnum[1] = bsf;
  fltnum[2] = BDS_RefValue;
  /*
  printf("intnum %d %d %d\n", intnum[0], intnum[1], intnum[2]);
  printf("fltnum %g %g %g\n", fltnum[0], fltnum[1], fltnum[2]);
  */
  return (0);
}

void gribPrintALL(int nrec, long offset, long recpos, long recsize, unsigned char *gribbuffer)
{
  static int header = 1;
  int GridType, level, nerr;
  unsigned char *is = NULL, *pds = NULL, *gds = NULL, *bms = NULL, *bds = NULL;

  if ( header )
    {
      fprintf(stdout, 
      "  Rec : Off Position   Size : V PDS  GDS    BMS    BDS : Code Level :  LType GType\n");
/*     ----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8----+ */
      header = 0;
    }

  is = gribbuffer;

  nerr = gribSections(gribbuffer, recsize, &pds, &gds, &bms, &bds);

  if ( nerr )
    {
      fprintf(stdout, "%5d :%4ld%9ld%7ld : error\n", nrec, offset, recpos, recsize);
      return;
    }

  if ( gds == NULL )
    GridType = -1;
  else
    GridType = GDS_GridType;

  if ( PDS_LevelType == 100 )
    level = PDS_Level * 100;
  else if ( PDS_LevelType == 99 )
    level = PDS_Level;
  else if ( PDS_LevelType == 109 )
    level = PDS_Level;
  else
    level = PDS_Level1;

  fprintf(stdout, "%5d :%4ld%9ld%7ld :%2d%4d%5d%7d%7d : %3d%7d : %5d %5d\n",
	  nrec, offset, recpos, recsize, IS_GRIB_Version,
	  PDS_Len, GDS_Len, BMS_Len, BDS_Len,
	  PDS_Parameter, level, PDS_LevelType, GridType);
}

void gribPrintPDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer)
{
  static int header = 1;
  unsigned char *is = NULL, *pds = NULL, *gds = NULL, *bms = NULL, *bds = NULL;
  int century, subcenter, decimalscale, nerr;

  if ( header )
    {
      fprintf(stdout, 
      "  Rec : PDS Tab Cen Sub Ver Grid Code LTyp Level1 Level2    Date  Time P1 TU TR NAVE Scale\n");
/*     ----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8----+ */
      header = 0;
    }

  is = gribbuffer;

  nerr = gribSections(gribbuffer, recsize, &pds, &gds, &bms, &bds);

  if ( nerr )
    {
      fprintf(stdout, "%5d : error\n", nrec);
      return;
    }

  switch(IS_GRIB_Version)
    {   
    case 0:
      century             = 1;
      subcenter           = 0;
      decimalscale        = 0;
      break;
    case 1:
      century             = PDS_Century;
      subcenter           = PDS_Subcenter;
      decimalscale        = PDS_DecimalScale;
      break;
    default:
      fprintf(stderr, "Grib version %d not supported!", IS_GRIB_Version);
      exit(EXIT_FAILURE);
    }

  fprintf(stdout, "%5d :%4d%4d%4d%4d%4d %4d %4d%4d%7d%7d %8d%6d%3d%3d%3d%5d%6d\n", nrec,
	  PDS_Len,  PDS_CodeTable,   PDS_CenterID, subcenter, PDS_ModelID,
	  PDS_GridDefinition, PDS_Parameter, PDS_LevelType, PDS_Level1, PDS_Level2,
	  PDS_Date, PDS_Time, PDS_TimePeriod1, PDS_TimeUnit, PDS_TimeRange,
	  PDS_AvgNum, decimalscale);
}

void gribPrintGDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer)
{
  static int header = 1;
  int nerr;
  unsigned char *pds = NULL, *gds = NULL, *bms = NULL, *bds = NULL;

  if ( header )
    {
      fprintf(stdout, 
      "  Rec : GDS  NV PVPL Typ : xsize ysize   Lat1   Lon1   Lat2   Lon2    dx    dy\n");
/*     ----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8----+ */
      header = 0;
    }

  nerr = gribSections(gribbuffer, recsize, &pds, &gds, &bms, &bds);

  if ( nerr )
    {
      fprintf(stdout, "%5d : error\n", nrec);
      return;
    }

  if ( gds )
    fprintf(stdout, "%5d :%4d%4d%4d %4d :%6d%6d%7d%7d%7d%7d%6d%6d\n", nrec,
	    GDS_Len,  GDS_NV,   GDS_PVPL, GDS_GridType,
	    GDS_NumLon,   GDS_NumLat,
	    GDS_FirstLat, GDS_FirstLon,
	    GDS_LastLat,  GDS_LastLon,
	    GDS_LonIncr,  GDS_LatIncr);
  else
    fprintf(stdout, "%5d : Grid Description Section not defined\n", nrec);
}


void gribPrintBMS(int nrec, long recpos, long recsize, unsigned char *gribbuffer)
{
  static int header = 1;
  int level, nerr;
  unsigned char *pds = NULL, *gds = NULL, *bms = NULL, *bds = NULL;

  if ( header )
    {
      fprintf(stdout, 
      "  Rec : Code Level     BMS    Size\n");
/*     ----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8----+ */
      header = 0;
    }

  nerr = gribSections(gribbuffer, recsize, &pds, &gds, &bms, &bds);

  if ( nerr )
    {
      fprintf(stdout, "%5d : error\n", nrec);
      return;
    }

  if ( PDS_LevelType == 100 )
    level = PDS_Level * 100;
  else if ( PDS_LevelType == 99 )
    level = PDS_Level;
  else
    level = PDS_Level1;

  if ( bms )
    fprintf(stdout, "%5d :%4d%7d %7d %7d\n", nrec,
	    PDS_Parameter, level,
	    BMS_Len, BMS_BitmapSize);
  else
    fprintf(stdout, "%5d :%4d%7d Bit Map Section not defined\n", nrec,
	    PDS_Parameter, level);
}

void gribPrintBDS(int nrec, long recpos, long recsize, unsigned char *gribbuffer)
{
  static int header = 1;
  int level, nerr;
  unsigned char *pds = NULL, *gds = NULL, *bms = NULL, *bds = NULL;

  if ( header )
    {
      fprintf(stdout, 
      "  Rec : Code Level     BDS Flag Scale  RefValue Bits\n");
/*     ----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8----+ */
      header = 0;
    }

  nerr = gribSections(gribbuffer, recsize, &pds, &gds, &bms, &bds);

  if ( nerr )
    {
      fprintf(stdout, "%5d : error\n", nrec);
      return;
    }

  if ( PDS_LevelType == 100 )
    level = PDS_Level * 100;
  else if ( PDS_LevelType == 99 )
    level = PDS_Level;
  else
    level = PDS_Level1;

  fprintf(stdout, "%5d :%4d%7d %7d %4d%5d%11.5g%4d \n", nrec,
	  PDS_Parameter, level,
	  BDS_Len, BDS_Flag,
	  BDS_BinScale, BDS_RefValue, BDS_NumBits);
}
char *LIBGRIB = "0.6.0" " of ""Apr  1 2005"" ""19:51:54";







static const char grb_libvers[] = "0.6.0" " of ""Apr  1 2005"" ""19:51:54";





const char *
gribLibraryVersion(void)
{
  return (grb_libvers);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif



void swap4byte(void *ptr, size_t size)
{
  static char func[] = "swap4byte";
  INT32 *ptrtmp;
  int nval;

  nval = size;
  if ( nval < 0 ) nval = 0;
  ptrtmp = (INT32 *) ptr;

  if ( sizeof(INT32) == 4 )
    {
      while ( nval-- )
	{
	  *ptrtmp = (((*ptrtmp >> 24) & 0x00ff) | ((*ptrtmp & 0x00ff) << 24) |
		     ((*ptrtmp >>  8) & 0xff00) | ((*ptrtmp & 0xff00) <<  8));
	  ptrtmp++;
	}
    }
  else
    {
      Error(func, "not implemented for %d byte data", sizeof(INT32));
    }
}

void swap8byte(void *ptr, size_t size)
{
  static char func[] = "swap8byte";
  INT64 *ptrtmp;
  int nval;

  nval = size;
  if ( nval < 0 ) nval = 0;
  ptrtmp = (INT64 *) ptr;

  if ( sizeof(INT64) == 8 )
    {
      while ( nval-- )
	{
	  *ptrtmp = (((*ptrtmp >> 56) & 0x000000ff) | ((*ptrtmp & 0x000000ff) << 56) |
		     ((*ptrtmp >> 40) & 0x0000ff00) | ((*ptrtmp & 0x0000ff00) << 40) |
		     ((*ptrtmp >> 24) & 0x00ff0000) | ((*ptrtmp & 0x00ff0000) << 24) |
		     ((*ptrtmp >>  8) & 0xff000000) | ((*ptrtmp & 0xff000000) <<  8));
	  ptrtmp++;
	}
    }
  else
    {
      Error(func, "not implemented for %d byte data", sizeof(INT64));
    }
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif


size_t
binReadF77Block(int fileID, int byteswap)
{
  unsigned char f77block[4];
  size_t blocklen;

  fileRead(fileID, f77block, 4);

  if ( byteswap )
    blocklen = get_SUINT32(f77block);
  else
    blocklen =  get_UINT32(f77block);

  return (blocklen);
}

#undef  IsBigendian
#define IsBigendian()  ( u_byteorder.c[sizeof(long) - 1] )

void
binWriteF77Block(int fileID, int byteswap, size_t blocksize)
{
  static char func[] = "binWriteF77Block";
  static union {unsigned long l; unsigned char c[sizeof(long)];} u_byteorder = {1};
  unsigned char f77block[4];

  if ( IsBigendian() )
    {
      if ( byteswap )
	{
	  f77block[0] = (unsigned char) (blocksize);
	  f77block[1] = (unsigned char) (blocksize >>  8);
	  f77block[2] = (unsigned char) (blocksize >> 16);
	  f77block[3] = (unsigned char) (blocksize >> 24);
	}
      else
	{
	  f77block[3] = (unsigned char) (blocksize);
	  f77block[2] = (unsigned char) (blocksize >>  8);
	  f77block[1] = (unsigned char) (blocksize >> 16);
	  f77block[0] = (unsigned char) (blocksize >> 24);
	}
    }
  else
    {
      if ( byteswap )
	{
	  f77block[3] = (unsigned char) (blocksize);
	  f77block[2] = (unsigned char) (blocksize >>  8);
	  f77block[1] = (unsigned char) (blocksize >> 16);
	  f77block[0] = (unsigned char) (blocksize >> 24);
	}
      else
	{
	  f77block[0] = (unsigned char) (blocksize);
	  f77block[1] = (unsigned char) (blocksize >>  8);
	  f77block[2] = (unsigned char) (blocksize >> 16);
	  f77block[3] = (unsigned char) (blocksize >> 24);
	}
    }

  if ( fileWrite(fileID, f77block, 4) != 4 )
    Error(func, "write failed on %s", fileInqName(fileID));
}

int
binReadInt32(int fileID, int byteswap, size_t size, INT32 *ptr)
{
  static char func[] = "binReadInt32";

  if ( sizeof(INT32) == 4 )
    {
      fileRead(fileID, (void *) ptr, 4*size);
      if ( byteswap ) swap4byte(ptr, size);
    }
  else
    {
      Error(func, "not implemented for %d byte integer", sizeof(INT32));
    }

  return (0);
}

int
binReadInt64(int fileID, int byteswap, size_t size, INT64 *ptr)
{
  static char func[] = "binReadInt64";

  if ( sizeof(INT64) == 8 )
    {
      fileRead(fileID, (void *) ptr, 8*size);
      if ( byteswap ) swap8byte(ptr, size);
    }
  else
    {
      Error(func, "not implemented for %d byte integer", sizeof(INT64));
    }

  return (0);
}

int
binReadReal4(int fileID, int byteswap, size_t size, REAL4 *ptr)
{
  static char func[] = "binReadReal4";

  if ( sizeof(REAL4) == 4 )
    {
      fileRead(fileID, (void *) ptr, 4*size);
      if ( byteswap ) swap4byte(ptr, size);
    }
  else
    {
      Error(func, "not implemented for %d byte float", sizeof(REAL4));
    }

  return (0);
}

int
binReadReal8(int fileID, int byteswap, size_t size, REAL8 *ptr)
{
  static char func[] = "binReadReal8";

  if ( sizeof(REAL8) == 8 )
    {
      fileRead(fileID, (void *) ptr, 8*size);
      if ( byteswap ) swap8byte(ptr, size);
    }
  else
    {
      Error(func, "not implemented for %d byte float", sizeof(REAL8));
    }

  return (0);
}

int
binWriteInt32(int fileID, int byteswap, size_t size, INT32 *ptr)
{
  static char func[] = "binWriteInt32";

  if ( sizeof(INT32) == 4 )
    {
      if ( byteswap ) swap4byte(ptr, size);
      fileWrite(fileID, (void *) ptr, 4*size);
    }
  else
    {
      Error(func, "not implemented for %d byte integer", sizeof(INT32));
    }

  return (0);
}

int
binWriteInt64(int fileID, int byteswap, size_t size, INT64 *ptr)
{
  static char func[] = "binWriteInt64";

  if ( sizeof(INT64) == 8 )
    {
      if ( byteswap ) swap8byte(ptr, size);
      fileWrite(fileID, (void *) ptr, 8*size);
    }
  else
    {
      Error(func, "not implemented for %d byte integer", sizeof(INT64));
    }

  return (0);
}

int
binWriteReal4(int fileID, int byteswap, size_t size, REAL4 *ptr)
{
  static char func[] = "binWriteReal4";

  if ( sizeof(REAL4) == 4 )
    {
      if ( byteswap ) swap4byte(ptr, size);
      fileWrite(fileID, (void *) ptr, 4*size);
    }
  else
    {
      Error(func, "not implemented for %d byte float", sizeof(REAL4));
    }

  return (0);
}

int
binWriteReal8(int fileID, int byteswap, size_t size, REAL8 *ptr)
{
  static char func[] = "binWriteReal8";

  if ( sizeof(REAL8) == 8 )
    {
      if ( byteswap ) swap8byte(ptr, size);
      fileWrite(fileID, (void *) ptr, 8*size);
    }
  else
    {
      Error(func, "not implemented for %d byte float", sizeof(REAL8));
    }

  return (0);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




const char *cdfLibraryVersion(void)
{
#if  defined  (HAVE_LIBNETCDF)
  return (nc_inq_libvers());
#else
  return ("library undefined");
#endif
}


int CDF_Debug   = 0;    /* If set to 1, debugging           */


void cdfDebug(int debug)
{
  static char func[] = "cdfDebug";

  CDF_Debug = debug;

  if ( CDF_Debug )
    Message(func, "debug level %d", debug);
}

void cdfComment(int ncid)
{
#if  defined  (HAVE_LIBNETCDF)
  static char comment[256] = "Climate Data Interface version ";
  static int init = 0;
  char *blank;
  int size = 0;

  if ( ! init )
    {
      init = 1;
      blank = strchr(cdiLibraryVersion(), ' ');
      if ( blank ) size = blank - cdiLibraryVersion();

      if ( size == 0 || ! isdigit((int) *cdiLibraryVersion()) )
	strcat(comment, "??");
      else
	strncat(comment, cdiLibraryVersion(), size);
  /*  strcat(comment, " available from http://.../software/cdi.html"); */
    }

  cdf_put_att_text(ncid, NC_GLOBAL, "CDI", strlen(comment), comment);
  cdf_put_att_text(ncid, NC_GLOBAL, "Conventions", 6, "CF 1.0");
#endif
}


int cdfOpenFile(const char *filename, const char *mode, int version)
{
  static char func[] = "cdfOpenFile";
  int ncid = -1;
#if  defined  (HAVE_LIBNETCDF)
  int fmode;
  int writemode = NC_WRITE;

  if ( filename == NULL )
    ncid = CDI_EINVAL;
  else
    {
      switch (*mode)
	{
	case 'r':
	case 'R':
	  fmode = 'r';
	  cdf_open(filename, NC_NOWRITE, &ncid);
	  break;
	case 'w':
	case 'W':
	  fmode = 'w';
#if  defined  (NC_64BIT_OFFSET)
	  if ( version == 2 ) writemode = NC_WRITE|NC_64BIT_OFFSET;
#endif
	  cdf_create(filename, writemode, &ncid);
	  cdfComment(ncid);
	  break;
	case 'a':
	case 'A':
	  fmode = 'a';
	  cdf_open(filename, NC_WRITE, &ncid);
	  break;
	default:
	  ncid = CDI_EINVAL;
	}
    }
#endif

  return (ncid);
}


int cdfOpen(const char *filename, const char *mode)
{
  static char func[] = "cdfOpen";
  int fileID = 0;

  if ( CDF_Debug )
    Message(func, "open %s with mode %c", filename, *mode);

  fileID = cdfOpenFile(filename, mode, 1);

  if ( CDF_Debug )
    Message(func, "file %s opened with id %d", filename, fileID);

  return (fileID);
}


int cdfOpen64(const char *filename, const char *mode)
{
  static char func[] = "cdfOpen";
  int fileID = -1;

  if ( CDF_Debug )
    Message(func, "open %s with mode %c", filename, *mode);

#if  defined  (HAVE_LIBNETCDF)
#if  ! defined  (NC_64BIT_OFFSET)
  fileID = CDI_ELIBNAVAIL;
#endif
#endif

  if ( fileID != CDI_ELIBNAVAIL )
    {
      fileID = cdfOpenFile(filename, mode, 2);

      if ( CDF_Debug )
	Message(func, "file %s opened with id %d", filename, fileID);
    }

  return (fileID);
}


void cdfCloseFile(int fileID)
{
#if  defined  (HAVE_LIBNETCDF)
  cdf_close(fileID);
#endif
}

void cdfClose(int fileID)
{
  cdfCloseFile(fileID);
}
#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif




const char *hdfLibraryVersion(void)
{
#if  defined  (HAVE_LIBHDF5)
  static char libversion[128];
  unsigned majnum, minnum, relnum;
  H5get_libversion(&majnum, &minnum, &relnum);
  sprintf(libversion, "%u.%u.%u", majnum, minnum, relnum);
  return (libversion);
#else
  return ("library undefined");
#endif
}


int HDF_Debug   = 0;    /* If set to 1, debugging           */


void hdfDebug(int debug)
{
  static char func[] = "hdfDebug";

  HDF_Debug = debug;

  if ( HDF_Debug )
    Message(func, "debug level %d", debug);
}

void hdfComment(int hfid)
{
#if  defined  (HAVE_LIBHDF5)
  static char comment[256] = "using CDI library version ";
  static int init = 0;
  char *blank;
  int size = 0;

  if ( ! init )
    {
      init = 1;
      blank = strchr(cdiLibraryVersion(), ' ');
      if ( blank ) size = blank - cdiLibraryVersion();

      if ( size == 0 || ! isdigit((int) *cdiLibraryVersion()) )
	strcat(comment, "??");
      else
	strncat(comment, cdiLibraryVersion(), size);
  /*  strcat(comment, " available from http://.../software/cdi.html"); */
    }

  hdf_put_att_text(hfid, -1, "comment", strlen(comment), comment);

#endif
}

int hdfOpenFile(const char *filename, const char *mode)
{
  int hfid = 0;
#if  defined  (HAVE_LIBHDF5)
  static char func[] = "hdfOpenFile";
  int fmode;

  switch (*mode)
    {
    case 'r':
    case 'R':
      Error(func, "read of HDF5 files unsupported\n");
      /*
      fmode = 'r';
      hfid = hdf_open(filename, H5F_ACC_RDONLY);
      */
      break;
    case 'w':
    case 'W':
      fmode = 'w';
      hfid = hdf_create(filename, H5F_ACC_TRUNC);
      hdfComment(hfid);

      break;
    /*
    case 'a':
    case 'A':
      fmode = 'a';
      hdf_open(filename, NC_APPEND, &hfid);
      break;
    */
    default:
      Error(func, "mode %c unexpected\n", *mode);
    }

#endif
  return (hfid);
}

int hdfOpen(const char *filename, const char *mode)
{
  static char func[] = "hdfOpen";
  int fileID = 0;

  if ( HDF_Debug )
    Message(func, "open %s with mode %c", filename, *mode);

  if ( !filename )
    {
      Error(func, "filename undefined\n");
      return (-1);
    }

  fileID = hdfOpenFile(filename, mode);

  if ( HDF_Debug )
    Message(func, "file %s opened with id %d", filename, fileID);

  return (fileID);
}

void hdfCloseFile(int fileID)
{
#if  defined  (HAVE_LIBHDF5)
  hdf_close(fileID);
#endif
}

void hdfClose(int fileID)
{
  hdfCloseFile(fileID);
}
   static const char cdi_libvers[] = "0.8.9" " of ""Apr  1 2005"" ""19:52:30";
const char *cdiLibraryVersion(void);





const char *cdiLibraryVersion(void)
{
  return (cdi_libvers);
}
#if defined (HAVE_CF_INTERFACE)
#undef realloc
#undef malloc
#undef calloc
#undef free
#undef DOUBLE_PRECISION
/* cfortran.h  4.3 */
/* http://www-zeus.desy.de/~burow/cfortran/                   */
/* Burkhard Burow  burow@desy.de                 1990 - 2001. */

/* 02/12/2002 Uwe Schulzweida : UXP Fortran support           */
/* 02/05/2003 Uwe Schulzweida : Linux Fortran support on i386 */

#ifndef __CFORTRAN_LOADED
#define __CFORTRAN_LOADED

/* 
   THIS FILE IS PROPERTY OF BURKHARD BUROW. IF YOU ARE USING THIS FILE YOU
   SHOULD ALSO HAVE ACCESS TO CFORTRAN.DOC WHICH PROVIDES TERMS FOR USING,
   MODIFYING, COPYING AND DISTRIBUTING THE CFORTRAN.H PACKAGE.
*/

/* 
  Avoid symbols already used by compilers and system *.h:
  __ - OSF1 zukal06 V3.0 347 alpha, cc -c -std1 cfortest.c

 */


/* First prepare for the C compiler. */

#ifndef ANSI_C_preprocessor /* i.e. user can override. */
#ifdef __CF__KnR
#define ANSI_C_preprocessor 0
#else
#ifdef __STDC__
#define ANSI_C_preprocessor 1
#else
#define _cfleft             1
#define _cfright 
#define _cfleft_cfright     0
#define ANSI_C_preprocessor _cfleft/**/_cfright
#endif
#endif
#endif

#if ANSI_C_preprocessor
#define _0(A,B)   A##B
#define  _(A,B)   _0(A,B)  /* see cat,xcat of K&R ANSI C p. 231 */
#define _2(A,B)   A##B     /* K&R ANSI C p.230: .. identifier is not replaced */
#define _3(A,B,C) _(A,_(B,C))
#else                      /* if it turns up again during rescanning.         */
#define  _(A,B)   A/**/B
#define _2(A,B)   A/**/B
#define _3(A,B,C) A/**/B/**/C
#endif

#if (defined(vax)&&defined(unix)) || (defined(__vax__)&&defined(__unix__))
#define VAXUltrix
#endif

#include <stdio.h>     /* NULL [in all machines stdio.h]                      */
#include <string.h>    /* strlen, memset, memcpy, memchr.                     */
#if !( defined(VAXUltrix) || defined(sun) || (defined(apollo)&&!defined(__STDCPP__)) )
#include <stdlib.h>    /* malloc,free                                         */
#else
#include <malloc.h>    /* Had to be removed for DomainOS h105 10.4 sys5.3 425t*/
#ifdef apollo
#define __CF__APOLLO67 /* __STDCPP__ is in Apollo 6.8 (i.e. ANSI) and onwards */
#endif
#endif

#if !defined(__GNUC__) && !defined(__sun) && (defined(sun)||defined(VAXUltrix)||defined(lynx))
#define __CF__KnR     /* Sun, LynxOS and VAX Ultrix cc only supports K&R.     */
                      /* Manually define __CF__KnR for HP if desired/required.*/
#endif                /*       i.e. We will generate Kernighan and Ritchie C. */
/* Note that you may define __CF__KnR before #include cfortran.h, in order to
generate K&R C instead of the default ANSI C. The differences are mainly in the
function prototypes and declarations. All machines, except the Apollo, work
with either style. The Apollo's argument promotion rules require ANSI or use of
the obsolete std_$call which we have not implemented here. Hence on the Apollo,
only C calling FORTRAN subroutines will work using K&R style.*/


/* Remainder of cfortran.h depends on the Fortran compiler. */

#if defined(CLIPPERFortran) || defined(pgiFortran)
#define f2cFortran
#endif

/* VAX/VMS does not let us \-split long #if lines. */ 
/* Split #if into 2 because some HP-UX can't handle long #if */
#if !(defined(NAGf90Fortran)||defined(f2cFortran)||defined(hpuxFortran)||defined(apolloFortran)||defined(sunFortran)||defined(IBMR2Fortran)||defined(CRAYFortran))
#if !(defined(mipsFortran)||defined(DECFortran)||defined(vmsFortran)||defined(CONVEXFortran)||defined(PowerStationFortran)||defined(AbsoftUNIXFortran)||defined(AbsoftProFortran)||defined(SXFortran))
/* If no Fortran compiler is given, we choose one for the machines we know.   */
#if defined(__linux__) && defined(__i386__)
#define f2cFortran
#endif
#if defined(lynx) || defined(VAXUltrix)
#define f2cFortran    /* Lynx:      Only support f2c at the moment.
                         VAXUltrix: f77 behaves like f2c.
                           Support f2c or f77 with gcc, vcc with f2c. 
                           f77 with vcc works, missing link magic for f77 I/O.*/
#endif
#if defined(__hpux)             /* 921107: Use __hpux instead of __hp9000s300 */
#define       hpuxFortran       /*         Should also allow hp9000s7/800 use.*/
#endif
#if       defined(apollo)
#define           apolloFortran /* __CF__APOLLO67 also defines some behavior. */
#endif
#if          defined(sun) || defined(__sun) 
#define              sunFortran
#endif
#if       defined(_IBMR2)
#define            IBMR2Fortran
#endif
#if        defined(_CRAY)
#define             CRAYFortran /*       _CRAYT3E also defines some behavior. */
#endif
#if        defined(_SX)
#define               SXFortran
#endif
#if        defined(__uxp__)
#define               UXPFortran
#endif
#if         defined(mips) || defined(__mips)
#define             mipsFortran
#endif
#if          defined(vms) || defined(__vms)
#define              vmsFortran
#endif
#if      defined(__alpha) && defined(__unix__)
#define              DECFortran
#endif
#if   defined(__convex__)
#define           CONVEXFortran
#endif
#if   defined(VISUAL_CPLUSPLUS)
#define     PowerStationFortran
#endif
#endif /* ...Fortran */
#endif /* ...Fortran */

/* Split #if into 2 because some HP-UX can't handle long #if */
#if !(defined(NAGf90Fortran)||defined(f2cFortran)||defined(hpuxFortran)||defined(apolloFortran)||defined(sunFortran)||defined(IBMR2Fortran)||defined(CRAYFortran))
#if !(defined(mipsFortran)||defined(DECFortran)||defined(vmsFortran)||defined(CONVEXFortran)||defined(PowerStationFortran)||defined(AbsoftUNIXFortran)||defined(AbsoftProFortran)||defined(SXFortran)||defined(UXPFortran))
/* If your compiler barfs on ' #error', replace # with the trigraph for #     */
 #error "cfortran.h:  Can't find your environment among:\
    - MIPS cc and f77 2.0. (e.g. Silicon Graphics, DECstations, ...)     \
    - IBM AIX XL C and FORTRAN Compiler/6000 Version 01.01.0000.0000     \
    - VAX   VMS CC 3.1 and FORTRAN 5.4.                                  \
    - Alpha VMS DEC C 1.3 and DEC FORTRAN 6.0.                           \
    - Alpha OSF DEC C and DEC Fortran for OSF/1 AXP Version 1.2          \
    - Apollo DomainOS 10.2 (sys5.3) with f77 10.7 and cc 6.7.            \
    - CRAY                                                               \
    - NEC SX-4 SUPER-UX                                                  \
    - CONVEX                                                             \
    - Sun                                                                \
    - PowerStation Fortran with Visual C++                               \
    - HP9000s300/s700/s800 Latest test with: HP-UX A.08.07 A 9000/730    \
    - LynxOS: cc or gcc with f2c.                                        \
    - VAXUltrix: vcc,cc or gcc with f2c. gcc or cc with f77.             \
    -            f77 with vcc works; but missing link magic for f77 I/O. \
    -            NO fort. None of gcc, cc or vcc generate required names.\
    - f2c    : Use #define    f2cFortran, or cc -Df2cFortran             \
    - NAG f90: Use #define NAGf90Fortran, or cc -DNAGf90Fortran          \
    - Absoft UNIX F77: Use #define AbsoftUNIXFortran or cc -DAbsoftUNIXFortran \
    - Absoft Pro Fortran: Use #define AbsoftProFortran \
    - Portland Group Fortran: Use #define pgiFortran"
/* Compiler must throw us out at this point! */
#endif
#endif


#if defined(VAXC) && !defined(__VAXC)
#define OLD_VAXC
#pragma nostandard                       /* Prevent %CC-I-PARAMNOTUSED.       */
#endif

/* Throughout cfortran.h we use: UN = Uppercase Name.  LN = Lowercase Name.   */

#if defined(f2cFortran) || defined(NAGf90Fortran) || defined(DECFortran) || defined(mipsFortran) || defined(apolloFortran) || defined(sunFortran) || defined(CONVEXFortran) || defined(SXFortran) || defined(UXPFortran) || defined(extname)
#define CFC_(UN,LN)            _(LN,_)      /* Lowercase FORTRAN symbols.     */
#define orig_fcallsc(UN,LN)    CFC_(UN,LN)
#else 
#if defined(CRAYFortran) || defined(PowerStationFortran) || defined(AbsoftProFortran)
#ifdef _CRAY          /* (UN), not UN, circumvents CRAY preprocessor bug.     */
#define CFC_(UN,LN)            (UN)         /* Uppercase FORTRAN symbols.     */
#else                 /* At least VISUAL_CPLUSPLUS barfs on (UN), so need UN. */
#define CFC_(UN,LN)            UN           /* Uppercase FORTRAN symbols.     */
#endif
#define orig_fcallsc(UN,LN)    CFC_(UN,LN)  /* CRAY insists on arg.'s here.   */
#else  /* For following machines one may wish to change the fcallsc default.  */
#define CF_SAME_NAMESPACE
#ifdef vmsFortran
#define CFC_(UN,LN)            LN           /* Either case FORTRAN symbols.   */
     /* BUT we usually use UN for C macro to FORTRAN routines, so use LN here,*/
     /* because VAX/VMS doesn't do recursive macros.                          */
#define orig_fcallsc(UN,LN)    UN
#else      /* HP-UX without +ppu or IBMR2 without -qextname. NOT reccomended. */
#define CFC_(UN,LN)            LN           /* Lowercase FORTRAN symbols.     */
#define orig_fcallsc(UN,LN)    CFC_(UN,LN)
#endif /*  vmsFortran */
#endif /* CRAYFortran PowerStationFortran */
#endif /* ....Fortran */

#define fcallsc(UN,LN)               orig_fcallsc(UN,LN)
#define preface_fcallsc(P,p,UN,LN)   CFC_(_(P,UN),_(p,LN))
#define  append_fcallsc(P,p,UN,LN)   CFC_(_(UN,P),_(LN,p))

#define C_FUNCTION(UN,LN)            fcallsc(UN,LN)      
#define FORTRAN_FUNCTION(UN,LN)      CFC_(UN,LN)

#ifndef COMMON_BLOCK
#ifndef CONVEXFortran
#ifndef CLIPPERFortran
#if     !(defined(AbsoftUNIXFortran)||defined(AbsoftProFortran))
#define COMMON_BLOCK(UN,LN)          CFC_(UN,LN)
#else
#define COMMON_BLOCK(UN,LN)          _(_C,LN)
#endif  /* AbsoftUNIXFortran or AbsoftProFortran */
#else
#define COMMON_BLOCK(UN,LN)          _(LN,__)
#endif  /* CLIPPERFortran */
#else
#define COMMON_BLOCK(UN,LN)          _3(_,LN,_)
#endif  /* CONVEXFortran */
#endif  /* COMMON_BLOCK */

#ifndef DOUBLE_PRECISION
#if defined(CRAYFortran) && !defined(_CRAYT3E)
#define DOUBLE_PRECISION long double
#else
#define DOUBLE_PRECISION double
#endif
#endif

#ifndef FORTRAN_REAL
#if defined(CRAYFortran) &&  defined(_CRAYT3E)
#define FORTRAN_REAL double
#else
#define FORTRAN_REAL float
#endif
#endif

#ifdef CRAYFortran
#ifdef _CRAY
#include <fortran.h>
#else
#include "fortran.h"  /* i.e. if crosscompiling assume user has file. */
#endif
#define FLOATVVVVVVV_cfPP (FORTRAN_REAL *)   /* Used for C calls FORTRAN.     */
/* CRAY's double==float but CRAY says pointers to doubles and floats are diff.*/
#define VOIDP  (void *)  /* When FORTRAN calls C, we don't know if C routine 
                            arg.'s have been declared float *, or double *.   */
#else
#define FLOATVVVVVVV_cfPP
#define VOIDP
#endif

#ifdef vmsFortran
#if    defined(vms) || defined(__vms)
#include <descrip.h>
#else
#include "descrip.h"  /* i.e. if crosscompiling assume user has file. */
#endif
#endif

#ifdef sunFortran
#if defined(sun) || defined(__sun)
#include <math.h>     /* Sun's FLOATFUNCTIONTYPE, ASSIGNFLOAT, RETURNFLOAT.  */
#else
#include "math.h"     /* i.e. if crosscompiling assume user has file. */
#endif
/* At least starting with the default C compiler SC3.0.1 of SunOS 5.3,
 * FLOATFUNCTIONTYPE, ASSIGNFLOAT, RETURNFLOAT are not required and not in
 * <math.h>, since sun C no longer promotes C float return values to doubles.
 * Therefore, only use them if defined.
 * Even if gcc is being used, assume that it exhibits the Sun C compiler
 * behavior in order to be able to use *.o from the Sun C compiler.
 * i.e. If FLOATFUNCTIONTYPE, etc. are in math.h, they required by gcc.
 */
#endif

#ifndef apolloFortran
#define COMMON_BLOCK_DEF(DEFINITION, NAME) extern DEFINITION NAME
#define CF_NULL_PROTO
#else                                         /* HP doesn't understand #elif. */
/* Without ANSI prototyping, Apollo promotes float functions to double.    */
/* Note that VAX/VMS, IBM, Mips choke on 'type function(...);' prototypes. */
#define CF_NULL_PROTO ...
#ifndef __CF__APOLLO67
#define COMMON_BLOCK_DEF(DEFINITION, NAME) \
 DEFINITION NAME __attribute((__section(NAME)))
#else
#define COMMON_BLOCK_DEF(DEFINITION, NAME) \
 DEFINITION NAME #attribute[section(NAME)]
#endif
#endif

#ifdef __cplusplus
#undef  CF_NULL_PROTO
#define CF_NULL_PROTO  ...
#endif


#ifndef USE_NEW_DELETE
#ifdef __cplusplus
#define USE_NEW_DELETE 1
#else
#define USE_NEW_DELETE 0
#endif
#endif
#if USE_NEW_DELETE
#define _cf_malloc(N) new char[N]
#define _cf_free(P)   delete[] P
#else
#define _cf_malloc(N) (char *)malloc(N)
#define _cf_free(P)   free(P)
#endif

#ifdef mipsFortran
#define CF_DECLARE_GETARG         int f77argc; char **f77argv
#define CF_SET_GETARG(ARGC,ARGV)  f77argc = ARGC; f77argv = ARGV
#else
#define CF_DECLARE_GETARG
#define CF_SET_GETARG(ARGC,ARGV)
#endif

#ifdef OLD_VAXC                          /* Allow %CC-I-PARAMNOTUSED.         */
#pragma standard                         
#endif

#define AcfCOMMA ,
#define AcfCOLON ;

/*-------------------------------------------------------------------------*/

/*               UTILITIES USED WITHIN CFORTRAN.H                          */

#define _cfMIN(A,B) (A<B?A:B)

/* 970211 - XIX.145:
   firstindexlength  - better name is all_but_last_index_lengths
   secondindexlength - better name is         last_index_length
 */
#define  firstindexlength(A) (sizeof(A[0])==1 ? 1 : (sizeof(A) / sizeof(A[0])) )
#define secondindexlength(A) (sizeof(A[0])==1 ?      sizeof(A) : sizeof(A[0])  )

/* Behavior of FORTRAN LOGICAL. All machines' LOGICAL is same size as C's int.
Conversion is automatic except for arrays which require F2CLOGICALV/C2FLOGICALV.
f2c, MIPS f77 [DECstation, SGI], VAX Ultrix f77,
HP-UX f77                                        : as in C.
VAX/VMS FORTRAN, VAX Ultrix fort,
Absoft Unix Fortran, IBM RS/6000 xlf             : LS Bit = 0/1 = TRUE/FALSE.
Apollo                                           : neg.   = TRUE, else FALSE. 
[Apollo accepts -1 as TRUE for function values, but NOT all other neg. values.]
[DECFortran for Ultrix RISC is also called f77 but is the same as VAX/VMS.]   
[MIPS f77 treats .eqv./.neqv. as .eq./.ne. and hence requires LOGICAL_STRICT.]*/

#if defined(NAGf90Fortran) || defined(f2cFortran) || defined(mipsFortran) || defined(PowerStationFortran) || defined(hpuxFortran800) || defined(AbsoftUNIXFortran) || defined(AbsoftProFortran) || defined(SXFortran) || defined(UXPFortran)
/* SX/PowerStationFortran have 0 and 1 defined, others are neither T nor F.   */
/* hpuxFortran800 has 0 and 0x01000000 defined. Others are unknown.           */
#define LOGICAL_STRICT      /* Other Fortran have .eqv./.neqv. == .eq./.ne.   */
#endif

#define C2FLOGICALV(A,I) \
 do {int __i; for(__i=0;__i<I;__i++) A[__i]=C2FLOGICAL(A[__i]); } while (0)
#define F2CLOGICALV(A,I) \
 do {int __i; for(__i=0;__i<I;__i++) A[__i]=F2CLOGICAL(A[__i]); } while (0)

#if defined(apolloFortran)
#define C2FLOGICAL(L) ((L)?-1:(L)&~((unsigned)1<<sizeof(int)*8-1))
#define F2CLOGICAL(L) ((L)<0?(L):0) 
#else
#if defined(CRAYFortran)
#define C2FLOGICAL(L) _btol(L)
#define F2CLOGICAL(L) _ltob(&(L))     /* Strangely _ltob() expects a pointer. */
#else
#if defined(IBMR2Fortran) || defined(vmsFortran) || defined(DECFortran) || defined(AbsoftUNIXFortran)
/* How come no AbsoftProFortran ? */
#define C2FLOGICAL(L) ((L)?(L)|1:(L)&~(int)1)
#define F2CLOGICAL(L) ((L)&1?(L):0)
#else
#if defined(CONVEXFortran)
#define C2FLOGICAL(L) ((L) ? ~0 : 0 )
#define F2CLOGICAL(L) (L)
#else   /* others evaluate LOGICALs as for C. */
#define C2FLOGICAL(L) (L)
#define F2CLOGICAL(L) (L)
#ifndef LOGICAL_STRICT
#undef  C2FLOGICALV
#undef  F2CLOGICALV
#define C2FLOGICALV(A,I)
#define F2CLOGICALV(A,I)
#endif  /* LOGICAL_STRICT                     */
#endif  /* CONVEXFortran || All Others        */
#endif  /* IBMR2Fortran vmsFortran DECFortran AbsoftUNIXFortran */
#endif  /* CRAYFortran                        */
#endif  /* apolloFortran                      */

/* 970514 - In addition to CRAY, there may be other machines
            for which LOGICAL_STRICT makes no sense. */
#if defined(LOGICAL_STRICT) && !defined(CRAYFortran)
/* Force C2FLOGICAL to generate only the values for either .TRUE. or .FALSE.
   SX/PowerStationFortran only have 0 and 1 defined.
   Elsewhere, only needed if you want to do:
     logical lvariable
     if (lvariable .eq.  .true.) then       ! (1)
   instead of
     if (lvariable .eqv. .true.) then       ! (2)
   - (1) may not even be FORTRAN/77 and that Apollo's f77 and IBM's xlf
     refuse to compile (1), so you are probably well advised to stay away from 
     (1) and from LOGICAL_STRICT.
   - You pay a (slight) performance penalty for using LOGICAL_STRICT. */
#undef  C2FLOGICAL
#ifdef hpuxFortran800
#define C2FLOGICAL(L) ((L)?0x01000000:0)
#else
#if defined(apolloFortran) || defined(vmsFortran) || defined(DECFortran)
#define C2FLOGICAL(L) ((L)?-1:0) /* These machines use -1/0 for .true./.false.*/
#else
#define C2FLOGICAL(L) ((L)? 1:0) /* All others     use +1/0 for .true./.false.*/
#endif
#endif
#endif /* LOGICAL_STRICT */

/* Convert a vector of C strings into FORTRAN strings. */
#ifndef __CF__KnR
static char *c2fstrv(char* cstr, char *fstr, int elem_len, int sizeofcstr)
#else
static char *c2fstrv(      cstr,       fstr,     elem_len,     sizeofcstr)
                     char* cstr; char *fstr; int elem_len; int sizeofcstr;
#endif
{ int i,j;
/* elem_len includes \0 for C strings. Fortran strings don't have term. \0.
   Useful size of string must be the same in both languages. */
for (i=0; i<sizeofcstr/elem_len; i++) {
  for (j=1; j<elem_len && *cstr; j++) *fstr++ = *cstr++;
  cstr += 1+elem_len-j;
  for (; j<elem_len; j++) *fstr++ = ' ';
} /* 95109 - Seems to be returning the original fstr. */
return fstr-sizeofcstr+sizeofcstr/elem_len; }

/* Convert a vector of FORTRAN strings into C strings. */
#ifndef __CF__KnR
static char *f2cstrv(char *fstr, char* cstr, int elem_len, int sizeofcstr)
#else
static char *f2cstrv(      fstr,       cstr,     elem_len,     sizeofcstr)
                     char *fstr; char* cstr; int elem_len; int sizeofcstr; 
#endif
{ int i,j;
/* elem_len includes \0 for C strings. Fortran strings don't have term. \0.
   Useful size of string must be the same in both languages. */
cstr += sizeofcstr;
fstr += sizeofcstr - sizeofcstr/elem_len;
for (i=0; i<sizeofcstr/elem_len; i++) {
  *--cstr = '\0';
  for (j=1; j<elem_len; j++) *--cstr = *--fstr;
} return cstr; }

/* kill the trailing char t's in string s. */
#ifndef __CF__KnR
static char *kill_trailing(char *s, char t)
#else
static char *kill_trailing(      s,      t) char *s; char t;
#endif
{char *e; 
e = s + strlen(s);
if (e>s) {                           /* Need this to handle NULL string.*/
  while (e>s && *--e==t);            /* Don't follow t's past beginning. */
  e[*e==t?0:1] = '\0';               /* Handle s[0]=t correctly.       */
} return s; }

/* kill_trailingn(s,t,e) will kill the trailing t's in string s. e normally 
points to the terminating '\0' of s, but may actually point to anywhere in s.
s's new '\0' will be placed at e or earlier in order to remove any trailing t's.
If e<s string s is left unchanged. */ 
#ifndef __CF__KnR
static char *kill_trailingn(char *s, char t, char *e)
#else
static char *kill_trailingn(      s,      t,       e) char *s; char t; char *e;
#endif
{ 
if (e==s) *e = '\0';                 /* Kill the string makes sense here.*/
else if (e>s) {                      /* Watch out for neg. length string.*/
  while (e>s && *--e==t);            /* Don't follow t's past beginning. */
  e[*e==t?0:1] = '\0';               /* Handle s[0]=t correctly.       */
} return s; }

/* Note the following assumes that any element which has t's to be chopped off,
does indeed fill the entire element. */
#ifndef __CF__KnR
static char *vkill_trailing(char* cstr, int elem_len, int sizeofcstr, char t)
#else
static char *vkill_trailing(      cstr,     elem_len,     sizeofcstr,      t)
                            char* cstr; int elem_len; int sizeofcstr; char t;
#endif
{ int i;
for (i=0; i<sizeofcstr/elem_len; i++) /* elem_len includes \0 for C strings. */
  kill_trailingn(cstr+elem_len*i,t,cstr+elem_len*(i+1)-1);
return cstr; }

#ifdef vmsFortran
typedef struct dsc$descriptor_s fstring;
#define DSC$DESCRIPTOR_A(DIMCT)  		                               \
struct {                                                                       \
  unsigned short dsc$w_length;	        unsigned char	 dsc$b_dtype;	       \
  unsigned char	 dsc$b_class;	                 char	*dsc$a_pointer;	       \
           char	 dsc$b_scale;	        unsigned char	 dsc$b_digits;         \
  struct {                                                                     \
    unsigned		       : 3;	  unsigned dsc$v_fl_binscale : 1;      \
    unsigned dsc$v_fl_redim    : 1;       unsigned dsc$v_fl_column   : 1;      \
    unsigned dsc$v_fl_coeff    : 1;       unsigned dsc$v_fl_bounds   : 1;      \
  } dsc$b_aflags;	                                                       \
  unsigned char	 dsc$b_dimct;	        unsigned long	 dsc$l_arsize;	       \
           char	*dsc$a_a0;	                 long	 dsc$l_m [DIMCT];      \
  struct {                                                                     \
    long dsc$l_l;                         long dsc$l_u;                        \
  } dsc$bounds [DIMCT];                                                        \
}
typedef DSC$DESCRIPTOR_A(1) fstringvector;
/*typedef DSC$DESCRIPTOR_A(2) fstringarrarr;
  typedef DSC$DESCRIPTOR_A(3) fstringarrarrarr;*/
#define initfstr(F,C,ELEMNO,ELEMLEN)                                           \
( (F).dsc$l_arsize=  ( (F).dsc$w_length                        =(ELEMLEN) )    \
                    *( (F).dsc$l_m[0]=(F).dsc$bounds[0].dsc$l_u=(ELEMNO)  ),   \
  (F).dsc$a_a0    =  ( (F).dsc$a_pointer=(C) ) - (F).dsc$w_length          ,(F))

#else
#define _NUM_ELEMS      -1
#define _NUM_ELEM_ARG   -2
#define NUM_ELEMS(A)    A,_NUM_ELEMS
#define NUM_ELEM_ARG(B) *_2(A,B),_NUM_ELEM_ARG
#define TERM_CHARS(A,B) A,B
#ifndef __CF__KnR
static int num_elem(char *strv, unsigned elem_len, int term_char, int num_term)
#else
static int num_elem(      strv,          elem_len,     term_char,     num_term)
                    char *strv; unsigned elem_len; int term_char; int num_term;
#endif
/* elem_len is the number of characters in each element of strv, the FORTRAN
vector of strings. The last element of the vector must begin with at least
num_term term_char characters, so that this routine can determine how 
many elements are in the vector. */
{
unsigned num,i;
if (num_term == _NUM_ELEMS || num_term == _NUM_ELEM_ARG) 
  return term_char;
if (num_term <=0) num_term = (int)elem_len;
for (num=0; ; num++) {
  for (i=0; i<(unsigned)num_term && *strv==term_char; i++,strv++);
  if (i==(unsigned)num_term) break;
  else strv += elem_len-i;
}
return (int)num;
}
#endif
/*-------------------------------------------------------------------------*/

/*           UTILITIES FOR C TO USE STRINGS IN FORTRAN COMMON BLOCKS       */

/* C string TO Fortran Common Block STRing. */
/* DIM is the number of DIMensions of the array in terms of strings, not
   characters. e.g. char a[12] has DIM = 0, char a[12][4] has DIM = 1, etc. */
#define C2FCBSTR(CSTR,FSTR,DIM)                                                \
 c2fstrv((char *)CSTR, (char *)FSTR, sizeof(FSTR)/cfelementsof(FSTR,DIM)+1,    \
         sizeof(FSTR)+cfelementsof(FSTR,DIM))

/* Fortran Common Block string TO C STRing. */
#define FCB2CSTR(FSTR,CSTR,DIM)                                                \
 vkill_trailing(f2cstrv((char *)FSTR, (char *)CSTR,                            \
                        sizeof(FSTR)/cfelementsof(FSTR,DIM)+1,                 \
                        sizeof(FSTR)+cfelementsof(FSTR,DIM)),                  \
                sizeof(FSTR)/cfelementsof(FSTR,DIM)+1,                         \
                sizeof(FSTR)+cfelementsof(FSTR,DIM), ' ')

#define cfDEREFERENCE0
#define cfDEREFERENCE1 *
#define cfDEREFERENCE2 **
#define cfDEREFERENCE3 ***
#define cfDEREFERENCE4 ****
#define cfDEREFERENCE5 *****
#define cfelementsof(A,D) (sizeof(A)/sizeof(_(cfDEREFERENCE,D)(A)))

/*-------------------------------------------------------------------------*/

/*               UTILITIES FOR C TO CALL FORTRAN SUBROUTINES               */

/* Define lookup tables for how to handle the various types of variables.  */

#ifdef OLD_VAXC                                /* Prevent %CC-I-PARAMNOTUSED. */
#pragma nostandard
#endif

#define ZTRINGV_NUM(I)       I
#define ZTRINGV_ARGFP(I) (*(_2(A,I))) /* Undocumented. For PINT, etc. */
#define ZTRINGV_ARGF(I) _2(A,I)
#ifdef CFSUBASFUN
#define ZTRINGV_ARGS(I) ZTRINGV_ARGF(I)
#else
#define ZTRINGV_ARGS(I) _2(B,I)
#endif

#define    PBYTE_cfVP(A,B) PINT_cfVP(A,B)
#define  PDOUBLE_cfVP(A,B)
#define   PFLOAT_cfVP(A,B)
#ifdef ZTRINGV_ARGS_allows_Pvariables
/* This allows Pvariables for ARGS. ARGF machinery is above ARGFP.
 * B is not needed because the variable may be changed by the Fortran routine,
 * but because B is the only way to access an arbitrary macro argument.       */
#define     PINT_cfVP(A,B) int  B = (int)A;              /* For ZSTRINGV_ARGS */
#else
#define     PINT_cfVP(A,B)
#endif
#define PLOGICAL_cfVP(A,B) int *B;      /* Returning LOGICAL in FUNn and SUBn */
#define    PLONG_cfVP(A,B) PINT_cfVP(A,B)
#define   PSHORT_cfVP(A,B) PINT_cfVP(A,B)

#define        VCF_INT_S(T,A,B) _(T,VVVVVVV_cfTYPE) B = A;
#define        VCF_INT_F(T,A,B) _(T,_cfVCF)(A,B)
/* _cfVCF table is directly mapped to _cfCCC table. */
#define     BYTE_cfVCF(A,B)
#define   DOUBLE_cfVCF(A,B)
#if !defined(__CF__KnR)
#define    FLOAT_cfVCF(A,B)
#else
#define    FLOAT_cfVCF(A,B) FORTRAN_REAL B = A;
#endif
#define      INT_cfVCF(A,B)
#define  LOGICAL_cfVCF(A,B)
#define     LONG_cfVCF(A,B)
#define    SHORT_cfVCF(A,B)

/* 980416
   Cast (void (*)(CF_NULL_PROTO)) causes SunOS CC 4.2 occasionally to barf,
   while the following equivalent typedef is fine.
   For consistency use the typedef on all machines.
 */
typedef void (*cfCAST_FUNCTION)(CF_NULL_PROTO);

#define VCF(TN,I)       _Icf4(4,V,TN,_(A,I),_(B,I),F)
#define VVCF(TN,AI,BI)  _Icf4(4,V,TN,AI,BI,S)
#define        INT_cfV(T,A,B,F) _(VCF_INT_,F)(T,A,B)
#define       INTV_cfV(T,A,B,F)
#define      INTVV_cfV(T,A,B,F)
#define     INTVVV_cfV(T,A,B,F)
#define    INTVVVV_cfV(T,A,B,F)
#define   INTVVVVV_cfV(T,A,B,F)
#define  INTVVVVVV_cfV(T,A,B,F)
#define INTVVVVVVV_cfV(T,A,B,F)
#define PINT_cfV(      T,A,B,F) _(T,_cfVP)(A,B)
#define PVOID_cfV(     T,A,B,F)
#if defined(apolloFortran) || defined(hpuxFortran800) || defined(AbsoftUNIXFortran) || defined(AbsoftProFortran)
#define    ROUTINE_cfV(T,A,B,F) void (*B)(CF_NULL_PROTO) = (cfCAST_FUNCTION)A;
#else
#define    ROUTINE_cfV(T,A,B,F)
#endif
#define     SIMPLE_cfV(T,A,B,F)
#ifdef vmsFortran
#define     STRING_cfV(T,A,B,F) static struct {fstring f; unsigned clen;} B =  \
                                       {{0,DSC$K_DTYPE_T,DSC$K_CLASS_S,NULL},0};
#define    PSTRING_cfV(T,A,B,F) static fstring B={0,DSC$K_DTYPE_T,DSC$K_CLASS_S,NULL};
#define    STRINGV_cfV(T,A,B,F) static fstringvector B =                       \
  {sizeof(A),DSC$K_DTYPE_T,DSC$K_CLASS_A,NULL,0,0,{0,0,1,1,1},1,0,NULL,0,{1,0}};
#define   PSTRINGV_cfV(T,A,B,F) static fstringvector B =                       \
          {0,DSC$K_DTYPE_T,DSC$K_CLASS_A,NULL,0,0,{0,0,1,1,1},1,0,NULL,0,{1,0}};
#else
#define     STRING_cfV(T,A,B,F) struct {unsigned int clen, flen;} B;
#define    STRINGV_cfV(T,A,B,F) struct {char *s, *fs; unsigned flen;} B;
#define    PSTRING_cfV(T,A,B,F) int     B;
#define   PSTRINGV_cfV(T,A,B,F) struct{char *fs; unsigned int sizeofA,flen;}B;
#endif
#define    ZTRINGV_cfV(T,A,B,F)  STRINGV_cfV(T,A,B,F)
#define   PZTRINGV_cfV(T,A,B,F) PSTRINGV_cfV(T,A,B,F)

/* Note that the actions of the A table were performed inside the AA table.
   VAX Ultrix vcc, and HP-UX cc, didn't evaluate arguments to functions left to
   right, so we had to split the original table into the current robust two. */
#define ACF(NAME,TN,AI,I)      _(TN,_cfSTR)(4,A,NAME,I,AI,_(B,I),0)
#define   DEFAULT_cfA(M,I,A,B)
#define   LOGICAL_cfA(M,I,A,B) B=C2FLOGICAL(B);
#define  PLOGICAL_cfA(M,I,A,B) A=C2FLOGICAL(A);
#define    STRING_cfA(M,I,A,B)  STRING_cfC(M,I,A,B,sizeof(A))
#define   PSTRING_cfA(M,I,A,B) PSTRING_cfC(M,I,A,B,sizeof(A))
#ifdef vmsFortran
#define  AATRINGV_cfA(    A,B, sA,filA,silA)                                   \
 initfstr(B,_cf_malloc((sA)-(filA)),(filA),(silA)-1),                          \
          c2fstrv(A,B.dsc$a_pointer,(silA),(sA));
#define APATRINGV_cfA(    A,B, sA,filA,silA)                                   \
 initfstr(B,A,(filA),(silA)-1),c2fstrv(A,A,(silA),(sA));
#else
#define  AATRINGV_cfA(    A,B, sA,filA,silA)                                   \
     (B.s=_cf_malloc((sA)-(filA)),B.fs=c2fstrv(A,B.s,(B.flen=(silA)-1)+1,(sA)));
#define APATRINGV_cfA(    A,B, sA,filA,silA)                                   \
 B.fs=c2fstrv(A,A,(B.flen=(silA)-1)+1,B.sizeofA=(sA));
#endif
#define   STRINGV_cfA(M,I,A,B)                                                 \
    AATRINGV_cfA((char *)A,B,sizeof(A),firstindexlength(A),secondindexlength(A))
#define  PSTRINGV_cfA(M,I,A,B)                                                 \
   APATRINGV_cfA((char *)A,B,sizeof(A),firstindexlength(A),secondindexlength(A))
#define   ZTRINGV_cfA(M,I,A,B)  AATRINGV_cfA( (char *)A,B,                     \
                    (_3(M,_ELEMS_,I))*(( _3(M,_ELEMLEN_,I))+1),                \
                              (_3(M,_ELEMS_,I)),(_3(M,_ELEMLEN_,I))+1)
#define  PZTRINGV_cfA(M,I,A,B) APATRINGV_cfA( (char *)A,B,                     \
                    (_3(M,_ELEMS_,I))*(( _3(M,_ELEMLEN_,I))+1),                \
                              (_3(M,_ELEMS_,I)),(_3(M,_ELEMLEN_,I))+1)

#define    PBYTE_cfAAP(A,B) &A
#define  PDOUBLE_cfAAP(A,B) &A
#define   PFLOAT_cfAAP(A,B) FLOATVVVVVVV_cfPP &A
#define     PINT_cfAAP(A,B) &A
#define PLOGICAL_cfAAP(A,B) B= &A         /* B used to keep a common W table. */
#define    PLONG_cfAAP(A,B) &A
#define   PSHORT_cfAAP(A,B) &A

#define AACF(TN,AI,I,C) _SEP_(TN,C,cfCOMMA) _Icf(3,AA,TN,AI,_(B,I))
#define        INT_cfAA(T,A,B) &B
#define       INTV_cfAA(T,A,B) _(T,VVVVVV_cfPP) A
#define      INTVV_cfAA(T,A,B) _(T,VVVVV_cfPP)  A[0]
#define     INTVVV_cfAA(T,A,B) _(T,VVVV_cfPP)   A[0][0]
#define    INTVVVV_cfAA(T,A,B) _(T,VVV_cfPP)    A[0][0][0]
#define   INTVVVVV_cfAA(T,A,B) _(T,VV_cfPP)     A[0][0][0][0]
#define  INTVVVVVV_cfAA(T,A,B) _(T,V_cfPP)      A[0][0][0][0][0]
#define INTVVVVVVV_cfAA(T,A,B) _(T,_cfPP)       A[0][0][0][0][0][0]
#define       PINT_cfAA(T,A,B) _(T,_cfAAP)(A,B)
#define      PVOID_cfAA(T,A,B) (void *) A
#if defined(apolloFortran) || defined(hpuxFortran800) || defined(AbsoftUNIXFortran)
#define    ROUTINE_cfAA(T,A,B) &B
#else
#define    ROUTINE_cfAA(T,A,B) (cfCAST_FUNCTION)A
#endif
#define     STRING_cfAA(T,A,B)  STRING_cfCC(T,A,B)
#define    PSTRING_cfAA(T,A,B) PSTRING_cfCC(T,A,B)
#ifdef vmsFortran
#define    STRINGV_cfAA(T,A,B) &B
#else
#ifdef CRAYFortran
#define    STRINGV_cfAA(T,A,B) _cptofcd(B.fs,B.flen)
#else
#define    STRINGV_cfAA(T,A,B) B.fs
#endif
#endif
#define   PSTRINGV_cfAA(T,A,B) STRINGV_cfAA(T,A,B)
#define    ZTRINGV_cfAA(T,A,B) STRINGV_cfAA(T,A,B)
#define   PZTRINGV_cfAA(T,A,B) STRINGV_cfAA(T,A,B)

#if defined(vmsFortran) || defined(CRAYFortran)
#define JCF(TN,I)
#define KCF(TN,I)
#else
#define JCF(TN,I)    _(TN,_cfSTR)(1,J,_(B,I), 0,0,0,0)
#if defined(AbsoftUNIXFortran)
#define  DEFAULT_cfJ(B) ,0
#else
#define  DEFAULT_cfJ(B)
#endif
#define  LOGICAL_cfJ(B) DEFAULT_cfJ(B)
#define PLOGICAL_cfJ(B) DEFAULT_cfJ(B)
#define   STRING_cfJ(B) ,B.flen
#define  PSTRING_cfJ(B) ,B
#define  STRINGV_cfJ(B) STRING_cfJ(B)
#define PSTRINGV_cfJ(B) STRING_cfJ(B)
#define  ZTRINGV_cfJ(B) STRING_cfJ(B)
#define PZTRINGV_cfJ(B) STRING_cfJ(B)

/* KCF is identical to DCF, except that KCF ZTRING is not empty. */
#define KCF(TN,I)    _(TN,_cfSTR)(1,KK,_(B,I), 0,0,0,0)
#if defined(AbsoftUNIXFortran)
#define  DEFAULT_cfKK(B) , unsigned B
#else
#define  DEFAULT_cfKK(B)
#endif
#define  LOGICAL_cfKK(B) DEFAULT_cfKK(B)
#define PLOGICAL_cfKK(B) DEFAULT_cfKK(B)
#define   STRING_cfKK(B) , unsigned B
#define  PSTRING_cfKK(B) STRING_cfKK(B)
#define  STRINGV_cfKK(B) STRING_cfKK(B)
#define PSTRINGV_cfKK(B) STRING_cfKK(B)
#define  ZTRINGV_cfKK(B) STRING_cfKK(B)
#define PZTRINGV_cfKK(B) STRING_cfKK(B)
#endif

#define WCF(TN,AN,I)      _(TN,_cfSTR)(2,W,AN,_(B,I), 0,0,0)
#define  DEFAULT_cfW(A,B)
#define  LOGICAL_cfW(A,B)
#define PLOGICAL_cfW(A,B) *B=F2CLOGICAL(*B);
#define   STRING_cfW(A,B) (A[B.clen]!='\0'?A[B.clen]='\0':0); /* A?="constnt"*/
#define  PSTRING_cfW(A,B) kill_trailing(A,' ');
#ifdef vmsFortran
#define  STRINGV_cfW(A,B) _cf_free(B.dsc$a_pointer);
#define PSTRINGV_cfW(A,B)                                                      \
  vkill_trailing(f2cstrv((char*)A, (char*)A,                                   \
                           B.dsc$w_length+1, B.dsc$l_arsize+B.dsc$l_m[0]),     \
                   B.dsc$w_length+1, B.dsc$l_arsize+B.dsc$l_m[0], ' ');
#else
#define  STRINGV_cfW(A,B) _cf_free(B.s);
#define PSTRINGV_cfW(A,B) vkill_trailing(                                      \
         f2cstrv((char*)A,(char*)A,B.flen+1,B.sizeofA), B.flen+1,B.sizeofA,' ');
#endif
#define  ZTRINGV_cfW(A,B)      STRINGV_cfW(A,B)
#define PZTRINGV_cfW(A,B)     PSTRINGV_cfW(A,B)

#define   NCF(TN,I,C)       _SEP_(TN,C,cfCOMMA) _Icf(2,N,TN,_(A,I),0) 
#define  NNCF(TN,I,C)        UUCF(TN,I,C)
#define NNNCF(TN,I,C)       _SEP_(TN,C,cfCOLON) _Icf(2,N,TN,_(A,I),0) 
#define        INT_cfN(T,A) _(T,VVVVVVV_cfTYPE) * A
#define       INTV_cfN(T,A) _(T,VVVVVV_cfTYPE)  * A
#define      INTVV_cfN(T,A) _(T,VVVVV_cfTYPE)   * A
#define     INTVVV_cfN(T,A) _(T,VVVV_cfTYPE)    * A
#define    INTVVVV_cfN(T,A) _(T,VVV_cfTYPE)     * A
#define   INTVVVVV_cfN(T,A) _(T,VV_cfTYPE)      * A
#define  INTVVVVVV_cfN(T,A) _(T,V_cfTYPE)       * A
#define INTVVVVVVV_cfN(T,A) _(T,_cfTYPE)        * A
#define       PINT_cfN(T,A) _(T,_cfTYPE)        * A
#define      PVOID_cfN(T,A) void *                A
#if defined(apolloFortran) || defined(hpuxFortran800) || defined(AbsoftUNIXFortran)
#define    ROUTINE_cfN(T,A) void (**A)(CF_NULL_PROTO)
#else
#define    ROUTINE_cfN(T,A) void ( *A)(CF_NULL_PROTO)
#endif
#ifdef vmsFortran
#define     STRING_cfN(T,A) fstring *             A
#define    STRINGV_cfN(T,A) fstringvector *       A
#else
#ifdef CRAYFortran
#define     STRING_cfN(T,A) _fcd                  A
#define    STRINGV_cfN(T,A) _fcd                  A
#else
#define     STRING_cfN(T,A) char *                A
#define    STRINGV_cfN(T,A) char *                A
#endif
#endif
#define    PSTRING_cfN(T,A)   STRING_cfN(T,A) /* CRAY insists on arg.'s here. */
#define   PNSTRING_cfN(T,A)   STRING_cfN(T,A) /* CRAY insists on arg.'s here. */
#define   PPSTRING_cfN(T,A)   STRING_cfN(T,A) /* CRAY insists on arg.'s here. */
#define   PSTRINGV_cfN(T,A)  STRINGV_cfN(T,A)
#define    ZTRINGV_cfN(T,A)  STRINGV_cfN(T,A)
#define   PZTRINGV_cfN(T,A) PSTRINGV_cfN(T,A)


/* Apollo 6.7, CRAY, old Sun, VAX/Ultrix vcc/cc and new ultrix
   can't hack more than 31 arg's.
   e.g. ultrix >= 4.3 gives message:
       zow35> cc -c -DDECFortran cfortest.c
       cfe: Fatal: Out of memory: cfortest.c
       zow35>
   Old __hpux had the problem, but new 'HP-UX A.09.03 A 9000/735' is fine
   if using -Aa, otherwise we have a problem.
 */
#ifndef MAX_PREPRO_ARGS
#if !defined(__GNUC__) && (defined(VAXUltrix) || defined(__CF__APOLLO67) || (defined(sun)&&!defined(__sun)) || defined(_CRAY) || defined(__ultrix__) || (defined(__hpux)&&defined(__CF__KnR)))
#define MAX_PREPRO_ARGS 31
#else
#define MAX_PREPRO_ARGS 99
#endif
#endif

#if defined(AbsoftUNIXFortran) || defined(AbsoftProFortran)
/* In addition to explicit Absoft stuff, only Absoft requires:
   - DEFAULT coming from _cfSTR.
     DEFAULT could have been called e.g. INT, but keep it for clarity.
   - M term in CFARGT14 and CFARGT14FS.
 */
#define ABSOFT_cf1(T0) _(T0,_cfSTR)(0,ABSOFT1,0,0,0,0,0)
#define ABSOFT_cf2(T0) _(T0,_cfSTR)(0,ABSOFT2,0,0,0,0,0)
#define ABSOFT_cf3(T0) _(T0,_cfSTR)(0,ABSOFT3,0,0,0,0,0)
#define DEFAULT_cfABSOFT1
#define LOGICAL_cfABSOFT1
#define  STRING_cfABSOFT1 ,MAX_LEN_FORTRAN_FUNCTION_STRING
#define DEFAULT_cfABSOFT2
#define LOGICAL_cfABSOFT2
#define  STRING_cfABSOFT2 ,unsigned D0
#define DEFAULT_cfABSOFT3
#define LOGICAL_cfABSOFT3
#define  STRING_cfABSOFT3 ,D0
#else
#define ABSOFT_cf1(T0)
#define ABSOFT_cf2(T0)
#define ABSOFT_cf3(T0)
#endif

/* _Z introduced to cicumvent IBM and HP silly preprocessor warning.
   e.g. "Macro CFARGT14 invoked with a null argument."
 */
#define _Z

#define  CFARGT14S(S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)                \
 S(T1,1)   S(T2,2)   S(T3,3)    S(T4,4)    S(T5,5)    S(T6,6)    S(T7,7)       \
 S(T8,8)   S(T9,9)   S(TA,10)   S(TB,11)   S(TC,12)   S(TD,13)   S(TE,14)
#define  CFARGT27S(S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
 S(T1,1)   S(T2,2)   S(T3,3)    S(T4,4)    S(T5,5)    S(T6,6)    S(T7,7)       \
 S(T8,8)   S(T9,9)   S(TA,10)   S(TB,11)   S(TC,12)   S(TD,13)   S(TE,14)      \
 S(TF,15)  S(TG,16)  S(TH,17)   S(TI,18)   S(TJ,19)   S(TK,20)   S(TL,21)      \
 S(TM,22)  S(TN,23)  S(TO,24)   S(TP,25)   S(TQ,26)   S(TR,27)

#define  CFARGT14FS(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)           \
 F(T1,1,0) F(T2,2,1) F(T3,3,1)  F(T4,4,1)  F(T5,5,1)  F(T6,6,1)  F(T7,7,1)     \
 F(T8,8,1) F(T9,9,1) F(TA,10,1) F(TB,11,1) F(TC,12,1) F(TD,13,1) F(TE,14,1)    \
 M       CFARGT14S(S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
#define  CFARGT27FS(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
 F(T1,1,0)  F(T2,2,1)  F(T3,3,1)  F(T4,4,1)  F(T5,5,1)  F(T6,6,1)  F(T7,7,1)   \
 F(T8,8,1)  F(T9,9,1)  F(TA,10,1) F(TB,11,1) F(TC,12,1) F(TD,13,1) F(TE,14,1)  \
 F(TF,15,1) F(TG,16,1) F(TH,17,1) F(TI,18,1) F(TJ,19,1) F(TK,20,1) F(TL,21,1)  \
 F(TM,22,1) F(TN,23,1) F(TO,24,1) F(TP,25,1) F(TQ,26,1) F(TR,27,1)             \
 M       CFARGT27S(S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)

#if !(defined(PowerStationFortran)||defined(hpuxFortran800))
/*  Old CFARGT14 -> CFARGT14FS as seen below, for Absoft cross-compile yields:
      SunOS> cc -c -Xa -DAbsoftUNIXFortran c.c
      "c.c", line 406: warning: argument mismatch
    Haven't checked if this is ANSI C or a SunOS bug. SunOS -Xs works ok.
    Behavior is most clearly seen in example:
      #define A 1 , 2
      #define  C(X,Y,Z) x=X. y=Y. z=Z.
      #define  D(X,Y,Z) C(X,Y,Z)
      D(x,A,z)
    Output from preprocessor is: x = x . y = 1 . z = 2 .
 #define CFARGT14(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) \
       CFARGT14FS(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
*/
#define  CFARGT14(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)             \
 F(T1,1,0) F(T2,2,1) F(T3,3,1)  F(T4,4,1)  F(T5,5,1)  F(T6,6,1)  F(T7,7,1)     \
 F(T8,8,1) F(T9,9,1) F(TA,10,1) F(TB,11,1) F(TC,12,1) F(TD,13,1) F(TE,14,1)    \
 M       CFARGT14S(S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
#define  CFARGT27(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
 F(T1,1,0)  F(T2,2,1)  F(T3,3,1)  F(T4,4,1)  F(T5,5,1)  F(T6,6,1)  F(T7,7,1)   \
 F(T8,8,1)  F(T9,9,1)  F(TA,10,1) F(TB,11,1) F(TC,12,1) F(TD,13,1) F(TE,14,1)  \
 F(TF,15,1) F(TG,16,1) F(TH,17,1) F(TI,18,1) F(TJ,19,1) F(TK,20,1) F(TL,21,1)  \
 F(TM,22,1) F(TN,23,1) F(TO,24,1) F(TP,25,1) F(TQ,26,1) F(TR,27,1)             \
 M       CFARGT27S(S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)

#define  CFARGT20(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) \
 F(T1,1,0)  F(T2,2,1)  F(T3,3,1)  F(T4,4,1)  F(T5,5,1)  F(T6,6,1)  F(T7,7,1)   \
 F(T8,8,1)  F(T9,9,1)  F(TA,10,1) F(TB,11,1) F(TC,12,1) F(TD,13,1) F(TE,14,1)  \
 F(TF,15,1) F(TG,16,1) F(TH,17,1) F(TI,18,1) F(TJ,19,1) F(TK,20,1)             \
 S(T1,1)    S(T2,2)    S(T3,3)    S(T4,4)    S(T5,5)    S(T6,6)    S(T7,7)     \
 S(T8,8)    S(T9,9)    S(TA,10)   S(TB,11)   S(TC,12)   S(TD,13)   S(TE,14)    \
 S(TF,15)   S(TG,16)   S(TH,17)   S(TI,18)   S(TJ,19)   S(TK,20)
#define CFARGTA14(F,S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE) \
 F(T1,A1,1,0)  F(T2,A2,2,1)  F(T3,A3,3,1) F(T4,A4,4,1)  F(T5,A5,5,1)  F(T6,A6,6,1)  \
 F(T7,A7,7,1)  F(T8,A8,8,1)  F(T9,A9,9,1) F(TA,AA,10,1) F(TB,AB,11,1) F(TC,AC,12,1) \
 F(TD,AD,13,1) F(TE,AE,14,1) S(T1,1)      S(T2,2)       S(T3,3)       S(T4,4)       \
 S(T5,5)       S(T6,6)       S(T7,7)      S(T8,8)       S(T9,9)       S(TA,10)      \
 S(TB,11)      S(TC,12)      S(TD,13)     S(TE,14)
#if MAX_PREPRO_ARGS>31
#define CFARGTA20(F,S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK) \
 F(T1,A1,1,0)  F(T2,A2,2,1)  F(T3,A3,3,1)  F(T4,A4,4,1)  F(T5,A5,5,1)  F(T6,A6,6,1)  \
 F(T7,A7,7,1)  F(T8,A8,8,1)  F(T9,A9,9,1)  F(TA,AA,10,1) F(TB,AB,11,1) F(TC,AC,12,1) \
 F(TD,AD,13,1) F(TE,AE,14,1) F(TF,AF,15,1) F(TG,AG,16,1) F(TH,AH,17,1) F(TI,AI,18,1) \
 F(TJ,AJ,19,1) F(TK,AK,20,1) S(T1,1)       S(T2,2)       S(T3,3)       S(T4,4)       \
 S(T5,5)       S(T6,6)       S(T7,7)       S(T8,8)       S(T9,9)       S(TA,10)      \
 S(TB,11)      S(TC,12)      S(TD,13)      S(TE,14)      S(TF,15)      S(TG,16)      \
 S(TH,17)      S(TI,18)      S(TJ,19)      S(TK,20)
#define CFARGTA27(F,S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR) \
 F(T1,A1,1,0)  F(T2,A2,2,1)  F(T3,A3,3,1)  F(T4,A4,4,1)  F(T5,A5,5,1)  F(T6,A6,6,1)  \
 F(T7,A7,7,1)  F(T8,A8,8,1)  F(T9,A9,9,1)  F(TA,AA,10,1) F(TB,AB,11,1) F(TC,AC,12,1) \
 F(TD,AD,13,1) F(TE,AE,14,1) F(TF,AF,15,1) F(TG,AG,16,1) F(TH,AH,17,1) F(TI,AI,18,1) \
 F(TJ,AJ,19,1) F(TK,AK,20,1) F(TL,AL,21,1) F(TM,AM,22,1) F(TN,AN,23,1) F(TO,AO,24,1) \
 F(TP,AP,25,1) F(TQ,AQ,26,1) F(TR,AR,27,1) S(T1,1)       S(T2,2)       S(T3,3)       \
 S(T4,4)       S(T5,5)       S(T6,6)       S(T7,7)       S(T8,8)       S(T9,9)       \
 S(TA,10)      S(TB,11)      S(TC,12)      S(TD,13)      S(TE,14)      S(TF,15)      \
 S(TG,16)      S(TH,17)      S(TI,18)      S(TJ,19)      S(TK,20)      S(TL,21)      \
 S(TM,22)      S(TN,23)      S(TO,24)      S(TP,25)      S(TQ,26)      S(TR,27)
#endif
#else
#define  CFARGT14(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)             \
 F(T1,1,0) S(T1,1) F(T2,2,1)  S(T2,2)  F(T3,3,1)  S(T3,3)  F(T4,4,1)  S(T4,4)  \
 F(T5,5,1) S(T5,5) F(T6,6,1)  S(T6,6)  F(T7,7,1)  S(T7,7)  F(T8,8,1)  S(T8,8)  \
 F(T9,9,1) S(T9,9) F(TA,10,1) S(TA,10) F(TB,11,1) S(TB,11) F(TC,12,1) S(TC,12) \
 F(TD,13,1) S(TD,13) F(TE,14,1) S(TE,14)
#define  CFARGT27(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
 F(T1,1,0)  S(T1,1)  F(T2,2,1)  S(T2,2)  F(T3,3,1)  S(T3,3)  F(T4,4,1)  S(T4,4)  \
 F(T5,5,1)  S(T5,5)  F(T6,6,1)  S(T6,6)  F(T7,7,1)  S(T7,7)  F(T8,8,1)  S(T8,8)  \
 F(T9,9,1)  S(T9,9)  F(TA,10,1) S(TA,10) F(TB,11,1) S(TB,11) F(TC,12,1) S(TC,12) \
 F(TD,13,1) S(TD,13) F(TE,14,1) S(TE,14) F(TF,15,1) S(TF,15) F(TG,16,1) S(TG,16) \
 F(TH,17,1) S(TH,17) F(TI,18,1) S(TI,18) F(TJ,19,1) S(TJ,19) F(TK,20,1) S(TK,20) \
 F(TL,21,1) S(TL,21) F(TM,22,1) S(TM,22) F(TN,23,1) S(TN,23) F(TO,24,1) S(TO,24) \
 F(TP,25,1) S(TP,25) F(TQ,26,1) S(TQ,26) F(TR,27,1) S(TR,27)

#define  CFARGT20(F,S,M,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) \
 F(T1,1,0)  S(T1,1)  F(T2,2,1)  S(T2,2)  F(T3,3,1)  S(T3,3)  F(T4,4,1)  S(T4,4)  \
 F(T5,5,1)  S(T5,5)  F(T6,6,1)  S(T6,6)  F(T7,7,1)  S(T7,7)  F(T8,8,1)  S(T8,8)  \
 F(T9,9,1)  S(T9,9)  F(TA,10,1) S(TA,10) F(TB,11,1) S(TB,11) F(TC,12,1) S(TC,12) \
 F(TD,13,1) S(TD,13) F(TE,14,1) S(TE,14) F(TF,15,1) S(TF,15) F(TG,16,1) S(TG,16) \
 F(TH,17,1) S(TH,17) F(TI,18,1) S(TI,18) F(TJ,19,1) S(TJ,19) F(TK,20,1) S(TK,20)
#define CFARGTA14(F,S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE) \
 F(T1,A1,1,0)  S(T1,1)  F(T2,A2,2,1)  S(T2,2)  F(T3,A3,3,1)  S(T3,3)           \
 F(T4,A4,4,1)  S(T4,4)  F(T5,A5,5,1)  S(T5,5)  F(T6,A6,6,1)  S(T6,6)           \
 F(T7,A7,7,1)  S(T7,7)  F(T8,A8,8,1)  S(T8,8)  F(T9,A9,9,1)  S(T9,9)           \
 F(TA,AA,10,1) S(TA,10) F(TB,AB,11,1) S(TB,11) F(TC,AC,12,1) S(TC,12)          \
 F(TD,AD,13,1) S(TD,13) F(TE,AE,14,1) S(TE,14)
#if MAX_PREPRO_ARGS>31
#define CFARGTA20(F,S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK) \
 F(T1,A1,1,0)  S(T1,1)  F(T2,A2,2,1)  S(T2,2)  F(T3,A3,3,1)  S(T3,3)           \
 F(T4,A4,4,1)  S(T4,4)  F(T5,A5,5,1)  S(T5,5)  F(T6,A6,6,1)  S(T6,6)           \
 F(T7,A7,7,1)  S(T7,7)  F(T8,A8,8,1)  S(T8,8)  F(T9,A9,9,1)  S(T9,9)           \
 F(TA,AA,10,1) S(TA,10) F(TB,AB,11,1) S(TB,11) F(TC,AC,12,1) S(TC,12)          \
 F(TD,AD,13,1) S(TD,13) F(TE,AE,14,1) S(TE,14) F(TF,AF,15,1) S(TF,15)          \
 F(TG,AG,16,1) S(TG,16) F(TH,AH,17,1) S(TH,17) F(TI,AI,18,1) S(TI,18)          \
 F(TJ,AJ,19,1) S(TJ,19) F(TK,AK,20,1) S(TK,20)                
#define CFARGTA27(F,S,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR) \
 F(T1,A1,1,0)  S(T1,1)  F(T2,A2,2,1)  S(T2,2)  F(T3,A3,3,1)  S(T3,3)           \
 F(T4,A4,4,1)  S(T4,4)  F(T5,A5,5,1)  S(T5,5)  F(T6,A6,6,1)  S(T6,6)           \
 F(T7,A7,7,1)  S(T7,7)  F(T8,A8,8,1)  S(T8,8)  F(T9,A9,9,1)  S(T9,9)           \
 F(TA,AA,10,1) S(TA,10) F(TB,AB,11,1) S(TB,11) F(TC,AC,12,1) S(TC,12)          \
 F(TD,AD,13,1) S(TD,13) F(TE,AE,14,1) S(TE,14) F(TF,AF,15,1) S(TF,15)          \
 F(TG,AG,16,1) S(TG,16) F(TH,AH,17,1) S(TH,17) F(TI,AI,18,1) S(TI,18)          \
 F(TJ,AJ,19,1) S(TJ,19) F(TK,AK,20,1) S(TK,20) F(TL,AL,21,1) S(TL,21)          \
 F(TM,AM,22,1) S(TM,22) F(TN,AN,23,1) S(TN,23) F(TO,AO,24,1) S(TO,24)          \
 F(TP,AP,25,1) S(TP,25) F(TQ,AQ,26,1) S(TQ,26) F(TR,AR,27,1) S(TR,27)
#endif
#endif


#define PROTOCCALLSFSUB1( UN,LN,T1) \
        PROTOCCALLSFSUB14(UN,LN,T1,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB2( UN,LN,T1,T2) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB3( UN,LN,T1,T2,T3) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB4( UN,LN,T1,T2,T3,T4) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB5( UN,LN,T1,T2,T3,T4,T5) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB6( UN,LN,T1,T2,T3,T4,T5,T6) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB7( UN,LN,T1,T2,T3,T4,T5,T6,T7) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB8( UN,LN,T1,T2,T3,T4,T5,T6,T7,T8) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB9( UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB11(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB12(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,CF_0,CF_0)
#define PROTOCCALLSFSUB13(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD) \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,CF_0)


#define PROTOCCALLSFSUB15(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF) \
        PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB16(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG) \
        PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB17(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH) \
        PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB18(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI) \
        PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,CF_0,CF_0)
#define PROTOCCALLSFSUB19(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ) \
        PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,CF_0)

#define PROTOCCALLSFSUB21(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB22(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB23(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB24(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,CF_0,CF_0,CF_0)
#define PROTOCCALLSFSUB25(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,CF_0,CF_0)
#define PROTOCCALLSFSUB26(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,CF_0)


#ifndef FCALLSC_QUALIFIER
#ifdef VISUAL_CPLUSPLUS
#define FCALLSC_QUALIFIER __stdcall
#else
#define FCALLSC_QUALIFIER
#endif
#endif

#ifdef __cplusplus
#define CFextern extern "C"
#else
#define CFextern extern
#endif


#ifdef CFSUBASFUN
#define PROTOCCALLSFSUB0(UN,LN) \
   PROTOCCALLSFFUN0( VOID,UN,LN)
#define PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) \
   PROTOCCALLSFFUN14(VOID,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
#define PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)\
   PROTOCCALLSFFUN20(VOID,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)
#define PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)\
   PROTOCCALLSFFUN27(VOID,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)
#else
/* Note: Prevent compiler warnings, null #define PROTOCCALLSFSUB14/20 after 
   #include-ing cfortran.h if calling the FORTRAN wrapper within the same 
   source code where the wrapper is created. */
#define PROTOCCALLSFSUB0(UN,LN)     _(VOID,_cfPU)(CFC_(UN,LN))();
#ifndef __CF__KnR
#define PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) \
 _(VOID,_cfPU)(CFC_(UN,LN))( CFARGT14(NCF,KCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) );
#define PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)\
 _(VOID,_cfPU)(CFC_(UN,LN))( CFARGT20(NCF,KCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) );
#define PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)\
 _(VOID,_cfPU)(CFC_(UN,LN))( CFARGT27(NCF,KCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) );
#else
#define PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)     \
         PROTOCCALLSFSUB0(UN,LN)
#define PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) \
         PROTOCCALLSFSUB0(UN,LN)
#define PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
         PROTOCCALLSFSUB0(UN,LN)
#endif
#endif


#ifdef OLD_VAXC                                  /* Allow %CC-I-PARAMNOTUSED. */
#pragma standard
#endif


#define CCALLSFSUB1( UN,LN,T1,                        A1)         \
        CCALLSFSUB5 (UN,LN,T1,CF_0,CF_0,CF_0,CF_0,A1,0,0,0,0)
#define CCALLSFSUB2( UN,LN,T1,T2,                     A1,A2)      \
        CCALLSFSUB5 (UN,LN,T1,T2,CF_0,CF_0,CF_0,A1,A2,0,0,0)
#define CCALLSFSUB3( UN,LN,T1,T2,T3,                  A1,A2,A3)   \
        CCALLSFSUB5 (UN,LN,T1,T2,T3,CF_0,CF_0,A1,A2,A3,0,0)
#define CCALLSFSUB4( UN,LN,T1,T2,T3,T4,               A1,A2,A3,A4)\
        CCALLSFSUB5 (UN,LN,T1,T2,T3,T4,CF_0,A1,A2,A3,A4,0)
#define CCALLSFSUB5( UN,LN,T1,T2,T3,T4,T5,            A1,A2,A3,A4,A5)          \
        CCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,CF_0,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,0,0,0,0,0)
#define CCALLSFSUB6( UN,LN,T1,T2,T3,T4,T5,T6,         A1,A2,A3,A4,A5,A6)       \
        CCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,T6,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,0,0,0,0)
#define CCALLSFSUB7( UN,LN,T1,T2,T3,T4,T5,T6,T7,      A1,A2,A3,A4,A5,A6,A7)    \
        CCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,T6,T7,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,0,0,0)
#define CCALLSFSUB8( UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,   A1,A2,A3,A4,A5,A6,A7,A8) \
        CCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,0,0)
#define CCALLSFSUB9( UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,A1,A2,A3,A4,A5,A6,A7,A8,A9)\
        CCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,0)
#define CCALLSFSUB10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA)\
        CCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,0,0,0,0)
#define CCALLSFSUB11(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB)\
        CCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,0,0,0)
#define CCALLSFSUB12(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC)\
        CCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,0,0)
#define CCALLSFSUB13(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD)\
        CCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,0)

#ifdef __cplusplus
#define CPPPROTOCLSFSUB0( UN,LN)
#define CPPPROTOCLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
#define CPPPROTOCLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)
#define CPPPROTOCLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)
#else
#define CPPPROTOCLSFSUB0(UN,LN) \
        PROTOCCALLSFSUB0(UN,LN)
#define CPPPROTOCLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)     \
        PROTOCCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
#define CPPPROTOCLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) \
        PROTOCCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)
#define CPPPROTOCLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
        PROTOCCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)
#endif

#ifdef CFSUBASFUN
#define CCALLSFSUB0(UN,LN) CCALLSFFUN0(UN,LN)
#define CCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE)\
        CCALLSFFUN14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE)
#else
/* do{...}while(0) allows if(a==b) FORT(); else BORT(); */
#define CCALLSFSUB0( UN,LN) do{CPPPROTOCLSFSUB0(UN,LN) CFC_(UN,LN)();}while(0)
#define CCALLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE)\
do{VVCF(T1,A1,B1) VVCF(T2,A2,B2) VVCF(T3,A3,B3) VVCF(T4,A4,B4) VVCF(T5,A5,B5)  \
   VVCF(T6,A6,B6) VVCF(T7,A7,B7) VVCF(T8,A8,B8) VVCF(T9,A9,B9) VVCF(TA,AA,B10) \
   VVCF(TB,AB,B11) VVCF(TC,AC,B12) VVCF(TD,AD,B13) VVCF(TE,AE,B14)             \
   CPPPROTOCLSFSUB14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)          \
   ACF(LN,T1,A1,1)  ACF(LN,T2,A2,2)  ACF(LN,T3,A3,3)                           \
   ACF(LN,T4,A4,4)  ACF(LN,T5,A5,5)  ACF(LN,T6,A6,6)  ACF(LN,T7,A7,7)          \
   ACF(LN,T8,A8,8)  ACF(LN,T9,A9,9)  ACF(LN,TA,AA,10) ACF(LN,TB,AB,11)         \
   ACF(LN,TC,AC,12) ACF(LN,TD,AD,13) ACF(LN,TE,AE,14)                          \
   CFC_(UN,LN)( CFARGTA14(AACF,JCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE) );\
   WCF(T1,A1,1)  WCF(T2,A2,2)  WCF(T3,A3,3)  WCF(T4,A4,4)  WCF(T5,A5,5)        \
   WCF(T6,A6,6)  WCF(T7,A7,7)  WCF(T8,A8,8)  WCF(T9,A9,9)  WCF(TA,AA,10)       \
   WCF(TB,AB,11) WCF(TC,AC,12) WCF(TD,AD,13) WCF(TE,AE,14)      }while(0)
#endif


#if MAX_PREPRO_ARGS>31
#define CCALLSFSUB15(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF)\
        CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,CF_0,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,0,0,0,0,0)
#define CCALLSFSUB16(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG)\
        CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,0,0,0,0)
#define CCALLSFSUB17(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH)\
        CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,0,0,0)
#define CCALLSFSUB18(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI)\
        CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,0,0)
#define CCALLSFSUB19(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ)\
        CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,0)

#ifdef CFSUBASFUN
#define CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH, \
        TI,TJ,TK, A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK) \
        CCALLSFFUN20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH, \
        TI,TJ,TK, A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK)
#else
#define CCALLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH, \
        TI,TJ,TK, A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK) \
do{VVCF(T1,A1,B1)  VVCF(T2,A2,B2)  VVCF(T3,A3,B3)  VVCF(T4,A4,B4)  VVCF(T5,A5,B5)   \
   VVCF(T6,A6,B6)  VVCF(T7,A7,B7)  VVCF(T8,A8,B8)  VVCF(T9,A9,B9)  VVCF(TA,AA,B10)  \
   VVCF(TB,AB,B11) VVCF(TC,AC,B12) VVCF(TD,AD,B13) VVCF(TE,AE,B14) VVCF(TF,AF,B15)  \
   VVCF(TG,AG,B16) VVCF(TH,AH,B17) VVCF(TI,AI,B18) VVCF(TJ,AJ,B19) VVCF(TK,AK,B20)  \
   CPPPROTOCLSFSUB20(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)  \
   ACF(LN,T1,A1,1)  ACF(LN,T2,A2,2)  ACF(LN,T3,A3,3)  ACF(LN,T4,A4,4)          \
   ACF(LN,T5,A5,5)  ACF(LN,T6,A6,6)  ACF(LN,T7,A7,7)  ACF(LN,T8,A8,8)          \
   ACF(LN,T9,A9,9)  ACF(LN,TA,AA,10) ACF(LN,TB,AB,11) ACF(LN,TC,AC,12)         \
   ACF(LN,TD,AD,13) ACF(LN,TE,AE,14) ACF(LN,TF,AF,15) ACF(LN,TG,AG,16)         \
   ACF(LN,TH,AH,17) ACF(LN,TI,AI,18) ACF(LN,TJ,AJ,19) ACF(LN,TK,AK,20)         \
   CFC_(UN,LN)( CFARGTA20(AACF,JCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK) ); \
 WCF(T1,A1,1)  WCF(T2,A2,2)  WCF(T3,A3,3)  WCF(T4,A4,4)  WCF(T5,A5,5)  WCF(T6,A6,6)  \
 WCF(T7,A7,7)  WCF(T8,A8,8)  WCF(T9,A9,9)  WCF(TA,AA,10) WCF(TB,AB,11) WCF(TC,AC,12) \
 WCF(TD,AD,13) WCF(TE,AE,14) WCF(TF,AF,15) WCF(TG,AG,16) WCF(TH,AH,17) WCF(TI,AI,18) \
 WCF(TJ,AJ,19) WCF(TK,AK,20) }while(0)
#endif
#endif         /* MAX_PREPRO_ARGS */

#if MAX_PREPRO_ARGS>31
#define CCALLSFSUB21(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL)\
        CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,0,0,0,0,0,0)
#define CCALLSFSUB22(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM)\
        CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,CF_0,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,0,0,0,0,0)
#define CCALLSFSUB23(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN)\
        CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,0,0,0,0)
#define CCALLSFSUB24(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO)\
        CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,0,0,0)
#define CCALLSFSUB25(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP)\
        CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,0,0)
#define CCALLSFSUB26(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ)\
        CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,0)

#ifdef CFSUBASFUN
#define CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR, \
                           A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR) \
        CCALLSFFUN27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR, \
                           A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR)
#else
#define CCALLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR, \
                           A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR) \
do{VVCF(T1,A1,B1)  VVCF(T2,A2,B2)  VVCF(T3,A3,B3)  VVCF(T4,A4,B4)  VVCF(T5,A5,B5)   \
   VVCF(T6,A6,B6)  VVCF(T7,A7,B7)  VVCF(T8,A8,B8)  VVCF(T9,A9,B9)  VVCF(TA,AA,B10)  \
   VVCF(TB,AB,B11) VVCF(TC,AC,B12) VVCF(TD,AD,B13) VVCF(TE,AE,B14) VVCF(TF,AF,B15)  \
   VVCF(TG,AG,B16) VVCF(TH,AH,B17) VVCF(TI,AI,B18) VVCF(TJ,AJ,B19) VVCF(TK,AK,B20)  \
   VVCF(TL,AL,B21) VVCF(TM,AM,B22) VVCF(TN,AN,B23) VVCF(TO,AO,B24) VVCF(TP,AP,B25)  \
   VVCF(TQ,AQ,B26) VVCF(TR,AR,B27)                                                  \
   CPPPROTOCLSFSUB27(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
   ACF(LN,T1,A1,1)  ACF(LN,T2,A2,2)  ACF(LN,T3,A3,3)  ACF(LN,T4,A4,4)          \
   ACF(LN,T5,A5,5)  ACF(LN,T6,A6,6)  ACF(LN,T7,A7,7)  ACF(LN,T8,A8,8)          \
   ACF(LN,T9,A9,9)  ACF(LN,TA,AA,10) ACF(LN,TB,AB,11) ACF(LN,TC,AC,12)         \
   ACF(LN,TD,AD,13) ACF(LN,TE,AE,14) ACF(LN,TF,AF,15) ACF(LN,TG,AG,16)         \
   ACF(LN,TH,AH,17) ACF(LN,TI,AI,18) ACF(LN,TJ,AJ,19) ACF(LN,TK,AK,20)         \
   ACF(LN,TL,AL,21) ACF(LN,TM,AM,22) ACF(LN,TN,AN,23) ACF(LN,TO,AO,24)         \
   ACF(LN,TP,AP,25) ACF(LN,TQ,AQ,26) ACF(LN,TR,AR,27)                          \
   CFC_(UN,LN)( CFARGTA27(AACF,JCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR,\
                                   A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE,AF,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR) ); \
 WCF(T1,A1,1)  WCF(T2,A2,2)  WCF(T3,A3,3)  WCF(T4,A4,4)  WCF(T5,A5,5)  WCF(T6,A6,6)  \
 WCF(T7,A7,7)  WCF(T8,A8,8)  WCF(T9,A9,9)  WCF(TA,AA,10) WCF(TB,AB,11) WCF(TC,AC,12) \
 WCF(TD,AD,13) WCF(TE,AE,14) WCF(TF,AF,15) WCF(TG,AG,16) WCF(TH,AH,17) WCF(TI,AI,18) \
 WCF(TJ,AJ,19) WCF(TK,AK,20) WCF(TL,AL,21) WCF(TM,AM,22) WCF(TN,AN,23) WCF(TO,AO,24) \
 WCF(TP,AP,25) WCF(TQ,AQ,26) WCF(TR,AR,27) }while(0)
#endif
#endif         /* MAX_PREPRO_ARGS */

/*-------------------------------------------------------------------------*/

/*               UTILITIES FOR C TO CALL FORTRAN FUNCTIONS                 */

/*N.B. PROTOCCALLSFFUNn(..) generates code, whether or not the FORTRAN
  function is called. Therefore, especially for creator's of C header files
  for large FORTRAN libraries which include many functions, to reduce
  compile time and object code size, it may be desirable to create
  preprocessor directives to allow users to create code for only those
  functions which they use.                                                */

/* The following defines the maximum length string that a function can return.
   Of course it may be undefine-d and re-define-d before individual
   PROTOCCALLSFFUNn(..) as required. It would also be nice to have this derived
   from the individual machines' limits.                                      */
#define MAX_LEN_FORTRAN_FUNCTION_STRING 0x4FE

/* The following defines a character used by CFORTRAN.H to flag the end of a
   string coming out of a FORTRAN routine.                                 */
#define CFORTRAN_NON_CHAR 0x7F

#ifdef OLD_VAXC                                /* Prevent %CC-I-PARAMNOTUSED. */
#pragma nostandard
#endif

#define _SEP_(TN,C,cfCOMMA)     _(__SEP_,C)(TN,cfCOMMA)
#define __SEP_0(TN,cfCOMMA)  
#define __SEP_1(TN,cfCOMMA)     _Icf(2,SEP,TN,cfCOMMA,0)
#define        INT_cfSEP(T,B) _(A,B)
#define       INTV_cfSEP(T,B) INT_cfSEP(T,B)
#define      INTVV_cfSEP(T,B) INT_cfSEP(T,B)
#define     INTVVV_cfSEP(T,B) INT_cfSEP(T,B)
#define    INTVVVV_cfSEP(T,B) INT_cfSEP(T,B)
#define   INTVVVVV_cfSEP(T,B) INT_cfSEP(T,B)
#define  INTVVVVVV_cfSEP(T,B) INT_cfSEP(T,B)
#define INTVVVVVVV_cfSEP(T,B) INT_cfSEP(T,B)
#define       PINT_cfSEP(T,B) INT_cfSEP(T,B)
#define      PVOID_cfSEP(T,B) INT_cfSEP(T,B)
#define    ROUTINE_cfSEP(T,B) INT_cfSEP(T,B)
#define     SIMPLE_cfSEP(T,B) INT_cfSEP(T,B)
#define       VOID_cfSEP(T,B) INT_cfSEP(T,B)    /* For FORTRAN calls C subr.s.*/
#define     STRING_cfSEP(T,B) INT_cfSEP(T,B)
#define    STRINGV_cfSEP(T,B) INT_cfSEP(T,B)
#define    PSTRING_cfSEP(T,B) INT_cfSEP(T,B)
#define   PSTRINGV_cfSEP(T,B) INT_cfSEP(T,B)
#define   PNSTRING_cfSEP(T,B) INT_cfSEP(T,B)
#define   PPSTRING_cfSEP(T,B) INT_cfSEP(T,B)
#define    ZTRINGV_cfSEP(T,B) INT_cfSEP(T,B)
#define   PZTRINGV_cfSEP(T,B) INT_cfSEP(T,B)
                         
#if defined(SIGNED_BYTE) || !defined(UNSIGNED_BYTE)
#ifdef OLD_VAXC
#define INTEGER_BYTE               char    /* Old VAXC barfs on 'signed char' */
#else
#define INTEGER_BYTE        signed char    /* default */
#endif
#else
#define INTEGER_BYTE        unsigned char
#endif
#define    BYTEVVVVVVV_cfTYPE INTEGER_BYTE
#define  DOUBLEVVVVVVV_cfTYPE DOUBLE_PRECISION 
#define   FLOATVVVVVVV_cfTYPE FORTRAN_REAL
#define     INTVVVVVVV_cfTYPE int
#define LOGICALVVVVVVV_cfTYPE int
#define    LONGVVVVVVV_cfTYPE long
#define   SHORTVVVVVVV_cfTYPE short
#define          PBYTE_cfTYPE INTEGER_BYTE
#define        PDOUBLE_cfTYPE DOUBLE_PRECISION 
#define         PFLOAT_cfTYPE FORTRAN_REAL
#define           PINT_cfTYPE int
#define       PLOGICAL_cfTYPE int
#define          PLONG_cfTYPE long
#define         PSHORT_cfTYPE short

#define CFARGS0(A,T,V,W,X,Y,Z) _3(T,_cf,A)
#define CFARGS1(A,T,V,W,X,Y,Z) _3(T,_cf,A)(V)
#define CFARGS2(A,T,V,W,X,Y,Z) _3(T,_cf,A)(V,W)
#define CFARGS3(A,T,V,W,X,Y,Z) _3(T,_cf,A)(V,W,X)
#define CFARGS4(A,T,V,W,X,Y,Z) _3(T,_cf,A)(V,W,X,Y)
#define CFARGS5(A,T,V,W,X,Y,Z) _3(T,_cf,A)(V,W,X,Y,Z)

#define  _Icf(N,T,I,X,Y)                 _(I,_cfINT)(N,T,I,X,Y,0)
#define _Icf4(N,T,I,X,Y,Z)               _(I,_cfINT)(N,T,I,X,Y,Z)
#define           BYTE_cfINT(N,A,B,X,Y,Z)        DOUBLE_cfINT(N,A,B,X,Y,Z)
#define         DOUBLE_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INT,B,X,Y,Z,0)
#define          FLOAT_cfINT(N,A,B,X,Y,Z)        DOUBLE_cfINT(N,A,B,X,Y,Z)
#define            INT_cfINT(N,A,B,X,Y,Z)        DOUBLE_cfINT(N,A,B,X,Y,Z)
#define        LOGICAL_cfINT(N,A,B,X,Y,Z)        DOUBLE_cfINT(N,A,B,X,Y,Z)
#define           LONG_cfINT(N,A,B,X,Y,Z)        DOUBLE_cfINT(N,A,B,X,Y,Z)
#define          SHORT_cfINT(N,A,B,X,Y,Z)        DOUBLE_cfINT(N,A,B,X,Y,Z)
#define          PBYTE_cfINT(N,A,B,X,Y,Z)       PDOUBLE_cfINT(N,A,B,X,Y,Z)
#define        PDOUBLE_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,PINT,B,X,Y,Z,0)
#define         PFLOAT_cfINT(N,A,B,X,Y,Z)       PDOUBLE_cfINT(N,A,B,X,Y,Z)
#define           PINT_cfINT(N,A,B,X,Y,Z)       PDOUBLE_cfINT(N,A,B,X,Y,Z)
#define       PLOGICAL_cfINT(N,A,B,X,Y,Z)       PDOUBLE_cfINT(N,A,B,X,Y,Z)
#define          PLONG_cfINT(N,A,B,X,Y,Z)       PDOUBLE_cfINT(N,A,B,X,Y,Z)
#define         PSHORT_cfINT(N,A,B,X,Y,Z)       PDOUBLE_cfINT(N,A,B,X,Y,Z)
#define          BYTEV_cfINT(N,A,B,X,Y,Z)       DOUBLEV_cfINT(N,A,B,X,Y,Z)
#define         BYTEVV_cfINT(N,A,B,X,Y,Z)      DOUBLEVV_cfINT(N,A,B,X,Y,Z)
#define        BYTEVVV_cfINT(N,A,B,X,Y,Z)     DOUBLEVVV_cfINT(N,A,B,X,Y,Z)
#define       BYTEVVVV_cfINT(N,A,B,X,Y,Z)    DOUBLEVVVV_cfINT(N,A,B,X,Y,Z)
#define      BYTEVVVVV_cfINT(N,A,B,X,Y,Z)   DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z)
#define     BYTEVVVVVV_cfINT(N,A,B,X,Y,Z)  DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z)
#define    BYTEVVVVVVV_cfINT(N,A,B,X,Y,Z) DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z)
#define        DOUBLEV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTV,B,X,Y,Z,0)
#define       DOUBLEVV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTVV,B,X,Y,Z,0)
#define      DOUBLEVVV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTVVV,B,X,Y,Z,0)
#define     DOUBLEVVVV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTVVVV,B,X,Y,Z,0)
#define    DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTVVVVV,B,X,Y,Z,0)
#define   DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTVVVVVV,B,X,Y,Z,0)
#define  DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,INTVVVVVVV,B,X,Y,Z,0)
#define         FLOATV_cfINT(N,A,B,X,Y,Z)       DOUBLEV_cfINT(N,A,B,X,Y,Z)
#define        FLOATVV_cfINT(N,A,B,X,Y,Z)      DOUBLEVV_cfINT(N,A,B,X,Y,Z)
#define       FLOATVVV_cfINT(N,A,B,X,Y,Z)     DOUBLEVVV_cfINT(N,A,B,X,Y,Z)
#define      FLOATVVVV_cfINT(N,A,B,X,Y,Z)    DOUBLEVVVV_cfINT(N,A,B,X,Y,Z)
#define     FLOATVVVVV_cfINT(N,A,B,X,Y,Z)   DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z)
#define    FLOATVVVVVV_cfINT(N,A,B,X,Y,Z)  DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z)
#define   FLOATVVVVVVV_cfINT(N,A,B,X,Y,Z) DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z)
#define           INTV_cfINT(N,A,B,X,Y,Z)       DOUBLEV_cfINT(N,A,B,X,Y,Z)
#define          INTVV_cfINT(N,A,B,X,Y,Z)      DOUBLEVV_cfINT(N,A,B,X,Y,Z)
#define         INTVVV_cfINT(N,A,B,X,Y,Z)     DOUBLEVVV_cfINT(N,A,B,X,Y,Z)
#define        INTVVVV_cfINT(N,A,B,X,Y,Z)    DOUBLEVVVV_cfINT(N,A,B,X,Y,Z)
#define       INTVVVVV_cfINT(N,A,B,X,Y,Z)   DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z)
#define      INTVVVVVV_cfINT(N,A,B,X,Y,Z)  DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z)
#define     INTVVVVVVV_cfINT(N,A,B,X,Y,Z) DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z)
#define       LOGICALV_cfINT(N,A,B,X,Y,Z)       DOUBLEV_cfINT(N,A,B,X,Y,Z)
#define      LOGICALVV_cfINT(N,A,B,X,Y,Z)      DOUBLEVV_cfINT(N,A,B,X,Y,Z)
#define     LOGICALVVV_cfINT(N,A,B,X,Y,Z)     DOUBLEVVV_cfINT(N,A,B,X,Y,Z)
#define    LOGICALVVVV_cfINT(N,A,B,X,Y,Z)    DOUBLEVVVV_cfINT(N,A,B,X,Y,Z)
#define   LOGICALVVVVV_cfINT(N,A,B,X,Y,Z)   DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z)
#define  LOGICALVVVVVV_cfINT(N,A,B,X,Y,Z)  DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z)
#define LOGICALVVVVVVV_cfINT(N,A,B,X,Y,Z) DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z)
#define          LONGV_cfINT(N,A,B,X,Y,Z)       DOUBLEV_cfINT(N,A,B,X,Y,Z)
#define         LONGVV_cfINT(N,A,B,X,Y,Z)      DOUBLEVV_cfINT(N,A,B,X,Y,Z)
#define        LONGVVV_cfINT(N,A,B,X,Y,Z)     DOUBLEVVV_cfINT(N,A,B,X,Y,Z)
#define       LONGVVVV_cfINT(N,A,B,X,Y,Z)    DOUBLEVVVV_cfINT(N,A,B,X,Y,Z)
#define      LONGVVVVV_cfINT(N,A,B,X,Y,Z)   DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z)
#define     LONGVVVVVV_cfINT(N,A,B,X,Y,Z)  DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z)
#define    LONGVVVVVVV_cfINT(N,A,B,X,Y,Z) DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z)
#define         SHORTV_cfINT(N,A,B,X,Y,Z)       DOUBLEV_cfINT(N,A,B,X,Y,Z)
#define        SHORTVV_cfINT(N,A,B,X,Y,Z)      DOUBLEVV_cfINT(N,A,B,X,Y,Z)
#define       SHORTVVV_cfINT(N,A,B,X,Y,Z)     DOUBLEVVV_cfINT(N,A,B,X,Y,Z)
#define      SHORTVVVV_cfINT(N,A,B,X,Y,Z)    DOUBLEVVVV_cfINT(N,A,B,X,Y,Z)
#define     SHORTVVVVV_cfINT(N,A,B,X,Y,Z)   DOUBLEVVVVV_cfINT(N,A,B,X,Y,Z)
#define    SHORTVVVVVV_cfINT(N,A,B,X,Y,Z)  DOUBLEVVVVVV_cfINT(N,A,B,X,Y,Z)
#define   SHORTVVVVVVV_cfINT(N,A,B,X,Y,Z) DOUBLEVVVVVVV_cfINT(N,A,B,X,Y,Z)
#define          PVOID_cfINT(N,A,B,X,Y,Z) _(CFARGS,N)(A,B,B,X,Y,Z,0)
#define        ROUTINE_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
/*CRAY coughs on the first,
  i.e. the usual trouble of not being able to
  define macros to macros with arguments. 
  New ultrix is worse, it coughs on all such uses.
 */
/*#define       SIMPLE_cfINT                    PVOID_cfINT*/
#define         SIMPLE_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define           VOID_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define         STRING_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define        STRINGV_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define        PSTRING_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define       PSTRINGV_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define       PNSTRING_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define       PPSTRING_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define        ZTRINGV_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define       PZTRINGV_cfINT(N,A,B,X,Y,Z)         PVOID_cfINT(N,A,B,X,Y,Z)
#define           CF_0_cfINT(N,A,B,X,Y,Z)
                         

#define   UCF(TN,I,C)  _SEP_(TN,C,cfCOMMA) _Icf(2,U,TN,_(A,I),0)
#define  UUCF(TN,I,C)  _SEP_(TN,C,cfCOMMA) _SEP_(TN,1,I) 
#define UUUCF(TN,I,C)  _SEP_(TN,C,cfCOLON) _Icf(2,U,TN,_(A,I),0)
#define        INT_cfU(T,A) _(T,VVVVVVV_cfTYPE)   A
#define       INTV_cfU(T,A) _(T,VVVVVV_cfTYPE)  * A
#define      INTVV_cfU(T,A) _(T,VVVVV_cfTYPE)   * A
#define     INTVVV_cfU(T,A) _(T,VVVV_cfTYPE)    * A
#define    INTVVVV_cfU(T,A) _(T,VVV_cfTYPE)     * A
#define   INTVVVVV_cfU(T,A) _(T,VV_cfTYPE)      * A
#define  INTVVVVVV_cfU(T,A) _(T,V_cfTYPE)       * A
#define INTVVVVVVV_cfU(T,A) _(T,_cfTYPE)        * A
#define       PINT_cfU(T,A) _(T,_cfTYPE)        * A
#define      PVOID_cfU(T,A) void  *A 
#define    ROUTINE_cfU(T,A) void (*A)(CF_NULL_PROTO) 
#define       VOID_cfU(T,A) void   A    /* Needed for C calls FORTRAN sub.s.  */
#define     STRING_cfU(T,A) char  *A    /*            via VOID and wrapper.   */
#define    STRINGV_cfU(T,A) char  *A
#define    PSTRING_cfU(T,A) char  *A
#define   PSTRINGV_cfU(T,A) char  *A
#define    ZTRINGV_cfU(T,A) char  *A
#define   PZTRINGV_cfU(T,A) char  *A

/* VOID breaks U into U and UU. */
#define       INT_cfUU(T,A) _(T,VVVVVVV_cfTYPE) A
#define      VOID_cfUU(T,A)             /* Needed for FORTRAN calls C sub.s.  */
#define    STRING_cfUU(T,A) char *A 


#define      BYTE_cfPU(A)   CFextern INTEGER_BYTE      FCALLSC_QUALIFIER A
#define    DOUBLE_cfPU(A)   CFextern DOUBLE_PRECISION  FCALLSC_QUALIFIER A
#if ! (defined(FLOATFUNCTIONTYPE)&&defined(ASSIGNFLOAT)&&defined(RETURNFLOAT))
#define     FLOAT_cfPU(A)   CFextern FORTRAN_REAL      FCALLSC_QUALIFIER A
#else				   	                   
#define     FLOAT_cfPU(A)   CFextern FLOATFUNCTIONTYPE FCALLSC_QUALIFIER A
#endif				   	                   
#define       INT_cfPU(A)   CFextern int   FCALLSC_QUALIFIER   A
#define   LOGICAL_cfPU(A)   CFextern int   FCALLSC_QUALIFIER   A
#define      LONG_cfPU(A)   CFextern long  FCALLSC_QUALIFIER   A
#define     SHORT_cfPU(A)   CFextern short FCALLSC_QUALIFIER   A
#define    STRING_cfPU(A)   CFextern void  FCALLSC_QUALIFIER   A
#define      VOID_cfPU(A)   CFextern void  FCALLSC_QUALIFIER   A

#define    BYTE_cfE INTEGER_BYTE     A0;
#define  DOUBLE_cfE DOUBLE_PRECISION A0;
#if ! (defined(FLOATFUNCTIONTYPE)&&defined(ASSIGNFLOAT)&&defined(RETURNFLOAT))
#define   FLOAT_cfE FORTRAN_REAL  A0;
#else
#define   FLOAT_cfE FORTRAN_REAL AA0;   FLOATFUNCTIONTYPE A0;
#endif
#define     INT_cfE int    A0;
#define LOGICAL_cfE int    A0;
#define    LONG_cfE long   A0;
#define   SHORT_cfE short  A0;
#define    VOID_cfE
#ifdef vmsFortran
#define  STRING_cfE static char AA0[1+MAX_LEN_FORTRAN_FUNCTION_STRING];        \
                       static fstring A0 =                                     \
             {MAX_LEN_FORTRAN_FUNCTION_STRING,DSC$K_DTYPE_T,DSC$K_CLASS_S,AA0};\
               memset(AA0, CFORTRAN_NON_CHAR, MAX_LEN_FORTRAN_FUNCTION_STRING);\
                                    *(AA0+MAX_LEN_FORTRAN_FUNCTION_STRING)='\0';
#else
#ifdef CRAYFortran
#define  STRING_cfE static char AA0[1+MAX_LEN_FORTRAN_FUNCTION_STRING];        \
                   static _fcd A0; *(AA0+MAX_LEN_FORTRAN_FUNCTION_STRING)='\0';\
                memset(AA0,CFORTRAN_NON_CHAR, MAX_LEN_FORTRAN_FUNCTION_STRING);\
                            A0 = _cptofcd(AA0,MAX_LEN_FORTRAN_FUNCTION_STRING);
#else
/* 'cc: SC3.0.1 13 Jul 1994' barfs on char A0[0x4FE+1]; 
 * char A0[0x4FE +1]; char A0[1+0x4FE]; are both OK.     */
#define STRING_cfE static char A0[1+MAX_LEN_FORTRAN_FUNCTION_STRING];          \
                       memset(A0, CFORTRAN_NON_CHAR,                           \
                              MAX_LEN_FORTRAN_FUNCTION_STRING);                \
                       *(A0+MAX_LEN_FORTRAN_FUNCTION_STRING)='\0';
#endif
#endif
/* ESTRING must use static char. array which is guaranteed to exist after
   function returns.                                                     */

/* N.B.i) The diff. for 0 (Zero) and >=1 arguments.
       ii)That the following create an unmatched bracket, i.e. '(', which
          must of course be matched in the call.
       iii)Commas must be handled very carefully                         */
#define    INT_cfGZ(T,UN,LN) A0=CFC_(UN,LN)(
#define   VOID_cfGZ(T,UN,LN)    CFC_(UN,LN)(
#ifdef vmsFortran
#define STRING_cfGZ(T,UN,LN)    CFC_(UN,LN)(&A0
#else
#if defined(CRAYFortran) || defined(AbsoftUNIXFortran) || defined(AbsoftProFortran)
#define STRING_cfGZ(T,UN,LN)    CFC_(UN,LN)( A0
#else
#define STRING_cfGZ(T,UN,LN)    CFC_(UN,LN)( A0,MAX_LEN_FORTRAN_FUNCTION_STRING
#endif
#endif

#define     INT_cfG(T,UN,LN)    INT_cfGZ(T,UN,LN)
#define    VOID_cfG(T,UN,LN)   VOID_cfGZ(T,UN,LN)
#define  STRING_cfG(T,UN,LN) STRING_cfGZ(T,UN,LN), /*, is only diff. from _cfG*/

#define    BYTEVVVVVVV_cfPP
#define     INTVVVVVVV_cfPP     /* These complement FLOATVVVVVVV_cfPP. */
#define  DOUBLEVVVVVVV_cfPP
#define LOGICALVVVVVVV_cfPP
#define    LONGVVVVVVV_cfPP
#define   SHORTVVVVVVV_cfPP
#define          PBYTE_cfPP
#define           PINT_cfPP
#define        PDOUBLE_cfPP
#define       PLOGICAL_cfPP
#define          PLONG_cfPP
#define         PSHORT_cfPP
#define         PFLOAT_cfPP FLOATVVVVVVV_cfPP

#define BCF(TN,AN,C)        _SEP_(TN,C,cfCOMMA) _Icf(2,B,TN,AN,0)
#define        INT_cfB(T,A) (_(T,VVVVVVV_cfTYPE)) A
#define       INTV_cfB(T,A)            A
#define      INTVV_cfB(T,A)           (A)[0]
#define     INTVVV_cfB(T,A)           (A)[0][0]
#define    INTVVVV_cfB(T,A)           (A)[0][0][0]
#define   INTVVVVV_cfB(T,A)           (A)[0][0][0][0]
#define  INTVVVVVV_cfB(T,A)           (A)[0][0][0][0][0]
#define INTVVVVVVV_cfB(T,A)           (A)[0][0][0][0][0][0]
#define       PINT_cfB(T,A) _(T,_cfPP)&A
#define     STRING_cfB(T,A) (char *)   A
#define    STRINGV_cfB(T,A) (char *)   A
#define    PSTRING_cfB(T,A) (char *)   A
#define   PSTRINGV_cfB(T,A) (char *)   A
#define      PVOID_cfB(T,A) (void *)   A
#define    ROUTINE_cfB(T,A) (cfCAST_FUNCTION)A
#define    ZTRINGV_cfB(T,A) (char *)   A
#define   PZTRINGV_cfB(T,A) (char *)   A
                                                              	
#define SCF(TN,NAME,I,A)    _(TN,_cfSTR)(3,S,NAME,I,A,0,0)
#define  DEFAULT_cfS(M,I,A)
#define  LOGICAL_cfS(M,I,A)
#define PLOGICAL_cfS(M,I,A)
#define   STRING_cfS(M,I,A) ,sizeof(A)
#define  STRINGV_cfS(M,I,A) ,( (unsigned)0xFFFF*firstindexlength(A) \
                              +secondindexlength(A))
#define  PSTRING_cfS(M,I,A) ,sizeof(A)
#define PSTRINGV_cfS(M,I,A) STRINGV_cfS(M,I,A)
#define  ZTRINGV_cfS(M,I,A)
#define PZTRINGV_cfS(M,I,A)

#define   HCF(TN,I)         _(TN,_cfSTR)(3,H,cfCOMMA, H,_(C,I),0,0)
#define  HHCF(TN,I)         _(TN,_cfSTR)(3,H,cfCOMMA,HH,_(C,I),0,0)
#define HHHCF(TN,I)         _(TN,_cfSTR)(3,H,cfCOLON, H,_(C,I),0,0)
#define  H_CF_SPECIAL       unsigned
#define HH_CF_SPECIAL
#define  DEFAULT_cfH(M,I,A)
#define  LOGICAL_cfH(S,U,B)
#define PLOGICAL_cfH(S,U,B)
#define   STRING_cfH(S,U,B) _(A,S) _(U,_CF_SPECIAL) B
#define  STRINGV_cfH(S,U,B) STRING_cfH(S,U,B)
#define  PSTRING_cfH(S,U,B) STRING_cfH(S,U,B)
#define PSTRINGV_cfH(S,U,B) STRING_cfH(S,U,B)
#define PNSTRING_cfH(S,U,B) STRING_cfH(S,U,B)
#define PPSTRING_cfH(S,U,B) STRING_cfH(S,U,B)
#define  ZTRINGV_cfH(S,U,B)
#define PZTRINGV_cfH(S,U,B)

/* Need VOID_cfSTR because Absoft forced function types go through _cfSTR. */
/* No spaces inside expansion. They screws up macro catenation kludge.     */
#define           VOID_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define           BYTE_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         DOUBLE_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define          FLOAT_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define            INT_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        LOGICAL_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,LOGICAL,A,B,C,D,E)
#define           LONG_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define          SHORT_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define          BYTEV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         BYTEVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        BYTEVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       BYTEVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      BYTEVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     BYTEVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define    BYTEVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        DOUBLEV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       DOUBLEVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      DOUBLEVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     DOUBLEVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define    DOUBLEVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define   DOUBLEVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define  DOUBLEVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         FLOATV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        FLOATVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       FLOATVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      FLOATVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     FLOATVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define    FLOATVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define   FLOATVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define           INTV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define          INTVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         INTVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        INTVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       INTVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      INTVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     INTVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       LOGICALV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      LOGICALVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     LOGICALVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define    LOGICALVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define   LOGICALVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define  LOGICALVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define LOGICALVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define          LONGV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         LONGVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        LONGVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       LONGVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      LONGVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     LONGVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define    LONGVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         SHORTV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        SHORTVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       SHORTVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define      SHORTVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define     SHORTVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define    SHORTVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define   SHORTVVVVVVV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define          PBYTE_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        PDOUBLE_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         PFLOAT_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define           PINT_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define       PLOGICAL_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,PLOGICAL,A,B,C,D,E)
#define          PLONG_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         PSHORT_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         STRING_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,STRING,A,B,C,D,E)
#define        PSTRING_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,PSTRING,A,B,C,D,E)
#define        STRINGV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,STRINGV,A,B,C,D,E)
#define       PSTRINGV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,PSTRINGV,A,B,C,D,E)
#define       PNSTRING_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,PNSTRING,A,B,C,D,E)
#define       PPSTRING_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,PPSTRING,A,B,C,D,E)
#define          PVOID_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        ROUTINE_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define         SIMPLE_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,DEFAULT,A,B,C,D,E)
#define        ZTRINGV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,ZTRINGV,A,B,C,D,E)
#define       PZTRINGV_cfSTR(N,T,A,B,C,D,E) _(CFARGS,N)(T,PZTRINGV,A,B,C,D,E)
#define           CF_0_cfSTR(N,T,A,B,C,D,E)

/* See ACF table comments, which explain why CCF was split into two. */
#define CCF(NAME,TN,I)     _(TN,_cfSTR)(5,C,NAME,I,_(A,I),_(B,I),_(C,I))
#define  DEFAULT_cfC(M,I,A,B,C)
#define  LOGICAL_cfC(M,I,A,B,C)  A=C2FLOGICAL( A);
#define PLOGICAL_cfC(M,I,A,B,C) *A=C2FLOGICAL(*A);
#ifdef vmsFortran
#define   STRING_cfC(M,I,A,B,C) (B.clen=strlen(A),B.f.dsc$a_pointer=A,         \
        C==sizeof(char*)||C==(unsigned)(B.clen+1)?B.f.dsc$w_length=B.clen:     \
          (memset((A)+B.clen,' ',C-B.clen-1),A[B.f.dsc$w_length=C-1]='\0'));
      /* PSTRING_cfC to beware of array A which does not contain any \0.      */
#define  PSTRING_cfC(M,I,A,B,C) (B.dsc$a_pointer=A, C==sizeof(char*) ?         \
             B.dsc$w_length=strlen(A):  (A[C-1]='\0',B.dsc$w_length=strlen(A), \
       memset((A)+B.dsc$w_length,' ',C-B.dsc$w_length-1), B.dsc$w_length=C-1));
#else
#define   STRING_cfC(M,I,A,B,C) (B.clen=strlen(A),                             \
                C==sizeof(char*)||C==(unsigned)(B.clen+1)?B.flen=B.clen:       \
                        (memset((A)+B.clen,' ',C-B.clen-1),A[B.flen=C-1]='\0'));
#define  PSTRING_cfC(M,I,A,B,C) (C==sizeof(char*)? B=strlen(A):                \
                    (A[C-1]='\0',B=strlen(A),memset((A)+B,' ',C-B-1),B=C-1));
#endif
          /* For CRAYFortran for (P)STRINGV_cfC, B.fs is set, but irrelevant. */
#define  STRINGV_cfC(M,I,A,B,C) \
        AATRINGV_cfA(    A,B,(C/0xFFFF)*(C%0xFFFF),C/0xFFFF,C%0xFFFF)
#define PSTRINGV_cfC(M,I,A,B,C) \
       APATRINGV_cfA(    A,B,(C/0xFFFF)*(C%0xFFFF),C/0xFFFF,C%0xFFFF)
#define  ZTRINGV_cfC(M,I,A,B,C) \
        AATRINGV_cfA(    A,B, (_3(M,_ELEMS_,I))*((_3(M,_ELEMLEN_,I))+1),       \
                              (_3(M,_ELEMS_,I)), (_3(M,_ELEMLEN_,I))+1   )
#define PZTRINGV_cfC(M,I,A,B,C) \
       APATRINGV_cfA(    A,B, (_3(M,_ELEMS_,I))*((_3(M,_ELEMLEN_,I))+1),       \
                              (_3(M,_ELEMS_,I)), (_3(M,_ELEMLEN_,I))+1   )

#define     BYTE_cfCCC(A,B) &A
#define   DOUBLE_cfCCC(A,B) &A
#if !defined(__CF__KnR)
#define    FLOAT_cfCCC(A,B) &A
                               /* Although the VAX doesn't, at least the      */
#else                          /* HP and K&R mips promote float arg.'s of     */
#define    FLOAT_cfCCC(A,B) &B /* unprototyped functions to double. Cannot    */
#endif                         /* use A here to pass the argument to FORTRAN. */
#define      INT_cfCCC(A,B) &A
#define  LOGICAL_cfCCC(A,B) &A
#define     LONG_cfCCC(A,B) &A
#define    SHORT_cfCCC(A,B) &A
#define    PBYTE_cfCCC(A,B)  A
#define  PDOUBLE_cfCCC(A,B)  A
#define   PFLOAT_cfCCC(A,B)  A
#define     PINT_cfCCC(A,B)  A
#define PLOGICAL_cfCCC(A,B)  B=A       /* B used to keep a common W table. */
#define    PLONG_cfCCC(A,B)  A
#define   PSHORT_cfCCC(A,B)  A

#define CCCF(TN,I,M)           _SEP_(TN,M,cfCOMMA) _Icf(3,CC,TN,_(A,I),_(B,I))
#define        INT_cfCC(T,A,B) _(T,_cfCCC)(A,B) 
#define       INTV_cfCC(T,A,B)  A
#define      INTVV_cfCC(T,A,B)  A
#define     INTVVV_cfCC(T,A,B)  A
#define    INTVVVV_cfCC(T,A,B)  A
#define   INTVVVVV_cfCC(T,A,B)  A
#define  INTVVVVVV_cfCC(T,A,B)  A
#define INTVVVVVVV_cfCC(T,A,B)  A
#define       PINT_cfCC(T,A,B) _(T,_cfCCC)(A,B) 
#define      PVOID_cfCC(T,A,B)  A
#if defined(apolloFortran) || defined(hpuxFortran800) || defined(AbsoftUNIXFortran)
#define    ROUTINE_cfCC(T,A,B) &A
#else
#define    ROUTINE_cfCC(T,A,B)  A
#endif
#define     SIMPLE_cfCC(T,A,B)  A
#ifdef vmsFortran
#define     STRING_cfCC(T,A,B) &B.f
#define    STRINGV_cfCC(T,A,B) &B
#define    PSTRING_cfCC(T,A,B) &B
#define   PSTRINGV_cfCC(T,A,B) &B
#else
#ifdef CRAYFortran
#define     STRING_cfCC(T,A,B) _cptofcd(A,B.flen)
#define    STRINGV_cfCC(T,A,B) _cptofcd(B.s,B.flen)
#define    PSTRING_cfCC(T,A,B) _cptofcd(A,B)
#define   PSTRINGV_cfCC(T,A,B) _cptofcd(A,B.flen)
#else
#define     STRING_cfCC(T,A,B)  A
#define    STRINGV_cfCC(T,A,B)  B.fs
#define    PSTRING_cfCC(T,A,B)  A
#define   PSTRINGV_cfCC(T,A,B)  B.fs
#endif
#endif
#define    ZTRINGV_cfCC(T,A,B)   STRINGV_cfCC(T,A,B)
#define   PZTRINGV_cfCC(T,A,B)  PSTRINGV_cfCC(T,A,B)

#define    BYTE_cfX  return A0;
#define  DOUBLE_cfX  return A0;
#if ! (defined(FLOATFUNCTIONTYPE)&&defined(ASSIGNFLOAT)&&defined(RETURNFLOAT))
#define   FLOAT_cfX  return A0;
#else
#define   FLOAT_cfX  ASSIGNFLOAT(AA0,A0); return AA0;
#endif
#define     INT_cfX  return A0;
#define LOGICAL_cfX  return F2CLOGICAL(A0);
#define    LONG_cfX  return A0;
#define   SHORT_cfX  return A0;
#define    VOID_cfX  return   ;
#if defined(vmsFortran) || defined(CRAYFortran)
#define  STRING_cfX  return kill_trailing(                                     \
                                      kill_trailing(AA0,CFORTRAN_NON_CHAR),' ');
#else
#define  STRING_cfX  return kill_trailing(                                     \
                                      kill_trailing( A0,CFORTRAN_NON_CHAR),' ');
#endif

#define CFFUN(NAME) _(__cf__,NAME)

/* Note that we don't use LN here, but we keep it for consistency. */
#define CCALLSFFUN0(UN,LN) CFFUN(UN)()

#ifdef OLD_VAXC                                  /* Allow %CC-I-PARAMNOTUSED. */
#pragma standard
#endif

#define CCALLSFFUN1( UN,LN,T1,                        A1)         \
        CCALLSFFUN5 (UN,LN,T1,CF_0,CF_0,CF_0,CF_0,A1,0,0,0,0)
#define CCALLSFFUN2( UN,LN,T1,T2,                     A1,A2)      \
        CCALLSFFUN5 (UN,LN,T1,T2,CF_0,CF_0,CF_0,A1,A2,0,0,0)
#define CCALLSFFUN3( UN,LN,T1,T2,T3,                  A1,A2,A3)   \
        CCALLSFFUN5 (UN,LN,T1,T2,T3,CF_0,CF_0,A1,A2,A3,0,0)
#define CCALLSFFUN4( UN,LN,T1,T2,T3,T4,               A1,A2,A3,A4)\
        CCALLSFFUN5 (UN,LN,T1,T2,T3,T4,CF_0,A1,A2,A3,A4,0)
#define CCALLSFFUN5( UN,LN,T1,T2,T3,T4,T5,            A1,A2,A3,A4,A5)          \
        CCALLSFFUN10(UN,LN,T1,T2,T3,T4,T5,CF_0,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,0,0,0,0,0)
#define CCALLSFFUN6( UN,LN,T1,T2,T3,T4,T5,T6,         A1,A2,A3,A4,A5,A6)       \
        CCALLSFFUN10(UN,LN,T1,T2,T3,T4,T5,T6,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,0,0,0,0)
#define CCALLSFFUN7( UN,LN,T1,T2,T3,T4,T5,T6,T7,      A1,A2,A3,A4,A5,A6,A7)    \
        CCALLSFFUN10(UN,LN,T1,T2,T3,T4,T5,T6,T7,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,0,0,0)
#define CCALLSFFUN8( UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,   A1,A2,A3,A4,A5,A6,A7,A8) \
        CCALLSFFUN10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,0,0)
#define CCALLSFFUN9( UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,A1,A2,A3,A4,A5,A6,A7,A8,A9)\
        CCALLSFFUN10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,0)
#define CCALLSFFUN10(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA)\
        CCALLSFFUN14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,CF_0,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,0,0,0,0)
#define CCALLSFFUN11(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB)\
        CCALLSFFUN14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,CF_0,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,0,0,0)
#define CCALLSFFUN12(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC)\
        CCALLSFFUN14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,CF_0,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,0,0)
#define CCALLSFFUN13(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD)\
        CCALLSFFUN14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,CF_0,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,0)

#define CCALLSFFUN14(UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,A1,A2,A3,A4,A5,A6,A7,A8,A9,AA,AB,AC,AD,AE)\
((CFFUN(UN)(  BCF(T1,A1,0) BCF(T2,A2,1) BCF(T3,A3,1) BCF(T4,A4,1) BCF(T5,A5,1) \
              BCF(T6,A6,1) BCF(T7,A7,1) BCF(T8,A8,1) BCF(T9,A9,1) BCF(TA,AA,1) \
              BCF(TB,AB,1) BCF(TC,AC,1) BCF(TD,AD,1) BCF(TE,AE,1)              \
           SCF(T1,LN,1,A1)  SCF(T2,LN,2,A2)  SCF(T3,LN,3,A3)  SCF(T4,LN,4,A4)  \
           SCF(T5,LN,5,A5)  SCF(T6,LN,6,A6)  SCF(T7,LN,7,A7)  SCF(T8,LN,8,A8)  \
           SCF(T9,LN,9,A9)  SCF(TA,LN,10,AA) SCF(TB,LN,11,AB) SCF(TC,LN,12,AC) \
           SCF(TD,LN,13,AD) SCF(TE,LN,14,AE))))

/*  N.B. Create a separate function instead of using (call function, function
value here) because in order to create the variables needed for the input
arg.'s which may be const.'s one has to do the creation within {}, but these
can never be placed within ()'s. Therefore one must create wrapper functions.
gcc, on the other hand may be able to avoid the wrapper functions. */

/* Prototypes are needed to correctly handle the value returned correctly. N.B.
Can only have prototype arg.'s with difficulty, a la G... table since FORTRAN
functions returning strings have extra arg.'s. Don't bother, since this only
causes a compiler warning to come up when one uses FCALLSCFUNn and CCALLSFFUNn
for the same function in the same source code. Something done by the experts in
debugging only.*/    

#define PROTOCCALLSFFUN0(F,UN,LN)                                              \
_(F,_cfPU)( CFC_(UN,LN))(CF_NULL_PROTO);                                       \
static _Icf(2,U,F,CFFUN(UN),0)() {_(F,_cfE) _Icf(3,GZ,F,UN,LN) ABSOFT_cf1(F));_(F,_cfX)}

#define PROTOCCALLSFFUN1( T0,UN,LN,T1)                                         \
        PROTOCCALLSFFUN5 (T0,UN,LN,T1,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN2( T0,UN,LN,T1,T2)                                      \
        PROTOCCALLSFFUN5 (T0,UN,LN,T1,T2,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN3( T0,UN,LN,T1,T2,T3)                                   \
        PROTOCCALLSFFUN5 (T0,UN,LN,T1,T2,T3,CF_0,CF_0)
#define PROTOCCALLSFFUN4( T0,UN,LN,T1,T2,T3,T4)                                \
        PROTOCCALLSFFUN5 (T0,UN,LN,T1,T2,T3,T4,CF_0)
#define PROTOCCALLSFFUN5( T0,UN,LN,T1,T2,T3,T4,T5)                             \
        PROTOCCALLSFFUN10(T0,UN,LN,T1,T2,T3,T4,T5,CF_0,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN6( T0,UN,LN,T1,T2,T3,T4,T5,T6)                          \
        PROTOCCALLSFFUN10(T0,UN,LN,T1,T2,T3,T4,T5,T6,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN7( T0,UN,LN,T1,T2,T3,T4,T5,T6,T7)                       \
        PROTOCCALLSFFUN10(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN8( T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8)                    \
        PROTOCCALLSFFUN10(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,CF_0,CF_0)
#define PROTOCCALLSFFUN9( T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9)                 \
        PROTOCCALLSFFUN10(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,CF_0)
#define PROTOCCALLSFFUN10(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA)              \
        PROTOCCALLSFFUN14(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,CF_0,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN11(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB)           \
        PROTOCCALLSFFUN14(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,CF_0,CF_0,CF_0)
#define PROTOCCALLSFFUN12(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC)        \
        PROTOCCALLSFFUN14(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,CF_0,CF_0)
#define PROTOCCALLSFFUN13(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD)     \
        PROTOCCALLSFFUN14(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,CF_0)

/* HP/UX 9.01 cc requires the blank between '_Icf(3,G,T0,UN,LN) CCCF(T1,1,0)' */

#ifndef __CF__KnR
#define PROTOCCALLSFFUN14(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)  \
 _(T0,_cfPU)(CFC_(UN,LN))(CF_NULL_PROTO); static _Icf(2,U,T0,CFFUN(UN),0)(     \
   CFARGT14FS(UCF,HCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) )          \
{       CFARGT14S(VCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)    _(T0,_cfE) \
 CCF(LN,T1,1)  CCF(LN,T2,2)  CCF(LN,T3,3)  CCF(LN,T4,4)  CCF(LN,T5,5)          \
 CCF(LN,T6,6)  CCF(LN,T7,7)  CCF(LN,T8,8)  CCF(LN,T9,9)  CCF(LN,TA,10)         \
 CCF(LN,TB,11) CCF(LN,TC,12) CCF(LN,TD,13) CCF(LN,TE,14)    _Icf(3,G,T0,UN,LN) \
 CFARGT14(CCCF,JCF,ABSOFT_cf1(T0),T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)); \
 WCF(T1,A1,1)   WCF(T2,A2,2)   WCF(T3,A3,3)   WCF(T4,A4,4)  WCF(T5,A5,5)       \
 WCF(T6,A6,6)   WCF(T7,A7,7)   WCF(T8,A8,8)   WCF(T9,A9,9)  WCF(TA,A10,10)     \
 WCF(TB,A11,11) WCF(TC,A12,12) WCF(TD,A13,13) WCF(TE,A14,14) _(T0,_cfX)}
#else
#define PROTOCCALLSFFUN14(T0,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)  \
 _(T0,_cfPU)(CFC_(UN,LN))(CF_NULL_PROTO); static _Icf(2,U,T0,CFFUN(UN),0)(     \
   CFARGT14FS(UUCF,HHCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) )        \
 CFARGT14FS(UUUCF,HHHCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) ;        \
{       CFARGT14S(VCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)    _(T0,_cfE) \
 CCF(LN,T1,1)  CCF(LN,T2,2)  CCF(LN,T3,3)  CCF(LN,T4,4)  CCF(LN,T5,5)          \
 CCF(LN,T6,6)  CCF(LN,T7,7)  CCF(LN,T8,8)  CCF(LN,T9,9)  CCF(LN,TA,10)         \
 CCF(LN,TB,11) CCF(LN,TC,12) CCF(LN,TD,13) CCF(LN,TE,14)    _Icf(3,G,T0,UN,LN) \
 CFARGT14(CCCF,JCF,ABSOFT_cf1(T0),T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)); \
 WCF(T1,A1,1)   WCF(T2,A2,2)   WCF(T3,A3,3)   WCF(T4,A4,4)   WCF(T5,A5,5)      \
 WCF(T6,A6,6)   WCF(T7,A7,7)   WCF(T8,A8,8)   WCF(T9,A9,9)   WCF(TA,A10,10)    \
 WCF(TB,A11,11) WCF(TC,A12,12) WCF(TD,A13,13) WCF(TE,A14,14) _(T0,_cfX)}
#endif

/*-------------------------------------------------------------------------*/

/*               UTILITIES FOR FORTRAN TO CALL C ROUTINES                  */

#ifdef OLD_VAXC                                /* Prevent %CC-I-PARAMNOTUSED. */
#pragma nostandard
#endif

#if defined(vmsFortran) || defined(CRAYFortran)
#define   DCF(TN,I)
#define  DDCF(TN,I)
#define DDDCF(TN,I)
#else
#define   DCF(TN,I)          HCF(TN,I)
#define  DDCF(TN,I)         HHCF(TN,I)
#define DDDCF(TN,I)        HHHCF(TN,I)
#endif

#define QCF(TN,I)       _(TN,_cfSTR)(1,Q,_(B,I), 0,0,0,0)
#define  DEFAULT_cfQ(B)
#define  LOGICAL_cfQ(B)
#define PLOGICAL_cfQ(B)
#define  STRINGV_cfQ(B) char *B; unsigned int _(B,N);
#define   STRING_cfQ(B) char *B=NULL;
#define  PSTRING_cfQ(B) char *B=NULL;
#define PSTRINGV_cfQ(B) STRINGV_cfQ(B)
#define PNSTRING_cfQ(B) char *B=NULL;
#define PPSTRING_cfQ(B)

#ifdef     __sgi   /* Else SGI gives warning 182 contrary to its C LRM A.17.7 */
#define ROUTINE_orig    *(void**)& 
#else
#define ROUTINE_orig     (void *)  
#endif

#define ROUTINE_1     ROUTINE_orig   
#define ROUTINE_2     ROUTINE_orig   
#define ROUTINE_3     ROUTINE_orig   
#define ROUTINE_4     ROUTINE_orig   
#define ROUTINE_5     ROUTINE_orig   
#define ROUTINE_6     ROUTINE_orig   
#define ROUTINE_7     ROUTINE_orig   
#define ROUTINE_8     ROUTINE_orig   
#define ROUTINE_9     ROUTINE_orig   
#define ROUTINE_10    ROUTINE_orig   
#define ROUTINE_11    ROUTINE_orig   
#define ROUTINE_12    ROUTINE_orig   
#define ROUTINE_13    ROUTINE_orig   
#define ROUTINE_14    ROUTINE_orig   
#define ROUTINE_15    ROUTINE_orig   
#define ROUTINE_16    ROUTINE_orig   
#define ROUTINE_17    ROUTINE_orig   
#define ROUTINE_18    ROUTINE_orig   
#define ROUTINE_19    ROUTINE_orig   
#define ROUTINE_20    ROUTINE_orig   
#define ROUTINE_21    ROUTINE_orig   
#define ROUTINE_22    ROUTINE_orig   
#define ROUTINE_23    ROUTINE_orig   
#define ROUTINE_24    ROUTINE_orig   
#define ROUTINE_25    ROUTINE_orig   
#define ROUTINE_26    ROUTINE_orig   
#define ROUTINE_27    ROUTINE_orig   

#define TCF(NAME,TN,I,M)              _SEP_(TN,M,cfCOMMA) _(TN,_cfT)(NAME,I,_(A,I),_(B,I),_(C,I))
#define           BYTE_cfT(M,I,A,B,D) *A
#define         DOUBLE_cfT(M,I,A,B,D) *A
#define          FLOAT_cfT(M,I,A,B,D) *A
#define            INT_cfT(M,I,A,B,D) *A
#define        LOGICAL_cfT(M,I,A,B,D)  F2CLOGICAL(*A)
#define           LONG_cfT(M,I,A,B,D) *A
#define          SHORT_cfT(M,I,A,B,D) *A
#define          BYTEV_cfT(M,I,A,B,D)  A
#define        DOUBLEV_cfT(M,I,A,B,D)  A
#define         FLOATV_cfT(M,I,A,B,D)  VOIDP A
#define           INTV_cfT(M,I,A,B,D)  A
#define       LOGICALV_cfT(M,I,A,B,D)  A
#define          LONGV_cfT(M,I,A,B,D)  A
#define         SHORTV_cfT(M,I,A,B,D)  A
#define         BYTEVV_cfT(M,I,A,B,D)  (void *)A /* We have to cast to void *,*/
#define        BYTEVVV_cfT(M,I,A,B,D)  (void *)A /* since we don't know the   */
#define       BYTEVVVV_cfT(M,I,A,B,D)  (void *)A /* dimensions of the array.  */
#define      BYTEVVVVV_cfT(M,I,A,B,D)  (void *)A /* i.e. Unfortunately, can't */
#define     BYTEVVVVVV_cfT(M,I,A,B,D)  (void *)A /* check that the type       */
#define    BYTEVVVVVVV_cfT(M,I,A,B,D)  (void *)A /* matches the prototype.    */
#define       DOUBLEVV_cfT(M,I,A,B,D)  (void *)A
#define      DOUBLEVVV_cfT(M,I,A,B,D)  (void *)A
#define     DOUBLEVVVV_cfT(M,I,A,B,D)  (void *)A
#define    DOUBLEVVVVV_cfT(M,I,A,B,D)  (void *)A
#define   DOUBLEVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define  DOUBLEVVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define        FLOATVV_cfT(M,I,A,B,D)  (void *)A
#define       FLOATVVV_cfT(M,I,A,B,D)  (void *)A
#define      FLOATVVVV_cfT(M,I,A,B,D)  (void *)A
#define     FLOATVVVVV_cfT(M,I,A,B,D)  (void *)A
#define    FLOATVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define   FLOATVVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define          INTVV_cfT(M,I,A,B,D)  (void *)A  
#define         INTVVV_cfT(M,I,A,B,D)  (void *)A  
#define        INTVVVV_cfT(M,I,A,B,D)  (void *)A  
#define       INTVVVVV_cfT(M,I,A,B,D)  (void *)A
#define      INTVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define     INTVVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define      LOGICALVV_cfT(M,I,A,B,D)  (void *)A
#define     LOGICALVVV_cfT(M,I,A,B,D)  (void *)A
#define    LOGICALVVVV_cfT(M,I,A,B,D)  (void *)A
#define   LOGICALVVVVV_cfT(M,I,A,B,D)  (void *)A
#define  LOGICALVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define LOGICALVVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define         LONGVV_cfT(M,I,A,B,D)  (void *)A
#define        LONGVVV_cfT(M,I,A,B,D)  (void *)A
#define       LONGVVVV_cfT(M,I,A,B,D)  (void *)A
#define      LONGVVVVV_cfT(M,I,A,B,D)  (void *)A
#define     LONGVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define    LONGVVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define        SHORTVV_cfT(M,I,A,B,D)  (void *)A
#define       SHORTVVV_cfT(M,I,A,B,D)  (void *)A
#define      SHORTVVVV_cfT(M,I,A,B,D)  (void *)A
#define     SHORTVVVVV_cfT(M,I,A,B,D)  (void *)A
#define    SHORTVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define   SHORTVVVVVVV_cfT(M,I,A,B,D)  (void *)A
#define          PBYTE_cfT(M,I,A,B,D)  A
#define        PDOUBLE_cfT(M,I,A,B,D)  A
#define         PFLOAT_cfT(M,I,A,B,D)  VOIDP A
#define           PINT_cfT(M,I,A,B,D)  A
#define       PLOGICAL_cfT(M,I,A,B,D)  ((*A=F2CLOGICAL(*A)),A)
#define          PLONG_cfT(M,I,A,B,D)  A
#define         PSHORT_cfT(M,I,A,B,D)  A
#define          PVOID_cfT(M,I,A,B,D)  A
#if defined(apolloFortran) || defined(hpuxFortran800) || defined(AbsoftUNIXFortran)
#define        ROUTINE_cfT(M,I,A,B,D)  _(ROUTINE_,I)  (*A)
#else
#define        ROUTINE_cfT(M,I,A,B,D)  _(ROUTINE_,I)    A
#endif
/* A == pointer to the characters
   D == length of the string, or of an element in an array of strings
   E == number of elements in an array of strings                             */
#define TTSTR(    A,B,D)                                                       \
           ((B=_cf_malloc(D+1))[D]='\0', memcpy(B,A,D), kill_trailing(B,' '))
#define TTTTSTR(  A,B,D)   (!(D<4||A[0]||A[1]||A[2]||A[3]))?NULL:              \
                            memchr(A,'\0',D)                 ?A   : TTSTR(A,B,D)
#define TTTTSTRV( A,B,D,E) (_(B,N)=E,B=_cf_malloc(_(B,N)*(D+1)), (void *)      \
  vkill_trailing(f2cstrv(A,B,D+1, _(B,N)*(D+1)), D+1,_(B,N)*(D+1),' '))
#ifdef vmsFortran
#define         STRING_cfT(M,I,A,B,D)  TTTTSTR( A->dsc$a_pointer,B,A->dsc$w_length)
#define        STRINGV_cfT(M,I,A,B,D)  TTTTSTRV(A->dsc$a_pointer, B,           \
                                             A->dsc$w_length , A->dsc$l_m[0])
#define        PSTRING_cfT(M,I,A,B,D)    TTSTR( A->dsc$a_pointer,B,A->dsc$w_length)
#define       PPSTRING_cfT(M,I,A,B,D)           A->dsc$a_pointer
#else
#ifdef CRAYFortran
#define         STRING_cfT(M,I,A,B,D)  TTTTSTR( _fcdtocp(A),B,_fcdlen(A))
#define        STRINGV_cfT(M,I,A,B,D)  TTTTSTRV(_fcdtocp(A),B,_fcdlen(A),      \
                              num_elem(_fcdtocp(A),_fcdlen(A),_3(M,_STRV_A,I)))
#define        PSTRING_cfT(M,I,A,B,D)    TTSTR( _fcdtocp(A),B,_fcdlen(A))
#define       PPSTRING_cfT(M,I,A,B,D)           _fcdtocp(A)
#else
#define         STRING_cfT(M,I,A,B,D)  TTTTSTR( A,B,D)
#define        STRINGV_cfT(M,I,A,B,D)  TTTTSTRV(A,B,D, num_elem(A,D,_3(M,_STRV_A,I)))
#define        PSTRING_cfT(M,I,A,B,D)    TTSTR( A,B,D)
#define       PPSTRING_cfT(M,I,A,B,D)           A
#endif
#endif
#define       PNSTRING_cfT(M,I,A,B,D)    STRING_cfT(M,I,A,B,D)
#define       PSTRINGV_cfT(M,I,A,B,D)   STRINGV_cfT(M,I,A,B,D)
#define           CF_0_cfT(M,I,A,B,D)

#define RCF(TN,I)           _(TN,_cfSTR)(3,R,_(A,I),_(B,I),_(C,I),0,0)
#define  DEFAULT_cfR(A,B,D)
#define  LOGICAL_cfR(A,B,D)
#define PLOGICAL_cfR(A,B,D) *A=C2FLOGICAL(*A);
#define   STRING_cfR(A,B,D) if (B) _cf_free(B);
#define  STRINGV_cfR(A,B,D) _cf_free(B);
/* A and D as defined above for TSTRING(V) */
#define RRRRPSTR( A,B,D)    if (B) memcpy(A,B, _cfMIN(strlen(B),D)),           \
                  (D>strlen(B)?memset(A+strlen(B),' ', D-strlen(B)):0), _cf_free(B);
#define RRRRPSTRV(A,B,D)    c2fstrv(B,A,D+1,(D+1)*_(B,N)), _cf_free(B);
#ifdef vmsFortran
#define  PSTRING_cfR(A,B,D) RRRRPSTR( A->dsc$a_pointer,B,A->dsc$w_length)
#define PSTRINGV_cfR(A,B,D) RRRRPSTRV(A->dsc$a_pointer,B,A->dsc$w_length)
#else
#ifdef CRAYFortran
#define  PSTRING_cfR(A,B,D) RRRRPSTR( _fcdtocp(A),B,_fcdlen(A))
#define PSTRINGV_cfR(A,B,D) RRRRPSTRV(_fcdtocp(A),B,_fcdlen(A))
#else
#define  PSTRING_cfR(A,B,D) RRRRPSTR( A,B,D)
#define PSTRINGV_cfR(A,B,D) RRRRPSTRV(A,B,D)
#endif
#endif
#define PNSTRING_cfR(A,B,D) PSTRING_cfR(A,B,D)
#define PPSTRING_cfR(A,B,D)

#define    BYTE_cfFZ(UN,LN) INTEGER_BYTE     FCALLSC_QUALIFIER fcallsc(UN,LN)(
#define  DOUBLE_cfFZ(UN,LN) DOUBLE_PRECISION FCALLSC_QUALIFIER fcallsc(UN,LN)(
#define     INT_cfFZ(UN,LN) int   FCALLSC_QUALIFIER fcallsc(UN,LN)(
#define LOGICAL_cfFZ(UN,LN) int   FCALLSC_QUALIFIER fcallsc(UN,LN)(
#define    LONG_cfFZ(UN,LN) long  FCALLSC_QUALIFIER fcallsc(UN,LN)(
#define   SHORT_cfFZ(UN,LN) short FCALLSC_QUALIFIER fcallsc(UN,LN)(
#define    VOID_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(
#ifndef __CF__KnR
/* The void is req'd by the Apollo, to make this an ANSI function declaration.
   The Apollo promotes K&R float functions to double. */
#define   FLOAT_cfFZ(UN,LN) FORTRAN_REAL FCALLSC_QUALIFIER fcallsc(UN,LN)(void
#ifdef vmsFortran
#define  STRING_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(fstring *AS
#else
#ifdef CRAYFortran
#define  STRING_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(_fcd     AS
#else
#if  defined(AbsoftUNIXFortran) || defined(AbsoftProFortran)
#define  STRING_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(char    *AS
#else
#define  STRING_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(char    *AS, unsigned D0
#endif
#endif
#endif
#else
#if ! (defined(FLOATFUNCTIONTYPE)&&defined(ASSIGNFLOAT)&&defined(RETURNFLOAT))
#define   FLOAT_cfFZ(UN,LN) FORTRAN_REAL      FCALLSC_QUALIFIER fcallsc(UN,LN)(
#else
#define   FLOAT_cfFZ(UN,LN) FLOATFUNCTIONTYPE FCALLSC_QUALIFIER fcallsc(UN,LN)(
#endif
#if defined(vmsFortran) || defined(CRAYFortran) || defined(AbsoftUNIXFortran)
#define  STRING_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(AS
#else
#define  STRING_cfFZ(UN,LN) void  FCALLSC_QUALIFIER fcallsc(UN,LN)(AS, D0
#endif
#endif

#define    BYTE_cfF(UN,LN)     BYTE_cfFZ(UN,LN)
#define  DOUBLE_cfF(UN,LN)   DOUBLE_cfFZ(UN,LN)
#ifndef __CF_KnR
#define   FLOAT_cfF(UN,LN)  FORTRAN_REAL FCALLSC_QUALIFIER fcallsc(UN,LN)(
#else
#define   FLOAT_cfF(UN,LN)    FLOAT_cfFZ(UN,LN)
#endif
#define     INT_cfF(UN,LN)      INT_cfFZ(UN,LN)
#define LOGICAL_cfF(UN,LN)  LOGICAL_cfFZ(UN,LN)
#define    LONG_cfF(UN,LN)     LONG_cfFZ(UN,LN)
#define   SHORT_cfF(UN,LN)    SHORT_cfFZ(UN,LN)
#define    VOID_cfF(UN,LN)     VOID_cfFZ(UN,LN)
#define  STRING_cfF(UN,LN)   STRING_cfFZ(UN,LN),

#define     INT_cfFF
#define    VOID_cfFF
#ifdef vmsFortran
#define  STRING_cfFF           fstring *AS; 
#else
#ifdef CRAYFortran
#define  STRING_cfFF           _fcd     AS;
#else
#define  STRING_cfFF           char    *AS; unsigned D0;
#endif
#endif

#define     INT_cfL            A0=
#define  STRING_cfL            A0=
#define    VOID_cfL                        

#define    INT_cfK
#define   VOID_cfK
/* KSTRING copies the string into the position provided by the caller. */
#ifdef vmsFortran
#define STRING_cfK                                                             \
 memcpy(AS->dsc$a_pointer,A0,_cfMIN(AS->dsc$w_length,(A0==NULL?0:strlen(A0))));\
 AS->dsc$w_length>(A0==NULL?0:strlen(A0))?                                     \
  memset(AS->dsc$a_pointer+(A0==NULL?0:strlen(A0)),' ',                        \
         AS->dsc$w_length-(A0==NULL?0:strlen(A0))):0;
#else
#ifdef CRAYFortran
#define STRING_cfK                                                             \
 memcpy(_fcdtocp(AS),A0, _cfMIN(_fcdlen(AS),(A0==NULL?0:strlen(A0))) );        \
 _fcdlen(AS)>(A0==NULL?0:strlen(A0))?                                          \
  memset(_fcdtocp(AS)+(A0==NULL?0:strlen(A0)),' ',                             \
         _fcdlen(AS)-(A0==NULL?0:strlen(A0))):0;
#else
#define STRING_cfK         memcpy(AS,A0, _cfMIN(D0,(A0==NULL?0:strlen(A0))) ); \
                 D0>(A0==NULL?0:strlen(A0))?memset(AS+(A0==NULL?0:strlen(A0)), \
                                            ' ', D0-(A0==NULL?0:strlen(A0))):0;
#endif
#endif

/* Note that K.. and I.. can't be combined since K.. has to access data before
R.., in order for functions returning strings which are also passed in as
arguments to work correctly. Note that R.. frees and hence may corrupt the
string. */
#define    BYTE_cfI  return A0;
#define  DOUBLE_cfI  return A0;
#if ! (defined(FLOATFUNCTIONTYPE)&&defined(ASSIGNFLOAT)&&defined(RETURNFLOAT))
#define   FLOAT_cfI  return A0;
#else
#define   FLOAT_cfI  RETURNFLOAT(A0);
#endif
#define     INT_cfI  return A0;
#ifdef hpuxFortran800
/* Incredibly, functions must return true as 1, elsewhere .true.==0x01000000. */
#define LOGICAL_cfI  return ((A0)?1:0);
#else
#define LOGICAL_cfI  return C2FLOGICAL(A0);
#endif
#define    LONG_cfI  return A0;
#define   SHORT_cfI  return A0;
#define  STRING_cfI  return   ;
#define    VOID_cfI  return   ;

#ifdef OLD_VAXC                                  /* Allow %CC-I-PARAMNOTUSED. */
#pragma standard
#endif

#define FCALLSCSUB0( CN,UN,LN)             FCALLSCFUN0(VOID,CN,UN,LN)
#define FCALLSCSUB1( CN,UN,LN,T1)          FCALLSCFUN1(VOID,CN,UN,LN,T1)
#define FCALLSCSUB2( CN,UN,LN,T1,T2)       FCALLSCFUN2(VOID,CN,UN,LN,T1,T2)
#define FCALLSCSUB3( CN,UN,LN,T1,T2,T3)    FCALLSCFUN3(VOID,CN,UN,LN,T1,T2,T3)
#define FCALLSCSUB4( CN,UN,LN,T1,T2,T3,T4) \
    FCALLSCFUN4(VOID,CN,UN,LN,T1,T2,T3,T4)
#define FCALLSCSUB5( CN,UN,LN,T1,T2,T3,T4,T5) \
    FCALLSCFUN5(VOID,CN,UN,LN,T1,T2,T3,T4,T5)
#define FCALLSCSUB6( CN,UN,LN,T1,T2,T3,T4,T5,T6) \
    FCALLSCFUN6(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6)       
#define FCALLSCSUB7( CN,UN,LN,T1,T2,T3,T4,T5,T6,T7) \
    FCALLSCFUN7(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7)
#define FCALLSCSUB8( CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8) \
    FCALLSCFUN8(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8)
#define FCALLSCSUB9( CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9) \
    FCALLSCFUN9(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9)
#define FCALLSCSUB10(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA) \
   FCALLSCFUN10(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA)
#define FCALLSCSUB11(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB) \
   FCALLSCFUN11(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB)
#define FCALLSCSUB12(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC) \
   FCALLSCFUN12(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC)
#define FCALLSCSUB13(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD) \
   FCALLSCFUN13(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD)
#define FCALLSCSUB14(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) \
   FCALLSCFUN14(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)
#define FCALLSCSUB15(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF) \
   FCALLSCFUN15(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF)
#define FCALLSCSUB16(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG) \
   FCALLSCFUN16(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG)
#define FCALLSCSUB17(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH) \
   FCALLSCFUN17(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH)
#define FCALLSCSUB18(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI) \
   FCALLSCFUN18(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI)
#define FCALLSCSUB19(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ) \
   FCALLSCFUN19(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ)
#define FCALLSCSUB20(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) \
   FCALLSCFUN20(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK)
#define FCALLSCSUB21(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL) \
   FCALLSCFUN21(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL)
#define FCALLSCSUB22(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM) \
   FCALLSCFUN22(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM)
#define FCALLSCSUB23(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN) \
   FCALLSCFUN23(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN)
#define FCALLSCSUB24(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO) \
   FCALLSCFUN24(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO)
#define FCALLSCSUB25(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP) \
   FCALLSCFUN25(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP)
#define FCALLSCSUB26(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ) \
   FCALLSCFUN26(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ)
#define FCALLSCSUB27(CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) \
   FCALLSCFUN27(VOID,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)


#define FCALLSCFUN1( T0,CN,UN,LN,T1) \
        FCALLSCFUN5 (T0,CN,UN,LN,T1,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN2( T0,CN,UN,LN,T1,T2) \
        FCALLSCFUN5 (T0,CN,UN,LN,T1,T2,CF_0,CF_0,CF_0)
#define FCALLSCFUN3( T0,CN,UN,LN,T1,T2,T3) \
        FCALLSCFUN5 (T0,CN,UN,LN,T1,T2,T3,CF_0,CF_0)
#define FCALLSCFUN4( T0,CN,UN,LN,T1,T2,T3,T4) \
        FCALLSCFUN5 (T0,CN,UN,LN,T1,T2,T3,T4,CF_0)
#define FCALLSCFUN5( T0,CN,UN,LN,T1,T2,T3,T4,T5) \
        FCALLSCFUN10(T0,CN,UN,LN,T1,T2,T3,T4,T5,CF_0,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN6( T0,CN,UN,LN,T1,T2,T3,T4,T5,T6) \
        FCALLSCFUN10(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN7( T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7) \
        FCALLSCFUN10(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,CF_0,CF_0,CF_0)
#define FCALLSCFUN8( T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8) \
        FCALLSCFUN10(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,CF_0,CF_0)
#define FCALLSCFUN9( T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9) \
        FCALLSCFUN10(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,CF_0)
#define FCALLSCFUN10(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA) \
        FCALLSCFUN14(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN11(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB) \
        FCALLSCFUN14(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,CF_0,CF_0,CF_0)
#define FCALLSCFUN12(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC) \
        FCALLSCFUN14(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,CF_0,CF_0)
#define FCALLSCFUN13(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD) \
        FCALLSCFUN14(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,CF_0)


#define FCALLSCFUN15(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF) \
        FCALLSCFUN20(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,CF_0,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN16(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG) \
        FCALLSCFUN20(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN17(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH) \
        FCALLSCFUN20(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,CF_0,CF_0,CF_0)
#define FCALLSCFUN18(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI) \
        FCALLSCFUN20(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,CF_0,CF_0)
#define FCALLSCFUN19(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ) \
        FCALLSCFUN20(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,CF_0)
#define FCALLSCFUN20(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN21(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,CF_0,CF_0,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN22(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,CF_0,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN23(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,CF_0,CF_0,CF_0,CF_0)
#define FCALLSCFUN24(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,CF_0,CF_0,CF_0)
#define FCALLSCFUN25(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,CF_0,CF_0)
#define FCALLSCFUN26(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ) \
        FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,CF_0)


#ifndef __CF__KnR
#define FCALLSCFUN0(T0,CN,UN,LN) CFextern _(T0,_cfFZ)(UN,LN) ABSOFT_cf2(T0))   \
        {_Icf(2,UU,T0,A0,0); _Icf(0,L,T0,0,0) CN(); _Icf(0,K,T0,0,0) _(T0,_cfI)}

#define FCALLSCFUN14(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)    \
                                 CFextern _(T0,_cfF)(UN,LN)                    \
 CFARGT14(NCF,DCF,ABSOFT_cf2(T0),T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE) )  \
 {                 CFARGT14S(QCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)    \
  _Icf(2,UU,T0,A0,0); _Icf(0,L,T0,0,0)      CN(    TCF(LN,T1,1,0)  TCF(LN,T2,2,1) \
    TCF(LN,T3,3,1)  TCF(LN,T4,4,1) TCF(LN,T5,5,1)  TCF(LN,T6,6,1)  TCF(LN,T7,7,1) \
    TCF(LN,T8,8,1)  TCF(LN,T9,9,1) TCF(LN,TA,10,1) TCF(LN,TB,11,1) TCF(LN,TC,12,1) \
    TCF(LN,TD,13,1) TCF(LN,TE,14,1) );                          _Icf(0,K,T0,0,0) \
                   CFARGT14S(RCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)  _(T0,_cfI) }

#define FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)   \
                                 CFextern _(T0,_cfF)(UN,LN)                    \
 CFARGT27(NCF,DCF,ABSOFT_cf2(T0),T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR) ) \
 {                 CFARGT27S(QCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)   \
  _Icf(2,UU,T0,A0,0); _Icf(0,L,T0,0,0)      CN(     TCF(LN,T1,1,0)  TCF(LN,T2,2,1)  \
    TCF(LN,T3,3,1)  TCF(LN,T4,4,1)  TCF(LN,T5,5,1)  TCF(LN,T6,6,1)  TCF(LN,T7,7,1)  \
    TCF(LN,T8,8,1)  TCF(LN,T9,9,1)  TCF(LN,TA,10,1) TCF(LN,TB,11,1) TCF(LN,TC,12,1) \
    TCF(LN,TD,13,1) TCF(LN,TE,14,1) TCF(LN,TF,15,1) TCF(LN,TG,16,1) TCF(LN,TH,17,1) \
    TCF(LN,TI,18,1) TCF(LN,TJ,19,1) TCF(LN,TK,20,1) TCF(LN,TL,21,1) TCF(LN,TM,22,1) \
    TCF(LN,TN,23,1) TCF(LN,TO,24,1) TCF(LN,TP,25,1) TCF(LN,TQ,26,1) TCF(LN,TR,27,1) ); _Icf(0,K,T0,0,0) \
                   CFARGT27S(RCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)  _(T0,_cfI) }

#else
#define FCALLSCFUN0(T0,CN,UN,LN) CFextern _(T0,_cfFZ)(UN,LN) ABSOFT_cf3(T0)) _Icf(0,FF,T0,0,0)\
        {_Icf(2,UU,T0,A0,0); _Icf(0,L,T0,0,0) CN(); _Icf(0,K,T0,0,0) _(T0,_cfI)}

#define FCALLSCFUN14(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)    \
                                 CFextern _(T0,_cfF)(UN,LN)                    \
 CFARGT14(NNCF,DDCF,ABSOFT_cf3(T0),T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)) _Icf(0,FF,T0,0,0) \
       CFARGT14FS(NNNCF,DDDCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE);   \
 {                 CFARGT14S(QCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)    \
  _Icf(2,UU,T0,A0,0); _Icf(0,L,T0,0,0)      CN(  TCF(LN,T1,1,0) TCF(LN,T2,2,1) \
    TCF(LN,T3,3,1) TCF(LN,T4,4,1) TCF(LN,T5,5,1) TCF(LN,T6,6,1) TCF(LN,T7,7,1) \
    TCF(LN,T8,8,1) TCF(LN,T9,9,1) TCF(LN,TA,10,1) TCF(LN,TB,11,1) TCF(LN,TC,12,1) \
    TCF(LN,TD,13,1) TCF(LN,TE,14,1) );                          _Icf(0,K,T0,0,0) \
                   CFARGT14S(RCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE)  _(T0,_cfI)}

#define FCALLSCFUN27(T0,CN,UN,LN,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)  \
                                 CFextern _(T0,_cfF)(UN,LN)                    \
 CFARGT27(NNCF,DDCF,ABSOFT_cf3(T0),T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)) _Icf(0,FF,T0,0,0) \
       CFARGT27FS(NNNCF,DDDCF,_Z,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR); \
 {                 CFARGT27S(QCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)  \
  _Icf(2,UU,T0,A0,0); _Icf(0,L,T0,0,0)      CN(     TCF(LN,T1,1,0)  TCF(LN,T2,2,1)  \
    TCF(LN,T3,3,1)  TCF(LN,T4,4,1)  TCF(LN,T5,5,1)  TCF(LN,T6,6,1)  TCF(LN,T7,7,1)  \
    TCF(LN,T8,8,1)  TCF(LN,T9,9,1)  TCF(LN,TA,10,1) TCF(LN,TB,11,1) TCF(LN,TC,12,1) \
    TCF(LN,TD,13,1) TCF(LN,TE,14,1) TCF(LN,TF,15,1) TCF(LN,TG,16,1) TCF(LN,TH,17,1) \
    TCF(LN,TI,18,1) TCF(LN,TJ,19,1) TCF(LN,TK,20,1) TCF(LN,TL,21,1) TCF(LN,TM,22,1) \
    TCF(LN,TN,23,1) TCF(LN,TO,24,1) TCF(LN,TP,25,1) TCF(LN,TQ,26,1) TCF(LN,TR,27,1) ); _Icf(0,K,T0,0,0) \
                   CFARGT27S(RCF,T1,T2,T3,T4,T5,T6,T7,T8,T9,TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR)  _(T0,_cfI)}

#endif


#endif	 /* __CFORTRAN_LOADED */
#endif
#if ! defined (_CDI_H)
#  include "cdi.h"
#endif

#if defined (HAVE_CONFIG_H)
#  include "config.h"
#endif

#if defined (HAVE_CF_INTERFACE)

#if ! defined (__CFORTRAN_LOADED)
#  include "cfortran.h"
#endif


/*  Error identifier  */


/*  File types  */


/*  Data types  */


/*  GRID types  */


/*  ZAXIS types  */


/*  TAXIS types  */


/*  TIME types  */


/*  TUNIT types  */


/*  CALENDAR types  */


/*  CDI control routines  */

FCALLSCSUB1 (cdiDebug, CDIDEBUG, cdidebug, INT)
FCALLSCSUB0 (cdiPrintVersion, CDIPRINTVERSION, cdiprintversion)
FCALLSCSUB1 (cdiDefMissval, CDIDEFMISSVAL, cdidefmissval, DOUBLE)
FCALLSCFUN0 (DOUBLE, cdiInqMissval, CDIINQMISSVAL, cdiinqmissval)
FCALLSCFUN2 (INT, cdiDefGlobal, CDIDEFGLOBAL, cdidefglobal, STRING, INT)
FCALLSCSUB1 (cdiDefCompress, CDIDEFCOMPRESS, cdidefcompress, INT)

/*  STREAM control routines  */

FCALLSCFUN1 (INT, streamOpenRead, STREAMOPENREAD, streamopenread, STRING)
FCALLSCFUN2 (INT, streamOpenWrite, STREAMOPENWRITE, streamopenwrite, STRING, INT)
FCALLSCFUN1 (INT, streamOpenAppend, STREAMOPENAPPEND, streamopenappend, STRING)
FCALLSCSUB1 (streamClose, STREAMCLOSE, streamclose, INT)
FCALLSCSUB2 (streamDefVlist, STREAMDEFVLIST, streamdefvlist, INT, INT)
FCALLSCFUN1 (INT, streamInqVlist, STREAMINQVLIST, streaminqvlist, INT)
FCALLSCFUN1 (INT, streamInqFiletype, STREAMINQFILETYPE, streaminqfiletype, INT)
FCALLSCSUB2 (streamDefByteorder, STREAMDEFBYTEORDER, streamdefbyteorder, INT, INT)
FCALLSCFUN1 (INT, streamInqByteorder, STREAMINQBYTEORDER, streaminqbyteorder, INT)
FCALLSCFUN2 (INT, streamDefTimestep, STREAMDEFTIMESTEP, streamdeftimestep, INT, INT)
FCALLSCFUN2 (INT, streamInqTimestep, STREAMINQTIMESTEP, streaminqtimestep, INT, INT)
FCALLSCFUN1 (INT, streamNtsteps, STREAMNTSTEPS, streamntsteps, INT)

/*  STREAM var I/O routines  */

FCALLSCSUB4 (streamReadVar, STREAMREADVAR, streamreadvar, INT, INT, PDOUBLE, PINT)
FCALLSCSUB4 (streamWriteVar, STREAMWRITEVAR, streamwritevar, INT, INT, PDOUBLE, INT)
FCALLSCSUB5 (streamReadVarSlice, STREAMREADVARSLICE, streamreadvarslice, INT, INT, INT, PDOUBLE, PINT)
FCALLSCSUB5 (streamWriteVarSlice, STREAMWRITEVARSLICE, streamwritevarslice, INT, INT, INT, PDOUBLE, INT)

/*  STREAM record I/O routines  */

FCALLSCSUB3 (streamInqRecord, STREAMINQRECORD, streaminqrecord, INT, PINT, PINT)
FCALLSCSUB3 (streamDefRecord, STREAMDEFRECORD, streamdefrecord, INT, INT, INT)
FCALLSCSUB2 (streamCopyRecord, STREAMCOPYRECORD, streamcopyrecord, INT, INT)
FCALLSCSUB3 (streamReadRecord, STREAMREADRECORD, streamreadrecord, INT, PDOUBLE, PINT)
FCALLSCSUB3 (streamWriteRecord, STREAMWRITERECORD, streamwriterecord, INT, PDOUBLE, INT)

/*  VLIST routines  */

FCALLSCFUN0 (INT, vlistNew, VLISTNEW, vlistnew)
FCALLSCSUB1 (vlistFree, VLISTFREE, vlistfree, INT)
FCALLSCFUN1 (INT, vlistDuplicate, VLISTDUPLICATE, vlistduplicate, INT)
FCALLSCSUB2 (vlistCopy, VLISTCOPY, vlistcopy, INT, INT)
FCALLSCSUB2 (vlistCopyFlag, VLISTCOPYFLAG, vlistcopyflag, INT, INT)
FCALLSCSUB1 (vlistClearFlag, VLISTCLEARFLAG, vlistclearflag, INT)
FCALLSCSUB2 (vlistCat, VLISTCAT, vlistcat, INT, INT)
FCALLSCSUB1 (vlistPrint, VLISTPRINT, vlistprint, INT)
FCALLSCFUN1 (INT, vlistNvars, VLISTNVARS, vlistnvars, INT)
FCALLSCFUN1 (INT, vlistNgrids, VLISTNGRIDS, vlistngrids, INT)
FCALLSCFUN1 (INT, vlistNzaxis, VLISTNZAXIS, vlistnzaxis, INT)
FCALLSCSUB2 (vlistDefNtsteps, VLISTDEFNTSTEPS, vlistdefntsteps, INT, INT)
FCALLSCFUN1 (INT, vlistNtsteps, VLISTNTSTEPS, vlistntsteps, INT)
FCALLSCFUN1 (INT, vlistGridsizeMax, VLISTGRIDSIZEMAX, vlistgridsizemax, INT)
FCALLSCFUN2 (INT, vlistGrid, VLISTGRID, vlistgrid, INT, INT)
FCALLSCFUN2 (INT, vlistGridIndex, VLISTGRIDINDEX, vlistgridindex, INT, INT)
FCALLSCSUB3 (vlistChangeGridIndex, VLISTCHANGEGRIDINDEX, vlistchangegridindex, INT, INT, INT)
FCALLSCSUB3 (vlistChangeGrid, VLISTCHANGEGRID, vlistchangegrid, INT, INT, INT)
FCALLSCFUN2 (INT, vlistZaxis, VLISTZAXIS, vlistzaxis, INT, INT)
FCALLSCFUN2 (INT, vlistZaxisIndex, VLISTZAXISINDEX, vlistzaxisindex, INT, INT)
FCALLSCSUB3 (vlistChangeZaxisIndex, VLISTCHANGEZAXISINDEX, vlistchangezaxisindex, INT, INT, INT)
FCALLSCSUB3 (vlistChangeZaxis, VLISTCHANGEZAXIS, vlistchangezaxis, INT, INT, INT)
FCALLSCFUN1 (INT, vlistNrecs, VLISTNRECS, vlistnrecs, INT)
FCALLSCSUB2 (vlistDefTaxis, VLISTDEFTAXIS, vlistdeftaxis, INT, INT)
FCALLSCFUN1 (INT, vlistInqTaxis, VLISTINQTAXIS, vlistinqtaxis, INT)
FCALLSCSUB2 (vlistDefTable, VLISTDEFTABLE, vlistdeftable, INT, INT)
FCALLSCFUN1 (INT, vlistInqTable, VLISTINQTABLE, vlistinqtable, INT)
FCALLSCSUB2 (vlistDefInstitut, VLISTDEFINSTITUT, vlistdefinstitut, INT, INT)
FCALLSCFUN1 (INT, vlistInqInstitut, VLISTINQINSTITUT, vlistinqinstitut, INT)
FCALLSCSUB2 (vlistDefModel, VLISTDEFMODEL, vlistdefmodel, INT, INT)
FCALLSCFUN1 (INT, vlistInqModel, VLISTINQMODEL, vlistinqmodel, INT)
FCALLSCSUB3 (vlistDefAttribute, VLISTDEFATTRIBUTE, vlistdefattribute, INT, STRING, STRING)

/*  VLIST VAR routines  */

FCALLSCFUN4 (INT, vlistDefVar, VLISTDEFVAR, vlistdefvar, INT, INT, INT, INT)
FCALLSCSUB5 (vlistInqVar, VLISTINQVAR, vlistinqvar, INT, INT, PINT, PINT, PINT)
FCALLSCFUN2 (INT, vlistInqVarGrid, VLISTINQVARGRID, vlistinqvargrid, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarZaxis, VLISTINQVARZAXIS, vlistinqvarzaxis, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarTime, VLISTINQVARTIME, vlistinqvartime, INT, INT)
FCALLSCSUB3 (vlistDefVarCode, VLISTDEFVARCODE, vlistdefvarcode, INT, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarCode, VLISTINQVARCODE, vlistinqvarcode, INT, INT)
FCALLSCSUB3 (vlistDefVarDatatype, VLISTDEFVARDATATYPE, vlistdefvardatatype, INT, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarDatatype, VLISTINQVARDATATYPE, vlistinqvardatatype, INT, INT)
FCALLSCSUB3 (vlistDefVarInstitut, VLISTDEFVARINSTITUT, vlistdefvarinstitut, INT, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarInstitut, VLISTINQVARINSTITUT, vlistinqvarinstitut, INT, INT)
FCALLSCSUB3 (vlistDefVarModel, VLISTDEFVARMODEL, vlistdefvarmodel, INT, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarModel, VLISTINQVARMODEL, vlistinqvarmodel, INT, INT)
FCALLSCSUB3 (vlistDefVarTable, VLISTDEFVARTABLE, vlistdefvartable, INT, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarTable, VLISTINQVARTABLE, vlistinqvartable, INT, INT)
FCALLSCSUB3 (vlistDefVarName, VLISTDEFVARNAME, vlistdefvarname, INT, INT, STRING)
FCALLSCSUB3 (vlistInqVarName, VLISTINQVARNAME, vlistinqvarname, INT, INT, PSTRING)
FCALLSCSUB3 (vlistDefVarLongname, VLISTDEFVARLONGNAME, vlistdefvarlongname, INT, INT, STRING)
FCALLSCSUB3 (vlistInqVarLongname, VLISTINQVARLONGNAME, vlistinqvarlongname, INT, INT, PSTRING)
FCALLSCSUB3 (vlistDefVarUnits, VLISTDEFVARUNITS, vlistdefvarunits, INT, INT, STRING)
FCALLSCSUB3 (vlistInqVarUnits, VLISTINQVARUNITS, vlistinqvarunits, INT, INT, PSTRING)
FCALLSCSUB3 (vlistDefVarMissval, VLISTDEFVARMISSVAL, vlistdefvarmissval, INT, INT, DOUBLE)
FCALLSCFUN2 (DOUBLE, vlistInqVarMissval, VLISTINQVARMISSVAL, vlistinqvarmissval, INT, INT)
FCALLSCSUB3 (vlistDefVarScalefactor, VLISTDEFVARSCALEFACTOR, vlistdefvarscalefactor, INT, INT, DOUBLE)
FCALLSCFUN2 (DOUBLE, vlistInqVarScalefactor, VLISTINQVARSCALEFACTOR, vlistinqvarscalefactor, INT, INT)
FCALLSCSUB3 (vlistDefVarAddoffset, VLISTDEFVARADDOFFSET, vlistdefvaraddoffset, INT, INT, DOUBLE)
FCALLSCFUN2 (DOUBLE, vlistInqVarAddoffset, VLISTINQVARADDOFFSET, vlistinqvaraddoffset, INT, INT)
FCALLSCSUB3 (vlistDefVarAverage, VLISTDEFVARAVERAGE, vlistdefvaraverage, INT, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarAverage, VLISTINQVARAVERAGE, vlistinqvaraverage, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarSize, VLISTINQVARSIZE, vlistinqvarsize, INT, INT)
FCALLSCFUN2 (INT, vlistInqVarID, VLISTINQVARID, vlistinqvarid, INT, INT)
FCALLSCSUB4 (vlistDefIndex, VLISTDEFINDEX, vlistdefindex, INT, INT, INT, INT)
FCALLSCFUN3 (INT, vlistInqIndex, VLISTINQINDEX, vlistinqindex, INT, INT, INT)
FCALLSCSUB4 (vlistDefFlag, VLISTDEFFLAG, vlistdefflag, INT, INT, INT, INT)
FCALLSCFUN3 (INT, vlistInqFlag, VLISTINQFLAG, vlistinqflag, INT, INT, INT)
FCALLSCFUN2 (INT, vlistFlagVar, VLISTFLAGVAR, vlistflagvar, INT, INT)
FCALLSCFUN3 (INT, vlistFlagLevel, VLISTFLAGLEVEL, vlistflaglevel, INT, INT, INT)
FCALLSCFUN2 (INT, vlistFindVar, VLISTFINDVAR, vlistfindvar, INT, INT)
FCALLSCFUN3 (INT, vlistFindLevel, VLISTFINDLEVEL, vlistfindlevel, INT, INT, INT)

/*  GRID routines  */

FCALLSCFUN2 (INT, gridNew, GRIDNEW, gridnew, INT, INT)
FCALLSCFUN1 (INT, gridInqType, GRIDINQTYPE, gridinqtype, INT)
FCALLSCFUN1 (INT, gridInqSize, GRIDINQSIZE, gridinqsize, INT)
FCALLSCFUN1 (INT, gridDuplicate, GRIDDUPLICATE, gridduplicate, INT)
FCALLSCSUB1 (gridPrint, GRIDPRINT, gridprint, INT)
FCALLSCFUN0 (INT, gridSize, GRIDSIZE, gridsize)
FCALLSCSUB2 (gridDefXsize, GRIDDEFXSIZE, griddefxsize, INT, INT)
FCALLSCFUN1 (INT, gridInqXsize, GRIDINQXSIZE, gridinqxsize, INT)
FCALLSCSUB2 (gridDefYsize, GRIDDEFYSIZE, griddefysize, INT, INT)
FCALLSCFUN1 (INT, gridInqYsize, GRIDINQYSIZE, gridinqysize, INT)
FCALLSCSUB2 (gridDefXvals, GRIDDEFXVALS, griddefxvals, INT, PDOUBLE)
FCALLSCFUN2 (INT, gridInqXvals, GRIDINQXVALS, gridinqxvals, INT, PDOUBLE)
FCALLSCSUB2 (gridDefYvals, GRIDDEFYVALS, griddefyvals, INT, PDOUBLE)
FCALLSCFUN2 (INT, gridInqYvals, GRIDINQYVALS, gridinqyvals, INT, PDOUBLE)
FCALLSCSUB2 (gridDefXname, GRIDDEFXNAME, griddefxname, INT, PSTRING)
FCALLSCSUB2 (gridDefXlongname, GRIDDEFXLONGNAME, griddefxlongname, INT, PSTRING)
FCALLSCSUB2 (gridDefXunits, GRIDDEFXUNITS, griddefxunits, INT, PSTRING)
FCALLSCSUB2 (gridDefYname, GRIDDEFYNAME, griddefyname, INT, PSTRING)
FCALLSCSUB2 (gridDefYlongname, GRIDDEFYLONGNAME, griddefylongname, INT, PSTRING)
FCALLSCSUB2 (gridDefYunits, GRIDDEFYUNITS, griddefyunits, INT, PSTRING)
FCALLSCSUB2 (gridInqXname, GRIDINQXNAME, gridinqxname, INT, PSTRING)
FCALLSCSUB2 (gridInqXlongname, GRIDINQXLONGNAME, gridinqxlongname, INT, PSTRING)
FCALLSCSUB2 (gridInqXstdname, GRIDINQXSTDNAME, gridinqxstdname, INT, PSTRING)
FCALLSCSUB2 (gridInqXunits, GRIDINQXUNITS, gridinqxunits, INT, PSTRING)
FCALLSCSUB2 (gridInqYname, GRIDINQYNAME, gridinqyname, INT, PSTRING)
FCALLSCSUB2 (gridInqYlongname, GRIDINQYLONGNAME, gridinqylongname, INT, PSTRING)
FCALLSCSUB2 (gridInqYstdname, GRIDINQYSTDNAME, gridinqystdname, INT, PSTRING)
FCALLSCSUB2 (gridInqYunits, GRIDINQYUNITS, gridinqyunits, INT, PSTRING)
FCALLSCSUB2 (gridDefPrec, GRIDDEFPREC, griddefprec, INT, INT)
FCALLSCFUN1 (INT, gridInqPrec, GRIDINQPREC, gridinqprec, INT)
FCALLSCFUN2 (DOUBLE, gridInqXval, GRIDINQXVAL, gridinqxval, INT, INT)
FCALLSCFUN2 (DOUBLE, gridInqYval, GRIDINQYVAL, gridinqyval, INT, INT)
FCALLSCFUN1 (DOUBLE, gridInqXinc, GRIDINQXINC, gridinqxinc, INT)
FCALLSCFUN1 (DOUBLE, gridInqYinc, GRIDINQYINC, gridinqyinc, INT)
FCALLSCFUN1 (INT, gridIsRotated, GRIDISROTATED, gridisrotated, INT)
FCALLSCFUN1 (DOUBLE, gridInqXpole, GRIDINQXPOLE, gridinqxpole, INT)
FCALLSCSUB2 (gridDefXpole, GRIDDEFXPOLE, griddefxpole, INT, DOUBLE)
FCALLSCFUN1 (DOUBLE, gridInqYpole, GRIDINQYPOLE, gridinqypole, INT)
FCALLSCSUB2 (gridDefYpole, GRIDDEFYPOLE, griddefypole, INT, DOUBLE)
FCALLSCFUN1 (DOUBLE, gridInqAngle, GRIDINQANGLE, gridinqangle, INT)
FCALLSCSUB2 (gridDefAngle, GRIDDEFANGLE, griddefangle, INT, DOUBLE)
FCALLSCSUB2 (gridDefTrunc, GRIDDEFTRUNC, griddeftrunc, INT, INT)
FCALLSCFUN1 (INT, gridInqTrunc, GRIDINQTRUNC, gridinqtrunc, INT)
FCALLSCFUN1 (INT, gridInqTriNd, GRIDINQTRIND, gridinqtrind, INT)
FCALLSCSUB2 (gridDefTriNd, GRIDDEFTRIND, griddeftrind, INT, INT)
FCALLSCFUN1 (INT, gridInqTriNi, GRIDINQTRINI, gridinqtrini, INT)
FCALLSCSUB2 (gridDefTriNi, GRIDDEFTRINI, griddeftrini, INT, INT)
FCALLSCFUN1 (INT, gridInqTriNi2, GRIDINQTRINI2, gridinqtrini2, INT)
FCALLSCSUB2 (gridDefTriNi2, GRIDDEFTRINI2, griddeftrini2, INT, INT)
FCALLSCFUN1 (INT, gridInqTriNi3, GRIDINQTRINI3, gridinqtrini3, INT)
FCALLSCSUB2 (gridDefTriNi3, GRIDDEFTRINI3, griddeftrini3, INT, INT)
FCALLSCSUB2 (gridDefArea, GRIDDEFAREA, griddefarea, INT, PDOUBLE)
FCALLSCSUB2 (gridInqArea, GRIDINQAREA, gridinqarea, INT, PDOUBLE)
FCALLSCSUB2 (gridDefNvertex, GRIDDEFNVERTEX, griddefnvertex, INT, INT)
FCALLSCFUN1 (INT, gridInqNvertex, GRIDINQNVERTEX, gridinqnvertex, INT)
FCALLSCSUB2 (gridDefXbounds, GRIDDEFXBOUNDS, griddefxbounds, INT, PDOUBLE)
FCALLSCSUB2 (gridInqXbounds, GRIDINQXBOUNDS, gridinqxbounds, INT, PDOUBLE)
FCALLSCSUB2 (gridDefYbounds, GRIDDEFYBOUNDS, griddefybounds, INT, PDOUBLE)
FCALLSCSUB2 (gridInqYbounds, GRIDINQYBOUNDS, gridinqybounds, INT, PDOUBLE)
FCALLSCSUB3 (gridDefRowlon, GRIDDEFROWLON, griddefrowlon, INT, INT, PINT)
FCALLSCSUB2 (gridInqRowlon, GRIDINQROWLON, gridinqrowlon, INT, PINT)
FCALLSCSUB2 (gridChangeType, GRIDCHANGETYPE, gridchangetype, INT, INT)
FCALLSCFUN1 (INT, gridToZonal, GRIDTOZONAL, gridtozonal, INT)
FCALLSCFUN1 (INT, gridToMeridional, GRIDTOMERIDIONAL, gridtomeridional, INT)
FCALLSCFUN1 (INT, gridToCell, GRIDTOCELL, gridtocell, INT)
FCALLSCFUN1 (INT, gridToCurvilinear, GRIDTOCURVILINEAR, gridtocurvilinear, INT)

/*  ZAXIS routines  */

FCALLSCFUN2 (INT, zaxisNew, ZAXISNEW, zaxisnew, INT, INT)
FCALLSCFUN1 (INT, zaxisInqType, ZAXISINQTYPE, zaxisinqtype, INT)
FCALLSCFUN1 (INT, zaxisInqSize, ZAXISINQSIZE, zaxisinqsize, INT)
FCALLSCSUB1 (zaxisPrint, ZAXISPRINT, zaxisprint, INT)
FCALLSCFUN0 (INT, zaxisSize, ZAXISSIZE, zaxissize)
FCALLSCSUB2 (zaxisDefLevels, ZAXISDEFLEVELS, zaxisdeflevels, INT, PDOUBLE)
FCALLSCSUB2 (zaxisInqLevels, ZAXISINQLEVELS, zaxisinqlevels, INT, PDOUBLE)
FCALLSCFUN2 (DOUBLE, zaxisInqLevel, ZAXISINQLEVEL, zaxisinqlevel, INT, INT)
FCALLSCSUB2 (zaxisDefName, ZAXISDEFNAME, zaxisdefname, INT, PSTRING)
FCALLSCSUB2 (zaxisDefLongname, ZAXISDEFLONGNAME, zaxisdeflongname, INT, PSTRING)
FCALLSCSUB2 (zaxisDefUnits, ZAXISDEFUNITS, zaxisdefunits, INT, PSTRING)
FCALLSCSUB2 (zaxisInqName, ZAXISINQNAME, zaxisinqname, INT, PSTRING)
FCALLSCSUB2 (zaxisInqLongname, ZAXISINQLONGNAME, zaxisinqlongname, INT, PSTRING)
FCALLSCSUB2 (zaxisInqUnits, ZAXISINQUNITS, zaxisinqunits, INT, PSTRING)
FCALLSCSUB2 (zaxisDefPrec, ZAXISDEFPREC, zaxisdefprec, INT, INT)
FCALLSCFUN1 (INT, zaxisInqPrec, ZAXISINQPREC, zaxisinqprec, INT)
FCALLSCSUB3 (zaxisDefVct, ZAXISDEFVCT, zaxisdefvct, INT, INT, PDOUBLE)
FCALLSCFUN1 (INT, zaxisInqVctSize, ZAXISINQVCTSIZE, zaxisinqvctsize, INT)
FCALLSCFUN2 (DOUBLE, zaxisInqLbound, ZAXISINQLBOUND, zaxisinqlbound, INT, INT)
FCALLSCFUN2 (DOUBLE, zaxisInqUbound, ZAXISINQUBOUND, zaxisinqubound, INT, INT)
FCALLSCFUN1 (INT, zaxisInqHasBounds, ZAXISINQHASBOUNDS, zaxisinqhasbounds, INT)
FCALLSCSUB4 (zaxisDefBounds, ZAXISDEFBOUNDS, zaxisdefbounds, INT, INT, PDOUBLE, PDOUBLE)
FCALLSCSUB2 (zaxisChangeType, ZAXISCHANGETYPE, zaxischangetype, INT, INT)

/*  TAXIS routines  */

FCALLSCFUN1 (INT, taxisNew, TAXISNEW, taxisnew, INT)
FCALLSCFUN1 (INT, taxisDuplicate, TAXISDUPLICATE, taxisduplicate, INT)
FCALLSCSUB2 (taxisDefType, TAXISDEFTYPE, taxisdeftype, INT, INT)
FCALLSCSUB2 (taxisDefVdate, TAXISDEFVDATE, taxisdefvdate, INT, INT)
FCALLSCSUB2 (taxisDefVtime, TAXISDEFVTIME, taxisdefvtime, INT, INT)
FCALLSCSUB2 (taxisDefRdate, TAXISDEFRDATE, taxisdefrdate, INT, INT)
FCALLSCSUB2 (taxisDefRtime, TAXISDEFRTIME, taxisdefrtime, INT, INT)
FCALLSCSUB2 (taxisDefCalendar, TAXISDEFCALENDAR, taxisdefcalendar, INT, INT)
FCALLSCSUB2 (taxisDefTunit, TAXISDEFTUNIT, taxisdeftunit, INT, INT)
FCALLSCSUB2 (taxisDefNumavg, TAXISDEFNUMAVG, taxisdefnumavg, INT, INT)
FCALLSCFUN1 (INT, taxisInqType, TAXISINQTYPE, taxisinqtype, INT)
FCALLSCFUN1 (INT, taxisInqVdate, TAXISINQVDATE, taxisinqvdate, INT)
FCALLSCFUN1 (INT, taxisInqVtime, TAXISINQVTIME, taxisinqvtime, INT)
FCALLSCFUN1 (INT, taxisInqRdate, TAXISINQRDATE, taxisinqrdate, INT)
FCALLSCFUN1 (INT, taxisInqRtime, TAXISINQRTIME, taxisinqrtime, INT)
FCALLSCFUN1 (INT, taxisInqCalendar, TAXISINQCALENDAR, taxisinqcalendar, INT)
FCALLSCFUN1 (INT, taxisInqTunit, TAXISINQTUNIT, taxisinqtunit, INT)
FCALLSCFUN1 (INT, taxisInqNumavg, TAXISINQNUMAVG, taxisinqnumavg, INT)

/*  Institut routines  */

FCALLSCFUN4 (INT, institutDef, INSTITUTDEF, institutdef, INT, INT, STRING, STRING)
FCALLSCFUN4 (INT, institutInq, INSTITUTINQ, institutinq, INT, INT, STRING, STRING)
FCALLSCFUN0 (INT, institutInqNumber, INSTITUTINQNUMBER, institutinqnumber)
FCALLSCFUN1 (INT, institutInqCenter, INSTITUTINQCENTER, institutinqcenter, INT)
FCALLSCFUN1 (INT, institutInqSubcenter, INSTITUTINQSUBCENTER, institutinqsubcenter, INT)

/*  Model routines  */

FCALLSCFUN3 (INT, modelDef, MODELDEF, modeldef, INT, INT, STRING)
FCALLSCFUN3 (INT, modelInq, MODELINQ, modelinq, INT, INT, PSTRING)
FCALLSCFUN1 (INT, modelInqInstitut, MODELINQINSTITUT, modelinqinstitut, INT)
FCALLSCFUN1 (INT, modelInqGribID, MODELINQGRIBID, modelinqgribid, INT)

/*  Table routines  */

FCALLSCSUB2 (tableWriteC, TABLEWRITEC, tablewritec, STRING, INT)
FCALLSCSUB2 (tableWrite, TABLEWRITE, tablewrite, STRING, INT)
FCALLSCFUN1 (INT, tableRead, TABLEREAD, tableread, STRING)
FCALLSCFUN3 (INT, tableDef, TABLEDEF, tabledef, INT, INT, STRING)
FCALLSCSUB5 (tableDefEntry, TABLEDEFENTRY, tabledefentry, INT, INT, STRING, STRING, STRING)
FCALLSCFUN3 (INT, tableInq, TABLEINQ, tableinq, INT, INT, STRING)
FCALLSCFUN0 (INT, tableInqNumber, TABLEINQNUMBER, tableinqnumber)
FCALLSCFUN1 (INT, tableInqGribID, TABLEINQGRIBID, tableinqgribid, INT)
FCALLSCFUN1 (INT, tableInqModel, TABLEINQMODEL, tableinqmodel, INT)
FCALLSCSUB5 (tableInqPar, TABLEINQPAR, tableinqpar, INT, INT, PSTRING, PSTRING, PSTRING)
FCALLSCFUN3 (INT, tableInqParName, TABLEINQPARNAME, tableinqparname, INT, INT, PSTRING)
FCALLSCFUN3 (INT, tableInqParLongname, TABLEINQPARLONGNAME, tableinqparlongname, INT, INT, PSTRING)
FCALLSCFUN3 (INT, tableInqParUnits, TABLEINQPARUNITS, tableinqparunits, INT, INT, PSTRING)

/*  History routines  */

FCALLSCSUB3 (streamDefHistory, STREAMDEFHISTORY, streamdefhistory, INT, INT, STRING)
FCALLSCFUN1 (INT, streamInqHistorySize, STREAMINQHISTORYSIZE, streaminqhistorysize, INT)
FCALLSCSUB2 (streamInqHistoryString, STREAMINQHISTORYSTRING, streaminqhistorystring, INT, PSTRING)

#endif
#undef realloc
#undef malloc
#undef calloc
#undef free
